#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "8d11a118d0ee0852a0c92e798a8f648f86b2f504";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "errormessages";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_errormessages = NULL;
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"util\" as util",
  "",
  "// Contains modified lines used as suggestions for error messages.",
  "// When a line is added using one of the utility methods such as",
  "// insert()afterToken()onLine(), the line is copied from util.lines to the",
  "// internal lines array in the suggestion, and when a line that is already in",
  "// the array is modified, the internal lines array is updated.",
  "// There is no sorting of the order of the lines at any point, so",
  "// lines must be added in ascending order.",
  "def suggestion is public = object {",
  "  class new {",
  "    def lineNumbers is confidential = []",
  "    def lines is confidential = []",
  "",
  "    // Methods that deal with inserting/replacing/deleting character positions",
  "    // and ranges. These methods are usually called by lexing error messages",
  "    // due to lack of access to tokens, and by insert/replace/delete methods",
  "    // that operate on tokens.",
  "",
  "    method replaceRange(start, end)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(start == 1) then {",
  "            addLine(lineNumber, s ++ line.substringFrom(end + 1)to(line.size))",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(start - 1)",
  "                ++ s ++ line.substringFrom(end + 1)to(line.size))",
  "        }",
  "    }",
  "",
  "    method replaceChar(pos)with(s)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(s)onLine(lineNumber)",
  "    }",
  "",
  "    method replaceUntil(until)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        def len = until.size",
  "        for (1..line.size) do {i->",
  "            if (line.substringFrom(i)to(i + len - 1) == until) then {",
  "                replaceRange(1, i + len - 1)with(s)onLine(lineNumber)",
  "                return true",
  "            }",
  "        }",
  "        return false",
  "    }",
  "",
  "    method deleteRange(start, end)onLine(lineNumber) {",
  "        var start' := start",
  "        def line = getLine(lineNumber)",
  "        if((start' > 1) && (end == line.size)) then {",
  "            // Check for removing the whole line, then remove the indent also.",
  "            var indent := true",
  "            for(1..(start'-1)) do { i ->",
  "                if(line.at(i) != \" \") then {",
  "                    indent := false",
  "                }",
  "            }",
  "            if(indent == true) then {",
  "                start' := 1",
  "            }",
  "        }",
  "        replaceRange(start', end)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method deleteChar(pos)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method append(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        addLine(lineNumber, line ++ s)",
  "    }",
  "",
  "    method insert(s)atPosition(pos)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(pos == 1) then {",
  "            addLine(lineNumber, s ++ line)",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(pos - 1) ++ s",
  "                ++ line.substringFrom(pos)to(line.size))",
  "        }",
  "    }",
  "",
  "    // Methods that deal with inserting/replacing/deleteing tokens or ranges of",
  "    // tokens. These methods call the underlying methods that operate on",
  "    // characters.",
  "",
  "    method getTokenStart(token)includeLeadingSpace(includeLeading) {",
  "        var start := token.linePos",
  "        // Include leading whitespace.",
  "        if(includeLeading == true) then {",
  "            if((token.prev != false) && ({token.prev.line == token.line})) then {",
  "                start := token.prev.linePos + token.prev.size",
  "            }",
  "        }",
  "        // Include indentation if this is the only token on the line.",
  "        if(token.linePos == (token.indent + 1)) then {",
  "            if ((token.next == false) || {token.next.line != token.line}) then {",
  "                start := 1",
  "            }",
  "        }",
  "        start",
  "    }",
  "",
  "    method getTokenEnd(token)includeTrailingSpace(includeTrailing) {",
  "        var end := token.linePos + token.size - 1",
  "        // Include trailing space.",
  "        if(includeTrailing == true) then {",
  "            if((token.next != false) && ({token.next.line == token.line})) then {",
  "                end := token.next.linePos - 1;",
  "            } else {",
  "                end := getLine(token.line).size",
  "            }",
  "        }",
  "        end",
  "    }",
  "",
  "    method replaceToken(token)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        def start = getTokenStart(token)includeLeadingSpace(replaceLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(replaceTrailing)",
  "        replaceRange(start, end)with(s)onLine(token.line)",
  "    }",
  "",
  "    method replaceToken(token)with(s) {",
  "        replaceToken(token)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    method replaceTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        if(start == end) then {",
  "            replaceToken(start)leading(replaceLeading)trailing(replaceTrailing)with(s)",
  "        } else {",
  "            // Get the ident and position now in case deleteTokenRange changes it.",
  "            def insertPos = getTokenStart(start)includeLeadingSpace(replaceLeading)",
  "            def indent = getLine(start.line).substringFrom(1)to(start.indent)",
  "            deleteTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)",
  "            // If delete token range deleted the indent, then add it back.",
  "            if(getLine(start.line) == \"\") then {",
  "                insert(indent ++ s)atPosition(insertPos)onLine(start.line)",
  "            } else {",
  "                insert(s)atPosition(insertPos)onLine(start.line)",
  "            }",
  "        }",
  "    }",
  "",
  "    method replaceTokenRange(start, end)with(s) {",
  "        replaceTokenRange(start, end)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    // Deletes a token, and optionally leading and/or trailing spaces.",
  "    method deleteToken(token)leading(deleteLeading)trailing(deleteTrailing) {",
  "        def start = getTokenStart(token)includeLeadingSpace(deleteLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(deleteTrailing)",
  "        deleteRange(start, end)onLine(token.line)",
  "    }",
  "",
  "    method deleteToken(token) {",
  "        deleteToken(token)leading(false)trailing(false)",
  "    }",
  "",
  "    // Deletes a range of tokens, and optionally leading and/or trailing spaces.",
  "    method deleteTokenRange(start, end)leading(deleteLeading)trailing(deleteTrailing) {",
  "        if(start == end) then {",
  "            deleteToken(start)leading(deleteLeading)trailing(deleteTrailing)",
  "        } else {",
  "            var line := start.line",
  "            var startPos := getTokenStart(start)includeLeadingSpace(deleteLeading)",
  "            var endPos := getTokenEnd(start)includeTrailingSpace(deleteTrailing)",
  "            var tok := start.next",
  "            while {tok != end} do {",
  "                if(tok.line != line) then {",
  "                    deleteRange(startPos, endPos)onLine(line)",
  "                    line := tok.line",
  "                    startPos := getTokenStart(tok)includeLeadingSpace(deleteLeading)",
  "                }",
  "                endPos := getTokenEnd(tok)includeTrailingSpace(deleteTrailing)",
  "                tok := tok.next",
  "            }",
  "            if(end.line != line) then {",
  "                deleteRange(startPos, endPos)onLine(line)",
  "            }",
  "            endPos := getTokenEnd(end)includeTrailingSpace(deleteTrailing)",
  "            deleteRange(startPos, endPos)onLine(end.line)",
  "        }",
  "    }",
  "",
  "    method deleteTokenRange(start, end) {",
  "        deleteTokenRange(start, end)leading(false)trailing(false)",
  "    }",
  "",
  "    method deleteLine(lineNumber) {",
  "        addLine(lineNumber, \"\")",
  "    }",
  "",
  "    method insert(s)afterToken(token)andTrailingSpace(afterTrailing) {",
  "        def pos = getTokenEnd(token)includeTrailingSpace(afterTrailing) + 1",
  "        insert(s)atPosition(pos)onLine(token.line)",
  "    }",
  "",
  "    method insert(s)afterToken(token) {",
  "        insert(s)afterToken(token)andTrailingSpace(false)",
  "    }",
  "",
  "    method insert(s)beforeToken(token) {",
  "        insert(s)atPosition(token.linePos)onLine(token.line)",
  "    }",
  "",
  "    // Insert a new line. This stores the line with the same number as the line it comes after.",
  "    method insertNewLine(line)after(lineNumber) {",
  "        addLine(lineNumber, line)",
  "    }",
  "",
  "    // Manually add a line to the suggestion. This will overwrite any previous",
  "    // changes that may have been made to this line.",
  "    method addLine(lineNumber, line) {",
  "        var i := findLine(lineNumber)",
  "        if(i != false) then {",
  "            lines.at(i)put(line)",
  "        } else {",
  "            // Add new lines to make the list big enough.",
  "            lineNumbers.push(lineNumber)",
  "            lines.push(line)",
  "            if (lines.size > 1) then {",
  "                // Re-order the list.",
  "                i := lines.size",
  "                while {(i > 1) && {lineNumber < lineNumbers.at(i - 1)}} do {",
  "                    lineNumbers.at(i) put(lineNumbers.at(i - 1))",
  "                    lines.at(i) put (lines.at(i - 1))",
  "                    i := i - 1",
  "                }",
  "                lineNumbers.at(i) put (lineNumber)",
  "                lines.at(i) put (line)",
  "            }",
  "        }",
  "    }",
  "",
  "    // Internal method used to find the index of a line in the lines array.",
  "    // Returns false if the line is not found.",
  "    method findLine(lineNumber) is confidential {",
  "        for(lineNumbers.indices) do { i ->",
  "            if(lineNumbers.at(i) == lineNumber) then {",
  "                return i",
  "            }",
  "        }",
  "        false",
  "    }",
  "",
  "    // Internal method used to get the contents of a line so far.",
  "    // If the line is not part of this suggestion then it gets the unmodified line.",
  "    method getLine(lineNumber) is confidential {",
  "        def i = findLine(lineNumber)",
  "        if(i == false) then {",
  "            util.lines.at(lineNumber)",
  "        } else {",
  "            lines.at(i)",
  "        }",
  "    }",
  "",
  "    method print {",
  "        for(1..lines.size) do { i ->",
  "            if ((i > 1) && {(lineNumbers.at(i) > (lineNumbers.at(i-1) + 1))}) then {",
  "                var s := \"\"",
  "                repeat (lineNumbers.at(i-1).asString.size) times {",
  "                    s := s ++ \" \"",
  "                }",
  "                io.error.write(\"    {s}...\\n\")",
  "            }",
  "            // Handle insertion of new lines.",
  "            if(lineNumbers.at(i).truncated != lineNumbers.at(i)) then {",
  "                io.error.write(\" *{lineNumbers.at(i).truncated}: {lines.at(i)}\\n\")",
  "            } else {",
  "                io.error.write(\"  {lineNumbers.at(i)}: {lines.at(i)}\\n\")",
  "            }",
  "        }",
  "    }",
  "  }",
  "}",
  "",
  "method readableStringFrom(xs:Collection) {",
  "    // returns a string describing the contents of xs,",
  "    // separating items with commas and the word \"and\"",
  "    var result := \"\"",
  "    var count := xs.size",
  "    xs.do { v ->",
  "        result := result ++ v.asString",
  "        count := count - 1",
  "        if (count == 1) then {",
  "            if (xs.size > 2) then { result := result ++ \",\" }",
  "            result := result ++ \" and \"",
  "        } elseif { count > 1 } then {",
  "            result := result ++ \", \"",
  "        }",
  "    }",
  "    result",
  "}",
  "",
  "method name (p:String) matches (t:String) within (k:Number) {",
  "    // This is algorithm EDP from Jokinen, Jorma, Tarhio and Ukkinen:",
  "    // \"A comparison of Approximate String Matching Algorithms\"",
  "    // Software—Practice and Experience Vol 1(1), January 1988, pp.1–19",
  "    //",
  "    // Implements the \"Enhanced Dynamic Programming\" (EDP) algorithm for",
  "    // approximate string matching.  If pattern p matches text t within",
  "    // an edit distance ≤ k, this method returns j, the index of the highest",
  "    // character of t involved in the match.  Its time compelxity is O(k*|p|).",
  "    //",
  "    // The algorithm builds a dynamic progarmming table D such that",
  "    // D[i,j] is the minimum edit distance between p[1] p[2] ... p[i]",
  "    // and any substring of t ending at t[j].   However, it isn't necessary",
  "    // to store the whole table D.  Because D[i,j] depends on only D[i-1, j],",
  "    // D[i-1, j-1] and D[i, j-1], we can store only the current",
  "    // column, which we do in h, and the value of D[i-1,j-1], which is",
  "    // cached in c.  Moreover, since we are not interested in edit",
  "    // distances > k, it's only necessary to evalue the elments of the table",
  "    // around the diagonal.",
  "",
  "",
  "    def m = p.size",
  "    def n = t.size",
  "    if (k >= m) then { return m }  // trivial case",
  "    def k' = min3(k, n-1, m-1)",
  "    var top := k' + 1  // the location where the topmost diagonal under",
  "                       // threshold intersects the current column",
  "    def h = emptyList",
  "    for (0..m) do { i -> h.at(i+1) put(i+1) }",
  "    try {",
  "        for (1..n) do { j ->",
  "            var c := 0",
  "            for (1..top) do { i ->",
  "                def e = if (p.at(i) == t.at(j)) then {",
  "                    c",
  "                } else {",
  "                    min3(h.at(i), h.at(i+1), c) + 1",
  "                }",
  "                c := h.at(i+1)",
  "                h.at(i+1) put (e)",
  "            }",
  "            while { (top >= 0) && {h.at(top+1) > k'} } do { top := top - 1 }",
  "            if (top == m) then {",
  "                return j    // the last character of t that was used in the match",
  "            } else {",
  "                top := top + 1",
  "            }",
  "        }",
  "    } catch { e:BoundsError -> return 0 }   // if the code is buggy, don't crash",
  "    return 0            // there was no match",
  "}",
  "",
  "method min3(a, b, c) is confidential {",
  "    def sf = if (a < b) then { a } else { b }",
  "    if (sf < c) then { sf } else { c }",
  "}",
  "",
  "",
  "// Methods to actually display an error message and suggestions, then exit.",
  "",
  "method syntaxError (message) atRange (r) {",
  "    def more = if (r.start.line < r.end.line) then {",
  "        \"  This statement spans multiple lines; is that what you intended?\"",
  "    } else {",
  "        \"\"",
  "    }",
  "    syntaxError (message ++ more) atRange (r) withSuggestions []",
  "}",
  "method syntaxError (message) atRange (r) withSuggestion (s) {",
  "    syntaxError (message) atRange (r) withSuggestions [s]",
  "}",
  "method syntaxError (message) atRange (r) withSuggestions (s) {",
  "    syntaxError (message)",
  "          atRange (r.start.line, r.start.column, r.end.line, r.end.column)",
  "          withSuggestions (s)",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos) {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    var loc := if(startpos == endpos) then {startpos.asString} else { \"{startpos}-{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, errlinenum, \":{loc}\", arr, suggestions)",
  "}",
  "",
  "method syntaxError (message)",
  "          atRange (startline, startpos, endline, endpos)",
  "          withSuggestions (suggestions) {",
  "",
  "    // this variant allows for range to start and end on different lines.",
  "    def loc = if (startline == endline) then {",
  "        if (startpos == endpos)",
  "              then { startpos.asString }",
  "              else { \"{startpos}-{endpos}\" }",
  "    } else { \"{startpos}-{endline}:{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + startline.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, startline, \":{loc}\", arr, suggestions)",
  "}",
  "",
  "method error (message) atRange (r) {",
  "    error (message) atRange (r.start.line, r.start.column, r.end.column)",
  "}",
  "method error(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    var loc := if(startpos == endpos) then {startpos.asString} else { \"{startpos}-{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.generalError(message, errlinenum, \":{loc}\", arr, suggestions)",
  "}",
  "",
  "method error(message) atRange(errlinenum, startpos, endpos) {",
  "    error (message) atRange(errlinenum, startpos, endpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos) {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([])",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos) {",
  "    error(message) atPosition(errlinenum, errpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.syntaxError(message, errlinenum, \":{errpos}\", arr, suggestions)",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos)",
  "        withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.generalError(message, errlinenum, \":{errpos}\", arr, suggestions)",
  "}",
  "",
  "method error(message) {",
  "    util.generalError(message, 0, \"\", \"\", [])",
  "}",
  "",
  "method error(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    if (errlinenum > 0) then {",
  "            arr := arr ++ (\"^\" * util.lines.at(errlinenum).size)",
  "    }",
  "    util.generalError(message, errlinenum, \"\", arr, suggestions)",
  "}",
  "",
  "method error(message)atLine(errlinenum) {",
  "    error(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum) {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestion(suggestion') {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (1..util.lines.at(errlinenum).size) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, errlinenum, \"\", arr, suggestions)",
  "}",
  NULL
};
Object reader_errormessages_outer_712(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_outer_715(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_lineNumbers_716(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_errormessages_lines_717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
static Object strlit2;
static Object strlit32;
static Object strlit37;
static Object strlit47;
static Object strlit202;
static Object strlit234;
static Object strlit235;
static Object strlit281;
static Object strlit286;
static Object strlit290;
static Object strlit295;
static Object strlit311;
static Object strlit324;
static Object strlit332;
static Object strlit336;
static Object strlit352;
static Object strlit357;
static Object strlit361;
static Object strlit367;
static Object strlit372;
static Object strlit377;
static Object strlit381;
static Object strlit388;
static Object strlit404;
static Object strlit417;
static Object strlit425;
static Object strlit429;
static Object strlit456;
static Object strlit461;
static Object strlit465;
static Object strlit470;
static Object strlit486;
static Object strlit499;
static Object strlit507;
static Object strlit511;
static Object strlit532;
static Object strlit548;
static Object strlit555;
static Object strlit561;
static Object strlit565;
static Object strlit570;
static Object strlit586;
static Object strlit593;
static Object strlit599;
static Object strlit603;
static Object strlit610;
static Object strlit611;
static Object strlit615;
static Object strlit628;
static Object strlit648;
static Object strlit654;
static Object strlit669;
static Object strlit682;
static Object strlit702;
static Object strlit709;
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_util;
Object module_util_init();
static ClassData objclass711;
static ClassData objclass714;
static Object strlit836;
static Object strlit853;
static Object strlit857;
static Object strlit1068;
static Object strlit1173;
static Object strlit1377;
static Object strlit1394;
static Object strlit1402;
static Object strlit1406;
static Object strlit1428;
static Object strlit1437;
static Object strlit1447;
static Object strlit1457;
static Object strlit1466;
static Object strlit1474;
Object meth_errormessages_7__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_count = getfromclosure(closure, 1);
  Object *var_xs = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  Object call10 = callmethodflags(*var_v, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe9);
// compiled member node returning call10 (depth = 6)
  int op_slot_right_8 = gc_frame_newslot(call10);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  int op_slot_left_8 = gc_frame_newslot(*var_result);
  params[0] = call10;
  partcv[0] = 1;
  Object opresult12 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult12 (depth = 5)
  *var_result = opresult12;
  if (opresult12 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num15 = alloc_Float64(1);
// compiled num node returning num15 (depth = 6)
  int op_slot_right_14 = gc_frame_newslot(num15);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_14 = gc_frame_newslot(*var_count);
  params[0] = num15;
  partcv[0] = 1;
  Object diff17 = callmethod(*var_count, "-(1)", 1, partcv, params);
// compiled op node returning diff17 (depth = 5)
  *var_count = diff17;
  if (diff17 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num21 = alloc_Float64(1);
// compiled num node returning num21 (depth = 6)
  int op_slot_right_20 = gc_frame_newslot(num21);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_20 = gc_frame_newslot(*var_count);
  params[0] = num21;
  partcv[0] = 1;
  Object opresult23 = callmethod(*var_count, "==(1)", 1, partcv, params);
// compiled op node returning opresult23 (depth = 5)
  Object if19 = done;
  if (istrue(opresult23)) {
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num26 = alloc_Float64(2);
// compiled num node returning num26 (depth = 7)
  int op_slot_right_25 = gc_frame_newslot(num26);
// starting to compile member node (depth = 7)
  int callframe28 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_xs (depth = 8)
  Object call29 = callmethodflags(*var_xs, "size", 0, partcv, params, 0);
  gc_frame_end(callframe28);
// compiled member node returning call29 (depth = 7)
  int op_slot_left_25 = gc_frame_newslot(call29);
  params[0] = num26;
  partcv[0] = 1;
  Object opresult30 = callmethod(call29, ">(1)", 1, partcv, params);
// compiled op node returning opresult30 (depth = 6)
  Object if24 = done;
  if (istrue(opresult30)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit32 == NULL) {
    strlit32 = alloc_String(",");
    gc_root(strlit32);
  }
// compiled string node returning strlit32 (depth = 8)
  int op_slot_right_31 = gc_frame_newslot(strlit32);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  int op_slot_left_31 = gc_frame_newslot(*var_result);
  params[0] = strlit32;
  partcv[0] = 1;
  Object opresult34 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult34 (depth = 7)
  *var_result = opresult34;
  if (opresult34 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if24 = done;
  } else {
  }
// compiled if node returning if24 (depth = 5)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit37 == NULL) {
    strlit37 = alloc_String(" and ");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 7)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  int op_slot_left_36 = gc_frame_newslot(*var_result);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult39 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult39 (depth = 6)
  *var_result = opresult39;
  if (opresult39 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if19 = done;
  } else {
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num43 = alloc_Float64(1);
// compiled num node returning num43 (depth = 7)
  int op_slot_right_42 = gc_frame_newslot(num43);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_count (depth = 7)
  int op_slot_left_42 = gc_frame_newslot(*var_count);
  params[0] = num43;
  partcv[0] = 1;
  Object opresult45 = callmethod(*var_count, ">(1)", 1, partcv, params);
// compiled op node returning opresult45 (depth = 6)
  Object if41 = done;
  if (istrue(opresult45)) {
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit47 == NULL) {
    strlit47 = alloc_String(", ");
    gc_root(strlit47);
  }
// compiled string node returning strlit47 (depth = 8)
  int op_slot_right_46 = gc_frame_newslot(strlit47);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  int op_slot_left_46 = gc_frame_newslot(*var_result);
  params[0] = strlit47;
  partcv[0] = 1;
  Object opresult49 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult49 (depth = 7)
  *var_result = opresult49;
  if (opresult49 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if41 = done;
  } else {
  }
// compiled if node returning if41 (depth = 5)
    gc_frame_newslot(if41);
    if19 = if41;
  }
// compiled if node returning if19 (depth = 4)
  gc_frame_end(frame);
  return if19;
}
Object meth_errormessages_1_readableStringFrom_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "readableStringFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method readableStringFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for readableStringFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_xs = &(stackframe->slots[0]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part readableStringFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
  Object *var_count = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "count");
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2 == NULL) {
    strlit2 = alloc_String("");
    gc_root(strlit2);
  }
// compiled string node returning strlit2 (depth = 3)
  *var_result = strlit2;
  if (strlit2 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_xs (depth = 4)
  Object call4 = callmethodflags(*var_xs, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3);
// compiled member node returning call4 (depth = 3)
  *var_count = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6 = alloc_Block(NULL, NULL, "errormessages", 285);
  gc_frame_newslot(block6);
// method "_apply(_)"
  block_savedest(block6);
  Object closure7 = createclosure(4, "_apply(1)");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_result);
  addtoclosure(closure7, var_count);
  addtoclosure(closure7, var_xs);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_errormessages_7__apply_40_1_41_ = addmethod2pos(block6, "_apply(1)", &meth_errormessages_7__apply_40_1_41_, 0);
  int argcv_meth_errormessages_7__apply_40_1_41_[] = {1};
  meth_meth_errormessages_7__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_7__apply_40_1_41_);
  meth_meth_errormessages_7__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_7__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block6 (depth = 3)
  gc_frame_newslot(block6);
// call case 6: other requests
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  params[0] = block6;
  partcv[0] = 1;
  Object call52 = callmethodflags(*var_xs, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5);
// compiled call node returning call52 (depth = 2)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_errormessages_84__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_h = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe85 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num87 = alloc_Float64(1);
// compiled num node returning num87 (depth = 6)
  int op_slot_right_86 = gc_frame_newslot(num87);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_86 = gc_frame_newslot(*var_i);
  params[0] = num87;
  partcv[0] = 1;
  Object sum89 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum89 (depth = 5)
  gc_frame_newslot(sum89);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num91 = alloc_Float64(1);
// compiled num node returning num91 (depth = 6)
  int op_slot_right_90 = gc_frame_newslot(num91);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_90 = gc_frame_newslot(*var_i);
  params[0] = num91;
  partcv[0] = 1;
  Object sum93 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum93 (depth = 5)
  gc_frame_newslot(sum93);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_h (depth = 5)
  params[0] = sum89;
  params[1] = sum93;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call94 = callmethodflags(*var_h, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe85);
// compiled call node returning call94 (depth = 4)
  gc_frame_end(frame);
  return call94;
}
Object meth_errormessages_114__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[3];
  int partcv[2];
  Object *var_j = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_c = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_e = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "e");
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe117 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_j (depth = 12)
  gc_frame_newslot(*var_j);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  params[0] = *var_j;
  partcv[0] = 1;
  Object call118 = callmethodflags(*var_t, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe117);
// compiled call node returning call118 (depth = 11)
  int op_slot_right_116 = gc_frame_newslot(call118);
// starting to compile call node (depth = 11)
  int callframe120 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call121 = callmethodflags(*var_p, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled call node returning call121 (depth = 11)
  int op_slot_left_116 = gc_frame_newslot(call121);
  params[0] = call118;
  partcv[0] = 1;
  Object opresult122 = callmethod(call121, "==(1)", 1, partcv, params);
// compiled op node returning opresult122 (depth = 10)
  Object if115 = done;
struct StackFrameObject *iftmpstackframe115 = stackframe;
  if (istrue(opresult122)) {
stackframe = alloc_StackFrame(0, iftmpstackframe115);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
    gc_frame_newslot(*var_c);
    if115 = *var_c;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe115);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num124 = alloc_Float64(1);
// compiled num node returning num124 (depth = 11)
  int op_slot_right_123 = gc_frame_newslot(num124);
// starting to compile call node (depth = 11)
  int callframe126 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call128 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 12)
  gc_frame_newslot(call128);
// starting to compile call node (depth = 12)
  int callframe129 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num131 = alloc_Float64(1);
// compiled num node returning num131 (depth = 14)
  int op_slot_right_130 = gc_frame_newslot(num131);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  int op_slot_left_130 = gc_frame_newslot(*var_i);
  params[0] = num131;
  partcv[0] = 1;
  Object sum133 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum133 (depth = 13)
  gc_frame_newslot(sum133);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = sum133;
  partcv[0] = 1;
  Object call134 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe129);
// compiled call node returning call134 (depth = 12)
  gc_frame_newslot(call134);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning module_errormessages (depth = 12)
  params[0] = call128;
  params[1] = call134;
  params[2] = *var_c;
  partcv[0] = 3;
  Object call135 = callmethodflags(module_errormessages, "min3(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe126);
// compiled call node returning call135 (depth = 11)
  int op_slot_left_123 = gc_frame_newslot(call135);
  params[0] = num124;
  partcv[0] = 1;
  Object sum136 = callmethod(call135, "+(1)", 1, partcv, params);
// compiled op node returning sum136 (depth = 10)
    gc_frame_newslot(sum136);
    if115 = sum136;
  }
stackframe = iftmpstackframe115;
// compiled if node returning if115 (depth = 9)
  *var_e = if115;
  if (if115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe137 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num139 = alloc_Float64(1);
// compiled num node returning num139 (depth = 11)
  int op_slot_right_138 = gc_frame_newslot(num139);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_138 = gc_frame_newslot(*var_i);
  params[0] = num139;
  partcv[0] = 1;
  Object sum141 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum141 (depth = 10)
  gc_frame_newslot(sum141);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_h (depth = 10)
  params[0] = sum141;
  partcv[0] = 1;
  Object call142 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe137);
// compiled call node returning call142 (depth = 9)
  *var_c = call142;
  if (call142 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe144 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num146 = alloc_Float64(1);
// compiled num node returning num146 (depth = 10)
  int op_slot_right_145 = gc_frame_newslot(num146);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_145 = gc_frame_newslot(*var_i);
  params[0] = num146;
  partcv[0] = 1;
  Object sum148 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum148 (depth = 9)
  gc_frame_newslot(sum148);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  gc_frame_newslot(*var_e);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_h (depth = 9)
  params[0] = sum148;
  params[1] = *var_e;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call149 = callmethodflags(*var_h, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe144);
// compiled call node returning call149 (depth = 8)
  gc_frame_end(frame);
  return call149;
}
Object meth_errormessages_157__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k_39_ = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_h = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_k_39_ (depth = 11)
  int op_slot_right_158 = gc_frame_newslot(*var_k_39_);
// starting to compile call node (depth = 11)
  int callframe160 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num162 = alloc_Float64(1);
// compiled num node returning num162 (depth = 13)
  int op_slot_right_161 = gc_frame_newslot(num162);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_top (depth = 13)
  int op_slot_left_161 = gc_frame_newslot(*var_top);
  params[0] = num162;
  partcv[0] = 1;
  Object sum164 = callmethod(*var_top, "+(1)", 1, partcv, params);
// compiled op node returning sum164 (depth = 12)
  gc_frame_newslot(sum164);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_h (depth = 12)
  params[0] = sum164;
  partcv[0] = 1;
  Object call165 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe160);
// compiled call node returning call165 (depth = 11)
  int op_slot_left_158 = gc_frame_newslot(call165);
  params[0] = *var_k_39_;
  partcv[0] = 1;
  Object opresult166 = callmethod(call165, ">(1)", 1, partcv, params);
// compiled op node returning opresult166 (depth = 10)
  gc_frame_end(frame);
  return opresult166;
}
Object meth_errormessages_154__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k_39_ = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_h = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block156 = alloc_Block(NULL, NULL, "errormessages", 339);
  gc_frame_newslot(block156);
// method "_apply"
  block_savedest(block156);
  Object closure157 = createclosure(4, "_apply");
  setclosureframe(closure157, stackframe);
  addtoclosure(closure157, var_k_39_);
  addtoclosure(closure157, var_top);
  addtoclosure(closure157, var_h);
  addtoclosure(closure157, selfslot);
  struct UserObject *uo157 = (struct UserObject*)block156;
  uo157->data[0] = (Object)closure157;
  Method *meth_meth_errormessages_157__apply = addmethod2pos(block156, "_apply", &meth_errormessages_157__apply, 0);
  int argcv_meth_errormessages_157__apply[] = {0};
  meth_meth_errormessages_157__apply->type = alloc_MethodType(1, argcv_meth_errormessages_157__apply);
  meth_meth_errormessages_157__apply->definitionModule = modulename;
  meth_meth_errormessages_157__apply->definitionLine = 500;
// compiled block node returning block156 (depth = 9)
  int op_slot_right_155 = gc_frame_newslot(block156);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num170 = alloc_Float64(0);
// compiled num node returning num170 (depth = 10)
  int op_slot_right_169 = gc_frame_newslot(num170);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_top (depth = 10)
  int op_slot_left_169 = gc_frame_newslot(*var_top);
  params[0] = num170;
  partcv[0] = 1;
  Object opresult172 = callmethod(*var_top, "≥(1)", 1, partcv, params);
// compiled op node returning opresult172 (depth = 9)
  int op_slot_left_155 = gc_frame_newslot(opresult172);
  params[0] = block156;
  partcv[0] = 1;
  Object opresult173 = callmethod(opresult172, "&&(1)", 1, partcv, params);
// compiled op node returning opresult173 (depth = 8)
  gc_frame_end(frame);
  return opresult173;
}
Object meth_errormessages_176__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_top = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num178 = alloc_Float64(1);
// compiled num node returning num178 (depth = 10)
  int op_slot_right_177 = gc_frame_newslot(num178);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_top (depth = 10)
  int op_slot_left_177 = gc_frame_newslot(*var_top);
  params[0] = num178;
  partcv[0] = 1;
  Object diff180 = callmethod(*var_top, "-(1)", 1, partcv, params);
// compiled op node returning diff180 (depth = 9)
  *var_top = diff180;
  if (diff180 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_106__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_top = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_h = getfromclosure(closure, 3);
  Object *var_k_39_ = getfromclosure(closure, 4);
  Object *var_m = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_j = &(stackframe->slots[0]);
  *var_j = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_c = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "c");
// definebindings:
// definebindings:
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num107 = alloc_Float64(0);
// compiled num node returning num107 (depth = 7)
  *var_c = num107;
  if (num107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe108 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_right_109 = gc_frame_newslot(*var_top);
// starting to compile num node (depth = 8)
  Object num111 = alloc_Float64(1);
// compiled num node returning num111 (depth = 8)
  int op_slot_left_109 = gc_frame_newslot(num111);
  params[0] = *var_top;
  partcv[0] = 1;
  Object opresult112 = callmethod(num111, "..(1)", 1, partcv, params);
// compiled op node returning opresult112 (depth = 7)
  gc_frame_newslot(opresult112);
// starting to compile block node (depth = 7)
  Object block113 = alloc_Block(NULL, NULL, "errormessages", 330);
  gc_frame_newslot(block113);
// method "_apply(_)"
  block_savedest(block113);
  Object closure114 = createclosure(6, "_apply(1)");
  setclosureframe(closure114, stackframe);
  addtoclosure(closure114, var_j);
  addtoclosure(closure114, var_t);
  addtoclosure(closure114, var_p);
  addtoclosure(closure114, var_c);
  addtoclosure(closure114, var_h);
  addtoclosure(closure114, selfslot);
  struct UserObject *uo114 = (struct UserObject*)block113;
  uo114->data[0] = (Object)closure114;
  Method *meth_meth_errormessages_114__apply_40_1_41_ = addmethod2pos(block113, "_apply(1)", &meth_errormessages_114__apply_40_1_41_, 0);
  int argcv_meth_errormessages_114__apply_40_1_41_[] = {1};
  meth_meth_errormessages_114__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_114__apply_40_1_41_);
  meth_meth_errormessages_114__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_114__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block113 (depth = 7)
  gc_frame_newslot(block113);
// call case 5: prelude request
  params[0] = opresult112;
  params[1] = block113;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call151 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe108);
// compiled call node returning call151 (depth = 6)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe152 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block153 = alloc_Block(NULL, NULL, "errormessages", 339);
  gc_frame_newslot(block153);
// method "_apply"
  block_savedest(block153);
  Object closure154 = createclosure(4, "_apply");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_k_39_);
  addtoclosure(closure154, var_top);
  addtoclosure(closure154, var_h);
  addtoclosure(closure154, selfslot);
  struct UserObject *uo154 = (struct UserObject*)block153;
  uo154->data[0] = (Object)closure154;
  Method *meth_meth_errormessages_154__apply = addmethod2pos(block153, "_apply", &meth_errormessages_154__apply, 0);
  int argcv_meth_errormessages_154__apply[] = {0};
  meth_meth_errormessages_154__apply->type = alloc_MethodType(1, argcv_meth_errormessages_154__apply);
  meth_meth_errormessages_154__apply->definitionModule = modulename;
  meth_meth_errormessages_154__apply->definitionLine = 500;
// compiled block node returning block153 (depth = 7)
  gc_frame_newslot(block153);
// starting to compile block node (depth = 7)
  Object block175 = alloc_Block(NULL, NULL, "errormessages", 339);
  gc_frame_newslot(block175);
// method "_apply"
  block_savedest(block175);
  Object closure176 = createclosure(2, "_apply");
  setclosureframe(closure176, stackframe);
  addtoclosure(closure176, var_top);
  addtoclosure(closure176, selfslot);
  struct UserObject *uo176 = (struct UserObject*)block175;
  uo176->data[0] = (Object)closure176;
  Method *meth_meth_errormessages_176__apply = addmethod2pos(block175, "_apply", &meth_errormessages_176__apply, 0);
  int argcv_meth_errormessages_176__apply[] = {0};
  meth_meth_errormessages_176__apply->type = alloc_MethodType(1, argcv_meth_errormessages_176__apply);
  meth_meth_errormessages_176__apply->definitionModule = modulename;
  meth_meth_errormessages_176__apply->definitionLine = 500;
// compiled block node returning block175 (depth = 7)
  gc_frame_newslot(block175);
// call case 5: prelude request
  params[0] = block153;
  params[1] = block175;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call183 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe152);
// compiled call node returning call183 (depth = 6)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_m (depth = 8)
  int op_slot_right_185 = gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_left_185 = gc_frame_newslot(*var_top);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult187 = callmethod(*var_top, "==(1)", 1, partcv, params);
// compiled op node returning opresult187 (depth = 7)
  Object if184 = done;
  if (istrue(opresult187)) {
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_j (depth = 8)
  block_return(realself, *var_j);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if184 = undefined;
  } else {
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num189 = alloc_Float64(1);
// compiled num node returning num189 (depth = 9)
  int op_slot_right_188 = gc_frame_newslot(num189);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_top (depth = 9)
  int op_slot_left_188 = gc_frame_newslot(*var_top);
  params[0] = num189;
  partcv[0] = 1;
  Object sum191 = callmethod(*var_top, "+(1)", 1, partcv, params);
// compiled op node returning sum191 (depth = 8)
  *var_top = sum191;
  if (sum191 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if184 = done;
  }
// compiled if node returning if184 (depth = 6)
  gc_frame_end(frame);
  return if184;
}
Object meth_errormessages_99__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_p = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object *var_k_39_ = getfromclosure(closure, 5);
  Object *var_m = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe100 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_101 = gc_frame_newslot(*var_n);
// starting to compile num node (depth = 6)
  Object num103 = alloc_Float64(1);
// compiled num node returning num103 (depth = 6)
  int op_slot_left_101 = gc_frame_newslot(num103);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult104 = callmethod(num103, "..(1)", 1, partcv, params);
// compiled op node returning opresult104 (depth = 5)
  gc_frame_newslot(opresult104);
// starting to compile block node (depth = 5)
  Object block105 = alloc_Block(NULL, NULL, "errormessages", 328);
  gc_frame_newslot(block105);
// method "_apply(_)"
  block_savedest(block105);
  Object closure106 = createclosure(7, "_apply(1)");
  setclosureframe(closure106, stackframe);
  addtoclosure(closure106, var_top);
  addtoclosure(closure106, var_t);
  addtoclosure(closure106, var_p);
  addtoclosure(closure106, var_h);
  addtoclosure(closure106, var_k_39_);
  addtoclosure(closure106, var_m);
  addtoclosure(closure106, selfslot);
  struct UserObject *uo106 = (struct UserObject*)block105;
  uo106->data[0] = (Object)closure106;
  Method *meth_meth_errormessages_106__apply_40_1_41_ = addmethod2pos(block105, "_apply(1)", &meth_errormessages_106__apply_40_1_41_, 0);
  int argcv_meth_errormessages_106__apply_40_1_41_[] = {1};
  meth_meth_errormessages_106__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_106__apply_40_1_41_);
  meth_meth_errormessages_106__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_106__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block105 (depth = 5)
  gc_frame_newslot(block105);
// call case 5: prelude request
  params[0] = opresult104;
  params[1] = block105;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call194 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call194 (depth = 4)
  gc_frame_end(frame);
  return call194;
}
Object meth_errormessages_197__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num198 = alloc_Float64(0);
// compiled num node returning num198 (depth = 5)
  block_return(realself, num198);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name(1)matches(1)within(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for name(_)matches(_)within(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name(_)");
  Object *var_t = &(stackframe->slots[1]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part matches(_)");
  Object *var_k = &(stackframe->slots[2]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part within(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_m = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "m");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// definebindings:
// definebindings:
  Object *var_k_39_ = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "k'");
  Object *var_top = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "top");
  Object *var_h = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "h");
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe54 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  Object call55 = callmethodflags(*var_p, "size", 0, partcv, params, 0);
  gc_frame_end(callframe54);
// compiled member node returning call55 (depth = 3)
  *var_m = call55;
  if (call55 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe56 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  Object call57 = callmethodflags(*var_t, "size", 0, partcv, params, 0);
  gc_frame_end(callframe56);
// compiled member node returning call57 (depth = 3)
  *var_n = call57;
  if (call57 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_right_59 = gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_left_59 = gc_frame_newslot(*var_k);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult61 = callmethod(*var_k, "≥(1)", 1, partcv, params);
// compiled op node returning opresult61 (depth = 3)
  Object if58 = done;
  if (istrue(opresult61)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  return *var_m;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if58 = undefined;
  } else {
  }
// compiled if node returning if58 (depth = 2)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num64 = alloc_Float64(1);
// compiled num node returning num64 (depth = 5)
  int op_slot_right_63 = gc_frame_newslot(num64);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_63 = gc_frame_newslot(*var_n);
  params[0] = num64;
  partcv[0] = 1;
  Object diff66 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff66 (depth = 4)
  gc_frame_newslot(diff66);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num68 = alloc_Float64(1);
// compiled num node returning num68 (depth = 5)
  int op_slot_right_67 = gc_frame_newslot(num68);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  int op_slot_left_67 = gc_frame_newslot(*var_m);
  params[0] = num68;
  partcv[0] = 1;
  Object diff70 = callmethod(*var_m, "-(1)", 1, partcv, params);
// compiled op node returning diff70 (depth = 4)
  gc_frame_newslot(diff70);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_errormessages (depth = 4)
  params[0] = *var_k;
  params[1] = diff66;
  params[2] = diff70;
  partcv[0] = 3;
  Object call71 = callmethodflags(module_errormessages, "min3(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe62);
// compiled call node returning call71 (depth = 3)
  *var_k_39_ = call71;
  if (call71 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num73 = alloc_Float64(1);
// compiled num node returning num73 (depth = 4)
  int op_slot_right_72 = gc_frame_newslot(num73);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k_39_ (depth = 4)
  int op_slot_left_72 = gc_frame_newslot(*var_k_39_);
  params[0] = num73;
  partcv[0] = 1;
  Object sum75 = callmethod(*var_k_39_, "+(1)", 1, partcv, params);
// compiled op node returning sum75 (depth = 3)
  *var_top = sum75;
  if (sum75 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe76 = gc_frame_new();
// call case 5: prelude request
  Object call77 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe76);
// compiled member node returning call77 (depth = 3)
  *var_h = call77;
  if (call77 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe78 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_right_79 = gc_frame_newslot(*var_m);
// starting to compile num node (depth = 4)
  Object num81 = alloc_Float64(0);
// compiled num node returning num81 (depth = 4)
  int op_slot_left_79 = gc_frame_newslot(num81);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult82 = callmethod(num81, "..(1)", 1, partcv, params);
// compiled op node returning opresult82 (depth = 3)
  gc_frame_newslot(opresult82);
// starting to compile block node (depth = 3)
  Object block83 = alloc_Block(NULL, NULL, "errormessages", 326);
  gc_frame_newslot(block83);
// method "_apply(_)"
  block_savedest(block83);
  Object closure84 = createclosure(2, "_apply(1)");
  setclosureframe(closure84, stackframe);
  addtoclosure(closure84, var_h);
  addtoclosure(closure84, selfslot);
  struct UserObject *uo84 = (struct UserObject*)block83;
  uo84->data[0] = (Object)closure84;
  Method *meth_meth_errormessages_84__apply_40_1_41_ = addmethod2pos(block83, "_apply(1)", &meth_errormessages_84__apply_40_1_41_, 0);
  int argcv_meth_errormessages_84__apply_40_1_41_[] = {1};
  meth_meth_errormessages_84__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_84__apply_40_1_41_);
  meth_meth_errormessages_84__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_84__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block83 (depth = 3)
  gc_frame_newslot(block83);
// call case 5: prelude request
  params[0] = opresult82;
  params[1] = block83;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call96 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compiled call node returning call96 (depth = 2)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block98 = alloc_Block(NULL, NULL, "errormessages", 327);
  gc_frame_newslot(block98);
// method "_apply"
  block_savedest(block98);
  Object closure99 = createclosure(8, "_apply");
  setclosureframe(closure99, stackframe);
  addtoclosure(closure99, var_n);
  addtoclosure(closure99, var_top);
  addtoclosure(closure99, var_t);
  addtoclosure(closure99, var_p);
  addtoclosure(closure99, var_h);
  addtoclosure(closure99, var_k_39_);
  addtoclosure(closure99, var_m);
  addtoclosure(closure99, selfslot);
  struct UserObject *uo99 = (struct UserObject*)block98;
  uo99->data[0] = (Object)closure99;
  Method *meth_meth_errormessages_99__apply = addmethod2pos(block98, "_apply", &meth_errormessages_99__apply, 0);
  int argcv_meth_errormessages_99__apply[] = {0};
  meth_meth_errormessages_99__apply->type = alloc_MethodType(1, argcv_meth_errormessages_99__apply);
  meth_meth_errormessages_99__apply->definitionModule = modulename;
  meth_meth_errormessages_99__apply->definitionLine = 500;
// compiled block node returning block98 (depth = 3)
  int frame97 = gc_frame_new();
  gc_frame_newslot(block98);
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block196 = alloc_Block(NULL, NULL, "errormessages", 346);
  gc_frame_newslot(block196);
// method "_apply(_)"
  block_savedest(block196);
  Object closure197 = createclosure(1, "_apply(1)");
  setclosureframe(closure197, stackframe);
  addtoclosure(closure197, selfslot);
  struct UserObject *uo197 = (struct UserObject*)block196;
  uo197->data[0] = (Object)closure197;
  Method *meth_meth_errormessages_197__apply_40_1_41_ = addmethod2pos(block196, "_apply(1)", &meth_errormessages_197__apply_40_1_41_, 0);
  int argcv_meth_errormessages_197__apply_40_1_41_[] = {1};
  meth_meth_errormessages_197__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_197__apply_40_1_41_);
  meth_meth_errormessages_197__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_197__apply_40_1_41_->definitionLine = 500;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe200 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe201 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit202 == NULL) {
    strlit202 = alloc_String("e");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 6)
  gc_frame_newslot(strlit202);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe203 = gc_frame_new();
// call case 5: prelude request
  Object call204 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe203);
// compiled member node returning call204 (depth = 6)
  params[0] = strlit202;
  partcv[0] = 1;
  Object call205 = callmethodflags(call204, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe201);
// compiled call node returning call205 (depth = 5)
  gc_frame_newslot(call205);
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe206 = gc_frame_new();
// call case 5: prelude request
  Object call207 = callmethodflags(prelude, "BoundsError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe206);
// compiled member node returning call207 (depth = 5)
  gc_frame_newslot(call207);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe208 = gc_frame_new();
// call case 5: prelude request
  Object call209 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe208);
// compiled member node returning call209 (depth = 5)
  params[0] = call205;
  params[1] = call207;
  partcv[0] = 2;
  Object call210 = callmethodflags(call209, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe200);
// compiled call node returning call210 (depth = 4)
((struct UserObject *)block196)->data[1] = call210;
// compiled block node returning block196 (depth = 3)
  gc_frame_newslot(block196);
  params[0] = block196;
  setline(327);
  Object catchres97 = tryCatch(block98, params, 1,NULL);
  gc_frame_end(frame97);
// compiled trycatch node returning catchres97 (depth = 2)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num211 = alloc_Float64(0);
// compiled num node returning num211 (depth = 3)
  return num211;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_212_min3_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "min3(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method min3(_,_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for min3(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *var_c = &(stackframe->slots[2]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part min3(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sf = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sf");
// definebindings:
// definebindings:
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  int op_slot_right_214 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  int op_slot_left_214 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult216 = callmethod(*var_a, "<(1)", 1, partcv, params);
// compiled op node returning opresult216 (depth = 4)
  Object if213 = done;
struct StackFrameObject *iftmpstackframe213 = stackframe;
  if (istrue(opresult216)) {
stackframe = alloc_StackFrame(0, iftmpstackframe213);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
    gc_frame_newslot(*var_a);
    if213 = *var_a;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe213);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
    gc_frame_newslot(*var_b);
    if213 = *var_b;
  }
stackframe = iftmpstackframe213;
// compiled if node returning if213 (depth = 3)
  *var_sf = if213;
  if (if213 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_218 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sf (depth = 4)
  int op_slot_left_218 = gc_frame_newslot(*var_sf);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult220 = callmethod(*var_sf, "<(1)", 1, partcv, params);
// compiled op node returning opresult220 (depth = 3)
  Object if217 = done;
  if (istrue(opresult220)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sf (depth = 3)
    gc_frame_newslot(*var_sf);
    if217 = *var_sf;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
    gc_frame_newslot(*var_c);
    if217 = *var_c;
  }
// compiled if node returning if217 (depth = 2)
  gc_frame_end(frame);
  return if217;
}
Object meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_more = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "more");
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe224 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  Object call226 = callmethodflags(*var_r, "end", 0, partcv, params, 0);
  gc_frame_end(callframe225);
// compiled member node returning call226 (depth = 6)
  Object call227 = callmethodflags(call226, "line", 0, partcv, params, 0);
  gc_frame_end(callframe224);
// compiled member node returning call227 (depth = 5)
  int op_slot_right_223 = gc_frame_newslot(call227);
// starting to compile member node (depth = 5)
  int callframe229 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe230 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  Object call231 = callmethodflags(*var_r, "start", 0, partcv, params, 0);
  gc_frame_end(callframe230);
// compiled member node returning call231 (depth = 6)
  Object call232 = callmethodflags(call231, "line", 0, partcv, params, 0);
  gc_frame_end(callframe229);
// compiled member node returning call232 (depth = 5)
  int op_slot_left_223 = gc_frame_newslot(call232);
  params[0] = call227;
  partcv[0] = 1;
  Object opresult233 = callmethod(call232, "<(1)", 1, partcv, params);
// compiled op node returning opresult233 (depth = 4)
  Object if222 = done;
struct StackFrameObject *iftmpstackframe222 = stackframe;
  if (istrue(opresult233)) {
stackframe = alloc_StackFrame(0, iftmpstackframe222);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit234 == NULL) {
    strlit234 = alloc_String("  This statement spans multiple lines; is that what you intended?");
    gc_root(strlit234);
  }
// compiled string node returning strlit234 (depth = 4)
    gc_frame_newslot(strlit234);
    if222 = strlit234;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe222);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit235 == NULL) {
    strlit235 = alloc_String("");
    gc_root(strlit235);
  }
// compiled string node returning strlit235 (depth = 4)
    gc_frame_newslot(strlit235);
    if222 = strlit235;
  }
stackframe = iftmpstackframe222;
// compiled if node returning if222 (depth = 3)
  *var_more = if222;
  if (if222 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe236 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_more (depth = 4)
  int op_slot_right_237 = gc_frame_newslot(*var_more);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_message (depth = 4)
  int op_slot_left_237 = gc_frame_newslot(*var_message);
  params[0] = *var_more;
  partcv[0] = 1;
  Object opresult239 = callmethod(*var_message, "++(1)", 1, partcv, params);
// compiled op node returning opresult239 (depth = 3)
  gc_frame_newslot(opresult239);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  gc_frame_newslot(*var_r);
// starting to compile array node (depth = 3)
  Object array240 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array240 (depth = 3)
  gc_frame_newslot(array240);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = opresult239;
  params[1] = *var_r;
  params[2] = array240;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call241 = callmethodflags(module_errormessages, "syntaxError(1)atRange(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe236);
// compiled call node returning call241 (depth = 2)
  gc_frame_end(frame);
  return call241;
}
Object meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe243 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  gc_frame_newslot(*var_r);
// starting to compile array node (depth = 3)
  Object array244 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  callmethodflags(array244, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array244 (depth = 3)
  gc_frame_newslot(array244);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_r;
  params[2] = array244;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call245 = callmethodflags(module_errormessages, "syntaxError(1)atRange(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe243);
// compiled call node returning call245 (depth = 2)
  gc_frame_end(frame);
  return call245;
}
Object meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  Object params[6];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe247 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe248 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe249 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call250 = callmethodflags(*var_r, "start", 0, partcv, params, 0);
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 4)
  Object call251 = callmethodflags(call250, "line", 0, partcv, params, 0);
  gc_frame_end(callframe248);
// compiled member node returning call251 (depth = 3)
  gc_frame_newslot(call251);
// starting to compile member node (depth = 3)
  int callframe252 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call254 = callmethodflags(*var_r, "start", 0, partcv, params, 0);
  gc_frame_end(callframe253);
// compiled member node returning call254 (depth = 4)
  Object call255 = callmethodflags(call254, "column", 0, partcv, params, 0);
  gc_frame_end(callframe252);
// compiled member node returning call255 (depth = 3)
  gc_frame_newslot(call255);
// starting to compile member node (depth = 3)
  int callframe256 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call258 = callmethodflags(*var_r, "end", 0, partcv, params, 0);
  gc_frame_end(callframe257);
// compiled member node returning call258 (depth = 4)
  Object call259 = callmethodflags(call258, "line", 0, partcv, params, 0);
  gc_frame_end(callframe256);
// compiled member node returning call259 (depth = 3)
  gc_frame_newslot(call259);
// starting to compile member node (depth = 3)
  int callframe260 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call262 = callmethodflags(*var_r, "end", 0, partcv, params, 0);
  gc_frame_end(callframe261);
// compiled member node returning call262 (depth = 4)
  Object call263 = callmethodflags(call262, "column", 0, partcv, params, 0);
  gc_frame_end(callframe260);
// compiled member node returning call263 (depth = 3)
  gc_frame_newslot(call263);
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call251;
  params[2] = call255;
  params[3] = call259;
  params[4] = call263;
  params[5] = *var_s;
  partcv[0] = 1;
  partcv[1] = 4;
  partcv[2] = 1;
  Object call264 = callmethodflags(module_errormessages, "syntaxError(1)atRange(4)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe247);
// compiled call node returning call264 (depth = 2)
  gc_frame_end(frame);
  return call264;
}
Object meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe266 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array267 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array267 (depth = 3)
  gc_frame_newslot(array267);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array267;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call268 = callmethodflags(module_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe266);
// compiled call node returning call268 (depth = 2)
  gc_frame_end(frame);
  return call268;
}
Object meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestion_39_ = &(stackframe->slots[4]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe270 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array271 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array271, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array271 (depth = 3)
  gc_frame_newslot(array271);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array271;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call272 = callmethodflags(module_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe270);
// compiled call node returning call272 (depth = 2)
  gc_frame_end(frame);
  return call272;
}
Object meth_errormessages_309__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit311 == NULL) {
    strlit311 = alloc_String("-");
    gc_root(strlit311);
  }
// compiled string node returning strlit311 (depth = 6)
  int op_slot_right_310 = gc_frame_newslot(strlit311);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_310 = gc_frame_newslot(*var_arr);
  params[0] = strlit311;
  partcv[0] = 1;
  Object opresult313 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult313 (depth = 5)
  *var_arr = opresult313;
  if (opresult313 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_322__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit324 == NULL) {
    strlit324 = alloc_String("^");
    gc_root(strlit324);
  }
// compiled string node returning strlit324 (depth = 6)
  int op_slot_right_323 = gc_frame_newslot(strlit324);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_323 = gc_frame_newslot(*var_arr);
  params[0] = strlit324;
  partcv[0] = 1;
  Object opresult326 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult326 (depth = 5)
  *var_arr = opresult326;
  if (opresult326 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_loc = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "loc");
  Object *var_arr = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "arr");
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endpos (depth = 5)
  int op_slot_right_275 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_275 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult277 = callmethod(*var_startpos, "==(1)", 1, partcv, params);
// compiled op node returning opresult277 (depth = 4)
  Object if274 = done;
struct StackFrameObject *iftmpstackframe274 = stackframe;
  if (istrue(opresult277)) {
stackframe = alloc_StackFrame(0, iftmpstackframe274);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 4)
  int callframe278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  Object call279 = callmethodflags(*var_startpos, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe278);
// compiled member node returning call279 (depth = 4)
    gc_frame_newslot(call279);
    if274 = call279;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe274);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit281 == NULL) {
    strlit281 = alloc_String("");
    gc_root(strlit281);
  }
// compiled string node returning strlit281 (depth = 5)
  int op_slot_right_280 = gc_frame_newslot(strlit281);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_283 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit286 == NULL) {
    strlit286 = alloc_String("-");
    gc_root(strlit286);
  }
// compiled string node returning strlit286 (depth = 7)
  int op_slot_right_285 = gc_frame_newslot(strlit286);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startpos (depth = 8)
  int op_slot_right_288 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 8)
  if (strlit290 == NULL) {
    strlit290 = alloc_String("");
    gc_root(strlit290);
  }
// compiled string node returning strlit290 (depth = 8)
  int op_slot_left_288 = gc_frame_newslot(strlit290);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult291 = callmethod(strlit290, "++(1)", 1, partcv, params);
// compiled op node returning opresult291 (depth = 7)
  int op_slot_left_285 = gc_frame_newslot(opresult291);
  params[0] = strlit286;
  partcv[0] = 1;
  Object opresult292 = callmethod(opresult291, "++(1)", 1, partcv, params);
// compiled op node returning opresult292 (depth = 6)
  int op_slot_left_283 = gc_frame_newslot(opresult292);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult293 = callmethod(opresult292, "++(1)", 1, partcv, params);
// compiled op node returning opresult293 (depth = 5)
  int op_slot_left_280 = gc_frame_newslot(opresult293);
  params[0] = strlit281;
  partcv[0] = 1;
  Object opresult294 = callmethod(opresult293, "++(1)", 1, partcv, params);
// compiled op node returning opresult294 (depth = 4)
    gc_frame_newslot(opresult294);
    if274 = opresult294;
  }
stackframe = iftmpstackframe274;
// compiled if node returning if274 (depth = 3)
  *var_loc = if274;
  if (if274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit295 == NULL) {
    strlit295 = alloc_String("----");
    gc_root(strlit295);
  }
// compiled string node returning strlit295 (depth = 3)
  *var_arr = strlit295;
  if (strlit295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe296 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  Object call301 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe300);
// compiled member node returning call301 (depth = 6)
  Object call302 = callmethodflags(call301, "size", 0, partcv, params, 0);
  gc_frame_end(callframe299);
// compiled member node returning call302 (depth = 5)
  int op_slot_right_298 = gc_frame_newslot(call302);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_298 = gc_frame_newslot(*var_startpos);
  params[0] = call302;
  partcv[0] = 1;
  Object sum304 = callmethod(*var_startpos, "+(1)", 1, partcv, params);
// compiled op node returning sum304 (depth = 4)
  int op_slot_right_297 = gc_frame_newslot(sum304);
// starting to compile num node (depth = 4)
  Object num306 = alloc_Float64(2);
// compiled num node returning num306 (depth = 4)
  int op_slot_left_297 = gc_frame_newslot(num306);
  params[0] = sum304;
  partcv[0] = 1;
  Object opresult307 = callmethod(num306, "..(1)", 1, partcv, params);
// compiled op node returning opresult307 (depth = 3)
  gc_frame_newslot(opresult307);
// starting to compile block node (depth = 3)
  Object block308 = alloc_Block(NULL, NULL, "errormessages", 386);
  gc_frame_newslot(block308);
// method "_apply(_)"
  block_savedest(block308);
  Object closure309 = createclosure(2, "_apply(1)");
  setclosureframe(closure309, stackframe);
  addtoclosure(closure309, var_arr);
  addtoclosure(closure309, selfslot);
  struct UserObject *uo309 = (struct UserObject*)block308;
  uo309->data[0] = (Object)closure309;
  Method *meth_meth_errormessages_309__apply_40_1_41_ = addmethod2pos(block308, "_apply(1)", &meth_errormessages_309__apply_40_1_41_, 0);
  int argcv_meth_errormessages_309__apply_40_1_41_[] = {1};
  meth_meth_errormessages_309__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_309__apply_40_1_41_);
  meth_meth_errormessages_309__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_309__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block308 (depth = 3)
  gc_frame_newslot(block308);
// call case 5: prelude request
  params[0] = opresult307;
  params[1] = block308;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call316 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe296);
// compiled call node returning call316 (depth = 2)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe317 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_318 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_318 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult320 = callmethod(*var_startpos, "..(1)", 1, partcv, params);
// compiled op node returning opresult320 (depth = 3)
  gc_frame_newslot(opresult320);
// starting to compile block node (depth = 3)
  Object block321 = alloc_Block(NULL, NULL, "errormessages", 389);
  gc_frame_newslot(block321);
// method "_apply(_)"
  block_savedest(block321);
  Object closure322 = createclosure(2, "_apply(1)");
  setclosureframe(closure322, stackframe);
  addtoclosure(closure322, var_arr);
  addtoclosure(closure322, selfslot);
  struct UserObject *uo322 = (struct UserObject*)block321;
  uo322->data[0] = (Object)closure322;
  Method *meth_meth_errormessages_322__apply_40_1_41_ = addmethod2pos(block321, "_apply(1)", &meth_errormessages_322__apply_40_1_41_, 0);
  int argcv_meth_errormessages_322__apply_40_1_41_[] = {1};
  meth_meth_errormessages_322__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_322__apply_40_1_41_);
  meth_meth_errormessages_322__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_322__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block321 (depth = 3)
  gc_frame_newslot(block321);
// call case 5: prelude request
  params[0] = opresult320;
  params[1] = block321;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call329 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe317);
// compiled call node returning call329 (depth = 2)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe330 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit332 == NULL) {
    strlit332 = alloc_String("");
    gc_root(strlit332);
  }
// compiled string node returning strlit332 (depth = 4)
  int op_slot_right_331 = gc_frame_newslot(strlit332);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_334 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit336 == NULL) {
    strlit336 = alloc_String(":");
    gc_root(strlit336);
  }
// compiled string node returning strlit336 (depth = 5)
  int op_slot_left_334 = gc_frame_newslot(strlit336);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult337 = callmethod(strlit336, "++(1)", 1, partcv, params);
// compiled op node returning opresult337 (depth = 4)
  int op_slot_left_331 = gc_frame_newslot(opresult337);
  params[0] = strlit332;
  partcv[0] = 1;
  Object opresult338 = callmethod(opresult337, "++(1)", 1, partcv, params);
// compiled op node returning opresult338 (depth = 3)
  gc_frame_newslot(opresult338);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult338;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call339 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe330);
// compiled call node returning call339 (depth = 2)
  gc_frame_end(frame);
  return call339;
}
Object meth_errormessages_402__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit404 == NULL) {
    strlit404 = alloc_String("-");
    gc_root(strlit404);
  }
// compiled string node returning strlit404 (depth = 6)
  int op_slot_right_403 = gc_frame_newslot(strlit404);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_403 = gc_frame_newslot(*var_arr);
  params[0] = strlit404;
  partcv[0] = 1;
  Object opresult406 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult406 (depth = 5)
  *var_arr = opresult406;
  if (opresult406 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_415__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___4 = &(stackframe->slots[0]);
  *var___4 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit417 == NULL) {
    strlit417 = alloc_String("^");
    gc_root(strlit417);
  }
// compiled string node returning strlit417 (depth = 6)
  int op_slot_right_416 = gc_frame_newslot(strlit417);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_416 = gc_frame_newslot(*var_arr);
  params[0] = strlit417;
  partcv[0] = 1;
  Object opresult419 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult419 (depth = 5)
  *var_arr = opresult419;
  if (opresult419 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atRange(4)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 4)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_startline = &(stackframe->slots[1]);
  *var_startline = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endline = &(stackframe->slots[3]);
  *var_endline = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[4]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 4)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_,_)");
  Object *var_suggestions = &(stackframe->slots[5]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_loc = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "loc");
  Object *var_arr = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "arr");
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endline (depth = 5)
  int op_slot_right_342 = gc_frame_newslot(*var_endline);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startline (depth = 5)
  int op_slot_left_342 = gc_frame_newslot(*var_startline);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult344 = callmethod(*var_startline, "==(1)", 1, partcv, params);
// compiled op node returning opresult344 (depth = 4)
  Object if341 = done;
struct StackFrameObject *iftmpstackframe341 = stackframe;
  if (istrue(opresult344)) {
stackframe = alloc_StackFrame(0, iftmpstackframe341);
gc_frame_newslot((Object)stackframe);
// definebindings:
// definebindings:
// definebindings:
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_346 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  int op_slot_left_346 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult348 = callmethod(*var_startpos, "==(1)", 1, partcv, params);
// compiled op node returning opresult348 (depth = 5)
  Object if345 = done;
  if (istrue(opresult348)) {
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  Object call350 = callmethodflags(*var_startpos, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe349);
// compiled member node returning call350 (depth = 5)
    gc_frame_newslot(call350);
    if345 = call350;
  } else {
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit352 == NULL) {
    strlit352 = alloc_String("");
    gc_root(strlit352);
  }
// compiled string node returning strlit352 (depth = 6)
  int op_slot_right_351 = gc_frame_newslot(strlit352);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_endpos (depth = 7)
  int op_slot_right_354 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit357 == NULL) {
    strlit357 = alloc_String("-");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 8)
  int op_slot_right_356 = gc_frame_newslot(strlit357);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startpos (depth = 9)
  int op_slot_right_359 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 9)
  if (strlit361 == NULL) {
    strlit361 = alloc_String("");
    gc_root(strlit361);
  }
// compiled string node returning strlit361 (depth = 9)
  int op_slot_left_359 = gc_frame_newslot(strlit361);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult362 = callmethod(strlit361, "++(1)", 1, partcv, params);
// compiled op node returning opresult362 (depth = 8)
  int op_slot_left_356 = gc_frame_newslot(opresult362);
  params[0] = strlit357;
  partcv[0] = 1;
  Object opresult363 = callmethod(opresult362, "++(1)", 1, partcv, params);
// compiled op node returning opresult363 (depth = 7)
  int op_slot_left_354 = gc_frame_newslot(opresult363);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult364 = callmethod(opresult363, "++(1)", 1, partcv, params);
// compiled op node returning opresult364 (depth = 6)
  int op_slot_left_351 = gc_frame_newslot(opresult364);
  params[0] = strlit352;
  partcv[0] = 1;
  Object opresult365 = callmethod(opresult364, "++(1)", 1, partcv, params);
// compiled op node returning opresult365 (depth = 5)
    gc_frame_newslot(opresult365);
    if345 = opresult365;
  }
// compiled if node returning if345 (depth = 4)
    gc_frame_newslot(if345);
    if341 = if345;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe341);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit367 == NULL) {
    strlit367 = alloc_String("");
    gc_root(strlit367);
  }
// compiled string node returning strlit367 (depth = 5)
  int op_slot_right_366 = gc_frame_newslot(strlit367);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_369 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit372 == NULL) {
    strlit372 = alloc_String(":");
    gc_root(strlit372);
  }
// compiled string node returning strlit372 (depth = 7)
  int op_slot_right_371 = gc_frame_newslot(strlit372);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endline (depth = 8)
  int op_slot_right_374 = gc_frame_newslot(*var_endline);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit377 == NULL) {
    strlit377 = alloc_String("-");
    gc_root(strlit377);
  }
// compiled string node returning strlit377 (depth = 9)
  int op_slot_right_376 = gc_frame_newslot(strlit377);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_startpos (depth = 10)
  int op_slot_right_379 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 10)
  if (strlit381 == NULL) {
    strlit381 = alloc_String("");
    gc_root(strlit381);
  }
// compiled string node returning strlit381 (depth = 10)
  int op_slot_left_379 = gc_frame_newslot(strlit381);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult382 = callmethod(strlit381, "++(1)", 1, partcv, params);
// compiled op node returning opresult382 (depth = 9)
  int op_slot_left_376 = gc_frame_newslot(opresult382);
  params[0] = strlit377;
  partcv[0] = 1;
  Object opresult383 = callmethod(opresult382, "++(1)", 1, partcv, params);
// compiled op node returning opresult383 (depth = 8)
  int op_slot_left_374 = gc_frame_newslot(opresult383);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult384 = callmethod(opresult383, "++(1)", 1, partcv, params);
// compiled op node returning opresult384 (depth = 7)
  int op_slot_left_371 = gc_frame_newslot(opresult384);
  params[0] = strlit372;
  partcv[0] = 1;
  Object opresult385 = callmethod(opresult384, "++(1)", 1, partcv, params);
// compiled op node returning opresult385 (depth = 6)
  int op_slot_left_369 = gc_frame_newslot(opresult385);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult386 = callmethod(opresult385, "++(1)", 1, partcv, params);
// compiled op node returning opresult386 (depth = 5)
  int op_slot_left_366 = gc_frame_newslot(opresult386);
  params[0] = strlit367;
  partcv[0] = 1;
  Object opresult387 = callmethod(opresult386, "++(1)", 1, partcv, params);
// compiled op node returning opresult387 (depth = 4)
    gc_frame_newslot(opresult387);
    if341 = opresult387;
  }
stackframe = iftmpstackframe341;
// compiled if node returning if341 (depth = 3)
  *var_loc = if341;
  if (if341 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit388 == NULL) {
    strlit388 = alloc_String("----");
    gc_root(strlit388);
  }
// compiled string node returning strlit388 (depth = 3)
  *var_arr = strlit388;
  if (strlit388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe389 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe392 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startline (depth = 7)
  Object call394 = callmethodflags(*var_startline, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe393);
// compiled member node returning call394 (depth = 6)
  Object call395 = callmethodflags(call394, "size", 0, partcv, params, 0);
  gc_frame_end(callframe392);
// compiled member node returning call395 (depth = 5)
  int op_slot_right_391 = gc_frame_newslot(call395);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_391 = gc_frame_newslot(*var_startpos);
  params[0] = call395;
  partcv[0] = 1;
  Object sum397 = callmethod(*var_startpos, "+(1)", 1, partcv, params);
// compiled op node returning sum397 (depth = 4)
  int op_slot_right_390 = gc_frame_newslot(sum397);
// starting to compile num node (depth = 4)
  Object num399 = alloc_Float64(2);
// compiled num node returning num399 (depth = 4)
  int op_slot_left_390 = gc_frame_newslot(num399);
  params[0] = sum397;
  partcv[0] = 1;
  Object opresult400 = callmethod(num399, "..(1)", 1, partcv, params);
// compiled op node returning opresult400 (depth = 3)
  gc_frame_newslot(opresult400);
// starting to compile block node (depth = 3)
  Object block401 = alloc_Block(NULL, NULL, "errormessages", 406);
  gc_frame_newslot(block401);
// method "_apply(_)"
  block_savedest(block401);
  Object closure402 = createclosure(2, "_apply(1)");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_arr);
  addtoclosure(closure402, selfslot);
  struct UserObject *uo402 = (struct UserObject*)block401;
  uo402->data[0] = (Object)closure402;
  Method *meth_meth_errormessages_402__apply_40_1_41_ = addmethod2pos(block401, "_apply(1)", &meth_errormessages_402__apply_40_1_41_, 0);
  int argcv_meth_errormessages_402__apply_40_1_41_[] = {1};
  meth_meth_errormessages_402__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_402__apply_40_1_41_);
  meth_meth_errormessages_402__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_402__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block401 (depth = 3)
  gc_frame_newslot(block401);
// call case 5: prelude request
  params[0] = opresult400;
  params[1] = block401;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call409 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe389);
// compiled call node returning call409 (depth = 2)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe410 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_411 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_411 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult413 = callmethod(*var_startpos, "..(1)", 1, partcv, params);
// compiled op node returning opresult413 (depth = 3)
  gc_frame_newslot(opresult413);
// starting to compile block node (depth = 3)
  Object block414 = alloc_Block(NULL, NULL, "errormessages", 409);
  gc_frame_newslot(block414);
// method "_apply(_)"
  block_savedest(block414);
  Object closure415 = createclosure(2, "_apply(1)");
  setclosureframe(closure415, stackframe);
  addtoclosure(closure415, var_arr);
  addtoclosure(closure415, selfslot);
  struct UserObject *uo415 = (struct UserObject*)block414;
  uo415->data[0] = (Object)closure415;
  Method *meth_meth_errormessages_415__apply_40_1_41_ = addmethod2pos(block414, "_apply(1)", &meth_errormessages_415__apply_40_1_41_, 0);
  int argcv_meth_errormessages_415__apply_40_1_41_[] = {1};
  meth_meth_errormessages_415__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_415__apply_40_1_41_);
  meth_meth_errormessages_415__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_415__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block414 (depth = 3)
  gc_frame_newslot(block414);
// call case 5: prelude request
  params[0] = opresult413;
  params[1] = block414;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call422 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe410);
// compiled call node returning call422 (depth = 2)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe423 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startline (depth = 3)
  gc_frame_newslot(*var_startline);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit425 == NULL) {
    strlit425 = alloc_String("");
    gc_root(strlit425);
  }
// compiled string node returning strlit425 (depth = 4)
  int op_slot_right_424 = gc_frame_newslot(strlit425);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_427 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit429 == NULL) {
    strlit429 = alloc_String(":");
    gc_root(strlit429);
  }
// compiled string node returning strlit429 (depth = 5)
  int op_slot_left_427 = gc_frame_newslot(strlit429);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult430 = callmethod(strlit429, "++(1)", 1, partcv, params);
// compiled op node returning opresult430 (depth = 4)
  int op_slot_left_424 = gc_frame_newslot(opresult430);
  params[0] = strlit425;
  partcv[0] = 1;
  Object opresult431 = callmethod(opresult430, "++(1)", 1, partcv, params);
// compiled op node returning opresult431 (depth = 3)
  gc_frame_newslot(opresult431);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_startline;
  params[2] = opresult431;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call432 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe423);
// compiled call node returning call432 (depth = 2)
  gc_frame_end(frame);
  return call432;
}
Object meth_errormessages_433_error_40_1_41_atRange_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atRange(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_)");
  Object params[4];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe434 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile member node (depth = 3)
  int callframe435 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe436 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call437 = callmethodflags(*var_r, "start", 0, partcv, params, 0);
  gc_frame_end(callframe436);
// compiled member node returning call437 (depth = 4)
  Object call438 = callmethodflags(call437, "line", 0, partcv, params, 0);
  gc_frame_end(callframe435);
// compiled member node returning call438 (depth = 3)
  gc_frame_newslot(call438);
// starting to compile member node (depth = 3)
  int callframe439 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe440 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call441 = callmethodflags(*var_r, "start", 0, partcv, params, 0);
  gc_frame_end(callframe440);
// compiled member node returning call441 (depth = 4)
  Object call442 = callmethodflags(call441, "column", 0, partcv, params, 0);
  gc_frame_end(callframe439);
// compiled member node returning call442 (depth = 3)
  gc_frame_newslot(call442);
// starting to compile member node (depth = 3)
  int callframe443 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe444 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  Object call445 = callmethodflags(*var_r, "end", 0, partcv, params, 0);
  gc_frame_end(callframe444);
// compiled member node returning call445 (depth = 4)
  Object call446 = callmethodflags(call445, "column", 0, partcv, params, 0);
  gc_frame_end(callframe443);
// compiled member node returning call446 (depth = 3)
  gc_frame_newslot(call446);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call438;
  params[2] = call442;
  params[3] = call446;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call447 = callmethodflags(module_errormessages, "error(1)atRange(3)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe434);
// compiled call node returning call447 (depth = 2)
  gc_frame_end(frame);
  return call447;
}
Object meth_errormessages_484__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___5 = &(stackframe->slots[0]);
  *var___5 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit486 == NULL) {
    strlit486 = alloc_String("-");
    gc_root(strlit486);
  }
// compiled string node returning strlit486 (depth = 6)
  int op_slot_right_485 = gc_frame_newslot(strlit486);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_485 = gc_frame_newslot(*var_arr);
  params[0] = strlit486;
  partcv[0] = 1;
  Object opresult488 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult488 (depth = 5)
  *var_arr = opresult488;
  if (opresult488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_497__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___6 = &(stackframe->slots[0]);
  *var___6 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit499 == NULL) {
    strlit499 = alloc_String("^");
    gc_root(strlit499);
  }
// compiled string node returning strlit499 (depth = 6)
  int op_slot_right_498 = gc_frame_newslot(strlit499);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_498 = gc_frame_newslot(*var_arr);
  params[0] = strlit499;
  partcv[0] = 1;
  Object opresult501 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult501 (depth = 5)
  *var_arr = opresult501;
  if (opresult501 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atRange(3)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_loc = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "loc");
  Object *var_arr = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "arr");
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endpos (depth = 5)
  int op_slot_right_450 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_450 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult452 = callmethod(*var_startpos, "==(1)", 1, partcv, params);
// compiled op node returning opresult452 (depth = 4)
  Object if449 = done;
struct StackFrameObject *iftmpstackframe449 = stackframe;
  if (istrue(opresult452)) {
stackframe = alloc_StackFrame(0, iftmpstackframe449);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 4)
  int callframe453 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  Object call454 = callmethodflags(*var_startpos, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe453);
// compiled member node returning call454 (depth = 4)
    gc_frame_newslot(call454);
    if449 = call454;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe449);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit456 == NULL) {
    strlit456 = alloc_String("");
    gc_root(strlit456);
  }
// compiled string node returning strlit456 (depth = 5)
  int op_slot_right_455 = gc_frame_newslot(strlit456);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_458 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit461 == NULL) {
    strlit461 = alloc_String("-");
    gc_root(strlit461);
  }
// compiled string node returning strlit461 (depth = 7)
  int op_slot_right_460 = gc_frame_newslot(strlit461);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startpos (depth = 8)
  int op_slot_right_463 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 8)
  if (strlit465 == NULL) {
    strlit465 = alloc_String("");
    gc_root(strlit465);
  }
// compiled string node returning strlit465 (depth = 8)
  int op_slot_left_463 = gc_frame_newslot(strlit465);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult466 = callmethod(strlit465, "++(1)", 1, partcv, params);
// compiled op node returning opresult466 (depth = 7)
  int op_slot_left_460 = gc_frame_newslot(opresult466);
  params[0] = strlit461;
  partcv[0] = 1;
  Object opresult467 = callmethod(opresult466, "++(1)", 1, partcv, params);
// compiled op node returning opresult467 (depth = 6)
  int op_slot_left_458 = gc_frame_newslot(opresult467);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "++(1)", 1, partcv, params);
// compiled op node returning opresult468 (depth = 5)
  int op_slot_left_455 = gc_frame_newslot(opresult468);
  params[0] = strlit456;
  partcv[0] = 1;
  Object opresult469 = callmethod(opresult468, "++(1)", 1, partcv, params);
// compiled op node returning opresult469 (depth = 4)
    gc_frame_newslot(opresult469);
    if449 = opresult469;
  }
stackframe = iftmpstackframe449;
// compiled if node returning if449 (depth = 3)
  *var_loc = if449;
  if (if449 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit470 == NULL) {
    strlit470 = alloc_String("----");
    gc_root(strlit470);
  }
// compiled string node returning strlit470 (depth = 3)
  *var_arr = strlit470;
  if (strlit470 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe471 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe474 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  Object call476 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe475);
// compiled member node returning call476 (depth = 6)
  Object call477 = callmethodflags(call476, "size", 0, partcv, params, 0);
  gc_frame_end(callframe474);
// compiled member node returning call477 (depth = 5)
  int op_slot_right_473 = gc_frame_newslot(call477);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_473 = gc_frame_newslot(*var_startpos);
  params[0] = call477;
  partcv[0] = 1;
  Object sum479 = callmethod(*var_startpos, "+(1)", 1, partcv, params);
// compiled op node returning sum479 (depth = 4)
  int op_slot_right_472 = gc_frame_newslot(sum479);
// starting to compile num node (depth = 4)
  Object num481 = alloc_Float64(2);
// compiled num node returning num481 (depth = 4)
  int op_slot_left_472 = gc_frame_newslot(num481);
  params[0] = sum479;
  partcv[0] = 1;
  Object opresult482 = callmethod(num481, "..(1)", 1, partcv, params);
// compiled op node returning opresult482 (depth = 3)
  gc_frame_newslot(opresult482);
// starting to compile block node (depth = 3)
  Object block483 = alloc_Block(NULL, NULL, "errormessages", 421);
  gc_frame_newslot(block483);
// method "_apply(_)"
  block_savedest(block483);
  Object closure484 = createclosure(2, "_apply(1)");
  setclosureframe(closure484, stackframe);
  addtoclosure(closure484, var_arr);
  addtoclosure(closure484, selfslot);
  struct UserObject *uo484 = (struct UserObject*)block483;
  uo484->data[0] = (Object)closure484;
  Method *meth_meth_errormessages_484__apply_40_1_41_ = addmethod2pos(block483, "_apply(1)", &meth_errormessages_484__apply_40_1_41_, 0);
  int argcv_meth_errormessages_484__apply_40_1_41_[] = {1};
  meth_meth_errormessages_484__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_484__apply_40_1_41_);
  meth_meth_errormessages_484__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_484__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block483 (depth = 3)
  gc_frame_newslot(block483);
// call case 5: prelude request
  params[0] = opresult482;
  params[1] = block483;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call491 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe471);
// compiled call node returning call491 (depth = 2)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe492 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_493 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_493 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult495 = callmethod(*var_startpos, "..(1)", 1, partcv, params);
// compiled op node returning opresult495 (depth = 3)
  gc_frame_newslot(opresult495);
// starting to compile block node (depth = 3)
  Object block496 = alloc_Block(NULL, NULL, "errormessages", 424);
  gc_frame_newslot(block496);
// method "_apply(_)"
  block_savedest(block496);
  Object closure497 = createclosure(2, "_apply(1)");
  setclosureframe(closure497, stackframe);
  addtoclosure(closure497, var_arr);
  addtoclosure(closure497, selfslot);
  struct UserObject *uo497 = (struct UserObject*)block496;
  uo497->data[0] = (Object)closure497;
  Method *meth_meth_errormessages_497__apply_40_1_41_ = addmethod2pos(block496, "_apply(1)", &meth_errormessages_497__apply_40_1_41_, 0);
  int argcv_meth_errormessages_497__apply_40_1_41_[] = {1};
  meth_meth_errormessages_497__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_497__apply_40_1_41_);
  meth_meth_errormessages_497__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_497__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block496 (depth = 3)
  gc_frame_newslot(block496);
// call case 5: prelude request
  params[0] = opresult495;
  params[1] = block496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call504 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe492);
// compiled call node returning call504 (depth = 2)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe505 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit507 == NULL) {
    strlit507 = alloc_String("");
    gc_root(strlit507);
  }
// compiled string node returning strlit507 (depth = 4)
  int op_slot_right_506 = gc_frame_newslot(strlit507);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_509 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit511 == NULL) {
    strlit511 = alloc_String(":");
    gc_root(strlit511);
  }
// compiled string node returning strlit511 (depth = 5)
  int op_slot_left_509 = gc_frame_newslot(strlit511);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult512 = callmethod(strlit511, "++(1)", 1, partcv, params);
// compiled op node returning opresult512 (depth = 4)
  int op_slot_left_506 = gc_frame_newslot(opresult512);
  params[0] = strlit507;
  partcv[0] = 1;
  Object opresult513 = callmethod(opresult512, "++(1)", 1, partcv, params);
// compiled op node returning opresult513 (depth = 3)
  gc_frame_newslot(opresult513);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult513;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call514 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe505);
// compiled call node returning call514 (depth = 2)
  gc_frame_end(frame);
  return call514;
}
Object meth_errormessages_515_error_40_1_41_atRange_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atRange(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_,_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe516 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array517 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array517 (depth = 3)
  gc_frame_newslot(array517);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array517;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call518 = callmethodflags(module_errormessages, "error(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe516);
// compiled call node returning call518 (depth = 2)
  gc_frame_end(frame);
  return call518;
}
Object meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe520 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array521 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array521 (depth = 3)
  gc_frame_newslot(array521);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array521;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call522 = callmethodflags(module_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe520);
// compiled call node returning call522 (depth = 2)
  gc_frame_end(frame);
  return call522;
}
Object meth_errormessages_523_error_40_1_41_atPosition_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atPosition(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atPosition(_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe524 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array525 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array525 (depth = 3)
  gc_frame_newslot(array525);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array525;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call526 = callmethodflags(module_errormessages, "error(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe524);
// compiled call node returning call526 (depth = 2)
  gc_frame_end(frame);
  return call526;
}
Object meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestion_39_ = &(stackframe->slots[3]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe528 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array529 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array529, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array529 (depth = 3)
  gc_frame_newslot(array529);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array529;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call530 = callmethodflags(module_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe528);
// compiled call node returning call530 (depth = 2)
  gc_frame_end(frame);
  return call530;
}
Object meth_errormessages_546__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___7 = &(stackframe->slots[0]);
  *var___7 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit548 == NULL) {
    strlit548 = alloc_String("-");
    gc_root(strlit548);
  }
// compiled string node returning strlit548 (depth = 6)
  int op_slot_right_547 = gc_frame_newslot(strlit548);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_547 = gc_frame_newslot(*var_arr);
  params[0] = strlit548;
  partcv[0] = 1;
  Object opresult550 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult550 (depth = 5)
  *var_arr = opresult550;
  if (opresult550 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit532 == NULL) {
    strlit532 = alloc_String("----");
    gc_root(strlit532);
  }
// compiled string node returning strlit532 (depth = 3)
  *var_arr = strlit532;
  if (strlit532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe533 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe536 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe537 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  Object call538 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe537);
// compiled member node returning call538 (depth = 6)
  Object call539 = callmethodflags(call538, "size", 0, partcv, params, 0);
  gc_frame_end(callframe536);
// compiled member node returning call539 (depth = 5)
  int op_slot_right_535 = gc_frame_newslot(call539);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_535 = gc_frame_newslot(*var_errpos);
  params[0] = call539;
  partcv[0] = 1;
  Object sum541 = callmethod(*var_errpos, "+(1)", 1, partcv, params);
// compiled op node returning sum541 (depth = 4)
  int op_slot_right_534 = gc_frame_newslot(sum541);
// starting to compile num node (depth = 4)
  Object num543 = alloc_Float64(2);
// compiled num node returning num543 (depth = 4)
  int op_slot_left_534 = gc_frame_newslot(num543);
  params[0] = sum541;
  partcv[0] = 1;
  Object opresult544 = callmethod(num543, "..(1)", 1, partcv, params);
// compiled op node returning opresult544 (depth = 3)
  gc_frame_newslot(opresult544);
// starting to compile block node (depth = 3)
  Object block545 = alloc_Block(NULL, NULL, "errormessages", 448);
  gc_frame_newslot(block545);
// method "_apply(_)"
  block_savedest(block545);
  Object closure546 = createclosure(2, "_apply(1)");
  setclosureframe(closure546, stackframe);
  addtoclosure(closure546, var_arr);
  addtoclosure(closure546, selfslot);
  struct UserObject *uo546 = (struct UserObject*)block545;
  uo546->data[0] = (Object)closure546;
  Method *meth_meth_errormessages_546__apply_40_1_41_ = addmethod2pos(block545, "_apply(1)", &meth_errormessages_546__apply_40_1_41_, 0);
  int argcv_meth_errormessages_546__apply_40_1_41_[] = {1};
  meth_meth_errormessages_546__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_546__apply_40_1_41_);
  meth_meth_errormessages_546__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_546__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block545 (depth = 3)
  gc_frame_newslot(block545);
// call case 5: prelude request
  params[0] = opresult544;
  params[1] = block545;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call553 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe533);
// compiled call node returning call553 (depth = 2)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit555 == NULL) {
    strlit555 = alloc_String("^");
    gc_root(strlit555);
  }
// compiled string node returning strlit555 (depth = 4)
  int op_slot_right_554 = gc_frame_newslot(strlit555);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_554 = gc_frame_newslot(*var_arr);
  params[0] = strlit555;
  partcv[0] = 1;
  Object opresult557 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult557 (depth = 3)
  *var_arr = opresult557;
  if (opresult557 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe559 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit561 == NULL) {
    strlit561 = alloc_String("");
    gc_root(strlit561);
  }
// compiled string node returning strlit561 (depth = 4)
  int op_slot_right_560 = gc_frame_newslot(strlit561);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_563 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit565 == NULL) {
    strlit565 = alloc_String(":");
    gc_root(strlit565);
  }
// compiled string node returning strlit565 (depth = 5)
  int op_slot_left_563 = gc_frame_newslot(strlit565);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult566 = callmethod(strlit565, "++(1)", 1, partcv, params);
// compiled op node returning opresult566 (depth = 4)
  int op_slot_left_560 = gc_frame_newslot(opresult566);
  params[0] = strlit561;
  partcv[0] = 1;
  Object opresult567 = callmethod(opresult566, "++(1)", 1, partcv, params);
// compiled op node returning opresult567 (depth = 3)
  gc_frame_newslot(opresult567);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult567;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call568 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe559);
// compiled call node returning call568 (depth = 2)
  gc_frame_end(frame);
  return call568;
}
Object meth_errormessages_584__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___8 = &(stackframe->slots[0]);
  *var___8 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit586 == NULL) {
    strlit586 = alloc_String("-");
    gc_root(strlit586);
  }
// compiled string node returning strlit586 (depth = 6)
  int op_slot_right_585 = gc_frame_newslot(strlit586);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_585 = gc_frame_newslot(*var_arr);
  params[0] = strlit586;
  partcv[0] = 1;
  Object opresult588 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult588 (depth = 5)
  *var_arr = opresult588;
  if (opresult588 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atPosition(2)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atPosition(_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit570 == NULL) {
    strlit570 = alloc_String("----");
    gc_root(strlit570);
  }
// compiled string node returning strlit570 (depth = 3)
  *var_arr = strlit570;
  if (strlit570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe571 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe574 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe575 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  Object call576 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe575);
// compiled member node returning call576 (depth = 6)
  Object call577 = callmethodflags(call576, "size", 0, partcv, params, 0);
  gc_frame_end(callframe574);
// compiled member node returning call577 (depth = 5)
  int op_slot_right_573 = gc_frame_newslot(call577);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_573 = gc_frame_newslot(*var_errpos);
  params[0] = call577;
  partcv[0] = 1;
  Object sum579 = callmethod(*var_errpos, "+(1)", 1, partcv, params);
// compiled op node returning sum579 (depth = 4)
  int op_slot_right_572 = gc_frame_newslot(sum579);
// starting to compile num node (depth = 4)
  Object num581 = alloc_Float64(2);
// compiled num node returning num581 (depth = 4)
  int op_slot_left_572 = gc_frame_newslot(num581);
  params[0] = sum579;
  partcv[0] = 1;
  Object opresult582 = callmethod(num581, "..(1)", 1, partcv, params);
// compiled op node returning opresult582 (depth = 3)
  gc_frame_newslot(opresult582);
// starting to compile block node (depth = 3)
  Object block583 = alloc_Block(NULL, NULL, "errormessages", 458);
  gc_frame_newslot(block583);
// method "_apply(_)"
  block_savedest(block583);
  Object closure584 = createclosure(2, "_apply(1)");
  setclosureframe(closure584, stackframe);
  addtoclosure(closure584, var_arr);
  addtoclosure(closure584, selfslot);
  struct UserObject *uo584 = (struct UserObject*)block583;
  uo584->data[0] = (Object)closure584;
  Method *meth_meth_errormessages_584__apply_40_1_41_ = addmethod2pos(block583, "_apply(1)", &meth_errormessages_584__apply_40_1_41_, 0);
  int argcv_meth_errormessages_584__apply_40_1_41_[] = {1};
  meth_meth_errormessages_584__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_584__apply_40_1_41_);
  meth_meth_errormessages_584__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_584__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block583 (depth = 3)
  gc_frame_newslot(block583);
// call case 5: prelude request
  params[0] = opresult582;
  params[1] = block583;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call591 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe571);
// compiled call node returning call591 (depth = 2)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit593 == NULL) {
    strlit593 = alloc_String("^");
    gc_root(strlit593);
  }
// compiled string node returning strlit593 (depth = 4)
  int op_slot_right_592 = gc_frame_newslot(strlit593);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_592 = gc_frame_newslot(*var_arr);
  params[0] = strlit593;
  partcv[0] = 1;
  Object opresult595 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult595 (depth = 3)
  *var_arr = opresult595;
  if (opresult595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe597 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit599 == NULL) {
    strlit599 = alloc_String("");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 4)
  int op_slot_right_598 = gc_frame_newslot(strlit599);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_601 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit603 == NULL) {
    strlit603 = alloc_String(":");
    gc_root(strlit603);
  }
// compiled string node returning strlit603 (depth = 5)
  int op_slot_left_601 = gc_frame_newslot(strlit603);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult604 = callmethod(strlit603, "++(1)", 1, partcv, params);
// compiled op node returning opresult604 (depth = 4)
  int op_slot_left_598 = gc_frame_newslot(opresult604);
  params[0] = strlit599;
  partcv[0] = 1;
  Object opresult605 = callmethod(opresult604, "++(1)", 1, partcv, params);
// compiled op node returning opresult605 (depth = 3)
  gc_frame_newslot(opresult605);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult605;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call606 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe597);
// compiled call node returning call606 (depth = 2)
  gc_frame_end(frame);
  return call606;
}
Object meth_errormessages_607_error_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)");
  Object params[5];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for error(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe608 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile num node (depth = 3)
  Object num609 = alloc_Float64(0);
// compiled num node returning num609 (depth = 3)
  gc_frame_newslot(num609);
// starting to compile string node (depth = 3)
  if (strlit610 == NULL) {
    strlit610 = alloc_String("");
    gc_root(strlit610);
  }
// compiled string node returning strlit610 (depth = 3)
  gc_frame_newslot(strlit610);
// starting to compile string node (depth = 3)
  if (strlit611 == NULL) {
    strlit611 = alloc_String("");
    gc_root(strlit611);
  }
// compiled string node returning strlit611 (depth = 3)
  gc_frame_newslot(strlit611);
// starting to compile array node (depth = 3)
  Object array612 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array612 (depth = 3)
  gc_frame_newslot(array612);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = num609;
  params[2] = strlit610;
  params[3] = strlit611;
  params[4] = array612;
  partcv[0] = 5;
  Object call613 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe608);
// compiled call node returning call613 (depth = 2)
  gc_frame_end(frame);
  return call613;
}
Object meth_errormessages_626__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___9 = &(stackframe->slots[0]);
  *var___9 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit628 == NULL) {
    strlit628 = alloc_String("-");
    gc_root(strlit628);
  }
// compiled string node returning strlit628 (depth = 6)
  int op_slot_right_627 = gc_frame_newslot(strlit628);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_627 = gc_frame_newslot(*var_arr);
  params[0] = strlit628;
  partcv[0] = 1;
  Object opresult630 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult630 (depth = 5)
  *var_arr = opresult630;
  if (opresult630 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atLine(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atLine(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// definebindings:
// definebindings:
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit615 == NULL) {
    strlit615 = alloc_String("----");
    gc_root(strlit615);
  }
// compiled string node returning strlit615 (depth = 3)
  *var_arr = strlit615;
  if (strlit615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe616 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe618 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe619 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  Object call620 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe619);
// compiled member node returning call620 (depth = 5)
  Object call621 = callmethodflags(call620, "size", 0, partcv, params, 0);
  gc_frame_end(callframe618);
// compiled member node returning call621 (depth = 4)
  int op_slot_right_617 = gc_frame_newslot(call621);
// starting to compile num node (depth = 4)
  Object num623 = alloc_Float64(1);
// compiled num node returning num623 (depth = 4)
  int op_slot_left_617 = gc_frame_newslot(num623);
  params[0] = call621;
  partcv[0] = 1;
  Object opresult624 = callmethod(num623, "..(1)", 1, partcv, params);
// compiled op node returning opresult624 (depth = 3)
  gc_frame_newslot(opresult624);
// starting to compile block node (depth = 3)
  Object block625 = alloc_Block(NULL, NULL, "errormessages", 471);
  gc_frame_newslot(block625);
// method "_apply(_)"
  block_savedest(block625);
  Object closure626 = createclosure(2, "_apply(1)");
  setclosureframe(closure626, stackframe);
  addtoclosure(closure626, var_arr);
  addtoclosure(closure626, selfslot);
  struct UserObject *uo626 = (struct UserObject*)block625;
  uo626->data[0] = (Object)closure626;
  Method *meth_meth_errormessages_626__apply_40_1_41_ = addmethod2pos(block625, "_apply(1)", &meth_errormessages_626__apply_40_1_41_, 0);
  int argcv_meth_errormessages_626__apply_40_1_41_[] = {1};
  meth_meth_errormessages_626__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_626__apply_40_1_41_);
  meth_meth_errormessages_626__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_626__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block625 (depth = 3)
  gc_frame_newslot(block625);
// call case 5: prelude request
  params[0] = opresult624;
  params[1] = block625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call633 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe616);
// compiled call node returning call633 (depth = 2)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num636 = alloc_Float64(0);
// compiled num node returning num636 (depth = 4)
  int op_slot_right_635 = gc_frame_newslot(num636);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errlinenum (depth = 4)
  int op_slot_left_635 = gc_frame_newslot(*var_errlinenum);
  params[0] = num636;
  partcv[0] = 1;
  Object opresult638 = callmethod(*var_errlinenum, ">(1)", 1, partcv, params);
// compiled op node returning opresult638 (depth = 3)
  Object if634 = done;
  if (istrue(opresult638)) {
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe641 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe642 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errlinenum (depth = 8)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe643 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  Object call644 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe643);
// compiled member node returning call644 (depth = 8)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call645 = callmethodflags(call644, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe642);
// compiled call node returning call645 (depth = 7)
  Object call646 = callmethodflags(call645, "size", 0, partcv, params, 0);
  gc_frame_end(callframe641);
// compiled member node returning call646 (depth = 6)
  int op_slot_right_640 = gc_frame_newslot(call646);
// starting to compile string node (depth = 6)
  if (strlit648 == NULL) {
    strlit648 = alloc_String("^");
    gc_root(strlit648);
  }
// compiled string node returning strlit648 (depth = 6)
  int op_slot_left_640 = gc_frame_newslot(strlit648);
  params[0] = call646;
  partcv[0] = 1;
  Object prod649 = callmethod(strlit648, "*(1)", 1, partcv, params);
// compiled op node returning prod649 (depth = 5)
  int op_slot_right_639 = gc_frame_newslot(prod649);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arr (depth = 5)
  int op_slot_left_639 = gc_frame_newslot(*var_arr);
  params[0] = prod649;
  partcv[0] = 1;
  Object opresult651 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult651 (depth = 4)
  *var_arr = opresult651;
  if (opresult651 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if634 = done;
  } else {
  }
// compiled if node returning if634 (depth = 2)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe653 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit654 == NULL) {
    strlit654 = alloc_String("");
    gc_root(strlit654);
  }
// compiled string node returning strlit654 (depth = 3)
  gc_frame_newslot(strlit654);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit654;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call655 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe653);
// compiled call node returning call655 (depth = 2)
  gc_frame_end(frame);
  return call655;
}
Object meth_errormessages_656_error_40_1_41_atLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe657 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array658 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array658 (depth = 3)
  gc_frame_newslot(array658);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array658;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call659 = callmethodflags(module_errormessages, "error(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe657);
// compiled call node returning call659 (depth = 2)
  gc_frame_end(frame);
  return call659;
}
Object meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe661 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array662 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array662 (depth = 3)
  gc_frame_newslot(array662);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array662;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call663 = callmethodflags(module_errormessages, "syntaxError(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe661);
// compiled call node returning call663 (depth = 2)
  gc_frame_end(frame);
  return call663;
}
Object meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestion_39_ = &(stackframe->slots[2]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe665 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array666 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array666, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array666 (depth = 3)
  gc_frame_newslot(array666);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array666;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call667 = callmethodflags(module_errormessages, "syntaxError(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe665);
// compiled call node returning call667 (depth = 2)
  gc_frame_end(frame);
  return call667;
}
Object meth_errormessages_680__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___10 = &(stackframe->slots[0]);
  *var___10 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit682 == NULL) {
    strlit682 = alloc_String("-");
    gc_root(strlit682);
  }
// compiled string node returning strlit682 (depth = 6)
  int op_slot_right_681 = gc_frame_newslot(strlit682);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_681 = gc_frame_newslot(*var_arr);
  params[0] = strlit682;
  partcv[0] = 1;
  Object opresult684 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult684 (depth = 5)
  *var_arr = opresult684;
  if (opresult684 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_700__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___11 = &(stackframe->slots[0]);
  *var___11 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit702 == NULL) {
    strlit702 = alloc_String("^");
    gc_root(strlit702);
  }
// compiled string node returning strlit702 (depth = 6)
  int op_slot_right_701 = gc_frame_newslot(strlit702);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_701 = gc_frame_newslot(*var_arr);
  params[0] = strlit702;
  partcv[0] = 1;
  Object opresult704 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult704 (depth = 5)
  *var_arr = opresult704;
  if (opresult704 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit669 == NULL) {
    strlit669 = alloc_String("----");
    gc_root(strlit669);
  }
// compiled string node returning strlit669 (depth = 3)
  *var_arr = strlit669;
  if (strlit669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe670 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe672 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe673 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  Object call674 = callmethodflags(*var_errlinenum, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe673);
// compiled member node returning call674 (depth = 5)
  Object call675 = callmethodflags(call674, "size", 0, partcv, params, 0);
  gc_frame_end(callframe672);
// compiled member node returning call675 (depth = 4)
  int op_slot_right_671 = gc_frame_newslot(call675);
// starting to compile num node (depth = 4)
  Object num677 = alloc_Float64(1);
// compiled num node returning num677 (depth = 4)
  int op_slot_left_671 = gc_frame_newslot(num677);
  params[0] = call675;
  partcv[0] = 1;
  Object opresult678 = callmethod(num677, "..(1)", 1, partcv, params);
// compiled op node returning opresult678 (depth = 3)
  gc_frame_newslot(opresult678);
// starting to compile block node (depth = 3)
  Object block679 = alloc_Block(NULL, NULL, "errormessages", 494);
  gc_frame_newslot(block679);
// method "_apply(_)"
  block_savedest(block679);
  Object closure680 = createclosure(2, "_apply(1)");
  setclosureframe(closure680, stackframe);
  addtoclosure(closure680, var_arr);
  addtoclosure(closure680, selfslot);
  struct UserObject *uo680 = (struct UserObject*)block679;
  uo680->data[0] = (Object)closure680;
  Method *meth_meth_errormessages_680__apply_40_1_41_ = addmethod2pos(block679, "_apply(1)", &meth_errormessages_680__apply_40_1_41_, 0);
  int argcv_meth_errormessages_680__apply_40_1_41_[] = {1};
  meth_meth_errormessages_680__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_680__apply_40_1_41_);
  meth_meth_errormessages_680__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_680__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block679 (depth = 3)
  gc_frame_newslot(block679);
// call case 5: prelude request
  params[0] = opresult678;
  params[1] = block679;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call687 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe670);
// compiled call node returning call687 (depth = 2)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe688 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe690 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe691 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  Object call693 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe692);
// compiled member node returning call693 (depth = 6)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call694 = callmethodflags(call693, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe691);
// compiled call node returning call694 (depth = 5)
  Object call695 = callmethodflags(call694, "size", 0, partcv, params, 0);
  gc_frame_end(callframe690);
// compiled member node returning call695 (depth = 4)
  int op_slot_right_689 = gc_frame_newslot(call695);
// starting to compile num node (depth = 4)
  Object num697 = alloc_Float64(1);
// compiled num node returning num697 (depth = 4)
  int op_slot_left_689 = gc_frame_newslot(num697);
  params[0] = call695;
  partcv[0] = 1;
  Object opresult698 = callmethod(num697, "..(1)", 1, partcv, params);
// compiled op node returning opresult698 (depth = 3)
  gc_frame_newslot(opresult698);
// starting to compile block node (depth = 3)
  Object block699 = alloc_Block(NULL, NULL, "errormessages", 497);
  gc_frame_newslot(block699);
// method "_apply(_)"
  block_savedest(block699);
  Object closure700 = createclosure(2, "_apply(1)");
  setclosureframe(closure700, stackframe);
  addtoclosure(closure700, var_arr);
  addtoclosure(closure700, selfslot);
  struct UserObject *uo700 = (struct UserObject*)block699;
  uo700->data[0] = (Object)closure700;
  Method *meth_meth_errormessages_700__apply_40_1_41_ = addmethod2pos(block699, "_apply(1)", &meth_errormessages_700__apply_40_1_41_, 0);
  int argcv_meth_errormessages_700__apply_40_1_41_[] = {1};
  meth_meth_errormessages_700__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_700__apply_40_1_41_);
  meth_meth_errormessages_700__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_700__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block699 (depth = 3)
  gc_frame_newslot(block699);
// call case 5: prelude request
  params[0] = opresult698;
  params[1] = block699;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call707 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe688);
// compiled call node returning call707 (depth = 2)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe708 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit709 == NULL) {
    strlit709 = alloc_String("");
    gc_root(strlit709);
  }
// compiled string node returning strlit709 (depth = 3)
  gc_frame_newslot(strlit709);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit709;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call710 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe708);
// compiled call node returning call710 (depth = 2)
  gc_frame_end(frame);
  return call710;
}
Object meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceRange(2)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceRange(_,_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceRange(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[3]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
// definebindings:
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe719 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call720 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled call node returning call720 (depth = 4)
  *var_line = call720;
  if (call720 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num723 = alloc_Float64(1);
// compiled num node returning num723 (depth = 5)
  int op_slot_right_722 = gc_frame_newslot(num723);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_722 = gc_frame_newslot(*var_start);
  params[0] = num723;
  partcv[0] = 1;
  Object opresult725 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult725 (depth = 4)
  Object if721 = done;
  if (istrue(opresult725)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe726 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe728 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num730 = alloc_Float64(1);
// compiled num node returning num730 (depth = 8)
  int op_slot_right_729 = gc_frame_newslot(num730);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_729 = gc_frame_newslot(*var_end);
  params[0] = num730;
  partcv[0] = 1;
  Object sum732 = callmethod(*var_end, "+(1)", 1, partcv, params);
// compiled op node returning sum732 (depth = 7)
  gc_frame_newslot(sum732);
// starting to compile member node (depth = 7)
  int callframe733 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  Object call734 = callmethodflags(*var_line, "size", 0, partcv, params, 0);
  gc_frame_end(callframe733);
// compiled member node returning call734 (depth = 7)
  gc_frame_newslot(call734);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum732;
  params[1] = call734;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call735 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe728);
// compiled call node returning call735 (depth = 6)
  int op_slot_right_727 = gc_frame_newslot(call735);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_727 = gc_frame_newslot(*var_s);
  params[0] = call735;
  partcv[0] = 1;
  Object opresult737 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult737 (depth = 5)
  gc_frame_newslot(opresult737);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult737;
  partcv[0] = 2;
  Object call738 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe726);
// compiled call node returning call738 (depth = 4)
    gc_frame_newslot(call738);
    if721 = call738;
  } else {
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe739 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe741 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num743 = alloc_Float64(1);
// compiled num node returning num743 (depth = 8)
  int op_slot_right_742 = gc_frame_newslot(num743);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_742 = gc_frame_newslot(*var_end);
  params[0] = num743;
  partcv[0] = 1;
  Object sum745 = callmethod(*var_end, "+(1)", 1, partcv, params);
// compiled op node returning sum745 (depth = 7)
  gc_frame_newslot(sum745);
// starting to compile member node (depth = 7)
  int callframe746 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  Object call747 = callmethodflags(*var_line, "size", 0, partcv, params, 0);
  gc_frame_end(callframe746);
// compiled member node returning call747 (depth = 7)
  gc_frame_newslot(call747);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum745;
  params[1] = call747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call748 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe741);
// compiled call node returning call748 (depth = 6)
  int op_slot_right_740 = gc_frame_newslot(call748);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_750 = gc_frame_newslot(*var_s);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe752 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num753 = alloc_Float64(1);
// compiled num node returning num753 (depth = 8)
  gc_frame_newslot(num753);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num755 = alloc_Float64(1);
// compiled num node returning num755 (depth = 9)
  int op_slot_right_754 = gc_frame_newslot(num755);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_start (depth = 9)
  int op_slot_left_754 = gc_frame_newslot(*var_start);
  params[0] = num755;
  partcv[0] = 1;
  Object diff757 = callmethod(*var_start, "-(1)", 1, partcv, params);
// compiled op node returning diff757 (depth = 8)
  gc_frame_newslot(diff757);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num753;
  params[1] = diff757;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call758 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe752);
// compiled call node returning call758 (depth = 7)
  int op_slot_left_750 = gc_frame_newslot(call758);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult759 = callmethod(call758, "++(1)", 1, partcv, params);
// compiled op node returning opresult759 (depth = 6)
  int op_slot_left_740 = gc_frame_newslot(opresult759);
  params[0] = call748;
  partcv[0] = 1;
  Object opresult760 = callmethod(opresult759, "++(1)", 1, partcv, params);
// compiled op node returning opresult760 (depth = 5)
  gc_frame_newslot(opresult760);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult760;
  partcv[0] = 2;
  Object call761 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe739);
// compiled call node returning call761 (depth = 4)
    gc_frame_newslot(call761);
    if721 = call761;
  }
// compiled if node returning if721 (depth = 3)
  gc_frame_end(frame);
  return if721;
}
Object meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceChar(1)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceChar(_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceChar(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe763 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call764 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe763);
// compiled call node returning call764 (depth = 3)
  gc_frame_end(frame);
  return call764;
}
Object meth_errormessages_778__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[4];
  int partcv[3];
  Object *var_until = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_line = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_until (depth = 7)
  int op_slot_right_780 = gc_frame_newslot(*var_until);
// starting to compile call node (depth = 7)
  int callframe782 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num784 = alloc_Float64(1);
// compiled num node returning num784 (depth = 9)
  int op_slot_right_783 = gc_frame_newslot(num784);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_len (depth = 10)
  int op_slot_right_786 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_786 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum788 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum788 (depth = 9)
  int op_slot_left_783 = gc_frame_newslot(sum788);
  params[0] = num784;
  partcv[0] = 1;
  Object diff789 = callmethod(sum788, "-(1)", 1, partcv, params);
// compiled op node returning diff789 (depth = 8)
  gc_frame_newslot(diff789);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = *var_i;
  params[1] = diff789;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call790 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe782);
// compiled call node returning call790 (depth = 7)
  int op_slot_left_780 = gc_frame_newslot(call790);
  params[0] = *var_until;
  partcv[0] = 1;
  Object opresult791 = callmethod(call790, "==(1)", 1, partcv, params);
// compiled op node returning opresult791 (depth = 6)
  Object if779 = done;
  if (istrue(opresult791)) {
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe792 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num793 = alloc_Float64(1);
// compiled num node returning num793 (depth = 7)
  gc_frame_newslot(num793);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num795 = alloc_Float64(1);
// compiled num node returning num795 (depth = 8)
  int op_slot_right_794 = gc_frame_newslot(num795);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_len (depth = 9)
  int op_slot_right_797 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_797 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum799 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum799 (depth = 8)
  int op_slot_left_794 = gc_frame_newslot(sum799);
  params[0] = num795;
  partcv[0] = 1;
  Object diff800 = callmethod(sum799, "-(1)", 1, partcv, params);
// compiled op node returning diff800 (depth = 7)
  gc_frame_newslot(diff800);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = num793;
  params[1] = diff800;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call801 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe792);
// compiled call node returning call801 (depth = 6)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool802 = alloc_Boolean(1);
// compiled identifier node returning bool802 (depth = 7)
  block_return(realself, bool802);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if779 = undefined;
  } else {
  }
// compiled if node returning if779 (depth = 5)
  gc_frame_end(frame);
  return if779;
}
Object meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceUntil(1)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceUntil(_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_until = &(stackframe->slots[0]);
  *var_until = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceUntil(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe766 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call767 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe766);
// compiled call node returning call767 (depth = 4)
  *var_line = call767;
  if (call767 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe768 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_until (depth = 5)
  Object call769 = callmethodflags(*var_until, "size", 0, partcv, params, 0);
  gc_frame_end(callframe768);
// compiled member node returning call769 (depth = 4)
  *var_len = call769;
  if (call769 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe770 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe772 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  Object call773 = callmethodflags(*var_line, "size", 0, partcv, params, 0);
  gc_frame_end(callframe772);
// compiled member node returning call773 (depth = 5)
  int op_slot_right_771 = gc_frame_newslot(call773);
// starting to compile num node (depth = 5)
  Object num775 = alloc_Float64(1);
// compiled num node returning num775 (depth = 5)
  int op_slot_left_771 = gc_frame_newslot(num775);
  params[0] = call773;
  partcv[0] = 1;
  Object opresult776 = callmethod(num775, "..(1)", 1, partcv, params);
// compiled op node returning opresult776 (depth = 4)
  gc_frame_newslot(opresult776);
// starting to compile block node (depth = 4)
  Object block777 = alloc_Block(NULL, NULL, "errormessages", 40);
  gc_frame_newslot(block777);
// method "_apply(_)"
  block_savedest(block777);
  Object closure778 = createclosure(6, "_apply(1)");
  setclosureframe(closure778, stackframe);
  addtoclosure(closure778, var_until);
  addtoclosure(closure778, var_len);
  addtoclosure(closure778, var_line);
  addtoclosure(closure778, var_s);
  addtoclosure(closure778, var_lineNumber);
  addtoclosure(closure778, selfslot);
  struct UserObject *uo778 = (struct UserObject*)block777;
  uo778->data[0] = (Object)closure778;
  Method *meth_meth_errormessages_778__apply_40_1_41_ = addmethod2pos(block777, "_apply(1)", &meth_errormessages_778__apply_40_1_41_, 0);
  int argcv_meth_errormessages_778__apply_40_1_41_[] = {1};
  meth_meth_errormessages_778__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_778__apply_40_1_41_);
  meth_meth_errormessages_778__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_778__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block777 (depth = 4)
  gc_frame_newslot(block777);
// call case 5: prelude request
  params[0] = opresult776;
  params[1] = block777;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call804 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe770);
// compiled call node returning call804 (depth = 3)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool805 = alloc_Boolean(0);
// compiled identifier node returning bool805 (depth = 4)
  return bool805;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_833__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_indent = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit836 == NULL) {
    strlit836 = alloc_String(" ");
    gc_root(strlit836);
  }
// compiled string node returning strlit836 (depth = 8)
  int op_slot_right_835 = gc_frame_newslot(strlit836);
// starting to compile call node (depth = 8)
  int callframe838 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call839 = callmethodflags(*var_line, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe838);
// compiled call node returning call839 (depth = 8)
  int op_slot_left_835 = gc_frame_newslot(call839);
  params[0] = strlit836;
  partcv[0] = 1;
  Object opresult840 = callmethod(call839, "≠(1)", 1, partcv, params);
// compiled op node returning opresult840 (depth = 7)
  Object if834 = done;
  if (istrue(opresult840)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool841 = alloc_Boolean(0);
// compiled identifier node returning bool841 (depth = 8)
  *var_indent = bool841;
  if (bool841 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if834 = done;
  } else {
  }
// compiled if node returning if834 (depth = 6)
  gc_frame_end(frame);
  return if834;
}
Object meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteRange(2)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange(_,_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange(_,_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteRange(_,_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteRange(_,_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start'");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
  Object *var_indent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "indent");
// definebindings:
// definebindings:
// definebindings:
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  *var_start_39_ = *var_start;
  if (*var_start == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe807 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call808 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe807);
// compiled call node returning call808 (depth = 4)
  *var_line = call808;
  if (call808 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe812 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  Object call813 = callmethodflags(*var_line, "size", 0, partcv, params, 0);
  gc_frame_end(callframe812);
// compiled member node returning call813 (depth = 6)
  int op_slot_right_811 = gc_frame_newslot(call813);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  int op_slot_left_811 = gc_frame_newslot(*var_end);
  params[0] = call813;
  partcv[0] = 1;
  Object opresult815 = callmethod(*var_end, "==(1)", 1, partcv, params);
// compiled op node returning opresult815 (depth = 5)
  int op_slot_right_810 = gc_frame_newslot(opresult815);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num818 = alloc_Float64(1);
// compiled num node returning num818 (depth = 6)
  int op_slot_right_817 = gc_frame_newslot(num818);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start_39_ (depth = 6)
  int op_slot_left_817 = gc_frame_newslot(*var_start_39_);
  params[0] = num818;
  partcv[0] = 1;
  Object opresult820 = callmethod(*var_start_39_, ">(1)", 1, partcv, params);
// compiled op node returning opresult820 (depth = 5)
  int op_slot_left_810 = gc_frame_newslot(opresult820);
  params[0] = opresult815;
  partcv[0] = 1;
  Object opresult821 = callmethod(opresult820, "&&(1)", 1, partcv, params);
// compiled op node returning opresult821 (depth = 4)
  Object if809 = done;
  if (istrue(opresult821)) {
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool822 = alloc_Boolean(1);
// compiled identifier node returning bool822 (depth = 5)
  *var_indent = bool822;
  if (bool822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe823 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num826 = alloc_Float64(1);
// compiled num node returning num826 (depth = 7)
  int op_slot_right_825 = gc_frame_newslot(num826);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start_39_ (depth = 7)
  int op_slot_left_825 = gc_frame_newslot(*var_start_39_);
  params[0] = num826;
  partcv[0] = 1;
  Object diff828 = callmethod(*var_start_39_, "-(1)", 1, partcv, params);
// compiled op node returning diff828 (depth = 6)
  int op_slot_right_824 = gc_frame_newslot(diff828);
// starting to compile num node (depth = 6)
  Object num830 = alloc_Float64(1);
// compiled num node returning num830 (depth = 6)
  int op_slot_left_824 = gc_frame_newslot(num830);
  params[0] = diff828;
  partcv[0] = 1;
  Object opresult831 = callmethod(num830, "..(1)", 1, partcv, params);
// compiled op node returning opresult831 (depth = 5)
  gc_frame_newslot(opresult831);
// starting to compile block node (depth = 5)
  Object block832 = alloc_Block(NULL, NULL, "errormessages", 55);
  gc_frame_newslot(block832);
// method "_apply(_)"
  block_savedest(block832);
  Object closure833 = createclosure(3, "_apply(1)");
  setclosureframe(closure833, stackframe);
  addtoclosure(closure833, var_line);
  addtoclosure(closure833, var_indent);
  addtoclosure(closure833, selfslot);
  struct UserObject *uo833 = (struct UserObject*)block832;
  uo833->data[0] = (Object)closure833;
  Method *meth_meth_errormessages_833__apply_40_1_41_ = addmethod2pos(block832, "_apply(1)", &meth_errormessages_833__apply_40_1_41_, 0);
  int argcv_meth_errormessages_833__apply_40_1_41_[] = {1};
  meth_meth_errormessages_833__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_833__apply_40_1_41_);
  meth_meth_errormessages_833__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_833__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block832 (depth = 5)
  gc_frame_newslot(block832);
// call case 5: prelude request
  params[0] = opresult831;
  params[1] = block832;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call844 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled call node returning call844 (depth = 4)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool847 = alloc_Boolean(1);
// compiled identifier node returning bool847 (depth = 6)
  int op_slot_right_846 = gc_frame_newslot(bool847);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indent (depth = 6)
  int op_slot_left_846 = gc_frame_newslot(*var_indent);
  params[0] = bool847;
  partcv[0] = 1;
  Object opresult849 = callmethod(*var_indent, "==(1)", 1, partcv, params);
// compiled op node returning opresult849 (depth = 5)
  Object if845 = done;
  if (istrue(opresult849)) {
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num850 = alloc_Float64(1);
// compiled num node returning num850 (depth = 6)
  *var_start_39_ = num850;
  if (num850 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if845 = done;
  } else {
  }
// compiled if node returning if845 (depth = 4)
    gc_frame_newslot(if845);
    if809 = if845;
  } else {
  }
// compiled if node returning if809 (depth = 3)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start_39_ (depth = 4)
  gc_frame_newslot(*var_start_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile string node (depth = 4)
  if (strlit853 == NULL) {
    strlit853 = alloc_String("");
    gc_root(strlit853);
  }
// compiled string node returning strlit853 (depth = 4)
  gc_frame_newslot(strlit853);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_start_39_;
  params[1] = *var_end;
  params[2] = strlit853;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call854 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe852);
// compiled call node returning call854 (depth = 3)
  gc_frame_end(frame);
  return call854;
}
Object meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteChar(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar(_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteChar(_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteChar(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe856 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile string node (depth = 4)
  if (strlit857 == NULL) {
    strlit857 = alloc_String("");
    gc_root(strlit857);
  }
// compiled string node returning strlit857 (depth = 4)
  gc_frame_newslot(strlit857);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = strlit857;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call858 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe856);
// compiled call node returning call858 (depth = 3)
  gc_frame_end(frame);
  return call858;
}
Object meth_errormessages_859_append_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "append(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append(_)onLine(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for append(_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part append(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "line");
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe860 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call861 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 4)
  *var_line = call861;
  if (call861 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe862 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_right_863 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  int op_slot_left_863 = gc_frame_newslot(*var_line);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult865 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult865 (depth = 4)
  gc_frame_newslot(opresult865);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult865;
  partcv[0] = 2;
  Object call866 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe862);
// compiled call node returning call866 (depth = 3)
  gc_frame_end(frame);
  return call866;
}
Object meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)atPosition(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)atPosition(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_pos = &(stackframe->slots[1]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// definebindings:
// definebindings:
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe868 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call869 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled call node returning call869 (depth = 4)
  *var_line = call869;
  if (call869 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num872 = alloc_Float64(1);
// compiled num node returning num872 (depth = 5)
  int op_slot_right_871 = gc_frame_newslot(num872);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pos (depth = 5)
  int op_slot_left_871 = gc_frame_newslot(*var_pos);
  params[0] = num872;
  partcv[0] = 1;
  Object opresult874 = callmethod(*var_pos, "==(1)", 1, partcv, params);
// compiled op node returning opresult874 (depth = 4)
  Object if870 = done;
  if (istrue(opresult874)) {
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe875 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_876 = gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_876 = gc_frame_newslot(*var_s);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult878 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult878 (depth = 5)
  gc_frame_newslot(opresult878);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult878;
  partcv[0] = 2;
  Object call879 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe875);
// compiled call node returning call879 (depth = 4)
    gc_frame_newslot(call879);
    if870 = call879;
  } else {
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe880 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe882 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_pos (depth = 7)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 7)
  int callframe883 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  Object call884 = callmethodflags(*var_line, "size", 0, partcv, params, 0);
  gc_frame_end(callframe883);
// compiled member node returning call884 (depth = 7)
  gc_frame_newslot(call884);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = *var_pos;
  params[1] = call884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call885 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe882);
// compiled call node returning call885 (depth = 6)
  int op_slot_right_881 = gc_frame_newslot(call885);
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_887 = gc_frame_newslot(*var_s);
// starting to compile call node (depth = 7)
  int callframe889 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num890 = alloc_Float64(1);
// compiled num node returning num890 (depth = 8)
  gc_frame_newslot(num890);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num892 = alloc_Float64(1);
// compiled num node returning num892 (depth = 9)
  int op_slot_right_891 = gc_frame_newslot(num892);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_pos (depth = 9)
  int op_slot_left_891 = gc_frame_newslot(*var_pos);
  params[0] = num892;
  partcv[0] = 1;
  Object diff894 = callmethod(*var_pos, "-(1)", 1, partcv, params);
// compiled op node returning diff894 (depth = 8)
  gc_frame_newslot(diff894);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num890;
  params[1] = diff894;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call895 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe889);
// compiled call node returning call895 (depth = 7)
  int op_slot_left_887 = gc_frame_newslot(call895);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult896 = callmethod(call895, "++(1)", 1, partcv, params);
// compiled op node returning opresult896 (depth = 6)
  int op_slot_left_881 = gc_frame_newslot(opresult896);
  params[0] = call885;
  partcv[0] = 1;
  Object opresult897 = callmethod(opresult896, "++(1)", 1, partcv, params);
// compiled op node returning opresult897 (depth = 5)
  gc_frame_newslot(opresult897);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult897;
  partcv[0] = 2;
  Object call898 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe880);
// compiled call node returning call898 (depth = 4)
    gc_frame_newslot(call898);
    if870 = call898;
  }
// compiled if node returning if870 (depth = 3)
  gc_frame_end(frame);
  return if870;
}
Object meth_errormessages_910__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe912 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call913 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe912);
// compiled member node returning call913 (depth = 8)
  int op_slot_right_911 = gc_frame_newslot(call913);
// starting to compile member node (depth = 8)
  int callframe915 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  Object call917 = callmethodflags(*var_token, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe916);
// compiled member node returning call917 (depth = 9)
  Object call918 = callmethodflags(call917, "line", 0, partcv, params, 0);
  gc_frame_end(callframe915);
// compiled member node returning call918 (depth = 8)
  int op_slot_left_911 = gc_frame_newslot(call918);
  params[0] = call913;
  partcv[0] = 1;
  Object opresult919 = callmethod(call918, "==(1)", 1, partcv, params);
// compiled op node returning opresult919 (depth = 7)
  gc_frame_end(frame);
  return opresult919;
}
Object meth_errormessages_956__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call959 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe958);
// compiled member node returning call959 (depth = 8)
  int op_slot_right_957 = gc_frame_newslot(call959);
// starting to compile member node (depth = 8)
  int callframe961 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe962 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  Object call963 = callmethodflags(*var_token, "next", 0, partcv, params, 0);
  gc_frame_end(callframe962);
// compiled member node returning call963 (depth = 9)
  Object call964 = callmethodflags(call963, "line", 0, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled member node returning call964 (depth = 8)
  int op_slot_left_957 = gc_frame_newslot(call964);
  params[0] = call959;
  partcv[0] = 1;
  Object opresult965 = callmethod(call964, "≠(1)", 1, partcv, params);
// compiled op node returning opresult965 (depth = 7)
  gc_frame_end(frame);
  return opresult965;
}
Object meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenStart(1)includeLeadingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart(_)includeLeadingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart(_)includeLeadingSpace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenStart(_)includeLeadingSpace(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getTokenStart(_)");
  Object *var_includeLeading = &(stackframe->slots[1]);
  *var_includeLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includeLeadingSpace(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call901 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe900);
// compiled member node returning call901 (depth = 4)
  *var_start = call901;
  if (call901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool904 = alloc_Boolean(1);
// compiled identifier node returning bool904 (depth = 5)
  int op_slot_right_903 = gc_frame_newslot(bool904);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeLeading (depth = 5)
  int op_slot_left_903 = gc_frame_newslot(*var_includeLeading);
  params[0] = bool904;
  partcv[0] = 1;
  Object opresult906 = callmethod(*var_includeLeading, "==(1)", 1, partcv, params);
// compiled op node returning opresult906 (depth = 4)
  Object if902 = done;
  if (istrue(opresult906)) {
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block909 = alloc_Block(NULL, NULL, "errormessages", 94);
  gc_frame_newslot(block909);
// method "_apply"
  block_savedest(block909);
  Object closure910 = createclosure(2, "_apply");
  setclosureframe(closure910, stackframe);
  addtoclosure(closure910, var_token);
  addtoclosure(closure910, selfslot);
  struct UserObject *uo910 = (struct UserObject*)block909;
  uo910->data[0] = (Object)closure910;
  Method *meth_meth_errormessages_910__apply = addmethod2pos(block909, "_apply", &meth_errormessages_910__apply, 0);
  int argcv_meth_errormessages_910__apply[] = {0};
  meth_meth_errormessages_910__apply->type = alloc_MethodType(1, argcv_meth_errormessages_910__apply);
  meth_meth_errormessages_910__apply->definitionModule = modulename;
  meth_meth_errormessages_910__apply->definitionLine = 500;
// compiled block node returning block909 (depth = 6)
  int op_slot_right_908 = gc_frame_newslot(block909);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool923 = alloc_Boolean(0);
// compiled identifier node returning bool923 (depth = 7)
  int op_slot_right_922 = gc_frame_newslot(bool923);
// starting to compile member node (depth = 7)
  int callframe925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  Object call926 = callmethodflags(*var_token, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe925);
// compiled member node returning call926 (depth = 7)
  int op_slot_left_922 = gc_frame_newslot(call926);
  params[0] = bool923;
  partcv[0] = 1;
  Object opresult927 = callmethod(call926, "≠(1)", 1, partcv, params);
// compiled op node returning opresult927 (depth = 6)
  int op_slot_left_908 = gc_frame_newslot(opresult927);
  params[0] = block909;
  partcv[0] = 1;
  Object opresult928 = callmethod(opresult927, "&&(1)", 1, partcv, params);
// compiled op node returning opresult928 (depth = 5)
  Object if907 = done;
  if (istrue(opresult928)) {
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe930 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call932 = callmethodflags(*var_token, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe931);
// compiled member node returning call932 (depth = 8)
  Object call933 = callmethodflags(call932, "size", 0, partcv, params, 0);
  gc_frame_end(callframe930);
// compiled member node returning call933 (depth = 7)
  int op_slot_right_929 = gc_frame_newslot(call933);
// starting to compile member node (depth = 7)
  int callframe935 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call937 = callmethodflags(*var_token, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe936);
// compiled member node returning call937 (depth = 8)
  Object call938 = callmethodflags(call937, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe935);
// compiled member node returning call938 (depth = 7)
  int op_slot_left_929 = gc_frame_newslot(call938);
  params[0] = call933;
  partcv[0] = 1;
  Object sum939 = callmethod(call938, "+(1)", 1, partcv, params);
// compiled op node returning sum939 (depth = 6)
  *var_start = sum939;
  if (sum939 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if907 = done;
  } else {
  }
// compiled if node returning if907 (depth = 4)
    gc_frame_newslot(if907);
    if902 = if907;
  } else {
  }
// compiled if node returning if902 (depth = 3)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num944 = alloc_Float64(1);
// compiled num node returning num944 (depth = 6)
  int op_slot_right_943 = gc_frame_newslot(num944);
// starting to compile member node (depth = 6)
  int callframe946 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call947 = callmethodflags(*var_token, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe946);
// compiled member node returning call947 (depth = 6)
  int op_slot_left_943 = gc_frame_newslot(call947);
  params[0] = num944;
  partcv[0] = 1;
  Object sum948 = callmethod(call947, "+(1)", 1, partcv, params);
// compiled op node returning sum948 (depth = 5)
  int op_slot_right_942 = gc_frame_newslot(sum948);
// starting to compile member node (depth = 5)
  int callframe950 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  Object call951 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe950);
// compiled member node returning call951 (depth = 5)
  int op_slot_left_942 = gc_frame_newslot(call951);
  params[0] = sum948;
  partcv[0] = 1;
  Object opresult952 = callmethod(call951, "==(1)", 1, partcv, params);
// compiled op node returning opresult952 (depth = 4)
  Object if941 = done;
  if (istrue(opresult952)) {
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block955 = alloc_Block(NULL, NULL, "errormessages", 100);
  gc_frame_newslot(block955);
// method "_apply"
  block_savedest(block955);
  Object closure956 = createclosure(2, "_apply");
  setclosureframe(closure956, stackframe);
  addtoclosure(closure956, var_token);
  addtoclosure(closure956, selfslot);
  struct UserObject *uo956 = (struct UserObject*)block955;
  uo956->data[0] = (Object)closure956;
  Method *meth_meth_errormessages_956__apply = addmethod2pos(block955, "_apply", &meth_errormessages_956__apply, 0);
  int argcv_meth_errormessages_956__apply[] = {0};
  meth_meth_errormessages_956__apply->type = alloc_MethodType(1, argcv_meth_errormessages_956__apply);
  meth_meth_errormessages_956__apply->definitionModule = modulename;
  meth_meth_errormessages_956__apply->definitionLine = 500;
// compiled block node returning block955 (depth = 6)
  int op_slot_right_954 = gc_frame_newslot(block955);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool969 = alloc_Boolean(0);
// compiled identifier node returning bool969 (depth = 7)
  int op_slot_right_968 = gc_frame_newslot(bool969);
// starting to compile member node (depth = 7)
  int callframe971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  Object call972 = callmethodflags(*var_token, "next", 0, partcv, params, 0);
  gc_frame_end(callframe971);
// compiled member node returning call972 (depth = 7)
  int op_slot_left_968 = gc_frame_newslot(call972);
  params[0] = bool969;
  partcv[0] = 1;
  Object opresult973 = callmethod(call972, "==(1)", 1, partcv, params);
// compiled op node returning opresult973 (depth = 6)
  int op_slot_left_954 = gc_frame_newslot(opresult973);
  params[0] = block955;
  partcv[0] = 1;
  Object opresult974 = callmethod(opresult973, "||(1)", 1, partcv, params);
// compiled op node returning opresult974 (depth = 5)
  Object if953 = done;
  if (istrue(opresult974)) {
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num975 = alloc_Float64(1);
// compiled num node returning num975 (depth = 6)
  *var_start = num975;
  if (num975 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if953 = done;
  } else {
  }
// compiled if node returning if953 (depth = 4)
    gc_frame_newslot(if953);
    if941 = if953;
  } else {
  }
// compiled if node returning if941 (depth = 3)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_start (depth = 3)
  gc_frame_end(frame);
  return *var_start;
}
Object meth_errormessages_997__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe999 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call1000 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe999);
// compiled member node returning call1000 (depth = 8)
  int op_slot_right_998 = gc_frame_newslot(call1000);
// starting to compile member node (depth = 8)
  int callframe1002 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1003 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  Object call1004 = callmethodflags(*var_token, "next", 0, partcv, params, 0);
  gc_frame_end(callframe1003);
// compiled member node returning call1004 (depth = 9)
  Object call1005 = callmethodflags(call1004, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1002);
// compiled member node returning call1005 (depth = 8)
  int op_slot_left_998 = gc_frame_newslot(call1005);
  params[0] = call1000;
  partcv[0] = 1;
  Object opresult1006 = callmethod(call1005, "==(1)", 1, partcv, params);
// compiled op node returning opresult1006 (depth = 7)
  gc_frame_end(frame);
  return opresult1006;
}
Object meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenEnd(1)includeTrailingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd(_)includeTrailingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd(_)includeTrailingSpace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenEnd(_)includeTrailingSpace(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getTokenEnd(_)");
  Object *var_includeTrailing = &(stackframe->slots[1]);
  *var_includeTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includeTrailingSpace(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_end = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "end");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num979 = alloc_Float64(1);
// compiled num node returning num979 (depth = 5)
  int op_slot_right_978 = gc_frame_newslot(num979);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe982 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call983 = callmethodflags(*var_token, "size", 0, partcv, params, 0);
  gc_frame_end(callframe982);
// compiled member node returning call983 (depth = 6)
  int op_slot_right_981 = gc_frame_newslot(call983);
// starting to compile member node (depth = 6)
  int callframe985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call986 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe985);
// compiled member node returning call986 (depth = 6)
  int op_slot_left_981 = gc_frame_newslot(call986);
  params[0] = call983;
  partcv[0] = 1;
  Object sum987 = callmethod(call986, "+(1)", 1, partcv, params);
// compiled op node returning sum987 (depth = 5)
  int op_slot_left_978 = gc_frame_newslot(sum987);
  params[0] = num979;
  partcv[0] = 1;
  Object diff988 = callmethod(sum987, "-(1)", 1, partcv, params);
// compiled op node returning diff988 (depth = 4)
  *var_end = diff988;
  if (diff988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool991 = alloc_Boolean(1);
// compiled identifier node returning bool991 (depth = 5)
  int op_slot_right_990 = gc_frame_newslot(bool991);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeTrailing (depth = 5)
  int op_slot_left_990 = gc_frame_newslot(*var_includeTrailing);
  params[0] = bool991;
  partcv[0] = 1;
  Object opresult993 = callmethod(*var_includeTrailing, "==(1)", 1, partcv, params);
// compiled op node returning opresult993 (depth = 4)
  Object if989 = done;
  if (istrue(opresult993)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block996 = alloc_Block(NULL, NULL, "errormessages", 111);
  gc_frame_newslot(block996);
// method "_apply"
  block_savedest(block996);
  Object closure997 = createclosure(2, "_apply");
  setclosureframe(closure997, stackframe);
  addtoclosure(closure997, var_token);
  addtoclosure(closure997, selfslot);
  struct UserObject *uo997 = (struct UserObject*)block996;
  uo997->data[0] = (Object)closure997;
  Method *meth_meth_errormessages_997__apply = addmethod2pos(block996, "_apply", &meth_errormessages_997__apply, 0);
  int argcv_meth_errormessages_997__apply[] = {0};
  meth_meth_errormessages_997__apply->type = alloc_MethodType(1, argcv_meth_errormessages_997__apply);
  meth_meth_errormessages_997__apply->definitionModule = modulename;
  meth_meth_errormessages_997__apply->definitionLine = 500;
// compiled block node returning block996 (depth = 6)
  int op_slot_right_995 = gc_frame_newslot(block996);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1010 = alloc_Boolean(0);
// compiled identifier node returning bool1010 (depth = 7)
  int op_slot_right_1009 = gc_frame_newslot(bool1010);
// starting to compile member node (depth = 7)
  int callframe1012 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  Object call1013 = callmethodflags(*var_token, "next", 0, partcv, params, 0);
  gc_frame_end(callframe1012);
// compiled member node returning call1013 (depth = 7)
  int op_slot_left_1009 = gc_frame_newslot(call1013);
  params[0] = bool1010;
  partcv[0] = 1;
  Object opresult1014 = callmethod(call1013, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1014 (depth = 6)
  int op_slot_left_995 = gc_frame_newslot(opresult1014);
  params[0] = block996;
  partcv[0] = 1;
  Object opresult1015 = callmethod(opresult1014, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1015 (depth = 5)
  Object if994 = done;
  if (istrue(opresult1015)) {
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1017 = alloc_Float64(1);
// compiled num node returning num1017 (depth = 7)
  int op_slot_right_1016 = gc_frame_newslot(num1017);
// starting to compile member node (depth = 7)
  int callframe1019 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call1021 = callmethodflags(*var_token, "next", 0, partcv, params, 0);
  gc_frame_end(callframe1020);
// compiled member node returning call1021 (depth = 8)
  Object call1022 = callmethodflags(call1021, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1019);
// compiled member node returning call1022 (depth = 7)
  int op_slot_left_1016 = gc_frame_newslot(call1022);
  params[0] = num1017;
  partcv[0] = 1;
  Object diff1023 = callmethod(call1022, "-(1)", 1, partcv, params);
// compiled op node returning diff1023 (depth = 6)
  *var_end = diff1023;
  if (diff1023 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if994 = done;
  } else {
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1025 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1026 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  Object call1028 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1027);
// compiled member node returning call1028 (depth = 8)
  gc_frame_newslot(call1028);
// call case 4: self request
  params[0] = call1028;
  partcv[0] = 1;
  Object call1029 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1026);
// compiled call node returning call1029 (depth = 7)
  Object call1030 = callmethodflags(call1029, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1025);
// compiled member node returning call1030 (depth = 6)
  *var_end = call1030;
  if (call1030 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if994 = done;
  }
// compiled if node returning if994 (depth = 4)
    gc_frame_newslot(if994);
    if989 = if994;
  } else {
  }
// compiled if node returning if989 (depth = 3)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_end (depth = 3)
  gc_frame_end(frame);
  return *var_end;
}
Object meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken(1)leading(1)trailing(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken(_)leading(_)trailing(_)with(_) (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceToken(_)");
  Object *var_replaceLeading = &(stackframe->slots[1]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_replaceTrailing = &(stackframe->slots[2]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "start");
  Object *var_end = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "end");
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1033 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1034 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compiled call node returning call1034 (depth = 4)
  *var_start = call1034;
  if (call1034 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1035 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1036 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1035);
// compiled call node returning call1036 (depth = 4)
  *var_end = call1036;
  if (call1036 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1037 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
  int callframe1038 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call1039 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1038);
// compiled member node returning call1039 (depth = 4)
  gc_frame_newslot(call1039);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_s;
  params[3] = call1039;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1040 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1037);
// compiled call node returning call1040 (depth = 3)
  gc_frame_end(frame);
  return call1040;
}
Object meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)with(_)");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken(_)with(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceToken(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1042 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1043 = alloc_Boolean(0);
// compiled identifier node returning bool1043 (depth = 4)
  gc_frame_newslot(bool1043);
// starting to compile identifier node (depth = 4)
  Object bool1044 = alloc_Boolean(0);
// compiled identifier node returning bool1044 (depth = 4)
  gc_frame_newslot(bool1044);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool1043;
  params[2] = bool1044;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1045 = callmethodflags(self, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1042);
// compiled call node returning call1045 (depth = 3)
  gc_frame_end(frame);
  return call1045;
}
Object meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange(2)leading(1)trailing(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange(_,_)leading(_)trailing(_)with(_) (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceTokenRange(_,_)");
  Object *var_replaceLeading = &(stackframe->slots[2]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_replaceTrailing = &(stackframe->slots[3]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_insertPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "insertPos");
  Object *var_indent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "indent");
// definebindings:
// definebindings:
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_1048 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_1048 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1050 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult1050 (depth = 4)
  Object if1047 = done;
  if (istrue(opresult1050)) {
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1051 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  params[2] = *var_replaceTrailing;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1052 = callmethodflags(self, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1051);
// compiled call node returning call1052 (depth = 4)
    gc_frame_newslot(call1052);
    if1047 = call1052;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1053 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_replaceLeading (depth = 6)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1054 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1053);
// compiled call node returning call1054 (depth = 5)
  *var_insertPos = call1054;
  if (call1054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1055 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num1056 = alloc_Float64(1);
// compiled num node returning num1056 (depth = 6)
  gc_frame_newslot(num1056);
// starting to compile member node (depth = 6)
  int callframe1057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  Object call1058 = callmethodflags(*var_start, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe1057);
// compiled member node returning call1058 (depth = 6)
  gc_frame_newslot(call1058);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe1059 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1060 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  Object call1061 = callmethodflags(*var_start, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1060);
// compiled member node returning call1061 (depth = 7)
  gc_frame_newslot(call1061);
// call case 4: self request
  params[0] = call1061;
  partcv[0] = 1;
  Object call1062 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1059);
// compiled call node returning call1062 (depth = 6)
  params[0] = num1056;
  params[1] = call1058;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1063 = callmethodflags(call1062, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1055);
// compiled call node returning call1063 (depth = 5)
  *var_indent = call1063;
  if (call1063 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1064 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_replaceLeading;
  params[3] = *var_replaceTrailing;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1065 = callmethodflags(self, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1064);
// compiled call node returning call1065 (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1068 == NULL) {
    strlit1068 = alloc_String("");
    gc_root(strlit1068);
  }
// compiled string node returning strlit1068 (depth = 6)
  int op_slot_right_1067 = gc_frame_newslot(strlit1068);
// starting to compile call node (depth = 6)
  int callframe1070 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  Object call1072 = callmethodflags(*var_start, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1071);
// compiled member node returning call1072 (depth = 7)
  gc_frame_newslot(call1072);
// call case 4: self request
  params[0] = call1072;
  partcv[0] = 1;
  Object call1073 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1070);
// compiled call node returning call1073 (depth = 6)
  int op_slot_left_1067 = gc_frame_newslot(call1073);
  params[0] = strlit1068;
  partcv[0] = 1;
  Object opresult1074 = callmethod(call1073, "==(1)", 1, partcv, params);
// compiled op node returning opresult1074 (depth = 5)
  Object if1066 = done;
  if (istrue(opresult1074)) {
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1075 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_1076 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indent (depth = 7)
  int op_slot_left_1076 = gc_frame_newslot(*var_indent);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1078 = callmethod(*var_indent, "++(1)", 1, partcv, params);
// compiled op node returning opresult1078 (depth = 6)
  gc_frame_newslot(opresult1078);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
  int callframe1079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  Object call1080 = callmethodflags(*var_start, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1079);
// compiled member node returning call1080 (depth = 6)
  gc_frame_newslot(call1080);
// call case 4: self request
  params[0] = opresult1078;
  params[1] = *var_insertPos;
  params[2] = call1080;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1081 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1075);
// compiled call node returning call1081 (depth = 5)
    gc_frame_newslot(call1081);
    if1066 = call1081;
  } else {
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1082 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
  int callframe1083 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  Object call1084 = callmethodflags(*var_start, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1083);
// compiled member node returning call1084 (depth = 6)
  gc_frame_newslot(call1084);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_insertPos;
  params[2] = call1084;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1085 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1082);
// compiled call node returning call1085 (depth = 5)
    gc_frame_newslot(call1085);
    if1066 = call1085;
  }
// compiled if node returning if1066 (depth = 4)
    gc_frame_newslot(if1066);
    if1047 = if1066;
  }
// compiled if node returning if1047 (depth = 3)
  gc_frame_end(frame);
  return if1047;
}
Object meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange(2)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)with(_)");
  Object params[5];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange(_,_)with(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceTokenRange(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1087 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool1088 = alloc_Boolean(0);
// compiled identifier node returning bool1088 (depth = 4)
  gc_frame_newslot(bool1088);
// starting to compile identifier node (depth = 4)
  Object bool1089 = alloc_Boolean(0);
// compiled identifier node returning bool1089 (depth = 4)
  gc_frame_newslot(bool1089);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool1088;
  params[3] = bool1089;
  params[4] = *var_s;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1090 = callmethodflags(self, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compiled call node returning call1090 (depth = 3)
  gc_frame_end(frame);
  return call1090;
}
Object meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken(1)leading(1)trailing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken(_)leading(_)trailing(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteToken(_)");
  Object *var_deleteLeading = &(stackframe->slots[1]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_deleteTrailing = &(stackframe->slots[2]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start");
  Object *var_end = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "end");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1092 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1093 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1092);
// compiled call node returning call1093 (depth = 4)
  *var_start = call1093;
  if (call1093 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1094 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1095 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1094);
// compiled call node returning call1095 (depth = 4)
  *var_end = call1095;
  if (call1095 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1096 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile member node (depth = 4)
  int callframe1097 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call1098 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1097);
// compiled member node returning call1098 (depth = 4)
  gc_frame_newslot(call1098);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = call1098;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1099 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled call node returning call1099 (depth = 3)
  gc_frame_end(frame);
  return call1099;
}
Object meth_errormessages_1100_deleteToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1102 = alloc_Boolean(0);
// compiled identifier node returning bool1102 (depth = 4)
  gc_frame_newslot(bool1102);
// starting to compile identifier node (depth = 4)
  Object bool1103 = alloc_Boolean(0);
// compiled identifier node returning bool1103 (depth = 4)
  gc_frame_newslot(bool1103);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool1102;
  params[2] = bool1103;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1104 = callmethodflags(self, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1101);
// compiled call node returning call1104 (depth = 3)
  gc_frame_end(frame);
  return call1104;
}
Object meth_errormessages_1122__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  int op_slot_right_1123 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  int op_slot_left_1123 = gc_frame_newslot(*var_tok);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1125 = callmethod(*var_tok, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1125 (depth = 6)
  gc_frame_end(frame);
  return opresult1125;
}
Object meth_errormessages_1128__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_startPos = getfromclosure(closure, 2);
  Object *var_endPos = getfromclosure(closure, 3);
  Object *var_deleteLeading = getfromclosure(closure, 4);
  Object *var_deleteTrailing = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  int op_slot_right_1130 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 8)
  int callframe1132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call1133 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1132);
// compiled member node returning call1133 (depth = 8)
  int op_slot_left_1130 = gc_frame_newslot(call1133);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult1134 = callmethod(call1133, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1134 (depth = 7)
  Object if1129 = done;
  if (istrue(opresult1134)) {
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1135 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startPos (depth = 8)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endPos (depth = 8)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1136 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1135);
// compiled call node returning call1136 (depth = 7)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1137 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call1138 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1137);
// compiled member node returning call1138 (depth = 8)
  *var_line = call1138;
  if (call1138 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1140 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_deleteLeading (depth = 9)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1141 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1140);
// compiled call node returning call1141 (depth = 8)
  *var_startPos = call1141;
  if (call1141 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1129 = done;
  } else {
  }
// compiled if node returning if1129 (depth = 6)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1143 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_deleteTrailing (depth = 8)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1144 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled call node returning call1144 (depth = 7)
  *var_endPos = call1144;
  if (call1144 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  Object call1147 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe1146);
// compiled member node returning call1147 (depth = 7)
  *var_tok = call1147;
  if (call1147 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange(2)leading(1)trailing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange(_,_)leading(_)trailing(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteTokenRange(_,_)");
  Object *var_deleteLeading = &(stackframe->slots[2]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_deleteTrailing = &(stackframe->slots[3]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_startPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "startPos");
  Object *var_endPos = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "endPos");
  Object *var_tok = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tok");
// definebindings:
// definebindings:
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_1107 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_1107 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1109 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult1109 (depth = 4)
  Object if1106 = done;
  if (istrue(opresult1109)) {
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1110 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  params[2] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1111 = callmethodflags(self, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1110);
// compiled call node returning call1111 (depth = 4)
    gc_frame_newslot(call1111);
    if1106 = call1111;
  } else {
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  Object call1113 = callmethodflags(*var_start, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1112);
// compiled member node returning call1113 (depth = 5)
  *var_line = call1113;
  if (call1113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1114 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteLeading (depth = 6)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1115 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1114);
// compiled call node returning call1115 (depth = 5)
  *var_startPos = call1115;
  if (call1115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1116 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1117 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 5)
  *var_endPos = call1117;
  if (call1117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1118 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  Object call1119 = callmethodflags(*var_start, "next", 0, partcv, params, 0);
  gc_frame_end(callframe1118);
// compiled member node returning call1119 (depth = 5)
  *var_tok = call1119;
  if (call1119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1120 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1121 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block1121);
// method "_apply"
  block_savedest(block1121);
  Object closure1122 = createclosure(3, "_apply");
  setclosureframe(closure1122, stackframe);
  addtoclosure(closure1122, var_end);
  addtoclosure(closure1122, var_tok);
  addtoclosure(closure1122, selfslot);
  struct UserObject *uo1122 = (struct UserObject*)block1121;
  uo1122->data[0] = (Object)closure1122;
  Method *meth_meth_errormessages_1122__apply = addmethod2pos(block1121, "_apply", &meth_errormessages_1122__apply, 0);
  int argcv_meth_errormessages_1122__apply[] = {0};
  meth_meth_errormessages_1122__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1122__apply);
  meth_meth_errormessages_1122__apply->definitionModule = modulename;
  meth_meth_errormessages_1122__apply->definitionLine = 500;
// compiled block node returning block1121 (depth = 5)
  gc_frame_newslot(block1121);
// starting to compile block node (depth = 5)
  Object block1127 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block1127);
// method "_apply"
  block_savedest(block1127);
  Object closure1128 = createclosure(7, "_apply");
  setclosureframe(closure1128, stackframe);
  addtoclosure(closure1128, var_line);
  addtoclosure(closure1128, var_tok);
  addtoclosure(closure1128, var_startPos);
  addtoclosure(closure1128, var_endPos);
  addtoclosure(closure1128, var_deleteLeading);
  addtoclosure(closure1128, var_deleteTrailing);
  addtoclosure(closure1128, selfslot);
  struct UserObject *uo1128 = (struct UserObject*)block1127;
  uo1128->data[0] = (Object)closure1128;
  Method *meth_meth_errormessages_1128__apply = addmethod2pos(block1127, "_apply", &meth_errormessages_1128__apply, 0);
  int argcv_meth_errormessages_1128__apply[] = {0};
  meth_meth_errormessages_1128__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1128__apply);
  meth_meth_errormessages_1128__apply->definitionModule = modulename;
  meth_meth_errormessages_1128__apply->definitionLine = 500;
// compiled block node returning block1127 (depth = 5)
  gc_frame_newslot(block1127);
// call case 5: prelude request
  params[0] = block1121;
  params[1] = block1127;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1150 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1120);
// compiled call node returning call1150 (depth = 4)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_1152 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 6)
  int callframe1154 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  Object call1155 = callmethodflags(*var_end, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1154);
// compiled member node returning call1155 (depth = 6)
  int op_slot_left_1152 = gc_frame_newslot(call1155);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult1156 = callmethod(call1155, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1156 (depth = 5)
  Object if1151 = done;
  if (istrue(opresult1156)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1157 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPos (depth = 6)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endPos (depth = 6)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1158 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 5)
    gc_frame_newslot(call1158);
    if1151 = call1158;
  } else {
  }
// compiled if node returning if1151 (depth = 4)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1159 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_end;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1160 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled call node returning call1160 (depth = 5)
  *var_endPos = call1160;
  if (call1160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1162 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startPos (depth = 5)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endPos (depth = 5)
  gc_frame_newslot(*var_endPos);
// starting to compile member node (depth = 5)
  int callframe1163 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  Object call1164 = callmethodflags(*var_end, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1163);
// compiled member node returning call1164 (depth = 5)
  gc_frame_newslot(call1164);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = call1164;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1165 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1162);
// compiled call node returning call1165 (depth = 4)
    gc_frame_newslot(call1165);
    if1106 = call1165;
  }
// compiled if node returning if1106 (depth = 3)
  gc_frame_end(frame);
  return if1106;
}
Object meth_errormessages_1166_deleteTokenRange_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteTokenRange(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool1168 = alloc_Boolean(0);
// compiled identifier node returning bool1168 (depth = 4)
  gc_frame_newslot(bool1168);
// starting to compile identifier node (depth = 4)
  Object bool1169 = alloc_Boolean(0);
// compiled identifier node returning bool1169 (depth = 4)
  gc_frame_newslot(bool1169);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool1168;
  params[3] = bool1169;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1170 = callmethodflags(self, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1167);
// compiled call node returning call1170 (depth = 3)
  gc_frame_end(frame);
  return call1170;
}
Object meth_errormessages_1171_deleteLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteLine(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1172 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 4)
  if (strlit1173 == NULL) {
    strlit1173 = alloc_String("");
    gc_root(strlit1173);
  }
// compiled string node returning strlit1173 (depth = 4)
  gc_frame_newslot(strlit1173);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = strlit1173;
  partcv[0] = 2;
  Object call1174 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1172);
// compiled call node returning call1174 (depth = 3)
  gc_frame_end(frame);
  return call1174;
}
Object meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)afterToken(1)andTrailingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)afterToken(_)andTrailingSpace(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part afterToken(_)");
  Object *var_afterTrailing = &(stackframe->slots[2]);
  *var_afterTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part andTrailingSpace(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_pos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "pos");
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 5)
  int op_slot_right_1176 = gc_frame_newslot(num1177);
// starting to compile call node (depth = 5)
  int callframe1179 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_afterTrailing (depth = 6)
  gc_frame_newslot(*var_afterTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_afterTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1180 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1179);
// compiled call node returning call1180 (depth = 5)
  int op_slot_left_1176 = gc_frame_newslot(call1180);
  params[0] = num1177;
  partcv[0] = 1;
  Object sum1181 = callmethod(call1180, "+(1)", 1, partcv, params);
// compiled op node returning sum1181 (depth = 4)
  *var_pos = sum1181;
  if (sum1181 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1182 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 4)
  int callframe1183 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call1184 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1183);
// compiled member node returning call1184 (depth = 4)
  gc_frame_newslot(call1184);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_pos;
  params[2] = call1184;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1185 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled call node returning call1185 (depth = 3)
  gc_frame_end(frame);
  return call1185;
}
Object meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)afterToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)afterToken(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part afterToken(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1187 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1188 = alloc_Boolean(0);
// compiled identifier node returning bool1188 (depth = 4)
  gc_frame_newslot(bool1188);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_token;
  params[2] = bool1188;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1189 = callmethodflags(self, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1187);
// compiled call node returning call1189 (depth = 3)
  gc_frame_end(frame);
  return call1189;
}
Object meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)beforeToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)beforeToken(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)beforeToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)beforeToken(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part beforeToken(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1191 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
  int callframe1192 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call1193 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1192);
// compiled member node returning call1193 (depth = 4)
  gc_frame_newslot(call1193);
// starting to compile member node (depth = 4)
  int callframe1194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  Object call1195 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1194);
// compiled member node returning call1195 (depth = 4)
  gc_frame_newslot(call1195);
// call case 4: self request
  params[0] = *var_s;
  params[1] = call1193;
  params[2] = call1195;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1196 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compiled call node returning call1196 (depth = 3)
  gc_frame_end(frame);
  return call1196;
}
Object meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insertNewLine(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine(_)after(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insertNewLine(_)after(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_line = &(stackframe->slots[0]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insertNewLine(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1198 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call1199 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1198);
// compiled call node returning call1199 (depth = 3)
  gc_frame_end(frame);
  return call1199;
}
Object meth_errormessages_1239__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1241 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1243 = alloc_Float64(1);
// compiled num node returning num1243 (depth = 12)
  int op_slot_right_1242 = gc_frame_newslot(num1243);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1242 = gc_frame_newslot(*var_i);
  params[0] = num1243;
  partcv[0] = 1;
  Object diff1245 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1245 (depth = 11)
  gc_frame_newslot(diff1245);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1246 = gc_frame_new();
// call case 4: self request
  Object call1247 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled member node returning call1247 (depth = 11)
  params[0] = diff1245;
  partcv[0] = 1;
  Object call1248 = callmethodflags(call1247, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1241);
// compiled call node returning call1248 (depth = 10)
  int op_slot_right_1240 = gc_frame_newslot(call1248);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  int op_slot_left_1240 = gc_frame_newslot(*var_lineNumber);
  params[0] = call1248;
  partcv[0] = 1;
  Object opresult1250 = callmethod(*var_lineNumber, "<(1)", 1, partcv, params);
// compiled op node returning opresult1250 (depth = 9)
  gc_frame_end(frame);
  return opresult1250;
}
Object meth_errormessages_1236__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1238 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1238);
// method "_apply"
  block_savedest(block1238);
  Object closure1239 = createclosure(3, "_apply");
  setclosureframe(closure1239, stackframe);
  addtoclosure(closure1239, var_i);
  addtoclosure(closure1239, var_lineNumber);
  addtoclosure(closure1239, selfslot);
  struct UserObject *uo1239 = (struct UserObject*)block1238;
  uo1239->data[0] = (Object)closure1239;
  Method *meth_meth_errormessages_1239__apply = addmethod2pos(block1238, "_apply", &meth_errormessages_1239__apply, 0);
  int argcv_meth_errormessages_1239__apply[] = {0};
  meth_meth_errormessages_1239__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1239__apply);
  meth_meth_errormessages_1239__apply->definitionModule = modulename;
  meth_meth_errormessages_1239__apply->definitionLine = 500;
// compiled block node returning block1238 (depth = 8)
  int op_slot_right_1237 = gc_frame_newslot(block1238);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1254 = alloc_Float64(1);
// compiled num node returning num1254 (depth = 9)
  int op_slot_right_1253 = gc_frame_newslot(num1254);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1253 = gc_frame_newslot(*var_i);
  params[0] = num1254;
  partcv[0] = 1;
  Object opresult1256 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult1256 (depth = 8)
  int op_slot_left_1237 = gc_frame_newslot(opresult1256);
  params[0] = block1238;
  partcv[0] = 1;
  Object opresult1257 = callmethod(opresult1256, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1257 (depth = 7)
  gc_frame_end(frame);
  return opresult1257;
}
Object meth_errormessages_1260__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1261 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1262 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1264 = alloc_Float64(1);
// compiled num node returning num1264 (depth = 10)
  int op_slot_right_1263 = gc_frame_newslot(num1264);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1263 = gc_frame_newslot(*var_i);
  params[0] = num1264;
  partcv[0] = 1;
  Object diff1266 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1266 (depth = 9)
  gc_frame_newslot(diff1266);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1267 = gc_frame_new();
// call case 4: self request
  Object call1268 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1267);
// compiled member node returning call1268 (depth = 9)
  params[0] = diff1266;
  partcv[0] = 1;
  Object call1269 = callmethodflags(call1268, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1262);
// compiled call node returning call1269 (depth = 8)
  gc_frame_newslot(call1269);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1270 = gc_frame_new();
// call case 4: self request
  Object call1271 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1270);
// compiled member node returning call1271 (depth = 8)
  params[0] = *var_i;
  params[1] = call1269;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1272 = callmethodflags(call1271, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1261);
// compiled call node returning call1272 (depth = 7)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1273 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1274 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1276 = alloc_Float64(1);
// compiled num node returning num1276 (depth = 10)
  int op_slot_right_1275 = gc_frame_newslot(num1276);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1275 = gc_frame_newslot(*var_i);
  params[0] = num1276;
  partcv[0] = 1;
  Object diff1278 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1278 (depth = 9)
  gc_frame_newslot(diff1278);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1279 = gc_frame_new();
// call case 4: self request
  Object call1280 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1279);
// compiled member node returning call1280 (depth = 9)
  params[0] = diff1278;
  partcv[0] = 1;
  Object call1281 = callmethodflags(call1280, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1274);
// compiled call node returning call1281 (depth = 8)
  gc_frame_newslot(call1281);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1282 = gc_frame_new();
// call case 4: self request
  Object call1283 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1282);
// compiled member node returning call1283 (depth = 8)
  params[0] = *var_i;
  params[1] = call1281;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1284 = callmethodflags(call1283, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1273);
// compiled call node returning call1284 (depth = 7)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1286 = alloc_Float64(1);
// compiled num node returning num1286 (depth = 9)
  int op_slot_right_1285 = gc_frame_newslot(num1286);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1285 = gc_frame_newslot(*var_i);
  params[0] = num1286;
  partcv[0] = 1;
  Object diff1288 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1288 (depth = 8)
  *var_i = diff1288;
  if (diff1288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1200_addLine_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLine(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method addLine(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLine(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  Object *var_line = &(stackframe->slots[1]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part addLine(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1201 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1202 = callmethodflags(self, "findLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1201);
// compiled call node returning call1202 (depth = 4)
  *var_i = call1202;
  if (call1202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1205 = alloc_Boolean(0);
// compiled identifier node returning bool1205 (depth = 5)
  int op_slot_right_1204 = gc_frame_newslot(bool1205);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1204 = gc_frame_newslot(*var_i);
  params[0] = bool1205;
  partcv[0] = 1;
  Object opresult1207 = callmethod(*var_i, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1207 (depth = 4)
  Object if1203 = done;
  if (istrue(opresult1207)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1208 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1209 = gc_frame_new();
// call case 4: self request
  Object call1210 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1209);
// compiled member node returning call1210 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1211 = callmethodflags(call1210, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1208);
// compiled call node returning call1211 (depth = 4)
    gc_frame_newslot(call1211);
    if1203 = call1211;
  } else {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1213 = gc_frame_new();
// call case 4: self request
  Object call1214 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1213);
// compiled member node returning call1214 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1215 = callmethodflags(call1214, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1212);
// compiled call node returning call1215 (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1216 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1217 = gc_frame_new();
// call case 4: self request
  Object call1218 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1217);
// compiled member node returning call1218 (depth = 5)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1219 = callmethodflags(call1218, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled call node returning call1219 (depth = 4)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1222 = alloc_Float64(1);
// compiled num node returning num1222 (depth = 6)
  int op_slot_right_1221 = gc_frame_newslot(num1222);
// starting to compile member node (depth = 6)
  int callframe1224 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1225 = gc_frame_new();
// call case 4: self request
  Object call1226 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1225);
// compiled member node returning call1226 (depth = 7)
  Object call1227 = callmethodflags(call1226, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1224);
// compiled member node returning call1227 (depth = 6)
  int op_slot_left_1221 = gc_frame_newslot(call1227);
  params[0] = num1222;
  partcv[0] = 1;
  Object opresult1228 = callmethod(call1227, ">(1)", 1, partcv, params);
// compiled op node returning opresult1228 (depth = 5)
  Object if1220 = done;
  if (istrue(opresult1228)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1229 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1230 = gc_frame_new();
// call case 4: self request
  Object call1231 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1230);
// compiled member node returning call1231 (depth = 7)
  Object call1232 = callmethodflags(call1231, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1229);
// compiled member node returning call1232 (depth = 6)
  *var_i = call1232;
  if (call1232 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1234 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1235 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1235);
// method "_apply"
  block_savedest(block1235);
  Object closure1236 = createclosure(3, "_apply");
  setclosureframe(closure1236, stackframe);
  addtoclosure(closure1236, var_i);
  addtoclosure(closure1236, var_lineNumber);
  addtoclosure(closure1236, selfslot);
  struct UserObject *uo1236 = (struct UserObject*)block1235;
  uo1236->data[0] = (Object)closure1236;
  Method *meth_meth_errormessages_1236__apply = addmethod2pos(block1235, "_apply", &meth_errormessages_1236__apply, 0);
  int argcv_meth_errormessages_1236__apply[] = {0};
  meth_meth_errormessages_1236__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1236__apply);
  meth_meth_errormessages_1236__apply->definitionModule = modulename;
  meth_meth_errormessages_1236__apply->definitionLine = 500;
// compiled block node returning block1235 (depth = 6)
  gc_frame_newslot(block1235);
// starting to compile block node (depth = 6)
  Object block1259 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1259);
// method "_apply"
  block_savedest(block1259);
  Object closure1260 = createclosure(2, "_apply");
  setclosureframe(closure1260, stackframe);
  addtoclosure(closure1260, var_i);
  addtoclosure(closure1260, selfslot);
  struct UserObject *uo1260 = (struct UserObject*)block1259;
  uo1260->data[0] = (Object)closure1260;
  Method *meth_meth_errormessages_1260__apply = addmethod2pos(block1259, "_apply", &meth_errormessages_1260__apply, 0);
  int argcv_meth_errormessages_1260__apply[] = {0};
  meth_meth_errormessages_1260__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1260__apply);
  meth_meth_errormessages_1260__apply->definitionModule = modulename;
  meth_meth_errormessages_1260__apply->definitionLine = 500;
// compiled block node returning block1259 (depth = 6)
  gc_frame_newslot(block1259);
// call case 5: prelude request
  params[0] = block1235;
  params[1] = block1259;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1291 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1234);
// compiled call node returning call1291 (depth = 5)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1292 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1293 = gc_frame_new();
// call case 4: self request
  Object call1294 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1293);
// compiled member node returning call1294 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1295 = callmethodflags(call1294, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1292);
// compiled call node returning call1295 (depth = 5)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1296 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1297 = gc_frame_new();
// call case 4: self request
  Object call1298 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1297);
// compiled member node returning call1298 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1299 = callmethodflags(call1298, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1296);
// compiled call node returning call1299 (depth = 5)
    gc_frame_newslot(call1299);
    if1220 = call1299;
  } else {
  }
// compiled if node returning if1220 (depth = 4)
    gc_frame_newslot(if1220);
    if1203 = if1220;
  }
// compiled if node returning if1203 (depth = 3)
  gc_frame_end(frame);
  return if1203;
}
Object meth_errormessages_1307__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  int op_slot_right_1309 = gc_frame_newslot(*var_lineNumber);
// starting to compile call node (depth = 7)
  int callframe1311 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1312 = gc_frame_new();
// call case 4: self request
  Object call1313 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1312);
// compiled member node returning call1313 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1314 = callmethodflags(call1313, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1311);
// compiled call node returning call1314 (depth = 7)
  int op_slot_left_1309 = gc_frame_newslot(call1314);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult1315 = callmethod(call1314, "==(1)", 1, partcv, params);
// compiled op node returning opresult1315 (depth = 6)
  Object if1308 = done;
  if (istrue(opresult1315)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  block_return(realself, *var_i);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if1308 = undefined;
  } else {
  }
// compiled if node returning if1308 (depth = 5)
  gc_frame_end(frame);
  return if1308;
}
Object meth_errormessages_1300_findLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1301 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1302 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1303 = gc_frame_new();
// call case 4: self request
  Object call1304 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compiled member node returning call1304 (depth = 5)
  Object call1305 = callmethodflags(call1304, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe1302);
// compiled member node returning call1305 (depth = 4)
  gc_frame_newslot(call1305);
// starting to compile block node (depth = 4)
  Object block1306 = alloc_Block(NULL, NULL, "errormessages", 241);
  gc_frame_newslot(block1306);
// method "_apply(_)"
  block_savedest(block1306);
  Object closure1307 = createclosure(2, "_apply(1)");
  setclosureframe(closure1307, stackframe);
  addtoclosure(closure1307, var_lineNumber);
  addtoclosure(closure1307, selfslot);
  struct UserObject *uo1307 = (struct UserObject*)block1306;
  uo1307->data[0] = (Object)closure1307;
  Method *meth_meth_errormessages_1307__apply_40_1_41_ = addmethod2pos(block1306, "_apply(1)", &meth_errormessages_1307__apply_40_1_41_, 0);
  int argcv_meth_errormessages_1307__apply_40_1_41_[] = {1};
  meth_meth_errormessages_1307__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1307__apply_40_1_41_);
  meth_meth_errormessages_1307__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1307__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block1306 (depth = 4)
  gc_frame_newslot(block1306);
// call case 5: prelude request
  params[0] = call1305;
  params[1] = block1306;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1317 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1301);
// compiled call node returning call1317 (depth = 3)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1318 = alloc_Boolean(0);
// compiled identifier node returning bool1318 (depth = 3)
  gc_frame_end(frame);
  return bool1318;
}
Object meth_errormessages_1319_getLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "getLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getLine(_)");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for getLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// definebindings:
// definebindings:
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1320 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1321 = callmethodflags(self, "findLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1320);
// compiled call node returning call1321 (depth = 4)
  *var_i = call1321;
  if (call1321 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1324 = alloc_Boolean(0);
// compiled identifier node returning bool1324 (depth = 5)
  int op_slot_right_1323 = gc_frame_newslot(bool1324);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1323 = gc_frame_newslot(*var_i);
  params[0] = bool1324;
  partcv[0] = 1;
  Object opresult1326 = callmethod(*var_i, "==(1)", 1, partcv, params);
// compiled op node returning opresult1326 (depth = 4)
  Object if1322 = done;
  if (istrue(opresult1326)) {
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1327 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  Object call1329 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe1328);
// compiled member node returning call1329 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1330 = callmethodflags(call1329, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1327);
// compiled call node returning call1330 (depth = 4)
    gc_frame_newslot(call1330);
    if1322 = call1330;
  } else {
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1331 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1332 = gc_frame_new();
// call case 4: self request
  Object call1333 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1332);
// compiled member node returning call1333 (depth = 5)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1334 = callmethodflags(call1333, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1331);
// compiled call node returning call1334 (depth = 4)
    gc_frame_newslot(call1334);
    if1322 = call1334;
  }
// compiled if node returning if1322 (depth = 3)
  gc_frame_end(frame);
  return if1322;
}
Object meth_errormessages_1350__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1353 = alloc_Float64(1);
// compiled num node returning num1353 (depth = 10)
  int op_slot_right_1352 = gc_frame_newslot(num1353);
// starting to compile call node (depth = 10)
  int callframe1355 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1357 = alloc_Float64(1);
// compiled num node returning num1357 (depth = 12)
  int op_slot_right_1356 = gc_frame_newslot(num1357);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1356 = gc_frame_newslot(*var_i);
  params[0] = num1357;
  partcv[0] = 1;
  Object diff1359 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1359 (depth = 11)
  gc_frame_newslot(diff1359);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1360 = gc_frame_new();
// call case 4: self request
  Object call1361 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1360);
// compiled member node returning call1361 (depth = 11)
  params[0] = diff1359;
  partcv[0] = 1;
  Object call1362 = callmethodflags(call1361, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1355);
// compiled call node returning call1362 (depth = 10)
  int op_slot_left_1352 = gc_frame_newslot(call1362);
  params[0] = num1353;
  partcv[0] = 1;
  Object sum1363 = callmethod(call1362, "+(1)", 1, partcv, params);
// compiled op node returning sum1363 (depth = 9)
  int op_slot_right_1351 = gc_frame_newslot(sum1363);
// starting to compile call node (depth = 9)
  int callframe1365 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1366 = gc_frame_new();
// call case 4: self request
  Object call1367 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1366);
// compiled member node returning call1367 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1368 = callmethodflags(call1367, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1365);
// compiled call node returning call1368 (depth = 9)
  int op_slot_left_1351 = gc_frame_newslot(call1368);
  params[0] = sum1363;
  partcv[0] = 1;
  Object opresult1369 = callmethod(call1368, ">(1)", 1, partcv, params);
// compiled op node returning opresult1369 (depth = 8)
  gc_frame_end(frame);
  return opresult1369;
}
Object meth_errormessages_1392__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1394 == NULL) {
    strlit1394 = alloc_String(" ");
    gc_root(strlit1394);
  }
// compiled string node returning strlit1394 (depth = 10)
  int op_slot_right_1393 = gc_frame_newslot(strlit1394);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1393 = gc_frame_newslot(*var_s);
  params[0] = strlit1394;
  partcv[0] = 1;
  Object opresult1396 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1396 (depth = 9)
  *var_s = opresult1396;
  if (opresult1396 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1346__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// definebindings:
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block1349 = alloc_Block(NULL, NULL, "errormessages", 262);
  gc_frame_newslot(block1349);
// method "_apply"
  block_savedest(block1349);
  Object closure1350 = createclosure(2, "_apply");
  setclosureframe(closure1350, stackframe);
  addtoclosure(closure1350, var_i);
  addtoclosure(closure1350, selfslot);
  struct UserObject *uo1350 = (struct UserObject*)block1349;
  uo1350->data[0] = (Object)closure1350;
  Method *meth_meth_errormessages_1350__apply = addmethod2pos(block1349, "_apply", &meth_errormessages_1350__apply, 0);
  int argcv_meth_errormessages_1350__apply[] = {0};
  meth_meth_errormessages_1350__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1350__apply);
  meth_meth_errormessages_1350__apply->definitionModule = modulename;
  meth_meth_errormessages_1350__apply->definitionLine = 500;
// compiled block node returning block1349 (depth = 7)
  int op_slot_right_1348 = gc_frame_newslot(block1349);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1373 = alloc_Float64(1);
// compiled num node returning num1373 (depth = 8)
  int op_slot_right_1372 = gc_frame_newslot(num1373);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1372 = gc_frame_newslot(*var_i);
  params[0] = num1373;
  partcv[0] = 1;
  Object opresult1375 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult1375 (depth = 7)
  int op_slot_left_1348 = gc_frame_newslot(opresult1375);
  params[0] = block1349;
  partcv[0] = 1;
  Object opresult1376 = callmethod(opresult1375, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 6)
  Object if1347 = done;
  if (istrue(opresult1376)) {
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1377 == NULL) {
    strlit1377 = alloc_String("");
    gc_root(strlit1377);
  }
// compiled string node returning strlit1377 (depth = 7)
  *var_s = strlit1377;
  if (strlit1377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1378 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1379 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1380 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe1381 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1383 = alloc_Float64(1);
// compiled num node returning num1383 (depth = 11)
  int op_slot_right_1382 = gc_frame_newslot(num1383);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_1382 = gc_frame_newslot(*var_i);
  params[0] = num1383;
  partcv[0] = 1;
  Object diff1385 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1385 (depth = 10)
  gc_frame_newslot(diff1385);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1386 = gc_frame_new();
// call case 4: self request
  Object call1387 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1386);
// compiled member node returning call1387 (depth = 10)
  params[0] = diff1385;
  partcv[0] = 1;
  Object call1388 = callmethodflags(call1387, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1381);
// compiled call node returning call1388 (depth = 9)
  Object call1389 = callmethodflags(call1388, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe1380);
// compiled member node returning call1389 (depth = 8)
  Object call1390 = callmethodflags(call1389, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1379);
// compiled member node returning call1390 (depth = 7)
  gc_frame_newslot(call1390);
// starting to compile block node (depth = 7)
  Object block1391 = alloc_Block(NULL, NULL, "errormessages", 264);
  gc_frame_newslot(block1391);
// method "_apply"
  block_savedest(block1391);
  Object closure1392 = createclosure(2, "_apply");
  setclosureframe(closure1392, stackframe);
  addtoclosure(closure1392, var_s);
  addtoclosure(closure1392, selfslot);
  struct UserObject *uo1392 = (struct UserObject*)block1391;
  uo1392->data[0] = (Object)closure1392;
  Method *meth_meth_errormessages_1392__apply = addmethod2pos(block1391, "_apply", &meth_errormessages_1392__apply, 0);
  int argcv_meth_errormessages_1392__apply[] = {0};
  meth_meth_errormessages_1392__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1392__apply);
  meth_meth_errormessages_1392__apply->definitionModule = modulename;
  meth_meth_errormessages_1392__apply->definitionLine = 500;
// compiled block node returning block1391 (depth = 7)
  gc_frame_newslot(block1391);
// call case 5: prelude request
  params[0] = call1390;
  params[1] = block1391;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1399 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1378);
// compiled call node returning call1399 (depth = 6)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1400 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("...""\x0a""");
    gc_root(strlit1402);
  }
// compiled string node returning strlit1402 (depth = 8)
  int op_slot_right_1401 = gc_frame_newslot(strlit1402);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_1404 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit1406 == NULL) {
    strlit1406 = alloc_String("    ");
    gc_root(strlit1406);
  }
// compiled string node returning strlit1406 (depth = 9)
  int op_slot_left_1404 = gc_frame_newslot(strlit1406);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1407 = callmethod(strlit1406, "++(1)", 1, partcv, params);
// compiled op node returning opresult1407 (depth = 8)
  int op_slot_left_1401 = gc_frame_newslot(opresult1407);
  params[0] = strlit1402;
  partcv[0] = 1;
  Object opresult1408 = callmethod(opresult1407, "++(1)", 1, partcv, params);
// compiled op node returning opresult1408 (depth = 7)
  gc_frame_newslot(opresult1408);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  Object call1410 = callmethodflags(*var_io, "error", 0, partcv, params, 0);
  gc_frame_end(callframe1409);
// compiled member node returning call1410 (depth = 7)
  params[0] = opresult1408;
  partcv[0] = 1;
  Object call1411 = callmethodflags(call1410, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1400);
// compiled call node returning call1411 (depth = 6)
    gc_frame_newslot(call1411);
    if1347 = call1411;
  } else {
  }
// compiled if node returning if1347 (depth = 5)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1414 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1415 = gc_frame_new();
// call case 4: self request
  Object call1416 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1415);
// compiled member node returning call1416 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1417 = callmethodflags(call1416, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1414);
// compiled call node returning call1417 (depth = 7)
  int op_slot_right_1413 = gc_frame_newslot(call1417);
// starting to compile member node (depth = 7)
  int callframe1419 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe1420 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1421 = gc_frame_new();
// call case 4: self request
  Object call1422 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1421);
// compiled member node returning call1422 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1423 = callmethodflags(call1422, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1420);
// compiled call node returning call1423 (depth = 8)
  Object call1424 = callmethodflags(call1423, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe1419);
// compiled member node returning call1424 (depth = 7)
  int op_slot_left_1413 = gc_frame_newslot(call1424);
  params[0] = call1417;
  partcv[0] = 1;
  Object opresult1425 = callmethod(call1424, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1425 (depth = 6)
  Object if1412 = done;
  if (istrue(opresult1425)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1426 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1428 == NULL) {
    strlit1428 = alloc_String("""\x0a""");
    gc_root(strlit1428);
  }
// compiled string node returning strlit1428 (depth = 8)
  int op_slot_right_1427 = gc_frame_newslot(strlit1428);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1431 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1432 = gc_frame_new();
// call case 4: self request
  Object call1433 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1432);
// compiled member node returning call1433 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1434 = callmethodflags(call1433, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1431);
// compiled call node returning call1434 (depth = 9)
  int op_slot_right_1430 = gc_frame_newslot(call1434);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1437 == NULL) {
    strlit1437 = alloc_String(": ");
    gc_root(strlit1437);
  }
// compiled string node returning strlit1437 (depth = 10)
  int op_slot_right_1436 = gc_frame_newslot(strlit1437);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe1440 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 12)
  int callframe1441 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe1442 = gc_frame_new();
// call case 4: self request
  Object call1443 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1442);
// compiled member node returning call1443 (depth = 13)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1444 = callmethodflags(call1443, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1441);
// compiled call node returning call1444 (depth = 12)
  Object call1445 = callmethodflags(call1444, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe1440);
// compiled member node returning call1445 (depth = 11)
  int op_slot_right_1439 = gc_frame_newslot(call1445);
// starting to compile string node (depth = 11)
  if (strlit1447 == NULL) {
    strlit1447 = alloc_String(" *");
    gc_root(strlit1447);
  }
// compiled string node returning strlit1447 (depth = 11)
  int op_slot_left_1439 = gc_frame_newslot(strlit1447);
  params[0] = call1445;
  partcv[0] = 1;
  Object opresult1448 = callmethod(strlit1447, "++(1)", 1, partcv, params);
// compiled op node returning opresult1448 (depth = 10)
  int op_slot_left_1436 = gc_frame_newslot(opresult1448);
  params[0] = strlit1437;
  partcv[0] = 1;
  Object opresult1449 = callmethod(opresult1448, "++(1)", 1, partcv, params);
// compiled op node returning opresult1449 (depth = 9)
  int op_slot_left_1430 = gc_frame_newslot(opresult1449);
  params[0] = call1434;
  partcv[0] = 1;
  Object opresult1450 = callmethod(opresult1449, "++(1)", 1, partcv, params);
// compiled op node returning opresult1450 (depth = 8)
  int op_slot_left_1427 = gc_frame_newslot(opresult1450);
  params[0] = strlit1428;
  partcv[0] = 1;
  Object opresult1451 = callmethod(opresult1450, "++(1)", 1, partcv, params);
// compiled op node returning opresult1451 (depth = 7)
  gc_frame_newslot(opresult1451);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1452 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  Object call1453 = callmethodflags(*var_io, "error", 0, partcv, params, 0);
  gc_frame_end(callframe1452);
// compiled member node returning call1453 (depth = 7)
  params[0] = opresult1451;
  partcv[0] = 1;
  Object call1454 = callmethodflags(call1453, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1426);
// compiled call node returning call1454 (depth = 6)
    gc_frame_newslot(call1454);
    if1412 = call1454;
  } else {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1455 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1457 == NULL) {
    strlit1457 = alloc_String("""\x0a""");
    gc_root(strlit1457);
  }
// compiled string node returning strlit1457 (depth = 8)
  int op_slot_right_1456 = gc_frame_newslot(strlit1457);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1460 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1461 = gc_frame_new();
// call case 4: self request
  Object call1462 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1461);
// compiled member node returning call1462 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1463 = callmethodflags(call1462, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1460);
// compiled call node returning call1463 (depth = 9)
  int op_slot_right_1459 = gc_frame_newslot(call1463);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1466 == NULL) {
    strlit1466 = alloc_String(": ");
    gc_root(strlit1466);
  }
// compiled string node returning strlit1466 (depth = 10)
  int op_slot_right_1465 = gc_frame_newslot(strlit1466);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1469 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe1470 = gc_frame_new();
// call case 4: self request
  Object call1471 = callmethodflags(self, "lineNumbers", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1470);
// compiled member node returning call1471 (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1472 = callmethodflags(call1471, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1469);
// compiled call node returning call1472 (depth = 11)
  int op_slot_right_1468 = gc_frame_newslot(call1472);
// starting to compile string node (depth = 11)
  if (strlit1474 == NULL) {
    strlit1474 = alloc_String("  ");
    gc_root(strlit1474);
  }
// compiled string node returning strlit1474 (depth = 11)
  int op_slot_left_1468 = gc_frame_newslot(strlit1474);
  params[0] = call1472;
  partcv[0] = 1;
  Object opresult1475 = callmethod(strlit1474, "++(1)", 1, partcv, params);
// compiled op node returning opresult1475 (depth = 10)
  int op_slot_left_1465 = gc_frame_newslot(opresult1475);
  params[0] = strlit1466;
  partcv[0] = 1;
  Object opresult1476 = callmethod(opresult1475, "++(1)", 1, partcv, params);
// compiled op node returning opresult1476 (depth = 9)
  int op_slot_left_1459 = gc_frame_newslot(opresult1476);
  params[0] = call1463;
  partcv[0] = 1;
  Object opresult1477 = callmethod(opresult1476, "++(1)", 1, partcv, params);
// compiled op node returning opresult1477 (depth = 8)
  int op_slot_left_1456 = gc_frame_newslot(opresult1477);
  params[0] = strlit1457;
  partcv[0] = 1;
  Object opresult1478 = callmethod(opresult1477, "++(1)", 1, partcv, params);
// compiled op node returning opresult1478 (depth = 7)
  gc_frame_newslot(opresult1478);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  Object call1480 = callmethodflags(*var_io, "error", 0, partcv, params, 0);
  gc_frame_end(callframe1479);
// compiled member node returning call1480 (depth = 7)
  params[0] = opresult1478;
  partcv[0] = 1;
  Object call1481 = callmethodflags(call1480, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1455);
// compiled call node returning call1481 (depth = 6)
    gc_frame_newslot(call1481);
    if1412 = call1481;
  }
// compiled if node returning if1412 (depth = 5)
  gc_frame_end(frame);
  return if1412;
}
Object meth_errormessages_1335_print(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "print");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1336 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1338 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1339 = gc_frame_new();
// call case 4: self request
  Object call1340 = callmethodflags(self, "lines", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1339);
// compiled member node returning call1340 (depth = 6)
  Object call1341 = callmethodflags(call1340, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1338);
// compiled member node returning call1341 (depth = 5)
  int op_slot_right_1337 = gc_frame_newslot(call1341);
// starting to compile num node (depth = 5)
  Object num1343 = alloc_Float64(1);
// compiled num node returning num1343 (depth = 5)
  int op_slot_left_1337 = gc_frame_newslot(num1343);
  params[0] = call1341;
  partcv[0] = 1;
  Object opresult1344 = callmethod(num1343, "..(1)", 1, partcv, params);
// compiled op node returning opresult1344 (depth = 4)
  gc_frame_newslot(opresult1344);
// starting to compile block node (depth = 4)
  Object block1345 = alloc_Block(NULL, NULL, "errormessages", 261);
  gc_frame_newslot(block1345);
// method "_apply(_)"
  block_savedest(block1345);
  Object closure1346 = createclosure(2, "_apply(1)");
  setclosureframe(closure1346, stackframe);
  addtoclosure(closure1346, var_io);
  addtoclosure(closure1346, selfslot);
  struct UserObject *uo1346 = (struct UserObject*)block1345;
  uo1346->data[0] = (Object)closure1346;
  Method *meth_meth_errormessages_1346__apply_40_1_41_ = addmethod2pos(block1345, "_apply(1)", &meth_errormessages_1346__apply_40_1_41_, 0);
  int argcv_meth_errormessages_1346__apply_40_1_41_[] = {1};
  meth_meth_errormessages_1346__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1346__apply_40_1_41_);
  meth_meth_errormessages_1346__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1346__apply_40_1_41_->definitionLine = 500;
// compiled block node returning block1345 (depth = 4)
  gc_frame_newslot(block1345);
// call case 5: prelude request
  params[0] = opresult1344;
  params[1] = block1345;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1483 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1336);
// compiled call node returning call1483 (depth = 3)
  gc_frame_end(frame);
  return call1483;
}
Object meth_errormessages_713_new(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject714 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj714 = alloc_userobj2(28,29, objclass714);
  gc_frame_newslot(obj714);
  if (objclass714 == NULL) {
    glfree(obj714->class->name);
    obj714->class->name = "suggestion.new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj714, self, 0);
  addmethodreal(obj714,"outer", &reader_errormessages_outer_715);
  Object oldself714 = self;
  struct StackFrameObject *oldstackframe714 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe714);
  gc_frame_newslot((Object)stackframe);
  self = obj714;
  Object *oldselfslot714 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter714 = (*(struct UserObject *)self).data[0], lowerouter714 = thisouter714;
  if (inheritingObject714) {
    struct UserObject *inho714 = (struct UserObject *)inheritingObject714;
    while (inho714->super != GraceDefaultObject) inho714 = (struct UserObject *)inho714->super;
    inho714->super = obj714;
    self = inheritingObject714;
    *selfslot = self;
    lowerouter714 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter714;
  }
  if (objclass714 == NULL) {
  Method *reader716 = addmethodrealflags(obj714, "lineNumbers",&reader_errormessages_lineNumbers_716, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader716->definitionModule = modulename;
  reader716->definitionLine = 15;
  }
  adddatum2(obj714, alloc_Undefined(), 1);
  if (objclass714 == NULL) {
  Method *reader717 = addmethodrealflags(obj714, "lines",&reader_errormessages_lines_717, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader717->definitionModule = modulename;
  reader717->definitionLine = 16;
  }
  adddatum2(obj714, alloc_Undefined(), 2);
// method "replaceRange(_,_)with(_)onLine(_)"
  struct UserObject *uo718 = (struct UserObject*)obj714;
  uo718->data[3] = emptyclosure;
  Method *meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceRange(2)with(1)onLine(1)", &meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_, 3);
  int argcv_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionLine = 23;
// method "replaceChar(_)with(_)onLine(_)"
  struct UserObject *uo762 = (struct UserObject*)obj714;
  uo762->data[4] = emptyclosure;
  Method *meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceChar(1)with(1)onLine(1)", &meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_, 4);
  int argcv_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 33;
// method "replaceUntil(_)with(_)onLine(_)"
  struct UserObject *uo765 = (struct UserObject*)obj714;
  uo765->data[5] = emptyclosure;
  Method *meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceUntil(1)with(1)onLine(1)", &meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_, 5);
  int argcv_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 37;
// method "deleteRange(_,_)onLine(_)"
  struct UserObject *uo806 = (struct UserObject*)obj714;
  uo806->data[6] = emptyclosure;
  Method *meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_ = addmethod2pos(obj714, "deleteRange(2)onLine(1)", &meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_, 6);
  int argcv_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_[] = {2, 1};
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_);
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->definitionLine = 49;
// method "deleteChar(_)onLine(_)"
  struct UserObject *uo855 = (struct UserObject*)obj714;
  uo855->data[7] = emptyclosure;
  Method *meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "deleteChar(1)onLine(1)", &meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_, 7);
  int argcv_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->definitionLine = 67;
// method "append(_)onLine(_)"
  struct UserObject *uo859 = (struct UserObject*)obj714;
  uo859->data[8] = emptyclosure;
  Method *meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "append(1)onLine(1)", &meth_errormessages_859_append_40_1_41_onLine_40_1_41_, 8);
  int argcv_meth_errormessages_859_append_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_859_append_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->definitionLine = 71;
// method "insert(_)atPosition(_)onLine(_)"
  struct UserObject *uo867 = (struct UserObject*)obj714;
  uo867->data[9] = emptyclosure;
  Method *meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "insert(1)atPosition(1)onLine(1)", &meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_, 9);
  int argcv_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionLine = 76;
// method "getTokenStart(_)includeLeadingSpace(_)"
  struct UserObject *uo899 = (struct UserObject*)obj714;
  uo899->data[10] = emptyclosure;
  Method *meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_ = addmethod2pos(obj714, "getTokenStart(1)includeLeadingSpace(1)", &meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_, 10);
  int argcv_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_);
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionLine = 90;
// method "getTokenEnd(_)includeTrailingSpace(_)"
  struct UserObject *uo977 = (struct UserObject*)obj714;
  uo977->data[11] = emptyclosure;
  Method *meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_ = addmethod2pos(obj714, "getTokenEnd(1)includeTrailingSpace(1)", &meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_, 11);
  int argcv_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_);
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionLine = 107;
// method "replaceToken(_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1032 = (struct UserObject*)obj714;
  uo1032->data[12] = emptyclosure;
  Method *meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceToken(1)leading(1)trailing(1)with(1)", &meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 12);
  int argcv_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {1, 1, 1, 1};
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 120;
// method "replaceToken(_)with(_)"
  struct UserObject *uo1041 = (struct UserObject*)obj714;
  uo1041->data[13] = emptyclosure;
  Method *meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceToken(1)with(1)", &meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_, 13);
  int argcv_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->definitionLine = 126;
// method "replaceTokenRange(_,_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1046 = (struct UserObject*)obj714;
  uo1046->data[14] = emptyclosure;
  Method *meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceTokenRange(2)leading(1)trailing(1)with(1)", &meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 14);
  int argcv_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {2, 1, 1, 1};
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 130;
// method "replaceTokenRange(_,_)with(_)"
  struct UserObject *uo1086 = (struct UserObject*)obj714;
  uo1086->data[15] = emptyclosure;
  Method *meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_ = addmethod2pos(obj714, "replaceTokenRange(2)with(1)", &meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_, 15);
  int argcv_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_[] = {2, 1};
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_);
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->definitionLine = 147;
// method "deleteToken(_)leading(_)trailing(_)"
  struct UserObject *uo1091 = (struct UserObject*)obj714;
  uo1091->data[16] = emptyclosure;
  Method *meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj714, "deleteToken(1)leading(1)trailing(1)", &meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_, 16);
  int argcv_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 152;
// method "deleteToken(_)"
  struct UserObject *uo1100 = (struct UserObject*)obj714;
  uo1100->data[17] = emptyclosure;
  Method *meth_meth_errormessages_1100_deleteToken_40_1_41_ = addmethod2pos(obj714, "deleteToken(1)", &meth_errormessages_1100_deleteToken_40_1_41_, 17);
  int argcv_meth_errormessages_1100_deleteToken_40_1_41_[] = {1};
  meth_meth_errormessages_1100_deleteToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1100_deleteToken_40_1_41_);
  meth_meth_errormessages_1100_deleteToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1100_deleteToken_40_1_41_->definitionLine = 158;
// method "deleteTokenRange(_,_)leading(_)trailing(_)"
  struct UserObject *uo1105 = (struct UserObject*)obj714;
  uo1105->data[18] = emptyclosure;
  Method *meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj714, "deleteTokenRange(2)leading(1)trailing(1)", &meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_, 18);
  int argcv_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 163;
// method "deleteTokenRange(_,_)"
  struct UserObject *uo1166 = (struct UserObject*)obj714;
  uo1166->data[19] = emptyclosure;
  Method *meth_meth_errormessages_1166_deleteTokenRange_40_2_41_ = addmethod2pos(obj714, "deleteTokenRange(2)", &meth_errormessages_1166_deleteTokenRange_40_2_41_, 19);
  int argcv_meth_errormessages_1166_deleteTokenRange_40_2_41_[] = {2};
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1166_deleteTokenRange_40_2_41_);
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->definitionLine = 188;
// method "deleteLine(_)"
  struct UserObject *uo1171 = (struct UserObject*)obj714;
  uo1171->data[20] = emptyclosure;
  Method *meth_meth_errormessages_1171_deleteLine_40_1_41_ = addmethod2pos(obj714, "deleteLine(1)", &meth_errormessages_1171_deleteLine_40_1_41_, 20);
  int argcv_meth_errormessages_1171_deleteLine_40_1_41_[] = {1};
  meth_meth_errormessages_1171_deleteLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1171_deleteLine_40_1_41_);
  meth_meth_errormessages_1171_deleteLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1171_deleteLine_40_1_41_->definitionLine = 192;
// method "insert(_)afterToken(_)andTrailingSpace(_)"
  struct UserObject *uo1175 = (struct UserObject*)obj714;
  uo1175->data[21] = emptyclosure;
  Method *meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_ = addmethod2pos(obj714, "insert(1)afterToken(1)andTrailingSpace(1)", &meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_, 21);
  int argcv_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_);
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionLine = 196;
// method "insert(_)afterToken(_)"
  struct UserObject *uo1186 = (struct UserObject*)obj714;
  uo1186->data[22] = emptyclosure;
  Method *meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_ = addmethod2pos(obj714, "insert(1)afterToken(1)", &meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_, 22);
  int argcv_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_);
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->definitionLine = 201;
// method "insert(_)beforeToken(_)"
  struct UserObject *uo1190 = (struct UserObject*)obj714;
  uo1190->data[23] = emptyclosure;
  Method *meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_ = addmethod2pos(obj714, "insert(1)beforeToken(1)", &meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_, 23);
  int argcv_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_);
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->definitionLine = 205;
// method "insertNewLine(_)after(_)"
  struct UserObject *uo1197 = (struct UserObject*)obj714;
  uo1197->data[24] = emptyclosure;
  Method *meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_ = addmethod2pos(obj714, "insertNewLine(1)after(1)", &meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_, 24);
  int argcv_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_);
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->definitionLine = 210;
// method "addLine(_,_)"
  struct UserObject *uo1200 = (struct UserObject*)obj714;
  uo1200->data[25] = emptyclosure;
  Method *meth_meth_errormessages_1200_addLine_40_2_41_ = addmethod2pos(obj714, "addLine(2)", &meth_errormessages_1200_addLine_40_2_41_, 25);
  int argcv_meth_errormessages_1200_addLine_40_2_41_[] = {2};
  meth_meth_errormessages_1200_addLine_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1200_addLine_40_2_41_);
  meth_meth_errormessages_1200_addLine_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1200_addLine_40_2_41_->definitionLine = 216;
// method "findLine(_)"
  struct UserObject *uo1300 = (struct UserObject*)obj714;
  uo1300->data[26] = emptyclosure;
  Method *meth_meth_errormessages_1300_findLine_40_1_41_ = addmethod2pos(obj714, "findLine(1)", &meth_errormessages_1300_findLine_40_1_41_, 26);
  int argcv_meth_errormessages_1300_findLine_40_1_41_[] = {1};
  meth_meth_errormessages_1300_findLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1300_findLine_40_1_41_);
  meth_meth_errormessages_1300_findLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1300_findLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1300_findLine_40_1_41_->definitionLine = 240;
// method "getLine(_)"
  block_savedest(obj714);
  Object closure1319 = createclosure(1, "getLine(1)");
  setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, var_util);
  struct UserObject *uo1319 = (struct UserObject*)obj714;
  uo1319->data[27] = (Object)closure1319;
  Method *meth_meth_errormessages_1319_getLine_40_1_41_ = addmethod2pos(obj714, "getLine(1)", &meth_errormessages_1319_getLine_40_1_41_, 27);
  int argcv_meth_errormessages_1319_getLine_40_1_41_[] = {1};
  meth_meth_errormessages_1319_getLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1319_getLine_40_1_41_);
  meth_meth_errormessages_1319_getLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1319_getLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1319_getLine_40_1_41_->definitionLine = 251;
// method "print"
  block_savedest(obj714);
  Object closure1335 = createclosure(1, "print");
  setclosureframe(closure1335, stackframe);
  addtoclosure(closure1335, var_io);
  struct UserObject *uo1335 = (struct UserObject*)obj714;
  uo1335->data[28] = (Object)closure1335;
  Method *meth_meth_errormessages_1335_print = addmethod2pos(obj714, "print", &meth_errormessages_1335_print, 28);
  int argcv_meth_errormessages_1335_print[] = {0};
  meth_meth_errormessages_1335_print->type = alloc_MethodType(1, argcv_meth_errormessages_1335_print);
  meth_meth_errormessages_1335_print->definitionModule = modulename;
  meth_meth_errormessages_1335_print->definitionLine = 260;
  sourceObject = obj714;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1484 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1484 (depth = 3)
  adddatum2(obj714, array1484, 1);
  sourceObject = obj714;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1485 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1485 (depth = 3)
  adddatum2(obj714, array1485, 2);
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  objclass714 = obj714->class;
  objclass714->definitionModule = modulename;
  objclass714->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter714;
  self = oldself714;
  selfslot = oldselfslot714;
  stackframe = oldstackframe714;
  gc_frame_end(frame);
  return obj714;
}
Object meth_errormessages_713_new_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject714 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj714 = alloc_userobj2(28,29, objclass714);
  gc_frame_newslot(obj714);
  if (objclass714 == NULL) {
    glfree(obj714->class->name);
    obj714->class->name = "suggestion.new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj714, self, 0);
  addmethodreal(obj714,"outer", &reader_errormessages_outer_715);
  Object oldself714 = self;
  struct StackFrameObject *oldstackframe714 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe714);
  gc_frame_newslot((Object)stackframe);
  self = obj714;
  Object *oldselfslot714 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter714 = (*(struct UserObject *)self).data[0], lowerouter714 = thisouter714;
  if (inheritingObject714) {
    struct UserObject *inho714 = (struct UserObject *)inheritingObject714;
    while (inho714->super != GraceDefaultObject) inho714 = (struct UserObject *)inho714->super;
    inho714->super = obj714;
    self = inheritingObject714;
    *selfslot = self;
    lowerouter714 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter714;
  }
  if (objclass714 == NULL) {
  Method *reader716 = addmethodrealflags(obj714, "lineNumbers",&reader_errormessages_lineNumbers_716, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader716->definitionModule = modulename;
  reader716->definitionLine = 15;
  }
  adddatum2(obj714, alloc_Undefined(), 1);
  if (objclass714 == NULL) {
  Method *reader717 = addmethodrealflags(obj714, "lines",&reader_errormessages_lines_717, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader717->definitionModule = modulename;
  reader717->definitionLine = 16;
  }
  adddatum2(obj714, alloc_Undefined(), 2);
// method "replaceRange(_,_)with(_)onLine(_)"
  struct UserObject *uo718 = (struct UserObject*)obj714;
  uo718->data[3] = emptyclosure;
  Method *meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceRange(2)with(1)onLine(1)", &meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_, 3);
  int argcv_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_718_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionLine = 23;
// method "replaceChar(_)with(_)onLine(_)"
  struct UserObject *uo762 = (struct UserObject*)obj714;
  uo762->data[4] = emptyclosure;
  Method *meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceChar(1)with(1)onLine(1)", &meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_, 4);
  int argcv_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_762_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 33;
// method "replaceUntil(_)with(_)onLine(_)"
  struct UserObject *uo765 = (struct UserObject*)obj714;
  uo765->data[5] = emptyclosure;
  Method *meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "replaceUntil(1)with(1)onLine(1)", &meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_, 5);
  int argcv_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_765_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 37;
// method "deleteRange(_,_)onLine(_)"
  struct UserObject *uo806 = (struct UserObject*)obj714;
  uo806->data[6] = emptyclosure;
  Method *meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_ = addmethod2pos(obj714, "deleteRange(2)onLine(1)", &meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_, 6);
  int argcv_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_[] = {2, 1};
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_);
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_806_deleteRange_40_2_41_onLine_40_1_41_->definitionLine = 49;
// method "deleteChar(_)onLine(_)"
  struct UserObject *uo855 = (struct UserObject*)obj714;
  uo855->data[7] = emptyclosure;
  Method *meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "deleteChar(1)onLine(1)", &meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_, 7);
  int argcv_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_855_deleteChar_40_1_41_onLine_40_1_41_->definitionLine = 67;
// method "append(_)onLine(_)"
  struct UserObject *uo859 = (struct UserObject*)obj714;
  uo859->data[8] = emptyclosure;
  Method *meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "append(1)onLine(1)", &meth_errormessages_859_append_40_1_41_onLine_40_1_41_, 8);
  int argcv_meth_errormessages_859_append_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_859_append_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_859_append_40_1_41_onLine_40_1_41_->definitionLine = 71;
// method "insert(_)atPosition(_)onLine(_)"
  struct UserObject *uo867 = (struct UserObject*)obj714;
  uo867->data[9] = emptyclosure;
  Method *meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_ = addmethod2pos(obj714, "insert(1)atPosition(1)onLine(1)", &meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_, 9);
  int argcv_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_867_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionLine = 76;
// method "getTokenStart(_)includeLeadingSpace(_)"
  struct UserObject *uo899 = (struct UserObject*)obj714;
  uo899->data[10] = emptyclosure;
  Method *meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_ = addmethod2pos(obj714, "getTokenStart(1)includeLeadingSpace(1)", &meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_, 10);
  int argcv_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_);
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_899_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionLine = 90;
// method "getTokenEnd(_)includeTrailingSpace(_)"
  struct UserObject *uo977 = (struct UserObject*)obj714;
  uo977->data[11] = emptyclosure;
  Method *meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_ = addmethod2pos(obj714, "getTokenEnd(1)includeTrailingSpace(1)", &meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_, 11);
  int argcv_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_);
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_977_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionLine = 107;
// method "replaceToken(_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1032 = (struct UserObject*)obj714;
  uo1032->data[12] = emptyclosure;
  Method *meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceToken(1)leading(1)trailing(1)with(1)", &meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 12);
  int argcv_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {1, 1, 1, 1};
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1032_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 120;
// method "replaceToken(_)with(_)"
  struct UserObject *uo1041 = (struct UserObject*)obj714;
  uo1041->data[13] = emptyclosure;
  Method *meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceToken(1)with(1)", &meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_, 13);
  int argcv_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1041_replaceToken_40_1_41_with_40_1_41_->definitionLine = 126;
// method "replaceTokenRange(_,_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1046 = (struct UserObject*)obj714;
  uo1046->data[14] = emptyclosure;
  Method *meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj714, "replaceTokenRange(2)leading(1)trailing(1)with(1)", &meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 14);
  int argcv_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {2, 1, 1, 1};
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1046_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 130;
// method "replaceTokenRange(_,_)with(_)"
  struct UserObject *uo1086 = (struct UserObject*)obj714;
  uo1086->data[15] = emptyclosure;
  Method *meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_ = addmethod2pos(obj714, "replaceTokenRange(2)with(1)", &meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_, 15);
  int argcv_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_[] = {2, 1};
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_);
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1086_replaceTokenRange_40_2_41_with_40_1_41_->definitionLine = 147;
// method "deleteToken(_)leading(_)trailing(_)"
  struct UserObject *uo1091 = (struct UserObject*)obj714;
  uo1091->data[16] = emptyclosure;
  Method *meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj714, "deleteToken(1)leading(1)trailing(1)", &meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_, 16);
  int argcv_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1091_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 152;
// method "deleteToken(_)"
  struct UserObject *uo1100 = (struct UserObject*)obj714;
  uo1100->data[17] = emptyclosure;
  Method *meth_meth_errormessages_1100_deleteToken_40_1_41_ = addmethod2pos(obj714, "deleteToken(1)", &meth_errormessages_1100_deleteToken_40_1_41_, 17);
  int argcv_meth_errormessages_1100_deleteToken_40_1_41_[] = {1};
  meth_meth_errormessages_1100_deleteToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1100_deleteToken_40_1_41_);
  meth_meth_errormessages_1100_deleteToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1100_deleteToken_40_1_41_->definitionLine = 158;
// method "deleteTokenRange(_,_)leading(_)trailing(_)"
  struct UserObject *uo1105 = (struct UserObject*)obj714;
  uo1105->data[18] = emptyclosure;
  Method *meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj714, "deleteTokenRange(2)leading(1)trailing(1)", &meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_, 18);
  int argcv_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1105_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 163;
// method "deleteTokenRange(_,_)"
  struct UserObject *uo1166 = (struct UserObject*)obj714;
  uo1166->data[19] = emptyclosure;
  Method *meth_meth_errormessages_1166_deleteTokenRange_40_2_41_ = addmethod2pos(obj714, "deleteTokenRange(2)", &meth_errormessages_1166_deleteTokenRange_40_2_41_, 19);
  int argcv_meth_errormessages_1166_deleteTokenRange_40_2_41_[] = {2};
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1166_deleteTokenRange_40_2_41_);
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1166_deleteTokenRange_40_2_41_->definitionLine = 188;
// method "deleteLine(_)"
  struct UserObject *uo1171 = (struct UserObject*)obj714;
  uo1171->data[20] = emptyclosure;
  Method *meth_meth_errormessages_1171_deleteLine_40_1_41_ = addmethod2pos(obj714, "deleteLine(1)", &meth_errormessages_1171_deleteLine_40_1_41_, 20);
  int argcv_meth_errormessages_1171_deleteLine_40_1_41_[] = {1};
  meth_meth_errormessages_1171_deleteLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1171_deleteLine_40_1_41_);
  meth_meth_errormessages_1171_deleteLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1171_deleteLine_40_1_41_->definitionLine = 192;
// method "insert(_)afterToken(_)andTrailingSpace(_)"
  struct UserObject *uo1175 = (struct UserObject*)obj714;
  uo1175->data[21] = emptyclosure;
  Method *meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_ = addmethod2pos(obj714, "insert(1)afterToken(1)andTrailingSpace(1)", &meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_, 21);
  int argcv_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_);
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1175_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionLine = 196;
// method "insert(_)afterToken(_)"
  struct UserObject *uo1186 = (struct UserObject*)obj714;
  uo1186->data[22] = emptyclosure;
  Method *meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_ = addmethod2pos(obj714, "insert(1)afterToken(1)", &meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_, 22);
  int argcv_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_);
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1186_insert_40_1_41_afterToken_40_1_41_->definitionLine = 201;
// method "insert(_)beforeToken(_)"
  struct UserObject *uo1190 = (struct UserObject*)obj714;
  uo1190->data[23] = emptyclosure;
  Method *meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_ = addmethod2pos(obj714, "insert(1)beforeToken(1)", &meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_, 23);
  int argcv_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_);
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1190_insert_40_1_41_beforeToken_40_1_41_->definitionLine = 205;
// method "insertNewLine(_)after(_)"
  struct UserObject *uo1197 = (struct UserObject*)obj714;
  uo1197->data[24] = emptyclosure;
  Method *meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_ = addmethod2pos(obj714, "insertNewLine(1)after(1)", &meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_, 24);
  int argcv_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_);
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1197_insertNewLine_40_1_41_after_40_1_41_->definitionLine = 210;
// method "addLine(_,_)"
  struct UserObject *uo1200 = (struct UserObject*)obj714;
  uo1200->data[25] = emptyclosure;
  Method *meth_meth_errormessages_1200_addLine_40_2_41_ = addmethod2pos(obj714, "addLine(2)", &meth_errormessages_1200_addLine_40_2_41_, 25);
  int argcv_meth_errormessages_1200_addLine_40_2_41_[] = {2};
  meth_meth_errormessages_1200_addLine_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1200_addLine_40_2_41_);
  meth_meth_errormessages_1200_addLine_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1200_addLine_40_2_41_->definitionLine = 216;
// method "findLine(_)"
  struct UserObject *uo1300 = (struct UserObject*)obj714;
  uo1300->data[26] = emptyclosure;
  Method *meth_meth_errormessages_1300_findLine_40_1_41_ = addmethod2pos(obj714, "findLine(1)", &meth_errormessages_1300_findLine_40_1_41_, 26);
  int argcv_meth_errormessages_1300_findLine_40_1_41_[] = {1};
  meth_meth_errormessages_1300_findLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1300_findLine_40_1_41_);
  meth_meth_errormessages_1300_findLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1300_findLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1300_findLine_40_1_41_->definitionLine = 240;
// method "getLine(_)"
  block_savedest(obj714);
  Object closure1319 = createclosure(1, "getLine(1)");
  setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, var_util);
  struct UserObject *uo1319 = (struct UserObject*)obj714;
  uo1319->data[27] = (Object)closure1319;
  Method *meth_meth_errormessages_1319_getLine_40_1_41_ = addmethod2pos(obj714, "getLine(1)", &meth_errormessages_1319_getLine_40_1_41_, 27);
  int argcv_meth_errormessages_1319_getLine_40_1_41_[] = {1};
  meth_meth_errormessages_1319_getLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1319_getLine_40_1_41_);
  meth_meth_errormessages_1319_getLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1319_getLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1319_getLine_40_1_41_->definitionLine = 251;
// method "print"
  block_savedest(obj714);
  Object closure1335 = createclosure(1, "print");
  setclosureframe(closure1335, stackframe);
  addtoclosure(closure1335, var_io);
  struct UserObject *uo1335 = (struct UserObject*)obj714;
  uo1335->data[28] = (Object)closure1335;
  Method *meth_meth_errormessages_1335_print = addmethod2pos(obj714, "print", &meth_errormessages_1335_print, 28);
  int argcv_meth_errormessages_1335_print[] = {0};
  meth_meth_errormessages_1335_print->type = alloc_MethodType(1, argcv_meth_errormessages_1335_print);
  meth_meth_errormessages_1335_print->definitionModule = modulename;
  meth_meth_errormessages_1335_print->definitionLine = 260;
  sourceObject = obj714;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1484 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1484 (depth = 3)
  adddatum2(obj714, array1484, 1);
  sourceObject = obj714;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1485 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1485 (depth = 3)
  adddatum2(obj714, array1485, 2);
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  sourceObject = obj714;
  objclass714 = obj714->class;
  objclass714->definitionModule = modulename;
  objclass714->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter714;
  self = oldself714;
  selfslot = oldselfslot714;
  stackframe = oldstackframe714;
  gc_frame_end(frame);
  return obj714;
}
Object meth_errormessages_1487_suggestion(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "suggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_suggestion = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_end(frame);
  return *var_suggestion;
}
Object module_errormessages_init() {
  if (module_errormessages) return module_errormessages;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(30, 30);
  module_errormessages = self;
  self->class->definitionModule = "errormessages";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("errormessages");
  setsource(originalSourceLines);
  setclassname(self, "Module<errormessages>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(30, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
// definebindings:
  Object *var_io = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "io");
  Object *var_sys = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sys");
  Object *var_util = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "util");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "readableStringFrom(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_errormessages_1_readableStringFrom_40_1_41_ = addmethod2pos(self, "readableStringFrom(1)", &meth_errormessages_1_readableStringFrom_40_1_41_, 1);
  int argcv_meth_errormessages_1_readableStringFrom_40_1_41_[] = {1};
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1_readableStringFrom_40_1_41_);
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->definitionLine = 280;
// compiled method node returning  (depth = 1)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "name(_)matches(_)within(_)"
  struct UserObject *uo53 = (struct UserObject*)self;
  uo53->data[2] = emptyclosure;
  Method *meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_ = addmethod2pos(self, "name(1)matches(1)within(1)", &meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_, 2);
  int argcv_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_);
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[0] = type_String;
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[0] = "p";
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[1] = type_String;
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[1] = "t";
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[2] = type_Number;
meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[2] = "k";
  meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_53_name_40_1_41_matches_40_1_41_within_40_1_41_->definitionLine = 298;
// compiled method node returning  (depth = 1)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "min3(_,_,_)"
  struct UserObject *uo212 = (struct UserObject*)self;
  uo212->data[3] = emptyclosure;
  Method *meth_meth_errormessages_212_min3_40_3_41_ = addmethod2pos(self, "min3(3)", &meth_errormessages_212_min3_40_3_41_, 3);
  int argcv_meth_errormessages_212_min3_40_3_41_[] = {3};
  meth_meth_errormessages_212_min3_40_3_41_->type = alloc_MethodType(1, argcv_meth_errormessages_212_min3_40_3_41_);
  meth_meth_errormessages_212_min3_40_3_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_212_min3_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_212_min3_40_3_41_->definitionLine = 350;
// compiled method node returning  (depth = 1)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)"
  struct UserObject *uo221 = (struct UserObject*)self;
  uo221->data[4] = emptyclosure;
  Method *meth_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)", &meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_, 4);
  int argcv_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_[] = {1, 1};
  meth_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_);
  meth_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_221_syntaxError_40_1_41_atRange_40_1_41_->definitionLine = 358;
// compiled method node returning  (depth = 1)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)withSuggestion(_)"
  struct UserObject *uo242 = (struct UserObject*)self;
  uo242->data[5] = emptyclosure;
  Method *meth_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)withSuggestion(1)", &meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_, 5);
  int argcv_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_242_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->definitionLine = 366;
// compiled method node returning  (depth = 1)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)withSuggestions(_)"
  struct UserObject *uo246 = (struct UserObject*)self;
  uo246->data[6] = emptyclosure;
  Method *meth_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)withSuggestions(1)", &meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_, 6);
  int argcv_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_246_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->definitionLine = 369;
// compiled method node returning  (depth = 1)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)"
  struct UserObject *uo265 = (struct UserObject*)self;
  uo265->data[7] = emptyclosure;
  Method *meth_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)", &meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_, 7);
  int argcv_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_[] = {1, 3};
  meth_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_->type = alloc_MethodType(2, argcv_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_);
  meth_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_265_syntaxError_40_1_41_atRange_40_3_41_->definitionLine = 375;
// compiled method node returning  (depth = 1)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)withSuggestion(_)"
  struct UserObject *uo269 = (struct UserObject*)self;
  uo269->data[8] = emptyclosure;
  Method *meth_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)withSuggestion(1)", &meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_, 8);
  int argcv_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_269_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->definitionLine = 379;
// compiled method node returning  (depth = 1)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure273 = createclosure(1, "syntaxError(1)atRange(3)withSuggestions(1)");
  setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_util);
  struct UserObject *uo273 = (struct UserObject*)self;
  uo273->data[9] = (Object)closure273;
  Method *meth_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)withSuggestions(1)", &meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_, 9);
  int argcv_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_273_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionLine = 383;
// compiled method node returning  (depth = 1)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure340 = createclosure(1, "syntaxError(1)atRange(4)withSuggestions(1)");
  setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_util);
  struct UserObject *uo340 = (struct UserObject*)self;
  uo340->data[10] = (Object)closure340;
  Method *meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(4)withSuggestions(1)", &meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_, 10);
  int argcv_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_[] = {1, 4, 1};
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionLine = 395;
// compiled method node returning  (depth = 1)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_)"
  struct UserObject *uo433 = (struct UserObject*)self;
  uo433->data[11] = emptyclosure;
  Method *meth_meth_errormessages_433_error_40_1_41_atRange_40_1_41_ = addmethod2pos(self, "error(1)atRange(1)", &meth_errormessages_433_error_40_1_41_atRange_40_1_41_, 11);
  int argcv_meth_errormessages_433_error_40_1_41_atRange_40_1_41_[] = {1, 1};
  meth_meth_errormessages_433_error_40_1_41_atRange_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_433_error_40_1_41_atRange_40_1_41_);
  meth_meth_errormessages_433_error_40_1_41_atRange_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_433_error_40_1_41_atRange_40_1_41_->definitionLine = 415;
// compiled method node returning  (depth = 1)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_,_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure448 = createclosure(1, "error(1)atRange(3)withSuggestions(1)");
  setclosureframe(closure448, stackframe);
  addtoclosure(closure448, var_util);
  struct UserObject *uo448 = (struct UserObject*)self;
  uo448->data[12] = (Object)closure448;
  Method *meth_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atRange(3)withSuggestions(1)", &meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_, 12);
  int argcv_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_448_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionLine = 418;
// compiled method node returning  (depth = 1)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_,_,_)"
  struct UserObject *uo515 = (struct UserObject*)self;
  uo515->data[13] = emptyclosure;
  Method *meth_meth_errormessages_515_error_40_1_41_atRange_40_3_41_ = addmethod2pos(self, "error(1)atRange(3)", &meth_errormessages_515_error_40_1_41_atRange_40_3_41_, 13);
  int argcv_meth_errormessages_515_error_40_1_41_atRange_40_3_41_[] = {1, 3};
  meth_meth_errormessages_515_error_40_1_41_atRange_40_3_41_->type = alloc_MethodType(2, argcv_meth_errormessages_515_error_40_1_41_atRange_40_3_41_);
  meth_meth_errormessages_515_error_40_1_41_atRange_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_515_error_40_1_41_atRange_40_3_41_->definitionLine = 430;
// compiled method node returning  (depth = 1)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)"
  struct UserObject *uo519 = (struct UserObject*)self;
  uo519->data[14] = emptyclosure;
  Method *meth_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)", &meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_, 14);
  int argcv_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_[] = {1, 2};
  meth_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_->type = alloc_MethodType(2, argcv_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_);
  meth_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_519_syntaxError_40_1_41_atPosition_40_2_41_->definitionLine = 434;
// compiled method node returning  (depth = 1)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atPosition(_,_)"
  struct UserObject *uo523 = (struct UserObject*)self;
  uo523->data[15] = emptyclosure;
  Method *meth_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_ = addmethod2pos(self, "error(1)atPosition(2)", &meth_errormessages_523_error_40_1_41_atPosition_40_2_41_, 15);
  int argcv_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_[] = {1, 2};
  meth_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_->type = alloc_MethodType(2, argcv_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_);
  meth_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_523_error_40_1_41_atPosition_40_2_41_->definitionLine = 438;
// compiled method node returning  (depth = 1)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)withSuggestion(_)"
  struct UserObject *uo527 = (struct UserObject*)self;
  uo527->data[16] = emptyclosure;
  Method *meth_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)withSuggestion(1)", &meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_, 16);
  int argcv_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_527_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->definitionLine = 442;
// compiled method node returning  (depth = 1)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure531 = createclosure(1, "syntaxError(1)atPosition(2)withSuggestions(1)");
  setclosureframe(closure531, stackframe);
  addtoclosure(closure531, var_util);
  struct UserObject *uo531 = (struct UserObject*)self;
  uo531->data[17] = (Object)closure531;
  Method *meth_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)withSuggestions(1)", &meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_, 17);
  int argcv_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_531_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionLine = 446;
// compiled method node returning  (depth = 1)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atPosition(_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure569 = createclosure(1, "error(1)atPosition(2)withSuggestions(1)");
  setclosureframe(closure569, stackframe);
  addtoclosure(closure569, var_util);
  struct UserObject *uo569 = (struct UserObject*)self;
  uo569->data[18] = (Object)closure569;
  Method *meth_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atPosition(2)withSuggestions(1)", &meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_, 18);
  int argcv_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_569_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionLine = 455;
// compiled method node returning  (depth = 1)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)"
  block_savedest(self);
  Object closure607 = createclosure(1, "error(1)");
  setclosureframe(closure607, stackframe);
  addtoclosure(closure607, var_util);
  struct UserObject *uo607 = (struct UserObject*)self;
  uo607->data[19] = (Object)closure607;
  Method *meth_meth_errormessages_607_error_40_1_41_ = addmethod2pos(self, "error(1)", &meth_errormessages_607_error_40_1_41_, 19);
  int argcv_meth_errormessages_607_error_40_1_41_[] = {1};
  meth_meth_errormessages_607_error_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_607_error_40_1_41_);
  meth_meth_errormessages_607_error_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_607_error_40_1_41_->definitionLine = 465;
// compiled method node returning  (depth = 1)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atLine(_)withSuggestions(_)"
  block_savedest(self);
  Object closure614 = createclosure(1, "error(1)atLine(1)withSuggestions(1)");
  setclosureframe(closure614, stackframe);
  addtoclosure(closure614, var_util);
  struct UserObject *uo614 = (struct UserObject*)self;
  uo614->data[20] = (Object)closure614;
  Method *meth_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atLine(1)withSuggestions(1)", &meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_, 20);
  int argcv_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_614_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionLine = 469;
// compiled method node returning  (depth = 1)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atLine(_)"
  struct UserObject *uo656 = (struct UserObject*)self;
  uo656->data[21] = emptyclosure;
  Method *meth_meth_errormessages_656_error_40_1_41_atLine_40_1_41_ = addmethod2pos(self, "error(1)atLine(1)", &meth_errormessages_656_error_40_1_41_atLine_40_1_41_, 21);
  int argcv_meth_errormessages_656_error_40_1_41_atLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_656_error_40_1_41_atLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_656_error_40_1_41_atLine_40_1_41_);
  meth_meth_errormessages_656_error_40_1_41_atLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_656_error_40_1_41_atLine_40_1_41_->definitionLine = 480;
// compiled method node returning  (depth = 1)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)"
  struct UserObject *uo660 = (struct UserObject*)self;
  uo660->data[22] = emptyclosure;
  Method *meth_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)", &meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_, 22);
  int argcv_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_);
  meth_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_660_syntaxError_40_1_41_atLine_40_1_41_->definitionLine = 484;
// compiled method node returning  (depth = 1)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)withSuggestion(_)"
  struct UserObject *uo664 = (struct UserObject*)self;
  uo664->data[23] = emptyclosure;
  Method *meth_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)withSuggestion(1)", &meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_, 23);
  int argcv_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_664_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->definitionLine = 488;
// compiled method node returning  (depth = 1)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)withSuggestions(_)"
  block_savedest(self);
  Object closure668 = createclosure(1, "syntaxError(1)atLine(1)withSuggestions(1)");
  setclosureframe(closure668, stackframe);
  addtoclosure(closure668, var_util);
  struct UserObject *uo668 = (struct UserObject*)self;
  uo668->data[24] = (Object)closure668;
  Method *meth_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)withSuggestions(1)", &meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_, 24);
  int argcv_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_668_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionLine = 492;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject711 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj711 = alloc_userobj2(2,4, objclass711);
  gc_frame_newslot(obj711);
  if (objclass711 == NULL) {
    glfree(obj711->class->name);
    obj711->class->name = "suggestion";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj711, self, 0);
  addmethodreal(obj711,"outer", &reader_errormessages_outer_712);
  Object oldself711 = self;
  struct StackFrameObject *oldstackframe711 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe711);
  gc_frame_newslot((Object)stackframe);
  self = obj711;
  Object *oldselfslot711 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter711 = (*(struct UserObject *)self).data[0], lowerouter711 = thisouter711;
  if (inheritingObject711) {
    struct UserObject *inho711 = (struct UserObject *)inheritingObject711;
    while (inho711->super != GraceDefaultObject) inho711 = (struct UserObject *)inho711->super;
    inho711->super = obj711;
    self = inheritingObject711;
    *selfslot = self;
    lowerouter711 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter711;
  }
// method "new"
  block_savedest(obj711);
  Object closure713 = createclosure(2, "new");
  setclosureframe(closure713, stackframe);
  addtoclosure(closure713, var_util);
  addtoclosure(closure713, var_io);
  struct UserObject *uo713 = (struct UserObject*)obj711;
  uo713->data[1] = (Object)closure713;
  Method *meth_meth_errormessages_713_new = addmethod2pos(obj711, "new", &meth_errormessages_713_new, 1);
  int argcv_meth_errormessages_713_new[] = {0};
  meth_meth_errormessages_713_new->type = alloc_MethodType(1, argcv_meth_errormessages_713_new);
  meth_meth_errormessages_713_new->definitionModule = modulename;
  meth_meth_errormessages_713_new->definitionLine = 14;
  block_savedest(obj711);
  Object closure1486 = createclosure(2, "new$object(1)");
  setclosureframe(closure1486, stackframe);
  addtoclosure(closure1486, var_util);
  addtoclosure(closure1486, var_io);
  Method *meth_meth_errormessages_713_new_object = addmethod2pos(obj711, "new$object(1)", &meth_errormessages_713_new_object, 1);
  meth_meth_errormessages_713_new_object->definitionModule = modulename;
  meth_meth_errormessages_713_new_object->definitionLine = 14;
  sourceObject = obj711;
  objclass711 = obj711->class;
  objclass711->definitionModule = modulename;
  objclass711->definitionLine = 13;
  (*(struct UserObject *)self).data[0] = lowerouter711;
  self = oldself711;
  selfslot = oldselfslot711;
  stackframe = oldstackframe711;
// compiled object node returning obj711 (depth = 2)
  *var_suggestion = obj711;
  if (obj711 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "suggestion"
  block_savedest(self);
  Object closure1487 = createclosure(1, "suggestion");
  setclosureframe(closure1487, stackframe);
  addtoclosure(closure1487, var_suggestion);
  struct UserObject *uo1487 = (struct UserObject*)self;
  uo1487->data[25] = (Object)closure1487;
  Method *meth_meth_errormessages_1487_suggestion = addmethod2pos(self, "suggestion", &meth_errormessages_1487_suggestion, 25);
  int argcv_meth_errormessages_1487_suggestion[] = {0};
  meth_meth_errormessages_1487_suggestion->type = alloc_MethodType(1, argcv_meth_errormessages_1487_suggestion);
  meth_meth_errormessages_1487_suggestion->definitionModule = modulename;
  meth_meth_errormessages_1487_suggestion->definitionLine = 500;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
