#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "8d11a118d0ee0852a0c92e798a8f648f86b2f504";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_parser = NULL;
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var moduleObject",
  "var comments := emptyList   // so we can request `removeAt`",
  "",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "",
  "",
  "var values := [ ]",
  "",
  "//  The alternative definition below allows pushes and pops of `values`",
  "//  to be traced.  It can be useful for debugging the parser.",
  "//  def values = object {",
  "//      def realValues = [ ]",
  "//      var tracing is public := false",
  "//      method push(v) {",
  "//          if (tracing) then {",
  "//              print \"pushed {v.toGrace 0} (line {v.line})\"",
  "//          }",
  "//          realValues.push(v)",
  "//      }",
  "//      method pop {",
  "//          def res = realValues.pop",
  "//          if (tracing) then {",
  "//              print \"popped {res.toGrace 0} (line {res.line})\"",
  "//          }",
  "//          res",
  "//      }",
  "//      method size { realValues.size }",
  "//      method filter(b) { realValues.filter(b) }",
  "//      method isEmpty { realValues.isEmpty }",
  "//      method last { realValues.last }",
  "//      method do(b) { realValues.do(b) }",
  "//  }",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "    method ==(other) {",
  "        if (other == false) then {",
  "            false",
  "        } else {",
  "            (other.line == line) && (other.linePos == linePos)",
  "        }",
  "    }",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken     // the token starting the current statement",
  "var comment := false",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        pushComments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "method indentHasIncreased {",
  "    // is lastToken on a line that is a continuation of the previous line?",
  "",
  "    if (lastIndent == 0) then {",
  "        return false        // this ensures that there will be a previous symbol",
  "                            // on a prior line, and we won't hit start of input.",
  "    }",
  "    var s := sym.prev",
  "    do { s := s.prev } while { s.line == lastLine }",
  "    if ( s.kind == \"lbrace\" ) then { return false }",
  "    if ( s.kind == \"comment\" ) then { return false }",
  "    return s.indent < lastIndent",
  "}",
  "",
  "method saveParsePosition {",
  "    def lexerState = tokens.savePosition",
  "    return [lexerState, values.size]",
  "}",
  "",
  "method restoreParsePosition(saved) {",
  "    tokens.restorePosition(saved.first)",
  "    sym := tokens.first.prev",
  "    lastToken := sym.prev",
  "    def oldValueStackSize = saved.second",
  "    if (oldValueStackSize > values.size) then {",
  "        ProgrammingError.raise \"can't restore parse position; the values stack has been popped\"",
  "    }",
  "    while {oldValueStackSize ≠ values.size} do { values.pop }",
  "}",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok } && { n.indent >= lastToken.indent }} do {",
  "        if (tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if (((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok }} do {",
  "        if (((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set [\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if (validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if (!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if (inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if (n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif { n.kind == \"rbrace\" } then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1 ",
  "        }",
  "        n := n.next",
  "    }",
  "    if (n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif {(n.prev.kind == \"rbrace\") && (numOpening == numClosing)} then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "",
  "method accept(t) {",
  "    // True if the current token has kind t, where",
  "    // t is \"num\", \"string\", \"keyword\", etc.",
  "    sym.kind == t",
  "}",
  "",
  "method acceptKeyword (kw) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    return sym.value == kw",
  "}",
  "",
  "method acceptSameLine (t) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line (either because it's on the same physical line, or because",
  "    // it's on an indented continuation line).",
  "",
  "    (sym.kind == t) && ",
  "        ((lastLine == sym.line) || (sym.indent > lastIndent))",
  "}",
  "method acceptWithoutSpaces (t) {",
  "    // True if the current token is a t, and follows the previous token",
  "    // without any intervening spaces or continuation lines.",
  "",
  "    (sym.kind == t) && ",
  "        (lastLine == sym.line) && (sym.linePos == (lastToken.linePos + lastToken.size))",
  "}",
  "method accept (t) onLineOf (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as other (either because it's on the same physical",
  "    // line, or because it's on an indented continuation line).",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "method accept (t) onLineOfLastOr (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as the last token, or the other token.",
  "    if (sym.kind != t) then { return false }",
  "    if (lastLine == sym.line) then { return true }",
  "    if (sym.indent > lastIndent) then { return true }  // continuation last",
  "    if (other.line == sym.line) then { return true }",
  "    if (sym.indent > other.indent) then { return true }      // continuation of other",
  "    return false",
  "}",
  "method acceptArgumentOnLineOf(tok) {",
  "    // True if the current token can start an argument to a request",
  "    if (accept \"string\" onLineOf(tok)) then { return true }",
  "    if (accept \"num\" onLineOf(tok)) then { return true }",
  "    if (accept \"lbrace\" onLineOf(tok)) then { return true }",
  "    if (accept \"lsquare\" onLineOf(tok)) then { return true }",
  "    if (accept \"identifier\" onLineOf(tok)) then { ",
  "        return (sym.value == \"true\") || (sym.value == \"false\")",
  "    }",
  "    return false",
  "}",
  "method tokenOnSameLine {",
  "    // returns true if there is a token on the current logical line",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "method tokenOnLineOfLastOr (other) {",
  "    // returns true if there is a token on the current logical line, or one",
  "    // the same line as `other`",
  "    if (lastLine == sym.line) then { return true }",
  "    if (sym.indent > lastIndent) then { return true }   // continuation of last",
  "    if (other.line == sym.line) then { return true }",
  "    if (sym.indent > other.indent) then { return true } // continuation of other",
  "    return false",
  "}",
  "method didConsume (aParsingBlock) {",
  "    // returns true if executing aParsingBlock consumes at least one token.",
  "    def sz = tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size != sz",
  "}",
  "method didNotConsume (aParsingBlock) {",
  "    // returns true if executing aParsingBlock fails to consume any tokens.",
  "    def sz = tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size == sz",
  "}",
  "method pushnum {",
  "    // Push the current token onto the output stack as a number",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method pushstring {",
  "    // Push the current token onto the output stack as a string",
  "    var o := ast.stringNode.new(sym.value)",
  "    o.end := ast.line (sym.line) column (sym.endPos)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    def o = if (sym.value == \"_\") then {",
  "        ast.identifierNode.wildcard(false)",
  "    } else {",
  "        ast.identifierNode.new(sym.value, false)",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\") && {false != a.dtype}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"an argument to an annotation cannot have a type.\")",
  "                          atRange(tok.line, tok.linePos, tok.next.endPos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if (acceptKeyword \"is\" .not) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = [ ]",
  "    if (didNotConsume {expression(noBlocks)}) then {",
  "        errorMissingAnnotation",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if (didNotConsume {expression(noBlocks)}) then {",
  "            errorMissingAnnotation",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method errorMissingAnnotation {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [\"bind\"] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "        atRange(lastToken.line, lastToken.linePos, lastToken.endPos)",
  "        withSuggestions(suggestions)",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept \"identifier\") then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (acceptKeyword \"type\") then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept \"lparen\") then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if (didNotConsume {typeexpression}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev) leading (true)",
  "                    trailing(false) with \"«type expression»\"",
  "            }",
  "            errormessages.syntaxError \"parentheses must contain a valid type expression.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError \"a type expression beginning with a '(' must end with a ')'.\"",
  "                atRange(lastToken.line, lastToken.linePos, lastToken.endPos)",
  "                withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "method reportSyntaxError(message) before (expectedTokens) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken (expectedTokens)",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(message)",
  "        atPosition(sym.line, sym.linePos)",
  "        withSuggestions(suggestions)",
  "}",
  "",
  "method reportMissingArrow {",
  "    def suggestion = errormessages.suggestion.new",
  "    if ((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "        suggestion.replaceToken(sym)with(\"->\")",
  "    } else {",
  "        suggestion.insert(\" ->\")afterToken(lastToken)",
  "    }",
  "    errormessages.syntaxError(\"in a block with parameters, the parameters must be followed by '->'\")",
  "        atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "}",
  "",
  "method reportBadRhs {",
  "    // a bind symbol := was not followed by a valid expression.",
  "",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a valid expression must follow ':='.\")",
  "        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "}",
  "",
  "method block {",
  "    // Parses a block.  Since a block is (a) treated as a statement, and",
  "    // (b) may have statements inside, we save and restore the setting of the",
  "    // global variables relevant to the statement context.",
  "",
  "    if (accept \"lbrace\") then {",
  "        def btok = sym",
  "        next",
  "        def oldMinIndent = minIndentLevel",
  "        def minInd = statementIndent + 2",
  "        def oldStatementToken = statementToken",
  "        def oldStatementIndent = statementIndent",
  "        statementToken := sym",
  "        var isMatchingBlock := false",
  "",
  "        // a block may start with or without parameters.  We assume that",
  "        // parameters are present, parse the first expression, and then check.",
  "        // If it wasn't a parameter, we back-up the parse position.",
  "        def savedPosition = saveParsePosition",
  "        def params = blockParameters",
  "        if (params.isEmpty) then {",
  "            restoreParsePosition(savedPosition)",
  "        }",
  "",
  "        def blockNode = blockBody (params) beginningWith (btok)",
  "        values.push(blockNode)",
  "        minIndentLevel := oldMinIndent",
  "        statementIndent := oldStatementIndent",
  "        statementToken := oldStatementToken",
  "    }",
  "}",
  "",
  "method blockParameters {",
  "    // parse all the parameters of this block, and return them as a",
  "    // collection of identifier nodes.",
  "    def params = [ ]",
  "    while {blockParameter(params)} do {",
  "        if (accept \"arrow\") then {",
  "            next",
  "            return params",
  "        }",
  "        if (accept \"comma\") then {",
  "            next",
  "        } else {",
  "            reportMissingArrow",
  "        }",
  "    }",
  "    return params",
  "}",
  "",
  "method blockParameter(params) -> Boolean {",
  "    // parse one parameter, if possible, push it onto params, and",
  "    // return true. If the next expression is not a parameter, return false.",
  "",
  "    var paramIsPattern := sym.kind == \"lparen\"",
  "    // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "    // Checking for a paren lets us distinguish parameter from pattern.",
  "    if (didConsume {expression(blocksOK)}) then {",
  "        if (accept \"comma\" || accept \"arrow\" || accept \"colon\") then {",
  "            // we have found a parameter",
  "            var thisParam := values.pop",
  "            if (paramIsPattern || thisParam.isIdentifier.not) then {",
  "                paramIsPattern := true",
  "                thisParam := ast.identifierNode.wildcard(thisParam)",
  "                    // put the pattern in the type field",
  "            }",
  "            thisParam.isBindingOccurrence := true",
  "            if (paramIsPattern && accept \"colon\") then {",
  "                reportSyntaxError(\"a block parameter that's an  expression is assumed to mean \" ++",
  "                      \"_:‹expression›, and so cannot be followed by a colon\")",
  "                      before [\"arrow\", \"comma\"]",
  "            }",
  "            if (accept \"colon\") then {",
  "                // We allow an expression for v: <PatternExpression>",
  "                next",
  "                if (didConsume {expression(blocksOK)} .not) then {",
  "                    reportSyntaxError \"a block parameter must have a pattern or type expression after the ':'.\" before [\"arrow\", \"rbrace\"]",
  "                }",
  "                thisParam.dtype := values.pop",
  "            }",
  "            params.push(thisParam)",
  "            return true",
  "        } else {",
  "            // we just parsed the first expression in the block",
  "            return false",
  "        }",
  "    } else {",
  "        return false    // we didn't parse anything",
  "    }",
  "}",
  "",
  "method blockBody(params) beginningWith (btok) {",
  "    // returns a block AST node.",
  "",
  "    def originalValues = values",
  "    values := []",
  "    if (sym.line == lastToken.line) then {",
  "        indentFreePass := true",
  "    }",
  "    while {accept \"rbrace\".not} do {",
  "        // Take the body of the block",
  "        if (didNotConsume {statement}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert \"}\" afterToken (lastToken)",
  "            errormessages.syntaxError \"a block must end with a '}'.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "    }",
  "    next",
  "    def body = values",
  "    values := originalValues",
  "    return ast.blockNode.new(params, body).setPositionFrom(btok)",
  "}",
  "",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        def opener = if ((sym.kind == \"lparen\") || {sym.kind == \"lbrace\"})",
  "                        then { sym.value } else { \"-missing-\" }",
  "        def closer = if (opener == \"(\") then { \")\" }",
  "                        else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "        if (opener == \"-missing-\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" («condition») then \\{\")afterToken(btok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif { nextTok.kind == \"lbrace\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" («condition») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have a condition \" ++",
  "                \"in parentheses or braces after the 'if'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didNotConsume {expression(blocksOK)}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if (false == nextTok) then {",
  "                nextTok := findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a \" ++",
  "                      \"condition in parentheses or braces after the 'if'.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestion(suggestion)",
  "            } else {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atPosition(sym.line, sym.linePos)",
  "                        withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atRange(sym.line, sym.linePos, nextTok.linePos - 1)",
  "                        withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.value != closer) then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a \"++",
  "                  \"'{opener}' must end with a '{closer}'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 2",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if (sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if (didNotConsume {statement}) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"an if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if (false == nextTok) then {",
  "                        suggestion.insert(\" \\{ «expression» \\} then \\{\")afterToken(statementToken)",
  "                    } elseif { nextTok.kind == \"rbrace\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\}\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                        }",
  "                    } elseif { nextTok.kind == \"lbrace\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\" \\{ «expression» \\} then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\} then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif { nextTok.kind == \"identifier\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\} \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\}\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a \" ++",
  "                          \"condition in braces after the 'elseif'.\")",
  "                          atPosition(sym.line, sym.linePos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        (t.kind == \"rbrace\")})",
  "                    if (false == nextTok) then {",
  "                        nextTok := findNextValidToken( [\"rbrace\"] )",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"«expression» \\} then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression» \\} then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"an elseif statement must have an expression in braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"an elseif statement must have an expression in braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"(4) an elseif statement must have an expression in braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if (sym.value != \"\\}\") then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a condition beginning with a \" ++",
  "                        \"'\\{' must end with a '\\}'.\")",
  "                        atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if (sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have 'then' after the expression in braces.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if (didNotConsume {statement}) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if (didNotConsume {statement}) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (sym.kind == \"eof\") then {",
  "                                errormessages.syntaxError(\"end of program \" ++",
  "                                    \"found while searching for the '}' to close \" ++",
  "                                      \"an 'else' statement.\")",
  "                                        atPosition(sym.line, sym.linePos)",
  "                            }",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if (sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have 'then' after \" ++",
  "                  \"the condition in parentheses.\")",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept \"identifier\") then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    def startIndent = minIndentLevel",
  "    if (accept \"op\") then {",
  "        var op := sym.value",
  "        next",
  "        if (accept \"lparen\") then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (didNotConsume {term}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if (lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        def rcvr = values.pop",
  "        def call = ast.callNode.new(rcvr,",
  "            [ ast.requestPart.request(\"prefix\" ++ op) withArgs( [] ) ] )",
  "        values.push(call)",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept \"lgeneric\") then {",
  "        def id = values.pop",
  "        def gens = [ ]",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if (sym.kind != \"identifier\") then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept \"comma\") then {",
  "                next",
  "            } else {",
  "                if (sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"a type containing a '⟦' must end with a '⟧'.\")",
  "                          atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                          withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"a type containing a '⟦' must end with a '⟧'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept \"identifier\" && {sym.value == \"try\"})) then {",
  "        return",
  "    }",
  "    def localmin = minIndentLevel",
  "    def tryTok = sym",
  "    next",
  "    if (accept \"lbrace\") then {",
  "        block",
  "    } else {",
  "        if (sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == tryTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" \\{}\")afterToken(tryTok)",
  "            } elseif { nextTok.kind == \"rbrace\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(tryTok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(tryTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_) statement must have \" ++",
  "                \"a block or an expression in parentheses after the 'try'.\")",
  "                atPosition(tryTok.line, tryTok.endPos + 1)",
  "                withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didNotConsume {expression(blocksOK)}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_) statement must have \" ++",
  "                \"a block or an expression in parentheses after the 'try'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_) statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(tryTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"a try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try(_)catch(_)…finally(_) statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_)…finally(_) statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(tryTok.line, tryTok.linePos)",
  "    values.push(ast.tryCatchNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if (sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif { nextTok.kind == \"rparen\" } then {",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif { nextTok.kind == \"identifier\" } then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (didNotConsume {expression(blocksOK)}) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"rparen\"] )",
  "        if (nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if (sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"num\") then {",
  "        pushnum",
  "    } elseif { accept \"string\" } then {",
  "        pushstring",
  "    } elseif { accept \"identifier\" && (sym.value == \"match\") } then {",
  "        matchcase",
  "    } elseif { accept(\"identifier\") && (sym.value == \"try\") } then {",
  "        trycatch",
  "    } elseif { accept \"identifier\" } then {",
  "        identifier",
  "    } elseif { acceptKeyword \"object\" } then {",
  "        doobject",
  "    } elseif { acceptKeyword \"type\" } then {",
  "        dotypeLiteral",
  "    } elseif { accept \"lbrace\" } then {",
  "        block",
  "    } elseif { accept \"lsquare\" } then {",
  "        doarray",
  "    } elseif { accept \"op\" } then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"lparen\") then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if (didConsume{expression(acceptBlocks)}.not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                      leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif { o == \"/\" } then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept \"op\") then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parameterised so that it",
  "    // can be used for both type- and value- expressions.",
  "    ",
  "    def startIndent = minIndentLevel",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken) && ",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"an expression containing both arithmetic \" ++",
  "                  \"and non-arithmetic operators requires parentheses.\") atRange (",
  "                  lastToken.prev.prev.prev.line, lastToken.prev.prev.prev.linePos,",
  "                  lastToken.linePos) withSuggestions (suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept \"lparen\") then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if (didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (! tokenOnLineOfLastOr(statementToken)) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines.at(sym.line))afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if (didNotConsume {term}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"comma\", \"rparen\", \"rsquare\", \"rbrace\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "    minIndentLevel := startIndent",
  "}",
  "",
  "method dotrest(acceptBlocks) {",
  "    // Accept a method request starting with \".\". The receiver of the request",
  "    // is assumed to be on the values stack, and will be replaced by a",
  "    // memberNode representing this request, consuming the dot and all the",
  "    // parts of a following method name and its arguments.   Any following",
  "    // dotted requests will also be parsed, by recursive invocations.",
  "",
  "    if (acceptSameLine(\"dot\")) then {",
  "        def startIndent = minIndentLevel",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept \"identifier\") then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            def dro = ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept \"dot\") then {",
  "                dotrest(acceptBlocks)",
  "            } elseif { accept \"lgeneric\" } then {",
  "                dro.generics := typeArgs",
  "            }",
  "            if (accept \"lparen\" || (acceptBlocks && accept \"lbrace\") ||",
  "                  accept \"num\" || accept \"string\" || accept \"lsquare\") then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method callrest(acceptBlocks) {",
  "    // Accept a method request with arguments, if they are present.",
  "    // Method requests without arguments are left as \"member\" AST nodes",
  "",
  "    // The top of the values stack may be an identifierNode, which will become",
  "    // the method name of an implicit request, or a memberNode, whose receiver",
  "    // will become the receiver of the parsed call, and whose and nameString",
  "    // will become the first part-name of the method name.  It may also",
  "    // be some other expression (such as a literal), in which case there",
  "    // can be no arguments, and there is nothing to do.",
  "    // Leaves the stack depth unchanged.",
  "",
  "    if (values.size == 0) then {",
  "        return",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.nameString",
  "    def argumentParts = []",
  "    def part = ast.requestPart.request(methn) withArgs [].setPositionFrom(meth)",
  "    argumentParts.push(part)",
  "    var foundArgs := false",
  "    var tok := lastToken",
  "    var genericIdents := false",
  "    def g = meth.generics",
  "        // when used to parse a value expression, generic arguments have already",
  "        // been parse and are in `meth`.  When used to parse a type expression,",
  "        // they are in the unparsed input.  This is probably a bug!",
  "    if (false == g) then {",
  "        if (acceptSameLine \"lgeneric\") then {",
  "            genericIdents := typeArgs",
  "        }",
  "    } else {",
  "        genericIdents := g",
  "    }",
  "    foundArgs := parseArgumentsFor(meth) into (part) acceptBlocks (acceptBlocks)",
  "    ",
  "    if (foundArgs) then {",
  "        def realRcvr = if (meth.isIdentifier) then {",
  "            ast.implicit.setPositionFrom(meth)",
  "        } else {",
  "            meth.receiver",
  "        }",
  "        meth := ast.callNode.new(realRcvr, argumentParts).setPositionFrom(realRcvr)",
  "",
  "        while {accept \"identifier\" onLineOfLastOr (statementToken)} do {",
  "            // parse more parts of a multi-part request",
  "            def argList = [ ]",
  "            def namePart = ast.requestPart.request(sym.value) withArgs(argList).setPositionFrom(sym)",
  "            next",
  "            def argsFound = parseArgumentsFor(meth) into (namePart) acceptBlocks (acceptBlocks)",
  "            if (argsFound.not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert \"(‹expression›)\" afterToken (lastToken)",
  "                def more = if (indentHasIncreased) then {",
  "                    \"  The indentation tells me that this is a continuation of\" ++",
  "                        \" the previous line; is that what you intended?\"",
  "                } else { \"\" }",
  "                def reqStart = ast.line (lnum) column (lpos)",
  "                def reqEnd = ast.line (lastToken.line) column (lastToken.endPos)",
  "                def reqRange = ast.start (reqStart) end (reqEnd)",
  "                errormessages.syntaxError(\"a multi-part method request must end with an argument list,\" ++",
  "                    \" either parenthesized or self-delimiting.\" ++ more)",
  "                        atRange(reqRange) withSuggestion (suggestion)",
  "            }",
  "            argumentParts.addLast(namePart)",
  "        }",
  "    }",
  "    meth.generics := genericIdents",
  "    values.push(meth)",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parseArgumentsFor(meth) into (part) acceptBlocks (acceptBlocks) {",
  "    // `meth` is a memberNode or an identifier.",
  "    // Parses the arguments for `part`, a requestPart of a method request.",
  "    // If arguments are present, adds them to `part.args` and answers true.",
  "    // Answers false if no arguments are present.",
  "",
  "",
  "    var tok := lastToken",
  "    if (acceptSameLine \"lparen\") then {",
  "        tok := sym",
  "        parenthesizedArgs(part) startingWith (tok)",
  "        true",
  "    } elseif { acceptBlocks.not && { accept \"lbrace\" onLineOf (statementToken) } } then {",
  "        false",
  "    } elseif { acceptArgumentOnLineOf (tok) } then {",
  "        tok := sym",
  "        term",
  "        part.args.push(values.pop)",
  "        true",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parenthesizedArgs(part) startingWith (tok) {",
  "    next",
  "    if (didConsume {expression(blocksOK)}) then {",
  "        while {accept \"comma\"} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert \" «expression»\" afterToken (lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading (true) trailing (false) with \" «expression»\"",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"an argument list must have an expression after a ','.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestions(suggestions)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if (sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        def rng = ast.start (ast.line (tok.line) column (tok.linePos))",
  "                        end (ast.line (lastToken.line) column (lastToken.linePos + lastToken.size))",
  "        errormessages.syntaxError \"an argument list beginning with a '(' must end with a ')'.\"",
  "              atRange (rng) withSuggestion (suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parses one or more type arguments, if present, and returns them as a list.",
  "",
  "    def args = [ ]",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    def startToken = sym",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if (sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert \"⟦\" afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert \" \" beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError \"a method request containing a '⟦' must have a matching '⟧'. \"",
  "              atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "              withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leaves it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        }",
  "    } else {",
  "        dotypeLiteral",
  "    }",
  "}",
  "",
  "method errorDefNoName {",
  "    def suggestion = errormessages.suggestion.new",
  "    def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "        && (t.value == \"=\") && (t.line == sym.line)})",
  "    if (false == nextToken) then {",
  "        suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "    } elseif { nextToken == sym } then {",
  "        suggestion.insert(\" «name»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextToken.prev)",
  "              leading(false)trailing(true)with(\"«name» \")",
  "    }",
  "    errormessages.syntaxError(\"a definition must have a name, '=', \" ++",
  "          \"and a value after the 'def'.\") atPosition(sym.line, sym.linePos)",
  "          withSuggestion(suggestion)",
  "}",
  "",
  "method errorDefNoExpression {",
  "    def suggestion = errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [ ] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)",
  "              leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    errormessages.syntaxError(\"a definition must have a value after the '='.\")",
  "          atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "          withSuggestion(suggestion)",
  "}",
  "",
  "method errorDefUsesAssign(defTok) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(sym)with(\"=\")",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(defTok)with(\"var\")",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a definition must use '=' instead of ':='. \" ++",
  "        \"A variable declaration uses 'var' and ':='.\")atRange(",
  "        sym.line, sym.linePos, sym.linePos + 1) withSuggestions(suggestions)",
  "}",
  "",
  "method errorDefMissingRhs(defTok) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(defTok)with(\"var\")",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a definition must have '=' and a value after the name. \"",
  "        ++ \"A variable declaration does not require a value but uses 'var', not 'def'.\")",
  "        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "}",
  "",
  "method defdec {",
  "    // Accept definition of a constant",
  "",
  "    if (acceptKeyword \"def\") then {",
  "        def startIndent = minIndentLevel",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            errorDefNoName",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                errorDefNoExpression",
  "            }",
  "            val := values.pop",
  "        } elseif { accept \"bind\" } then {",
  "            errorDefUsesAssign(defTok)",
  "        } else {",
  "            errorDefMissingRhs(defTok)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method vardec {",
  "    // Accept a var declaration",
  "",
  "    if (acceptKeyword \"var\") then {",
  "        def startIndent = minIndentLevel",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if ((false == nextToken) || {nextToken == sym}) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError \"a variable declaration must have a name after the 'var'.\"",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept \"bind\") then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method doarray {",
  "    // Accept a square-bracketed collection literal like [1,2,3].",
  "",
  "    if (accept \"lsquare\") then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        if (didConsume {expression(blocksOK)}) then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rsquare\"] )",
  "                    if (nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a collection must contain zero or more expressions separated by commas.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if (sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a collection beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "method dodialect {",
  "    // Parses \"dialect «quoted-string»\"",
  "",
  "    if (acceptKeyword \"dialect\") then {",
  "        next",
  "        if (sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"a dialect statement must have the name \" ++",
  "                \"of the dialect in quotes after the word 'dialect'.\")",
  "                atPosition(lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        if (values.isEmpty) then {",
  "            def dn = ast.dialectNode.fromToken(sym)",
  "            next",
  "            moduleObject.theDialect := dn",
  "        } else {",
  "            util.log 50 verbose \"values = {values}\"",
  "            errormessages.syntaxError(\"a dialect statement must be at the start of the module.\")",
  "                  atLine(lastToken.line)",
  "        }",
  "    }",
  "}",
  "",
  "method inheritOrUse {",
  "    // Parses \"inherit «object expression»\"",
  "",
  "    if (! accept \"keyword\") then { return }",
  "    if ((sym.value == \"inherit\") || (sym.value == \"use\")) then {",
  "        statementToken := sym",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if (didNotConsume {expression(noBlocks)}) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            var msg := \"The {btok.value} keyword must be followed by an expression that creates \"",
  "            if (btok.value == \"use\") then {",
  "                msg := msg ++ \"the trait being used.\"",
  "            } else {",
  "                msg := msg ++ \"the object being inherited.\"",
  "            }",
  "            errormessages.syntaxError(msg)",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritNode.new(values.pop)",
  "        if (btok.value == \"use\") then {",
  "            inhNode.isUse := true",
  "        }",
  "        while { inheritModifier(inhNode) onLineOf(btok) } do { }",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "method inheritModifier(node) onLineOf(startToken) {",
  "    // parse an alias or exclude modifier on an `inherit` clause",
  "    if (! accept \"keyword\" onLineOf(startToken) ) then { ",
  "        return false",
  "    }",
  "    if (sym.value == \"alias\") then { ",
  "        parseAlias(node) ",
  "    } elseif {sym.value == \"exclude\"} then {",
  "        parseExclude(node)",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parseAlias(node) {",
  "    next    // skip the alias keyword",
  "    def newMeth = methodsignature(true)",
  "    if (accept \"op\" && (sym.value == \"=\")) then {",
  "        next",
  "        def oldMeth = methodsignature(true).appliedOccurence",
  "        if (newMeth.numParams ≠ oldMeth.numParams) then {",
  "            errormessages.syntaxError \"a method and its alias must have the same number of parameters\"",
  "                atRange (newMeth.line, newMeth.linePos, oldMeth.endPos)",
  "        }",
  "        node.addAlias (newMeth.asIdentifier) for (oldMeth.asIdentifier)",
  "    } else {",
  "        errormessages.syntaxError (\"an alias modifier must take the form \" ++",
  "            \"'‹newMethodName› = ‹oldMethodName›'\")",
  "            atPosition (lastToken.line, lastToken.linePos + lastToken.size)",
  "    }",
  "    return true",
  "}",
  "method parseExclude(node) {",
  "    next    // skip the exclude keyword",
  "    def excludedMeth = methodsignature(true).appliedOccurence",
  "    node.addExclusion (excludedMeth.asIdentifier)",
  "    return true",
  "}",
  "",
  "method doobject {",
  "    // Parse an object constructor.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (acceptKeyword \"object\") then {",
  "        next",
  "        parseObjectConstructorBody \"an object constructor\" ",
  "            startingWith (lastToken) after \"'object'\"",
  "    }",
  "}",
  "",
  "method parseObjectConstructorBody(constructName) startingWith (btok) after (prev) {",
  "    // Parse the body of an object constructor, leaving the node on the",
  "    // values stack.  Common code for parsing object, class, and factory method",
  "    // bodies; constructName says which, so that error messages are correct.",
  "    // btok is the keyword token that started the construct: class, object, or trait.",
  "    def localMinIndentLevel = minIndentLevel",
  "    def anns = doannotation",
  "    if (sym.kind != \"lbrace\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextToken { t -> t.kind == \"rbrace\" }",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "        }",
  "        errormessages.syntaxError \"{constructName} must have a '\\{' after the {prev}.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (sym.line == statementToken.line) then {",
  "        minIndentLevel := sym.linePos - 2",
  "    } else {",
  "        minIndentLevel := statementToken.indent + 2",
  "    }",
  "    def originalValues = values",
  "    values := []",
  "    var superObject := false",
  "    def usedTraits = []",
  "    var inPreamble := true  // => processing inherit and use statements",
  "    while {(accept(\"rbrace\")).not && {sym.kind != \"eof\"}} do {",
  "        pushComments",
  "        if (didConsume {inheritOrUse}) then {",
  "            def parentNode = values.pop",
  "            if (inPreamble) then {",
  "                if (parentNode.isUse) then {",
  "                    usedTraits.add(parentNode)",
  "                } elseif { usedTraits.isEmpty } then {",
  "                    superObject := parentNode",
  "                } else {",
  "                    errormessages.syntaxError(\"'inherit' must come \" ++",
  "                        \"before 'use' in {constructName}\")",
  "                        atRange(parentNode.line, parentNode.linePos,",
  "                        parentNode.linePos + 7)",
  "                }",
  "            } else {",
  "                errormessages.syntaxError(\"'{parentNode.statementName}' must \" ++",
  "                    \"come at the start of {constructName}\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                            parentNode.linePos + parentNode.statementName.size)",
  "            }",
  "        } elseif { didConsume {methoddec} } then {",
  "            inPreamble := false",
  "        } elseif { didConsume {statement} } then {",
  "            inPreamble := false",
  "        } else {",
  "            errormessages.syntaxError(\"unexpected symbol '{sym.value}' in body \" ++",
  "                \"of of {constructName}\")",
  "                atRange(sym.line, sym.linePos, sym.endPos)",
  "        }",
  "    }",
  "    def body = values",
  "    values := originalValues",
  "    next",
  "    def objNode = ast.objectNode.new(body, superObject).setPositionFrom(btok)",
  "    if (false != anns) then { objNode.annotations.addAll(anns) }",
  "    objNode.usedTraits := usedTraits",
  "    values.push(objNode)",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method doclass {",
  "    // Accepts a class declaration with or without a `dot`",
  "    // Class declarations were formerly of the form:",
  "    //",
  "    //   class objName.methodName (param1, param2) {",
  "    //     inherit <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // Now they are of the form:",
  "    //",
  "    // class methodName (param1, param2) {",
  "    //     inherit <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // The old \"dotted\" form is compiled into a defDecNode that contains",
  "    // an objectNode that contains the class method and an asString method.",
  "    // The current form is compiled into a methodNode that contains",
  "    // an objectNode, i.e., it is treated as syntactic sugar for",
  "    //",
  "    // method methodName (param1, param2) {",
  "    //     object {",
  "    //         inherit <expr>",
  "    //         var x",
  "    //         method y(z) { ... }",
  "    //     }",
  "    // }",
  "",
  "    def btok = sym",
  "    next",
  "    def localMinIndentLevel = minIndentLevel",
  "    if (sym.kind != \"identifier\") then {",
  "        def suggestions = [ ]",
  "        if (sym.kind == \"lbrace\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(lastToken)with(\"object\")",
  "            suggestions.push(suggestion)",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"a class must have a name after the 'class'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    var objName := false",
  "    if (tokens.first.kind == \"dot\") then {",
  "        pushidentifier // the name of the class object",
  "        objName := values.pop",
  "        objName.isBindingOccurrence := true",
  "        next    // skip over the dot",
  "    }",
  "    def meth = methodsignature(false)",
  "    meth.setPositionFrom(btok)",
  "    parseObjectConstructorBody \"a class\" startingWith (btok) after \"method header\"",
  "    def objNode = values.pop",
  "    meth.body := [objNode]",
  "    meth.usesClassSyntax := true",
  "    meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "    // see comment in dofactoryMethod",
  "    if (false != objName) then {   // deal with (deprecated) dotted class",
  "        util.setPosition(btok.line, btok.linePos)",
  "        objNode.name := objName.nameString ++ \".\" ++ meth.canonicalName",
  "        def asStringBody = [ ast.stringNode.new(\"class {objName.nameString}\") ]",
  "        def signature = [ ast.signaturePart.partName \"asString\" ]",
  "        def asStringMeth = ast.methodNode.new(signature, asStringBody, false)",
  "        def metaBody = [meth, asStringMeth]",
  "        def metaObj = ast.objectNode.body (metaBody) named \"class {objName.nameString}\"",
  "        def defDec = ast.defDecNode.new(objName, metaObj, ast.unknownType)",
  "        defDec.startToken := btok",
  "        defDec.annotations.add(ast.identifierNode.new(\"public\", false))",
  "        values.push(defDec)",
  "    } else {",
  "        objNode.name := meth.canonicalName",
  "        if (btok.value == \"class\") then {",
  "            objNode.inClass := true",
  "        } elseif { btok.value == \"trait\" } then {",
  "            objNode.inTrait := true",
  "        }",
  "        values.push(meth)",
  "    }",
  "    reconcileComments",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method dofactoryMethod {",
  "    // Accept a factory method declaration",
  "    if ((acceptKeyword \"factory\") && {",
  "            tokens.first.kind == \"keyword\"} && {",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestions = [ ]",
  "            if (sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError \"a factory method must have a name after the 'method'.\"",
  "                atPosition (lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions (suggestions)",
  "        }",
  "        var meth := methodsignature(false)",
  "        parseObjectConstructorBody \"a factory method\" startingWith (btok) after \"method header\"",
  "        def objNode = values.pop",
  "        objNode.name := meth.nameString",
  "        util.setPosition(btok.line, btok.linePos)",
  "        meth.body := [objNode]",
  "        meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "        // In a class or factory method declaration, there is just one place",
  "        // for annotations.  These might include annotations on the method (such",
  "        // as confidential), and annotations on the object (such as imutable)",
  "        values.push(meth)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "method methoddec {",
  "    // Parse a method declaration",
  "",
  "    if (acceptKeyword \"method\") then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        next",
  "        def methNode = methodsignature(false).setPositionFrom(btok)",
  "        var localMin",
  "        def anns = doannotation",
  "        def originalValues = values",
  "        values := []",
  "        if (accept \"lbrace\") then {",
  "            next",
  "            localMin := minIndentLevel",
  "            // sym is now the first token in the method body",
  "            if (sym.line == btok.line) then {",
  "                // first statement is on the same line as `method` keyword",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := btok.indent + 2",
  "            }",
  "            while { didConsume { statement } } do { }",
  "                // The body is a sequence of statements; the method ends",
  "                // when no further statement is found.",
  "            if (sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if (closingBrace.found.not) then {",
  "                    if (sym.kind == \"eof\") then {",
  "                        errormessages.syntaxError(\"end of program \" ++",
  "                            \"found while searching for the '}' to close \" ++",
  "                              \"a method declaration.\")",
  "                                atPosition(sym.line, sym.linePos)",
  "                    }",
  "                    if (closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"a method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if (closingBrace.found.not) then {",
  "                if (closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"a method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        methNode.body := values",
  "        values := originalValues",
  "        util.setline(btok.line)",
  "        if (false != anns) then { methNode.annotations.addAll(anns) }",
  "        values.push(methNode)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "",
  "method methodDecRest(tm, sameline) {",
  "    // Process the remainder of a method header. These follow",
  "    // mostly the same rules as calls, but aren't strictly enforced to be on",
  "    // a single line (because they are ended by \"{\"). ",
  "    //",
  "    // tm is a methodNode.  This method modifies tm.params in place.",
  "",
  "    var signature := tm.signature",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        pushidentifier",
  "        def part = ast.signaturePart.partName(values.pop.nameString)",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"the declaration of a method with multiple \" ++",
  "                  \"parameter lists must have parentheses around each parameter list.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            def nxt = values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            part.params.push(nxt)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept \"colon\") then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if ((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method name must start with an identifier, or be an operator.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestion(suggestion)",
  "    }",
  "    def startToken = sym",
  "    def part = ast.signaturePart.partName(startToken.value)",
  "    next",
  "    def result = ast.methodNode.new( [ part ], [], false)",
  "    if ((startToken.value == \"[\") && {sym.kind == \"rsquare\"}) then {",
  "        errormessages.syntaxError(\"methods named '[]' and '[]:=' are no longer part of Grace.\")",
  "            atRange(lastToken.line, lastToken.linePos, sym.linePos)",
  "    }",
  "    if (accept \"lgeneric\") then { result.typeParams := typeparameters }",
  "    if (accept \"bind\") then {",
  "        part.name := part.name ++ \":=\"",
  "        next",
  "    } elseif { accept \"op\"  && (startToken.value == \"prefix\") } then {",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    if (accept \"lparen\") then {",
  "        def lparen = sym",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            id.dtype := optionalTypeAnnotation",
  "            part.params.push(id)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            } elseif { sym.kind != \"rparen\" } then {",
  "                if (sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if (false == rparen) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            methodDecRest(result, sameline)",
  "        }",
  "    }",
  "    if (accept \"arrow\") then {",
  "        // parse the return type",
  "        next",
  "        if (didNotConsume {typeexpression} ) then {",
  "            errormessages.syntaxError(\"after an arrow, write the method's return \" ++",
  "                  \"type. If you don't want to state the return type, omit the arrow.\")",
  "                  atRange(sym.line, sym.linePos, sym.endPos)",
  "        }",
  "        result.dtype := values.pop",
  "    }",
  "    result",
  "}",
  "",
  "method typeparameters {",
  "    next",
  "    def typeIds = [ ]",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept \"comma\") then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    def result = ast.typeParametersNode.new(typeIds)",
  "    if (sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a list of type parameters starting with '⟦' must end with '⟧'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    result",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (acceptKeyword \"import\") then {",
  "        def importSym = sym",
  "        next",
  "        if (sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if ((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def o = ast.importNode.new(p.value, name, dtype).setPositionFrom(importSym)",
  "        def anns = doannotation",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (acceptKeyword \"return\") then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine) && {accept(\"rbrace\").not}) then {",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError (\"a return statement must have \" ++",
  "                    \"an expression or a newline after the word 'return'.\")",
  "                    atRange (sym.line, sym.linePos, sym.endPos)",
  "                    withSuggestions (suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false).setStart(ast.noPosition)",
  "            retval.end := ast.noPosition",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var methNode := methodsignature(true)",
  "    var dtype := methNode.dtype",
  "    if (false == methNode.dtype) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    def o = ast.methodTypeNode.new(methNode.signature, dtype)",
  "                                            .setPositionFrom(methodTypeTok)",
  "    o.typeParams := methNode.typeParams",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept \"semicolon\") then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines.at(sym.line).substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    def typeLiteralTok = sym",
  "    if (acceptKeyword \"type\") then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept \"lbrace\") then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (acceptKeyword \"type\") then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (acceptKeyword \"type\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept \"lgeneric\") then { nt.typeParams := typeparameters }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if ((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if ((false == nextTok) || {nextTok == sym}) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError \"a type declaration must have an '=' after the type name.\"",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept \"lbrace\") then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif { sym.kind == \"semicolon\" } then {",
  "        // pass",
  "    } elseif {(sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "          || (sym.kind == \"rsquare\")} then {",
  "        // pass",
  "    } elseif { sym.kind == \"eof\" } then {",
  "    } elseif { sym.indent < minIndentLevel } then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def correctIndent = \" \" * (minIndentLevel - (sym.linePos - 1))",
  "            suggestion.insert (correctIndent) atPosition 1 onLine(sym.line)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { ",
  "                tok := tok.prev ",
  "            }",
  "            def line = (\" \" * tok.indent) ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"the indentation for this line must be \" ++",
  "                  \"at least {minIndentLevel}. This is often caused by a missing '}'.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif { sym.indent > minIndentLevel } then {",
  "        // The lexer rejects indentation changes of 1, so we don't",
  "        // need to check for that error here.",
  "        minIndentLevel := sym.indent",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    pushComments",
  "    checkIndent",
  "    if (accept \"keyword\") then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif { sym.value == \"def\" } then {",
  "            defdec",
  "        } elseif { sym.value == \"import\" } then {",
  "            doimport",
  "        } elseif { sym.value == \"dialect\" } then {",
  "            dodialect",
  "        } elseif { sym.value == \"type\" } then {",
  "            typedec",
  "        } elseif { sym.value == \"class\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"trait\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"factory\" } then {",
  "            dofactoryMethod",
  "        } elseif { sym.value == \"return\" } then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        if (didConsume {expression(blocksOK)}) then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                if (dest.kind == \"lbrace\") then {",
  "                    print \"sym = {sym}, sym.line = {sym.line}\"",
  "                    ProgrammingError.raise \"popped lbrace token while parsing statement\"",
  "                }",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    reportBadRhs",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept \"eof\") then {",
  "        return true",
  "    }",
  "    if (accept \"semicolon\") then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushComments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, removes them from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushComments",
  "    def node = if (values.isEmpty) then {",
  "        moduleObject ",
  "    } else {",
  "        values.last",
  "    }",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes are not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = emptyList",
  "    def postComments = emptyList",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = [ ]",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = [ ]",
  "            var suggestion",
  "            if ( (values.size > 0) && { (values.last.kind == \"identifier\") || { values.last.kind == \"member\" }} && { sym.kind == \"identifier\" } ) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken( [\"rbrace\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines.at(lastToken.line).substringFrom(1)to(lastToken.endPos))",
  "                def newLine = util.lines.at(sym.line).substringFrom(sym.linePos)to(util.lines.at(sym.line).size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(",
  "                \"multiple statements must be separated by a newline or a semicolon. \" ++",
  "                  \"This error is often caused by unbalanced parentheses, \" ++",
  "                    \"or by omitting a part of a method name.\")",
  "                      atPosition (sym.line, sym.linePos) withSuggestions (suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parses toks, a linked list of tokens, and returns an AST moduleNode",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "    moduleObject := ast.moduleNode.body(values) named (util.modname)",
  "",
  "    if (toks.size == 0) then {",
  "        return moduleObject",
  "    }",
  "    tokens := toks",
  "    next",
  "",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError \"the first line must not be indented.\"",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        pushComments",
  "        methoddec",
  "        pushComments",
  "        if (didConsume { inheritOrUse }) then {",
  "            def parentNode = values.pop",
  "            if (parentNode.isUse) then {",
  "                moduleObject.usedTraits.add(parentNode)",
  "            } elseif { moduleObject.usedTraits.isEmpty } then {",
  "                moduleObject.superclass := parentNode",
  "            } else {",
  "                errormessages.syntaxError(\"'inherit' must come \" ++",
  "                    \"before 'use' in a module.\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                    parentNode.linePos + 6)",
  "            }",
  "        }",
  "        statement",
  "        pushComments",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError (\"invalid statement. This is often \" ++",
  "                \"caused by an extra '}', ')', or ']'.\")",
  "                atRange (sym.line, sym.linePos, sym.endPos)",
  "                withSuggestion (suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    statement",
  "    pushComments",
  "    return moduleObject",
  "}",
  NULL
};
Object reader_parser_outer_307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9776(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_9777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_9778(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_9779(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_9780(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_9781(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_9782(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit29;
static Object strlit31;
static Object strlit65;
static Object strlit73;
static Object strlit112;
static Object strlit182;
static Object strlit230;
static Object strlit263;
static Object strlit264;
static Object strlit265;
static Object strlit266;
static Object strlit267;
static Object strlit268;
static Object strlit269;
static Object strlit270;
static Object strlit276;
static ClassData objclass306;
static Object strlit323;
static Object strlit334;
static Object strlit346;
static Object strlit374;
static Object strlit385;
static Object strlit397;
static Object strlit414;
static Object strlit431;
static Object strlit462;
static Object strlit594;
static Object strlit599;
static Object strlit604;
static Object strlit609;
static Object strlit614;
static Object strlit618;
static Object strlit625;
static Object strlit739;
static Object strlit763;
static Object strlit791;
static Object strlit801;
static Object strlit825;
static Object strlit843;
static Object strlit864;
static Object strlit903;
static Object strlit910;
static Object strlit917;
static Object strlit935;
static Object strlit946;
static Object strlit956;
static Object strlit965;
static Object strlit984;
static Object strlit991;
static Object strlit998;
static Object strlit1001;
static Object strlit1009;
static Object strlit1021;
static Object strlit1024;
static Object strlit1077;
static Object strlit1084;
static Object strlit1115;
static Object strlit1122;
static Object strlit1129;
static Object strlit1132;
static Object strlit1135;
static Object strlit1149;
static Object strlit1156;
static Object strlit1163;
static Object strlit1181;
static Object strlit1190;
static Object strlit1228;
static Object strlit1234;
static Object strlit1244;
static Object strlit1260;
static Object strlit1265;
static Object strlit1269;
static Object strlit1296;
static Object strlit1302;
static Object strlit1304;
static Object strlit1307;
static Object strlit1308;
static Object strlit1312;
static Object strlit1327;
static Object strlit1329;
static Object strlit1330;
static Object strlit1359;
static Object strlit1378;
static Object strlit1381;
static Object strlit1402;
static Object strlit1409;
static Object strlit1419;
static Object strlit1427;
static Object strlit1435;
static Object strlit1438;
static Object strlit1441;
static Object strlit1444;
static Object strlit1447;
static Object strlit1448;
static Object strlit1451;
static Object strlit1465;
static Object strlit1472;
static Object strlit1481;
static Object strlit1489;
static Object strlit1496;
static Object strlit1521;
static Object strlit1525;
static Object strlit1535;
static Object strlit1538;
static Object strlit1542;
static Object strlit1552;
static Object strlit1555;
static Object strlit1558;
static Object strlit1565;
static Object strlit1575;
static Object strlit1578;
static Object strlit1581;
static Object strlit1588;
static Object strlit1590;
static Object strlit1616;
static Object strlit1639;
static Object strlit1647;
static Object strlit1654;
static Object strlit1658;
static Object strlit1660;
static Object strlit1672;
static Object strlit1676;
static Object strlit1678;
static Object strlit1690;
static Object strlit1694;
static Object strlit1696;
static Object strlit1722;
static Object strlit1727;
static Object strlit1732;
static Object strlit1736;
static Object strlit1742;
static Object strlit1767;
static Object strlit1774;
static Object strlit1781;
static Object strlit1807;
static Object strlit1818;
static Object strlit1823;
static Object strlit1828;
static Object strlit1831;
static Object strlit1865;
static Object strlit1898;
static Object strlit1909;
static Object strlit1914;
static Object strlit1934;
static Object strlit1941;
static Object strlit1952;
static Object strlit1968;
static Object strlit1975;
static Object strlit1984;
static Object strlit1991;
static Object strlit2015;
static Object strlit2019;
static Object strlit2029;
static Object strlit2032;
static Object strlit2036;
static Object strlit2046;
static Object strlit2049;
static Object strlit2052;
static Object strlit2059;
static Object strlit2069;
static Object strlit2072;
static Object strlit2075;
static Object strlit2082;
static Object strlit2084;
static Object strlit2110;
static Object strlit2133;
static Object strlit2141;
static Object strlit2148;
static Object strlit2151;
static Object strlit2162;
static Object strlit2165;
static Object strlit2176;
static Object strlit2179;
static Object strlit2193;
static Object strlit2205;
static Object strlit2209;
static Object strlit2211;
static Object strlit2231;
static Object strlit2238;
static Object strlit2251;
static Object strlit2273;
static Object strlit2278;
static Object strlit2289;
static Object strlit2294;
static Object strlit2311;
static Object strlit2314;
static Object strlit2325;
static Object strlit2328;
static Object strlit2331;
static Object strlit2339;
static Object strlit2365;
static Object strlit2376;
static Object strlit2381;
static Object strlit2386;
static Object strlit2389;
static Object strlit2423;
static Object strlit2456;
static Object strlit2467;
static Object strlit2472;
static Object strlit2500;
static Object strlit2507;
static Object strlit2514;
static Object strlit2540;
static Object strlit2551;
static Object strlit2556;
static Object strlit2561;
static Object strlit2564;
static Object strlit2598;
static Object strlit2626;
static Object strlit2633;
static Object strlit2636;
static Object strlit2638;
static Object strlit2653;
static Object strlit2664;
static Object strlit2669;
static Object strlit2700;
static Object strlit2722;
static Object strlit2727;
static Object strlit2738;
static Object strlit2743;
static Object strlit2760;
static Object strlit2763;
static Object strlit2774;
static Object strlit2777;
static Object strlit2781;
static Object strlit2783;
static Object strlit2795;
static Object strlit2799;
static Object strlit2811;
static Object strlit2819;
static Object strlit2837;
static Object strlit2844;
static Object strlit2851;
static Object strlit2854;
static Object strlit2862;
static Object strlit2874;
static Object strlit2877;
static Object strlit2905;
static Object strlit2912;
static Object strlit2919;
static Object strlit2925;
static Object strlit2952;
static Object strlit2974;
static Object strlit2989;
static Object strlit3000;
static Object strlit3011;
static Object strlit3022;
static Object strlit3033;
static Object strlit3047;
static Object strlit3087;
static Object strlit3093;
static Object strlit3103;
static Object strlit3110;
static Object strlit3114;
static Object strlit3129;
static Object strlit3139;
static Object strlit3146;
static Object strlit3150;
static Object strlit3176;
static Object strlit3184;
static Object strlit3192;
static Object strlit3198;
static Object strlit3213;
static Object strlit3220;
static Object strlit3238;
static Object strlit3246;
static Object strlit3261;
static Object strlit3265;
static Object strlit3271;
static Object strlit3275;
static Object strlit3285;
static Object strlit3289;
static Object strlit3294;
static Object strlit3300;
static Object strlit3303;
static Object strlit3307;
static Object strlit3309;
static Object strlit3336;
static Object strlit3343;
static Object strlit3350;
static Object strlit3354;
static Object strlit3356;
static Object strlit3365;
static Object strlit3377;
static Object strlit3380;
static Object strlit3402;
static Object strlit3409;
static Object strlit3419;
static Object strlit3425;
static Object strlit3443;
static Object strlit3450;
static Object strlit3457;
static Object strlit3460;
static Object strlit3468;
static Object strlit3480;
static Object strlit3483;
static Object strlit3509;
static Object strlit3514;
static Object strlit3523;
static Object strlit3533;
static Object strlit3538;
static Object strlit3543;
static Object strlit3548;
static Object strlit3563;
static Object strlit3570;
static Object strlit3578;
static Object strlit3582;
static Object strlit3585;
static Object strlit3587;
static Object strlit3604;
static Object strlit3611;
static Object strlit3618;
static Object strlit3624;
static Object strlit3642;
static Object strlit3649;
static Object strlit3656;
static Object strlit3659;
static Object strlit3667;
static Object strlit3679;
static Object strlit3682;
static Object strlit3708;
static Object strlit3713;
static Object strlit3722;
static Object strlit3732;
static Object strlit3737;
static Object strlit3742;
static Object strlit3747;
static Object strlit3774;
static Object strlit3781;
static Object strlit3790;
static Object strlit3805;
static Object strlit3812;
static Object strlit3829;
static Object strlit3844;
static Object strlit3848;
static Object strlit3858;
static Object strlit3861;
static Object strlit3865;
static Object strlit3871;
static Object strlit3874;
static Object strlit3880;
static Object strlit3907;
static Object strlit3914;
static Object strlit3921;
static Object strlit3924;
static Object strlit3934;
static Object strlit3946;
static Object strlit3949;
static Object strlit3968;
static Object strlit3975;
static Object strlit3985;
static Object strlit3991;
static Object strlit4009;
static Object strlit4016;
static Object strlit4023;
static Object strlit4026;
static Object strlit4034;
static Object strlit4046;
static Object strlit4049;
static Object strlit4075;
static Object strlit4080;
static Object strlit4089;
static Object strlit4099;
static Object strlit4104;
static Object strlit4109;
static Object strlit4114;
static Object strlit4148;
static Object strlit4154;
static Object strlit4161;
static Object strlit4168;
static Object strlit4176;
static Object strlit4183;
static Object strlit4190;
static Object strlit4196;
static Object strlit4202;
static Object strlit4208;
static Object strlit4214;
static Object strlit4220;
static Object strlit4235;
static Object strlit4262;
static Object strlit4269;
static Object strlit4276;
static Object strlit4279;
static Object strlit4287;
static Object strlit4299;
static Object strlit4302;
static Object strlit4333;
static Object strlit4339;
static Object strlit4360;
static Object strlit4363;
static Object strlit4373;
static Object strlit4376;
static Object strlit4392;
static Object strlit4400;
static Object strlit4408;
static Object strlit4430;
static Object strlit4436;
static Object strlit4442;
static Object strlit4447;
static Object strlit4466;
static Object strlit4477;
static Object strlit4480;
static Object strlit4492;
static Object strlit4497;
static Object strlit4509;
static Object strlit4511;
static Object strlit4581;
static Object strlit4596;
static Object strlit4604;
static Object strlit4608;
static Object strlit4618;
static Object strlit4622;
static Object strlit4628;
static Object strlit4632;
static Object strlit4642;
static Object strlit4654;
static Object strlit4657;
static Object strlit4693;
static Object strlit4697;
static Object strlit4717;
static Object strlit4728;
static Object strlit4734;
static Object strlit4762;
static Object strlit4763;
static Object strlit4764;
static Object strlit4765;
static Object strlit4773;
static Object strlit4777;
static Object strlit4787;
static Object strlit4791;
static Object strlit4812;
static Object strlit4819;
static Object strlit4823;
static Object strlit4898;
static Object strlit4908;
static Object strlit4922;
static Object strlit4942;
static Object strlit4948;
static Object strlit4957;
static Object strlit4962;
static Object strlit4967;
static Object strlit4973;
static Object strlit4979;
static Object strlit5002;
static Object strlit5007;
static Object strlit5026;
static Object strlit5033;
static Object strlit5067;
static Object strlit5097;
static Object strlit5123;
static Object strlit5129;
static Object strlit5131;
static Object strlit5133;
static Object strlit5148;
static Object strlit5150;
static Object strlit5167;
static Object strlit5178;
static Object strlit5215;
static Object strlit5243;
static Object strlit5250;
static Object strlit5257;
static Object strlit5275;
static Object strlit5291;
static Object strlit5303;
static Object strlit5325;
static Object strlit5350;
static Object strlit5376;
static Object strlit5387;
static Object strlit5397;
static Object strlit5404;
static Object strlit5408;
static Object strlit5424;
static Object strlit5430;
static Object strlit5466;
static Object strlit5473;
static Object strlit5488;
static Object strlit5495;
static Object strlit5502;
static Object strlit5506;
static Object strlit5508;
static Object strlit5528;
static Object strlit5535;
static Object strlit5538;
static Object strlit5556;
static Object strlit5566;
static Object strlit5572;
static Object strlit5574;
static Object strlit5594;
static Object strlit5604;
static Object strlit5610;
static Object strlit5612;
static Object strlit5622;
static Object strlit5632;
static Object strlit5654;
static Object strlit5661;
static Object strlit5681;
static Object strlit5716;
static Object strlit5726;
static Object strlit5748;
static Object strlit5771;
static Object strlit5778;
static Object strlit5781;
static Object strlit5801;
static Object strlit5826;
static Object strlit5833;
static Object strlit5852;
static Object strlit5854;
static Object strlit5872;
static Object strlit5879;
static Object strlit5888;
static Object strlit5898;
static Object strlit5903;
static Object strlit5934;
static Object strlit5951;
static Object strlit5978;
static Object strlit5985;
static Object strlit5992;
static Object strlit6010;
static Object strlit6025;
static Object strlit6035;
static Object strlit6038;
static Object strlit6060;
static Object strlit6066;
static Object strlit6086;
static Object strlit6094;
static Object strlit6100;
static Object strlit6108;
static Object strlit6124;
static Object strlit6126;
static Object strlit6145;
static Object strlit6149;
static Object strlit6154;
static Object strlit6162;
static Object strlit6168;
static Object strlit6175;
static Object strlit6201;
static Object strlit6208;
static Object strlit6215;
static Object strlit6233;
static Object strlit6239;
static Object strlit6244;
static Object strlit6250;
static Object strlit6255;
static Object strlit6288;
static Object strlit6312;
static Object strlit6318;
static Object strlit6327;
static Object strlit6344;
static Object strlit6351;
static Object strlit6370;
static Object strlit6386;
static Object strlit6388;
static Object strlit6417;
static Object strlit6422;
static Object strlit6423;
static Object strlit6430;
static Object strlit6443;
static Object strlit6456;
static Object strlit6459;
static Object strlit6463;
static Object strlit6468;
static Object strlit6472;
static Object strlit6523;
static Object strlit6532;
static Object strlit6564;
static Object strlit6568;
static Object strlit6572;
static Object strlit6588;
static Object strlit6592;
static Object strlit6597;
static Object strlit6603;
static Object strlit6644;
static Object strlit6648;
static Object strlit6653;
static Object strlit6659;
static Object strlit6700;
static Object strlit6708;
static Object strlit6718;
static Object strlit6728;
static Object strlit6737;
static Object strlit6742;
static Object strlit6760;
static Object strlit6783;
static Object strlit6784;
static Object strlit6817;
static Object strlit6827;
static Object strlit6833;
static Object strlit6841;
static Object strlit6853;
static Object strlit6859;
static Object strlit6875;
static Object strlit6891;
static Object strlit6901;
static Object strlit6920;
static Object strlit6933;
static Object strlit6943;
static Object strlit6953;
static Object strlit6961;
static Object strlit6971;
static Object strlit6981;
static Object strlit6990;
static Object strlit6995;
static Object strlit7014;
static Object strlit7015;
static Object strlit7046;
static Object strlit7064;
static Object strlit7108;
static Object strlit7127;
static Object strlit7134;
static Object strlit7137;
static Object strlit7139;
static Object strlit7154;
static Object strlit7165;
static Object strlit7170;
static Object strlit7198;
static Object strlit7210;
static Object strlit7213;
static Object strlit7217;
static Object strlit7221;
static Object strlit7260;
static Object strlit7265;
static Object strlit7288;
static Object strlit7296;
static Object strlit7300;
static Object strlit7302;
static Object strlit7318;
static Object strlit7325;
static Object strlit7330;
static Object strlit7338;
static Object strlit7344;
static Object strlit7350;
static Object strlit7375;
static Object strlit7384;
static Object strlit7394;
static Object strlit7397;
static Object strlit7417;
static Object strlit7439;
static Object strlit7455;
static Object strlit7466;
static Object strlit7474;
static Object strlit7481;
static Object strlit7493;
static Object strlit7496;
static Object strlit7531;
static Object strlit7539;
static Object strlit7546;
static Object strlit7556;
static Object strlit7564;
static Object strlit7568;
static Object strlit7579;
static Object strlit7586;
static Object strlit7602;
static Object strlit7613;
static Object strlit7620;
static Object strlit7625;
static Object strlit7633;
static Object strlit7639;
static Object strlit7645;
static Object strlit7671;
static Object strlit7678;
static Object strlit7685;
static Object strlit7695;
static Object strlit7698;
static Object strlit7713;
static Object strlit7735;
static Object strlit7749;
static Object strlit7754;
static Object strlit7784;
static Object strlit7789;
static Object strlit7800;
static Object strlit7814;
static Object strlit7816;
static Object strlit7837;
static Object strlit7853;
static Object strlit7873;
static Object strlit7883;
static Object strlit7886;
static Object strlit7902;
static Object strlit7908;
static Object strlit7928;
static Object strlit7936;
static Object strlit7942;
static Object strlit7950;
static Object strlit7965;
static Object strlit7976;
static Object strlit7983;
static Object strlit8004;
static Object strlit8011;
static Object strlit8015;
static Object strlit8021;
static Object strlit8026;
static Object strlit8045;
static Object strlit8065;
static Object strlit8073;
static Object strlit8079;
static Object strlit8088;
static Object strlit8094;
static Object strlit8111;
static Object strlit8150;
static Object strlit8160;
static Object strlit8183;
static Object strlit8190;
static Object strlit8208;
static Object strlit8227;
static Object strlit8229;
static Object strlit8245;
static Object strlit8282;
static Object strlit8306;
static Object strlit8313;
static Object strlit8361;
static Object strlit8370;
static Object strlit8377;
static Object strlit8385;
static Object strlit8388;
static Object strlit8396;
static Object strlit8412;
static Object strlit8420;
static Object strlit8453;
static Object strlit8463;
static Object strlit8473;
static Object strlit8476;
static Object strlit8504;
static Object strlit8520;
static Object strlit8527;
static Object strlit8541;
static Object strlit8563;
static Object strlit8568;
static Object strlit8571;
static Object strlit8590;
static Object strlit8619;
static Object strlit8627;
static Object strlit8635;
static Object strlit8642;
static Object strlit8651;
static Object strlit8688;
static Object strlit8733;
static Object strlit8739;
static Object strlit8755;
static Object strlit8759;
static Object strlit8763;
static Object strlit8790;
static Object strlit8794;
static Object strlit8803;
static Object strlit8812;
static Object strlit8821;
static Object strlit8830;
static Object strlit8839;
static Object strlit8848;
static Object strlit8857;
static Object strlit8866;
static Object strlit8886;
static Object strlit8891;
static Object strlit8900;
static Object strlit8913;
static Object strlit8919;
static Object strlit8926;
static Object strlit8930;
static Object strlit8937;
static Object strlit8971;
static Object strlit8976;
static Object strlit8996;
static Object strlit9014;
static Object strlit9056;
static Object strlit9121;
static Object strlit9224;
static Object strlit9241;
static Object strlit9251;
static Object strlit9254;
static Object strlit9265;
static Object strlit9275;
static Object strlit9278;
static Object strlit9298;
static Object strlit9306;
static Object strlit9313;
static Object strlit9328;
static Object strlit9339;
static Object strlit9344;
static Object strlit9354;
static Object strlit9365;
static Object strlit9379;
static Object strlit9389;
static Object strlit9416;
static Object strlit9422;
static Object strlit9454;
static Object strlit9460;
static Object strlit9465;
static Object strlit9473;
static Object strlit9489;
static Object strlit9495;
static Object strlit9503;
static Object strlit9572;
static Object strlit9575;
static Object strlit9577;
static Object strlit9587;
static Object strlit9625;
static Object strlit9678;
static Object strlit9680;
static Object strlit9711;
static Object strlit9713;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass9775;
static Object strlit9807;
static Object strlit9811;
Object meth_parser_1_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4 = alloc_Float64(0);
// compiled num node returning num4 (depth = 4)
  int op_slot_right_3 = gc_frame_newslot(num4);
// starting to compile member node (depth = 4)
  int callframe6 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call7 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6);
// compiled member node returning call7 (depth = 4)
  int op_slot_left_3 = gc_frame_newslot(call7);
  params[0] = num4;
  partcv[0] = 1;
  Object opresult8 = callmethod(call7, ">(1)", 1, partcv, params);
// compiled op node returning opresult8 (depth = 3)
  Object if2 = done;
  if (istrue(opresult8)) {
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call11 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10);
// compiled member node returning call11 (depth = 4)
  *var_lastLine = call11;
  if (call11 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe13 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call14 = callmethodflags(*var_lastToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe13);
// compiled member node returning call14 (depth = 4)
  *var_lastIndent = call14;
  if (call14 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe16 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call17 = callmethodflags(*var_tokens, "poll", 0, partcv, params, 0);
  gc_frame_end(callframe16);
// compiled member node returning call17 (depth = 4)
  *var_sym = call17;
  if (call17 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe19 = gc_frame_new();
// call case 4: self request
  Object call20 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe19);
// compiled member node returning call20 (depth = 3)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe21 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe22 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call23 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe22);
// compiled member node returning call23 (depth = 4)
  gc_frame_newslot(call23);
// starting to compile member node (depth = 4)
  int callframe24 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call25 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe24);
// compiled member node returning call25 (depth = 4)
  gc_frame_newslot(call25);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call23;
  params[1] = call25;
  partcv[0] = 2;
  Object call26 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled call node returning call26 (depth = 3)
    gc_frame_newslot(call26);
    if2 = call26;
  } else {
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe27 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit29 == NULL) {
    strlit29 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit29);
  }
// compiled string node returning strlit29 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(strlit29);
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit31 == NULL) {
    strlit31 = alloc_String("unexpectedly found the end of the input. ");
    gc_root(strlit31);
  }
// compiled string node returning strlit31 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(strlit31);
  params[0] = strlit29;
  partcv[0] = 1;
  Object opresult32 = callmethod(strlit31, "++(1)", 1, partcv, params);
// compiled op node returning opresult32 (depth = 4)
  gc_frame_newslot(opresult32);
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe33 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call34 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe33);
// compiled member node returning call34 (depth = 4)
  gc_frame_newslot(call34);
// starting to compile member node (depth = 4)
  int callframe35 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call36 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe35);
// compiled member node returning call36 (depth = 4)
  gc_frame_newslot(call36);
// call case 6: other requests
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult32;
  params[1] = call34;
  params[2] = call36;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call37 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe27);
// compiled call node returning call37 (depth = 3)
    gc_frame_newslot(call37);
    if2 = call37;
  }
// compiled if node returning if2 (depth = 2)
  gc_frame_end(frame);
  return if2;
}
Object meth_parser_49__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe50 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  Object call51 = callmethodflags(*var_s, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe50);
// compiled member node returning call51 (depth = 5)
  *var_s = call51;
  if (call51 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_55__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_right_56 = gc_frame_newslot(*var_lastLine);
// starting to compile member node (depth = 5)
  int callframe58 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  Object call59 = callmethodflags(*var_s, "line", 0, partcv, params, 0);
  gc_frame_end(callframe58);
// compiled member node returning call59 (depth = 5)
  int op_slot_left_56 = gc_frame_newslot(call59);
  params[0] = *var_lastLine;
  partcv[0] = 1;
  Object opresult60 = callmethod(call59, "==(1)", 1, partcv, params);
// compiled op node returning opresult60 (depth = 4)
  gc_frame_end(frame);
  return opresult60;
}
Object meth_parser_38_indentHasIncreased(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentHasIncreased");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num41 = alloc_Float64(0);
// compiled num node returning num41 (depth = 4)
  int op_slot_right_40 = gc_frame_newslot(num41);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_left_40 = gc_frame_newslot(*var_lastIndent);
  params[0] = num41;
  partcv[0] = 1;
  Object opresult43 = callmethod(*var_lastIndent, "==(1)", 1, partcv, params);
// compiled op node returning opresult43 (depth = 3)
  Object if39 = done;
  if (istrue(opresult43)) {
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool44 = alloc_Boolean(0);
// compiled identifier node returning bool44 (depth = 4)
  return bool44;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if39 = undefined;
  } else {
  }
// compiled if node returning if39 (depth = 2)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe45 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call46 = callmethodflags(*var_sym, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe45);
// compiled member node returning call46 (depth = 3)
  *var_s = call46;
  if (call46 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe47 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block48 = alloc_Block(NULL, NULL, "parser", 96);
  gc_frame_newslot(block48);
// method "_apply"
  block_savedest(block48);
  Object closure49 = createclosure(2, "_apply");
  setclosureframe(closure49, stackframe);
  addtoclosure(closure49, var_s);
  addtoclosure(closure49, selfslot);
  struct UserObject *uo49 = (struct UserObject*)block48;
  uo49->data[0] = (Object)closure49;
  Method *meth_meth_parser_49__apply = addmethod2pos(block48, "_apply", &meth_parser_49__apply, 0);
  int argcv_meth_parser_49__apply[] = {0};
  meth_meth_parser_49__apply->type = alloc_MethodType(1, argcv_meth_parser_49__apply);
  meth_meth_parser_49__apply->definitionModule = modulename;
  meth_meth_parser_49__apply->definitionLine = 3208;
// compiled block node returning block48 (depth = 3)
  gc_frame_newslot(block48);
// starting to compile block node (depth = 3)
  Object block54 = alloc_Block(NULL, NULL, "parser", 96);
  gc_frame_newslot(block54);
// method "_apply"
  block_savedest(block54);
  Object closure55 = createclosure(3, "_apply");
  setclosureframe(closure55, stackframe);
  addtoclosure(closure55, var_lastLine);
  addtoclosure(closure55, var_s);
  addtoclosure(closure55, selfslot);
  struct UserObject *uo55 = (struct UserObject*)block54;
  uo55->data[0] = (Object)closure55;
  Method *meth_meth_parser_55__apply = addmethod2pos(block54, "_apply", &meth_parser_55__apply, 0);
  int argcv_meth_parser_55__apply[] = {0};
  meth_meth_parser_55__apply->type = alloc_MethodType(1, argcv_meth_parser_55__apply);
  meth_meth_parser_55__apply->definitionModule = modulename;
  meth_meth_parser_55__apply->definitionLine = 3208;
// compiled block node returning block54 (depth = 3)
  gc_frame_newslot(block54);
// call case 5: prelude request
  params[0] = block48;
  params[1] = block54;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call62 = callmethodflags(prelude, "do(1)while(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe47);
// compiled call node returning call62 (depth = 2)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit65 == NULL) {
    strlit65 = alloc_String("lbrace");
    gc_root(strlit65);
  }
// compiled string node returning strlit65 (depth = 4)
  int op_slot_right_64 = gc_frame_newslot(strlit65);
// starting to compile member node (depth = 4)
  int callframe67 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  Object call68 = callmethodflags(*var_s, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe67);
// compiled member node returning call68 (depth = 4)
  int op_slot_left_64 = gc_frame_newslot(call68);
  params[0] = strlit65;
  partcv[0] = 1;
  Object opresult69 = callmethod(call68, "==(1)", 1, partcv, params);
// compiled op node returning opresult69 (depth = 3)
  Object if63 = done;
  if (istrue(opresult69)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool70 = alloc_Boolean(0);
// compiled identifier node returning bool70 (depth = 4)
  return bool70;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if63 = undefined;
  } else {
  }
// compiled if node returning if63 (depth = 2)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit73 == NULL) {
    strlit73 = alloc_String("comment");
    gc_root(strlit73);
  }
// compiled string node returning strlit73 (depth = 4)
  int op_slot_right_72 = gc_frame_newslot(strlit73);
// starting to compile member node (depth = 4)
  int callframe75 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  Object call76 = callmethodflags(*var_s, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 4)
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = strlit73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, "==(1)", 1, partcv, params);
// compiled op node returning opresult77 (depth = 3)
  Object if71 = done;
  if (istrue(opresult77)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool78 = alloc_Boolean(0);
// compiled identifier node returning bool78 (depth = 4)
  return bool78;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if71 = undefined;
  } else {
  }
// compiled if node returning if71 (depth = 2)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_79 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe81 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  Object call82 = callmethodflags(*var_s, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe81);
// compiled member node returning call82 (depth = 4)
  int op_slot_left_79 = gc_frame_newslot(call82);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult83 = callmethod(call82, "<(1)", 1, partcv, params);
// compiled op node returning opresult83 (depth = 3)
  return opresult83;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_84_saveParsePosition(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "saveParsePosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_lexerState = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lexerState");
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe85 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call86 = callmethodflags(*var_tokens, "savePosition", 0, partcv, params, 0);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 3)
  *var_lexerState = call86;
  if (call86 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile array node (depth = 3)
  Object array87 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lexerState (depth = 4)
  params[0] = *var_lexerState;
  partcv[0] = 1;
  callmethodflags(array87, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile member node (depth = 4)
  int callframe88 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call89 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe88);
// compiled member node returning call89 (depth = 4)
  params[0] = call89;
  partcv[0] = 1;
  callmethodflags(array87, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array87 (depth = 3)
  return array87;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_118__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_oldValueStackSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call121 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call121 (depth = 5)
  int op_slot_right_119 = gc_frame_newslot(call121);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldValueStackSize (depth = 5)
  int op_slot_left_119 = gc_frame_newslot(*var_oldValueStackSize);
  params[0] = call121;
  partcv[0] = 1;
  Object opresult123 = callmethod(*var_oldValueStackSize, "≠(1)", 1, partcv, params);
// compiled op node returning opresult123 (depth = 4)
  gc_frame_end(frame);
  return opresult123;
}
Object meth_parser_126__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call128 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe127);
// compiled member node returning call128 (depth = 4)
  gc_frame_end(frame);
  return call128;
}
Object meth_parser_90_restoreParsePosition_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "restoreParsePosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method restoreParsePosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for restoreParsePosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_saved = &(stackframe->slots[0]);
  *var_saved = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part restoreParsePosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_oldValueStackSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldValueStackSize");
// definebindings:
// definebindings:
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe91 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe92 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_saved (depth = 4)
  Object call93 = callmethodflags(*var_saved, "first", 0, partcv, params, 0);
  gc_frame_end(callframe92);
// compiled member node returning call93 (depth = 3)
  gc_frame_newslot(call93);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  params[0] = call93;
  partcv[0] = 1;
  Object call94 = callmethodflags(*var_tokens, "restorePosition(1)", 1, partcv, params, 0);
  gc_frame_end(callframe91);
// compiled call node returning call94 (depth = 2)
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe95 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe96 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call97 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe96);
// compiled member node returning call97 (depth = 4)
  Object call98 = callmethodflags(call97, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe95);
// compiled member node returning call98 (depth = 3)
  *var_sym = call98;
  if (call98 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe100 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call101 = callmethodflags(*var_sym, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe100);
// compiled member node returning call101 (depth = 3)
  *var_lastToken = call101;
  if (call101 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe103 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_saved (depth = 4)
  Object call104 = callmethodflags(*var_saved, "second", 0, partcv, params, 0);
  gc_frame_end(callframe103);
// compiled member node returning call104 (depth = 3)
  *var_oldValueStackSize = call104;
  if (call104 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe107 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call108 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe107);
// compiled member node returning call108 (depth = 4)
  int op_slot_right_106 = gc_frame_newslot(call108);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldValueStackSize (depth = 4)
  int op_slot_left_106 = gc_frame_newslot(*var_oldValueStackSize);
  params[0] = call108;
  partcv[0] = 1;
  Object opresult110 = callmethod(*var_oldValueStackSize, ">(1)", 1, partcv, params);
// compiled op node returning opresult110 (depth = 3)
  Object if105 = done;
  if (istrue(opresult110)) {
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe111 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit112 == NULL) {
    strlit112 = alloc_String("can't restore parse position; the values stack has been popped");
    gc_root(strlit112);
  }
// compiled string node returning strlit112 (depth = 4)
  gc_frame_newslot(strlit112);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe113 = gc_frame_new();
// call case 5: prelude request
  Object call114 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe113);
// compiled member node returning call114 (depth = 4)
  params[0] = strlit112;
  partcv[0] = 1;
  Object call115 = callmethodflags(call114, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe111);
// compiled call node returning call115 (depth = 3)
    gc_frame_newslot(call115);
    if105 = call115;
  } else {
  }
// compiled if node returning if105 (depth = 2)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe116 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block117 = alloc_Block(NULL, NULL, "parser", 115);
  gc_frame_newslot(block117);
// method "_apply"
  block_savedest(block117);
  Object closure118 = createclosure(3, "_apply");
  setclosureframe(closure118, stackframe);
  addtoclosure(closure118, var_values);
  addtoclosure(closure118, var_oldValueStackSize);
  addtoclosure(closure118, selfslot);
  struct UserObject *uo118 = (struct UserObject*)block117;
  uo118->data[0] = (Object)closure118;
  Method *meth_meth_parser_118__apply = addmethod2pos(block117, "_apply", &meth_parser_118__apply, 0);
  int argcv_meth_parser_118__apply[] = {0};
  meth_meth_parser_118__apply->type = alloc_MethodType(1, argcv_meth_parser_118__apply);
  meth_meth_parser_118__apply->definitionModule = modulename;
  meth_meth_parser_118__apply->definitionLine = 3208;
// compiled block node returning block117 (depth = 3)
  gc_frame_newslot(block117);
// starting to compile block node (depth = 3)
  Object block125 = alloc_Block(NULL, NULL, "parser", 115);
  gc_frame_newslot(block125);
// method "_apply"
  block_savedest(block125);
  Object closure126 = createclosure(2, "_apply");
  setclosureframe(closure126, stackframe);
  addtoclosure(closure126, var_values);
  addtoclosure(closure126, selfslot);
  struct UserObject *uo126 = (struct UserObject*)block125;
  uo126->data[0] = (Object)closure126;
  Method *meth_meth_parser_126__apply = addmethod2pos(block125, "_apply", &meth_parser_126__apply, 0);
  int argcv_meth_parser_126__apply[] = {0};
  meth_meth_parser_126__apply->type = alloc_MethodType(1, argcv_meth_parser_126__apply);
  meth_meth_parser_126__apply->definitionModule = modulename;
  meth_meth_parser_126__apply->definitionLine = 3208;
// compiled block node returning block125 (depth = 3)
  gc_frame_newslot(block125);
// call case 5: prelude request
  params[0] = block117;
  params[1] = block125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call130 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe116);
// compiled call node returning call130 (depth = 2)
  gc_frame_end(frame);
  return call130;
}
Object meth_parser_141__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call144 = callmethodflags(*var_lastToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe143);
// compiled member node returning call144 (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(call144);
// starting to compile member node (depth = 7)
  int callframe146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call147 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe146);
// compiled member node returning call147 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(call147);
  params[0] = call144;
  partcv[0] = 1;
  Object opresult148 = callmethod(call147, "≥(1)", 1, partcv, params);
// compiled op node returning opresult148 (depth = 6)
  gc_frame_end(frame);
  return opresult148;
}
Object meth_parser_153__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_154 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool156 = alloc_Boolean(0);
// compiled identifier node returning bool156 (depth = 8)
  int op_slot_left_154 = gc_frame_newslot(bool156);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult157 = callmethod(bool156, "==(1)", 1, partcv, params);
// compiled op node returning opresult157 (depth = 7)
  gc_frame_end(frame);
  return opresult157;
}
Object meth_parser_138__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block140 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block140);
// method "_apply"
  block_savedest(block140);
  Object closure141 = createclosure(3, "_apply");
  setclosureframe(closure141, stackframe);
  addtoclosure(closure141, var_lastToken);
  addtoclosure(closure141, var_n);
  addtoclosure(closure141, selfslot);
  struct UserObject *uo141 = (struct UserObject*)block140;
  uo141->data[0] = (Object)closure141;
  Method *meth_meth_parser_141__apply = addmethod2pos(block140, "_apply", &meth_parser_141__apply, 0);
  int argcv_meth_parser_141__apply[] = {0};
  meth_meth_parser_141__apply->type = alloc_MethodType(1, argcv_meth_parser_141__apply);
  meth_meth_parser_141__apply->definitionModule = modulename;
  meth_meth_parser_141__apply->definitionLine = 3208;
// compiled block node returning block140 (depth = 5)
  int op_slot_right_139 = gc_frame_newslot(block140);
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block152 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block152);
// method "_apply"
  block_savedest(block152);
  Object closure153 = createclosure(2, "_apply");
  setclosureframe(closure153, stackframe);
  addtoclosure(closure153, var_nextTok);
  addtoclosure(closure153, selfslot);
  struct UserObject *uo153 = (struct UserObject*)block152;
  uo153->data[0] = (Object)closure153;
  Method *meth_meth_parser_153__apply = addmethod2pos(block152, "_apply", &meth_parser_153__apply, 0);
  int argcv_meth_parser_153__apply[] = {0};
  meth_meth_parser_153__apply->type = alloc_MethodType(1, argcv_meth_parser_153__apply);
  meth_meth_parser_153__apply->definitionModule = modulename;
  meth_meth_parser_153__apply->definitionLine = 3208;
// compiled block node returning block152 (depth = 6)
  int op_slot_right_151 = gc_frame_newslot(block152);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_right_160 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 7)
  Object bool162 = alloc_Boolean(0);
// compiled identifier node returning bool162 (depth = 7)
  int op_slot_left_160 = gc_frame_newslot(bool162);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult163 = callmethod(bool162, "≠(1)", 1, partcv, params);
// compiled op node returning opresult163 (depth = 6)
  int op_slot_left_151 = gc_frame_newslot(opresult163);
  params[0] = block152;
  partcv[0] = 1;
  Object opresult164 = callmethod(opresult163, "&&(1)", 1, partcv, params);
// compiled op node returning opresult164 (depth = 5)
  int op_slot_left_139 = gc_frame_newslot(opresult164);
  params[0] = block140;
  partcv[0] = 1;
  Object opresult165 = callmethod(opresult164, "&&(1)", 1, partcv, params);
// compiled op node returning opresult165 (depth = 4)
  gc_frame_end(frame);
  return opresult165;
}
Object meth_parser_168__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe170 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call171 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 5)
  Object if169 = done;
  if (istrue(call171)) {
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if169 = done;
  } else {
  }
// compiled if node returning if169 (depth = 4)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe173 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call174 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe173);
// compiled member node returning call174 (depth = 5)
  *var_n = call174;
  if (call174 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_131_findNextToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe133 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call134 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe133);
// compiled call node returning call134 (depth = 3)
  Object if132 = done;
  if (istrue(call134)) {
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if132 = undefined;
  } else {
  }
// compiled if node returning if132 (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 3)
  *var_nextTok = bool135;
  if (bool135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe136 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block137 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block137);
// method "_apply"
  block_savedest(block137);
  Object closure138 = createclosure(4, "_apply");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_lastToken);
  addtoclosure(closure138, var_n);
  addtoclosure(closure138, var_nextTok);
  addtoclosure(closure138, selfslot);
  struct UserObject *uo138 = (struct UserObject*)block137;
  uo138->data[0] = (Object)closure138;
  Method *meth_meth_parser_138__apply = addmethod2pos(block137, "_apply", &meth_parser_138__apply, 0);
  int argcv_meth_parser_138__apply[] = {0};
  meth_meth_parser_138__apply->type = alloc_MethodType(1, argcv_meth_parser_138__apply);
  meth_meth_parser_138__apply->definitionModule = modulename;
  meth_meth_parser_138__apply->definitionLine = 3208;
// compiled block node returning block137 (depth = 3)
  gc_frame_newslot(block137);
// starting to compile block node (depth = 3)
  Object block167 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block167);
// method "_apply"
  block_savedest(block167);
  Object closure168 = createclosure(4, "_apply");
  setclosureframe(closure168, stackframe);
  addtoclosure(closure168, var_n);
  addtoclosure(closure168, var_tokenMatcher);
  addtoclosure(closure168, var_nextTok);
  addtoclosure(closure168, selfslot);
  struct UserObject *uo168 = (struct UserObject*)block167;
  uo168->data[0] = (Object)closure168;
  Method *meth_meth_parser_168__apply = addmethod2pos(block167, "_apply", &meth_parser_168__apply, 0);
  int argcv_meth_parser_168__apply[] = {0};
  meth_meth_parser_168__apply->type = alloc_MethodType(1, argcv_meth_parser_168__apply);
  meth_meth_parser_168__apply->definitionModule = modulename;
  meth_meth_parser_168__apply->definitionLine = 3208;
// compiled block node returning block167 (depth = 3)
  gc_frame_newslot(block167);
// call case 5: prelude request
  params[0] = block137;
  params[1] = block167;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call177 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe136);
// compiled call node returning call177 (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser_212__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_213 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool215 = alloc_Boolean(0);
// compiled identifier node returning bool215 (depth = 7)
  int op_slot_left_213 = gc_frame_newslot(bool215);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult216 = callmethod(bool215, "==(1)", 1, partcv, params);
// compiled op node returning opresult216 (depth = 6)
  gc_frame_end(frame);
  return opresult216;
}
Object meth_parser_209__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block211 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block211);
// method "_apply"
  block_savedest(block211);
  Object closure212 = createclosure(2, "_apply");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_nextTok);
  addtoclosure(closure212, selfslot);
  struct UserObject *uo212 = (struct UserObject*)block211;
  uo212->data[0] = (Object)closure212;
  Method *meth_meth_parser_212__apply = addmethod2pos(block211, "_apply", &meth_parser_212__apply, 0);
  int argcv_meth_parser_212__apply[] = {0};
  meth_meth_parser_212__apply->type = alloc_MethodType(1, argcv_meth_parser_212__apply);
  meth_meth_parser_212__apply->definitionModule = modulename;
  meth_meth_parser_212__apply->definitionLine = 3208;
// compiled block node returning block211 (depth = 5)
  int op_slot_right_210 = gc_frame_newslot(block211);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_219 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 6)
  Object bool221 = alloc_Boolean(0);
// compiled identifier node returning bool221 (depth = 6)
  int op_slot_left_219 = gc_frame_newslot(bool221);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult222 = callmethod(bool221, "≠(1)", 1, partcv, params);
// compiled op node returning opresult222 (depth = 5)
  int op_slot_left_210 = gc_frame_newslot(opresult222);
  params[0] = block211;
  partcv[0] = 1;
  Object opresult223 = callmethod(opresult222, "&&(1)", 1, partcv, params);
// compiled op node returning opresult223 (depth = 4)
  gc_frame_end(frame);
  return opresult223;
}
Object meth_parser_226__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit230 == NULL) {
    strlit230 = alloc_String("eof");
    gc_root(strlit230);
  }
// compiled string node returning strlit230 (depth = 7)
  int op_slot_right_229 = gc_frame_newslot(strlit230);
// starting to compile member node (depth = 7)
  int callframe232 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call233 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe232);
// compiled member node returning call233 (depth = 7)
  int op_slot_left_229 = gc_frame_newslot(call233);
  params[0] = strlit230;
  partcv[0] = 1;
  Object opresult234 = callmethod(call233, "==(1)", 1, partcv, params);
// compiled op node returning opresult234 (depth = 6)
  int op_slot_right_228 = gc_frame_newslot(opresult234);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe238 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call239 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe238);
// compiled member node returning call239 (depth = 8)
  int op_slot_right_237 = gc_frame_newslot(call239);
// starting to compile member node (depth = 8)
  int callframe241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call242 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe241);
// compiled member node returning call242 (depth = 8)
  int op_slot_left_237 = gc_frame_newslot(call242);
  params[0] = call239;
  partcv[0] = 1;
  Object opresult243 = callmethod(call242, "≤(1)", 1, partcv, params);
// compiled op node returning opresult243 (depth = 7)
  int op_slot_right_236 = gc_frame_newslot(opresult243);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call247 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe246);
// compiled member node returning call247 (depth = 8)
  int op_slot_right_245 = gc_frame_newslot(call247);
// starting to compile member node (depth = 8)
  int callframe249 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call250 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 8)
  int op_slot_left_245 = gc_frame_newslot(call250);
  params[0] = call247;
  partcv[0] = 1;
  Object opresult251 = callmethod(call250, ">(1)", 1, partcv, params);
// compiled op node returning opresult251 (depth = 7)
  int op_slot_left_236 = gc_frame_newslot(opresult251);
  params[0] = opresult243;
  partcv[0] = 1;
  Object opresult252 = callmethod(opresult251, "&&(1)", 1, partcv, params);
// compiled op node returning opresult252 (depth = 6)
  int op_slot_left_228 = gc_frame_newslot(opresult252);
  params[0] = opresult234;
  partcv[0] = 1;
  Object opresult253 = callmethod(opresult252, "||(1)", 1, partcv, params);
// compiled op node returning opresult253 (depth = 5)
  Object if227 = done;
  if (istrue(opresult253)) {
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if227 = done;
  } else {
  }
// compiled if node returning if227 (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call256 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe255);
// compiled member node returning call256 (depth = 5)
  *var_n = call256;
  if (call256 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_178_findNextTokenIndentedAt_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextTokenIndentedAt(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextTokenIndentedAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextTokenIndentedAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit182 == NULL) {
    strlit182 = alloc_String("eof");
    gc_root(strlit182);
  }
// compiled string node returning strlit182 (depth = 5)
  int op_slot_right_181 = gc_frame_newslot(strlit182);
// starting to compile member node (depth = 5)
  int callframe184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call185 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe184);
// compiled member node returning call185 (depth = 5)
  int op_slot_left_181 = gc_frame_newslot(call185);
  params[0] = strlit182;
  partcv[0] = 1;
  Object opresult186 = callmethod(call185, "==(1)", 1, partcv, params);
// compiled op node returning opresult186 (depth = 4)
  int op_slot_right_180 = gc_frame_newslot(opresult186);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call191 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe190);
// compiled member node returning call191 (depth = 6)
  int op_slot_right_189 = gc_frame_newslot(call191);
// starting to compile member node (depth = 6)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call194 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 6)
  int op_slot_left_189 = gc_frame_newslot(call194);
  params[0] = call191;
  partcv[0] = 1;
  Object opresult195 = callmethod(call194, "≤(1)", 1, partcv, params);
// compiled op node returning opresult195 (depth = 5)
  int op_slot_right_188 = gc_frame_newslot(opresult195);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call199 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe198);
// compiled member node returning call199 (depth = 6)
  int op_slot_right_197 = gc_frame_newslot(call199);
// starting to compile member node (depth = 6)
  int callframe201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call202 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe201);
// compiled member node returning call202 (depth = 6)
  int op_slot_left_197 = gc_frame_newslot(call202);
  params[0] = call199;
  partcv[0] = 1;
  Object opresult203 = callmethod(call202, ">(1)", 1, partcv, params);
// compiled op node returning opresult203 (depth = 5)
  int op_slot_left_188 = gc_frame_newslot(opresult203);
  params[0] = opresult195;
  partcv[0] = 1;
  Object opresult204 = callmethod(opresult203, "&&(1)", 1, partcv, params);
// compiled op node returning opresult204 (depth = 4)
  int op_slot_left_180 = gc_frame_newslot(opresult204);
  params[0] = opresult186;
  partcv[0] = 1;
  Object opresult205 = callmethod(opresult204, "||(1)", 1, partcv, params);
// compiled op node returning opresult205 (depth = 3)
  Object if179 = done;
  if (istrue(opresult205)) {
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if179 = undefined;
  } else {
  }
// compiled if node returning if179 (depth = 2)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool206 = alloc_Boolean(0);
// compiled identifier node returning bool206 (depth = 3)
  *var_nextTok = bool206;
  if (bool206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe207 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block208 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block208);
// method "_apply"
  block_savedest(block208);
  Object closure209 = createclosure(3, "_apply");
  setclosureframe(closure209, stackframe);
  addtoclosure(closure209, var_nextTok);
  addtoclosure(closure209, var_n);
  addtoclosure(closure209, selfslot);
  struct UserObject *uo209 = (struct UserObject*)block208;
  uo209->data[0] = (Object)closure209;
  Method *meth_meth_parser_209__apply = addmethod2pos(block208, "_apply", &meth_parser_209__apply, 0);
  int argcv_meth_parser_209__apply[] = {0};
  meth_meth_parser_209__apply->type = alloc_MethodType(1, argcv_meth_parser_209__apply);
  meth_meth_parser_209__apply->definitionModule = modulename;
  meth_meth_parser_209__apply->definitionLine = 3208;
// compiled block node returning block208 (depth = 3)
  gc_frame_newslot(block208);
// starting to compile block node (depth = 3)
  Object block225 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block225);
// method "_apply"
  block_savedest(block225);
  Object closure226 = createclosure(5, "_apply");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_sym);
  addtoclosure(closure226, var_tok);
  addtoclosure(closure226, var_n);
  addtoclosure(closure226, var_nextTok);
  addtoclosure(closure226, selfslot);
  struct UserObject *uo226 = (struct UserObject*)block225;
  uo226->data[0] = (Object)closure226;
  Method *meth_meth_parser_226__apply = addmethod2pos(block225, "_apply", &meth_parser_226__apply, 0);
  int argcv_meth_parser_226__apply[] = {0};
  meth_meth_parser_226__apply->type = alloc_MethodType(1, argcv_meth_parser_226__apply);
  meth_meth_parser_226__apply->definitionModule = modulename;
  meth_meth_parser_226__apply->definitionLine = 3208;
// compiled block node returning block225 (depth = 3)
  gc_frame_newslot(block225);
// call case 5: prelude request
  params[0] = block208;
  params[1] = block225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call259 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe207);
// compiled call node returning call259 (depth = 2)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser_274__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit276 == NULL) {
    strlit276 = alloc_String("eof");
    gc_root(strlit276);
  }
// compiled string node returning strlit276 (depth = 5)
  int op_slot_right_275 = gc_frame_newslot(strlit276);
// starting to compile member node (depth = 5)
  int callframe278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  Object call279 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe278);
// compiled member node returning call279 (depth = 5)
  int op_slot_left_275 = gc_frame_newslot(call279);
  params[0] = strlit276;
  partcv[0] = 1;
  Object opresult280 = callmethod(call279, "≠(1)", 1, partcv, params);
// compiled op node returning opresult280 (depth = 4)
  gc_frame_end(frame);
  return opresult280;
}
Object meth_parser_283__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe285 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  Object call287 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe286);
// compiled member node returning call287 (depth = 6)
  gc_frame_newslot(call287);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call287;
  partcv[0] = 1;
  Object call288 = callmethodflags(*var_validFollowTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe285);
// compiled call node returning call288 (depth = 5)
  Object if284 = done;
  if (istrue(call288)) {
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if284 = undefined;
  } else {
  }
// compiled if node returning if284 (depth = 4)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe290 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe291 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  Object call293 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe292);
// compiled member node returning call293 (depth = 7)
  gc_frame_newslot(call293);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call293;
  partcv[0] = 1;
  Object call294 = callmethodflags(*var_invalidTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe291);
// compiled call node returning call294 (depth = 6)
  partcv[0] = 0;
  Object call295 = callmethodflags(call294, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe290);
// compiled call node returning call295 (depth = 5)
  Object if289 = done;
  if (istrue(call295)) {
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if289 = undefined;
  } else {
  }
// compiled if node returning if289 (depth = 4)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe296 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  Object call297 = callmethodflags(*var_validToken, "next", 0, partcv, params, 0);
  gc_frame_end(callframe296);
// compiled member node returning call297 (depth = 5)
  *var_validToken = call297;
  if (call297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_260_findNextValidToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextValidToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextValidToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextValidToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe261 = gc_frame_new();
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array262 = alloc_BuiltinList();
  gc_pause();
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("dot");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 5)
  params[0] = strlit263;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit264 == NULL) {
    strlit264 = alloc_String("comma");
    gc_root(strlit264);
  }
// compiled string node returning strlit264 (depth = 5)
  params[0] = strlit264;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit265 == NULL) {
    strlit265 = alloc_String("colon");
    gc_root(strlit265);
  }
// compiled string node returning strlit265 (depth = 5)
  params[0] = strlit265;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit266 == NULL) {
    strlit266 = alloc_String("rparen");
    gc_root(strlit266);
  }
// compiled string node returning strlit266 (depth = 5)
  params[0] = strlit266;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit267 == NULL) {
    strlit267 = alloc_String("rbrace");
    gc_root(strlit267);
  }
// compiled string node returning strlit267 (depth = 5)
  params[0] = strlit267;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit268 == NULL) {
    strlit268 = alloc_String("rsquare");
    gc_root(strlit268);
  }
// compiled string node returning strlit268 (depth = 5)
  params[0] = strlit268;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit269 == NULL) {
    strlit269 = alloc_String("arrow");
    gc_root(strlit269);
  }
// compiled string node returning strlit269 (depth = 5)
  params[0] = strlit269;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit270 == NULL) {
    strlit270 = alloc_String("bind");
    gc_root(strlit270);
  }
// compiled string node returning strlit270 (depth = 5)
  params[0] = strlit270;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array262 (depth = 4)
  gc_frame_newslot(array262);
// call case 5: prelude request
  params[0] = array262;
  partcv[0] = 1;
  Object call271 = callmethodflags(prelude, "set(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe261);
// compiled call node returning call271 (depth = 3)
  *var_invalidTokens = call271;
  if (call271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe272 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block273 = alloc_Block(NULL, NULL, "parser", 156);
  gc_frame_newslot(block273);
// method "_apply"
  block_savedest(block273);
  Object closure274 = createclosure(2, "_apply");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_validToken);
  addtoclosure(closure274, selfslot);
  struct UserObject *uo274 = (struct UserObject*)block273;
  uo274->data[0] = (Object)closure274;
  Method *meth_meth_parser_274__apply = addmethod2pos(block273, "_apply", &meth_parser_274__apply, 0);
  int argcv_meth_parser_274__apply[] = {0};
  meth_meth_parser_274__apply->type = alloc_MethodType(1, argcv_meth_parser_274__apply);
  meth_meth_parser_274__apply->definitionModule = modulename;
  meth_meth_parser_274__apply->definitionLine = 3208;
// compiled block node returning block273 (depth = 3)
  gc_frame_newslot(block273);
// starting to compile block node (depth = 3)
  Object block282 = alloc_Block(NULL, NULL, "parser", 156);
  gc_frame_newslot(block282);
// method "_apply"
  block_savedest(block282);
  Object closure283 = createclosure(4, "_apply");
  setclosureframe(closure283, stackframe);
  addtoclosure(closure283, var_validToken);
  addtoclosure(closure283, var_validFollowTokens);
  addtoclosure(closure283, var_invalidTokens);
  addtoclosure(closure283, selfslot);
  struct UserObject *uo283 = (struct UserObject*)block282;
  uo283->data[0] = (Object)closure283;
  Method *meth_meth_parser_283__apply = addmethod2pos(block282, "_apply", &meth_parser_283__apply, 0);
  int argcv_meth_parser_283__apply[] = {0};
  meth_meth_parser_283__apply->type = alloc_MethodType(1, argcv_meth_parser_283__apply);
  meth_meth_parser_283__apply->definitionModule = modulename;
  meth_meth_parser_283__apply->definitionLine = 3208;
// compiled block node returning block282 (depth = 3)
  gc_frame_newslot(block282);
// call case 5: prelude request
  params[0] = block273;
  params[1] = block282;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe272);
// compiled call node returning call300 (depth = 2)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_312__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe315 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call316 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe315);
// compiled member node returning call316 (depth = 6)
  int op_slot_right_314 = gc_frame_newslot(call316);
// starting to compile member node (depth = 6)
  int callframe318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call319 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe318);
// compiled member node returning call319 (depth = 6)
  int op_slot_left_314 = gc_frame_newslot(call319);
  params[0] = call316;
  partcv[0] = 1;
  Object opresult320 = callmethod(call319, "==(1)", 1, partcv, params);
// compiled op node returning opresult320 (depth = 5)
  int op_slot_right_313 = gc_frame_newslot(opresult320);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit323 == NULL) {
    strlit323 = alloc_String("eof");
    gc_root(strlit323);
  }
// compiled string node returning strlit323 (depth = 6)
  int op_slot_right_322 = gc_frame_newslot(strlit323);
// starting to compile member node (depth = 6)
  int callframe325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call326 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe325);
// compiled member node returning call326 (depth = 6)
  int op_slot_left_322 = gc_frame_newslot(call326);
  params[0] = strlit323;
  partcv[0] = 1;
  Object opresult327 = callmethod(call326, "≠(1)", 1, partcv, params);
// compiled op node returning opresult327 (depth = 5)
  int op_slot_left_313 = gc_frame_newslot(opresult327);
  params[0] = opresult320;
  partcv[0] = 1;
  Object opresult328 = callmethod(opresult327, "&&(1)", 1, partcv, params);
// compiled op node returning opresult328 (depth = 4)
  gc_frame_end(frame);
  return opresult328;
}
Object meth_parser_331__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit334 == NULL) {
    strlit334 = alloc_String("lbrace");
    gc_root(strlit334);
  }
// compiled string node returning strlit334 (depth = 6)
  int op_slot_right_333 = gc_frame_newslot(strlit334);
// starting to compile member node (depth = 6)
  int callframe336 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call337 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe336);
// compiled member node returning call337 (depth = 6)
  int op_slot_left_333 = gc_frame_newslot(call337);
  params[0] = strlit334;
  partcv[0] = 1;
  Object opresult338 = callmethod(call337, "==(1)", 1, partcv, params);
// compiled op node returning opresult338 (depth = 5)
  Object if332 = done;
  if (istrue(opresult338)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num340 = alloc_Float64(1);
// compiled num node returning num340 (depth = 7)
  int op_slot_right_339 = gc_frame_newslot(num340);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_339 = gc_frame_newslot(*var_numOpening);
  params[0] = num340;
  partcv[0] = 1;
  Object sum342 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum342 (depth = 6)
  *var_numOpening = sum342;
  if (sum342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if332 = done;
  } else {
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit346 == NULL) {
    strlit346 = alloc_String("rbrace");
    gc_root(strlit346);
  }
// compiled string node returning strlit346 (depth = 7)
  int op_slot_right_345 = gc_frame_newslot(strlit346);
// starting to compile member node (depth = 7)
  int callframe348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call349 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe348);
// compiled member node returning call349 (depth = 7)
  int op_slot_left_345 = gc_frame_newslot(call349);
  params[0] = strlit346;
  partcv[0] = 1;
  Object opresult350 = callmethod(call349, "==(1)", 1, partcv, params);
// compiled op node returning opresult350 (depth = 6)
  Object if344 = done;
  if (istrue(opresult350)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num352 = alloc_Float64(1);
// compiled num node returning num352 (depth = 8)
  int op_slot_right_351 = gc_frame_newslot(num352);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_351 = gc_frame_newslot(*var_numClosing);
  params[0] = num352;
  partcv[0] = 1;
  Object sum354 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum354 (depth = 7)
  *var_numClosing = sum354;
  if (sum354 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if344 = done;
  } else {
  }
// compiled if node returning if344 (depth = 5)
    gc_frame_newslot(if344);
    if332 = if344;
  }
// compiled if node returning if332 (depth = 4)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe356 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call357 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe356);
// compiled member node returning call357 (depth = 5)
  *var_n = call357;
  if (call357 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_363__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe366 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call367 = callmethodflags(*var_token, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe366);
// compiled member node returning call367 (depth = 6)
  int op_slot_right_365 = gc_frame_newslot(call367);
// starting to compile member node (depth = 6)
  int callframe369 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call370 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe369);
// compiled member node returning call370 (depth = 6)
  int op_slot_left_365 = gc_frame_newslot(call370);
  params[0] = call367;
  partcv[0] = 1;
  Object opresult371 = callmethod(call370, ">(1)", 1, partcv, params);
// compiled op node returning opresult371 (depth = 5)
  int op_slot_right_364 = gc_frame_newslot(opresult371);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit374 == NULL) {
    strlit374 = alloc_String("eof");
    gc_root(strlit374);
  }
// compiled string node returning strlit374 (depth = 6)
  int op_slot_right_373 = gc_frame_newslot(strlit374);
// starting to compile member node (depth = 6)
  int callframe376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call377 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe376);
// compiled member node returning call377 (depth = 6)
  int op_slot_left_373 = gc_frame_newslot(call377);
  params[0] = strlit374;
  partcv[0] = 1;
  Object opresult378 = callmethod(call377, "≠(1)", 1, partcv, params);
// compiled op node returning opresult378 (depth = 5)
  int op_slot_left_364 = gc_frame_newslot(opresult378);
  params[0] = opresult371;
  partcv[0] = 1;
  Object opresult379 = callmethod(opresult378, "&&(1)", 1, partcv, params);
// compiled op node returning opresult379 (depth = 4)
  gc_frame_end(frame);
  return opresult379;
}
Object meth_parser_382__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit385 == NULL) {
    strlit385 = alloc_String("lbrace");
    gc_root(strlit385);
  }
// compiled string node returning strlit385 (depth = 6)
  int op_slot_right_384 = gc_frame_newslot(strlit385);
// starting to compile member node (depth = 6)
  int callframe387 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call388 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe387);
// compiled member node returning call388 (depth = 6)
  int op_slot_left_384 = gc_frame_newslot(call388);
  params[0] = strlit385;
  partcv[0] = 1;
  Object opresult389 = callmethod(call388, "==(1)", 1, partcv, params);
// compiled op node returning opresult389 (depth = 5)
  Object if383 = done;
  if (istrue(opresult389)) {
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num391 = alloc_Float64(1);
// compiled num node returning num391 (depth = 7)
  int op_slot_right_390 = gc_frame_newslot(num391);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_390 = gc_frame_newslot(*var_numOpening);
  params[0] = num391;
  partcv[0] = 1;
  Object sum393 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum393 (depth = 6)
  *var_numOpening = sum393;
  if (sum393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if383 = done;
  } else {
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("rbrace");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 7)
  int op_slot_right_396 = gc_frame_newslot(strlit397);
// starting to compile member node (depth = 7)
  int callframe399 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call400 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe399);
// compiled member node returning call400 (depth = 7)
  int op_slot_left_396 = gc_frame_newslot(call400);
  params[0] = strlit397;
  partcv[0] = 1;
  Object opresult401 = callmethod(call400, "==(1)", 1, partcv, params);
// compiled op node returning opresult401 (depth = 6)
  Object if395 = done;
  if (istrue(opresult401)) {
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num403 = alloc_Float64(1);
// compiled num node returning num403 (depth = 8)
  int op_slot_right_402 = gc_frame_newslot(num403);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_402 = gc_frame_newslot(*var_numClosing);
  params[0] = num403;
  partcv[0] = 1;
  Object sum405 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum405 (depth = 7)
  *var_numClosing = sum405;
  if (sum405 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if395 = done;
  } else {
  }
// compiled if node returning if395 (depth = 5)
    gc_frame_newslot(if395);
    if383 = if395;
  }
// compiled if node returning if383 (depth = 4)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call408 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe407);
// compiled member node returning call408 (depth = 5)
  *var_n = call408;
  if (call408 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_301_findClosingBrace_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findClosingBrace(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findClosingBrace(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findClosingBrace(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if302 = done;
struct StackFrameObject *iftmpstackframe302 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe302);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 4)
  Object num303 = alloc_Float64(1);
// compiled num node returning num303 (depth = 4)
    gc_frame_newslot(num303);
    if302 = num303;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe302);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 4)
  Object num304 = alloc_Float64(0);
// compiled num node returning num304 (depth = 4)
    gc_frame_newslot(num304);
    if302 = num304;
  }
stackframe = iftmpstackframe302;
// compiled if node returning if302 (depth = 3)
  *var_numOpening = if302;
  if (if302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num305 = alloc_Float64(0);
// compiled num node returning num305 (depth = 3)
  *var_numClosing = num305;
  if (num305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj306 = alloc_userobj2(4,4, objclass306);
  gc_frame_newslot(obj306);
  if (objclass306 == NULL) {
    glfree(obj306->class->name);
    obj306->class->name = "result";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj306, self, 0);
  addmethodreal(obj306,"outer", &reader_parser_outer_307);
  Object oldself306 = self;
  struct StackFrameObject *oldstackframe306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe306);
  gc_frame_newslot((Object)stackframe);
  self = obj306;
  Object *oldselfslot306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter306 = (*(struct UserObject *)self).data[0], lowerouter306 = thisouter306;
  if (inheritingObject306) {
    struct UserObject *inho306 = (struct UserObject *)inheritingObject306;
    while (inho306->super != GraceDefaultObject) inho306 = (struct UserObject *)inho306->super;
    inho306->super = obj306;
    self = inheritingObject306;
    *selfslot = self;
    lowerouter306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter306;
  }
  if (objclass306 == NULL) {
    Method *reader308 = addmethodrealflags(obj306, "found", &reader_parser_found_308, 0);
    Method *writer308 = addmethodrealflags(obj306, "found:=(1)", &writer_parser_found_308, 0);
    reader308->definitionModule = modulename;
    writer308->definitionModule = modulename;
    reader308->definitionLine = 181;
    writer308->definitionLine = 181;
  }
  obj306->flags |= OFLAG_MUTABLE;
  adddatum2(obj306, alloc_Undefined(), 1);
  if (objclass306 == NULL) {
    Method *reader309 = addmethodrealflags(obj306, "tok", &reader_parser_tok_309, 0);
    Method *writer309 = addmethodrealflags(obj306, "tok:=(1)", &writer_parser_tok_309, 0);
    reader309->definitionModule = modulename;
    writer309->definitionModule = modulename;
    reader309->definitionLine = 182;
    writer309->definitionLine = 182;
  }
  obj306->flags |= OFLAG_MUTABLE;
  adddatum2(obj306, alloc_Undefined(), 2);
  sourceObject = obj306;
  adddatum2(obj306, undefined, 1);
  sourceObject = obj306;
  adddatum2(obj306, undefined, 2);
  objclass306 = obj306->class;
  objclass306->definitionModule = modulename;
  objclass306->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter306;
  self = oldself306;
  selfslot = oldselfslot306;
  stackframe = oldstackframe306;
// compiled object node returning obj306 (depth = 3)
  *var_result = obj306;
  if (obj306 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe310 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block311 = alloc_Block(NULL, NULL, "parser", 185);
  gc_frame_newslot(block311);
// method "_apply"
  block_savedest(block311);
  Object closure312 = createclosure(3, "_apply");
  setclosureframe(closure312, stackframe);
  addtoclosure(closure312, var_token);
  addtoclosure(closure312, var_n);
  addtoclosure(closure312, selfslot);
  struct UserObject *uo312 = (struct UserObject*)block311;
  uo312->data[0] = (Object)closure312;
  Method *meth_meth_parser_312__apply = addmethod2pos(block311, "_apply", &meth_parser_312__apply, 0);
  int argcv_meth_parser_312__apply[] = {0};
  meth_meth_parser_312__apply->type = alloc_MethodType(1, argcv_meth_parser_312__apply);
  meth_meth_parser_312__apply->definitionModule = modulename;
  meth_meth_parser_312__apply->definitionLine = 3208;
// compiled block node returning block311 (depth = 3)
  gc_frame_newslot(block311);
// starting to compile block node (depth = 3)
  Object block330 = alloc_Block(NULL, NULL, "parser", 185);
  gc_frame_newslot(block330);
// method "_apply"
  block_savedest(block330);
  Object closure331 = createclosure(4, "_apply");
  setclosureframe(closure331, stackframe);
  addtoclosure(closure331, var_n);
  addtoclosure(closure331, var_numOpening);
  addtoclosure(closure331, var_numClosing);
  addtoclosure(closure331, selfslot);
  struct UserObject *uo331 = (struct UserObject*)block330;
  uo331->data[0] = (Object)closure331;
  Method *meth_meth_parser_331__apply = addmethod2pos(block330, "_apply", &meth_parser_331__apply, 0);
  int argcv_meth_parser_331__apply[] = {0};
  meth_meth_parser_331__apply->type = alloc_MethodType(1, argcv_meth_parser_331__apply);
  meth_meth_parser_331__apply->definitionModule = modulename;
  meth_meth_parser_331__apply->definitionLine = 3208;
// compiled block node returning block330 (depth = 3)
  gc_frame_newslot(block330);
// call case 5: prelude request
  params[0] = block311;
  params[1] = block330;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call360 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe310);
// compiled call node returning call360 (depth = 2)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe361 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block362 = alloc_Block(NULL, NULL, "parser", 191);
  gc_frame_newslot(block362);
// method "_apply"
  block_savedest(block362);
  Object closure363 = createclosure(3, "_apply");
  setclosureframe(closure363, stackframe);
  addtoclosure(closure363, var_token);
  addtoclosure(closure363, var_n);
  addtoclosure(closure363, selfslot);
  struct UserObject *uo363 = (struct UserObject*)block362;
  uo363->data[0] = (Object)closure363;
  Method *meth_meth_parser_363__apply = addmethod2pos(block362, "_apply", &meth_parser_363__apply, 0);
  int argcv_meth_parser_363__apply[] = {0};
  meth_meth_parser_363__apply->type = alloc_MethodType(1, argcv_meth_parser_363__apply);
  meth_meth_parser_363__apply->definitionModule = modulename;
  meth_meth_parser_363__apply->definitionLine = 3208;
// compiled block node returning block362 (depth = 3)
  gc_frame_newslot(block362);
// starting to compile block node (depth = 3)
  Object block381 = alloc_Block(NULL, NULL, "parser", 191);
  gc_frame_newslot(block381);
// method "_apply"
  block_savedest(block381);
  Object closure382 = createclosure(4, "_apply");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_n);
  addtoclosure(closure382, var_numOpening);
  addtoclosure(closure382, var_numClosing);
  addtoclosure(closure382, selfslot);
  struct UserObject *uo382 = (struct UserObject*)block381;
  uo382->data[0] = (Object)closure382;
  Method *meth_meth_parser_382__apply = addmethod2pos(block381, "_apply", &meth_parser_382__apply, 0);
  int argcv_meth_parser_382__apply[] = {0};
  meth_meth_parser_382__apply->type = alloc_MethodType(1, argcv_meth_parser_382__apply);
  meth_meth_parser_382__apply->definitionModule = modulename;
  meth_meth_parser_382__apply->definitionLine = 3208;
// compiled block node returning block381 (depth = 3)
  gc_frame_newslot(block381);
// call case 5: prelude request
  params[0] = block362;
  params[1] = block381;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call411 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe361);
// compiled call node returning call411 (depth = 2)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit414 == NULL) {
    strlit414 = alloc_String("rbrace");
    gc_root(strlit414);
  }
// compiled string node returning strlit414 (depth = 4)
  int op_slot_right_413 = gc_frame_newslot(strlit414);
// starting to compile member node (depth = 4)
  int callframe416 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  Object call417 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe416);
// compiled member node returning call417 (depth = 4)
  int op_slot_left_413 = gc_frame_newslot(call417);
  params[0] = strlit414;
  partcv[0] = 1;
  Object opresult418 = callmethod(call417, "==(1)", 1, partcv, params);
// compiled op node returning opresult418 (depth = 3)
  Object if412 = done;
  if (istrue(opresult418)) {
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe419 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool420 = alloc_Boolean(1);
// compiled identifier node returning bool420 (depth = 4)
  gc_frame_newslot(bool420);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = bool420;
  partcv[0] = 1;
  Object call421 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe419);
// compiled call node returning call421 (depth = 3)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call423 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe422);
// compiled call node returning call423 (depth = 3)
    gc_frame_newslot(call423);
    if412 = call423;
  } else {
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_426 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_426 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult428 = callmethod(*var_numOpening, "==(1)", 1, partcv, params);
// compiled op node returning opresult428 (depth = 5)
  int op_slot_right_425 = gc_frame_newslot(opresult428);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit431 == NULL) {
    strlit431 = alloc_String("rbrace");
    gc_root(strlit431);
  }
// compiled string node returning strlit431 (depth = 6)
  int op_slot_right_430 = gc_frame_newslot(strlit431);
// starting to compile member node (depth = 6)
  int callframe433 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe434 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call435 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe434);
// compiled member node returning call435 (depth = 7)
  Object call436 = callmethodflags(call435, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe433);
// compiled member node returning call436 (depth = 6)
  int op_slot_left_430 = gc_frame_newslot(call436);
  params[0] = strlit431;
  partcv[0] = 1;
  Object opresult437 = callmethod(call436, "==(1)", 1, partcv, params);
// compiled op node returning opresult437 (depth = 5)
  int op_slot_left_425 = gc_frame_newslot(opresult437);
  params[0] = opresult428;
  partcv[0] = 1;
  Object opresult438 = callmethod(opresult437, "&&(1)", 1, partcv, params);
// compiled op node returning opresult438 (depth = 4)
  Object if424 = done;
  if (istrue(opresult438)) {
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe439 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool440 = alloc_Boolean(1);
// compiled identifier node returning bool440 (depth = 5)
  gc_frame_newslot(bool440);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool440;
  partcv[0] = 1;
  Object call441 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe439);
// compiled call node returning call441 (depth = 4)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe442 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe443 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call444 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe443);
// compiled member node returning call444 (depth = 5)
  gc_frame_newslot(call444);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call444;
  partcv[0] = 1;
  Object call445 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe442);
// compiled call node returning call445 (depth = 4)
    gc_frame_newslot(call445);
    if424 = call445;
  } else {
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe446 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool447 = alloc_Boolean(0);
// compiled identifier node returning bool447 (depth = 5)
  gc_frame_newslot(bool447);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool447;
  partcv[0] = 1;
  Object call448 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe446);
// compiled call node returning call448 (depth = 4)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe449 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe450 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call451 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe450);
// compiled member node returning call451 (depth = 5)
  gc_frame_newslot(call451);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call451;
  partcv[0] = 1;
  Object call452 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe449);
// compiled call node returning call452 (depth = 4)
    gc_frame_newslot(call452);
    if424 = call452;
  }
// compiled if node returning if424 (depth = 3)
    gc_frame_newslot(if424);
    if412 = if424;
  }
// compiled if node returning if412 (depth = 2)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_453_accept_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_454 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
  int callframe456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call457 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe456);
// compiled member node returning call457 (depth = 3)
  int op_slot_left_454 = gc_frame_newslot(call457);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult458 = callmethod(call457, "==(1)", 1, partcv, params);
// compiled op node returning opresult458 (depth = 2)
  gc_frame_end(frame);
  return opresult458;
}
Object meth_parser_459_acceptKeyword_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_kw = &(stackframe->slots[0]);
  *var_kw = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptKeyword(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit462 == NULL) {
    strlit462 = alloc_String("keyword");
    gc_root(strlit462);
  }
// compiled string node returning strlit462 (depth = 4)
  int op_slot_right_461 = gc_frame_newslot(strlit462);
// starting to compile member node (depth = 4)
  int callframe464 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call465 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe464);
// compiled member node returning call465 (depth = 4)
  int op_slot_left_461 = gc_frame_newslot(call465);
  params[0] = strlit462;
  partcv[0] = 1;
  Object opresult466 = callmethod(call465, "≠(1)", 1, partcv, params);
// compiled op node returning opresult466 (depth = 3)
  Object if460 = done;
  if (istrue(opresult466)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool467 = alloc_Boolean(0);
// compiled identifier node returning bool467 (depth = 4)
  return bool467;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if460 = undefined;
  } else {
  }
// compiled if node returning if460 (depth = 2)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw (depth = 4)
  int op_slot_right_468 = gc_frame_newslot(*var_kw);
// starting to compile member node (depth = 4)
  int callframe470 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call471 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe470);
// compiled member node returning call471 (depth = 4)
  int op_slot_left_468 = gc_frame_newslot(call471);
  params[0] = *var_kw;
  partcv[0] = 1;
  Object opresult472 = callmethod(call471, "==(1)", 1, partcv, params);
// compiled op node returning opresult472 (depth = 3)
  return opresult472;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_473_acceptSameLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptSameLine(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptSameLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptSameLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_476 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
  int callframe478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call479 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe478);
// compiled member node returning call479 (depth = 5)
  int op_slot_left_476 = gc_frame_newslot(call479);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult480 = callmethod(call479, ">(1)", 1, partcv, params);
// compiled op node returning opresult480 (depth = 4)
  int op_slot_right_475 = gc_frame_newslot(opresult480);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call484 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe483);
// compiled member node returning call484 (depth = 5)
  int op_slot_right_482 = gc_frame_newslot(call484);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_482 = gc_frame_newslot(*var_lastLine);
  params[0] = call484;
  partcv[0] = 1;
  Object opresult486 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult486 (depth = 4)
  int op_slot_left_475 = gc_frame_newslot(opresult486);
  params[0] = opresult480;
  partcv[0] = 1;
  Object opresult487 = callmethod(opresult486, "||(1)", 1, partcv, params);
// compiled op node returning opresult487 (depth = 3)
  int op_slot_right_474 = gc_frame_newslot(opresult487);
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_489 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe491 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call492 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe491);
// compiled member node returning call492 (depth = 4)
  int op_slot_left_489 = gc_frame_newslot(call492);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult493 = callmethod(call492, "==(1)", 1, partcv, params);
// compiled op node returning opresult493 (depth = 3)
  int op_slot_left_474 = gc_frame_newslot(opresult493);
  params[0] = opresult487;
  partcv[0] = 1;
  Object opresult494 = callmethod(opresult493, "&&(1)", 1, partcv, params);
// compiled op node returning opresult494 (depth = 2)
  gc_frame_end(frame);
  return opresult494;
}
Object meth_parser_495_acceptWithoutSpaces_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptWithoutSpaces(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptWithoutSpaces(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptWithoutSpaces(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptWithoutSpaces(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe499 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call500 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe499);
// compiled member node returning call500 (depth = 5)
  int op_slot_right_498 = gc_frame_newslot(call500);
// starting to compile member node (depth = 5)
  int callframe502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call503 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe502);
// compiled member node returning call503 (depth = 5)
  int op_slot_left_498 = gc_frame_newslot(call503);
  params[0] = call500;
  partcv[0] = 1;
  Object sum504 = callmethod(call503, "+(1)", 1, partcv, params);
// compiled op node returning sum504 (depth = 4)
  int op_slot_right_497 = gc_frame_newslot(sum504);
// starting to compile member node (depth = 4)
  int callframe506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call507 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe506);
// compiled member node returning call507 (depth = 4)
  int op_slot_left_497 = gc_frame_newslot(call507);
  params[0] = sum504;
  partcv[0] = 1;
  Object opresult508 = callmethod(call507, "==(1)", 1, partcv, params);
// compiled op node returning opresult508 (depth = 3)
  int op_slot_right_496 = gc_frame_newslot(opresult508);
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call513 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe512);
// compiled member node returning call513 (depth = 5)
  int op_slot_right_511 = gc_frame_newslot(call513);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_511 = gc_frame_newslot(*var_lastLine);
  params[0] = call513;
  partcv[0] = 1;
  Object opresult515 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult515 (depth = 4)
  int op_slot_right_510 = gc_frame_newslot(opresult515);
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  int op_slot_right_517 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 5)
  int callframe519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call520 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe519);
// compiled member node returning call520 (depth = 5)
  int op_slot_left_517 = gc_frame_newslot(call520);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult521 = callmethod(call520, "==(1)", 1, partcv, params);
// compiled op node returning opresult521 (depth = 4)
  int op_slot_left_510 = gc_frame_newslot(opresult521);
  params[0] = opresult515;
  partcv[0] = 1;
  Object opresult522 = callmethod(opresult521, "&&(1)", 1, partcv, params);
// compiled op node returning opresult522 (depth = 3)
  int op_slot_left_496 = gc_frame_newslot(opresult522);
  params[0] = opresult508;
  partcv[0] = 1;
  Object opresult523 = callmethod(opresult522, "&&(1)", 1, partcv, params);
// compiled op node returning opresult523 (depth = 2)
  gc_frame_end(frame);
  return opresult523;
}
Object meth_parser_524_accept_40_1_41_onLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call529 = callmethodflags(*var_other, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe528);
// compiled member node returning call529 (depth = 5)
  int op_slot_right_527 = gc_frame_newslot(call529);
// starting to compile member node (depth = 5)
  int callframe531 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call532 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe531);
// compiled member node returning call532 (depth = 5)
  int op_slot_left_527 = gc_frame_newslot(call532);
  params[0] = call529;
  partcv[0] = 1;
  Object opresult533 = callmethod(call532, ">(1)", 1, partcv, params);
// compiled op node returning opresult533 (depth = 4)
  int op_slot_right_526 = gc_frame_newslot(opresult533);
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call537 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe536);
// compiled member node returning call537 (depth = 5)
  int op_slot_right_535 = gc_frame_newslot(call537);
// starting to compile member node (depth = 5)
  int callframe539 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call540 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe539);
// compiled member node returning call540 (depth = 5)
  int op_slot_left_535 = gc_frame_newslot(call540);
  params[0] = call537;
  partcv[0] = 1;
  Object opresult541 = callmethod(call540, "==(1)", 1, partcv, params);
// compiled op node returning opresult541 (depth = 4)
  int op_slot_left_526 = gc_frame_newslot(opresult541);
  params[0] = opresult533;
  partcv[0] = 1;
  Object opresult542 = callmethod(opresult541, "||(1)", 1, partcv, params);
// compiled op node returning opresult542 (depth = 3)
  int op_slot_right_525 = gc_frame_newslot(opresult542);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_544 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe546 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call547 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe546);
// compiled member node returning call547 (depth = 4)
  int op_slot_left_544 = gc_frame_newslot(call547);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult548 = callmethod(call547, "==(1)", 1, partcv, params);
// compiled op node returning opresult548 (depth = 3)
  int op_slot_left_525 = gc_frame_newslot(opresult548);
  params[0] = opresult542;
  partcv[0] = 1;
  Object opresult549 = callmethod(opresult548, "&&(1)", 1, partcv, params);
// compiled op node returning opresult549 (depth = 2)
  gc_frame_end(frame);
  return opresult549;
}
Object meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOfLastOr(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastIndent = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOfLastOr(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOfLastOr(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_552 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe554 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call555 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe554);
// compiled member node returning call555 (depth = 4)
  int op_slot_left_552 = gc_frame_newslot(call555);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult556 = callmethod(call555, "≠(1)", 1, partcv, params);
// compiled op node returning opresult556 (depth = 3)
  Object if551 = done;
  if (istrue(opresult556)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool557 = alloc_Boolean(0);
// compiled identifier node returning bool557 (depth = 4)
  return bool557;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if551 = undefined;
  } else {
  }
// compiled if node returning if551 (depth = 2)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call561 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe560);
// compiled member node returning call561 (depth = 4)
  int op_slot_right_559 = gc_frame_newslot(call561);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_559 = gc_frame_newslot(*var_lastLine);
  params[0] = call561;
  partcv[0] = 1;
  Object opresult563 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult563 (depth = 3)
  Object if558 = done;
  if (istrue(opresult563)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool564 = alloc_Boolean(1);
// compiled identifier node returning bool564 (depth = 4)
  return bool564;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if558 = undefined;
  } else {
  }
// compiled if node returning if558 (depth = 2)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_566 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe568 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call569 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe568);
// compiled member node returning call569 (depth = 4)
  int op_slot_left_566 = gc_frame_newslot(call569);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult570 = callmethod(call569, ">(1)", 1, partcv, params);
// compiled op node returning opresult570 (depth = 3)
  Object if565 = done;
  if (istrue(opresult570)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool571 = alloc_Boolean(1);
// compiled identifier node returning bool571 (depth = 4)
  return bool571;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if565 = undefined;
  } else {
  }
// compiled if node returning if565 (depth = 2)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe574 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call575 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe574);
// compiled member node returning call575 (depth = 4)
  int op_slot_right_573 = gc_frame_newslot(call575);
// starting to compile member node (depth = 4)
  int callframe577 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call578 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe577);
// compiled member node returning call578 (depth = 4)
  int op_slot_left_573 = gc_frame_newslot(call578);
  params[0] = call575;
  partcv[0] = 1;
  Object opresult579 = callmethod(call578, "==(1)", 1, partcv, params);
// compiled op node returning opresult579 (depth = 3)
  Object if572 = done;
  if (istrue(opresult579)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool580 = alloc_Boolean(1);
// compiled identifier node returning bool580 (depth = 4)
  return bool580;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if572 = undefined;
  } else {
  }
// compiled if node returning if572 (depth = 2)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe583 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call584 = callmethodflags(*var_other, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe583);
// compiled member node returning call584 (depth = 4)
  int op_slot_right_582 = gc_frame_newslot(call584);
// starting to compile member node (depth = 4)
  int callframe586 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call587 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe586);
// compiled member node returning call587 (depth = 4)
  int op_slot_left_582 = gc_frame_newslot(call587);
  params[0] = call584;
  partcv[0] = 1;
  Object opresult588 = callmethod(call587, ">(1)", 1, partcv, params);
// compiled op node returning opresult588 (depth = 3)
  Object if581 = done;
  if (istrue(opresult588)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool589 = alloc_Boolean(1);
// compiled identifier node returning bool589 (depth = 4)
  return bool589;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if581 = undefined;
  } else {
  }
// compiled if node returning if581 (depth = 2)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool590 = alloc_Boolean(0);
// compiled identifier node returning bool590 (depth = 3)
  return bool590;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_591_acceptArgumentOnLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptArgumentOnLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptArgumentOnLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptArgumentOnLineOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptArgumentOnLineOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe593 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit594 == NULL) {
    strlit594 = alloc_String("string");
    gc_root(strlit594);
  }
// compiled string node returning strlit594 (depth = 4)
  gc_frame_newslot(strlit594);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit594;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call595 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe593);
// compiled call node returning call595 (depth = 3)
  Object if592 = done;
  if (istrue(call595)) {
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool596 = alloc_Boolean(1);
// compiled identifier node returning bool596 (depth = 4)
  return bool596;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if592 = undefined;
  } else {
  }
// compiled if node returning if592 (depth = 2)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe598 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit599 == NULL) {
    strlit599 = alloc_String("num");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 4)
  gc_frame_newslot(strlit599);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit599;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call600 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compiled call node returning call600 (depth = 3)
  Object if597 = done;
  if (istrue(call600)) {
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool601 = alloc_Boolean(1);
// compiled identifier node returning bool601 (depth = 4)
  return bool601;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if597 = undefined;
  } else {
  }
// compiled if node returning if597 (depth = 2)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe603 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("lbrace");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 4)
  gc_frame_newslot(strlit604);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit604;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call605 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe603);
// compiled call node returning call605 (depth = 3)
  Object if602 = done;
  if (istrue(call605)) {
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool606 = alloc_Boolean(1);
// compiled identifier node returning bool606 (depth = 4)
  return bool606;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if602 = undefined;
  } else {
  }
// compiled if node returning if602 (depth = 2)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe608 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit609 == NULL) {
    strlit609 = alloc_String("lsquare");
    gc_root(strlit609);
  }
// compiled string node returning strlit609 (depth = 4)
  gc_frame_newslot(strlit609);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit609;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call610 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe608);
// compiled call node returning call610 (depth = 3)
  Object if607 = done;
  if (istrue(call610)) {
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool611 = alloc_Boolean(1);
// compiled identifier node returning bool611 (depth = 4)
  return bool611;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if607 = undefined;
  } else {
  }
// compiled if node returning if607 (depth = 2)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe613 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit614 == NULL) {
    strlit614 = alloc_String("identifier");
    gc_root(strlit614);
  }
// compiled string node returning strlit614 (depth = 4)
  gc_frame_newslot(strlit614);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit614;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call615 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe613);
// compiled call node returning call615 (depth = 3)
  Object if612 = done;
  if (istrue(call615)) {
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit618 == NULL) {
    strlit618 = alloc_String("false");
    gc_root(strlit618);
  }
// compiled string node returning strlit618 (depth = 6)
  int op_slot_right_617 = gc_frame_newslot(strlit618);
// starting to compile member node (depth = 6)
  int callframe620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call621 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe620);
// compiled member node returning call621 (depth = 6)
  int op_slot_left_617 = gc_frame_newslot(call621);
  params[0] = strlit618;
  partcv[0] = 1;
  Object opresult622 = callmethod(call621, "==(1)", 1, partcv, params);
// compiled op node returning opresult622 (depth = 5)
  int op_slot_right_616 = gc_frame_newslot(opresult622);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit625 == NULL) {
    strlit625 = alloc_String("true");
    gc_root(strlit625);
  }
// compiled string node returning strlit625 (depth = 6)
  int op_slot_right_624 = gc_frame_newslot(strlit625);
// starting to compile member node (depth = 6)
  int callframe627 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call628 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe627);
// compiled member node returning call628 (depth = 6)
  int op_slot_left_624 = gc_frame_newslot(call628);
  params[0] = strlit625;
  partcv[0] = 1;
  Object opresult629 = callmethod(call628, "==(1)", 1, partcv, params);
// compiled op node returning opresult629 (depth = 5)
  int op_slot_left_616 = gc_frame_newslot(opresult629);
  params[0] = opresult622;
  partcv[0] = 1;
  Object opresult630 = callmethod(opresult629, "||(1)", 1, partcv, params);
// compiled op node returning opresult630 (depth = 4)
  return opresult630;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if612 = undefined;
  } else {
  }
// compiled if node returning if612 (depth = 2)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool631 = alloc_Boolean(0);
// compiled identifier node returning bool631 (depth = 3)
  return bool631;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_632_tokenOnSameLine(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_634 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call637 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe636);
// compiled member node returning call637 (depth = 4)
  int op_slot_left_634 = gc_frame_newslot(call637);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult638 = callmethod(call637, ">(1)", 1, partcv, params);
// compiled op node returning opresult638 (depth = 3)
  int op_slot_right_633 = gc_frame_newslot(opresult638);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call642 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe641);
// compiled member node returning call642 (depth = 4)
  int op_slot_right_640 = gc_frame_newslot(call642);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_640 = gc_frame_newslot(*var_lastLine);
  params[0] = call642;
  partcv[0] = 1;
  Object opresult644 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult644 (depth = 3)
  int op_slot_left_633 = gc_frame_newslot(opresult644);
  params[0] = opresult638;
  partcv[0] = 1;
  Object opresult645 = callmethod(opresult644, "||(1)", 1, partcv, params);
// compiled op node returning opresult645 (depth = 2)
  gc_frame_end(frame);
  return opresult645;
}
Object meth_parser_646_tokenOnLineOfLastOr_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnLineOfLastOr(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokenOnLineOfLastOr(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastIndent = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokenOnLineOfLastOr(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tokenOnLineOfLastOr(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe649 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call650 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe649);
// compiled member node returning call650 (depth = 4)
  int op_slot_right_648 = gc_frame_newslot(call650);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_648 = gc_frame_newslot(*var_lastLine);
  params[0] = call650;
  partcv[0] = 1;
  Object opresult652 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult652 (depth = 3)
  Object if647 = done;
  if (istrue(opresult652)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool653 = alloc_Boolean(1);
// compiled identifier node returning bool653 (depth = 4)
  return bool653;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if647 = undefined;
  } else {
  }
// compiled if node returning if647 (depth = 2)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_655 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe657 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call658 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled member node returning call658 (depth = 4)
  int op_slot_left_655 = gc_frame_newslot(call658);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult659 = callmethod(call658, ">(1)", 1, partcv, params);
// compiled op node returning opresult659 (depth = 3)
  Object if654 = done;
  if (istrue(opresult659)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool660 = alloc_Boolean(1);
// compiled identifier node returning bool660 (depth = 4)
  return bool660;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if654 = undefined;
  } else {
  }
// compiled if node returning if654 (depth = 2)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe663 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call664 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe663);
// compiled member node returning call664 (depth = 4)
  int op_slot_right_662 = gc_frame_newslot(call664);
// starting to compile member node (depth = 4)
  int callframe666 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call667 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe666);
// compiled member node returning call667 (depth = 4)
  int op_slot_left_662 = gc_frame_newslot(call667);
  params[0] = call664;
  partcv[0] = 1;
  Object opresult668 = callmethod(call667, "==(1)", 1, partcv, params);
// compiled op node returning opresult668 (depth = 3)
  Object if661 = done;
  if (istrue(opresult668)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool669 = alloc_Boolean(1);
// compiled identifier node returning bool669 (depth = 4)
  return bool669;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if661 = undefined;
  } else {
  }
// compiled if node returning if661 (depth = 2)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call673 = callmethodflags(*var_other, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe672);
// compiled member node returning call673 (depth = 4)
  int op_slot_right_671 = gc_frame_newslot(call673);
// starting to compile member node (depth = 4)
  int callframe675 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call676 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe675);
// compiled member node returning call676 (depth = 4)
  int op_slot_left_671 = gc_frame_newslot(call676);
  params[0] = call673;
  partcv[0] = 1;
  Object opresult677 = callmethod(call676, ">(1)", 1, partcv, params);
// compiled op node returning opresult677 (depth = 3)
  Object if670 = done;
  if (istrue(opresult677)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool678 = alloc_Boolean(1);
// compiled identifier node returning bool678 (depth = 4)
  return bool678;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if670 = undefined;
  } else {
  }
// compiled if node returning if670 (depth = 2)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool679 = alloc_Boolean(0);
// compiled identifier node returning bool679 (depth = 3)
  return bool679;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_680_didConsume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didConsume(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didConsume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part didConsume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe681 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call682 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe681);
// compiled member node returning call682 (depth = 3)
  *var_sz = call682;
  if (call682 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aParsingBlock (depth = 3)
  Object call684 = callmethodflags(*var_aParsingBlock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe683);
// compiled member node returning call684 (depth = 2)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_685 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call688 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe687);
// compiled member node returning call688 (depth = 3)
  int op_slot_left_685 = gc_frame_newslot(call688);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult689 = callmethod(call688, "≠(1)", 1, partcv, params);
// compiled op node returning opresult689 (depth = 2)
  gc_frame_end(frame);
  return opresult689;
}
Object meth_parser_690_didNotConsume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didNotConsume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didNotConsume(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didNotConsume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part didNotConsume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call692 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe691);
// compiled member node returning call692 (depth = 3)
  *var_sz = call692;
  if (call692 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aParsingBlock (depth = 3)
  Object call694 = callmethodflags(*var_aParsingBlock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 2)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_695 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe697 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call698 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe697);
// compiled member node returning call698 (depth = 3)
  int op_slot_left_695 = gc_frame_newslot(call698);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult699 = callmethod(call698, "==(1)", 1, partcv, params);
// compiled op node returning opresult699 (depth = 2)
  gc_frame_end(frame);
  return opresult699;
}
Object meth_parser_700_pushnum(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe701 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call703 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled member node returning call703 (depth = 4)
  gc_frame_newslot(call703);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call705 = callmethodflags(*var_ast, "numNode", 0, partcv, params, 0);
  gc_frame_end(callframe704);
// compiled member node returning call705 (depth = 4)
  params[0] = call703;
  partcv[0] = 1;
  Object call706 = callmethodflags(call705, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe701);
// compiled call node returning call706 (depth = 3)
  *var_o = call706;
  if (call706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe707 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call708 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe707);
// compiled call node returning call708 (depth = 2)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe709 = gc_frame_new();
// call case 4: self request
  Object call710 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe709);
// compiled member node returning call710 (depth = 2)
  gc_frame_end(frame);
  return call710;
}
Object meth_parser_711_pushstring(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe712 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe713 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call714 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe713);
// compiled member node returning call714 (depth = 4)
  gc_frame_newslot(call714);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call716 = callmethodflags(*var_ast, "stringNode", 0, partcv, params, 0);
  gc_frame_end(callframe715);
// compiled member node returning call716 (depth = 4)
  params[0] = call714;
  partcv[0] = 1;
  Object call717 = callmethodflags(call716, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe712);
// compiled call node returning call717 (depth = 3)
  *var_o = call717;
  if (call717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe718 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe719 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe720 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call721 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe720);
// compiled member node returning call721 (depth = 4)
  gc_frame_newslot(call721);
// starting to compile member node (depth = 4)
  int callframe722 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call723 = callmethodflags(*var_sym, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe722);
// compiled member node returning call723 (depth = 4)
  gc_frame_newslot(call723);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ast (depth = 4)
  params[0] = call721;
  params[1] = call723;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call724 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe719);
// compiled call node returning call724 (depth = 3)
  gc_frame_newslot(call724);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call724;
  partcv[0] = 1;
  Object call725 = callmethodflags(*var_o, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe718);
// compiled call node returning call725 (depth = 2)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe726 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call727 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe726);
// compiled call node returning call727 (depth = 2)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe728 = gc_frame_new();
// call case 4: self request
  Object call729 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe728);
// compiled member node returning call729 (depth = 2)
  gc_frame_end(frame);
  return call729;
}
Object meth_parser_730_pushidentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe731 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe732 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call733 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe732);
// compiled member node returning call733 (depth = 3)
  gc_frame_newslot(call733);
// starting to compile member node (depth = 3)
  int callframe734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call735 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe734);
// compiled member node returning call735 (depth = 3)
  gc_frame_newslot(call735);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call733;
  params[1] = call735;
  partcv[0] = 2;
  Object call736 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe731);
// compiled call node returning call736 (depth = 2)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit739 == NULL) {
    strlit739 = alloc_String("_");
    gc_root(strlit739);
  }
// compiled string node returning strlit739 (depth = 5)
  int op_slot_right_738 = gc_frame_newslot(strlit739);
// starting to compile member node (depth = 5)
  int callframe741 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call742 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe741);
// compiled member node returning call742 (depth = 5)
  int op_slot_left_738 = gc_frame_newslot(call742);
  params[0] = strlit739;
  partcv[0] = 1;
  Object opresult743 = callmethod(call742, "==(1)", 1, partcv, params);
// compiled op node returning opresult743 (depth = 4)
  Object if737 = done;
struct StackFrameObject *iftmpstackframe737 = stackframe;
  if (istrue(opresult743)) {
stackframe = alloc_StackFrame(0, iftmpstackframe737);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe744 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool745 = alloc_Boolean(0);
// compiled identifier node returning bool745 (depth = 5)
  gc_frame_newslot(bool745);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe746 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call747 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe746);
// compiled member node returning call747 (depth = 5)
  params[0] = bool745;
  partcv[0] = 1;
  Object call748 = callmethodflags(call747, "wildcard(1)", 1, partcv, params, 0);
  gc_frame_end(callframe744);
// compiled call node returning call748 (depth = 4)
    gc_frame_newslot(call748);
    if737 = call748;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe737);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe749 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call751 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe750);
// compiled member node returning call751 (depth = 5)
  gc_frame_newslot(call751);
// starting to compile identifier node (depth = 5)
  Object bool752 = alloc_Boolean(0);
// compiled identifier node returning bool752 (depth = 5)
  gc_frame_newslot(bool752);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call754 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe753);
// compiled member node returning call754 (depth = 5)
  params[0] = call751;
  params[1] = bool752;
  partcv[0] = 2;
  Object call755 = callmethodflags(call754, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe749);
// compiled call node returning call755 (depth = 4)
    gc_frame_newslot(call755);
    if737 = call755;
  }
stackframe = iftmpstackframe737;
// compiled if node returning if737 (depth = 3)
  *var_o = if737;
  if (if737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe756 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call757 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe756);
// compiled call node returning call757 (depth = 2)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe758 = gc_frame_new();
// call case 4: self request
  Object call759 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe758);
// compiled member node returning call759 (depth = 2)
  gc_frame_end(frame);
  return call759;
}
Object meth_parser_781__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe783 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call784 = callmethodflags(*var_a, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe783);
// compiled member node returning call784 (depth = 11)
  int op_slot_right_782 = gc_frame_newslot(call784);
// starting to compile identifier node (depth = 11)
  Object bool786 = alloc_Boolean(0);
// compiled identifier node returning bool786 (depth = 11)
  int op_slot_left_782 = gc_frame_newslot(bool786);
  params[0] = call784;
  partcv[0] = 1;
  Object opresult787 = callmethod(bool786, "≠(1)", 1, partcv, params);
// compiled op node returning opresult787 (depth = 10)
  gc_frame_end(frame);
  return opresult787;
}
Object meth_parser_799__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit801 == NULL) {
    strlit801 = alloc_String(":");
    gc_root(strlit801);
  }
// compiled string node returning strlit801 (depth = 11)
  int op_slot_right_800 = gc_frame_newslot(strlit801);
// starting to compile member node (depth = 11)
  int callframe803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call804 = callmethodflags(*var_tok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe803);
// compiled member node returning call804 (depth = 11)
  int op_slot_left_800 = gc_frame_newslot(call804);
  params[0] = strlit801;
  partcv[0] = 1;
  Object opresult805 = callmethod(call804, "≠(1)", 1, partcv, params);
// compiled op node returning opresult805 (depth = 10)
  gc_frame_end(frame);
  return opresult805;
}
Object meth_parser_808__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe809 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call810 = callmethodflags(*var_tok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe809);
// compiled member node returning call810 (depth = 11)
  *var_tok = call810;
  if (call810 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_777__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block780 = alloc_Block(NULL, NULL, "parser", 325);
  gc_frame_newslot(block780);
// method "_apply"
  block_savedest(block780);
  Object closure781 = createclosure(2, "_apply");
  setclosureframe(closure781, stackframe);
  addtoclosure(closure781, var_a);
  addtoclosure(closure781, selfslot);
  struct UserObject *uo781 = (struct UserObject*)block780;
  uo781->data[0] = (Object)closure781;
  Method *meth_meth_parser_781__apply = addmethod2pos(block780, "_apply", &meth_parser_781__apply, 0);
  int argcv_meth_parser_781__apply[] = {0};
  meth_meth_parser_781__apply->type = alloc_MethodType(1, argcv_meth_parser_781__apply);
  meth_meth_parser_781__apply->definitionModule = modulename;
  meth_meth_parser_781__apply->definitionLine = 3208;
// compiled block node returning block780 (depth = 9)
  int op_slot_right_779 = gc_frame_newslot(block780);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit791 == NULL) {
    strlit791 = alloc_String("identifier");
    gc_root(strlit791);
  }
// compiled string node returning strlit791 (depth = 10)
  int op_slot_right_790 = gc_frame_newslot(strlit791);
// starting to compile member node (depth = 10)
  int callframe793 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  Object call794 = callmethodflags(*var_a, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe793);
// compiled member node returning call794 (depth = 10)
  int op_slot_left_790 = gc_frame_newslot(call794);
  params[0] = strlit791;
  partcv[0] = 1;
  Object opresult795 = callmethod(call794, "==(1)", 1, partcv, params);
// compiled op node returning opresult795 (depth = 9)
  int op_slot_left_779 = gc_frame_newslot(opresult795);
  params[0] = block780;
  partcv[0] = 1;
  Object opresult796 = callmethod(opresult795, "&&(1)", 1, partcv, params);
// compiled op node returning opresult796 (depth = 8)
  Object if778 = done;
  if (istrue(opresult796)) {
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe797 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block798 = alloc_Block(NULL, NULL, "parser", 328);
  gc_frame_newslot(block798);
// method "_apply"
  block_savedest(block798);
  Object closure799 = createclosure(2, "_apply");
  setclosureframe(closure799, stackframe);
  addtoclosure(closure799, var_tok);
  addtoclosure(closure799, selfslot);
  struct UserObject *uo799 = (struct UserObject*)block798;
  uo799->data[0] = (Object)closure799;
  Method *meth_meth_parser_799__apply = addmethod2pos(block798, "_apply", &meth_parser_799__apply, 0);
  int argcv_meth_parser_799__apply[] = {0};
  meth_meth_parser_799__apply->type = alloc_MethodType(1, argcv_meth_parser_799__apply);
  meth_meth_parser_799__apply->definitionModule = modulename;
  meth_meth_parser_799__apply->definitionLine = 3208;
// compiled block node returning block798 (depth = 9)
  gc_frame_newslot(block798);
// starting to compile block node (depth = 9)
  Object block807 = alloc_Block(NULL, NULL, "parser", 328);
  gc_frame_newslot(block807);
// method "_apply"
  block_savedest(block807);
  Object closure808 = createclosure(2, "_apply");
  setclosureframe(closure808, stackframe);
  addtoclosure(closure808, var_tok);
  addtoclosure(closure808, selfslot);
  struct UserObject *uo808 = (struct UserObject*)block807;
  uo808->data[0] = (Object)closure808;
  Method *meth_meth_parser_808__apply = addmethod2pos(block807, "_apply", &meth_parser_808__apply, 0);
  int argcv_meth_parser_808__apply[] = {0};
  meth_meth_parser_808__apply->type = alloc_MethodType(1, argcv_meth_parser_808__apply);
  meth_meth_parser_808__apply->definitionModule = modulename;
  meth_meth_parser_808__apply->definitionLine = 3208;
// compiled block node returning block807 (depth = 9)
  gc_frame_newslot(block807);
// call case 5: prelude request
  params[0] = block798;
  params[1] = block807;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call813 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe797);
// compiled call node returning call813 (depth = 8)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call816 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe815);
// compiled member node returning call816 (depth = 10)
  Object call817 = callmethodflags(call816, "new", 0, partcv, params, 0);
  gc_frame_end(callframe814);
// compiled member node returning call817 (depth = 9)
  *var_suggestion = call817;
  if (call817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe818 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
  int callframe819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call820 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe819);
// compiled member node returning call820 (depth = 9)
  gc_frame_newslot(call820);
// starting to compile identifier node (depth = 9)
  Object bool821 = alloc_Boolean(1);
// compiled identifier node returning bool821 (depth = 9)
  gc_frame_newslot(bool821);
// starting to compile identifier node (depth = 9)
  Object bool822 = alloc_Boolean(0);
// compiled identifier node returning bool822 (depth = 9)
  gc_frame_newslot(bool822);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call820;
  params[2] = bool821;
  params[3] = bool822;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call823 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe818);
// compiled call node returning call823 (depth = 8)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe824 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit825 == NULL) {
    strlit825 = alloc_String("an argument to an annotation cannot have a type.");
    gc_root(strlit825);
  }
// compiled string node returning strlit825 (depth = 9)
  gc_frame_newslot(strlit825);
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe826 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call827 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe826);
// compiled member node returning call827 (depth = 9)
  gc_frame_newslot(call827);
// starting to compile member node (depth = 9)
  int callframe828 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call829 = callmethodflags(*var_tok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe828);
// compiled member node returning call829 (depth = 9)
  gc_frame_newslot(call829);
// starting to compile member node (depth = 9)
  int callframe830 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  Object call832 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe831);
// compiled member node returning call832 (depth = 10)
  Object call833 = callmethodflags(call832, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe830);
// compiled member node returning call833 (depth = 9)
  gc_frame_newslot(call833);
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit825;
  params[1] = call827;
  params[2] = call829;
  params[3] = call833;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call834 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe824);
// compiled call node returning call834 (depth = 8)
    gc_frame_newslot(call834);
    if778 = call834;
  } else {
  }
// compiled if node returning if778 (depth = 7)
  gc_frame_end(frame);
  return if778;
}
Object meth_parser_772__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe773 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  Object call775 = callmethodflags(*var_p, "args", 0, partcv, params, 0);
  gc_frame_end(callframe774);
// compiled member node returning call775 (depth = 6)
  gc_frame_newslot(call775);
// starting to compile block node (depth = 6)
  Object block776 = alloc_Block(NULL, NULL, "parser", 324);
  gc_frame_newslot(block776);
// method "_apply(_)"
  block_savedest(block776);
  Object closure777 = createclosure(3, "_apply(1)");
  setclosureframe(closure777, stackframe);
  addtoclosure(closure777, var_sym);
  addtoclosure(closure777, var_errormessages);
  addtoclosure(closure777, selfslot);
  struct UserObject *uo777 = (struct UserObject*)block776;
  uo777->data[0] = (Object)closure777;
  Method *meth_meth_parser_777__apply_40_1_41_ = addmethod2pos(block776, "_apply(1)", &meth_parser_777__apply_40_1_41_, 0);
  int argcv_meth_parser_777__apply_40_1_41_[] = {1};
  meth_meth_parser_777__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_777__apply_40_1_41_);
  meth_meth_parser_777__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_777__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block776 (depth = 6)
  gc_frame_newslot(block776);
// call case 5: prelude request
  params[0] = call775;
  params[1] = block776;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call836 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe773);
// compiled call node returning call836 (depth = 5)
  gc_frame_end(frame);
  return call836;
}
Object meth_parser_760_checkAnnotation_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkAnnotation(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkAnnotation(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part checkAnnotation(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit763 == NULL) {
    strlit763 = alloc_String("call");
    gc_root(strlit763);
  }
// compiled string node returning strlit763 (depth = 4)
  int op_slot_right_762 = gc_frame_newslot(strlit763);
// starting to compile member node (depth = 4)
  int callframe765 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  Object call766 = callmethodflags(*var_ann, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe765);
// compiled member node returning call766 (depth = 4)
  int op_slot_left_762 = gc_frame_newslot(call766);
  params[0] = strlit763;
  partcv[0] = 1;
  Object opresult767 = callmethod(call766, "==(1)", 1, partcv, params);
// compiled op node returning opresult767 (depth = 3)
  Object if761 = done;
  if (istrue(opresult767)) {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe768 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe769 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  Object call770 = callmethodflags(*var_ann, "with", 0, partcv, params, 0);
  gc_frame_end(callframe769);
// compiled member node returning call770 (depth = 4)
  gc_frame_newslot(call770);
// starting to compile block node (depth = 4)
  Object block771 = alloc_Block(NULL, NULL, "parser", 323);
  gc_frame_newslot(block771);
// method "_apply(_)"
  block_savedest(block771);
  Object closure772 = createclosure(3, "_apply(1)");
  setclosureframe(closure772, stackframe);
  addtoclosure(closure772, var_sym);
  addtoclosure(closure772, var_errormessages);
  addtoclosure(closure772, selfslot);
  struct UserObject *uo772 = (struct UserObject*)block771;
  uo772->data[0] = (Object)closure772;
  Method *meth_meth_parser_772__apply_40_1_41_ = addmethod2pos(block771, "_apply(1)", &meth_parser_772__apply_40_1_41_, 0);
  int argcv_meth_parser_772__apply_40_1_41_[] = {1};
  meth_meth_parser_772__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_772__apply_40_1_41_);
  meth_meth_parser_772__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_772__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block771 (depth = 4)
  gc_frame_newslot(block771);
// call case 5: prelude request
  params[0] = call770;
  params[1] = block771;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call838 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe768);
// compiled call node returning call838 (depth = 3)
    gc_frame_newslot(call838);
    if761 = call838;
  } else {
  }
// compiled if node returning if761 (depth = 2)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser_853__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe854 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_noBlocks (depth = 6)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call855 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe854);
// compiled call node returning call855 (depth = 5)
  gc_frame_end(frame);
  return call855;
}
Object meth_parser_862__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe863 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit864 == NULL) {
    strlit864 = alloc_String("comma");
    gc_root(strlit864);
  }
// compiled string node returning strlit864 (depth = 5)
  gc_frame_newslot(strlit864);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit864;
  partcv[0] = 1;
  Object call865 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call865 (depth = 4)
  gc_frame_end(frame);
  return call865;
}
Object meth_parser_880__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe881 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call882 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe881);
// compiled call node returning call882 (depth = 7)
  gc_frame_end(frame);
  return call882;
}
Object meth_parser_868__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe869 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe870 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe871 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call872 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe871);
// compiled member node returning call872 (depth = 6)
  gc_frame_newslot(call872);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = call872;
  partcv[0] = 1;
  Object call873 = callmethodflags(module_parser, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe870);
// compiled call node returning call873 (depth = 5)
  gc_frame_newslot(call873);
// call case 6: other requests
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call873;
  partcv[0] = 1;
  Object call874 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe869);
// compiled call node returning call874 (depth = 4)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe875 = gc_frame_new();
// call case 4: self request
  Object call876 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe875);
// compiled member node returning call876 (depth = 4)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe878 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block879 = alloc_Block(NULL, NULL, "parser", 352);
  gc_frame_newslot(block879);
// method "_apply"
  block_savedest(block879);
  Object closure880 = createclosure(2, "_apply");
  setclosureframe(closure880, stackframe);
  addtoclosure(closure880, var_noBlocks);
  addtoclosure(closure880, selfslot);
  struct UserObject *uo880 = (struct UserObject*)block879;
  uo880->data[0] = (Object)closure880;
  Method *meth_meth_parser_880__apply = addmethod2pos(block879, "_apply", &meth_parser_880__apply, 0);
  int argcv_meth_parser_880__apply[] = {0};
  meth_meth_parser_880__apply->type = alloc_MethodType(1, argcv_meth_parser_880__apply);
  meth_meth_parser_880__apply->definitionModule = modulename;
  meth_meth_parser_880__apply->definitionLine = 3208;
// compiled block node returning block879 (depth = 6)
  gc_frame_newslot(block879);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block879;
  partcv[0] = 1;
  Object call884 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe878);
// compiled call node returning call884 (depth = 5)
  Object if877 = done;
  if (istrue(call884)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe885 = gc_frame_new();
// call case 4: self request
  Object call886 = callmethodflags(self, "errorMissingAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe885);
// compiled member node returning call886 (depth = 5)
    gc_frame_newslot(call886);
    if877 = call886;
  } else {
  }
// compiled if node returning if877 (depth = 4)
  gc_frame_end(frame);
  return if877;
}
Object meth_parser_839_doannotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
// definebindings:
// definebindings:
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe841 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe842 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit843 == NULL) {
    strlit843 = alloc_String("is");
    gc_root(strlit843);
  }
// compiled string node returning strlit843 (depth = 5)
  gc_frame_newslot(strlit843);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit843;
  partcv[0] = 1;
  Object call844 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe842);
// compiled call node returning call844 (depth = 4)
  Object call845 = callmethodflags(call844, "not", 0, partcv, params, 0);
  gc_frame_end(callframe841);
// compiled member node returning call845 (depth = 3)
  Object if840 = done;
  if (istrue(call845)) {
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool846 = alloc_Boolean(0);
// compiled identifier node returning bool846 (depth = 4)
  return bool846;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if840 = undefined;
  } else {
  }
// compiled if node returning if840 (depth = 2)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe847 = gc_frame_new();
// call case 4: self request
  Object call848 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe847);
// compiled member node returning call848 (depth = 2)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array849 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array849 (depth = 3)
  *var_anns = array849;
  if (array849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe851 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block852 = alloc_Block(NULL, NULL, "parser", 346);
  gc_frame_newslot(block852);
// method "_apply"
  block_savedest(block852);
  Object closure853 = createclosure(2, "_apply");
  setclosureframe(closure853, stackframe);
  addtoclosure(closure853, var_noBlocks);
  addtoclosure(closure853, selfslot);
  struct UserObject *uo853 = (struct UserObject*)block852;
  uo853->data[0] = (Object)closure853;
  Method *meth_meth_parser_853__apply = addmethod2pos(block852, "_apply", &meth_parser_853__apply, 0);
  int argcv_meth_parser_853__apply[] = {0};
  meth_meth_parser_853__apply->type = alloc_MethodType(1, argcv_meth_parser_853__apply);
  meth_meth_parser_853__apply->definitionModule = modulename;
  meth_meth_parser_853__apply->definitionLine = 3208;
// compiled block node returning block852 (depth = 4)
  gc_frame_newslot(block852);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block852;
  partcv[0] = 1;
  Object call857 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe851);
// compiled call node returning call857 (depth = 3)
  Object if850 = done;
  if (istrue(call857)) {
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe858 = gc_frame_new();
// call case 4: self request
  Object call859 = callmethodflags(self, "errorMissingAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe858);
// compiled member node returning call859 (depth = 3)
    gc_frame_newslot(call859);
    if850 = call859;
  } else {
  }
// compiled if node returning if850 (depth = 2)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe860 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block861 = alloc_Block(NULL, NULL, "parser", 349);
  gc_frame_newslot(block861);
// method "_apply"
  block_savedest(block861);
  Object closure862 = createclosure(1, "_apply");
  setclosureframe(closure862, stackframe);
  addtoclosure(closure862, selfslot);
  struct UserObject *uo862 = (struct UserObject*)block861;
  uo862->data[0] = (Object)closure862;
  Method *meth_meth_parser_862__apply = addmethod2pos(block861, "_apply", &meth_parser_862__apply, 0);
  int argcv_meth_parser_862__apply[] = {0};
  meth_meth_parser_862__apply->type = alloc_MethodType(1, argcv_meth_parser_862__apply);
  meth_meth_parser_862__apply->definitionModule = modulename;
  meth_meth_parser_862__apply->definitionLine = 3208;
// compiled block node returning block861 (depth = 3)
  gc_frame_newslot(block861);
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block867 = alloc_Block(NULL, NULL, "parser", 349);
  gc_frame_newslot(block867);
// method "_apply"
  block_savedest(block867);
  Object closure868 = createclosure(4, "_apply");
  setclosureframe(closure868, stackframe);
  addtoclosure(closure868, var_values);
  addtoclosure(closure868, var_anns);
  addtoclosure(closure868, var_noBlocks);
  addtoclosure(closure868, selfslot);
  struct UserObject *uo868 = (struct UserObject*)block867;
  uo868->data[0] = (Object)closure868;
  Method *meth_meth_parser_868__apply = addmethod2pos(block867, "_apply", &meth_parser_868__apply, 0);
  int argcv_meth_parser_868__apply[] = {0};
  meth_meth_parser_868__apply->type = alloc_MethodType(1, argcv_meth_parser_868__apply);
  meth_meth_parser_868__apply->definitionModule = modulename;
  meth_meth_parser_868__apply->definitionLine = 3208;
// compiled block node returning block867 (depth = 3)
  gc_frame_newslot(block867);
// call case 5: prelude request
  params[0] = block861;
  params[1] = block867;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call888 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe860);
// compiled call node returning call888 (depth = 2)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe889 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe890 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe891 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call892 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe891);
// compiled member node returning call892 (depth = 4)
  gc_frame_newslot(call892);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = call892;
  partcv[0] = 1;
  Object call893 = callmethodflags(module_parser, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe890);
// compiled call node returning call893 (depth = 3)
  gc_frame_newslot(call893);
// call case 6: other requests
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call893;
  partcv[0] = 1;
  Object call894 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe889);
// compiled call node returning call894 (depth = 2)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser_895_errorMissingAnnotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorMissingAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array896 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array896 (depth = 3)
  *var_suggestions = array896;
  if (array896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe897 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe898 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call899 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe898);
// compiled member node returning call899 (depth = 4)
  Object call900 = callmethodflags(call899, "new", 0, partcv, params, 0);
  gc_frame_end(callframe897);
// compiled member node returning call900 (depth = 3)
  *var_suggestion = call900;
  if (call900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe901 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array902 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 5)
  if (strlit903 == NULL) {
    strlit903 = alloc_String("bind");
    gc_root(strlit903);
  }
// compiled string node returning strlit903 (depth = 5)
  params[0] = strlit903;
  partcv[0] = 1;
  callmethodflags(array902, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array902 (depth = 4)
  gc_frame_newslot(array902);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array902;
  partcv[0] = 1;
  Object call904 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe901);
// compiled call node returning call904 (depth = 3)
  *var_nextTok = call904;
  if (call904 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_906 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_906 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult908 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult908 (depth = 3)
  Object if905 = done;
  if (istrue(opresult908)) {
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe909 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit910 == NULL) {
    strlit910 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit910);
  }
// compiled string node returning strlit910 (depth = 4)
  gc_frame_newslot(strlit910);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit910;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call911 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe909);
// compiled call node returning call911 (depth = 3)
    gc_frame_newslot(call911);
    if905 = call911;
  } else {
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe912 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe913 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  Object call914 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe913);
// compiled member node returning call914 (depth = 4)
  gc_frame_newslot(call914);
// starting to compile identifier node (depth = 4)
  Object bool915 = alloc_Boolean(1);
// compiled identifier node returning bool915 (depth = 4)
  gc_frame_newslot(bool915);
// starting to compile identifier node (depth = 4)
  Object bool916 = alloc_Boolean(0);
// compiled identifier node returning bool916 (depth = 4)
  gc_frame_newslot(bool916);
// starting to compile string node (depth = 4)
  if (strlit917 == NULL) {
    strlit917 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit917);
  }
// compiled string node returning strlit917 (depth = 4)
  gc_frame_newslot(strlit917);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call914;
  params[2] = bool915;
  params[3] = bool916;
  params[4] = strlit917;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call918 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe912);
// compiled call node returning call918 (depth = 3)
    gc_frame_newslot(call918);
    if905 = call918;
  }
// compiled if node returning if905 (depth = 2)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe919 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call920 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe919);
// compiled call node returning call920 (depth = 2)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe921 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe922 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call923 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe922);
// compiled member node returning call923 (depth = 4)
  Object call924 = callmethodflags(call923, "new", 0, partcv, params, 0);
  gc_frame_end(callframe921);
// compiled member node returning call924 (depth = 3)
  *var_suggestion = call924;
  if (call924 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe926 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe927 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  Object call928 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe927);
// compiled member node returning call928 (depth = 3)
  gc_frame_newslot(call928);
// starting to compile identifier node (depth = 3)
  Object bool929 = alloc_Boolean(1);
// compiled identifier node returning bool929 (depth = 3)
  gc_frame_newslot(bool929);
// starting to compile identifier node (depth = 3)
  Object bool930 = alloc_Boolean(0);
// compiled identifier node returning bool930 (depth = 3)
  gc_frame_newslot(bool930);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call928;
  params[2] = bool929;
  params[3] = bool930;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call931 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe926);
// compiled call node returning call931 (depth = 2)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe932 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call933 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe932);
// compiled call node returning call933 (depth = 2)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe934 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit935 == NULL) {
    strlit935 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit935);
  }
// compiled string node returning strlit935 (depth = 3)
  gc_frame_newslot(strlit935);
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  Object call937 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe936);
// compiled member node returning call937 (depth = 3)
  gc_frame_newslot(call937);
// starting to compile member node (depth = 3)
  int callframe938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  Object call939 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe938);
// compiled member node returning call939 (depth = 3)
  gc_frame_newslot(call939);
// starting to compile member node (depth = 3)
  int callframe940 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  Object call941 = callmethodflags(*var_lastToken, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe940);
// compiled member node returning call941 (depth = 3)
  gc_frame_newslot(call941);
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit935;
  params[1] = call937;
  params[2] = call939;
  params[3] = call941;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call942 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe934);
// compiled call node returning call942 (depth = 2)
  gc_frame_end(frame);
  return call942;
}
Object meth_parser_943_dotypeterm(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe945 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit946 == NULL) {
    strlit946 = alloc_String("identifier");
    gc_root(strlit946);
  }
// compiled string node returning strlit946 (depth = 4)
  gc_frame_newslot(strlit946);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit946;
  partcv[0] = 1;
  Object call947 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe945);
// compiled call node returning call947 (depth = 3)
  Object if944 = done;
  if (istrue(call947)) {
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe948 = gc_frame_new();
// call case 4: self request
  Object call949 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe948);
// compiled member node returning call949 (depth = 3)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe950 = gc_frame_new();
// call case 4: self request
  Object call951 = callmethodflags(self, "generic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe950);
// compiled member node returning call951 (depth = 3)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe952 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call953 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe952);
// compiled call node returning call953 (depth = 3)
    gc_frame_newslot(call953);
    if944 = call953;
  } else {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe955 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit956 == NULL) {
    strlit956 = alloc_String("type");
    gc_root(strlit956);
  }
// compiled string node returning strlit956 (depth = 5)
  gc_frame_newslot(strlit956);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit956;
  partcv[0] = 1;
  Object call957 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compiled call node returning call957 (depth = 4)
  Object if954 = done;
  if (istrue(call957)) {
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe958 = gc_frame_new();
// call case 4: self request
  Object call959 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe958);
// compiled member node returning call959 (depth = 4)
    gc_frame_newslot(call959);
    if954 = call959;
  } else {
  }
// compiled if node returning if954 (depth = 3)
    gc_frame_newslot(if954);
    if944 = if954;
  }
// compiled if node returning if944 (depth = 2)
  gc_frame_end(frame);
  return if944;
}
Object meth_parser_973__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe974 = gc_frame_new();
// call case 4: self request
  Object call975 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe974);
// compiled member node returning call975 (depth = 6)
  gc_frame_end(frame);
  return call975;
}
Object meth_parser_960_typeexpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
// definebindings:
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call962 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled member node returning call962 (depth = 3)
  *var_sz = call962;
  if (call962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe964 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit965 == NULL) {
    strlit965 = alloc_String("lparen");
    gc_root(strlit965);
  }
// compiled string node returning strlit965 (depth = 4)
  gc_frame_newslot(strlit965);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit965;
  partcv[0] = 1;
  Object call966 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe964);
// compiled call node returning call966 (depth = 3)
  Object if963 = done;
  if (istrue(call966)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe968 = gc_frame_new();
// call case 4: self request
  Object call969 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe968);
// compiled member node returning call969 (depth = 3)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe971 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block972 = alloc_Block(NULL, NULL, "parser", 396);
  gc_frame_newslot(block972);
// method "_apply"
  block_savedest(block972);
  Object closure973 = createclosure(1, "_apply");
  setclosureframe(closure973, stackframe);
  addtoclosure(closure973, selfslot);
  struct UserObject *uo973 = (struct UserObject*)block972;
  uo973->data[0] = (Object)closure973;
  Method *meth_meth_parser_973__apply = addmethod2pos(block972, "_apply", &meth_parser_973__apply, 0);
  int argcv_meth_parser_973__apply[] = {0};
  meth_meth_parser_973__apply->type = alloc_MethodType(1, argcv_meth_parser_973__apply);
  meth_meth_parser_973__apply->definitionModule = modulename;
  meth_meth_parser_973__apply->definitionLine = 3208;
// compiled block node returning block972 (depth = 5)
  gc_frame_newslot(block972);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block972;
  partcv[0] = 1;
  Object call977 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled call node returning call977 (depth = 4)
  Object if970 = done;
  if (istrue(call977)) {
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe978 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call980 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe979);
// compiled member node returning call980 (depth = 6)
  Object call981 = callmethodflags(call980, "new", 0, partcv, params, 0);
  gc_frame_end(callframe978);
// compiled member node returning call981 (depth = 5)
  *var_suggestion = call981;
  if (call981 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe982 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array983 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit984 == NULL) {
    strlit984 = alloc_String("rparen");
    gc_root(strlit984);
  }
// compiled string node returning strlit984 (depth = 7)
  params[0] = strlit984;
  partcv[0] = 1;
  callmethodflags(array983, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array983 (depth = 6)
  gc_frame_newslot(array983);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array983;
  partcv[0] = 1;
  Object call985 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe982);
// compiled call node returning call985 (depth = 5)
  *var_nextTok = call985;
  if (call985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_987 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_987 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult989 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult989 (depth = 5)
  Object if986 = done;
  if (istrue(opresult989)) {
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe990 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit991 == NULL) {
    strlit991 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit991);
  }
// compiled string node returning strlit991 (depth = 6)
  gc_frame_newslot(strlit991);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit991;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call992 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe990);
// compiled call node returning call992 (depth = 5)
    gc_frame_newslot(call992);
    if986 = call992;
  } else {
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe993 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call995 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe994);
// compiled member node returning call995 (depth = 6)
  gc_frame_newslot(call995);
// starting to compile identifier node (depth = 6)
  Object bool996 = alloc_Boolean(1);
// compiled identifier node returning bool996 (depth = 6)
  gc_frame_newslot(bool996);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool997 = alloc_Boolean(0);
// compiled identifier node returning bool997 (depth = 6)
  gc_frame_newslot(bool997);
// starting to compile string node (depth = 6)
  if (strlit998 == NULL) {
    strlit998 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit998);
  }
// compiled string node returning strlit998 (depth = 6)
  gc_frame_newslot(strlit998);
// call case 6: other requests
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call995;
  params[2] = bool996;
  params[3] = bool997;
  params[4] = strlit998;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call999 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe993);
// compiled call node returning call999 (depth = 5)
    gc_frame_newslot(call999);
    if986 = call999;
  }
// compiled if node returning if986 (depth = 4)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1000 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1001 == NULL) {
    strlit1001 = alloc_String("parentheses must contain a valid type expression.");
    gc_root(strlit1001);
  }
// compiled string node returning strlit1001 (depth = 5)
  gc_frame_newslot(strlit1001);
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1003 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1002);
// compiled member node returning call1003 (depth = 5)
  gc_frame_newslot(call1003);
// starting to compile member node (depth = 5)
  int callframe1004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1005 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1004);
// compiled member node returning call1005 (depth = 5)
  gc_frame_newslot(call1005);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1001;
  params[1] = call1003;
  params[2] = call1005;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1006 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1000);
// compiled call node returning call1006 (depth = 4)
    gc_frame_newslot(call1006);
    if970 = call1006;
  } else {
  }
// compiled if node returning if970 (depth = 3)
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1009 == NULL) {
    strlit1009 = alloc_String("rparen");
    gc_root(strlit1009);
  }
// compiled string node returning strlit1009 (depth = 5)
  int op_slot_right_1008 = gc_frame_newslot(strlit1009);
// starting to compile member node (depth = 5)
  int callframe1011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1012 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1011);
// compiled member node returning call1012 (depth = 5)
  int op_slot_left_1008 = gc_frame_newslot(call1012);
  params[0] = strlit1009;
  partcv[0] = 1;
  Object opresult1013 = callmethod(call1012, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 4)
  Object if1007 = done;
  if (istrue(opresult1013)) {
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1014 = gc_frame_new();
// call case 4: self request
  Object call1015 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1014);
// compiled member node returning call1015 (depth = 4)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1016 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1017 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1018 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1017);
// compiled member node returning call1018 (depth = 6)
  Object call1019 = callmethodflags(call1018, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1016);
// compiled member node returning call1019 (depth = 5)
  *var_suggestion = call1019;
  if (call1019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1020 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1021 == NULL) {
    strlit1021 = alloc_String(")");
    gc_root(strlit1021);
  }
// compiled string node returning strlit1021 (depth = 5)
  gc_frame_newslot(strlit1021);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1021;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1022 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1020);
// compiled call node returning call1022 (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1023 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1024 == NULL) {
    strlit1024 = alloc_String("a type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1024);
  }
// compiled string node returning strlit1024 (depth = 5)
  gc_frame_newslot(strlit1024);
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1026 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1025);
// compiled member node returning call1026 (depth = 5)
  gc_frame_newslot(call1026);
// starting to compile member node (depth = 5)
  int callframe1027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1028 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1027);
// compiled member node returning call1028 (depth = 5)
  gc_frame_newslot(call1028);
// starting to compile member node (depth = 5)
  int callframe1029 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1030 = callmethodflags(*var_lastToken, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe1029);
// compiled member node returning call1030 (depth = 5)
  gc_frame_newslot(call1030);
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1024;
  params[1] = call1026;
  params[2] = call1028;
  params[3] = call1030;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1031 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1023);
// compiled call node returning call1031 (depth = 4)
    gc_frame_newslot(call1031);
    if1007 = call1031;
  } else {
  }
// compiled if node returning if1007 (depth = 3)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1033 = gc_frame_new();
// call case 4: self request
  Object call1034 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compiled member node returning call1034 (depth = 3)
    gc_frame_newslot(call1034);
    if963 = call1034;
  } else {
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1035 = gc_frame_new();
// call case 4: self request
  Object call1036 = callmethodflags(self, "dotypeterm", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1035);
// compiled member node returning call1036 (depth = 3)
    gc_frame_newslot(call1036);
    if963 = call1036;
  }
// compiled if node returning if963 (depth = 2)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1038 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe1040 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call1041 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1040);
// compiled member node returning call1041 (depth = 4)
  int op_slot_left_1038 = gc_frame_newslot(call1041);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1042 = callmethod(call1041, ">(1)", 1, partcv, params);
// compiled op node returning opresult1042 (depth = 3)
  Object if1037 = done;
  if (istrue(opresult1042)) {
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1043 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1044 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1043);
// compiled call node returning call1044 (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1045 = gc_frame_new();
// call case 4: self request
  Object call1046 = callmethodflags(self, "typeexpressionrest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1045);
// compiled member node returning call1046 (depth = 3)
    gc_frame_newslot(call1046);
    if1037 = call1046;
  } else {
  }
// compiled if node returning if1037 (depth = 2)
  gc_frame_end(frame);
  return if1037;
}
Object meth_parser_1047_newIf_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method newIf(_,_,_)");
  Object params[3];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newIf(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part newIf(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1048 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1049 = gc_frame_new();
// call case 5: prelude request
  Object call1050 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1049);
// compiled member node returning call1050 (depth = 4)
  gc_frame_newslot(call1050);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call1052 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1051);
// compiled member node returning call1052 (depth = 4)
  params[0] = call1050;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1053 = callmethodflags(call1052, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1048);
// compiled call node returning call1053 (depth = 3)
  *var_thenBlock = call1053;
  if (call1053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1054 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1055 = gc_frame_new();
// call case 5: prelude request
  Object call1056 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1055);
// compiled member node returning call1056 (depth = 4)
  gc_frame_newslot(call1056);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call1058 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1057);
// compiled member node returning call1058 (depth = 4)
  params[0] = call1056;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1059 = callmethodflags(call1058, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1054);
// compiled call node returning call1059 (depth = 3)
  *var_elseBlock = call1059;
  if (call1059 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1060 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1061 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ast (depth = 4)
  Object call1062 = callmethodflags(*var_ast, "ifNode", 0, partcv, params, 0);
  gc_frame_end(callframe1061);
// compiled member node returning call1062 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1063 = callmethodflags(call1062, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe1060);
// compiled call node returning call1063 (depth = 2)
  gc_frame_end(frame);
  return call1063;
}
Object meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportSyntaxError(1)before(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method reportSyntaxError(_)before(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method reportSyntaxError(_)before(_)");
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for reportSyntaxError(_)before(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part reportSyntaxError(_)");
  Object *var_expectedTokens = &(stackframe->slots[1]);
  *var_expectedTokens = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part before(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1065 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1065 (depth = 3)
  *var_suggestions = array1065;
  if (array1065 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1066 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call1068 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1067);
// compiled member node returning call1068 (depth = 4)
  Object call1069 = callmethodflags(call1068, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1066);
// compiled member node returning call1069 (depth = 3)
  *var_suggestion = call1069;
  if (call1069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1070 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expectedTokens (depth = 4)
  gc_frame_newslot(*var_expectedTokens);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_expectedTokens;
  partcv[0] = 1;
  Object call1071 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1070);
// compiled call node returning call1071 (depth = 3)
  *var_nextTok = call1071;
  if (call1071 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_1073 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_1073 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1075 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1075 (depth = 3)
  Object if1072 = done;
  if (istrue(opresult1075)) {
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1076 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1077 == NULL) {
    strlit1077 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1077);
  }
// compiled string node returning strlit1077 (depth = 4)
  gc_frame_newslot(strlit1077);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1077;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1078 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1076);
// compiled call node returning call1078 (depth = 3)
    gc_frame_newslot(call1078);
    if1072 = call1078;
  } else {
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1079 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe1080 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  Object call1081 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1080);
// compiled member node returning call1081 (depth = 4)
  gc_frame_newslot(call1081);
// starting to compile identifier node (depth = 4)
  Object bool1082 = alloc_Boolean(1);
// compiled identifier node returning bool1082 (depth = 4)
  gc_frame_newslot(bool1082);
// starting to compile identifier node (depth = 4)
  Object bool1083 = alloc_Boolean(0);
// compiled identifier node returning bool1083 (depth = 4)
  gc_frame_newslot(bool1083);
// starting to compile string node (depth = 4)
  if (strlit1084 == NULL) {
    strlit1084 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1084);
  }
// compiled string node returning strlit1084 (depth = 4)
  gc_frame_newslot(strlit1084);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call1081;
  params[2] = bool1082;
  params[3] = bool1083;
  params[4] = strlit1084;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1085 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1079);
// compiled call node returning call1085 (depth = 3)
    gc_frame_newslot(call1085);
    if1072 = call1085;
  }
// compiled if node returning if1072 (depth = 2)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1086 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1087 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1086);
// compiled call node returning call1087 (depth = 2)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1088 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call1090 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1089);
// compiled member node returning call1090 (depth = 4)
  Object call1091 = callmethodflags(call1090, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1088);
// compiled member node returning call1091 (depth = 3)
  *var_suggestion = call1091;
  if (call1091 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1093 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe1094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  Object call1095 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1094);
// compiled member node returning call1095 (depth = 3)
  gc_frame_newslot(call1095);
// starting to compile identifier node (depth = 3)
  Object bool1096 = alloc_Boolean(1);
// compiled identifier node returning bool1096 (depth = 3)
  gc_frame_newslot(bool1096);
// starting to compile identifier node (depth = 3)
  Object bool1097 = alloc_Boolean(0);
// compiled identifier node returning bool1097 (depth = 3)
  gc_frame_newslot(bool1097);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call1095;
  params[2] = bool1096;
  params[3] = bool1097;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1098 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1093);
// compiled call node returning call1098 (depth = 2)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1099 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1100 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1099);
// compiled call node returning call1100 (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1101 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1103 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1102);
// compiled member node returning call1103 (depth = 3)
  gc_frame_newslot(call1103);
// starting to compile member node (depth = 3)
  int callframe1104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1105 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1104);
// compiled member node returning call1105 (depth = 3)
  gc_frame_newslot(call1105);
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call1103;
  params[2] = call1105;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1106 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1101);
// compiled call node returning call1106 (depth = 2)
  gc_frame_end(frame);
  return call1106;
}
Object meth_parser_1107_reportMissingArrow(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportMissingArrow");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// definebindings:
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1108 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1109 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call1110 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1109);
// compiled member node returning call1110 (depth = 4)
  Object call1111 = callmethodflags(call1110, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1108);
// compiled member node returning call1111 (depth = 3)
  *var_suggestion = call1111;
  if (call1111 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1115 == NULL) {
    strlit1115 = alloc_String("=");
    gc_root(strlit1115);
  }
// compiled string node returning strlit1115 (depth = 5)
  int op_slot_right_1114 = gc_frame_newslot(strlit1115);
// starting to compile member node (depth = 5)
  int callframe1117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1118 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1117);
// compiled member node returning call1118 (depth = 5)
  int op_slot_left_1114 = gc_frame_newslot(call1118);
  params[0] = strlit1115;
  partcv[0] = 1;
  Object opresult1119 = callmethod(call1118, "==(1)", 1, partcv, params);
// compiled op node returning opresult1119 (depth = 4)
  int op_slot_right_1113 = gc_frame_newslot(opresult1119);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1122 == NULL) {
    strlit1122 = alloc_String("bind");
    gc_root(strlit1122);
  }
// compiled string node returning strlit1122 (depth = 5)
  int op_slot_right_1121 = gc_frame_newslot(strlit1122);
// starting to compile member node (depth = 5)
  int callframe1124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1125 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1124);
// compiled member node returning call1125 (depth = 5)
  int op_slot_left_1121 = gc_frame_newslot(call1125);
  params[0] = strlit1122;
  partcv[0] = 1;
  Object opresult1126 = callmethod(call1125, "==(1)", 1, partcv, params);
// compiled op node returning opresult1126 (depth = 4)
  int op_slot_left_1113 = gc_frame_newslot(opresult1126);
  params[0] = opresult1119;
  partcv[0] = 1;
  Object opresult1127 = callmethod(opresult1126, "||(1)", 1, partcv, params);
// compiled op node returning opresult1127 (depth = 3)
  Object if1112 = done;
  if (istrue(opresult1127)) {
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1128 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit1129 == NULL) {
    strlit1129 = alloc_String("->");
    gc_root(strlit1129);
  }
// compiled string node returning strlit1129 (depth = 4)
  gc_frame_newslot(strlit1129);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit1129;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1130 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1128);
// compiled call node returning call1130 (depth = 3)
    gc_frame_newslot(call1130);
    if1112 = call1130;
  } else {
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1131 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1132 == NULL) {
    strlit1132 = alloc_String(" ->");
    gc_root(strlit1132);
  }
// compiled string node returning strlit1132 (depth = 4)
  gc_frame_newslot(strlit1132);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1132;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1133 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1131);
// compiled call node returning call1133 (depth = 3)
    gc_frame_newslot(call1133);
    if1112 = call1133;
  }
// compiled if node returning if1112 (depth = 2)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1134 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit1135 == NULL) {
    strlit1135 = alloc_String("in a block with parameters, the parameters must be followed by '->'");
    gc_root(strlit1135);
  }
// compiled string node returning strlit1135 (depth = 3)
  gc_frame_newslot(strlit1135);
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1137 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1136);
// compiled member node returning call1137 (depth = 3)
  gc_frame_newslot(call1137);
// starting to compile member node (depth = 3)
  int callframe1138 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1139 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1138);
// compiled member node returning call1139 (depth = 3)
  gc_frame_newslot(call1139);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit1135;
  params[1] = call1137;
  params[2] = call1139;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1140 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1134);
// compiled call node returning call1140 (depth = 2)
  gc_frame_end(frame);
  return call1140;
}
Object meth_parser_1141_reportBadRhs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportBadRhs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1142 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1142 (depth = 3)
  *var_suggestions = array1142;
  if (array1142 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1143 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1144 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call1145 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1144);
// compiled member node returning call1145 (depth = 4)
  Object call1146 = callmethodflags(call1145, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1143);
// compiled member node returning call1146 (depth = 3)
  *var_suggestion = call1146;
  if (call1146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1147 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array1148 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 5)
  if (strlit1149 == NULL) {
    strlit1149 = alloc_String("rbrace");
    gc_root(strlit1149);
  }
// compiled string node returning strlit1149 (depth = 5)
  params[0] = strlit1149;
  partcv[0] = 1;
  callmethodflags(array1148, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1148 (depth = 4)
  gc_frame_newslot(array1148);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array1148;
  partcv[0] = 1;
  Object call1150 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1147);
// compiled call node returning call1150 (depth = 3)
  *var_nextTok = call1150;
  if (call1150 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_1152 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_1152 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1154 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1154 (depth = 3)
  Object if1151 = done;
  if (istrue(opresult1154)) {
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1155 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1156 == NULL) {
    strlit1156 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1156);
  }
// compiled string node returning strlit1156 (depth = 4)
  gc_frame_newslot(strlit1156);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1156;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1157 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1155);
// compiled call node returning call1157 (depth = 3)
    gc_frame_newslot(call1157);
    if1151 = call1157;
  } else {
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1158 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe1159 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  Object call1160 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1159);
// compiled member node returning call1160 (depth = 4)
  gc_frame_newslot(call1160);
// starting to compile identifier node (depth = 4)
  Object bool1161 = alloc_Boolean(1);
// compiled identifier node returning bool1161 (depth = 4)
  gc_frame_newslot(bool1161);
// starting to compile identifier node (depth = 4)
  Object bool1162 = alloc_Boolean(0);
// compiled identifier node returning bool1162 (depth = 4)
  gc_frame_newslot(bool1162);
// starting to compile string node (depth = 4)
  if (strlit1163 == NULL) {
    strlit1163 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1163);
  }
// compiled string node returning strlit1163 (depth = 4)
  gc_frame_newslot(strlit1163);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call1160;
  params[2] = bool1161;
  params[3] = bool1162;
  params[4] = strlit1163;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1164 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1158);
// compiled call node returning call1164 (depth = 3)
    gc_frame_newslot(call1164);
    if1151 = call1164;
  }
// compiled if node returning if1151 (depth = 2)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1165 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1166 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1165);
// compiled call node returning call1166 (depth = 2)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call1169 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1168);
// compiled member node returning call1169 (depth = 4)
  Object call1170 = callmethodflags(call1169, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1167);
// compiled member node returning call1170 (depth = 3)
  *var_suggestion = call1170;
  if (call1170 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1172 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe1173 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  Object call1174 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1173);
// compiled member node returning call1174 (depth = 3)
  gc_frame_newslot(call1174);
// starting to compile identifier node (depth = 3)
  Object bool1175 = alloc_Boolean(1);
// compiled identifier node returning bool1175 (depth = 3)
  gc_frame_newslot(bool1175);
// starting to compile identifier node (depth = 3)
  Object bool1176 = alloc_Boolean(0);
// compiled identifier node returning bool1176 (depth = 3)
  gc_frame_newslot(bool1176);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call1174;
  params[2] = bool1175;
  params[3] = bool1176;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1177 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1172);
// compiled call node returning call1177 (depth = 2)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1178 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1179 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1178);
// compiled call node returning call1179 (depth = 2)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1180 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit1181 == NULL) {
    strlit1181 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit1181);
  }
// compiled string node returning strlit1181 (depth = 3)
  gc_frame_newslot(strlit1181);
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1183 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1182);
// compiled member node returning call1183 (depth = 3)
  gc_frame_newslot(call1183);
// starting to compile member node (depth = 3)
  int callframe1184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call1185 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1184);
// compiled member node returning call1185 (depth = 3)
  gc_frame_newslot(call1185);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit1181;
  params[1] = call1183;
  params[2] = call1185;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1186 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1180);
// compiled call node returning call1186 (depth = 2)
  gc_frame_end(frame);
  return call1186;
}
Object meth_parser_1187_block(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_statementIndent = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldMinIndent = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldMinIndent");
  Object *var_minInd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "minInd");
  Object *var_oldStatementToken = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "oldStatementToken");
  Object *var_oldStatementIndent = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldStatementIndent");
  Object *var_isMatchingBlock = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "isMatchingBlock");
  Object *var_savedPosition = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "savedPosition");
  Object *var_params = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "params");
// definebindings:
// definebindings:
  Object *var_blockNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "blockNode");
// definebindings:
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1189 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1190 == NULL) {
    strlit1190 = alloc_String("lbrace");
    gc_root(strlit1190);
  }
// compiled string node returning strlit1190 (depth = 4)
  gc_frame_newslot(strlit1190);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit1190;
  partcv[0] = 1;
  Object call1191 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1189);
// compiled call node returning call1191 (depth = 3)
  Object if1188 = done;
  if (istrue(call1191)) {
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1192 = gc_frame_new();
// call case 4: self request
  Object call1193 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1192);
// compiled member node returning call1193 (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_oldMinIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1195 = alloc_Float64(2);
// compiled num node returning num1195 (depth = 5)
  int op_slot_right_1194 = gc_frame_newslot(num1195);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1194 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1195;
  partcv[0] = 1;
  Object sum1197 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum1197 (depth = 4)
  *var_minInd = sum1197;
  if (sum1197 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_oldStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_oldStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1199 = alloc_Boolean(0);
// compiled identifier node returning bool1199 (depth = 4)
  *var_isMatchingBlock = bool1199;
  if (bool1199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1200 = gc_frame_new();
// call case 4: self request
  Object call1201 = callmethodflags(self, "saveParsePosition", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1200);
// compiled member node returning call1201 (depth = 4)
  *var_savedPosition = call1201;
  if (call1201 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1202 = gc_frame_new();
// call case 4: self request
  Object call1203 = callmethodflags(self, "blockParameters", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1202);
// compiled member node returning call1203 (depth = 4)
  *var_params = call1203;
  if (call1203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  Object call1206 = callmethodflags(*var_params, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe1205);
// compiled member node returning call1206 (depth = 4)
  Object if1204 = done;
  if (istrue(call1206)) {
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_savedPosition (depth = 5)
  gc_frame_newslot(*var_savedPosition);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_savedPosition;
  partcv[0] = 1;
  Object call1208 = callmethodflags(module_parser, "restoreParsePosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1207);
// compiled call node returning call1208 (depth = 4)
    gc_frame_newslot(call1208);
    if1204 = call1208;
  } else {
  }
// compiled if node returning if1204 (depth = 3)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1209 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_params;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1210 = callmethodflags(module_parser, "blockBody(1)beginningWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1209);
// compiled call node returning call1210 (depth = 4)
  *var_blockNode = call1210;
  if (call1210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1211 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blockNode (depth = 4)
  gc_frame_newslot(*var_blockNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_blockNode;
  partcv[0] = 1;
  Object call1212 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1211);
// compiled call node returning call1212 (depth = 3)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMinIndent (depth = 4)
  *var_minIndentLevel = *var_oldMinIndent;
  if (*var_oldMinIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldStatementIndent (depth = 4)
  *var_statementIndent = *var_oldStatementIndent;
  if (*var_oldStatementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldStatementToken (depth = 4)
  *var_statementToken = *var_oldStatementToken;
  if (*var_oldStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1188 = done;
  } else {
  }
// compiled if node returning if1188 (depth = 2)
  gc_frame_end(frame);
  return if1188;
}
Object meth_parser_1220__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_params = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe1221 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call1222 = callmethodflags(module_parser, "blockParameter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1221);
// compiled call node returning call1222 (depth = 4)
  gc_frame_end(frame);
  return call1222;
}
Object meth_parser_1225__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_params = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1227 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1228 == NULL) {
    strlit1228 = alloc_String("arrow");
    gc_root(strlit1228);
  }
// compiled string node returning strlit1228 (depth = 6)
  gc_frame_newslot(strlit1228);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1228;
  partcv[0] = 1;
  Object call1229 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled call node returning call1229 (depth = 5)
  Object if1226 = done;
  if (istrue(call1229)) {
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1230 = gc_frame_new();
// call case 4: self request
  Object call1231 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1230);
// compiled member node returning call1231 (depth = 5)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  block_return(realself, *var_params);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1226 = undefined;
  } else {
  }
// compiled if node returning if1226 (depth = 4)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1233 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1234 == NULL) {
    strlit1234 = alloc_String("comma");
    gc_root(strlit1234);
  }
// compiled string node returning strlit1234 (depth = 6)
  gc_frame_newslot(strlit1234);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1234;
  partcv[0] = 1;
  Object call1235 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1233);
// compiled call node returning call1235 (depth = 5)
  Object if1232 = done;
  if (istrue(call1235)) {
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1236 = gc_frame_new();
// call case 4: self request
  Object call1237 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1236);
// compiled member node returning call1237 (depth = 5)
    gc_frame_newslot(call1237);
    if1232 = call1237;
  } else {
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1238 = gc_frame_new();
// call case 4: self request
  Object call1239 = callmethodflags(self, "reportMissingArrow", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compiled member node returning call1239 (depth = 5)
    gc_frame_newslot(call1239);
    if1232 = call1239;
  }
// compiled if node returning if1232 (depth = 4)
  gc_frame_end(frame);
  return if1232;
}
Object meth_parser_1216_blockParameters(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "blockParameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_params = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "params");
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1217 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1217 (depth = 3)
  *var_params = array1217;
  if (array1217 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1218 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1219 = alloc_Block(NULL, NULL, "parser", 519);
  gc_frame_newslot(block1219);
// method "_apply"
  block_savedest(block1219);
  Object closure1220 = createclosure(2, "_apply");
  setclosureframe(closure1220, stackframe);
  addtoclosure(closure1220, var_params);
  addtoclosure(closure1220, selfslot);
  struct UserObject *uo1220 = (struct UserObject*)block1219;
  uo1220->data[0] = (Object)closure1220;
  Method *meth_meth_parser_1220__apply = addmethod2pos(block1219, "_apply", &meth_parser_1220__apply, 0);
  int argcv_meth_parser_1220__apply[] = {0};
  meth_meth_parser_1220__apply->type = alloc_MethodType(1, argcv_meth_parser_1220__apply);
  meth_meth_parser_1220__apply->definitionModule = modulename;
  meth_meth_parser_1220__apply->definitionLine = 3208;
// compiled block node returning block1219 (depth = 3)
  gc_frame_newslot(block1219);
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1224 = alloc_Block(NULL, NULL, "parser", 519);
  gc_frame_newslot(block1224);
// method "_apply"
  block_savedest(block1224);
  Object closure1225 = createclosure(2, "_apply");
  setclosureframe(closure1225, stackframe);
  addtoclosure(closure1225, var_params);
  addtoclosure(closure1225, selfslot);
  struct UserObject *uo1225 = (struct UserObject*)block1224;
  uo1225->data[0] = (Object)closure1225;
  Method *meth_meth_parser_1225__apply = addmethod2pos(block1224, "_apply", &meth_parser_1225__apply, 0);
  int argcv_meth_parser_1225__apply[] = {0};
  meth_meth_parser_1225__apply->type = alloc_MethodType(1, argcv_meth_parser_1225__apply);
  meth_meth_parser_1225__apply->definitionModule = modulename;
  meth_meth_parser_1225__apply->definitionLine = 3208;
// compiled block node returning block1224 (depth = 3)
  gc_frame_newslot(block1224);
// call case 5: prelude request
  params[0] = block1219;
  params[1] = block1224;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1241 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1218);
// compiled call node returning call1241 (depth = 2)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params (depth = 3)
  return *var_params;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_1252__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe1253 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1254 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1253);
// compiled call node returning call1254 (depth = 5)
  gc_frame_end(frame);
  return call1254;
}
Object meth_parser_1320__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe1321 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1322 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 9)
  gc_frame_end(frame);
  return call1322;
}
Object meth_parser_1242_blockParameter_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockParameter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockParameter(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blockParameter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params = &(stackframe->slots[0]);
  *var_params = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blockParameter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_paramIsPattern = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "paramIsPattern");
// definebindings:
// definebindings:
  Object *var_thisParam = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "thisParam");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1244 == NULL) {
    strlit1244 = alloc_String("lparen");
    gc_root(strlit1244);
  }
// compiled string node returning strlit1244 (depth = 4)
  int op_slot_right_1243 = gc_frame_newslot(strlit1244);
// starting to compile member node (depth = 4)
  int callframe1246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call1247 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1246);
// compiled member node returning call1247 (depth = 4)
  int op_slot_left_1243 = gc_frame_newslot(call1247);
  params[0] = strlit1244;
  partcv[0] = 1;
  Object opresult1248 = callmethod(call1247, "==(1)", 1, partcv, params);
// compiled op node returning opresult1248 (depth = 3)
  *var_paramIsPattern = opresult1248;
  if (opresult1248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1250 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1251 = alloc_Block(NULL, NULL, "parser", 540);
  gc_frame_newslot(block1251);
// method "_apply"
  block_savedest(block1251);
  Object closure1252 = createclosure(2, "_apply");
  setclosureframe(closure1252, stackframe);
  addtoclosure(closure1252, var_blocksOK);
  addtoclosure(closure1252, selfslot);
  struct UserObject *uo1252 = (struct UserObject*)block1251;
  uo1252->data[0] = (Object)closure1252;
  Method *meth_meth_parser_1252__apply = addmethod2pos(block1251, "_apply", &meth_parser_1252__apply, 0);
  int argcv_meth_parser_1252__apply[] = {0};
  meth_meth_parser_1252__apply->type = alloc_MethodType(1, argcv_meth_parser_1252__apply);
  meth_meth_parser_1252__apply->definitionModule = modulename;
  meth_meth_parser_1252__apply->definitionLine = 3208;
// compiled block node returning block1251 (depth = 4)
  gc_frame_newslot(block1251);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block1251;
  partcv[0] = 1;
  Object call1256 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1250);
// compiled call node returning call1256 (depth = 3)
  Object if1249 = done;
  if (istrue(call1256)) {
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1259 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1260 == NULL) {
    strlit1260 = alloc_String("colon");
    gc_root(strlit1260);
  }
// compiled string node returning strlit1260 (depth = 6)
  gc_frame_newslot(strlit1260);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1260;
  partcv[0] = 1;
  Object call1261 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1259);
// compiled call node returning call1261 (depth = 5)
  int op_slot_right_1258 = gc_frame_newslot(call1261);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1264 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1265 == NULL) {
    strlit1265 = alloc_String("arrow");
    gc_root(strlit1265);
  }
// compiled string node returning strlit1265 (depth = 7)
  gc_frame_newslot(strlit1265);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1265;
  partcv[0] = 1;
  Object call1266 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled call node returning call1266 (depth = 6)
  int op_slot_right_1263 = gc_frame_newslot(call1266);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1268 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1269 == NULL) {
    strlit1269 = alloc_String("comma");
    gc_root(strlit1269);
  }
// compiled string node returning strlit1269 (depth = 7)
  gc_frame_newslot(strlit1269);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1269;
  partcv[0] = 1;
  Object call1270 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1268);
// compiled call node returning call1270 (depth = 6)
  int op_slot_left_1263 = gc_frame_newslot(call1270);
  params[0] = call1266;
  partcv[0] = 1;
  Object opresult1271 = callmethod(call1270, "||(1)", 1, partcv, params);
// compiled op node returning opresult1271 (depth = 5)
  int op_slot_left_1258 = gc_frame_newslot(opresult1271);
  params[0] = call1261;
  partcv[0] = 1;
  Object opresult1272 = callmethod(opresult1271, "||(1)", 1, partcv, params);
// compiled op node returning opresult1272 (depth = 4)
  Object if1257 = done;
  if (istrue(opresult1272)) {
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1273 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call1274 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1273);
// compiled member node returning call1274 (depth = 5)
  *var_thisParam = call1274;
  if (call1274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1277 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_thisParam (depth = 8)
  Object call1279 = callmethodflags(*var_thisParam, "isIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe1278);
// compiled member node returning call1279 (depth = 7)
  Object call1280 = callmethodflags(call1279, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1277);
// compiled member node returning call1280 (depth = 6)
  int op_slot_right_1276 = gc_frame_newslot(call1280);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_paramIsPattern (depth = 6)
  int op_slot_left_1276 = gc_frame_newslot(*var_paramIsPattern);
  params[0] = call1280;
  partcv[0] = 1;
  Object opresult1282 = callmethod(*var_paramIsPattern, "||(1)", 1, partcv, params);
// compiled op node returning opresult1282 (depth = 5)
  Object if1275 = done;
  if (istrue(opresult1282)) {
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1283 = alloc_Boolean(1);
// compiled identifier node returning bool1283 (depth = 6)
  *var_paramIsPattern = bool1283;
  if (bool1283 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1285 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_thisParam (depth = 7)
  gc_frame_newslot(*var_thisParam);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call1287 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe1286);
// compiled member node returning call1287 (depth = 7)
  params[0] = *var_thisParam;
  partcv[0] = 1;
  Object call1288 = callmethodflags(call1287, "wildcard(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1285);
// compiled call node returning call1288 (depth = 6)
  *var_thisParam = call1288;
  if (call1288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1275 = done;
  } else {
  }
// compiled if node returning if1275 (depth = 4)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1290 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool1291 = alloc_Boolean(1);
// compiled identifier node returning bool1291 (depth = 5)
  gc_frame_newslot(bool1291);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_thisParam (depth = 5)
  params[0] = bool1291;
  partcv[0] = 1;
  Object call1292 = callmethodflags(*var_thisParam, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1290);
// compiled call node returning call1292 (depth = 4)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1295 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1296 == NULL) {
    strlit1296 = alloc_String("colon");
    gc_root(strlit1296);
  }
// compiled string node returning strlit1296 (depth = 7)
  gc_frame_newslot(strlit1296);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1296;
  partcv[0] = 1;
  Object call1297 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1295);
// compiled call node returning call1297 (depth = 6)
  int op_slot_right_1294 = gc_frame_newslot(call1297);
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_paramIsPattern (depth = 6)
  int op_slot_left_1294 = gc_frame_newslot(*var_paramIsPattern);
  params[0] = call1297;
  partcv[0] = 1;
  Object opresult1299 = callmethod(*var_paramIsPattern, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1299 (depth = 5)
  Object if1293 = done;
  if (istrue(opresult1299)) {
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1300 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1302 == NULL) {
    strlit1302 = alloc_String("_:""\xe2""""\x80""""\xb9""expression""\xe2""""\x80""""\xba"", and so cannot be followed by a colon");
    gc_root(strlit1302);
  }
// compiled string node returning strlit1302 (depth = 7)
  int op_slot_right_1301 = gc_frame_newslot(strlit1302);
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1304 == NULL) {
    strlit1304 = alloc_String("a block parameter that's an  expression is assumed to mean ");
    gc_root(strlit1304);
  }
// compiled string node returning strlit1304 (depth = 7)
  int op_slot_left_1301 = gc_frame_newslot(strlit1304);
  params[0] = strlit1302;
  partcv[0] = 1;
  Object opresult1305 = callmethod(strlit1304, "++(1)", 1, partcv, params);
// compiled op node returning opresult1305 (depth = 6)
  gc_frame_newslot(opresult1305);
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array1306 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1307 == NULL) {
    strlit1307 = alloc_String("arrow");
    gc_root(strlit1307);
  }
// compiled string node returning strlit1307 (depth = 7)
  params[0] = strlit1307;
  partcv[0] = 1;
  callmethodflags(array1306, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 7)
  if (strlit1308 == NULL) {
    strlit1308 = alloc_String("comma");
    gc_root(strlit1308);
  }
// compiled string node returning strlit1308 (depth = 7)
  params[0] = strlit1308;
  partcv[0] = 1;
  callmethodflags(array1306, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1306 (depth = 6)
  gc_frame_newslot(array1306);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = opresult1305;
  params[1] = array1306;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1309 = callmethodflags(module_parser, "reportSyntaxError(1)before(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1300);
// compiled call node returning call1309 (depth = 5)
    gc_frame_newslot(call1309);
    if1293 = call1309;
  } else {
  }
// compiled if node returning if1293 (depth = 4)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1311 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1312 == NULL) {
    strlit1312 = alloc_String("colon");
    gc_root(strlit1312);
  }
// compiled string node returning strlit1312 (depth = 6)
  gc_frame_newslot(strlit1312);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1312;
  partcv[0] = 1;
  Object call1313 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1311);
// compiled call node returning call1313 (depth = 5)
  Object if1310 = done;
  if (istrue(call1313)) {
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1314 = gc_frame_new();
// call case 4: self request
  Object call1315 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1314);
// compiled member node returning call1315 (depth = 5)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1317 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1318 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1319 = alloc_Block(NULL, NULL, "parser", 558);
  gc_frame_newslot(block1319);
// method "_apply"
  block_savedest(block1319);
  Object closure1320 = createclosure(2, "_apply");
  setclosureframe(closure1320, stackframe);
  addtoclosure(closure1320, var_blocksOK);
  addtoclosure(closure1320, selfslot);
  struct UserObject *uo1320 = (struct UserObject*)block1319;
  uo1320->data[0] = (Object)closure1320;
  Method *meth_meth_parser_1320__apply = addmethod2pos(block1319, "_apply", &meth_parser_1320__apply, 0);
  int argcv_meth_parser_1320__apply[] = {0};
  meth_meth_parser_1320__apply->type = alloc_MethodType(1, argcv_meth_parser_1320__apply);
  meth_meth_parser_1320__apply->definitionModule = modulename;
  meth_meth_parser_1320__apply->definitionLine = 3208;
// compiled block node returning block1319 (depth = 8)
  gc_frame_newslot(block1319);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block1319;
  partcv[0] = 1;
  Object call1324 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1318);
// compiled call node returning call1324 (depth = 7)
  Object call1325 = callmethodflags(call1324, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1317);
// compiled member node returning call1325 (depth = 6)
  Object if1316 = done;
  if (istrue(call1325)) {
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1326 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1327 == NULL) {
    strlit1327 = alloc_String("a block parameter must have a pattern or type expression after the ':'.");
    gc_root(strlit1327);
  }
// compiled string node returning strlit1327 (depth = 7)
  gc_frame_newslot(strlit1327);
// starting to compile array node (depth = 7)
  Object array1328 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1329 == NULL) {
    strlit1329 = alloc_String("arrow");
    gc_root(strlit1329);
  }
// compiled string node returning strlit1329 (depth = 8)
  params[0] = strlit1329;
  partcv[0] = 1;
  callmethodflags(array1328, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 8)
  if (strlit1330 == NULL) {
    strlit1330 = alloc_String("rbrace");
    gc_root(strlit1330);
  }
// compiled string node returning strlit1330 (depth = 8)
  params[0] = strlit1330;
  partcv[0] = 1;
  callmethodflags(array1328, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1328 (depth = 7)
  gc_frame_newslot(array1328);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1327;
  params[1] = array1328;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1331 = callmethodflags(module_parser, "reportSyntaxError(1)before(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1326);
// compiled call node returning call1331 (depth = 6)
    gc_frame_newslot(call1331);
    if1316 = call1331;
  } else {
  }
// compiled if node returning if1316 (depth = 5)
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1332 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call1334 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1333);
// compiled member node returning call1334 (depth = 6)
  gc_frame_newslot(call1334);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_thisParam (depth = 6)
  params[0] = call1334;
  partcv[0] = 1;
  Object call1335 = callmethodflags(*var_thisParam, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1332);
// compiled call node returning call1335 (depth = 5)
    gc_frame_newslot(call1335);
    if1310 = call1335;
  } else {
  }
// compiled if node returning if1310 (depth = 4)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1336 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_thisParam (depth = 5)
  gc_frame_newslot(*var_thisParam);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  params[0] = *var_thisParam;
  partcv[0] = 1;
  Object call1337 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1336);
// compiled call node returning call1337 (depth = 4)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1338 = alloc_Boolean(1);
// compiled identifier node returning bool1338 (depth = 5)
  return bool1338;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1257 = undefined;
  } else {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1339 = alloc_Boolean(0);
// compiled identifier node returning bool1339 (depth = 5)
  return bool1339;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1257 = undefined;
  }
// compiled if node returning if1257 (depth = 3)
    gc_frame_newslot(if1257);
    if1249 = if1257;
  } else {
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1340 = alloc_Boolean(0);
// compiled identifier node returning bool1340 (depth = 4)
  return bool1340;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1249 = undefined;
  }
// compiled if node returning if1249 (depth = 2)
  gc_frame_end(frame);
  return if1249;
}
Object meth_parser_1356__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe1357 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe1358 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1359 == NULL) {
    strlit1359 = alloc_String("rbrace");
    gc_root(strlit1359);
  }
// compiled string node returning strlit1359 (depth = 6)
  gc_frame_newslot(strlit1359);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1359;
  partcv[0] = 1;
  Object call1360 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1358);
// compiled call node returning call1360 (depth = 5)
  Object call1361 = callmethodflags(call1360, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1357);
// compiled member node returning call1361 (depth = 4)
  gc_frame_end(frame);
  return call1361;
}
Object meth_parser_1368__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe1369 = gc_frame_new();
// call case 4: self request
  Object call1370 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1369);
// compiled member node returning call1370 (depth = 7)
  gc_frame_end(frame);
  return call1370;
}
Object meth_parser_1364__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1366 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1367 = alloc_Block(NULL, NULL, "parser", 584);
  gc_frame_newslot(block1367);
// method "_apply"
  block_savedest(block1367);
  Object closure1368 = createclosure(1, "_apply");
  setclosureframe(closure1368, stackframe);
  addtoclosure(closure1368, selfslot);
  struct UserObject *uo1368 = (struct UserObject*)block1367;
  uo1368->data[0] = (Object)closure1368;
  Method *meth_meth_parser_1368__apply = addmethod2pos(block1367, "_apply", &meth_parser_1368__apply, 0);
  int argcv_meth_parser_1368__apply[] = {0};
  meth_meth_parser_1368__apply->type = alloc_MethodType(1, argcv_meth_parser_1368__apply);
  meth_meth_parser_1368__apply->definitionModule = modulename;
  meth_meth_parser_1368__apply->definitionLine = 3208;
// compiled block node returning block1367 (depth = 6)
  gc_frame_newslot(block1367);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1367;
  partcv[0] = 1;
  Object call1372 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1366);
// compiled call node returning call1372 (depth = 5)
  Object if1365 = done;
  if (istrue(call1372)) {
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1373 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1374 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call1375 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1374);
// compiled member node returning call1375 (depth = 7)
  Object call1376 = callmethodflags(call1375, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1373);
// compiled member node returning call1376 (depth = 6)
  *var_suggestion = call1376;
  if (call1376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1377 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1378 == NULL) {
    strlit1378 = alloc_String("}");
    gc_root(strlit1378);
  }
// compiled string node returning strlit1378 (depth = 6)
  gc_frame_newslot(strlit1378);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1378;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1379 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1377);
// compiled call node returning call1379 (depth = 5)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1380 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("a block must end with a '}'.");
    gc_root(strlit1381);
  }
// compiled string node returning strlit1381 (depth = 6)
  gc_frame_newslot(strlit1381);
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1382 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1383 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1382);
// compiled member node returning call1383 (depth = 6)
  gc_frame_newslot(call1383);
// starting to compile member node (depth = 6)
  int callframe1384 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1385 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1384);
// compiled member node returning call1385 (depth = 6)
  gc_frame_newslot(call1385);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1381;
  params[1] = call1383;
  params[2] = call1385;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1386 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1380);
// compiled call node returning call1386 (depth = 5)
    gc_frame_newslot(call1386);
    if1365 = call1386;
  } else {
  }
// compiled if node returning if1365 (depth = 4)
  gc_frame_end(frame);
  return if1365;
}
Object meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockBody(1)beginningWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockBody(_)beginningWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockBody(_)beginningWith(_)");
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_indentFreePass = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for blockBody(_)beginningWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_params = &(stackframe->slots[0]);
  *var_params = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blockBody(_)");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part beginningWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_originalValues = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "originalValues");
// definebindings:
// definebindings:
  Object *var_body = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "body");
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1342 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1342 (depth = 3)
  *var_values = array1342;
  if (array1342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call1347 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1346);
// compiled member node returning call1347 (depth = 4)
  int op_slot_right_1345 = gc_frame_newslot(call1347);
// starting to compile member node (depth = 4)
  int callframe1349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call1350 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1349);
// compiled member node returning call1350 (depth = 4)
  int op_slot_left_1345 = gc_frame_newslot(call1350);
  params[0] = call1347;
  partcv[0] = 1;
  Object opresult1351 = callmethod(call1350, "==(1)", 1, partcv, params);
// compiled op node returning opresult1351 (depth = 3)
  Object if1344 = done;
  if (istrue(opresult1351)) {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1352 = alloc_Boolean(1);
// compiled identifier node returning bool1352 (depth = 4)
  *var_indentFreePass = bool1352;
  if (bool1352 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1344 = done;
  } else {
  }
// compiled if node returning if1344 (depth = 2)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1354 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1355 = alloc_Block(NULL, NULL, "parser", 582);
  gc_frame_newslot(block1355);
// method "_apply"
  block_savedest(block1355);
  Object closure1356 = createclosure(1, "_apply");
  setclosureframe(closure1356, stackframe);
  addtoclosure(closure1356, selfslot);
  struct UserObject *uo1356 = (struct UserObject*)block1355;
  uo1356->data[0] = (Object)closure1356;
  Method *meth_meth_parser_1356__apply = addmethod2pos(block1355, "_apply", &meth_parser_1356__apply, 0);
  int argcv_meth_parser_1356__apply[] = {0};
  meth_meth_parser_1356__apply->type = alloc_MethodType(1, argcv_meth_parser_1356__apply);
  meth_meth_parser_1356__apply->definitionModule = modulename;
  meth_meth_parser_1356__apply->definitionLine = 3208;
// compiled block node returning block1355 (depth = 3)
  gc_frame_newslot(block1355);
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1363 = alloc_Block(NULL, NULL, "parser", 582);
  gc_frame_newslot(block1363);
// method "_apply"
  block_savedest(block1363);
  Object closure1364 = createclosure(4, "_apply");
  setclosureframe(closure1364, stackframe);
  addtoclosure(closure1364, var_errormessages);
  addtoclosure(closure1364, var_lastToken);
  addtoclosure(closure1364, var_sym);
  addtoclosure(closure1364, selfslot);
  struct UserObject *uo1364 = (struct UserObject*)block1363;
  uo1364->data[0] = (Object)closure1364;
  Method *meth_meth_parser_1364__apply = addmethod2pos(block1363, "_apply", &meth_parser_1364__apply, 0);
  int argcv_meth_parser_1364__apply[] = {0};
  meth_meth_parser_1364__apply->type = alloc_MethodType(1, argcv_meth_parser_1364__apply);
  meth_meth_parser_1364__apply->definitionModule = modulename;
  meth_meth_parser_1364__apply->definitionLine = 3208;
// compiled block node returning block1363 (depth = 3)
  gc_frame_newslot(block1363);
// call case 5: prelude request
  params[0] = block1355;
  params[1] = block1363;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1388 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1354);
// compiled call node returning call1388 (depth = 2)
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1389 = gc_frame_new();
// call case 4: self request
  Object call1390 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1389);
// compiled member node returning call1390 (depth = 2)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_body = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_originalValues (depth = 3)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1392 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1393 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1394 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call1395 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1394);
// compiled member node returning call1395 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1396 = callmethodflags(call1395, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1393);
// compiled call node returning call1396 (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call1397 = callmethodflags(call1396, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1392);
// compiled call node returning call1397 (depth = 3)
  return call1397;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_1417__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1419 == NULL) {
    strlit1419 = alloc_String("lbrace");
    gc_root(strlit1419);
  }
// compiled string node returning strlit1419 (depth = 8)
  int op_slot_right_1418 = gc_frame_newslot(strlit1419);
// starting to compile member node (depth = 8)
  int callframe1421 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1422 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1421);
// compiled member node returning call1422 (depth = 8)
  int op_slot_left_1418 = gc_frame_newslot(call1422);
  params[0] = strlit1419;
  partcv[0] = 1;
  Object opresult1423 = callmethod(call1422, "==(1)", 1, partcv, params);
// compiled op node returning opresult1423 (depth = 7)
  gc_frame_end(frame);
  return opresult1423;
}
Object meth_parser_1460__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1465 == NULL) {
    strlit1465 = alloc_String("then");
    gc_root(strlit1465);
  }
// compiled string node returning strlit1465 (depth = 11)
  int op_slot_right_1464 = gc_frame_newslot(strlit1465);
// starting to compile member node (depth = 11)
  int callframe1467 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1468 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1467);
// compiled member node returning call1468 (depth = 11)
  int op_slot_left_1464 = gc_frame_newslot(call1468);
  params[0] = strlit1465;
  partcv[0] = 1;
  Object opresult1469 = callmethod(call1468, "==(1)", 1, partcv, params);
// compiled op node returning opresult1469 (depth = 10)
  int op_slot_right_1463 = gc_frame_newslot(opresult1469);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1472 == NULL) {
    strlit1472 = alloc_String("identifier");
    gc_root(strlit1472);
  }
// compiled string node returning strlit1472 (depth = 11)
  int op_slot_right_1471 = gc_frame_newslot(strlit1472);
// starting to compile member node (depth = 11)
  int callframe1474 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1475 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1474);
// compiled member node returning call1475 (depth = 11)
  int op_slot_left_1471 = gc_frame_newslot(call1475);
  params[0] = strlit1472;
  partcv[0] = 1;
  Object opresult1476 = callmethod(call1475, "==(1)", 1, partcv, params);
// compiled op node returning opresult1476 (depth = 10)
  int op_slot_left_1463 = gc_frame_newslot(opresult1476);
  params[0] = opresult1469;
  partcv[0] = 1;
  Object opresult1477 = callmethod(opresult1476, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1477 (depth = 9)
  int op_slot_right_1462 = gc_frame_newslot(opresult1477);
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1481 == NULL) {
    strlit1481 = alloc_String("lbrace");
    gc_root(strlit1481);
  }
// compiled string node returning strlit1481 (depth = 11)
  int op_slot_right_1480 = gc_frame_newslot(strlit1481);
// starting to compile member node (depth = 11)
  int callframe1483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1484 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1483);
// compiled member node returning call1484 (depth = 11)
  int op_slot_left_1480 = gc_frame_newslot(call1484);
  params[0] = strlit1481;
  partcv[0] = 1;
  Object opresult1485 = callmethod(call1484, "==(1)", 1, partcv, params);
// compiled op node returning opresult1485 (depth = 10)
  int op_slot_right_1479 = gc_frame_newslot(opresult1485);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1489 == NULL) {
    strlit1489 = alloc_String("rbrace");
    gc_root(strlit1489);
  }
// compiled string node returning strlit1489 (depth = 12)
  int op_slot_right_1488 = gc_frame_newslot(strlit1489);
// starting to compile member node (depth = 12)
  int callframe1491 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call1492 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1491);
// compiled member node returning call1492 (depth = 12)
  int op_slot_left_1488 = gc_frame_newslot(call1492);
  params[0] = strlit1489;
  partcv[0] = 1;
  Object opresult1493 = callmethod(call1492, "==(1)", 1, partcv, params);
// compiled op node returning opresult1493 (depth = 11)
  int op_slot_right_1487 = gc_frame_newslot(opresult1493);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1496 == NULL) {
    strlit1496 = alloc_String("rparen");
    gc_root(strlit1496);
  }
// compiled string node returning strlit1496 (depth = 12)
  int op_slot_right_1495 = gc_frame_newslot(strlit1496);
// starting to compile member node (depth = 12)
  int callframe1498 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call1499 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1498);
// compiled member node returning call1499 (depth = 12)
  int op_slot_left_1495 = gc_frame_newslot(call1499);
  params[0] = strlit1496;
  partcv[0] = 1;
  Object opresult1500 = callmethod(call1499, "==(1)", 1, partcv, params);
// compiled op node returning opresult1500 (depth = 11)
  int op_slot_left_1487 = gc_frame_newslot(opresult1500);
  params[0] = opresult1493;
  partcv[0] = 1;
  Object opresult1501 = callmethod(opresult1500, "||(1)", 1, partcv, params);
// compiled op node returning opresult1501 (depth = 10)
  int op_slot_left_1479 = gc_frame_newslot(opresult1501);
  params[0] = opresult1485;
  partcv[0] = 1;
  Object opresult1502 = callmethod(opresult1501, "||(1)", 1, partcv, params);
// compiled op node returning opresult1502 (depth = 9)
  int op_slot_left_1462 = gc_frame_newslot(opresult1502);
  params[0] = opresult1477;
  partcv[0] = 1;
  Object opresult1503 = callmethod(opresult1502, "||(1)", 1, partcv, params);
// compiled op node returning opresult1503 (depth = 8)
  int op_slot_right_1461 = gc_frame_newslot(opresult1503);
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  Object call1507 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1506);
// compiled member node returning call1507 (depth = 9)
  int op_slot_right_1505 = gc_frame_newslot(call1507);
// starting to compile member node (depth = 9)
  int callframe1509 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1510 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1509);
// compiled member node returning call1510 (depth = 9)
  int op_slot_left_1505 = gc_frame_newslot(call1510);
  params[0] = call1507;
  partcv[0] = 1;
  Object opresult1511 = callmethod(call1510, "==(1)", 1, partcv, params);
// compiled op node returning opresult1511 (depth = 8)
  int op_slot_left_1461 = gc_frame_newslot(opresult1511);
  params[0] = opresult1503;
  partcv[0] = 1;
  Object opresult1512 = callmethod(opresult1511, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1512 (depth = 7)
  gc_frame_end(frame);
  return opresult1512;
}
Object meth_parser_1602__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe1603 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1604 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1603);
// compiled call node returning call1604 (depth = 6)
  gc_frame_end(frame);
  return call1604;
}
Object meth_parser_1613__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String("rparen");
    gc_root(strlit1616);
  }
// compiled string node returning strlit1616 (depth = 9)
  int op_slot_right_1615 = gc_frame_newslot(strlit1616);
// starting to compile member node (depth = 9)
  int callframe1618 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1619 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1618);
// compiled member node returning call1619 (depth = 9)
  int op_slot_left_1615 = gc_frame_newslot(call1619);
  params[0] = strlit1616;
  partcv[0] = 1;
  Object opresult1620 = callmethod(call1619, "==(1)", 1, partcv, params);
// compiled op node returning opresult1620 (depth = 8)
  int op_slot_right_1614 = gc_frame_newslot(opresult1620);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1623 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call1624 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1623);
// compiled member node returning call1624 (depth = 9)
  int op_slot_right_1622 = gc_frame_newslot(call1624);
// starting to compile member node (depth = 9)
  int callframe1626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1627 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1626);
// compiled member node returning call1627 (depth = 9)
  int op_slot_left_1622 = gc_frame_newslot(call1627);
  params[0] = call1624;
  partcv[0] = 1;
  Object opresult1628 = callmethod(call1627, "==(1)", 1, partcv, params);
// compiled op node returning opresult1628 (depth = 8)
  int op_slot_left_1614 = gc_frame_newslot(opresult1628);
  params[0] = opresult1620;
  partcv[0] = 1;
  Object opresult1629 = callmethod(opresult1628, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1629 (depth = 7)
  gc_frame_end(frame);
  return opresult1629;
}
Object meth_parser_1862__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe1863 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1864 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1865 == NULL) {
    strlit1865 = alloc_String("rbrace");
    gc_root(strlit1865);
  }
// compiled string node returning strlit1865 (depth = 8)
  gc_frame_newslot(strlit1865);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit1865;
  partcv[0] = 1;
  Object call1866 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1864);
// compiled call node returning call1866 (depth = 7)
  Object call1867 = callmethodflags(call1866, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1863);
// compiled member node returning call1867 (depth = 6)
  gc_frame_end(frame);
  return call1867;
}
Object meth_parser_1874__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 9)
  int callframe1875 = gc_frame_new();
// call case 4: self request
  Object call1876 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1875);
// compiled member node returning call1876 (depth = 9)
  gc_frame_end(frame);
  return call1876;
}
Object meth_parser_1870__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1872 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1873 = alloc_Block(NULL, NULL, "parser", 726);
  gc_frame_newslot(block1873);
// method "_apply"
  block_savedest(block1873);
  Object closure1874 = createclosure(1, "_apply");
  setclosureframe(closure1874, stackframe);
  addtoclosure(closure1874, selfslot);
  struct UserObject *uo1874 = (struct UserObject*)block1873;
  uo1874->data[0] = (Object)closure1874;
  Method *meth_meth_parser_1874__apply = addmethod2pos(block1873, "_apply", &meth_parser_1874__apply, 0);
  int argcv_meth_parser_1874__apply[] = {0};
  meth_meth_parser_1874__apply->type = alloc_MethodType(1, argcv_meth_parser_1874__apply);
  meth_meth_parser_1874__apply->definitionModule = modulename;
  meth_meth_parser_1874__apply->definitionLine = 3208;
// compiled block node returning block1873 (depth = 8)
  gc_frame_newslot(block1873);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block1873;
  partcv[0] = 1;
  Object call1878 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1872);
// compiled call node returning call1878 (depth = 7)
  Object if1871 = done;
  if (istrue(call1878)) {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1879 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call1881 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1880);
// compiled member node returning call1881 (depth = 9)
  Object call1882 = callmethodflags(call1881, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1879);
// compiled member node returning call1882 (depth = 8)
  *var_suggestion = call1882;
  if (call1882 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1883 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool1884 = alloc_Boolean(0);
// compiled identifier node returning bool1884 (depth = 9)
  gc_frame_newslot(bool1884);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_btok;
  params[1] = bool1884;
  partcv[0] = 2;
  Object call1885 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1883);
// compiled call node returning call1885 (depth = 8)
  *var_closingBrace = call1885;
  if (call1885 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1887 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1888 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call1889 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe1888);
// compiled member node returning call1889 (depth = 9)
  Object call1890 = callmethodflags(call1889, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1887);
// compiled member node returning call1890 (depth = 8)
  Object if1886 = done;
  if (istrue(call1890)) {
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_1892 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe1894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call1895 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe1894);
// compiled member node returning call1895 (depth = 10)
  int op_slot_left_1892 = gc_frame_newslot(call1895);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1896 = callmethod(call1895, "==(1)", 1, partcv, params);
// compiled op node returning opresult1896 (depth = 9)
  Object if1891 = done;
  if (istrue(opresult1896)) {
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1897 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1898 == NULL) {
    strlit1898 = alloc_String("}");
    gc_root(strlit1898);
  }
// compiled string node returning strlit1898 (depth = 10)
  gc_frame_newslot(strlit1898);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1898;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1899 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1897);
// compiled call node returning call1899 (depth = 9)
    gc_frame_newslot(call1899);
    if1891 = call1899;
  } else {
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1900 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1902 = alloc_Float64(0.1);
// compiled num node returning num1902 (depth = 11)
  int op_slot_right_1901 = gc_frame_newslot(num1902);
// starting to compile member node (depth = 11)
  int callframe1904 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe1905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call1906 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe1905);
// compiled member node returning call1906 (depth = 12)
  Object call1907 = callmethodflags(call1906, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1904);
// compiled member node returning call1907 (depth = 11)
  int op_slot_left_1901 = gc_frame_newslot(call1907);
  params[0] = num1902;
  partcv[0] = 1;
  Object sum1908 = callmethod(call1907, "+(1)", 1, partcv, params);
// compiled op node returning sum1908 (depth = 10)
  gc_frame_newslot(sum1908);
// starting to compile string node (depth = 10)
  if (strlit1909 == NULL) {
    strlit1909 = alloc_String("}");
    gc_root(strlit1909);
  }
// compiled string node returning strlit1909 (depth = 10)
  gc_frame_newslot(strlit1909);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum1908;
  params[1] = strlit1909;
  partcv[0] = 2;
  Object call1910 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1900);
// compiled call node returning call1910 (depth = 9)
    gc_frame_newslot(call1910);
    if1891 = call1910;
  }
// compiled if node returning if1891 (depth = 8)
    gc_frame_newslot(if1891);
    if1886 = if1891;
  } else {
  }
// compiled if node returning if1886 (depth = 7)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1911 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call1912 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1911);
// compiled call node returning call1912 (depth = 7)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1913 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1914 == NULL) {
    strlit1914 = alloc_String("an if statement must end with a '}'.");
    gc_root(strlit1914);
  }
// compiled string node returning strlit1914 (depth = 8)
  gc_frame_newslot(strlit1914);
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1915 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1916 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1915);
// compiled member node returning call1916 (depth = 8)
  gc_frame_newslot(call1916);
// starting to compile member node (depth = 8)
  int callframe1917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1918 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1917);
// compiled member node returning call1918 (depth = 8)
  gc_frame_newslot(call1918);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1914;
  params[1] = call1916;
  params[2] = call1918;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1919 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1913);
// compiled call node returning call1919 (depth = 7)
    gc_frame_newslot(call1919);
    if1871 = call1919;
  } else {
  }
// compiled if node returning if1871 (depth = 6)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1920 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call1921 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1920);
// compiled member node returning call1921 (depth = 7)
  *var_v = call1921;
  if (call1921 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1923 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call1924 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1923);
// compiled call node returning call1924 (depth = 6)
  gc_frame_end(frame);
  return call1924;
}
Object meth_parser_1931__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1934 == NULL) {
    strlit1934 = alloc_String("elseif");
    gc_root(strlit1934);
  }
// compiled string node returning strlit1934 (depth = 8)
  int op_slot_right_1933 = gc_frame_newslot(strlit1934);
// starting to compile member node (depth = 8)
  int callframe1936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1937 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1936);
// compiled member node returning call1937 (depth = 8)
  int op_slot_left_1933 = gc_frame_newslot(call1937);
  params[0] = strlit1934;
  partcv[0] = 1;
  Object opresult1938 = callmethod(call1937, "==(1)", 1, partcv, params);
// compiled op node returning opresult1938 (depth = 7)
  int op_slot_right_1932 = gc_frame_newslot(opresult1938);
// starting to compile call node (depth = 7)
  int callframe1940 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1941 == NULL) {
    strlit1941 = alloc_String("identifier");
    gc_root(strlit1941);
  }
// compiled string node returning strlit1941 (depth = 8)
  gc_frame_newslot(strlit1941);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit1941;
  partcv[0] = 1;
  Object call1942 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1940);
// compiled call node returning call1942 (depth = 7)
  int op_slot_left_1932 = gc_frame_newslot(call1942);
  params[0] = opresult1938;
  partcv[0] = 1;
  Object opresult1943 = callmethod(call1942, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1943 (depth = 6)
  gc_frame_end(frame);
  return opresult1943;
}
Object meth_parser_1963__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1968 == NULL) {
    strlit1968 = alloc_String("then");
    gc_root(strlit1968);
  }
// compiled string node returning strlit1968 (depth = 14)
  int op_slot_right_1967 = gc_frame_newslot(strlit1968);
// starting to compile member node (depth = 14)
  int callframe1970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call1971 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1970);
// compiled member node returning call1971 (depth = 14)
  int op_slot_left_1967 = gc_frame_newslot(call1971);
  params[0] = strlit1968;
  partcv[0] = 1;
  Object opresult1972 = callmethod(call1971, "==(1)", 1, partcv, params);
// compiled op node returning opresult1972 (depth = 13)
  int op_slot_right_1966 = gc_frame_newslot(opresult1972);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1975 == NULL) {
    strlit1975 = alloc_String("identifier");
    gc_root(strlit1975);
  }
// compiled string node returning strlit1975 (depth = 14)
  int op_slot_right_1974 = gc_frame_newslot(strlit1975);
// starting to compile member node (depth = 14)
  int callframe1977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call1978 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1977);
// compiled member node returning call1978 (depth = 14)
  int op_slot_left_1974 = gc_frame_newslot(call1978);
  params[0] = strlit1975;
  partcv[0] = 1;
  Object opresult1979 = callmethod(call1978, "==(1)", 1, partcv, params);
// compiled op node returning opresult1979 (depth = 13)
  int op_slot_left_1966 = gc_frame_newslot(opresult1979);
  params[0] = opresult1972;
  partcv[0] = 1;
  Object opresult1980 = callmethod(opresult1979, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1980 (depth = 12)
  int op_slot_right_1965 = gc_frame_newslot(opresult1980);
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1984 == NULL) {
    strlit1984 = alloc_String("lbrace");
    gc_root(strlit1984);
  }
// compiled string node returning strlit1984 (depth = 14)
  int op_slot_right_1983 = gc_frame_newslot(strlit1984);
// starting to compile member node (depth = 14)
  int callframe1986 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call1987 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1986);
// compiled member node returning call1987 (depth = 14)
  int op_slot_left_1983 = gc_frame_newslot(call1987);
  params[0] = strlit1984;
  partcv[0] = 1;
  Object opresult1988 = callmethod(call1987, "==(1)", 1, partcv, params);
// compiled op node returning opresult1988 (depth = 13)
  int op_slot_right_1982 = gc_frame_newslot(opresult1988);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1991 == NULL) {
    strlit1991 = alloc_String("rbrace");
    gc_root(strlit1991);
  }
// compiled string node returning strlit1991 (depth = 14)
  int op_slot_right_1990 = gc_frame_newslot(strlit1991);
// starting to compile member node (depth = 14)
  int callframe1993 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call1994 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1993);
// compiled member node returning call1994 (depth = 14)
  int op_slot_left_1990 = gc_frame_newslot(call1994);
  params[0] = strlit1991;
  partcv[0] = 1;
  Object opresult1995 = callmethod(call1994, "==(1)", 1, partcv, params);
// compiled op node returning opresult1995 (depth = 13)
  int op_slot_left_1982 = gc_frame_newslot(opresult1995);
  params[0] = opresult1988;
  partcv[0] = 1;
  Object opresult1996 = callmethod(opresult1995, "||(1)", 1, partcv, params);
// compiled op node returning opresult1996 (depth = 12)
  int op_slot_left_1965 = gc_frame_newslot(opresult1996);
  params[0] = opresult1980;
  partcv[0] = 1;
  Object opresult1997 = callmethod(opresult1996, "||(1)", 1, partcv, params);
// compiled op node returning opresult1997 (depth = 11)
  int op_slot_right_1964 = gc_frame_newslot(opresult1997);
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2000 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_statementToken (depth = 13)
  Object call2001 = callmethodflags(*var_statementToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2000);
// compiled member node returning call2001 (depth = 12)
  int op_slot_right_1999 = gc_frame_newslot(call2001);
// starting to compile member node (depth = 12)
  int callframe2003 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2004 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2003);
// compiled member node returning call2004 (depth = 12)
  int op_slot_left_1999 = gc_frame_newslot(call2004);
  params[0] = call2001;
  partcv[0] = 1;
  Object opresult2005 = callmethod(call2004, "==(1)", 1, partcv, params);
// compiled op node returning opresult2005 (depth = 11)
  int op_slot_left_1964 = gc_frame_newslot(opresult2005);
  params[0] = opresult1997;
  partcv[0] = 1;
  Object opresult2006 = callmethod(opresult2005, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2006 (depth = 10)
  gc_frame_end(frame);
  return opresult2006;
}
Object meth_parser_2096__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe2097 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2098 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2097);
// compiled call node returning call2098 (depth = 9)
  gc_frame_end(frame);
  return call2098;
}
Object meth_parser_2107__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2110 == NULL) {
    strlit2110 = alloc_String("rbrace");
    gc_root(strlit2110);
  }
// compiled string node returning strlit2110 (depth = 12)
  int op_slot_right_2109 = gc_frame_newslot(strlit2110);
// starting to compile member node (depth = 12)
  int callframe2112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2113 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2112);
// compiled member node returning call2113 (depth = 12)
  int op_slot_left_2109 = gc_frame_newslot(call2113);
  params[0] = strlit2110;
  partcv[0] = 1;
  Object opresult2114 = callmethod(call2113, "==(1)", 1, partcv, params);
// compiled op node returning opresult2114 (depth = 11)
  int op_slot_right_2108 = gc_frame_newslot(opresult2114);
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  Object call2118 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2117);
// compiled member node returning call2118 (depth = 12)
  int op_slot_right_2116 = gc_frame_newslot(call2118);
// starting to compile member node (depth = 12)
  int callframe2120 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2121 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2120);
// compiled member node returning call2121 (depth = 12)
  int op_slot_left_2116 = gc_frame_newslot(call2121);
  params[0] = call2118;
  partcv[0] = 1;
  Object opresult2122 = callmethod(call2121, "==(1)", 1, partcv, params);
// compiled op node returning opresult2122 (depth = 11)
  int op_slot_left_2108 = gc_frame_newslot(opresult2122);
  params[0] = opresult2114;
  partcv[0] = 1;
  Object opresult2123 = callmethod(opresult2122, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2123 (depth = 10)
  gc_frame_end(frame);
  return opresult2123;
}
Object meth_parser_2420__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe2421 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe2422 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2423 == NULL) {
    strlit2423 = alloc_String("rbrace");
    gc_root(strlit2423);
  }
// compiled string node returning strlit2423 (depth = 10)
  gc_frame_newslot(strlit2423);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit2423;
  partcv[0] = 1;
  Object call2424 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2422);
// compiled call node returning call2424 (depth = 9)
  Object call2425 = callmethodflags(call2424, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2421);
// compiled member node returning call2425 (depth = 8)
  gc_frame_end(frame);
  return call2425;
}
Object meth_parser_2432__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 11)
  int callframe2433 = gc_frame_new();
// call case 4: self request
  Object call2434 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2433);
// compiled member node returning call2434 (depth = 11)
  gc_frame_end(frame);
  return call2434;
}
Object meth_parser_2428__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2430 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2431 = alloc_Block(NULL, NULL, "parser", 884);
  gc_frame_newslot(block2431);
// method "_apply"
  block_savedest(block2431);
  Object closure2432 = createclosure(1, "_apply");
  setclosureframe(closure2432, stackframe);
  addtoclosure(closure2432, selfslot);
  struct UserObject *uo2432 = (struct UserObject*)block2431;
  uo2432->data[0] = (Object)closure2432;
  Method *meth_meth_parser_2432__apply = addmethod2pos(block2431, "_apply", &meth_parser_2432__apply, 0);
  int argcv_meth_parser_2432__apply[] = {0};
  meth_meth_parser_2432__apply->type = alloc_MethodType(1, argcv_meth_parser_2432__apply);
  meth_meth_parser_2432__apply->definitionModule = modulename;
  meth_meth_parser_2432__apply->definitionLine = 3208;
// compiled block node returning block2431 (depth = 10)
  gc_frame_newslot(block2431);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = block2431;
  partcv[0] = 1;
  Object call2436 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2430);
// compiled call node returning call2436 (depth = 9)
  Object if2429 = done;
  if (istrue(call2436)) {
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2437 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  Object call2439 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2438);
// compiled member node returning call2439 (depth = 11)
  Object call2440 = callmethodflags(call2439, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2437);
// compiled member node returning call2440 (depth = 10)
  *var_suggestion = call2440;
  if (call2440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2441 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2442 = alloc_Boolean(0);
// compiled identifier node returning bool2442 (depth = 11)
  gc_frame_newslot(bool2442);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = *var_btok;
  params[1] = bool2442;
  partcv[0] = 2;
  Object call2443 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2441);
// compiled call node returning call2443 (depth = 10)
  *var_closingBrace = call2443;
  if (call2443 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2445 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2446 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2447 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2446);
// compiled member node returning call2447 (depth = 11)
  Object call2448 = callmethodflags(call2447, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2445);
// compiled member node returning call2448 (depth = 10)
  Object if2444 = done;
  if (istrue(call2448)) {
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2450 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
  int callframe2452 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call2453 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2452);
// compiled member node returning call2453 (depth = 12)
  int op_slot_left_2450 = gc_frame_newslot(call2453);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2454 = callmethod(call2453, "==(1)", 1, partcv, params);
// compiled op node returning opresult2454 (depth = 11)
  Object if2449 = done;
  if (istrue(opresult2454)) {
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2455 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2456 == NULL) {
    strlit2456 = alloc_String("}");
    gc_root(strlit2456);
  }
// compiled string node returning strlit2456 (depth = 12)
  gc_frame_newslot(strlit2456);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2456;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2457 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2455);
// compiled call node returning call2457 (depth = 11)
    gc_frame_newslot(call2457);
    if2449 = call2457;
  } else {
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2458 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2460 = alloc_Float64(0.1);
// compiled num node returning num2460 (depth = 13)
  int op_slot_right_2459 = gc_frame_newslot(num2460);
// starting to compile member node (depth = 13)
  int callframe2462 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  Object call2464 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2463);
// compiled member node returning call2464 (depth = 14)
  Object call2465 = callmethodflags(call2464, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2462);
// compiled member node returning call2465 (depth = 13)
  int op_slot_left_2459 = gc_frame_newslot(call2465);
  params[0] = num2460;
  partcv[0] = 1;
  Object sum2466 = callmethod(call2465, "+(1)", 1, partcv, params);
// compiled op node returning sum2466 (depth = 12)
  gc_frame_newslot(sum2466);
// starting to compile string node (depth = 12)
  if (strlit2467 == NULL) {
    strlit2467 = alloc_String("}");
    gc_root(strlit2467);
  }
// compiled string node returning strlit2467 (depth = 12)
  gc_frame_newslot(strlit2467);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2466;
  params[1] = strlit2467;
  partcv[0] = 2;
  Object call2468 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2458);
// compiled call node returning call2468 (depth = 11)
    gc_frame_newslot(call2468);
    if2449 = call2468;
  }
// compiled if node returning if2449 (depth = 10)
    gc_frame_newslot(if2449);
    if2444 = if2449;
  } else {
  }
// compiled if node returning if2444 (depth = 9)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2469 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2470 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2469);
// compiled call node returning call2470 (depth = 9)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2471 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2472 == NULL) {
    strlit2472 = alloc_String("an elseif statement must end with a '}'.");
    gc_root(strlit2472);
  }
// compiled string node returning strlit2472 (depth = 10)
  gc_frame_newslot(strlit2472);
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2473 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2474 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2473);
// compiled member node returning call2474 (depth = 10)
  gc_frame_newslot(call2474);
// starting to compile member node (depth = 10)
  int callframe2475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2476 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2475);
// compiled member node returning call2476 (depth = 10)
  gc_frame_newslot(call2476);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2472;
  params[1] = call2474;
  params[2] = call2476;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2477 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2471);
// compiled call node returning call2477 (depth = 9)
    gc_frame_newslot(call2477);
    if2429 = call2477;
  } else {
  }
// compiled if node returning if2429 (depth = 8)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call2479 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2478);
// compiled member node returning call2479 (depth = 9)
  *var_v = call2479;
  if (call2479 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2481 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2482 = callmethodflags(*var_ebody, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2481);
// compiled call node returning call2482 (depth = 8)
  gc_frame_end(frame);
  return call2482;
}
Object meth_parser_1946__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_closingBrace = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1948 = gc_frame_new();
// call case 4: self request
  Object call1949 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1948);
// compiled member node returning call1949 (depth = 6)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1952 == NULL) {
    strlit1952 = alloc_String("lbrace");
    gc_root(strlit1952);
  }
// compiled string node returning strlit1952 (depth = 8)
  int op_slot_right_1951 = gc_frame_newslot(strlit1952);
// starting to compile member node (depth = 8)
  int callframe1954 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1955 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1954);
// compiled member node returning call1955 (depth = 8)
  int op_slot_left_1951 = gc_frame_newslot(call1955);
  params[0] = strlit1952;
  partcv[0] = 1;
  Object opresult1956 = callmethod(call1955, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1956 (depth = 7)
  Object if1950 = done;
  if (istrue(opresult1956)) {
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1957 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call1959 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1958);
// compiled member node returning call1959 (depth = 9)
  Object call1960 = callmethodflags(call1959, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1957);
// compiled member node returning call1960 (depth = 8)
  *var_suggestion = call1960;
  if (call1960 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1961 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1962 = alloc_Block(NULL, NULL, "parser", 757);
  gc_frame_newslot(block1962);
// method "_apply(_)"
  block_savedest(block1962);
  Object closure1963 = createclosure(2, "_apply(1)");
  setclosureframe(closure1963, stackframe);
  addtoclosure(closure1963, var_statementToken);
  addtoclosure(closure1963, selfslot);
  struct UserObject *uo1963 = (struct UserObject*)block1962;
  uo1963->data[0] = (Object)closure1963;
  Method *meth_meth_parser_1963__apply_40_1_41_ = addmethod2pos(block1962, "_apply(1)", &meth_parser_1963__apply_40_1_41_, 0);
  int argcv_meth_parser_1963__apply_40_1_41_[] = {1};
  meth_meth_parser_1963__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1963__apply_40_1_41_);
  meth_meth_parser_1963__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1963__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block1962 (depth = 9)
  gc_frame_newslot(block1962);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block1962;
  partcv[0] = 1;
  Object call2008 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1961);
// compiled call node returning call2008 (depth = 8)
  *var_nextTok = call2008;
  if (call2008 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2010 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2012 = alloc_Boolean(0);
// compiled identifier node returning bool2012 (depth = 9)
  int op_slot_left_2010 = gc_frame_newslot(bool2012);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2013 = callmethod(bool2012, "==(1)", 1, partcv, params);
// compiled op node returning opresult2013 (depth = 8)
  Object if2009 = done;
  if (istrue(opresult2013)) {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2014 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2015 == NULL) {
    strlit2015 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2015);
  }
// compiled string node returning strlit2015 (depth = 9)
  gc_frame_newslot(strlit2015);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2015;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2016 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2014);
// compiled call node returning call2016 (depth = 8)
    gc_frame_newslot(call2016);
    if2009 = call2016;
  } else {
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("rbrace");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 10)
  int op_slot_right_2018 = gc_frame_newslot(strlit2019);
// starting to compile member node (depth = 10)
  int callframe2021 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2022 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2021);
// compiled member node returning call2022 (depth = 10)
  int op_slot_left_2018 = gc_frame_newslot(call2022);
  params[0] = strlit2019;
  partcv[0] = 1;
  Object opresult2023 = callmethod(call2022, "==(1)", 1, partcv, params);
// compiled op node returning opresult2023 (depth = 9)
  Object if2017 = done;
  if (istrue(opresult2023)) {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2025 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2025 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2027 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2027 (depth = 10)
  Object if2024 = done;
  if (istrue(opresult2027)) {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2028 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2029 == NULL) {
    strlit2029 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit2029);
  }
// compiled string node returning strlit2029 (depth = 11)
  gc_frame_newslot(strlit2029);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2029;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2030 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2028);
// compiled call node returning call2030 (depth = 10)
    gc_frame_newslot(call2030);
    if2024 = call2030;
  } else {
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2031 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2032 == NULL) {
    strlit2032 = alloc_String("{ ");
    gc_root(strlit2032);
  }
// compiled string node returning strlit2032 (depth = 11)
  gc_frame_newslot(strlit2032);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2032;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2033 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2031);
// compiled call node returning call2033 (depth = 10)
    gc_frame_newslot(call2033);
    if2024 = call2033;
  }
// compiled if node returning if2024 (depth = 9)
    gc_frame_newslot(if2024);
    if2017 = if2024;
  } else {
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2036 == NULL) {
    strlit2036 = alloc_String("lbrace");
    gc_root(strlit2036);
  }
// compiled string node returning strlit2036 (depth = 11)
  int op_slot_right_2035 = gc_frame_newslot(strlit2036);
// starting to compile member node (depth = 11)
  int callframe2038 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  Object call2039 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2038);
// compiled member node returning call2039 (depth = 11)
  int op_slot_left_2035 = gc_frame_newslot(call2039);
  params[0] = strlit2036;
  partcv[0] = 1;
  Object opresult2040 = callmethod(call2039, "==(1)", 1, partcv, params);
// compiled op node returning opresult2040 (depth = 10)
  Object if2034 = done;
  if (istrue(opresult2040)) {
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2042 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2042 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2044 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2044 (depth = 11)
  Object if2041 = done;
  if (istrue(opresult2044)) {
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2045 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2046 == NULL) {
    strlit2046 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then");
    gc_root(strlit2046);
  }
// compiled string node returning strlit2046 (depth = 12)
  gc_frame_newslot(strlit2046);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2046;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2047 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2045);
// compiled call node returning call2047 (depth = 11)
    gc_frame_newslot(call2047);
    if2041 = call2047;
  } else {
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2048 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2049 == NULL) {
    strlit2049 = alloc_String("{ ");
    gc_root(strlit2049);
  }
// compiled string node returning strlit2049 (depth = 12)
  gc_frame_newslot(strlit2049);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2049;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2050 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2048);
// compiled call node returning call2050 (depth = 11)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2051 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2052 == NULL) {
    strlit2052 = alloc_String(" } then");
    gc_root(strlit2052);
  }
// compiled string node returning strlit2052 (depth = 12)
  gc_frame_newslot(strlit2052);
// starting to compile member node (depth = 12)
  int callframe2053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  Object call2054 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2053);
// compiled member node returning call2054 (depth = 12)
  gc_frame_newslot(call2054);
// starting to compile identifier node (depth = 12)
  Object bool2055 = alloc_Boolean(1);
// compiled identifier node returning bool2055 (depth = 12)
  gc_frame_newslot(bool2055);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2052;
  params[1] = call2054;
  params[2] = bool2055;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2056 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2051);
// compiled call node returning call2056 (depth = 11)
    gc_frame_newslot(call2056);
    if2041 = call2056;
  }
// compiled if node returning if2041 (depth = 10)
    gc_frame_newslot(if2041);
    if2034 = if2041;
  } else {
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2059 == NULL) {
    strlit2059 = alloc_String("identifier");
    gc_root(strlit2059);
  }
// compiled string node returning strlit2059 (depth = 12)
  int op_slot_right_2058 = gc_frame_newslot(strlit2059);
// starting to compile member node (depth = 12)
  int callframe2061 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  Object call2062 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2061);
// compiled member node returning call2062 (depth = 12)
  int op_slot_left_2058 = gc_frame_newslot(call2062);
  params[0] = strlit2059;
  partcv[0] = 1;
  Object opresult2063 = callmethod(call2062, "==(1)", 1, partcv, params);
// compiled op node returning opresult2063 (depth = 11)
  Object if2057 = done;
  if (istrue(opresult2063)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2065 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2065 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2067 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2067 (depth = 12)
  Object if2064 = done;
  if (istrue(opresult2067)) {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2068 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2069 == NULL) {
    strlit2069 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" } ");
    gc_root(strlit2069);
  }
// compiled string node returning strlit2069 (depth = 13)
  gc_frame_newslot(strlit2069);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2069;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2070 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2068);
// compiled call node returning call2070 (depth = 12)
    gc_frame_newslot(call2070);
    if2064 = call2070;
  } else {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2071 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2072 == NULL) {
    strlit2072 = alloc_String("{ ");
    gc_root(strlit2072);
  }
// compiled string node returning strlit2072 (depth = 13)
  gc_frame_newslot(strlit2072);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2072;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2073 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2071);
// compiled call node returning call2073 (depth = 12)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2074 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2075 == NULL) {
    strlit2075 = alloc_String(" }");
    gc_root(strlit2075);
  }
// compiled string node returning strlit2075 (depth = 13)
  gc_frame_newslot(strlit2075);
// starting to compile member node (depth = 13)
  int callframe2076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  Object call2077 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2076);
// compiled member node returning call2077 (depth = 13)
  gc_frame_newslot(call2077);
// starting to compile identifier node (depth = 13)
  Object bool2078 = alloc_Boolean(1);
// compiled identifier node returning bool2078 (depth = 13)
  gc_frame_newslot(bool2078);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2075;
  params[1] = call2077;
  params[2] = bool2078;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2079 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2074);
// compiled call node returning call2079 (depth = 12)
    gc_frame_newslot(call2079);
    if2064 = call2079;
  }
// compiled if node returning if2064 (depth = 11)
    gc_frame_newslot(if2064);
    if2057 = if2064;
  } else {
  }
// compiled if node returning if2057 (depth = 10)
    gc_frame_newslot(if2057);
    if2034 = if2057;
  }
// compiled if node returning if2034 (depth = 9)
    gc_frame_newslot(if2034);
    if2017 = if2034;
  }
// compiled if node returning if2017 (depth = 8)
    gc_frame_newslot(if2017);
    if2009 = if2017;
  }
// compiled if node returning if2009 (depth = 7)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2080 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2082 == NULL) {
    strlit2082 = alloc_String("condition in braces after the 'elseif'.");
    gc_root(strlit2082);
  }
// compiled string node returning strlit2082 (depth = 9)
  int op_slot_right_2081 = gc_frame_newslot(strlit2082);
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2084 == NULL) {
    strlit2084 = alloc_String("an elseif statement must have a ");
    gc_root(strlit2084);
  }
// compiled string node returning strlit2084 (depth = 9)
  int op_slot_left_2081 = gc_frame_newslot(strlit2084);
  params[0] = strlit2082;
  partcv[0] = 1;
  Object opresult2085 = callmethod(strlit2084, "++(1)", 1, partcv, params);
// compiled op node returning opresult2085 (depth = 8)
  gc_frame_newslot(opresult2085);
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2086 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2087 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2086);
// compiled member node returning call2087 (depth = 8)
  gc_frame_newslot(call2087);
// starting to compile member node (depth = 8)
  int callframe2088 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2089 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2088);
// compiled member node returning call2089 (depth = 8)
  gc_frame_newslot(call2089);
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2085;
  params[1] = call2087;
  params[2] = call2089;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2090 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2080);
// compiled call node returning call2090 (depth = 7)
    gc_frame_newslot(call2090);
    if1950 = call2090;
  } else {
  }
// compiled if node returning if1950 (depth = 6)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2091 = gc_frame_new();
// call case 4: self request
  Object call2092 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2091);
// compiled member node returning call2092 (depth = 6)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2094 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block2095 = alloc_Block(NULL, NULL, "parser", 789);
  gc_frame_newslot(block2095);
// method "_apply"
  block_savedest(block2095);
  Object closure2096 = createclosure(2, "_apply");
  setclosureframe(closure2096, stackframe);
  addtoclosure(closure2096, var_blocksOK);
  addtoclosure(closure2096, selfslot);
  struct UserObject *uo2096 = (struct UserObject*)block2095;
  uo2096->data[0] = (Object)closure2096;
  Method *meth_meth_parser_2096__apply = addmethod2pos(block2095, "_apply", &meth_parser_2096__apply, 0);
  int argcv_meth_parser_2096__apply[] = {0};
  meth_meth_parser_2096__apply->type = alloc_MethodType(1, argcv_meth_parser_2096__apply);
  meth_meth_parser_2096__apply->definitionModule = modulename;
  meth_meth_parser_2096__apply->definitionLine = 3208;
// compiled block node returning block2095 (depth = 8)
  gc_frame_newslot(block2095);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block2095;
  partcv[0] = 1;
  Object call2100 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2094);
// compiled call node returning call2100 (depth = 7)
  Object if2093 = done;
  if (istrue(call2100)) {
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2101 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2103 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2102);
// compiled member node returning call2103 (depth = 9)
  Object call2104 = callmethodflags(call2103, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2101);
// compiled member node returning call2104 (depth = 8)
  *var_suggestion = call2104;
  if (call2104 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2105 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2106 = alloc_Block(NULL, NULL, "parser", 792);
  gc_frame_newslot(block2106);
// method "_apply(_)"
  block_savedest(block2106);
  Object closure2107 = createclosure(2, "_apply(1)");
  setclosureframe(closure2107, stackframe);
  addtoclosure(closure2107, var_lastToken);
  addtoclosure(closure2107, selfslot);
  struct UserObject *uo2107 = (struct UserObject*)block2106;
  uo2107->data[0] = (Object)closure2107;
  Method *meth_meth_parser_2107__apply_40_1_41_ = addmethod2pos(block2106, "_apply(1)", &meth_parser_2107__apply_40_1_41_, 0);
  int argcv_meth_parser_2107__apply_40_1_41_[] = {1};
  meth_meth_parser_2107__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_2107__apply_40_1_41_);
  meth_meth_parser_2107__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_2107__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block2106 (depth = 9)
  gc_frame_newslot(block2106);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block2106;
  partcv[0] = 1;
  Object call2125 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2105);
// compiled call node returning call2125 (depth = 8)
  *var_nextTok = call2125;
  if (call2125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2127 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2129 = alloc_Boolean(0);
// compiled identifier node returning bool2129 (depth = 9)
  int op_slot_left_2127 = gc_frame_newslot(bool2129);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2130 = callmethod(bool2129, "==(1)", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 8)
  Object if2126 = done;
  if (istrue(opresult2130)) {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2131 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array2132 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit2133 == NULL) {
    strlit2133 = alloc_String("rbrace");
    gc_root(strlit2133);
  }
// compiled string node returning strlit2133 (depth = 11)
  params[0] = strlit2133;
  partcv[0] = 1;
  callmethodflags(array2132, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2132 (depth = 10)
  gc_frame_newslot(array2132);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = array2132;
  partcv[0] = 1;
  Object call2134 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2131);
// compiled call node returning call2134 (depth = 9)
  *var_nextTok = call2134;
  if (call2134 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2137 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2137 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2139 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2139 (depth = 9)
  Object if2136 = done;
  if (istrue(opresult2139)) {
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2140 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2141 == NULL) {
    strlit2141 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2141);
  }
// compiled string node returning strlit2141 (depth = 10)
  gc_frame_newslot(strlit2141);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2141;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2142 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2140);
// compiled call node returning call2142 (depth = 9)
    gc_frame_newslot(call2142);
    if2136 = call2142;
  } else {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2143 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2144 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2145 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2144);
// compiled member node returning call2145 (depth = 10)
  gc_frame_newslot(call2145);
// starting to compile identifier node (depth = 10)
  Object bool2146 = alloc_Boolean(1);
// compiled identifier node returning bool2146 (depth = 10)
  gc_frame_newslot(bool2146);
// starting to compile identifier node (depth = 10)
  Object bool2147 = alloc_Boolean(0);
// compiled identifier node returning bool2147 (depth = 10)
  gc_frame_newslot(bool2147);
// starting to compile string node (depth = 10)
  if (strlit2148 == NULL) {
    strlit2148 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2148);
  }
// compiled string node returning strlit2148 (depth = 10)
  gc_frame_newslot(strlit2148);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2145;
  params[2] = bool2146;
  params[3] = bool2147;
  params[4] = strlit2148;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2149 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2143);
// compiled call node returning call2149 (depth = 9)
    gc_frame_newslot(call2149);
    if2136 = call2149;
  }
// compiled if node returning if2136 (depth = 8)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2150 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2151 == NULL) {
    strlit2151 = alloc_String("an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2151);
  }
// compiled string node returning strlit2151 (depth = 9)
  gc_frame_newslot(strlit2151);
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2152 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2153 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2152);
// compiled member node returning call2153 (depth = 9)
  gc_frame_newslot(call2153);
// starting to compile member node (depth = 9)
  int callframe2154 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2155 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2154);
// compiled member node returning call2155 (depth = 9)
  gc_frame_newslot(call2155);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2151;
  params[1] = call2153;
  params[2] = call2155;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2156 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2150);
// compiled call node returning call2156 (depth = 8)
    gc_frame_newslot(call2156);
    if2126 = call2156;
  } else {
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2158 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2158 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2160 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2160 (depth = 9)
  Object if2157 = done;
  if (istrue(opresult2160)) {
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2161 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2162 == NULL) {
    strlit2162 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2162);
  }
// compiled string node returning strlit2162 (depth = 10)
  gc_frame_newslot(strlit2162);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2162;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2163 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2161);
// compiled call node returning call2163 (depth = 9)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2164 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2165 == NULL) {
    strlit2165 = alloc_String("an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2165);
  }
// compiled string node returning strlit2165 (depth = 10)
  gc_frame_newslot(strlit2165);
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2166 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2167 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2166);
// compiled member node returning call2167 (depth = 10)
  gc_frame_newslot(call2167);
// starting to compile member node (depth = 10)
  int callframe2168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2169 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2168);
// compiled member node returning call2169 (depth = 10)
  gc_frame_newslot(call2169);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2165;
  params[1] = call2167;
  params[2] = call2169;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2170 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2164);
// compiled call node returning call2170 (depth = 9)
    gc_frame_newslot(call2170);
    if2157 = call2170;
  } else {
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2171 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2172 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2173 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2172);
// compiled member node returning call2173 (depth = 10)
  gc_frame_newslot(call2173);
// starting to compile identifier node (depth = 10)
  Object bool2174 = alloc_Boolean(0);
// compiled identifier node returning bool2174 (depth = 10)
  gc_frame_newslot(bool2174);
// starting to compile identifier node (depth = 10)
  Object bool2175 = alloc_Boolean(1);
// compiled identifier node returning bool2175 (depth = 10)
  gc_frame_newslot(bool2175);
// starting to compile string node (depth = 10)
  if (strlit2176 == NULL) {
    strlit2176 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2176);
  }
// compiled string node returning strlit2176 (depth = 10)
  gc_frame_newslot(strlit2176);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2173;
  params[2] = bool2174;
  params[3] = bool2175;
  params[4] = strlit2176;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2177 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2171);
// compiled call node returning call2177 (depth = 9)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2178 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2179 == NULL) {
    strlit2179 = alloc_String("(4) an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2179);
  }
// compiled string node returning strlit2179 (depth = 10)
  gc_frame_newslot(strlit2179);
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2180 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2181 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2180);
// compiled member node returning call2181 (depth = 10)
  gc_frame_newslot(call2181);
// starting to compile member node (depth = 10)
  int callframe2182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2183 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2182);
// compiled member node returning call2183 (depth = 10)
  gc_frame_newslot(call2183);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2185 = alloc_Float64(1);
// compiled num node returning num2185 (depth = 11)
  int op_slot_right_2184 = gc_frame_newslot(num2185);
// starting to compile member node (depth = 11)
  int callframe2187 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  Object call2188 = callmethodflags(*var_nextTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2187);
// compiled member node returning call2188 (depth = 11)
  int op_slot_left_2184 = gc_frame_newslot(call2188);
  params[0] = num2185;
  partcv[0] = 1;
  Object diff2189 = callmethod(call2188, "-(1)", 1, partcv, params);
// compiled op node returning diff2189 (depth = 10)
  gc_frame_newslot(diff2189);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2179;
  params[1] = call2181;
  params[2] = call2183;
  params[3] = diff2189;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2190 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2178);
// compiled call node returning call2190 (depth = 9)
    gc_frame_newslot(call2190);
    if2157 = call2190;
  }
// compiled if node returning if2157 (depth = 8)
    gc_frame_newslot(if2157);
    if2126 = if2157;
  }
// compiled if node returning if2126 (depth = 7)
    gc_frame_newslot(if2126);
    if2093 = if2126;
  } else {
  }
// compiled if node returning if2093 (depth = 6)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2193 == NULL) {
    strlit2193 = alloc_String("}");
    gc_root(strlit2193);
  }
// compiled string node returning strlit2193 (depth = 8)
  int op_slot_right_2192 = gc_frame_newslot(strlit2193);
// starting to compile member node (depth = 8)
  int callframe2195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2196 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2195);
// compiled member node returning call2196 (depth = 8)
  int op_slot_left_2192 = gc_frame_newslot(call2196);
  params[0] = strlit2193;
  partcv[0] = 1;
  Object opresult2197 = callmethod(call2196, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2197 (depth = 7)
  Object if2191 = done;
  if (istrue(opresult2197)) {
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2198 = gc_frame_new();
// call case 4: self request
  Object call2199 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2198);
// compiled member node returning call2199 (depth = 7)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2200 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2202 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2201);
// compiled member node returning call2202 (depth = 9)
  Object call2203 = callmethodflags(call2202, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2200);
// compiled member node returning call2203 (depth = 8)
  *var_suggestion = call2203;
  if (call2203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2204 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2205 == NULL) {
    strlit2205 = alloc_String(")");
    gc_root(strlit2205);
  }
// compiled string node returning strlit2205 (depth = 8)
  gc_frame_newslot(strlit2205);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2205;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2206 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2204);
// compiled call node returning call2206 (depth = 7)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2207 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2209 == NULL) {
    strlit2209 = alloc_String("'{' must end with a '}'.");
    gc_root(strlit2209);
  }
// compiled string node returning strlit2209 (depth = 9)
  int op_slot_right_2208 = gc_frame_newslot(strlit2209);
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2211 == NULL) {
    strlit2211 = alloc_String("a condition beginning with a ");
    gc_root(strlit2211);
  }
// compiled string node returning strlit2211 (depth = 9)
  int op_slot_left_2208 = gc_frame_newslot(strlit2211);
  params[0] = strlit2209;
  partcv[0] = 1;
  Object opresult2212 = callmethod(strlit2211, "++(1)", 1, partcv, params);
// compiled op node returning opresult2212 (depth = 8)
  gc_frame_newslot(opresult2212);
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2214 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2213);
// compiled member node returning call2214 (depth = 8)
  gc_frame_newslot(call2214);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2216 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2217 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2216);
// compiled member node returning call2217 (depth = 9)
  int op_slot_right_2215 = gc_frame_newslot(call2217);
// starting to compile member node (depth = 9)
  int callframe2219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2220 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2219);
// compiled member node returning call2220 (depth = 9)
  int op_slot_left_2215 = gc_frame_newslot(call2220);
  params[0] = call2217;
  partcv[0] = 1;
  Object sum2221 = callmethod(call2220, "+(1)", 1, partcv, params);
// compiled op node returning sum2221 (depth = 8)
  gc_frame_newslot(sum2221);
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2212;
  params[1] = call2214;
  params[2] = sum2221;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2222 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2207);
// compiled call node returning call2222 (depth = 7)
    gc_frame_newslot(call2222);
    if2191 = call2222;
  } else {
  }
// compiled if node returning if2191 (depth = 6)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2223 = gc_frame_new();
// call case 4: self request
  Object call2224 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2223);
// compiled member node returning call2224 (depth = 6)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call2226 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2225);
// compiled member node returning call2226 (depth = 7)
  *var_econd = call2226;
  if (call2226 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2231 == NULL) {
    strlit2231 = alloc_String("then");
    gc_root(strlit2231);
  }
// compiled string node returning strlit2231 (depth = 9)
  int op_slot_right_2230 = gc_frame_newslot(strlit2231);
// starting to compile member node (depth = 9)
  int callframe2233 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2234 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2233);
// compiled member node returning call2234 (depth = 9)
  int op_slot_left_2230 = gc_frame_newslot(call2234);
  params[0] = strlit2231;
  partcv[0] = 1;
  Object opresult2235 = callmethod(call2234, "==(1)", 1, partcv, params);
// compiled op node returning opresult2235 (depth = 8)
  int op_slot_right_2229 = gc_frame_newslot(opresult2235);
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2237 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2238 == NULL) {
    strlit2238 = alloc_String("identifier");
    gc_root(strlit2238);
  }
// compiled string node returning strlit2238 (depth = 9)
  gc_frame_newslot(strlit2238);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit2238;
  partcv[0] = 1;
  Object call2239 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2237);
// compiled call node returning call2239 (depth = 8)
  int op_slot_left_2229 = gc_frame_newslot(call2239);
  params[0] = opresult2235;
  partcv[0] = 1;
  Object opresult2240 = callmethod(call2239, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2240 (depth = 7)
  Object if2228 = done;
  if (istrue(opresult2240)) {
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2241 = gc_frame_new();
// call case 4: self request
  Object call2242 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2241);
// compiled member node returning call2242 (depth = 7)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2243 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2243 (depth = 8)
  *var_ebody = array2243;
  if (array2243 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2228 = done;
  } else {
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2245 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2247 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2246);
// compiled member node returning call2247 (depth = 9)
  Object call2248 = callmethodflags(call2247, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2245);
// compiled member node returning call2248 (depth = 8)
  *var_suggestion = call2248;
  if (call2248 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2251 == NULL) {
    strlit2251 = alloc_String("lbrace");
    gc_root(strlit2251);
  }
// compiled string node returning strlit2251 (depth = 9)
  int op_slot_right_2250 = gc_frame_newslot(strlit2251);
// starting to compile member node (depth = 9)
  int callframe2253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2254 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2253);
// compiled member node returning call2254 (depth = 9)
  int op_slot_left_2250 = gc_frame_newslot(call2254);
  params[0] = strlit2251;
  partcv[0] = 1;
  Object opresult2255 = callmethod(call2254, "==(1)", 1, partcv, params);
// compiled op node returning opresult2255 (depth = 8)
  Object if2249 = done;
  if (istrue(opresult2255)) {
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2256 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2257 = alloc_Boolean(0);
// compiled identifier node returning bool2257 (depth = 10)
  gc_frame_newslot(bool2257);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_statementToken;
  params[1] = bool2257;
  partcv[0] = 2;
  Object call2258 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2256);
// compiled call node returning call2258 (depth = 9)
  *var_closingBrace = call2258;
  if (call2258 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2260 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2262 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2261);
// compiled member node returning call2262 (depth = 10)
  Object call2263 = callmethodflags(call2262, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2260);
// compiled member node returning call2263 (depth = 9)
  Object if2259 = done;
  if (istrue(call2263)) {
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2265 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
  int callframe2267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2268 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2267);
// compiled member node returning call2268 (depth = 11)
  int op_slot_left_2265 = gc_frame_newslot(call2268);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2269 = callmethod(call2268, "==(1)", 1, partcv, params);
// compiled op node returning opresult2269 (depth = 10)
  Object if2264 = done;
  if (istrue(opresult2269)) {
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2270 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2271 = alloc_Boolean(1);
// compiled identifier node returning bool2271 (depth = 11)
  gc_frame_newslot(bool2271);
// starting to compile identifier node (depth = 11)
  Object bool2272 = alloc_Boolean(0);
// compiled identifier node returning bool2272 (depth = 11)
  gc_frame_newslot(bool2272);
// starting to compile string node (depth = 11)
  if (strlit2273 == NULL) {
    strlit2273 = alloc_String(" then {}");
    gc_root(strlit2273);
  }
// compiled string node returning strlit2273 (depth = 11)
  gc_frame_newslot(strlit2273);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2271;
  params[2] = bool2272;
  params[3] = strlit2273;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2274 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2270);
// compiled call node returning call2274 (depth = 10)
    gc_frame_newslot(call2274);
    if2264 = call2274;
  } else {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2275 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2276 = alloc_Boolean(1);
// compiled identifier node returning bool2276 (depth = 11)
  gc_frame_newslot(bool2276);
// starting to compile identifier node (depth = 11)
  Object bool2277 = alloc_Boolean(0);
// compiled identifier node returning bool2277 (depth = 11)
  gc_frame_newslot(bool2277);
// starting to compile string node (depth = 11)
  if (strlit2278 == NULL) {
    strlit2278 = alloc_String(" then {");
    gc_root(strlit2278);
  }
// compiled string node returning strlit2278 (depth = 11)
  gc_frame_newslot(strlit2278);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2276;
  params[2] = bool2277;
  params[3] = strlit2278;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2279 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2275);
// compiled call node returning call2279 (depth = 10)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2280 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2282 = alloc_Float64(0.1);
// compiled num node returning num2282 (depth = 12)
  int op_slot_right_2281 = gc_frame_newslot(num2282);
// starting to compile member node (depth = 12)
  int callframe2284 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2285 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2286 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2285);
// compiled member node returning call2286 (depth = 13)
  Object call2287 = callmethodflags(call2286, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2284);
// compiled member node returning call2287 (depth = 12)
  int op_slot_left_2281 = gc_frame_newslot(call2287);
  params[0] = num2282;
  partcv[0] = 1;
  Object sum2288 = callmethod(call2287, "+(1)", 1, partcv, params);
// compiled op node returning sum2288 (depth = 11)
  gc_frame_newslot(sum2288);
// starting to compile string node (depth = 11)
  if (strlit2289 == NULL) {
    strlit2289 = alloc_String("}");
    gc_root(strlit2289);
  }
// compiled string node returning strlit2289 (depth = 11)
  gc_frame_newslot(strlit2289);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2288;
  params[1] = strlit2289;
  partcv[0] = 2;
  Object call2290 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2280);
// compiled call node returning call2290 (depth = 10)
    gc_frame_newslot(call2290);
    if2264 = call2290;
  }
// compiled if node returning if2264 (depth = 9)
    gc_frame_newslot(if2264);
    if2259 = if2264;
  } else {
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2291 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2292 = alloc_Boolean(1);
// compiled identifier node returning bool2292 (depth = 10)
  gc_frame_newslot(bool2292);
// starting to compile identifier node (depth = 10)
  Object bool2293 = alloc_Boolean(0);
// compiled identifier node returning bool2293 (depth = 10)
  gc_frame_newslot(bool2293);
// starting to compile string node (depth = 10)
  if (strlit2294 == NULL) {
    strlit2294 = alloc_String(" then {");
    gc_root(strlit2294);
  }
// compiled string node returning strlit2294 (depth = 10)
  gc_frame_newslot(strlit2294);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2292;
  params[2] = bool2293;
  params[3] = strlit2294;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2295 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2291);
// compiled call node returning call2295 (depth = 9)
    gc_frame_newslot(call2295);
    if2259 = call2295;
  }
// compiled if node returning if2259 (depth = 8)
    gc_frame_newslot(if2259);
    if2249 = if2259;
  } else {
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2296 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2297 = alloc_Boolean(1);
// compiled identifier node returning bool2297 (depth = 10)
  gc_frame_newslot(bool2297);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_statementToken;
  params[1] = bool2297;
  partcv[0] = 2;
  Object call2298 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2296);
// compiled call node returning call2298 (depth = 9)
  *var_closingBrace = call2298;
  if (call2298 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2300 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2302 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2301);
// compiled member node returning call2302 (depth = 10)
  Object call2303 = callmethodflags(call2302, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2300);
// compiled member node returning call2303 (depth = 9)
  Object if2299 = done;
  if (istrue(call2303)) {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2305 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2307 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2308 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2307);
// compiled member node returning call2308 (depth = 11)
  int op_slot_left_2305 = gc_frame_newslot(call2308);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2309 = callmethod(call2308, "==(1)", 1, partcv, params);
// compiled op node returning opresult2309 (depth = 10)
  Object if2304 = done;
  if (istrue(opresult2309)) {
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2310 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2311 == NULL) {
    strlit2311 = alloc_String(" then {}");
    gc_root(strlit2311);
  }
// compiled string node returning strlit2311 (depth = 11)
  gc_frame_newslot(strlit2311);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2311;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2312 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2310);
// compiled call node returning call2312 (depth = 10)
    gc_frame_newslot(call2312);
    if2304 = call2312;
  } else {
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2313 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2314 == NULL) {
    strlit2314 = alloc_String(" then {");
    gc_root(strlit2314);
  }
// compiled string node returning strlit2314 (depth = 11)
  gc_frame_newslot(strlit2314);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2314;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2315 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2313);
// compiled call node returning call2315 (depth = 10)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2316 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2318 = alloc_Float64(0.1);
// compiled num node returning num2318 (depth = 12)
  int op_slot_right_2317 = gc_frame_newslot(num2318);
// starting to compile member node (depth = 12)
  int callframe2320 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2322 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2321);
// compiled member node returning call2322 (depth = 13)
  Object call2323 = callmethodflags(call2322, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2320);
// compiled member node returning call2323 (depth = 12)
  int op_slot_left_2317 = gc_frame_newslot(call2323);
  params[0] = num2318;
  partcv[0] = 1;
  Object sum2324 = callmethod(call2323, "+(1)", 1, partcv, params);
// compiled op node returning sum2324 (depth = 11)
  gc_frame_newslot(sum2324);
// starting to compile string node (depth = 11)
  if (strlit2325 == NULL) {
    strlit2325 = alloc_String("}");
    gc_root(strlit2325);
  }
// compiled string node returning strlit2325 (depth = 11)
  gc_frame_newslot(strlit2325);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2324;
  params[1] = strlit2325;
  partcv[0] = 2;
  Object call2326 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2316);
// compiled call node returning call2326 (depth = 10)
    gc_frame_newslot(call2326);
    if2304 = call2326;
  }
// compiled if node returning if2304 (depth = 9)
    gc_frame_newslot(if2304);
    if2299 = if2304;
  } else {
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2327 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2328 == NULL) {
    strlit2328 = alloc_String(" then {");
    gc_root(strlit2328);
  }
// compiled string node returning strlit2328 (depth = 10)
  gc_frame_newslot(strlit2328);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2328;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2329 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2327);
// compiled call node returning call2329 (depth = 9)
    gc_frame_newslot(call2329);
    if2299 = call2329;
  }
// compiled if node returning if2299 (depth = 8)
    gc_frame_newslot(if2299);
    if2249 = if2299;
  }
// compiled if node returning if2249 (depth = 7)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2330 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2331 == NULL) {
    strlit2331 = alloc_String("an elseif statement must have 'then' after the expression in braces.");
    gc_root(strlit2331);
  }
// compiled string node returning strlit2331 (depth = 8)
  gc_frame_newslot(strlit2331);
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2332 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2333 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2332);
// compiled member node returning call2333 (depth = 8)
  gc_frame_newslot(call2333);
// starting to compile member node (depth = 8)
  int callframe2334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2335 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2334);
// compiled member node returning call2335 (depth = 8)
  gc_frame_newslot(call2335);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2331;
  params[1] = call2333;
  params[2] = call2335;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2336 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2330);
// compiled call node returning call2336 (depth = 7)
    gc_frame_newslot(call2336);
    if2228 = call2336;
  }
// compiled if node returning if2228 (depth = 6)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2339 == NULL) {
    strlit2339 = alloc_String("lbrace");
    gc_root(strlit2339);
  }
// compiled string node returning strlit2339 (depth = 8)
  int op_slot_right_2338 = gc_frame_newslot(strlit2339);
// starting to compile member node (depth = 8)
  int callframe2341 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2342 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2341);
// compiled member node returning call2342 (depth = 8)
  int op_slot_left_2338 = gc_frame_newslot(call2342);
  params[0] = strlit2339;
  partcv[0] = 1;
  Object opresult2343 = callmethod(call2342, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2343 (depth = 7)
  Object if2337 = done;
  if (istrue(opresult2343)) {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2344 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2345 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2346 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2345);
// compiled member node returning call2346 (depth = 9)
  Object call2347 = callmethodflags(call2346, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2344);
// compiled member node returning call2347 (depth = 8)
  *var_suggestion = call2347;
  if (call2347 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2348 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2349 = alloc_Boolean(1);
// compiled identifier node returning bool2349 (depth = 9)
  gc_frame_newslot(bool2349);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_btok;
  params[1] = bool2349;
  partcv[0] = 2;
  Object call2350 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2348);
// compiled call node returning call2350 (depth = 8)
  *var_closingBrace = call2350;
  if (call2350 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2352 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2353 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call2354 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2353);
// compiled member node returning call2354 (depth = 9)
  Object call2355 = callmethodflags(call2354, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2352);
// compiled member node returning call2355 (depth = 8)
  Object if2351 = done;
  if (istrue(call2355)) {
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2357 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe2359 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2360 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2359);
// compiled member node returning call2360 (depth = 10)
  int op_slot_left_2357 = gc_frame_newslot(call2360);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2361 = callmethod(call2360, "==(1)", 1, partcv, params);
// compiled op node returning opresult2361 (depth = 9)
  Object if2356 = done;
  if (istrue(opresult2361)) {
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2362 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2363 = alloc_Boolean(0);
// compiled identifier node returning bool2363 (depth = 10)
  gc_frame_newslot(bool2363);
// starting to compile identifier node (depth = 10)
  Object bool2364 = alloc_Boolean(1);
// compiled identifier node returning bool2364 (depth = 10)
  gc_frame_newslot(bool2364);
// starting to compile string node (depth = 10)
  if (strlit2365 == NULL) {
    strlit2365 = alloc_String("then {}");
    gc_root(strlit2365);
  }
// compiled string node returning strlit2365 (depth = 10)
  gc_frame_newslot(strlit2365);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2363;
  params[2] = bool2364;
  params[3] = strlit2365;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2366 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2362);
// compiled call node returning call2366 (depth = 9)
    gc_frame_newslot(call2366);
    if2356 = call2366;
  } else {
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2367 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2369 = alloc_Float64(0.1);
// compiled num node returning num2369 (depth = 11)
  int op_slot_right_2368 = gc_frame_newslot(num2369);
// starting to compile member node (depth = 11)
  int callframe2371 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call2373 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2372);
// compiled member node returning call2373 (depth = 12)
  Object call2374 = callmethodflags(call2373, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2371);
// compiled member node returning call2374 (depth = 11)
  int op_slot_left_2368 = gc_frame_newslot(call2374);
  params[0] = num2369;
  partcv[0] = 1;
  Object sum2375 = callmethod(call2374, "+(1)", 1, partcv, params);
// compiled op node returning sum2375 (depth = 10)
  gc_frame_newslot(sum2375);
// starting to compile string node (depth = 10)
  if (strlit2376 == NULL) {
    strlit2376 = alloc_String("}");
    gc_root(strlit2376);
  }
// compiled string node returning strlit2376 (depth = 10)
  gc_frame_newslot(strlit2376);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2375;
  params[1] = strlit2376;
  partcv[0] = 2;
  Object call2377 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2367);
// compiled call node returning call2377 (depth = 9)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2378 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2379 = alloc_Boolean(0);
// compiled identifier node returning bool2379 (depth = 10)
  gc_frame_newslot(bool2379);
// starting to compile identifier node (depth = 10)
  Object bool2380 = alloc_Boolean(1);
// compiled identifier node returning bool2380 (depth = 10)
  gc_frame_newslot(bool2380);
// starting to compile string node (depth = 10)
  if (strlit2381 == NULL) {
    strlit2381 = alloc_String("then {");
    gc_root(strlit2381);
  }
// compiled string node returning strlit2381 (depth = 10)
  gc_frame_newslot(strlit2381);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2379;
  params[2] = bool2380;
  params[3] = strlit2381;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2382 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2378);
// compiled call node returning call2382 (depth = 9)
    gc_frame_newslot(call2382);
    if2356 = call2382;
  }
// compiled if node returning if2356 (depth = 8)
    gc_frame_newslot(if2356);
    if2351 = if2356;
  } else {
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2383 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2384 = alloc_Boolean(0);
// compiled identifier node returning bool2384 (depth = 9)
  gc_frame_newslot(bool2384);
// starting to compile identifier node (depth = 9)
  Object bool2385 = alloc_Boolean(1);
// compiled identifier node returning bool2385 (depth = 9)
  gc_frame_newslot(bool2385);
// starting to compile string node (depth = 9)
  if (strlit2386 == NULL) {
    strlit2386 = alloc_String("then {");
    gc_root(strlit2386);
  }
// compiled string node returning strlit2386 (depth = 9)
  gc_frame_newslot(strlit2386);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2384;
  params[2] = bool2385;
  params[3] = strlit2386;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2387 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2383);
// compiled call node returning call2387 (depth = 8)
    gc_frame_newslot(call2387);
    if2351 = call2387;
  }
// compiled if node returning if2351 (depth = 7)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2388 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2389 == NULL) {
    strlit2389 = alloc_String("an elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2389);
  }
// compiled string node returning strlit2389 (depth = 8)
  gc_frame_newslot(strlit2389);
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2391 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2390);
// compiled member node returning call2391 (depth = 8)
  gc_frame_newslot(call2391);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2394 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2393);
// compiled member node returning call2394 (depth = 9)
  int op_slot_right_2392 = gc_frame_newslot(call2394);
// starting to compile member node (depth = 9)
  int callframe2396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2397 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2396);
// compiled member node returning call2397 (depth = 9)
  int op_slot_left_2392 = gc_frame_newslot(call2397);
  params[0] = call2394;
  partcv[0] = 1;
  Object sum2398 = callmethod(call2397, "+(1)", 1, partcv, params);
// compiled op node returning sum2398 (depth = 8)
  gc_frame_newslot(sum2398);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2389;
  params[1] = call2391;
  params[2] = sum2398;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2399 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2388);
// compiled call node returning call2399 (depth = 7)
    gc_frame_newslot(call2399);
    if2337 = call2399;
  } else {
  }
// compiled if node returning if2337 (depth = 6)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2400 = gc_frame_new();
// call case 4: self request
  Object call2401 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2400);
// compiled member node returning call2401 (depth = 6)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2405 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2404);
// compiled member node returning call2405 (depth = 8)
  int op_slot_right_2403 = gc_frame_newslot(call2405);
// starting to compile member node (depth = 8)
  int callframe2407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2408 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2407);
// compiled member node returning call2408 (depth = 8)
  int op_slot_left_2403 = gc_frame_newslot(call2408);
  params[0] = call2405;
  partcv[0] = 1;
  Object opresult2409 = callmethod(call2408, "==(1)", 1, partcv, params);
// compiled op node returning opresult2409 (depth = 7)
  Object if2402 = done;
  if (istrue(opresult2409)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2411 = alloc_Float64(1);
// compiled num node returning num2411 (depth = 9)
  int op_slot_right_2410 = gc_frame_newslot(num2411);
// starting to compile member node (depth = 9)
  int callframe2413 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2414 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2413);
// compiled member node returning call2414 (depth = 9)
  int op_slot_left_2410 = gc_frame_newslot(call2414);
  params[0] = num2411;
  partcv[0] = 1;
  Object diff2415 = callmethod(call2414, "-(1)", 1, partcv, params);
// compiled op node returning diff2415 (depth = 8)
  *var_minIndentLevel = diff2415;
  if (diff2415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2402 = done;
  } else {
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2402 = done;
  }
// compiled if node returning if2402 (depth = 6)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2418 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2419 = alloc_Block(NULL, NULL, "parser", 883);
  gc_frame_newslot(block2419);
// method "_apply"
  block_savedest(block2419);
  Object closure2420 = createclosure(1, "_apply");
  setclosureframe(closure2420, stackframe);
  addtoclosure(closure2420, selfslot);
  struct UserObject *uo2420 = (struct UserObject*)block2419;
  uo2420->data[0] = (Object)closure2420;
  Method *meth_meth_parser_2420__apply = addmethod2pos(block2419, "_apply", &meth_parser_2420__apply, 0);
  int argcv_meth_parser_2420__apply[] = {0};
  meth_meth_parser_2420__apply->type = alloc_MethodType(1, argcv_meth_parser_2420__apply);
  meth_meth_parser_2420__apply->definitionModule = modulename;
  meth_meth_parser_2420__apply->definitionLine = 3208;
// compiled block node returning block2419 (depth = 7)
  gc_frame_newslot(block2419);
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block2427 = alloc_Block(NULL, NULL, "parser", 883);
  gc_frame_newslot(block2427);
// method "_apply"
  block_savedest(block2427);
  Object closure2428 = createclosure(8, "_apply");
  setclosureframe(closure2428, stackframe);
  addtoclosure(closure2428, var_errormessages);
  addtoclosure(closure2428, var_btok);
  addtoclosure(closure2428, var_lastToken);
  addtoclosure(closure2428, var_sym);
  addtoclosure(closure2428, var_values);
  addtoclosure(closure2428, var_v);
  addtoclosure(closure2428, var_ebody);
  addtoclosure(closure2428, selfslot);
  struct UserObject *uo2428 = (struct UserObject*)block2427;
  uo2428->data[0] = (Object)closure2428;
  Method *meth_meth_parser_2428__apply = addmethod2pos(block2427, "_apply", &meth_parser_2428__apply, 0);
  int argcv_meth_parser_2428__apply[] = {0};
  meth_meth_parser_2428__apply->type = alloc_MethodType(1, argcv_meth_parser_2428__apply);
  meth_meth_parser_2428__apply->definitionModule = modulename;
  meth_meth_parser_2428__apply->definitionLine = 3208;
// compiled block node returning block2427 (depth = 7)
  gc_frame_newslot(block2427);
// call case 5: prelude request
  params[0] = block2419;
  params[1] = block2427;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2484 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2418);
// compiled call node returning call2484 (depth = 6)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2485 = gc_frame_new();
// call case 4: self request
  Object call2486 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2485);
// compiled member node returning call2486 (depth = 6)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2487 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2487 (depth = 7)
  *var_newelse = array2487;
  if (array2487 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2489 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2490 = callmethodflags(module_parser, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2489);
// compiled call node returning call2490 (depth = 7)
  *var_eif = call2490;
  if (call2490 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2492 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2493 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2492);
// compiled call node returning call2493 (depth = 6)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_2595__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe2596 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe2597 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2598 == NULL) {
    strlit2598 = alloc_String("rbrace");
    gc_root(strlit2598);
  }
// compiled string node returning strlit2598 (depth = 9)
  gc_frame_newslot(strlit2598);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit2598;
  partcv[0] = 1;
  Object call2599 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2597);
// compiled call node returning call2599 (depth = 8)
  Object call2600 = callmethodflags(call2599, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2596);
// compiled member node returning call2600 (depth = 7)
  gc_frame_end(frame);
  return call2600;
}
Object meth_parser_2607__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 10)
  int callframe2608 = gc_frame_new();
// call case 4: self request
  Object call2609 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2608);
// compiled member node returning call2609 (depth = 10)
  gc_frame_end(frame);
  return call2609;
}
Object meth_parser_2603__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2605 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2606 = alloc_Block(NULL, NULL, "parser", 938);
  gc_frame_newslot(block2606);
// method "_apply"
  block_savedest(block2606);
  Object closure2607 = createclosure(1, "_apply");
  setclosureframe(closure2607, stackframe);
  addtoclosure(closure2607, selfslot);
  struct UserObject *uo2607 = (struct UserObject*)block2606;
  uo2607->data[0] = (Object)closure2607;
  Method *meth_meth_parser_2607__apply = addmethod2pos(block2606, "_apply", &meth_parser_2607__apply, 0);
  int argcv_meth_parser_2607__apply[] = {0};
  meth_meth_parser_2607__apply->type = alloc_MethodType(1, argcv_meth_parser_2607__apply);
  meth_meth_parser_2607__apply->definitionModule = modulename;
  meth_meth_parser_2607__apply->definitionLine = 3208;
// compiled block node returning block2606 (depth = 9)
  gc_frame_newslot(block2606);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block2606;
  partcv[0] = 1;
  Object call2611 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2605);
// compiled call node returning call2611 (depth = 8)
  Object if2604 = done;
  if (istrue(call2611)) {
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2612 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2613 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call2614 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2613);
// compiled member node returning call2614 (depth = 10)
  Object call2615 = callmethodflags(call2614, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2612);
// compiled member node returning call2615 (depth = 9)
  *var_suggestion = call2615;
  if (call2615 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2616 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool2617 = alloc_Boolean(0);
// compiled identifier node returning bool2617 (depth = 10)
  gc_frame_newslot(bool2617);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_btok;
  params[1] = bool2617;
  partcv[0] = 2;
  Object call2618 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2616);
// compiled call node returning call2618 (depth = 9)
  *var_closingBrace = call2618;
  if (call2618 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2620 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2621 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2622 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2621);
// compiled member node returning call2622 (depth = 10)
  Object call2623 = callmethodflags(call2622, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2620);
// compiled member node returning call2623 (depth = 9)
  Object if2619 = done;
  if (istrue(call2623)) {
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2626 == NULL) {
    strlit2626 = alloc_String("eof");
    gc_root(strlit2626);
  }
// compiled string node returning strlit2626 (depth = 11)
  int op_slot_right_2625 = gc_frame_newslot(strlit2626);
// starting to compile member node (depth = 11)
  int callframe2628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call2629 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2628);
// compiled member node returning call2629 (depth = 11)
  int op_slot_left_2625 = gc_frame_newslot(call2629);
  params[0] = strlit2626;
  partcv[0] = 1;
  Object opresult2630 = callmethod(call2629, "==(1)", 1, partcv, params);
// compiled op node returning opresult2630 (depth = 10)
  Object if2624 = done;
  if (istrue(opresult2630)) {
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2631 = gc_frame_new();
// starting to compile op node (depth = 11)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2633 == NULL) {
    strlit2633 = alloc_String("an 'else' statement.");
    gc_root(strlit2633);
  }
// compiled string node returning strlit2633 (depth = 12)
  int op_slot_right_2632 = gc_frame_newslot(strlit2633);
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2636 == NULL) {
    strlit2636 = alloc_String("found while searching for the '}' to close ");
    gc_root(strlit2636);
  }
// compiled string node returning strlit2636 (depth = 13)
  int op_slot_right_2635 = gc_frame_newslot(strlit2636);
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2638 == NULL) {
    strlit2638 = alloc_String("end of program ");
    gc_root(strlit2638);
  }
// compiled string node returning strlit2638 (depth = 13)
  int op_slot_left_2635 = gc_frame_newslot(strlit2638);
  params[0] = strlit2636;
  partcv[0] = 1;
  Object opresult2639 = callmethod(strlit2638, "++(1)", 1, partcv, params);
// compiled op node returning opresult2639 (depth = 12)
  int op_slot_left_2632 = gc_frame_newslot(opresult2639);
  params[0] = strlit2633;
  partcv[0] = 1;
  Object opresult2640 = callmethod(opresult2639, "++(1)", 1, partcv, params);
// compiled op node returning opresult2640 (depth = 11)
  gc_frame_newslot(opresult2640);
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe2641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call2642 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2641);
// compiled member node returning call2642 (depth = 11)
  gc_frame_newslot(call2642);
// starting to compile member node (depth = 11)
  int callframe2643 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call2644 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2643);
// compiled member node returning call2644 (depth = 11)
  gc_frame_newslot(call2644);
// call case 6: other requests
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = opresult2640;
  params[1] = call2642;
  params[2] = call2644;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call2645 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe2631);
// compiled call node returning call2645 (depth = 10)
    gc_frame_newslot(call2645);
    if2624 = call2645;
  } else {
  }
// compiled if node returning if2624 (depth = 9)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2647 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2649 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2650 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2649);
// compiled member node returning call2650 (depth = 11)
  int op_slot_left_2647 = gc_frame_newslot(call2650);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2651 = callmethod(call2650, "==(1)", 1, partcv, params);
// compiled op node returning opresult2651 (depth = 10)
  Object if2646 = done;
  if (istrue(opresult2651)) {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2652 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2653 == NULL) {
    strlit2653 = alloc_String("}");
    gc_root(strlit2653);
  }
// compiled string node returning strlit2653 (depth = 11)
  gc_frame_newslot(strlit2653);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2653;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2654 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2652);
// compiled call node returning call2654 (depth = 10)
    gc_frame_newslot(call2654);
    if2646 = call2654;
  } else {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2655 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2657 = alloc_Float64(0.1);
// compiled num node returning num2657 (depth = 12)
  int op_slot_right_2656 = gc_frame_newslot(num2657);
// starting to compile member node (depth = 12)
  int callframe2659 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2661 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2660);
// compiled member node returning call2661 (depth = 13)
  Object call2662 = callmethodflags(call2661, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2659);
// compiled member node returning call2662 (depth = 12)
  int op_slot_left_2656 = gc_frame_newslot(call2662);
  params[0] = num2657;
  partcv[0] = 1;
  Object sum2663 = callmethod(call2662, "+(1)", 1, partcv, params);
// compiled op node returning sum2663 (depth = 11)
  gc_frame_newslot(sum2663);
// starting to compile string node (depth = 11)
  if (strlit2664 == NULL) {
    strlit2664 = alloc_String("}");
    gc_root(strlit2664);
  }
// compiled string node returning strlit2664 (depth = 11)
  gc_frame_newslot(strlit2664);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2663;
  params[1] = strlit2664;
  partcv[0] = 2;
  Object call2665 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2655);
// compiled call node returning call2665 (depth = 10)
    gc_frame_newslot(call2665);
    if2646 = call2665;
  }
// compiled if node returning if2646 (depth = 9)
    gc_frame_newslot(if2646);
    if2619 = if2646;
  } else {
  }
// compiled if node returning if2619 (depth = 8)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2666 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2667 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2666);
// compiled call node returning call2667 (depth = 8)
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2668 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2669 == NULL) {
    strlit2669 = alloc_String("an else statement must end with a '}'.");
    gc_root(strlit2669);
  }
// compiled string node returning strlit2669 (depth = 9)
  gc_frame_newslot(strlit2669);
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2671 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2670);
// compiled member node returning call2671 (depth = 9)
  gc_frame_newslot(call2671);
// starting to compile member node (depth = 9)
  int callframe2672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2673 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2672);
// compiled member node returning call2673 (depth = 9)
  gc_frame_newslot(call2673);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2669;
  params[1] = call2671;
  params[2] = call2673;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2674 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2668);
// compiled call node returning call2674 (depth = 8)
    gc_frame_newslot(call2674);
    if2604 = call2674;
  } else {
  }
// compiled if node returning if2604 (depth = 7)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2675 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call2676 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2675);
// compiled member node returning call2676 (depth = 8)
  *var_v = call2676;
  if (call2676 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2678 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2679 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2678);
// compiled call node returning call2679 (depth = 7)
  gc_frame_end(frame);
  return call2679;
}
Object meth_parser_1398_doif(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_opener = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "opener");
  Object *var_closer = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closer");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_cond = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cond");
  Object *var_body = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "body");
  Object *var_elseblock = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "elseblock");
  Object *var_curelse = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "curelse");
  Object *var_v = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "v");
  Object *var_localMin = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "minInd");
// definebindings:
// definebindings:
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_econd = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "econd");
  Object *var_eif = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "eif");
  Object *var_newelse = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "newelse");
  Object *var_ebody = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "ebody");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("if");
    gc_root(strlit1402);
  }
// compiled string node returning strlit1402 (depth = 5)
  int op_slot_right_1401 = gc_frame_newslot(strlit1402);
// starting to compile member node (depth = 5)
  int callframe1404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1405 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1404);
// compiled member node returning call1405 (depth = 5)
  int op_slot_left_1401 = gc_frame_newslot(call1405);
  params[0] = strlit1402;
  partcv[0] = 1;
  Object opresult1406 = callmethod(call1405, "==(1)", 1, partcv, params);
// compiled op node returning opresult1406 (depth = 4)
  int op_slot_right_1400 = gc_frame_newslot(opresult1406);
// starting to compile call node (depth = 4)
  int callframe1408 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1409 == NULL) {
    strlit1409 = alloc_String("identifier");
    gc_root(strlit1409);
  }
// compiled string node returning strlit1409 (depth = 5)
  gc_frame_newslot(strlit1409);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit1409;
  partcv[0] = 1;
  Object call1410 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1410 (depth = 4)
  int op_slot_left_1400 = gc_frame_newslot(call1410);
  params[0] = opresult1406;
  partcv[0] = 1;
  Object opresult1411 = callmethod(call1410, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1411 (depth = 3)
  Object if1399 = done;
  if (istrue(opresult1411)) {
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1412 = gc_frame_new();
// call case 4: self request
  Object call1413 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1412);
// compiled member node returning call1413 (depth = 3)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1416 = alloc_Block(NULL, NULL, "parser", 605);
  gc_frame_newslot(block1416);
// method "_apply"
  block_savedest(block1416);
  Object closure1417 = createclosure(2, "_apply");
  setclosureframe(closure1417, stackframe);
  addtoclosure(closure1417, var_sym);
  addtoclosure(closure1417, selfslot);
  struct UserObject *uo1417 = (struct UserObject*)block1416;
  uo1417->data[0] = (Object)closure1417;
  Method *meth_meth_parser_1417__apply = addmethod2pos(block1416, "_apply", &meth_parser_1417__apply, 0);
  int argcv_meth_parser_1417__apply[] = {0};
  meth_meth_parser_1417__apply->type = alloc_MethodType(1, argcv_meth_parser_1417__apply);
  meth_meth_parser_1417__apply->definitionModule = modulename;
  meth_meth_parser_1417__apply->definitionLine = 3208;
// compiled block node returning block1416 (depth = 6)
  int op_slot_right_1415 = gc_frame_newslot(block1416);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1427 == NULL) {
    strlit1427 = alloc_String("lparen");
    gc_root(strlit1427);
  }
// compiled string node returning strlit1427 (depth = 7)
  int op_slot_right_1426 = gc_frame_newslot(strlit1427);
// starting to compile member node (depth = 7)
  int callframe1429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1430 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1429);
// compiled member node returning call1430 (depth = 7)
  int op_slot_left_1426 = gc_frame_newslot(call1430);
  params[0] = strlit1427;
  partcv[0] = 1;
  Object opresult1431 = callmethod(call1430, "==(1)", 1, partcv, params);
// compiled op node returning opresult1431 (depth = 6)
  int op_slot_left_1415 = gc_frame_newslot(opresult1431);
  params[0] = block1416;
  partcv[0] = 1;
  Object opresult1432 = callmethod(opresult1431, "||(1)", 1, partcv, params);
// compiled op node returning opresult1432 (depth = 5)
  Object if1414 = done;
struct StackFrameObject *iftmpstackframe1414 = stackframe;
  if (istrue(opresult1432)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1414);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1433 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1434 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1433);
// compiled member node returning call1434 (depth = 5)
    gc_frame_newslot(call1434);
    if1414 = call1434;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1414);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("-missing-");
    gc_root(strlit1435);
  }
// compiled string node returning strlit1435 (depth = 5)
    gc_frame_newslot(strlit1435);
    if1414 = strlit1435;
  }
stackframe = iftmpstackframe1414;
// compiled if node returning if1414 (depth = 4)
  *var_opener = if1414;
  if (if1414 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1438 == NULL) {
    strlit1438 = alloc_String("(");
    gc_root(strlit1438);
  }
// compiled string node returning strlit1438 (depth = 6)
  int op_slot_right_1437 = gc_frame_newslot(strlit1438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opener (depth = 6)
  int op_slot_left_1437 = gc_frame_newslot(*var_opener);
  params[0] = strlit1438;
  partcv[0] = 1;
  Object opresult1440 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 5)
  Object if1436 = done;
struct StackFrameObject *iftmpstackframe1436 = stackframe;
  if (istrue(opresult1440)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1436);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit1441 == NULL) {
    strlit1441 = alloc_String(")");
    gc_root(strlit1441);
  }
// compiled string node returning strlit1441 (depth = 5)
    gc_frame_newslot(strlit1441);
    if1436 = strlit1441;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1436);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// definebindings:
// definebindings:
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1444 == NULL) {
    strlit1444 = alloc_String("{");
    gc_root(strlit1444);
  }
// compiled string node returning strlit1444 (depth = 7)
  int op_slot_right_1443 = gc_frame_newslot(strlit1444);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_opener (depth = 7)
  int op_slot_left_1443 = gc_frame_newslot(*var_opener);
  params[0] = strlit1444;
  partcv[0] = 1;
  Object opresult1446 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 6)
  Object if1442 = done;
  if (istrue(opresult1446)) {
// starting to compile string node (depth = 6)
  if (strlit1447 == NULL) {
    strlit1447 = alloc_String("}");
    gc_root(strlit1447);
  }
// compiled string node returning strlit1447 (depth = 6)
    gc_frame_newslot(strlit1447);
    if1442 = strlit1447;
  } else {
// starting to compile string node (depth = 6)
  if (strlit1448 == NULL) {
    strlit1448 = alloc_String("-nothing-");
    gc_root(strlit1448);
  }
// compiled string node returning strlit1448 (depth = 6)
    gc_frame_newslot(strlit1448);
    if1442 = strlit1448;
  }
// compiled if node returning if1442 (depth = 5)
    gc_frame_newslot(if1442);
    if1436 = if1442;
  }
stackframe = iftmpstackframe1436;
// compiled if node returning if1436 (depth = 4)
  *var_closer = if1436;
  if (if1436 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1451 == NULL) {
    strlit1451 = alloc_String("-missing-");
    gc_root(strlit1451);
  }
// compiled string node returning strlit1451 (depth = 5)
  int op_slot_right_1450 = gc_frame_newslot(strlit1451);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opener (depth = 5)
  int op_slot_left_1450 = gc_frame_newslot(*var_opener);
  params[0] = strlit1451;
  partcv[0] = 1;
  Object opresult1453 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1453 (depth = 4)
  Object if1449 = done;
  if (istrue(opresult1453)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1454 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1456 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1455);
// compiled member node returning call1456 (depth = 6)
  Object call1457 = callmethodflags(call1456, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1454);
// compiled member node returning call1457 (depth = 5)
  *var_suggestion = call1457;
  if (call1457 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1458 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1459 = alloc_Block(NULL, NULL, "parser", 612);
  gc_frame_newslot(block1459);
// method "_apply(_)"
  block_savedest(block1459);
  Object closure1460 = createclosure(2, "_apply(1)");
  setclosureframe(closure1460, stackframe);
  addtoclosure(closure1460, var_btok);
  addtoclosure(closure1460, selfslot);
  struct UserObject *uo1460 = (struct UserObject*)block1459;
  uo1460->data[0] = (Object)closure1460;
  Method *meth_meth_parser_1460__apply_40_1_41_ = addmethod2pos(block1459, "_apply(1)", &meth_parser_1460__apply_40_1_41_, 0);
  int argcv_meth_parser_1460__apply_40_1_41_[] = {1};
  meth_meth_parser_1460__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1460__apply_40_1_41_);
  meth_meth_parser_1460__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1460__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block1459 (depth = 6)
  gc_frame_newslot(block1459);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1459;
  partcv[0] = 1;
  Object call1514 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1458);
// compiled call node returning call1514 (depth = 5)
  *var_nextTok = call1514;
  if (call1514 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1516 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1518 = alloc_Boolean(0);
// compiled identifier node returning bool1518 (depth = 6)
  int op_slot_left_1516 = gc_frame_newslot(bool1518);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1519 = callmethod(bool1518, "==(1)", 1, partcv, params);
// compiled op node returning opresult1519 (depth = 5)
  Object if1515 = done;
  if (istrue(opresult1519)) {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1520 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1521 == NULL) {
    strlit1521 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then {");
    gc_root(strlit1521);
  }
// compiled string node returning strlit1521 (depth = 6)
  gc_frame_newslot(strlit1521);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1521;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1522 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1520);
// compiled call node returning call1522 (depth = 5)
    gc_frame_newslot(call1522);
    if1515 = call1522;
  } else {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1525 == NULL) {
    strlit1525 = alloc_String("rparen");
    gc_root(strlit1525);
  }
// compiled string node returning strlit1525 (depth = 7)
  int op_slot_right_1524 = gc_frame_newslot(strlit1525);
// starting to compile member node (depth = 7)
  int callframe1527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call1528 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1527);
// compiled member node returning call1528 (depth = 7)
  int op_slot_left_1524 = gc_frame_newslot(call1528);
  params[0] = strlit1525;
  partcv[0] = 1;
  Object opresult1529 = callmethod(call1528, "==(1)", 1, partcv, params);
// compiled op node returning opresult1529 (depth = 6)
  Object if1523 = done;
  if (istrue(opresult1529)) {
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1531 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1531 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1533 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1533 (depth = 7)
  Object if1530 = done;
  if (istrue(opresult1533)) {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1534 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb""");
    gc_root(strlit1535);
  }
// compiled string node returning strlit1535 (depth = 8)
  gc_frame_newslot(strlit1535);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1535;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1536 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1534);
// compiled call node returning call1536 (depth = 7)
    gc_frame_newslot(call1536);
    if1530 = call1536;
  } else {
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1537 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1538 == NULL) {
    strlit1538 = alloc_String("(");
    gc_root(strlit1538);
  }
// compiled string node returning strlit1538 (depth = 8)
  gc_frame_newslot(strlit1538);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1538;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1539 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1537);
// compiled call node returning call1539 (depth = 7)
    gc_frame_newslot(call1539);
    if1530 = call1539;
  }
// compiled if node returning if1530 (depth = 6)
    gc_frame_newslot(if1530);
    if1523 = if1530;
  } else {
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1542 == NULL) {
    strlit1542 = alloc_String("lbrace");
    gc_root(strlit1542);
  }
// compiled string node returning strlit1542 (depth = 8)
  int op_slot_right_1541 = gc_frame_newslot(strlit1542);
// starting to compile member node (depth = 8)
  int callframe1544 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call1545 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1544);
// compiled member node returning call1545 (depth = 8)
  int op_slot_left_1541 = gc_frame_newslot(call1545);
  params[0] = strlit1542;
  partcv[0] = 1;
  Object opresult1546 = callmethod(call1545, "==(1)", 1, partcv, params);
// compiled op node returning opresult1546 (depth = 7)
  Object if1540 = done;
  if (istrue(opresult1546)) {
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1548 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1548 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1550 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1550 (depth = 8)
  Object if1547 = done;
  if (istrue(opresult1550)) {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1551 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1552 == NULL) {
    strlit1552 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then");
    gc_root(strlit1552);
  }
// compiled string node returning strlit1552 (depth = 9)
  gc_frame_newslot(strlit1552);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1552;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1553 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1551);
// compiled call node returning call1553 (depth = 8)
    gc_frame_newslot(call1553);
    if1547 = call1553;
  } else {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1554 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1555 == NULL) {
    strlit1555 = alloc_String("(");
    gc_root(strlit1555);
  }
// compiled string node returning strlit1555 (depth = 9)
  gc_frame_newslot(strlit1555);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1555;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1556 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1554);
// compiled call node returning call1556 (depth = 8)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1557 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1558 == NULL) {
    strlit1558 = alloc_String(") then");
    gc_root(strlit1558);
  }
// compiled string node returning strlit1558 (depth = 9)
  gc_frame_newslot(strlit1558);
// starting to compile member node (depth = 9)
  int callframe1559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call1560 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1559);
// compiled member node returning call1560 (depth = 9)
  gc_frame_newslot(call1560);
// starting to compile identifier node (depth = 9)
  Object bool1561 = alloc_Boolean(1);
// compiled identifier node returning bool1561 (depth = 9)
  gc_frame_newslot(bool1561);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1558;
  params[1] = call1560;
  params[2] = bool1561;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1562 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1557);
// compiled call node returning call1562 (depth = 8)
    gc_frame_newslot(call1562);
    if1547 = call1562;
  }
// compiled if node returning if1547 (depth = 7)
    gc_frame_newslot(if1547);
    if1540 = if1547;
  } else {
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1565 == NULL) {
    strlit1565 = alloc_String("identifier");
    gc_root(strlit1565);
  }
// compiled string node returning strlit1565 (depth = 9)
  int op_slot_right_1564 = gc_frame_newslot(strlit1565);
// starting to compile member node (depth = 9)
  int callframe1567 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call1568 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1567);
// compiled member node returning call1568 (depth = 9)
  int op_slot_left_1564 = gc_frame_newslot(call1568);
  params[0] = strlit1565;
  partcv[0] = 1;
  Object opresult1569 = callmethod(call1568, "==(1)", 1, partcv, params);
// compiled op node returning opresult1569 (depth = 8)
  Object if1563 = done;
  if (istrue(opresult1569)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1571 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1571 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1573 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1573 (depth = 9)
  Object if1570 = done;
  if (istrue(opresult1573)) {
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1574 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1575 == NULL) {
    strlit1575 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb"") ");
    gc_root(strlit1575);
  }
// compiled string node returning strlit1575 (depth = 10)
  gc_frame_newslot(strlit1575);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1575;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1576 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1574);
// compiled call node returning call1576 (depth = 9)
    gc_frame_newslot(call1576);
    if1570 = call1576;
  } else {
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1577 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1578 == NULL) {
    strlit1578 = alloc_String("(");
    gc_root(strlit1578);
  }
// compiled string node returning strlit1578 (depth = 10)
  gc_frame_newslot(strlit1578);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1578;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1579 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1577);
// compiled call node returning call1579 (depth = 9)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1580 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1581 == NULL) {
    strlit1581 = alloc_String(")");
    gc_root(strlit1581);
  }
// compiled string node returning strlit1581 (depth = 10)
  gc_frame_newslot(strlit1581);
// starting to compile member node (depth = 10)
  int callframe1582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call1583 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1582);
// compiled member node returning call1583 (depth = 10)
  gc_frame_newslot(call1583);
// starting to compile identifier node (depth = 10)
  Object bool1584 = alloc_Boolean(1);
// compiled identifier node returning bool1584 (depth = 10)
  gc_frame_newslot(bool1584);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1581;
  params[1] = call1583;
  params[2] = bool1584;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1585 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1580);
// compiled call node returning call1585 (depth = 9)
    gc_frame_newslot(call1585);
    if1570 = call1585;
  }
// compiled if node returning if1570 (depth = 8)
    gc_frame_newslot(if1570);
    if1563 = if1570;
  } else {
  }
// compiled if node returning if1563 (depth = 7)
    gc_frame_newslot(if1563);
    if1540 = if1563;
  }
// compiled if node returning if1540 (depth = 6)
    gc_frame_newslot(if1540);
    if1523 = if1540;
  }
// compiled if node returning if1523 (depth = 5)
    gc_frame_newslot(if1523);
    if1515 = if1523;
  }
// compiled if node returning if1515 (depth = 4)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1586 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1588 == NULL) {
    strlit1588 = alloc_String("in parentheses or braces after the 'if'.");
    gc_root(strlit1588);
  }
// compiled string node returning strlit1588 (depth = 6)
  int op_slot_right_1587 = gc_frame_newslot(strlit1588);
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1590 == NULL) {
    strlit1590 = alloc_String("an if statement must have a condition ");
    gc_root(strlit1590);
  }
// compiled string node returning strlit1590 (depth = 6)
  int op_slot_left_1587 = gc_frame_newslot(strlit1590);
  params[0] = strlit1588;
  partcv[0] = 1;
  Object opresult1591 = callmethod(strlit1590, "++(1)", 1, partcv, params);
// compiled op node returning opresult1591 (depth = 5)
  gc_frame_newslot(opresult1591);
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1592 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1593 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1592);
// compiled member node returning call1593 (depth = 5)
  gc_frame_newslot(call1593);
// starting to compile member node (depth = 5)
  int callframe1594 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1595 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1594);
// compiled member node returning call1595 (depth = 5)
  gc_frame_newslot(call1595);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1591;
  params[1] = call1593;
  params[2] = call1595;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1596 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1586);
// compiled call node returning call1596 (depth = 4)
    gc_frame_newslot(call1596);
    if1449 = call1596;
  } else {
  }
// compiled if node returning if1449 (depth = 3)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1597 = gc_frame_new();
// call case 4: self request
  Object call1598 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1597);
// compiled member node returning call1598 (depth = 3)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1600 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1601 = alloc_Block(NULL, NULL, "parser", 643);
  gc_frame_newslot(block1601);
// method "_apply"
  block_savedest(block1601);
  Object closure1602 = createclosure(2, "_apply");
  setclosureframe(closure1602, stackframe);
  addtoclosure(closure1602, var_blocksOK);
  addtoclosure(closure1602, selfslot);
  struct UserObject *uo1602 = (struct UserObject*)block1601;
  uo1602->data[0] = (Object)closure1602;
  Method *meth_meth_parser_1602__apply = addmethod2pos(block1601, "_apply", &meth_parser_1602__apply, 0);
  int argcv_meth_parser_1602__apply[] = {0};
  meth_meth_parser_1602__apply->type = alloc_MethodType(1, argcv_meth_parser_1602__apply);
  meth_meth_parser_1602__apply->definitionModule = modulename;
  meth_meth_parser_1602__apply->definitionLine = 3208;
// compiled block node returning block1601 (depth = 5)
  gc_frame_newslot(block1601);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block1601;
  partcv[0] = 1;
  Object call1606 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1600);
// compiled call node returning call1606 (depth = 4)
  Object if1599 = done;
  if (istrue(call1606)) {
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1607 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1608 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1609 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1608);
// compiled member node returning call1609 (depth = 6)
  Object call1610 = callmethodflags(call1609, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1607);
// compiled member node returning call1610 (depth = 5)
  *var_suggestion = call1610;
  if (call1610 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1611 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1612 = alloc_Block(NULL, NULL, "parser", 646);
  gc_frame_newslot(block1612);
// method "_apply(_)"
  block_savedest(block1612);
  Object closure1613 = createclosure(2, "_apply(1)");
  setclosureframe(closure1613, stackframe);
  addtoclosure(closure1613, var_lastToken);
  addtoclosure(closure1613, selfslot);
  struct UserObject *uo1613 = (struct UserObject*)block1612;
  uo1613->data[0] = (Object)closure1613;
  Method *meth_meth_parser_1613__apply_40_1_41_ = addmethod2pos(block1612, "_apply(1)", &meth_parser_1613__apply_40_1_41_, 0);
  int argcv_meth_parser_1613__apply_40_1_41_[] = {1};
  meth_meth_parser_1613__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1613__apply_40_1_41_);
  meth_meth_parser_1613__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1613__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block1612 (depth = 6)
  gc_frame_newslot(block1612);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1612;
  partcv[0] = 1;
  Object call1631 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1611);
// compiled call node returning call1631 (depth = 5)
  *var_nextTok = call1631;
  if (call1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1633 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1635 = alloc_Boolean(0);
// compiled identifier node returning bool1635 (depth = 6)
  int op_slot_left_1633 = gc_frame_newslot(bool1635);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1636 = callmethod(bool1635, "==(1)", 1, partcv, params);
// compiled op node returning opresult1636 (depth = 5)
  Object if1632 = done;
  if (istrue(opresult1636)) {
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1637 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array1638 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1639 == NULL) {
    strlit1639 = alloc_String("rparen");
    gc_root(strlit1639);
  }
// compiled string node returning strlit1639 (depth = 8)
  params[0] = strlit1639;
  partcv[0] = 1;
  callmethodflags(array1638, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1638 (depth = 7)
  gc_frame_newslot(array1638);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array1638;
  partcv[0] = 1;
  Object call1640 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1637);
// compiled call node returning call1640 (depth = 6)
  *var_nextTok = call1640;
  if (call1640 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1643 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1643 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1645 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1645 (depth = 6)
  Object if1642 = done;
  if (istrue(opresult1645)) {
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1646 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1647 == NULL) {
    strlit1647 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1647);
  }
// compiled string node returning strlit1647 (depth = 7)
  gc_frame_newslot(strlit1647);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1647;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1648 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1646);
// compiled call node returning call1648 (depth = 6)
    gc_frame_newslot(call1648);
    if1642 = call1648;
  } else {
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1649 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe1650 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call1651 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1650);
// compiled member node returning call1651 (depth = 7)
  gc_frame_newslot(call1651);
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1652 = alloc_Boolean(1);
// compiled identifier node returning bool1652 (depth = 7)
  gc_frame_newslot(bool1652);
// starting to compile identifier node (depth = 7)
  Object bool1653 = alloc_Boolean(0);
// compiled identifier node returning bool1653 (depth = 7)
  gc_frame_newslot(bool1653);
// starting to compile string node (depth = 7)
  if (strlit1654 == NULL) {
    strlit1654 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1654);
  }
// compiled string node returning strlit1654 (depth = 7)
  gc_frame_newslot(strlit1654);
// call case 6: other requests
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1651;
  params[2] = bool1652;
  params[3] = bool1653;
  params[4] = strlit1654;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1655 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1649);
// compiled call node returning call1655 (depth = 6)
    gc_frame_newslot(call1655);
    if1642 = call1655;
  }
// compiled if node returning if1642 (depth = 5)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1656 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1658 == NULL) {
    strlit1658 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1658);
  }
// compiled string node returning strlit1658 (depth = 7)
  int op_slot_right_1657 = gc_frame_newslot(strlit1658);
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1660 == NULL) {
    strlit1660 = alloc_String("an if statement must have a ");
    gc_root(strlit1660);
  }
// compiled string node returning strlit1660 (depth = 7)
  int op_slot_left_1657 = gc_frame_newslot(strlit1660);
  params[0] = strlit1658;
  partcv[0] = 1;
  Object opresult1661 = callmethod(strlit1660, "++(1)", 1, partcv, params);
// compiled op node returning opresult1661 (depth = 6)
  gc_frame_newslot(opresult1661);
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1662 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1663 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1662);
// compiled member node returning call1663 (depth = 6)
  gc_frame_newslot(call1663);
// starting to compile member node (depth = 6)
  int callframe1664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1665 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1664);
// compiled member node returning call1665 (depth = 6)
  gc_frame_newslot(call1665);
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1661;
  params[1] = call1663;
  params[2] = call1665;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1666 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1656);
// compiled call node returning call1666 (depth = 5)
    gc_frame_newslot(call1666);
    if1632 = call1666;
  } else {
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1668 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1668 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1670 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1670 (depth = 6)
  Object if1667 = done;
  if (istrue(opresult1670)) {
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1671 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1672 == NULL) {
    strlit1672 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1672);
  }
// compiled string node returning strlit1672 (depth = 7)
  gc_frame_newslot(strlit1672);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1672;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1673 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1671);
// compiled call node returning call1673 (depth = 6)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1674 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1676 == NULL) {
    strlit1676 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1676);
  }
// compiled string node returning strlit1676 (depth = 8)
  int op_slot_right_1675 = gc_frame_newslot(strlit1676);
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1678 == NULL) {
    strlit1678 = alloc_String("an if statement must have a ");
    gc_root(strlit1678);
  }
// compiled string node returning strlit1678 (depth = 8)
  int op_slot_left_1675 = gc_frame_newslot(strlit1678);
  params[0] = strlit1676;
  partcv[0] = 1;
  Object opresult1679 = callmethod(strlit1678, "++(1)", 1, partcv, params);
// compiled op node returning opresult1679 (depth = 7)
  gc_frame_newslot(opresult1679);
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1681 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1680);
// compiled member node returning call1681 (depth = 7)
  gc_frame_newslot(call1681);
// starting to compile member node (depth = 7)
  int callframe1682 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1683 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1682);
// compiled member node returning call1683 (depth = 7)
  gc_frame_newslot(call1683);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1679;
  params[1] = call1681;
  params[2] = call1683;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1684 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1674);
// compiled call node returning call1684 (depth = 6)
    gc_frame_newslot(call1684);
    if1667 = call1684;
  } else {
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1685 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe1686 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call1687 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1686);
// compiled member node returning call1687 (depth = 7)
  gc_frame_newslot(call1687);
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1688 = alloc_Boolean(0);
// compiled identifier node returning bool1688 (depth = 7)
  gc_frame_newslot(bool1688);
// starting to compile identifier node (depth = 7)
  Object bool1689 = alloc_Boolean(1);
// compiled identifier node returning bool1689 (depth = 7)
  gc_frame_newslot(bool1689);
// starting to compile string node (depth = 7)
  if (strlit1690 == NULL) {
    strlit1690 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1690);
  }
// compiled string node returning strlit1690 (depth = 7)
  gc_frame_newslot(strlit1690);
// call case 6: other requests
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1687;
  params[2] = bool1688;
  params[3] = bool1689;
  params[4] = strlit1690;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1691 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1685);
// compiled call node returning call1691 (depth = 6)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1692 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1694 == NULL) {
    strlit1694 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1694);
  }
// compiled string node returning strlit1694 (depth = 8)
  int op_slot_right_1693 = gc_frame_newslot(strlit1694);
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1696 == NULL) {
    strlit1696 = alloc_String("an if statement must have a ");
    gc_root(strlit1696);
  }
// compiled string node returning strlit1696 (depth = 8)
  int op_slot_left_1693 = gc_frame_newslot(strlit1696);
  params[0] = strlit1694;
  partcv[0] = 1;
  Object opresult1697 = callmethod(strlit1696, "++(1)", 1, partcv, params);
// compiled op node returning opresult1697 (depth = 7)
  gc_frame_newslot(opresult1697);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1698 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1699 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1698);
// compiled member node returning call1699 (depth = 7)
  gc_frame_newslot(call1699);
// starting to compile member node (depth = 7)
  int callframe1700 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1701 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1700);
// compiled member node returning call1701 (depth = 7)
  gc_frame_newslot(call1701);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1703 = alloc_Float64(1);
// compiled num node returning num1703 (depth = 8)
  int op_slot_right_1702 = gc_frame_newslot(num1703);
// starting to compile member node (depth = 8)
  int callframe1705 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call1706 = callmethodflags(*var_nextTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1705);
// compiled member node returning call1706 (depth = 8)
  int op_slot_left_1702 = gc_frame_newslot(call1706);
  params[0] = num1703;
  partcv[0] = 1;
  Object diff1707 = callmethod(call1706, "-(1)", 1, partcv, params);
// compiled op node returning diff1707 (depth = 7)
  gc_frame_newslot(diff1707);
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1697;
  params[1] = call1699;
  params[2] = call1701;
  params[3] = diff1707;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1708 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1692);
// compiled call node returning call1708 (depth = 6)
    gc_frame_newslot(call1708);
    if1667 = call1708;
  }
// compiled if node returning if1667 (depth = 5)
    gc_frame_newslot(if1667);
    if1632 = if1667;
  }
// compiled if node returning if1632 (depth = 4)
    gc_frame_newslot(if1632);
    if1599 = if1632;
  } else {
  }
// compiled if node returning if1599 (depth = 3)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_closer (depth = 5)
  int op_slot_right_1710 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 5)
  int callframe1712 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1713 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1712);
// compiled member node returning call1713 (depth = 5)
  int op_slot_left_1710 = gc_frame_newslot(call1713);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult1714 = callmethod(call1713, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1714 (depth = 4)
  Object if1709 = done;
  if (istrue(opresult1714)) {
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1715 = gc_frame_new();
// call case 4: self request
  Object call1716 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1715);
// compiled member node returning call1716 (depth = 4)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1717 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1719 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1718);
// compiled member node returning call1719 (depth = 6)
  Object call1720 = callmethodflags(call1719, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1717);
// compiled member node returning call1720 (depth = 5)
  *var_suggestion = call1720;
  if (call1720 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1721 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1722 == NULL) {
    strlit1722 = alloc_String(")");
    gc_root(strlit1722);
  }
// compiled string node returning strlit1722 (depth = 5)
  gc_frame_newslot(strlit1722);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1722;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1723 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1721);
// compiled call node returning call1723 (depth = 4)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1724 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1727 == NULL) {
    strlit1727 = alloc_String("'.");
    gc_root(strlit1727);
  }
// compiled string node returning strlit1727 (depth = 7)
  int op_slot_right_1726 = gc_frame_newslot(strlit1727);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_1729 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1732 == NULL) {
    strlit1732 = alloc_String("' must end with a '");
    gc_root(strlit1732);
  }
// compiled string node returning strlit1732 (depth = 9)
  int op_slot_right_1731 = gc_frame_newslot(strlit1732);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_right_1734 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 10)
  if (strlit1736 == NULL) {
    strlit1736 = alloc_String("'");
    gc_root(strlit1736);
  }
// compiled string node returning strlit1736 (depth = 10)
  int op_slot_left_1734 = gc_frame_newslot(strlit1736);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult1737 = callmethod(strlit1736, "++(1)", 1, partcv, params);
// compiled op node returning opresult1737 (depth = 9)
  int op_slot_left_1731 = gc_frame_newslot(opresult1737);
  params[0] = strlit1732;
  partcv[0] = 1;
  Object opresult1738 = callmethod(opresult1737, "++(1)", 1, partcv, params);
// compiled op node returning opresult1738 (depth = 8)
  int op_slot_left_1729 = gc_frame_newslot(opresult1738);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult1739 = callmethod(opresult1738, "++(1)", 1, partcv, params);
// compiled op node returning opresult1739 (depth = 7)
  int op_slot_left_1726 = gc_frame_newslot(opresult1739);
  params[0] = strlit1727;
  partcv[0] = 1;
  Object opresult1740 = callmethod(opresult1739, "++(1)", 1, partcv, params);
// compiled op node returning opresult1740 (depth = 6)
  int op_slot_right_1725 = gc_frame_newslot(opresult1740);
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1742 == NULL) {
    strlit1742 = alloc_String("an expression beginning with a ");
    gc_root(strlit1742);
  }
// compiled string node returning strlit1742 (depth = 6)
  int op_slot_left_1725 = gc_frame_newslot(strlit1742);
  params[0] = opresult1740;
  partcv[0] = 1;
  Object opresult1743 = callmethod(strlit1742, "++(1)", 1, partcv, params);
// compiled op node returning opresult1743 (depth = 5)
  gc_frame_newslot(opresult1743);
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1745 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1744);
// compiled member node returning call1745 (depth = 5)
  gc_frame_newslot(call1745);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1748 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1747);
// compiled member node returning call1748 (depth = 6)
  int op_slot_right_1746 = gc_frame_newslot(call1748);
// starting to compile member node (depth = 6)
  int callframe1750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1751 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1750);
// compiled member node returning call1751 (depth = 6)
  int op_slot_left_1746 = gc_frame_newslot(call1751);
  params[0] = call1748;
  partcv[0] = 1;
  Object sum1752 = callmethod(call1751, "+(1)", 1, partcv, params);
// compiled op node returning sum1752 (depth = 5)
  gc_frame_newslot(sum1752);
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1743;
  params[1] = call1745;
  params[2] = sum1752;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1753 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1724);
// compiled call node returning call1753 (depth = 4)
    gc_frame_newslot(call1753);
    if1709 = call1753;
  } else {
  }
// compiled if node returning if1709 (depth = 3)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1754 = gc_frame_new();
// call case 4: self request
  Object call1755 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1754);
// compiled member node returning call1755 (depth = 3)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1756 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call1757 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1756);
// compiled member node returning call1757 (depth = 4)
  *var_cond = call1757;
  if (call1757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1758 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1758 (depth = 4)
  *var_body = array1758;
  if (array1758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1759 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1759 (depth = 4)
  *var_elseblock = array1759;
  if (array1759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1761 = alloc_Float64(2);
// compiled num node returning num1761 (depth = 5)
  int op_slot_right_1760 = gc_frame_newslot(num1761);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1760 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1761;
  partcv[0] = 1;
  Object sum1763 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum1763 (depth = 4)
  *var_minInd = sum1763;
  if (sum1763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1767 == NULL) {
    strlit1767 = alloc_String("then");
    gc_root(strlit1767);
  }
// compiled string node returning strlit1767 (depth = 6)
  int op_slot_right_1766 = gc_frame_newslot(strlit1767);
// starting to compile member node (depth = 6)
  int callframe1769 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1770 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1769);
// compiled member node returning call1770 (depth = 6)
  int op_slot_left_1766 = gc_frame_newslot(call1770);
  params[0] = strlit1767;
  partcv[0] = 1;
  Object opresult1771 = callmethod(call1770, "==(1)", 1, partcv, params);
// compiled op node returning opresult1771 (depth = 5)
  int op_slot_right_1765 = gc_frame_newslot(opresult1771);
// starting to compile call node (depth = 5)
  int callframe1773 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1774 == NULL) {
    strlit1774 = alloc_String("identifier");
    gc_root(strlit1774);
  }
// compiled string node returning strlit1774 (depth = 6)
  gc_frame_newslot(strlit1774);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1774;
  partcv[0] = 1;
  Object call1775 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1773);
// compiled call node returning call1775 (depth = 5)
  int op_slot_left_1765 = gc_frame_newslot(call1775);
  params[0] = opresult1771;
  partcv[0] = 1;
  Object opresult1776 = callmethod(call1775, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1776 (depth = 4)
  Object if1764 = done;
  if (istrue(opresult1776)) {
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1777 = gc_frame_new();
// call case 4: self request
  Object call1778 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1777);
// compiled member node returning call1778 (depth = 4)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1781 == NULL) {
    strlit1781 = alloc_String("lbrace");
    gc_root(strlit1781);
  }
// compiled string node returning strlit1781 (depth = 6)
  int op_slot_right_1780 = gc_frame_newslot(strlit1781);
// starting to compile member node (depth = 6)
  int callframe1783 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1784 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1783);
// compiled member node returning call1784 (depth = 6)
  int op_slot_left_1780 = gc_frame_newslot(call1784);
  params[0] = strlit1781;
  partcv[0] = 1;
  Object opresult1785 = callmethod(call1784, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1785 (depth = 5)
  Object if1779 = done;
  if (istrue(opresult1785)) {
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1786 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1787 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call1788 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1787);
// compiled member node returning call1788 (depth = 7)
  Object call1789 = callmethodflags(call1788, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1786);
// compiled member node returning call1789 (depth = 6)
  *var_suggestion = call1789;
  if (call1789 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1790 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool1791 = alloc_Boolean(1);
// compiled identifier node returning bool1791 (depth = 7)
  gc_frame_newslot(bool1791);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool1791;
  partcv[0] = 2;
  Object call1792 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compiled call node returning call1792 (depth = 6)
  *var_closingBrace = call1792;
  if (call1792 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1794 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call1796 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe1795);
// compiled member node returning call1796 (depth = 7)
  Object call1797 = callmethodflags(call1796, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1794);
// compiled member node returning call1797 (depth = 6)
  Object if1793 = done;
  if (istrue(call1797)) {
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_1799 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe1801 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call1802 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe1801);
// compiled member node returning call1802 (depth = 8)
  int op_slot_left_1799 = gc_frame_newslot(call1802);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1803 = callmethod(call1802, "==(1)", 1, partcv, params);
// compiled op node returning opresult1803 (depth = 7)
  Object if1798 = done;
  if (istrue(opresult1803)) {
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1804 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1805 = alloc_Boolean(0);
// compiled identifier node returning bool1805 (depth = 8)
  gc_frame_newslot(bool1805);
// starting to compile identifier node (depth = 8)
  Object bool1806 = alloc_Boolean(1);
// compiled identifier node returning bool1806 (depth = 8)
  gc_frame_newslot(bool1806);
// starting to compile string node (depth = 8)
  if (strlit1807 == NULL) {
    strlit1807 = alloc_String("then {}");
    gc_root(strlit1807);
  }
// compiled string node returning strlit1807 (depth = 8)
  gc_frame_newslot(strlit1807);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1805;
  params[2] = bool1806;
  params[3] = strlit1807;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1808 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1804);
// compiled call node returning call1808 (depth = 7)
    gc_frame_newslot(call1808);
    if1798 = call1808;
  } else {
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1809 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1811 = alloc_Float64(0.1);
// compiled num node returning num1811 (depth = 9)
  int op_slot_right_1810 = gc_frame_newslot(num1811);
// starting to compile member node (depth = 9)
  int callframe1813 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1814 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call1815 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe1814);
// compiled member node returning call1815 (depth = 10)
  Object call1816 = callmethodflags(call1815, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1813);
// compiled member node returning call1816 (depth = 9)
  int op_slot_left_1810 = gc_frame_newslot(call1816);
  params[0] = num1811;
  partcv[0] = 1;
  Object sum1817 = callmethod(call1816, "+(1)", 1, partcv, params);
// compiled op node returning sum1817 (depth = 8)
  gc_frame_newslot(sum1817);
// starting to compile string node (depth = 8)
  if (strlit1818 == NULL) {
    strlit1818 = alloc_String("}");
    gc_root(strlit1818);
  }
// compiled string node returning strlit1818 (depth = 8)
  gc_frame_newslot(strlit1818);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1817;
  params[1] = strlit1818;
  partcv[0] = 2;
  Object call1819 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1809);
// compiled call node returning call1819 (depth = 7)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1820 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1821 = alloc_Boolean(0);
// compiled identifier node returning bool1821 (depth = 8)
  gc_frame_newslot(bool1821);
// starting to compile identifier node (depth = 8)
  Object bool1822 = alloc_Boolean(1);
// compiled identifier node returning bool1822 (depth = 8)
  gc_frame_newslot(bool1822);
// starting to compile string node (depth = 8)
  if (strlit1823 == NULL) {
    strlit1823 = alloc_String("then {");
    gc_root(strlit1823);
  }
// compiled string node returning strlit1823 (depth = 8)
  gc_frame_newslot(strlit1823);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1821;
  params[2] = bool1822;
  params[3] = strlit1823;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1824 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1820);
// compiled call node returning call1824 (depth = 7)
    gc_frame_newslot(call1824);
    if1798 = call1824;
  }
// compiled if node returning if1798 (depth = 6)
    gc_frame_newslot(if1798);
    if1793 = if1798;
  } else {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1825 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool1826 = alloc_Boolean(0);
// compiled identifier node returning bool1826 (depth = 7)
  gc_frame_newslot(bool1826);
// starting to compile identifier node (depth = 7)
  Object bool1827 = alloc_Boolean(1);
// compiled identifier node returning bool1827 (depth = 7)
  gc_frame_newslot(bool1827);
// starting to compile string node (depth = 7)
  if (strlit1828 == NULL) {
    strlit1828 = alloc_String("then {");
    gc_root(strlit1828);
  }
// compiled string node returning strlit1828 (depth = 7)
  gc_frame_newslot(strlit1828);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool1826;
  params[2] = bool1827;
  params[3] = strlit1828;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1829 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1825);
// compiled call node returning call1829 (depth = 6)
    gc_frame_newslot(call1829);
    if1793 = call1829;
  }
// compiled if node returning if1793 (depth = 5)
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1830 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1831 == NULL) {
    strlit1831 = alloc_String("an if statement must have a '{' after the 'then'.");
    gc_root(strlit1831);
  }
// compiled string node returning strlit1831 (depth = 6)
  gc_frame_newslot(strlit1831);
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1832 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1833 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1832);
// compiled member node returning call1833 (depth = 6)
  gc_frame_newslot(call1833);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1835 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call1836 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1835);
// compiled member node returning call1836 (depth = 7)
  int op_slot_right_1834 = gc_frame_newslot(call1836);
// starting to compile member node (depth = 7)
  int callframe1838 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call1839 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1838);
// compiled member node returning call1839 (depth = 7)
  int op_slot_left_1834 = gc_frame_newslot(call1839);
  params[0] = call1836;
  partcv[0] = 1;
  Object sum1840 = callmethod(call1839, "+(1)", 1, partcv, params);
// compiled op node returning sum1840 (depth = 6)
  gc_frame_newslot(sum1840);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1831;
  params[1] = call1833;
  params[2] = sum1840;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1841 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1830);
// compiled call node returning call1841 (depth = 5)
    gc_frame_newslot(call1841);
    if1779 = call1841;
  } else {
  }
// compiled if node returning if1779 (depth = 4)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1842 = gc_frame_new();
// call case 4: self request
  Object call1843 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1842);
// compiled member node returning call1843 (depth = 4)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1846 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1847 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1846);
// compiled member node returning call1847 (depth = 6)
  int op_slot_right_1845 = gc_frame_newslot(call1847);
// starting to compile member node (depth = 6)
  int callframe1849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1850 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1849);
// compiled member node returning call1850 (depth = 6)
  int op_slot_left_1845 = gc_frame_newslot(call1850);
  params[0] = call1847;
  partcv[0] = 1;
  Object opresult1851 = callmethod(call1850, "==(1)", 1, partcv, params);
// compiled op node returning opresult1851 (depth = 5)
  Object if1844 = done;
  if (istrue(opresult1851)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1853 = alloc_Float64(1);
// compiled num node returning num1853 (depth = 7)
  int op_slot_right_1852 = gc_frame_newslot(num1853);
// starting to compile member node (depth = 7)
  int callframe1855 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1856 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1855);
// compiled member node returning call1856 (depth = 7)
  int op_slot_left_1852 = gc_frame_newslot(call1856);
  params[0] = num1853;
  partcv[0] = 1;
  Object diff1857 = callmethod(call1856, "-(1)", 1, partcv, params);
// compiled op node returning diff1857 (depth = 6)
  *var_minIndentLevel = diff1857;
  if (diff1857 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1844 = done;
  } else {
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1844 = done;
  }
// compiled if node returning if1844 (depth = 4)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1860 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1861 = alloc_Block(NULL, NULL, "parser", 725);
  gc_frame_newslot(block1861);
// method "_apply"
  block_savedest(block1861);
  Object closure1862 = createclosure(1, "_apply");
  setclosureframe(closure1862, stackframe);
  addtoclosure(closure1862, selfslot);
  struct UserObject *uo1862 = (struct UserObject*)block1861;
  uo1862->data[0] = (Object)closure1862;
  Method *meth_meth_parser_1862__apply = addmethod2pos(block1861, "_apply", &meth_parser_1862__apply, 0);
  int argcv_meth_parser_1862__apply[] = {0};
  meth_meth_parser_1862__apply->type = alloc_MethodType(1, argcv_meth_parser_1862__apply);
  meth_meth_parser_1862__apply->definitionModule = modulename;
  meth_meth_parser_1862__apply->definitionLine = 3208;
// compiled block node returning block1861 (depth = 5)
  gc_frame_newslot(block1861);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block1869 = alloc_Block(NULL, NULL, "parser", 725);
  gc_frame_newslot(block1869);
// method "_apply"
  block_savedest(block1869);
  Object closure1870 = createclosure(8, "_apply");
  setclosureframe(closure1870, stackframe);
  addtoclosure(closure1870, var_errormessages);
  addtoclosure(closure1870, var_btok);
  addtoclosure(closure1870, var_lastToken);
  addtoclosure(closure1870, var_sym);
  addtoclosure(closure1870, var_values);
  addtoclosure(closure1870, var_v);
  addtoclosure(closure1870, var_body);
  addtoclosure(closure1870, selfslot);
  struct UserObject *uo1870 = (struct UserObject*)block1869;
  uo1870->data[0] = (Object)closure1870;
  Method *meth_meth_parser_1870__apply = addmethod2pos(block1869, "_apply", &meth_parser_1870__apply, 0);
  int argcv_meth_parser_1870__apply[] = {0};
  meth_meth_parser_1870__apply->type = alloc_MethodType(1, argcv_meth_parser_1870__apply);
  meth_meth_parser_1870__apply->definitionModule = modulename;
  meth_meth_parser_1870__apply->definitionLine = 3208;
// compiled block node returning block1869 (depth = 5)
  gc_frame_newslot(block1869);
// call case 5: prelude request
  params[0] = block1861;
  params[1] = block1869;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1926 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1860);
// compiled call node returning call1926 (depth = 4)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1927 = gc_frame_new();
// call case 4: self request
  Object call1928 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1927);
// compiled member node returning call1928 (depth = 4)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1929 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1930 = alloc_Block(NULL, NULL, "parser", 748);
  gc_frame_newslot(block1930);
// method "_apply"
  block_savedest(block1930);
  Object closure1931 = createclosure(2, "_apply");
  setclosureframe(closure1931, stackframe);
  addtoclosure(closure1931, var_sym);
  addtoclosure(closure1931, selfslot);
  struct UserObject *uo1931 = (struct UserObject*)block1930;
  uo1931->data[0] = (Object)closure1931;
  Method *meth_meth_parser_1931__apply = addmethod2pos(block1930, "_apply", &meth_parser_1931__apply, 0);
  int argcv_meth_parser_1931__apply[] = {0};
  meth_meth_parser_1931__apply->type = alloc_MethodType(1, argcv_meth_parser_1931__apply);
  meth_meth_parser_1931__apply->definitionModule = modulename;
  meth_meth_parser_1931__apply->definitionLine = 3208;
// compiled block node returning block1930 (depth = 5)
  gc_frame_newslot(block1930);
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block1945 = alloc_Block(NULL, NULL, "parser", 748);
  gc_frame_newslot(block1945);
// method "_apply"
  block_savedest(block1945);
  Object closure1946 = createclosure(16, "_apply");
  setclosureframe(closure1946, stackframe);
  addtoclosure(closure1946, var_sym);
  addtoclosure(closure1946, var_statementToken);
  addtoclosure(closure1946, var_errormessages);
  addtoclosure(closure1946, var_blocksOK);
  addtoclosure(closure1946, var_lastToken);
  addtoclosure(closure1946, var_values);
  addtoclosure(closure1946, var_econd);
  addtoclosure(closure1946, var_ebody);
  addtoclosure(closure1946, var_btok);
  addtoclosure(closure1946, var_minIndentLevel);
  addtoclosure(closure1946, var_minInd);
  addtoclosure(closure1946, var_v);
  addtoclosure(closure1946, var_newelse);
  addtoclosure(closure1946, var_eif);
  addtoclosure(closure1946, var_curelse);
  addtoclosure(closure1946, selfslot);
  struct UserObject *uo1946 = (struct UserObject*)block1945;
  uo1946->data[0] = (Object)closure1946;
  Method *meth_meth_parser_1946__apply = addmethod2pos(block1945, "_apply", &meth_parser_1946__apply, 0);
  int argcv_meth_parser_1946__apply[] = {0};
  meth_meth_parser_1946__apply->type = alloc_MethodType(1, argcv_meth_parser_1946__apply);
  meth_meth_parser_1946__apply->definitionModule = modulename;
  meth_meth_parser_1946__apply->definitionLine = 3208;
// compiled block node returning block1945 (depth = 5)
  gc_frame_newslot(block1945);
// call case 5: prelude request
  params[0] = block1930;
  params[1] = block1945;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2496 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call2496 (depth = 4)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2500 == NULL) {
    strlit2500 = alloc_String("else");
    gc_root(strlit2500);
  }
// compiled string node returning strlit2500 (depth = 7)
  int op_slot_right_2499 = gc_frame_newslot(strlit2500);
// starting to compile member node (depth = 7)
  int callframe2502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2503 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2502);
// compiled member node returning call2503 (depth = 7)
  int op_slot_left_2499 = gc_frame_newslot(call2503);
  params[0] = strlit2500;
  partcv[0] = 1;
  Object opresult2504 = callmethod(call2503, "==(1)", 1, partcv, params);
// compiled op node returning opresult2504 (depth = 6)
  int op_slot_right_2498 = gc_frame_newslot(opresult2504);
// starting to compile call node (depth = 6)
  int callframe2506 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2507 == NULL) {
    strlit2507 = alloc_String("identifier");
    gc_root(strlit2507);
  }
// compiled string node returning strlit2507 (depth = 7)
  gc_frame_newslot(strlit2507);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit2507;
  partcv[0] = 1;
  Object call2508 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2506);
// compiled call node returning call2508 (depth = 6)
  int op_slot_left_2498 = gc_frame_newslot(call2508);
  params[0] = opresult2504;
  partcv[0] = 1;
  Object opresult2509 = callmethod(call2508, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2509 (depth = 5)
  Object if2497 = done;
  if (istrue(opresult2509)) {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2510 = gc_frame_new();
// call case 4: self request
  Object call2511 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2510);
// compiled member node returning call2511 (depth = 5)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2514 == NULL) {
    strlit2514 = alloc_String("lbrace");
    gc_root(strlit2514);
  }
// compiled string node returning strlit2514 (depth = 7)
  int op_slot_right_2513 = gc_frame_newslot(strlit2514);
// starting to compile member node (depth = 7)
  int callframe2516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2517 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2516);
// compiled member node returning call2517 (depth = 7)
  int op_slot_left_2513 = gc_frame_newslot(call2517);
  params[0] = strlit2514;
  partcv[0] = 1;
  Object opresult2518 = callmethod(call2517, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2518 (depth = 6)
  Object if2512 = done;
  if (istrue(opresult2518)) {
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2519 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call2521 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2520);
// compiled member node returning call2521 (depth = 8)
  Object call2522 = callmethodflags(call2521, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2519);
// compiled member node returning call2522 (depth = 7)
  *var_suggestion = call2522;
  if (call2522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2523 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2524 = alloc_Boolean(1);
// compiled identifier node returning bool2524 (depth = 8)
  gc_frame_newslot(bool2524);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_btok;
  params[1] = bool2524;
  partcv[0] = 2;
  Object call2525 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2523);
// compiled call node returning call2525 (depth = 7)
  *var_closingBrace = call2525;
  if (call2525 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call2529 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2528);
// compiled member node returning call2529 (depth = 8)
  Object call2530 = callmethodflags(call2529, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2527);
// compiled member node returning call2530 (depth = 7)
  Object if2526 = done;
  if (istrue(call2530)) {
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2532 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe2534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call2535 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2534);
// compiled member node returning call2535 (depth = 9)
  int op_slot_left_2532 = gc_frame_newslot(call2535);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2536 = callmethod(call2535, "==(1)", 1, partcv, params);
// compiled op node returning opresult2536 (depth = 8)
  Object if2531 = done;
  if (istrue(opresult2536)) {
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2537 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2538 = alloc_Boolean(0);
// compiled identifier node returning bool2538 (depth = 9)
  gc_frame_newslot(bool2538);
// starting to compile identifier node (depth = 9)
  Object bool2539 = alloc_Boolean(1);
// compiled identifier node returning bool2539 (depth = 9)
  gc_frame_newslot(bool2539);
// starting to compile string node (depth = 9)
  if (strlit2540 == NULL) {
    strlit2540 = alloc_String("else {}");
    gc_root(strlit2540);
  }
// compiled string node returning strlit2540 (depth = 9)
  gc_frame_newslot(strlit2540);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2538;
  params[2] = bool2539;
  params[3] = strlit2540;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2541 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2537);
// compiled call node returning call2541 (depth = 8)
    gc_frame_newslot(call2541);
    if2531 = call2541;
  } else {
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2542 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2544 = alloc_Float64(0.1);
// compiled num node returning num2544 (depth = 10)
  int op_slot_right_2543 = gc_frame_newslot(num2544);
// starting to compile member node (depth = 10)
  int callframe2546 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2547 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2548 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2547);
// compiled member node returning call2548 (depth = 11)
  Object call2549 = callmethodflags(call2548, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2546);
// compiled member node returning call2549 (depth = 10)
  int op_slot_left_2543 = gc_frame_newslot(call2549);
  params[0] = num2544;
  partcv[0] = 1;
  Object sum2550 = callmethod(call2549, "+(1)", 1, partcv, params);
// compiled op node returning sum2550 (depth = 9)
  gc_frame_newslot(sum2550);
// starting to compile string node (depth = 9)
  if (strlit2551 == NULL) {
    strlit2551 = alloc_String("}");
    gc_root(strlit2551);
  }
// compiled string node returning strlit2551 (depth = 9)
  gc_frame_newslot(strlit2551);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2550;
  params[1] = strlit2551;
  partcv[0] = 2;
  Object call2552 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2542);
// compiled call node returning call2552 (depth = 8)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2553 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2554 = alloc_Boolean(0);
// compiled identifier node returning bool2554 (depth = 9)
  gc_frame_newslot(bool2554);
// starting to compile identifier node (depth = 9)
  Object bool2555 = alloc_Boolean(1);
// compiled identifier node returning bool2555 (depth = 9)
  gc_frame_newslot(bool2555);
// starting to compile string node (depth = 9)
  if (strlit2556 == NULL) {
    strlit2556 = alloc_String("else {");
    gc_root(strlit2556);
  }
// compiled string node returning strlit2556 (depth = 9)
  gc_frame_newslot(strlit2556);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2554;
  params[2] = bool2555;
  params[3] = strlit2556;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2557 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2553);
// compiled call node returning call2557 (depth = 8)
    gc_frame_newslot(call2557);
    if2531 = call2557;
  }
// compiled if node returning if2531 (depth = 7)
    gc_frame_newslot(if2531);
    if2526 = if2531;
  } else {
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2558 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2559 = alloc_Boolean(0);
// compiled identifier node returning bool2559 (depth = 8)
  gc_frame_newslot(bool2559);
// starting to compile identifier node (depth = 8)
  Object bool2560 = alloc_Boolean(1);
// compiled identifier node returning bool2560 (depth = 8)
  gc_frame_newslot(bool2560);
// starting to compile string node (depth = 8)
  if (strlit2561 == NULL) {
    strlit2561 = alloc_String("else {");
    gc_root(strlit2561);
  }
// compiled string node returning strlit2561 (depth = 8)
  gc_frame_newslot(strlit2561);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2559;
  params[2] = bool2560;
  params[3] = strlit2561;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2562 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2558);
// compiled call node returning call2562 (depth = 7)
    gc_frame_newslot(call2562);
    if2526 = call2562;
  }
// compiled if node returning if2526 (depth = 6)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2563 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2564 == NULL) {
    strlit2564 = alloc_String("an else statement must have a '{' after the 'else'.");
    gc_root(strlit2564);
  }
// compiled string node returning strlit2564 (depth = 7)
  gc_frame_newslot(strlit2564);
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2566 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2565);
// compiled member node returning call2566 (depth = 7)
  gc_frame_newslot(call2566);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2568 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2569 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2568);
// compiled member node returning call2569 (depth = 8)
  int op_slot_right_2567 = gc_frame_newslot(call2569);
// starting to compile member node (depth = 8)
  int callframe2571 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2572 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2571);
// compiled member node returning call2572 (depth = 8)
  int op_slot_left_2567 = gc_frame_newslot(call2572);
  params[0] = call2569;
  partcv[0] = 1;
  Object sum2573 = callmethod(call2572, "+(1)", 1, partcv, params);
// compiled op node returning sum2573 (depth = 7)
  gc_frame_newslot(sum2573);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2564;
  params[1] = call2566;
  params[2] = sum2573;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2574 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2563);
// compiled call node returning call2574 (depth = 6)
    gc_frame_newslot(call2574);
    if2512 = call2574;
  } else {
  }
// compiled if node returning if2512 (depth = 5)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2575 = gc_frame_new();
// call case 4: self request
  Object call2576 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2575);
// compiled member node returning call2576 (depth = 5)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2580 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2579);
// compiled member node returning call2580 (depth = 7)
  int op_slot_right_2578 = gc_frame_newslot(call2580);
// starting to compile member node (depth = 7)
  int callframe2582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2583 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2582);
// compiled member node returning call2583 (depth = 7)
  int op_slot_left_2578 = gc_frame_newslot(call2583);
  params[0] = call2580;
  partcv[0] = 1;
  Object opresult2584 = callmethod(call2583, "==(1)", 1, partcv, params);
// compiled op node returning opresult2584 (depth = 6)
  Object if2577 = done;
  if (istrue(opresult2584)) {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2586 = alloc_Float64(1);
// compiled num node returning num2586 (depth = 8)
  int op_slot_right_2585 = gc_frame_newslot(num2586);
// starting to compile member node (depth = 8)
  int callframe2588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2589 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2588);
// compiled member node returning call2589 (depth = 8)
  int op_slot_left_2585 = gc_frame_newslot(call2589);
  params[0] = num2586;
  partcv[0] = 1;
  Object diff2590 = callmethod(call2589, "-(1)", 1, partcv, params);
// compiled op node returning diff2590 (depth = 7)
  *var_minIndentLevel = diff2590;
  if (diff2590 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2577 = done;
  } else {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2577 = done;
  }
// compiled if node returning if2577 (depth = 5)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2593 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2594 = alloc_Block(NULL, NULL, "parser", 937);
  gc_frame_newslot(block2594);
// method "_apply"
  block_savedest(block2594);
  Object closure2595 = createclosure(1, "_apply");
  setclosureframe(closure2595, stackframe);
  addtoclosure(closure2595, selfslot);
  struct UserObject *uo2595 = (struct UserObject*)block2594;
  uo2595->data[0] = (Object)closure2595;
  Method *meth_meth_parser_2595__apply = addmethod2pos(block2594, "_apply", &meth_parser_2595__apply, 0);
  int argcv_meth_parser_2595__apply[] = {0};
  meth_meth_parser_2595__apply->type = alloc_MethodType(1, argcv_meth_parser_2595__apply);
  meth_meth_parser_2595__apply->definitionModule = modulename;
  meth_meth_parser_2595__apply->definitionLine = 3208;
// compiled block node returning block2594 (depth = 6)
  gc_frame_newslot(block2594);
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block2602 = alloc_Block(NULL, NULL, "parser", 937);
  gc_frame_newslot(block2602);
// method "_apply"
  block_savedest(block2602);
  Object closure2603 = createclosure(8, "_apply");
  setclosureframe(closure2603, stackframe);
  addtoclosure(closure2603, var_errormessages);
  addtoclosure(closure2603, var_btok);
  addtoclosure(closure2603, var_sym);
  addtoclosure(closure2603, var_lastToken);
  addtoclosure(closure2603, var_values);
  addtoclosure(closure2603, var_v);
  addtoclosure(closure2603, var_curelse);
  addtoclosure(closure2603, selfslot);
  struct UserObject *uo2603 = (struct UserObject*)block2602;
  uo2603->data[0] = (Object)closure2603;
  Method *meth_meth_parser_2603__apply = addmethod2pos(block2602, "_apply", &meth_parser_2603__apply, 0);
  int argcv_meth_parser_2603__apply[] = {0};
  meth_meth_parser_2603__apply->type = alloc_MethodType(1, argcv_meth_parser_2603__apply);
  meth_meth_parser_2603__apply->definitionModule = modulename;
  meth_meth_parser_2603__apply->definitionLine = 3208;
// compiled block node returning block2602 (depth = 6)
  gc_frame_newslot(block2602);
// call case 5: prelude request
  params[0] = block2594;
  params[1] = block2602;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2681 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2593);
// compiled call node returning call2681 (depth = 5)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2682 = gc_frame_new();
// call case 4: self request
  Object call2683 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2682);
// compiled member node returning call2683 (depth = 5)
    gc_frame_newslot(call2683);
    if2497 = call2683;
  } else {
  }
// compiled if node returning if2497 (depth = 4)
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2684 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call2686 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2685);
// compiled member node returning call2686 (depth = 5)
  gc_frame_newslot(call2686);
// starting to compile member node (depth = 5)
  int callframe2687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call2688 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2687);
// compiled member node returning call2688 (depth = 5)
  gc_frame_newslot(call2688);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call2686;
  params[1] = call2688;
  partcv[0] = 2;
  Object call2689 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2684);
// compiled call node returning call2689 (depth = 4)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2690 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call2691 = callmethodflags(module_parser, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2690);
// compiled call node returning call2691 (depth = 5)
  *var_o = call2691;
  if (call2691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2692 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call2693 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2692);
// compiled call node returning call2693 (depth = 4)
    gc_frame_newslot(call2693);
    if1764 = call2693;
  } else {
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2694 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2695 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call2696 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2695);
// compiled member node returning call2696 (depth = 6)
  Object call2697 = callmethodflags(call2696, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2694);
// compiled member node returning call2697 (depth = 5)
  *var_suggestion = call2697;
  if (call2697 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2700 == NULL) {
    strlit2700 = alloc_String("lbrace");
    gc_root(strlit2700);
  }
// compiled string node returning strlit2700 (depth = 6)
  int op_slot_right_2699 = gc_frame_newslot(strlit2700);
// starting to compile member node (depth = 6)
  int callframe2702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2703 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2702);
// compiled member node returning call2703 (depth = 6)
  int op_slot_left_2699 = gc_frame_newslot(call2703);
  params[0] = strlit2700;
  partcv[0] = 1;
  Object opresult2704 = callmethod(call2703, "==(1)", 1, partcv, params);
// compiled op node returning opresult2704 (depth = 5)
  Object if2698 = done;
  if (istrue(opresult2704)) {
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2705 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2706 = alloc_Boolean(0);
// compiled identifier node returning bool2706 (depth = 7)
  gc_frame_newslot(bool2706);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool2706;
  partcv[0] = 2;
  Object call2707 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2705);
// compiled call node returning call2707 (depth = 6)
  *var_closingBrace = call2707;
  if (call2707 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2709 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call2711 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2710);
// compiled member node returning call2711 (depth = 7)
  Object call2712 = callmethodflags(call2711, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2709);
// compiled member node returning call2712 (depth = 6)
  Object if2708 = done;
  if (istrue(call2712)) {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_2714 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe2716 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call2717 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2716);
// compiled member node returning call2717 (depth = 8)
  int op_slot_left_2714 = gc_frame_newslot(call2717);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2718 = callmethod(call2717, "==(1)", 1, partcv, params);
// compiled op node returning opresult2718 (depth = 7)
  Object if2713 = done;
  if (istrue(opresult2718)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2719 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2720 = alloc_Boolean(1);
// compiled identifier node returning bool2720 (depth = 8)
  gc_frame_newslot(bool2720);
// starting to compile identifier node (depth = 8)
  Object bool2721 = alloc_Boolean(0);
// compiled identifier node returning bool2721 (depth = 8)
  gc_frame_newslot(bool2721);
// starting to compile string node (depth = 8)
  if (strlit2722 == NULL) {
    strlit2722 = alloc_String(" then {}");
    gc_root(strlit2722);
  }
// compiled string node returning strlit2722 (depth = 8)
  gc_frame_newslot(strlit2722);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2720;
  params[2] = bool2721;
  params[3] = strlit2722;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2723 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2719);
// compiled call node returning call2723 (depth = 7)
    gc_frame_newslot(call2723);
    if2713 = call2723;
  } else {
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2724 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2725 = alloc_Boolean(1);
// compiled identifier node returning bool2725 (depth = 8)
  gc_frame_newslot(bool2725);
// starting to compile identifier node (depth = 8)
  Object bool2726 = alloc_Boolean(0);
// compiled identifier node returning bool2726 (depth = 8)
  gc_frame_newslot(bool2726);
// starting to compile string node (depth = 8)
  if (strlit2727 == NULL) {
    strlit2727 = alloc_String(" then {");
    gc_root(strlit2727);
  }
// compiled string node returning strlit2727 (depth = 8)
  gc_frame_newslot(strlit2727);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2725;
  params[2] = bool2726;
  params[3] = strlit2727;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2728 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2724);
// compiled call node returning call2728 (depth = 7)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2729 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2731 = alloc_Float64(0.1);
// compiled num node returning num2731 (depth = 9)
  int op_slot_right_2730 = gc_frame_newslot(num2731);
// starting to compile member node (depth = 9)
  int callframe2733 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2735 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2734);
// compiled member node returning call2735 (depth = 10)
  Object call2736 = callmethodflags(call2735, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2733);
// compiled member node returning call2736 (depth = 9)
  int op_slot_left_2730 = gc_frame_newslot(call2736);
  params[0] = num2731;
  partcv[0] = 1;
  Object sum2737 = callmethod(call2736, "+(1)", 1, partcv, params);
// compiled op node returning sum2737 (depth = 8)
  gc_frame_newslot(sum2737);
// starting to compile string node (depth = 8)
  if (strlit2738 == NULL) {
    strlit2738 = alloc_String("}");
    gc_root(strlit2738);
  }
// compiled string node returning strlit2738 (depth = 8)
  gc_frame_newslot(strlit2738);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2737;
  params[1] = strlit2738;
  partcv[0] = 2;
  Object call2739 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2729);
// compiled call node returning call2739 (depth = 7)
    gc_frame_newslot(call2739);
    if2713 = call2739;
  }
// compiled if node returning if2713 (depth = 6)
    gc_frame_newslot(if2713);
    if2708 = if2713;
  } else {
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2740 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool2741 = alloc_Boolean(1);
// compiled identifier node returning bool2741 (depth = 7)
  gc_frame_newslot(bool2741);
// starting to compile identifier node (depth = 7)
  Object bool2742 = alloc_Boolean(0);
// compiled identifier node returning bool2742 (depth = 7)
  gc_frame_newslot(bool2742);
// starting to compile string node (depth = 7)
  if (strlit2743 == NULL) {
    strlit2743 = alloc_String(" then {");
    gc_root(strlit2743);
  }
// compiled string node returning strlit2743 (depth = 7)
  gc_frame_newslot(strlit2743);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool2741;
  params[2] = bool2742;
  params[3] = strlit2743;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2744 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2740);
// compiled call node returning call2744 (depth = 6)
    gc_frame_newslot(call2744);
    if2708 = call2744;
  }
// compiled if node returning if2708 (depth = 5)
    gc_frame_newslot(if2708);
    if2698 = if2708;
  } else {
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2745 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2746 = alloc_Boolean(1);
// compiled identifier node returning bool2746 (depth = 7)
  gc_frame_newslot(bool2746);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool2746;
  partcv[0] = 2;
  Object call2747 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2745);
// compiled call node returning call2747 (depth = 6)
  *var_closingBrace = call2747;
  if (call2747 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2749 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call2751 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2750);
// compiled member node returning call2751 (depth = 7)
  Object call2752 = callmethodflags(call2751, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2749);
// compiled member node returning call2752 (depth = 6)
  Object if2748 = done;
  if (istrue(call2752)) {
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2754 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe2756 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call2757 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2756);
// compiled member node returning call2757 (depth = 8)
  int op_slot_left_2754 = gc_frame_newslot(call2757);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2758 = callmethod(call2757, "==(1)", 1, partcv, params);
// compiled op node returning opresult2758 (depth = 7)
  Object if2753 = done;
  if (istrue(opresult2758)) {
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2759 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2760 == NULL) {
    strlit2760 = alloc_String(" then {}");
    gc_root(strlit2760);
  }
// compiled string node returning strlit2760 (depth = 8)
  gc_frame_newslot(strlit2760);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2760;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2761 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2759);
// compiled call node returning call2761 (depth = 7)
    gc_frame_newslot(call2761);
    if2753 = call2761;
  } else {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2762 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2763 == NULL) {
    strlit2763 = alloc_String(" then {");
    gc_root(strlit2763);
  }
// compiled string node returning strlit2763 (depth = 8)
  gc_frame_newslot(strlit2763);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2763;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2764 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2762);
// compiled call node returning call2764 (depth = 7)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2765 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2767 = alloc_Float64(0.1);
// compiled num node returning num2767 (depth = 9)
  int op_slot_right_2766 = gc_frame_newslot(num2767);
// starting to compile member node (depth = 9)
  int callframe2769 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2770 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2771 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2770);
// compiled member node returning call2771 (depth = 10)
  Object call2772 = callmethodflags(call2771, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2769);
// compiled member node returning call2772 (depth = 9)
  int op_slot_left_2766 = gc_frame_newslot(call2772);
  params[0] = num2767;
  partcv[0] = 1;
  Object sum2773 = callmethod(call2772, "+(1)", 1, partcv, params);
// compiled op node returning sum2773 (depth = 8)
  gc_frame_newslot(sum2773);
// starting to compile string node (depth = 8)
  if (strlit2774 == NULL) {
    strlit2774 = alloc_String("}");
    gc_root(strlit2774);
  }
// compiled string node returning strlit2774 (depth = 8)
  gc_frame_newslot(strlit2774);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2773;
  params[1] = strlit2774;
  partcv[0] = 2;
  Object call2775 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2765);
// compiled call node returning call2775 (depth = 7)
    gc_frame_newslot(call2775);
    if2753 = call2775;
  }
// compiled if node returning if2753 (depth = 6)
    gc_frame_newslot(if2753);
    if2748 = if2753;
  } else {
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2776 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2777 == NULL) {
    strlit2777 = alloc_String(" then {");
    gc_root(strlit2777);
  }
// compiled string node returning strlit2777 (depth = 7)
  gc_frame_newslot(strlit2777);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2777;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2778 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2776);
// compiled call node returning call2778 (depth = 6)
    gc_frame_newslot(call2778);
    if2748 = call2778;
  }
// compiled if node returning if2748 (depth = 5)
    gc_frame_newslot(if2748);
    if2698 = if2748;
  }
// compiled if node returning if2698 (depth = 4)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2779 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2781 == NULL) {
    strlit2781 = alloc_String("the condition in parentheses.");
    gc_root(strlit2781);
  }
// compiled string node returning strlit2781 (depth = 6)
  int op_slot_right_2780 = gc_frame_newslot(strlit2781);
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2783 == NULL) {
    strlit2783 = alloc_String("an if statement must have 'then' after ");
    gc_root(strlit2783);
  }
// compiled string node returning strlit2783 (depth = 6)
  int op_slot_left_2780 = gc_frame_newslot(strlit2783);
  params[0] = strlit2781;
  partcv[0] = 1;
  Object opresult2784 = callmethod(strlit2783, "++(1)", 1, partcv, params);
// compiled op node returning opresult2784 (depth = 5)
  gc_frame_newslot(opresult2784);
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2785 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call2786 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2785);
// compiled member node returning call2786 (depth = 5)
  gc_frame_newslot(call2786);
// starting to compile member node (depth = 5)
  int callframe2787 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call2788 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2787);
// compiled member node returning call2788 (depth = 5)
  gc_frame_newslot(call2788);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult2784;
  params[1] = call2786;
  params[2] = call2788;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2789 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2779);
// compiled call node returning call2789 (depth = 4)
    gc_frame_newslot(call2789);
    if1764 = call2789;
  }
// compiled if node returning if1764 (depth = 3)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1399 = done;
  } else {
  }
// compiled if node returning if1399 (depth = 2)
  gc_frame_end(frame);
  return if1399;
}
Object meth_parser_2792_identifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2794 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2795 == NULL) {
    strlit2795 = alloc_String("identifier");
    gc_root(strlit2795);
  }
// compiled string node returning strlit2795 (depth = 4)
  gc_frame_newslot(strlit2795);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit2795;
  partcv[0] = 1;
  Object call2796 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2794);
// compiled call node returning call2796 (depth = 3)
  Object if2793 = done;
  if (istrue(call2796)) {
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2799 == NULL) {
    strlit2799 = alloc_String("if");
    gc_root(strlit2799);
  }
// compiled string node returning strlit2799 (depth = 5)
  int op_slot_right_2798 = gc_frame_newslot(strlit2799);
// starting to compile member node (depth = 5)
  int callframe2801 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call2802 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2801);
// compiled member node returning call2802 (depth = 5)
  int op_slot_left_2798 = gc_frame_newslot(call2802);
  params[0] = strlit2799;
  partcv[0] = 1;
  Object opresult2803 = callmethod(call2802, "==(1)", 1, partcv, params);
// compiled op node returning opresult2803 (depth = 4)
  Object if2797 = done;
  if (istrue(opresult2803)) {
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2804 = gc_frame_new();
// call case 4: self request
  Object call2805 = callmethodflags(self, "doif", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2804);
// compiled member node returning call2805 (depth = 4)
    gc_frame_newslot(call2805);
    if2797 = call2805;
  } else {
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2806 = gc_frame_new();
// call case 4: self request
  Object call2807 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compiled member node returning call2807 (depth = 4)
    gc_frame_newslot(call2807);
    if2797 = call2807;
  }
// compiled if node returning if2797 (depth = 3)
    gc_frame_newslot(if2797);
    if2793 = if2797;
  } else {
  }
// compiled if node returning if2793 (depth = 2)
  gc_frame_end(frame);
  return if2793;
}
Object meth_parser_2826__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe2827 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2828 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2827);
// compiled call node returning call2828 (depth = 7)
  gc_frame_end(frame);
  return call2828;
}
Object meth_parser_2893__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe2894 = gc_frame_new();
// call case 4: self request
  Object call2895 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2894);
// compiled member node returning call2895 (depth = 7)
  gc_frame_end(frame);
  return call2895;
}
Object meth_parser_2808_prefixop(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
// definebindings:
  Object *var_op = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "op");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_rcvr = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rcvr");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// definebindings:
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2810 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2811 == NULL) {
    strlit2811 = alloc_String("op");
    gc_root(strlit2811);
  }
// compiled string node returning strlit2811 (depth = 4)
  gc_frame_newslot(strlit2811);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit2811;
  partcv[0] = 1;
  Object call2812 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2810);
// compiled call node returning call2812 (depth = 3)
  Object if2809 = done;
  if (istrue(call2812)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2813 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call2814 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2813);
// compiled member node returning call2814 (depth = 4)
  *var_op = call2814;
  if (call2814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2815 = gc_frame_new();
// call case 4: self request
  Object call2816 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2815);
// compiled member node returning call2816 (depth = 3)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2818 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2819 == NULL) {
    strlit2819 = alloc_String("lparen");
    gc_root(strlit2819);
  }
// compiled string node returning strlit2819 (depth = 5)
  gc_frame_newslot(strlit2819);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit2819;
  partcv[0] = 1;
  Object call2820 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2818);
// compiled call node returning call2820 (depth = 4)
  Object if2817 = done;
  if (istrue(call2820)) {
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2821 = gc_frame_new();
// call case 4: self request
  Object call2822 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2821);
// compiled member node returning call2822 (depth = 4)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2824 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2825 = alloc_Block(NULL, NULL, "parser", 1022);
  gc_frame_newslot(block2825);
// method "_apply"
  block_savedest(block2825);
  Object closure2826 = createclosure(2, "_apply");
  setclosureframe(closure2826, stackframe);
  addtoclosure(closure2826, var_blocksOK);
  addtoclosure(closure2826, selfslot);
  struct UserObject *uo2826 = (struct UserObject*)block2825;
  uo2826->data[0] = (Object)closure2826;
  Method *meth_meth_parser_2826__apply = addmethod2pos(block2825, "_apply", &meth_parser_2826__apply, 0);
  int argcv_meth_parser_2826__apply[] = {0};
  meth_meth_parser_2826__apply->type = alloc_MethodType(1, argcv_meth_parser_2826__apply);
  meth_meth_parser_2826__apply->definitionModule = modulename;
  meth_meth_parser_2826__apply->definitionLine = 3208;
// compiled block node returning block2825 (depth = 6)
  gc_frame_newslot(block2825);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block2825;
  partcv[0] = 1;
  Object call2830 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2824);
// compiled call node returning call2830 (depth = 5)
  Object if2823 = done;
  if (istrue(call2830)) {
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2831 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2832 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call2833 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2832);
// compiled member node returning call2833 (depth = 7)
  Object call2834 = callmethodflags(call2833, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2831);
// compiled member node returning call2834 (depth = 6)
  *var_suggestion = call2834;
  if (call2834 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2835 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array2836 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit2837 == NULL) {
    strlit2837 = alloc_String("rparen");
    gc_root(strlit2837);
  }
// compiled string node returning strlit2837 (depth = 8)
  params[0] = strlit2837;
  partcv[0] = 1;
  callmethodflags(array2836, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2836 (depth = 7)
  gc_frame_newslot(array2836);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array2836;
  partcv[0] = 1;
  Object call2838 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2835);
// compiled call node returning call2838 (depth = 6)
  *var_nextTok = call2838;
  if (call2838 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_2840 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_2840 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2842 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2842 (depth = 6)
  Object if2839 = done;
  if (istrue(opresult2842)) {
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2843 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2844 == NULL) {
    strlit2844 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2844);
  }
// compiled string node returning strlit2844 (depth = 7)
  gc_frame_newslot(strlit2844);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2844;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2845 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2843);
// compiled call node returning call2845 (depth = 6)
    gc_frame_newslot(call2845);
    if2839 = call2845;
  } else {
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2846 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe2847 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call2848 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2847);
// compiled member node returning call2848 (depth = 7)
  gc_frame_newslot(call2848);
// starting to compile identifier node (depth = 7)
  Object bool2849 = alloc_Boolean(1);
// compiled identifier node returning bool2849 (depth = 7)
  gc_frame_newslot(bool2849);
// starting to compile identifier node (depth = 7)
  Object bool2850 = alloc_Boolean(0);
// compiled identifier node returning bool2850 (depth = 7)
  gc_frame_newslot(bool2850);
// starting to compile string node (depth = 7)
  if (strlit2851 == NULL) {
    strlit2851 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2851);
  }
// compiled string node returning strlit2851 (depth = 7)
  gc_frame_newslot(strlit2851);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2848;
  params[2] = bool2849;
  params[3] = bool2850;
  params[4] = strlit2851;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2852 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2846);
// compiled call node returning call2852 (depth = 6)
    gc_frame_newslot(call2852);
    if2839 = call2852;
  }
// compiled if node returning if2839 (depth = 5)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2853 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2854 == NULL) {
    strlit2854 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit2854);
  }
// compiled string node returning strlit2854 (depth = 6)
  gc_frame_newslot(strlit2854);
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2855 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2856 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2855);
// compiled member node returning call2856 (depth = 6)
  gc_frame_newslot(call2856);
// starting to compile member node (depth = 6)
  int callframe2857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2858 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2857);
// compiled member node returning call2858 (depth = 6)
  gc_frame_newslot(call2858);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2854;
  params[1] = call2856;
  params[2] = call2858;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2859 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2853);
// compiled call node returning call2859 (depth = 5)
    gc_frame_newslot(call2859);
    if2823 = call2859;
  } else {
  }
// compiled if node returning if2823 (depth = 4)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2862 == NULL) {
    strlit2862 = alloc_String("rparen");
    gc_root(strlit2862);
  }
// compiled string node returning strlit2862 (depth = 6)
  int op_slot_right_2861 = gc_frame_newslot(strlit2862);
// starting to compile member node (depth = 6)
  int callframe2864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2865 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2864);
// compiled member node returning call2865 (depth = 6)
  int op_slot_left_2861 = gc_frame_newslot(call2865);
  params[0] = strlit2862;
  partcv[0] = 1;
  Object opresult2866 = callmethod(call2865, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2866 (depth = 5)
  Object if2860 = done;
  if (istrue(opresult2866)) {
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2867 = gc_frame_new();
// call case 4: self request
  Object call2868 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2867);
// compiled member node returning call2868 (depth = 5)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2869 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2870 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call2871 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2870);
// compiled member node returning call2871 (depth = 7)
  Object call2872 = callmethodflags(call2871, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2869);
// compiled member node returning call2872 (depth = 6)
  *var_suggestion = call2872;
  if (call2872 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2873 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2874 == NULL) {
    strlit2874 = alloc_String(")");
    gc_root(strlit2874);
  }
// compiled string node returning strlit2874 (depth = 6)
  gc_frame_newslot(strlit2874);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit2874;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2875 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2873);
// compiled call node returning call2875 (depth = 5)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2876 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2877 == NULL) {
    strlit2877 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit2877);
  }
// compiled string node returning strlit2877 (depth = 6)
  gc_frame_newslot(strlit2877);
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2878 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2879 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2878);
// compiled member node returning call2879 (depth = 6)
  gc_frame_newslot(call2879);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2882 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2881);
// compiled member node returning call2882 (depth = 7)
  int op_slot_right_2880 = gc_frame_newslot(call2882);
// starting to compile member node (depth = 7)
  int callframe2884 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2885 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2884);
// compiled member node returning call2885 (depth = 7)
  int op_slot_left_2880 = gc_frame_newslot(call2885);
  params[0] = call2882;
  partcv[0] = 1;
  Object sum2886 = callmethod(call2885, "+(1)", 1, partcv, params);
// compiled op node returning sum2886 (depth = 6)
  gc_frame_newslot(sum2886);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2877;
  params[1] = call2879;
  params[2] = sum2886;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2887 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2876);
// compiled call node returning call2887 (depth = 5)
    gc_frame_newslot(call2887);
    if2860 = call2887;
  } else {
  }
// compiled if node returning if2860 (depth = 4)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2888 = gc_frame_new();
// call case 4: self request
  Object call2889 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2888);
// compiled member node returning call2889 (depth = 4)
    gc_frame_newslot(call2889);
    if2817 = call2889;
  } else {
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2891 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2892 = alloc_Block(NULL, NULL, "parser", 1042);
  gc_frame_newslot(block2892);
// method "_apply"
  block_savedest(block2892);
  Object closure2893 = createclosure(1, "_apply");
  setclosureframe(closure2893, stackframe);
  addtoclosure(closure2893, selfslot);
  struct UserObject *uo2893 = (struct UserObject*)block2892;
  uo2893->data[0] = (Object)closure2893;
  Method *meth_meth_parser_2893__apply = addmethod2pos(block2892, "_apply", &meth_parser_2893__apply, 0);
  int argcv_meth_parser_2893__apply[] = {0};
  meth_meth_parser_2893__apply->type = alloc_MethodType(1, argcv_meth_parser_2893__apply);
  meth_meth_parser_2893__apply->definitionModule = modulename;
  meth_meth_parser_2893__apply->definitionLine = 3208;
// compiled block node returning block2892 (depth = 6)
  gc_frame_newslot(block2892);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block2892;
  partcv[0] = 1;
  Object call2897 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2891);
// compiled call node returning call2897 (depth = 5)
  Object if2890 = done;
  if (istrue(call2897)) {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array2898 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2898 (depth = 6)
  *var_suggestions = array2898;
  if (array2898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2899 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call2901 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2900);
// compiled member node returning call2901 (depth = 7)
  Object call2902 = callmethodflags(call2901, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2899);
// compiled member node returning call2902 (depth = 6)
  *var_suggestion = call2902;
  if (call2902 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2903 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array2904 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("rparen");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 8)
  params[0] = strlit2905;
  partcv[0] = 1;
  callmethodflags(array2904, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2904 (depth = 7)
  gc_frame_newslot(array2904);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array2904;
  partcv[0] = 1;
  Object call2906 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2903);
// compiled call node returning call2906 (depth = 6)
  *var_nextTok = call2906;
  if (call2906 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_2908 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_2908 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2910 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2910 (depth = 6)
  Object if2907 = done;
  if (istrue(opresult2910)) {
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2911 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2912 == NULL) {
    strlit2912 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2912);
  }
// compiled string node returning strlit2912 (depth = 7)
  gc_frame_newslot(strlit2912);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2912;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2913 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2911);
// compiled call node returning call2913 (depth = 6)
    gc_frame_newslot(call2913);
    if2907 = call2913;
  } else {
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2914 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe2915 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call2916 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2915);
// compiled member node returning call2916 (depth = 7)
  gc_frame_newslot(call2916);
// starting to compile identifier node (depth = 7)
  Object bool2917 = alloc_Boolean(1);
// compiled identifier node returning bool2917 (depth = 7)
  gc_frame_newslot(bool2917);
// starting to compile identifier node (depth = 7)
  Object bool2918 = alloc_Boolean(0);
// compiled identifier node returning bool2918 (depth = 7)
  gc_frame_newslot(bool2918);
// starting to compile string node (depth = 7)
  if (strlit2919 == NULL) {
    strlit2919 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2919);
  }
// compiled string node returning strlit2919 (depth = 7)
  gc_frame_newslot(strlit2919);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2916;
  params[2] = bool2917;
  params[3] = bool2918;
  params[4] = strlit2919;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2920 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2914);
// compiled call node returning call2920 (depth = 6)
    gc_frame_newslot(call2920);
    if2907 = call2920;
  }
// compiled if node returning if2907 (depth = 5)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2921 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call2922 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2921);
// compiled call node returning call2922 (depth = 5)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2925 == NULL) {
    strlit2925 = alloc_String("bind");
    gc_root(strlit2925);
  }
// compiled string node returning strlit2925 (depth = 7)
  int op_slot_right_2924 = gc_frame_newslot(strlit2925);
// starting to compile member node (depth = 7)
  int callframe2927 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2928 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2929 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2928);
// compiled member node returning call2929 (depth = 8)
  Object call2930 = callmethodflags(call2929, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2927);
// compiled member node returning call2930 (depth = 7)
  int op_slot_left_2924 = gc_frame_newslot(call2930);
  params[0] = strlit2925;
  partcv[0] = 1;
  Object opresult2931 = callmethod(call2930, "==(1)", 1, partcv, params);
// compiled op node returning opresult2931 (depth = 6)
  Object if2923 = done;
  if (istrue(opresult2931)) {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2932 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2933 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call2934 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2933);
// compiled member node returning call2934 (depth = 8)
  Object call2935 = callmethodflags(call2934, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2932);
// compiled member node returning call2935 (depth = 7)
  *var_suggestion = call2935;
  if (call2935 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2937 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe2938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call2939 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2938);
// compiled member node returning call2939 (depth = 7)
  gc_frame_newslot(call2939);
// starting to compile identifier node (depth = 7)
  Object bool2940 = alloc_Boolean(1);
// compiled identifier node returning bool2940 (depth = 7)
  gc_frame_newslot(bool2940);
// starting to compile identifier node (depth = 7)
  Object bool2941 = alloc_Boolean(0);
// compiled identifier node returning bool2941 (depth = 7)
  gc_frame_newslot(bool2941);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call2939;
  params[2] = bool2940;
  params[3] = bool2941;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2942 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2937);
// compiled call node returning call2942 (depth = 6)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2943 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe2944 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2945 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2944);
// compiled member node returning call2945 (depth = 7)
  gc_frame_newslot(call2945);
// starting to compile identifier node (depth = 7)
  Object bool2946 = alloc_Boolean(1);
// compiled identifier node returning bool2946 (depth = 7)
  gc_frame_newslot(bool2946);
// starting to compile identifier node (depth = 7)
  Object bool2947 = alloc_Boolean(0);
// compiled identifier node returning bool2947 (depth = 7)
  gc_frame_newslot(bool2947);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call2945;
  params[1] = bool2946;
  params[2] = bool2947;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2948 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2943);
// compiled call node returning call2948 (depth = 6)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2949 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call2950 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2949);
// compiled call node returning call2950 (depth = 6)
    gc_frame_newslot(call2950);
    if2923 = call2950;
  } else {
  }
// compiled if node returning if2923 (depth = 5)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2951 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2952 == NULL) {
    strlit2952 = alloc_String("a prefix operator must be followed by an expression.");
    gc_root(strlit2952);
  }
// compiled string node returning strlit2952 (depth = 6)
  gc_frame_newslot(strlit2952);
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2954 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2953);
// compiled member node returning call2954 (depth = 6)
  gc_frame_newslot(call2954);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2957 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2956);
// compiled member node returning call2957 (depth = 7)
  int op_slot_right_2955 = gc_frame_newslot(call2957);
// starting to compile member node (depth = 7)
  int callframe2959 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2960 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2959);
// compiled member node returning call2960 (depth = 7)
  int op_slot_left_2955 = gc_frame_newslot(call2960);
  params[0] = call2957;
  partcv[0] = 1;
  Object sum2961 = callmethod(call2960, "+(1)", 1, partcv, params);
// compiled op node returning sum2961 (depth = 6)
  gc_frame_newslot(sum2961);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2952;
  params[1] = call2954;
  params[2] = sum2961;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2962 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2951);
// compiled call node returning call2962 (depth = 5)
    gc_frame_newslot(call2962);
    if2890 = call2962;
  } else {
  }
// compiled if node returning if2890 (depth = 4)
    gc_frame_newslot(if2890);
    if2817 = if2890;
  }
// compiled if node returning if2817 (depth = 3)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2963 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2964 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2963);
// compiled call node returning call2964 (depth = 3)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2965 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2966 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2965);
// compiled call node returning call2966 (depth = 3)
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call2968 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2967);
// compiled member node returning call2968 (depth = 4)
  *var_rcvr = call2968;
  if (call2968 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2969 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rcvr (depth = 5)
  gc_frame_newslot(*var_rcvr);
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array2970 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe2971 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_op (depth = 8)
  int op_slot_right_2972 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 8)
  if (strlit2974 == NULL) {
    strlit2974 = alloc_String("prefix");
    gc_root(strlit2974);
  }
// compiled string node returning strlit2974 (depth = 8)
  int op_slot_left_2972 = gc_frame_newslot(strlit2974);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult2975 = callmethod(strlit2974, "++(1)", 1, partcv, params);
// compiled op node returning opresult2975 (depth = 7)
  gc_frame_newslot(opresult2975);
// starting to compile array node (depth = 7)
  Object array2976 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2976 (depth = 7)
  gc_frame_newslot(array2976);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call2978 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe2977);
// compiled member node returning call2978 (depth = 7)
  params[0] = opresult2975;
  params[1] = array2976;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2979 = callmethodflags(call2978, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2971);
// compiled call node returning call2979 (depth = 6)
  params[0] = call2979;
  partcv[0] = 1;
  callmethodflags(array2970, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2970 (depth = 5)
  gc_frame_newslot(array2970);
// call case 6: other requests
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2980 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call2981 = callmethodflags(*var_ast, "callNode", 0, partcv, params, 0);
  gc_frame_end(callframe2980);
// compiled member node returning call2981 (depth = 5)
  params[0] = *var_rcvr;
  params[1] = array2970;
  partcv[0] = 2;
  Object call2982 = callmethodflags(call2981, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2969);
// compiled call node returning call2982 (depth = 4)
  *var_call = call2982;
  if (call2982 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2983 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call2984 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2983);
// compiled call node returning call2984 (depth = 3)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if2809 = done;
  } else {
  }
// compiled if node returning if2809 (depth = 2)
  gc_frame_end(frame);
  return if2809;
}
Object meth_parser_2998__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe2999 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3000 == NULL) {
    strlit3000 = alloc_String("identifier");
    gc_root(strlit3000);
  }
// compiled string node returning strlit3000 (depth = 6)
  gc_frame_newslot(strlit3000);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3000;
  partcv[0] = 1;
  Object call3001 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2999);
// compiled call node returning call3001 (depth = 5)
  gc_frame_end(frame);
  return call3001;
}
Object meth_parser_3009__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe3010 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3011 == NULL) {
    strlit3011 = alloc_String("dot");
    gc_root(strlit3011);
  }
// compiled string node returning strlit3011 (depth = 8)
  gc_frame_newslot(strlit3011);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit3011;
  partcv[0] = 1;
  Object call3012 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3010);
// compiled call node returning call3012 (depth = 7)
  gc_frame_end(frame);
  return call3012;
}
Object meth_parser_3015__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3016 = gc_frame_new();
// call case 4: self request
  Object call3017 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3016);
// compiled member node returning call3017 (depth = 7)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call3019 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3018);
// compiled member node returning call3019 (depth = 8)
  *var_memberIn = call3019;
  if (call3019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3022 == NULL) {
    strlit3022 = alloc_String("identifier");
    gc_root(strlit3022);
  }
// compiled string node returning strlit3022 (depth = 9)
  int op_slot_right_3021 = gc_frame_newslot(strlit3022);
// starting to compile member node (depth = 9)
  int callframe3024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call3025 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3024);
// compiled member node returning call3025 (depth = 9)
  int op_slot_left_3021 = gc_frame_newslot(call3025);
  params[0] = strlit3022;
  partcv[0] = 1;
  Object opresult3026 = callmethod(call3025, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3026 (depth = 8)
  Object if3020 = done;
  if (istrue(opresult3026)) {
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array3027 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3027 (depth = 9)
  *var_suggestions = array3027;
  if (array3027 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3028 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3029 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3030 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3029);
// compiled member node returning call3030 (depth = 10)
  Object call3031 = callmethodflags(call3030, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3028);
// compiled member node returning call3031 (depth = 9)
  *var_suggestion = call3031;
  if (call3031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3032 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3033 == NULL) {
    strlit3033 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3033);
  }
// compiled string node returning strlit3033 (depth = 9)
  gc_frame_newslot(strlit3033);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3033;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3034 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3032);
// compiled call node returning call3034 (depth = 8)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3035 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3036 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3035);
// compiled call node returning call3036 (depth = 8)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3037 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3038 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3039 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3038);
// compiled member node returning call3039 (depth = 10)
  Object call3040 = callmethodflags(call3039, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3037);
// compiled member node returning call3040 (depth = 9)
  *var_suggestion = call3040;
  if (call3040 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3042 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3043 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3042);
// compiled call node returning call3043 (depth = 8)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3044 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3045 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3044);
// compiled call node returning call3045 (depth = 8)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3046 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3047 == NULL) {
    strlit3047 = alloc_String("a type name must follow the '.'.");
    gc_root(strlit3047);
  }
// compiled string node returning strlit3047 (depth = 9)
  gc_frame_newslot(strlit3047);
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe3048 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3049 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3048);
// compiled member node returning call3049 (depth = 9)
  gc_frame_newslot(call3049);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3051 = alloc_Float64(1);
// compiled num node returning num3051 (depth = 10)
  int op_slot_right_3050 = gc_frame_newslot(num3051);
// starting to compile member node (depth = 10)
  int callframe3053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call3054 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3053);
// compiled member node returning call3054 (depth = 10)
  int op_slot_left_3050 = gc_frame_newslot(call3054);
  params[0] = num3051;
  partcv[0] = 1;
  Object sum3055 = callmethod(call3054, "+(1)", 1, partcv, params);
// compiled op node returning sum3055 (depth = 9)
  gc_frame_newslot(sum3055);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3047;
  params[1] = call3049;
  params[2] = sum3055;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3056 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3046);
// compiled call node returning call3056 (depth = 8)
    gc_frame_newslot(call3056);
    if3020 = call3056;
  } else {
  }
// compiled if node returning if3020 (depth = 7)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3057 = gc_frame_new();
// call case 4: self request
  Object call3058 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3057);
// compiled member node returning call3058 (depth = 7)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call3060 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3059);
// compiled member node returning call3060 (depth = 8)
  *var_memberName = call3060;
  if (call3060 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3061 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe3062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  Object call3063 = callmethodflags(*var_memberName, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3062);
// compiled member node returning call3063 (depth = 9)
  gc_frame_newslot(call3063);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  Object call3065 = callmethodflags(*var_ast, "memberNode", 0, partcv, params, 0);
  gc_frame_end(callframe3064);
// compiled member node returning call3065 (depth = 9)
  params[0] = call3063;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3066 = callmethodflags(call3065, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3061);
// compiled call node returning call3066 (depth = 8)
  *var_memberNd = call3066;
  if (call3066 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3067 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  Object call3069 = callmethodflags(*var_memberName, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled member node returning call3069 (depth = 8)
  gc_frame_newslot(call3069);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3069;
  partcv[0] = 1;
  Object call3070 = callmethodflags(*var_memberNd, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3067);
// compiled call node returning call3070 (depth = 7)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3071 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  Object call3073 = callmethodflags(*var_memberName, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3072);
// compiled member node returning call3073 (depth = 8)
  gc_frame_newslot(call3073);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3073;
  partcv[0] = 1;
  Object call3074 = callmethodflags(*var_memberNd, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3071);
// compiled call node returning call3074 (depth = 7)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3075 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3076 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3075);
// compiled call node returning call3076 (depth = 7)
  gc_frame_end(frame);
  return call3076;
}
Object meth_parser_3004__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3005 = gc_frame_new();
// call case 4: self request
  Object call3006 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3005);
// compiled member node returning call3006 (depth = 5)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3007 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3008 = alloc_Block(NULL, NULL, "parser", 1080);
  gc_frame_newslot(block3008);
// method "_apply"
  block_savedest(block3008);
  Object closure3009 = createclosure(1, "_apply");
  setclosureframe(closure3009, stackframe);
  addtoclosure(closure3009, selfslot);
  struct UserObject *uo3009 = (struct UserObject*)block3008;
  uo3009->data[0] = (Object)closure3009;
  Method *meth_meth_parser_3009__apply = addmethod2pos(block3008, "_apply", &meth_parser_3009__apply, 0);
  int argcv_meth_parser_3009__apply[] = {0};
  meth_meth_parser_3009__apply->type = alloc_MethodType(1, argcv_meth_parser_3009__apply);
  meth_meth_parser_3009__apply->definitionModule = modulename;
  meth_meth_parser_3009__apply->definitionLine = 3208;
// compiled block node returning block3008 (depth = 6)
  gc_frame_newslot(block3008);
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block3014 = alloc_Block(NULL, NULL, "parser", 1080);
  gc_frame_newslot(block3014);
// method "_apply"
  block_savedest(block3014);
  Object closure3015 = createclosure(6, "_apply");
  setclosureframe(closure3015, stackframe);
  addtoclosure(closure3015, var_values);
  addtoclosure(closure3015, var_sym);
  addtoclosure(closure3015, var_errormessages);
  addtoclosure(closure3015, var_lastToken);
  addtoclosure(closure3015, var_ast);
  addtoclosure(closure3015, selfslot);
  struct UserObject *uo3015 = (struct UserObject*)block3014;
  uo3015->data[0] = (Object)closure3015;
  Method *meth_meth_parser_3015__apply = addmethod2pos(block3014, "_apply", &meth_parser_3015__apply, 0);
  int argcv_meth_parser_3015__apply[] = {0};
  meth_meth_parser_3015__apply->type = alloc_MethodType(1, argcv_meth_parser_3015__apply);
  meth_meth_parser_3015__apply->definitionModule = modulename;
  meth_meth_parser_3015__apply->definitionLine = 3208;
// compiled block node returning block3014 (depth = 6)
  gc_frame_newslot(block3014);
// call case 5: prelude request
  params[0] = block3008;
  params[1] = block3014;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3078 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3007);
// compiled call node returning call3078 (depth = 5)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3079 = gc_frame_new();
// call case 4: self request
  Object call3080 = callmethodflags(self, "generic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3079);
// compiled member node returning call3080 (depth = 5)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3081 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3082 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call3083 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3082);
// compiled member node returning call3083 (depth = 6)
  gc_frame_newslot(call3083);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3083;
  partcv[0] = 1;
  Object call3084 = callmethodflags(*var_gens, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3081);
// compiled call node returning call3084 (depth = 5)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3086 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3087 == NULL) {
    strlit3087 = alloc_String("comma");
    gc_root(strlit3087);
  }
// compiled string node returning strlit3087 (depth = 7)
  gc_frame_newslot(strlit3087);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit3087;
  partcv[0] = 1;
  Object call3088 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3086);
// compiled call node returning call3088 (depth = 6)
  Object if3085 = done;
  if (istrue(call3088)) {
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3089 = gc_frame_new();
// call case 4: self request
  Object call3090 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3089);
// compiled member node returning call3090 (depth = 6)
    gc_frame_newslot(call3090);
    if3085 = call3090;
  } else {
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3093 == NULL) {
    strlit3093 = alloc_String("rgeneric");
    gc_root(strlit3093);
  }
// compiled string node returning strlit3093 (depth = 8)
  int op_slot_right_3092 = gc_frame_newslot(strlit3093);
// starting to compile member node (depth = 8)
  int callframe3095 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3096 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3095);
// compiled member node returning call3096 (depth = 8)
  int op_slot_left_3092 = gc_frame_newslot(call3096);
  params[0] = strlit3093;
  partcv[0] = 1;
  Object opresult3097 = callmethod(call3096, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3097 (depth = 7)
  Object if3091 = done;
  if (istrue(opresult3097)) {
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3098 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3099 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3100 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3099);
// compiled member node returning call3100 (depth = 9)
  Object call3101 = callmethodflags(call3100, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3098);
// compiled member node returning call3101 (depth = 8)
  *var_suggestion = call3101;
  if (call3101 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3102 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3103 == NULL) {
    strlit3103 = alloc_String(">");
    gc_root(strlit3103);
  }
// compiled string node returning strlit3103 (depth = 8)
  gc_frame_newslot(strlit3103);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3103;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3104 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3102);
// compiled call node returning call3104 (depth = 7)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3105 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3106 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3107 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3106);
// compiled member node returning call3107 (depth = 9)
  Object call3108 = callmethodflags(call3107, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3105);
// compiled member node returning call3108 (depth = 8)
  *var_suggestion2 = call3108;
  if (call3108 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3109 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3110 == NULL) {
    strlit3110 = alloc_String(" ");
    gc_root(strlit3110);
  }
// compiled string node returning strlit3110 (depth = 8)
  gc_frame_newslot(strlit3110);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3110;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3111 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3109);
// compiled call node returning call3111 (depth = 7)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3112 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3112, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3112, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3112 (depth = 8)
  *var_suggestions = array3112;
  if (array3112 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3113 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3114 == NULL) {
    strlit3114 = alloc_String("a type containing a '""\xe2""""\x9f""""\xa6""' must end with a '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit3114);
  }
// compiled string node returning strlit3114 (depth = 8)
  gc_frame_newslot(strlit3114);
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3116 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3115);
// compiled member node returning call3116 (depth = 8)
  gc_frame_newslot(call3116);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3118 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3119 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3118);
// compiled member node returning call3119 (depth = 9)
  int op_slot_right_3117 = gc_frame_newslot(call3119);
// starting to compile member node (depth = 9)
  int callframe3121 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3122 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3121);
// compiled member node returning call3122 (depth = 9)
  int op_slot_left_3117 = gc_frame_newslot(call3122);
  params[0] = call3119;
  partcv[0] = 1;
  Object sum3123 = callmethod(call3122, "+(1)", 1, partcv, params);
// compiled op node returning sum3123 (depth = 8)
  gc_frame_newslot(sum3123);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3114;
  params[1] = call3116;
  params[2] = sum3123;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3124 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3113);
// compiled call node returning call3124 (depth = 7)
    gc_frame_newslot(call3124);
    if3091 = call3124;
  } else {
  }
// compiled if node returning if3091 (depth = 6)
    gc_frame_newslot(if3091);
    if3085 = if3091;
  }
// compiled if node returning if3085 (depth = 5)
  gc_frame_end(frame);
  return if3085;
}
Object meth_parser_2986_generic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// definebindings:
// definebindings:
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2988 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2989 == NULL) {
    strlit2989 = alloc_String("lgeneric");
    gc_root(strlit2989);
  }
// compiled string node returning strlit2989 (depth = 4)
  gc_frame_newslot(strlit2989);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit2989;
  partcv[0] = 1;
  Object call2990 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2988);
// compiled call node returning call2990 (depth = 3)
  Object if2987 = done;
  if (istrue(call2990)) {
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2991 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call2992 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2991);
// compiled member node returning call2992 (depth = 4)
  *var_id = call2992;
  if (call2992 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2993 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2993 (depth = 4)
  *var_gens = array2993;
  if (array2993 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2994 = gc_frame_new();
// call case 4: self request
  Object call2995 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2994);
// compiled member node returning call2995 (depth = 3)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2996 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2997 = alloc_Block(NULL, NULL, "parser", 1078);
  gc_frame_newslot(block2997);
// method "_apply"
  block_savedest(block2997);
  Object closure2998 = createclosure(1, "_apply");
  setclosureframe(closure2998, stackframe);
  addtoclosure(closure2998, selfslot);
  struct UserObject *uo2998 = (struct UserObject*)block2997;
  uo2998->data[0] = (Object)closure2998;
  Method *meth_meth_parser_2998__apply = addmethod2pos(block2997, "_apply", &meth_parser_2998__apply, 0);
  int argcv_meth_parser_2998__apply[] = {0};
  meth_meth_parser_2998__apply->type = alloc_MethodType(1, argcv_meth_parser_2998__apply);
  meth_meth_parser_2998__apply->definitionModule = modulename;
  meth_meth_parser_2998__apply->definitionLine = 3208;
// compiled block node returning block2997 (depth = 4)
  gc_frame_newslot(block2997);
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block3003 = alloc_Block(NULL, NULL, "parser", 1078);
  gc_frame_newslot(block3003);
// method "_apply"
  block_savedest(block3003);
  Object closure3004 = createclosure(8, "_apply");
  setclosureframe(closure3004, stackframe);
  addtoclosure(closure3004, var_values);
  addtoclosure(closure3004, var_sym);
  addtoclosure(closure3004, var_errormessages);
  addtoclosure(closure3004, var_lastToken);
  addtoclosure(closure3004, var_ast);
  addtoclosure(closure3004, var_gens);
  addtoclosure(closure3004, var_startToken);
  addtoclosure(closure3004, selfslot);
  struct UserObject *uo3004 = (struct UserObject*)block3003;
  uo3004->data[0] = (Object)closure3004;
  Method *meth_meth_parser_3004__apply = addmethod2pos(block3003, "_apply", &meth_parser_3004__apply, 0);
  int argcv_meth_parser_3004__apply[] = {0};
  meth_meth_parser_3004__apply->type = alloc_MethodType(1, argcv_meth_parser_3004__apply);
  meth_meth_parser_3004__apply->definitionModule = modulename;
  meth_meth_parser_3004__apply->definitionLine = 3208;
// compiled block node returning block3003 (depth = 4)
  gc_frame_newslot(block3003);
// call case 5: prelude request
  params[0] = block2997;
  params[1] = block3003;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3126 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call3126 (depth = 3)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3129 == NULL) {
    strlit3129 = alloc_String("rgeneric");
    gc_root(strlit3129);
  }
// compiled string node returning strlit3129 (depth = 5)
  int op_slot_right_3128 = gc_frame_newslot(strlit3129);
// starting to compile member node (depth = 5)
  int callframe3131 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3132 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3131);
// compiled member node returning call3132 (depth = 5)
  int op_slot_left_3128 = gc_frame_newslot(call3132);
  params[0] = strlit3129;
  partcv[0] = 1;
  Object opresult3133 = callmethod(call3132, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3133 (depth = 4)
  Object if3127 = done;
  if (istrue(opresult3133)) {
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3134 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3135 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3136 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3135);
// compiled member node returning call3136 (depth = 6)
  Object call3137 = callmethodflags(call3136, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3134);
// compiled member node returning call3137 (depth = 5)
  *var_suggestion = call3137;
  if (call3137 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3138 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3139 == NULL) {
    strlit3139 = alloc_String(">");
    gc_root(strlit3139);
  }
// compiled string node returning strlit3139 (depth = 5)
  gc_frame_newslot(strlit3139);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3139;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3140 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3138);
// compiled call node returning call3140 (depth = 4)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3141 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3142 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3143 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3142);
// compiled member node returning call3143 (depth = 6)
  Object call3144 = callmethodflags(call3143, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3141);
// compiled member node returning call3144 (depth = 5)
  *var_suggestion2 = call3144;
  if (call3144 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3145 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3146 == NULL) {
    strlit3146 = alloc_String(" ");
    gc_root(strlit3146);
  }
// compiled string node returning strlit3146 (depth = 5)
  gc_frame_newslot(strlit3146);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3146;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3147 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3145);
// compiled call node returning call3147 (depth = 4)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3148 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3148, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3148, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3148 (depth = 5)
  *var_suggestions = array3148;
  if (array3148 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3149 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3150 == NULL) {
    strlit3150 = alloc_String("a type containing a '""\xe2""""\x9f""""\xa6""' must end with a '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit3150);
  }
// compiled string node returning strlit3150 (depth = 5)
  gc_frame_newslot(strlit3150);
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3151 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3152 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3151);
// compiled member node returning call3152 (depth = 5)
  gc_frame_newslot(call3152);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3154 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3155 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3154);
// compiled member node returning call3155 (depth = 6)
  int op_slot_right_3153 = gc_frame_newslot(call3155);
// starting to compile member node (depth = 6)
  int callframe3157 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3158 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3157);
// compiled member node returning call3158 (depth = 6)
  int op_slot_left_3153 = gc_frame_newslot(call3158);
  params[0] = call3155;
  partcv[0] = 1;
  Object sum3159 = callmethod(call3158, "+(1)", 1, partcv, params);
// compiled op node returning sum3159 (depth = 5)
  gc_frame_newslot(sum3159);
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3150;
  params[1] = call3152;
  params[2] = sum3159;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3160 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3149);
// compiled call node returning call3160 (depth = 4)
    gc_frame_newslot(call3160);
    if3127 = call3160;
  } else {
  }
// compiled if node returning if3127 (depth = 3)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3161 = gc_frame_new();
// call case 4: self request
  Object call3162 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3161);
// compiled member node returning call3162 (depth = 3)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3163 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3164 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call3166 = callmethodflags(*var_ast, "genericNode", 0, partcv, params, 0);
  gc_frame_end(callframe3165);
// compiled member node returning call3166 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3167 = callmethodflags(call3166, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3164);
// compiled call node returning call3167 (depth = 4)
  gc_frame_newslot(call3167);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3167;
  partcv[0] = 1;
  Object call3168 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3163);
// compiled call node returning call3168 (depth = 3)
    gc_frame_newslot(call3168);
    if2987 = call3168;
  } else {
  }
// compiled if node returning if2987 (depth = 2)
  gc_frame_end(frame);
  return if2987;
}
Object meth_parser_3174__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3176 == NULL) {
    strlit3176 = alloc_String("try");
    gc_root(strlit3176);
  }
// compiled string node returning strlit3176 (depth = 7)
  int op_slot_right_3175 = gc_frame_newslot(strlit3176);
// starting to compile member node (depth = 7)
  int callframe3178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3179 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3178);
// compiled member node returning call3179 (depth = 7)
  int op_slot_left_3175 = gc_frame_newslot(call3179);
  params[0] = strlit3176;
  partcv[0] = 1;
  Object opresult3180 = callmethod(call3179, "==(1)", 1, partcv, params);
// compiled op node returning opresult3180 (depth = 6)
  gc_frame_end(frame);
  return opresult3180;
}
Object meth_parser_3209__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_tryTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3213 == NULL) {
    strlit3213 = alloc_String("catch");
    gc_root(strlit3213);
  }
// compiled string node returning strlit3213 (depth = 10)
  int op_slot_right_3212 = gc_frame_newslot(strlit3213);
// starting to compile member node (depth = 10)
  int callframe3215 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3216 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3215);
// compiled member node returning call3216 (depth = 10)
  int op_slot_left_3212 = gc_frame_newslot(call3216);
  params[0] = strlit3213;
  partcv[0] = 1;
  Object opresult3217 = callmethod(call3216, "==(1)", 1, partcv, params);
// compiled op node returning opresult3217 (depth = 9)
  int op_slot_right_3211 = gc_frame_newslot(opresult3217);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3220 == NULL) {
    strlit3220 = alloc_String("identifier");
    gc_root(strlit3220);
  }
// compiled string node returning strlit3220 (depth = 10)
  int op_slot_right_3219 = gc_frame_newslot(strlit3220);
// starting to compile member node (depth = 10)
  int callframe3222 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3223 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3222);
// compiled member node returning call3223 (depth = 10)
  int op_slot_left_3219 = gc_frame_newslot(call3223);
  params[0] = strlit3220;
  partcv[0] = 1;
  Object opresult3224 = callmethod(call3223, "==(1)", 1, partcv, params);
// compiled op node returning opresult3224 (depth = 9)
  int op_slot_left_3211 = gc_frame_newslot(opresult3224);
  params[0] = opresult3217;
  partcv[0] = 1;
  Object opresult3225 = callmethod(opresult3224, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3225 (depth = 8)
  int op_slot_right_3210 = gc_frame_newslot(opresult3225);
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3230 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tryTok (depth = 12)
  Object call3231 = callmethodflags(*var_tryTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3230);
// compiled member node returning call3231 (depth = 11)
  int op_slot_right_3229 = gc_frame_newslot(call3231);
// starting to compile member node (depth = 11)
  int callframe3233 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call3234 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3233);
// compiled member node returning call3234 (depth = 11)
  int op_slot_left_3229 = gc_frame_newslot(call3234);
  params[0] = call3231;
  partcv[0] = 1;
  Object opresult3235 = callmethod(call3234, "==(1)", 1, partcv, params);
// compiled op node returning opresult3235 (depth = 10)
  int op_slot_right_3228 = gc_frame_newslot(opresult3235);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3238 == NULL) {
    strlit3238 = alloc_String("rparen");
    gc_root(strlit3238);
  }
// compiled string node returning strlit3238 (depth = 11)
  int op_slot_right_3237 = gc_frame_newslot(strlit3238);
// starting to compile member node (depth = 11)
  int callframe3240 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call3241 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3240);
// compiled member node returning call3241 (depth = 11)
  int op_slot_left_3237 = gc_frame_newslot(call3241);
  params[0] = strlit3238;
  partcv[0] = 1;
  Object opresult3242 = callmethod(call3241, "==(1)", 1, partcv, params);
// compiled op node returning opresult3242 (depth = 10)
  int op_slot_left_3228 = gc_frame_newslot(opresult3242);
  params[0] = opresult3235;
  partcv[0] = 1;
  Object opresult3243 = callmethod(opresult3242, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3243 (depth = 9)
  int op_slot_right_3227 = gc_frame_newslot(opresult3243);
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3246 == NULL) {
    strlit3246 = alloc_String("rbrace");
    gc_root(strlit3246);
  }
// compiled string node returning strlit3246 (depth = 10)
  int op_slot_right_3245 = gc_frame_newslot(strlit3246);
// starting to compile member node (depth = 10)
  int callframe3248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3249 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3248);
// compiled member node returning call3249 (depth = 10)
  int op_slot_left_3245 = gc_frame_newslot(call3249);
  params[0] = strlit3246;
  partcv[0] = 1;
  Object opresult3250 = callmethod(call3249, "==(1)", 1, partcv, params);
// compiled op node returning opresult3250 (depth = 9)
  int op_slot_left_3227 = gc_frame_newslot(opresult3250);
  params[0] = opresult3243;
  partcv[0] = 1;
  Object opresult3251 = callmethod(opresult3250, "||(1)", 1, partcv, params);
// compiled op node returning opresult3251 (depth = 8)
  int op_slot_left_3210 = gc_frame_newslot(opresult3251);
  params[0] = opresult3225;
  partcv[0] = 1;
  Object opresult3252 = callmethod(opresult3251, "||(1)", 1, partcv, params);
// compiled op node returning opresult3252 (depth = 7)
  gc_frame_end(frame);
  return opresult3252;
}
Object meth_parser_3325__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe3326 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3327 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3326);
// compiled call node returning call3327 (depth = 6)
  gc_frame_end(frame);
  return call3327;
}
Object meth_parser_3399__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3402 == NULL) {
    strlit3402 = alloc_String("catch");
    gc_root(strlit3402);
  }
// compiled string node returning strlit3402 (depth = 6)
  int op_slot_right_3401 = gc_frame_newslot(strlit3402);
// starting to compile member node (depth = 6)
  int callframe3404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3405 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3404);
// compiled member node returning call3405 (depth = 6)
  int op_slot_left_3401 = gc_frame_newslot(call3405);
  params[0] = strlit3402;
  partcv[0] = 1;
  Object opresult3406 = callmethod(call3405, "==(1)", 1, partcv, params);
// compiled op node returning opresult3406 (depth = 5)
  int op_slot_right_3400 = gc_frame_newslot(opresult3406);
// starting to compile call node (depth = 5)
  int callframe3408 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3409 == NULL) {
    strlit3409 = alloc_String("identifier");
    gc_root(strlit3409);
  }
// compiled string node returning strlit3409 (depth = 6)
  gc_frame_newslot(strlit3409);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3409;
  partcv[0] = 1;
  Object call3410 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3408);
// compiled call node returning call3410 (depth = 5)
  int op_slot_left_3400 = gc_frame_newslot(call3410);
  params[0] = opresult3406;
  partcv[0] = 1;
  Object opresult3411 = callmethod(call3410, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3411 (depth = 4)
  gc_frame_end(frame);
  return opresult3411;
}
Object meth_parser_3432__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe3433 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3434 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled call node returning call3434 (depth = 9)
  gc_frame_end(frame);
  return call3434;
}
Object meth_parser_3414__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3415 = gc_frame_new();
// call case 4: self request
  Object call3416 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3415);
// compiled member node returning call3416 (depth = 4)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3418 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3419 == NULL) {
    strlit3419 = alloc_String("lbrace");
    gc_root(strlit3419);
  }
// compiled string node returning strlit3419 (depth = 6)
  gc_frame_newslot(strlit3419);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3419;
  partcv[0] = 1;
  Object call3420 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3418);
// compiled call node returning call3420 (depth = 5)
  Object if3417 = done;
  if (istrue(call3420)) {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3421 = gc_frame_new();
// call case 4: self request
  Object call3422 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3421);
// compiled member node returning call3422 (depth = 5)
    gc_frame_newslot(call3422);
    if3417 = call3422;
  } else {
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3424 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3425 == NULL) {
    strlit3425 = alloc_String("lparen");
    gc_root(strlit3425);
  }
// compiled string node returning strlit3425 (depth = 7)
  gc_frame_newslot(strlit3425);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit3425;
  partcv[0] = 1;
  Object call3426 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compiled call node returning call3426 (depth = 6)
  Object if3423 = done;
  if (istrue(call3426)) {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3427 = gc_frame_new();
// call case 4: self request
  Object call3428 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3427);
// compiled member node returning call3428 (depth = 6)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3430 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3431 = alloc_Block(NULL, NULL, "parser", 1199);
  gc_frame_newslot(block3431);
// method "_apply"
  block_savedest(block3431);
  Object closure3432 = createclosure(2, "_apply");
  setclosureframe(closure3432, stackframe);
  addtoclosure(closure3432, var_blocksOK);
  addtoclosure(closure3432, selfslot);
  struct UserObject *uo3432 = (struct UserObject*)block3431;
  uo3432->data[0] = (Object)closure3432;
  Method *meth_meth_parser_3432__apply = addmethod2pos(block3431, "_apply", &meth_parser_3432__apply, 0);
  int argcv_meth_parser_3432__apply[] = {0};
  meth_meth_parser_3432__apply->type = alloc_MethodType(1, argcv_meth_parser_3432__apply);
  meth_meth_parser_3432__apply->definitionModule = modulename;
  meth_meth_parser_3432__apply->definitionLine = 3208;
// compiled block node returning block3431 (depth = 8)
  gc_frame_newslot(block3431);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block3431;
  partcv[0] = 1;
  Object call3436 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3430);
// compiled call node returning call3436 (depth = 7)
  Object if3429 = done;
  if (istrue(call3436)) {
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3437 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3439 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3438);
// compiled member node returning call3439 (depth = 9)
  Object call3440 = callmethodflags(call3439, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3437);
// compiled member node returning call3440 (depth = 8)
  *var_suggestion = call3440;
  if (call3440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3441 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array3442 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit3443 == NULL) {
    strlit3443 = alloc_String("rparen");
    gc_root(strlit3443);
  }
// compiled string node returning strlit3443 (depth = 10)
  params[0] = strlit3443;
  partcv[0] = 1;
  callmethodflags(array3442, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3442 (depth = 9)
  gc_frame_newslot(array3442);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array3442;
  partcv[0] = 1;
  Object call3444 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3441);
// compiled call node returning call3444 (depth = 8)
  *var_nextTok = call3444;
  if (call3444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3446 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3446 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3448 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3448 (depth = 8)
  Object if3445 = done;
  if (istrue(opresult3448)) {
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3449 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3450 == NULL) {
    strlit3450 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3450);
  }
// compiled string node returning strlit3450 (depth = 9)
  gc_frame_newslot(strlit3450);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3450;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3451 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3449);
// compiled call node returning call3451 (depth = 8)
    gc_frame_newslot(call3451);
    if3445 = call3451;
  } else {
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3452 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe3453 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3454 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3453);
// compiled member node returning call3454 (depth = 9)
  gc_frame_newslot(call3454);
// starting to compile identifier node (depth = 9)
  Object bool3455 = alloc_Boolean(1);
// compiled identifier node returning bool3455 (depth = 9)
  gc_frame_newslot(bool3455);
// starting to compile identifier node (depth = 9)
  Object bool3456 = alloc_Boolean(0);
// compiled identifier node returning bool3456 (depth = 9)
  gc_frame_newslot(bool3456);
// starting to compile string node (depth = 9)
  if (strlit3457 == NULL) {
    strlit3457 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3457);
  }
// compiled string node returning strlit3457 (depth = 9)
  gc_frame_newslot(strlit3457);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3454;
  params[2] = bool3455;
  params[3] = bool3456;
  params[4] = strlit3457;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3458 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3452);
// compiled call node returning call3458 (depth = 8)
    gc_frame_newslot(call3458);
    if3445 = call3458;
  }
// compiled if node returning if3445 (depth = 7)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3459 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3460 == NULL) {
    strlit3460 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3460);
  }
// compiled string node returning strlit3460 (depth = 8)
  gc_frame_newslot(strlit3460);
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3462 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3461);
// compiled member node returning call3462 (depth = 8)
  gc_frame_newslot(call3462);
// starting to compile member node (depth = 8)
  int callframe3463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3464 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3463);
// compiled member node returning call3464 (depth = 8)
  gc_frame_newslot(call3464);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3460;
  params[1] = call3462;
  params[2] = call3464;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3465 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3459);
// compiled call node returning call3465 (depth = 7)
    gc_frame_newslot(call3465);
    if3429 = call3465;
  } else {
  }
// compiled if node returning if3429 (depth = 6)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3468 == NULL) {
    strlit3468 = alloc_String("rparen");
    gc_root(strlit3468);
  }
// compiled string node returning strlit3468 (depth = 8)
  int op_slot_right_3467 = gc_frame_newslot(strlit3468);
// starting to compile member node (depth = 8)
  int callframe3470 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3471 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3470);
// compiled member node returning call3471 (depth = 8)
  int op_slot_left_3467 = gc_frame_newslot(call3471);
  params[0] = strlit3468;
  partcv[0] = 1;
  Object opresult3472 = callmethod(call3471, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3472 (depth = 7)
  Object if3466 = done;
  if (istrue(opresult3472)) {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3473 = gc_frame_new();
// call case 4: self request
  Object call3474 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3473);
// compiled member node returning call3474 (depth = 7)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3475 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3477 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3476);
// compiled member node returning call3477 (depth = 9)
  Object call3478 = callmethodflags(call3477, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3475);
// compiled member node returning call3478 (depth = 8)
  *var_suggestion = call3478;
  if (call3478 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3479 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3480 == NULL) {
    strlit3480 = alloc_String(")");
    gc_root(strlit3480);
  }
// compiled string node returning strlit3480 (depth = 8)
  gc_frame_newslot(strlit3480);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3480;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3481 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3479);
// compiled call node returning call3481 (depth = 7)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3482 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3483 == NULL) {
    strlit3483 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3483);
  }
// compiled string node returning strlit3483 (depth = 8)
  gc_frame_newslot(strlit3483);
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3484 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3485 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3484);
// compiled member node returning call3485 (depth = 8)
  gc_frame_newslot(call3485);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3487 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3488 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3487);
// compiled member node returning call3488 (depth = 9)
  int op_slot_right_3486 = gc_frame_newslot(call3488);
// starting to compile member node (depth = 9)
  int callframe3490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3491 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3490);
// compiled member node returning call3491 (depth = 9)
  int op_slot_left_3486 = gc_frame_newslot(call3491);
  params[0] = call3488;
  partcv[0] = 1;
  Object sum3492 = callmethod(call3491, "+(1)", 1, partcv, params);
// compiled op node returning sum3492 (depth = 8)
  gc_frame_newslot(sum3492);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3483;
  params[1] = call3485;
  params[2] = sum3492;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3493 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3482);
// compiled call node returning call3493 (depth = 7)
    gc_frame_newslot(call3493);
    if3466 = call3493;
  } else {
  }
// compiled if node returning if3466 (depth = 6)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3494 = gc_frame_new();
// call case 4: self request
  Object call3495 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3494);
// compiled member node returning call3495 (depth = 6)
    gc_frame_newslot(call3495);
    if3423 = call3495;
  } else {
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array3496 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3496 (depth = 7)
  *var_suggestions = array3496;
  if (array3496 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3497 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3498 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3497);
// compiled call node returning call3498 (depth = 7)
  *var_nextTok = call3498;
  if (call3498 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3499 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3501 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3500);
// compiled member node returning call3501 (depth = 8)
  Object call3502 = callmethodflags(call3501, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3499);
// compiled member node returning call3502 (depth = 7)
  *var_suggestion = call3502;
  if (call3502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_3504 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool3506 = alloc_Boolean(0);
// compiled identifier node returning bool3506 (depth = 8)
  int op_slot_left_3504 = gc_frame_newslot(bool3506);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3507 = callmethod(bool3506, "==(1)", 1, partcv, params);
// compiled op node returning opresult3507 (depth = 7)
  Object if3503 = done;
  if (istrue(opresult3507)) {
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3508 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3509 == NULL) {
    strlit3509 = alloc_String(" }");
    gc_root(strlit3509);
  }
// compiled string node returning strlit3509 (depth = 8)
  gc_frame_newslot(strlit3509);
// starting to compile member node (depth = 8)
  int callframe3510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call3511 = callmethodflags(*var_tokens, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3510);
// compiled member node returning call3511 (depth = 8)
  gc_frame_newslot(call3511);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3509;
  params[1] = call3511;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3512 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3508);
// compiled call node returning call3512 (depth = 7)
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3513 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3514 == NULL) {
    strlit3514 = alloc_String(" {");
    gc_root(strlit3514);
  }
// compiled string node returning strlit3514 (depth = 8)
  gc_frame_newslot(strlit3514);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3514;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3515 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3513);
// compiled call node returning call3515 (depth = 7)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3516 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3517 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3516);
// compiled call node returning call3517 (depth = 7)
    gc_frame_newslot(call3517);
    if3503 = call3517;
  } else {
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3519 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3519 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3521 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3521 (depth = 8)
  Object if3518 = done;
  if (istrue(opresult3521)) {
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3522 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3523 == NULL) {
    strlit3523 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3523);
  }
// compiled string node returning strlit3523 (depth = 9)
  gc_frame_newslot(strlit3523);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3523;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3524 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3522);
// compiled call node returning call3524 (depth = 8)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3525 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3526 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3525);
// compiled call node returning call3526 (depth = 8)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3529 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3528);
// compiled member node returning call3529 (depth = 10)
  Object call3530 = callmethodflags(call3529, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3527);
// compiled member node returning call3530 (depth = 9)
  *var_suggestion = call3530;
  if (call3530 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3532 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3533 == NULL) {
    strlit3533 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3533);
  }
// compiled string node returning strlit3533 (depth = 9)
  gc_frame_newslot(strlit3533);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3533;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3534 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3532);
// compiled call node returning call3534 (depth = 8)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3535 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3536 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3535);
// compiled call node returning call3536 (depth = 8)
    gc_frame_newslot(call3536);
    if3518 = call3536;
  } else {
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3537 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3538 == NULL) {
    strlit3538 = alloc_String(" }");
    gc_root(strlit3538);
  }
// compiled string node returning strlit3538 (depth = 9)
  gc_frame_newslot(strlit3538);
// starting to compile member node (depth = 9)
  int callframe3539 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3540 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3539);
// compiled member node returning call3540 (depth = 9)
  gc_frame_newslot(call3540);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3538;
  params[1] = call3540;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3541 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3537);
// compiled call node returning call3541 (depth = 8)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3542 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3543 == NULL) {
    strlit3543 = alloc_String(" {");
    gc_root(strlit3543);
  }
// compiled string node returning strlit3543 (depth = 9)
  gc_frame_newslot(strlit3543);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3543;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3544 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3542);
// compiled call node returning call3544 (depth = 8)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3545 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3546 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3545);
// compiled call node returning call3546 (depth = 8)
    gc_frame_newslot(call3546);
    if3518 = call3546;
  }
// compiled if node returning if3518 (depth = 7)
    gc_frame_newslot(if3518);
    if3503 = if3518;
  }
// compiled if node returning if3503 (depth = 6)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3547 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3548 == NULL) {
    strlit3548 = alloc_String("a try(_)catch(_) statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3548);
  }
// compiled string node returning strlit3548 (depth = 7)
  gc_frame_newslot(strlit3548);
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3550 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3549);
// compiled member node returning call3550 (depth = 7)
  gc_frame_newslot(call3550);
// starting to compile member node (depth = 7)
  int callframe3551 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3552 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3551);
// compiled member node returning call3552 (depth = 7)
  gc_frame_newslot(call3552);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3548;
  params[1] = call3550;
  params[2] = call3552;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3553 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3547);
// compiled call node returning call3553 (depth = 6)
    gc_frame_newslot(call3553);
    if3423 = call3553;
  }
// compiled if node returning if3423 (depth = 5)
    gc_frame_newslot(if3423);
    if3417 = if3423;
  }
// compiled if node returning if3417 (depth = 4)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3554 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3555 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call3556 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3555);
// compiled member node returning call3556 (depth = 5)
  gc_frame_newslot(call3556);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3556;
  partcv[0] = 1;
  Object call3557 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3554);
// compiled call node returning call3557 (depth = 4)
  gc_frame_end(frame);
  return call3557;
}
Object meth_parser_3631__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe3632 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3633 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3632);
// compiled call node returning call3633 (depth = 8)
  gc_frame_end(frame);
  return call3633;
}
Object meth_parser_3169_trycatch(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  Object *var_ast = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_tryTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tryTok");
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3171 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block3173 = alloc_Block(NULL, NULL, "parser", 1133);
  gc_frame_newslot(block3173);
// method "_apply"
  block_savedest(block3173);
  Object closure3174 = createclosure(2, "_apply");
  setclosureframe(closure3174, stackframe);
  addtoclosure(closure3174, var_sym);
  addtoclosure(closure3174, selfslot);
  struct UserObject *uo3174 = (struct UserObject*)block3173;
  uo3174->data[0] = (Object)closure3174;
  Method *meth_meth_parser_3174__apply = addmethod2pos(block3173, "_apply", &meth_parser_3174__apply, 0);
  int argcv_meth_parser_3174__apply[] = {0};
  meth_meth_parser_3174__apply->type = alloc_MethodType(1, argcv_meth_parser_3174__apply);
  meth_meth_parser_3174__apply->definitionModule = modulename;
  meth_meth_parser_3174__apply->definitionLine = 3208;
// compiled block node returning block3173 (depth = 5)
  int op_slot_right_3172 = gc_frame_newslot(block3173);
// starting to compile call node (depth = 5)
  int callframe3183 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3184 == NULL) {
    strlit3184 = alloc_String("identifier");
    gc_root(strlit3184);
  }
// compiled string node returning strlit3184 (depth = 6)
  gc_frame_newslot(strlit3184);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3184;
  partcv[0] = 1;
  Object call3185 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3183);
// compiled call node returning call3185 (depth = 5)
  int op_slot_left_3172 = gc_frame_newslot(call3185);
  params[0] = block3173;
  partcv[0] = 1;
  Object opresult3186 = callmethod(call3185, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3186 (depth = 4)
  partcv[0] = 0;
  Object call3187 = callmethodflags(opresult3186, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3171);
// compiled call node returning call3187 (depth = 3)
  Object if3170 = done;
  if (istrue(call3187)) {
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3170 = undefined;
  } else {
  }
// compiled if node returning if3170 (depth = 2)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_tryTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3188 = gc_frame_new();
// call case 4: self request
  Object call3189 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3188);
// compiled member node returning call3189 (depth = 2)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3191 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3192 == NULL) {
    strlit3192 = alloc_String("lbrace");
    gc_root(strlit3192);
  }
// compiled string node returning strlit3192 (depth = 4)
  gc_frame_newslot(strlit3192);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit3192;
  partcv[0] = 1;
  Object call3193 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3191);
// compiled call node returning call3193 (depth = 3)
  Object if3190 = done;
  if (istrue(call3193)) {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3194 = gc_frame_new();
// call case 4: self request
  Object call3195 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3194);
// compiled member node returning call3195 (depth = 3)
    gc_frame_newslot(call3195);
    if3190 = call3195;
  } else {
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3198 == NULL) {
    strlit3198 = alloc_String("lparen");
    gc_root(strlit3198);
  }
// compiled string node returning strlit3198 (depth = 5)
  int op_slot_right_3197 = gc_frame_newslot(strlit3198);
// starting to compile member node (depth = 5)
  int callframe3200 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3201 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3200);
// compiled member node returning call3201 (depth = 5)
  int op_slot_left_3197 = gc_frame_newslot(call3201);
  params[0] = strlit3198;
  partcv[0] = 1;
  Object opresult3202 = callmethod(call3201, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3202 (depth = 4)
  Object if3196 = done;
  if (istrue(opresult3202)) {
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3203 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3204 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3205 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3204);
// compiled member node returning call3205 (depth = 6)
  Object call3206 = callmethodflags(call3205, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3203);
// compiled member node returning call3206 (depth = 5)
  *var_suggestion = call3206;
  if (call3206 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3207 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3208 = alloc_Block(NULL, NULL, "parser", 1145);
  gc_frame_newslot(block3208);
// method "_apply(_)"
  block_savedest(block3208);
  Object closure3209 = createclosure(2, "_apply(1)");
  setclosureframe(closure3209, stackframe);
  addtoclosure(closure3209, var_tryTok);
  addtoclosure(closure3209, selfslot);
  struct UserObject *uo3209 = (struct UserObject*)block3208;
  uo3209->data[0] = (Object)closure3209;
  Method *meth_meth_parser_3209__apply_40_1_41_ = addmethod2pos(block3208, "_apply(1)", &meth_parser_3209__apply_40_1_41_, 0);
  int argcv_meth_parser_3209__apply_40_1_41_[] = {1};
  meth_meth_parser_3209__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_3209__apply_40_1_41_);
  meth_meth_parser_3209__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_3209__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block3208 (depth = 6)
  gc_frame_newslot(block3208);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block3208;
  partcv[0] = 1;
  Object call3254 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3207);
// compiled call node returning call3254 (depth = 5)
  *var_nextTok = call3254;
  if (call3254 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_3256 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool3258 = alloc_Boolean(0);
// compiled identifier node returning bool3258 (depth = 6)
  int op_slot_left_3256 = gc_frame_newslot(bool3258);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3259 = callmethod(bool3258, "==(1)", 1, partcv, params);
// compiled op node returning opresult3259 (depth = 5)
  Object if3255 = done;
  if (istrue(opresult3259)) {
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3260 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3261 == NULL) {
    strlit3261 = alloc_String(" {}");
    gc_root(strlit3261);
  }
// compiled string node returning strlit3261 (depth = 6)
  gc_frame_newslot(strlit3261);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tryTok (depth = 6)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3261;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3262 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3260);
// compiled call node returning call3262 (depth = 5)
    gc_frame_newslot(call3262);
    if3255 = call3262;
  } else {
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3265 == NULL) {
    strlit3265 = alloc_String("rbrace");
    gc_root(strlit3265);
  }
// compiled string node returning strlit3265 (depth = 7)
  int op_slot_right_3264 = gc_frame_newslot(strlit3265);
// starting to compile member node (depth = 7)
  int callframe3267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3268 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3267);
// compiled member node returning call3268 (depth = 7)
  int op_slot_left_3264 = gc_frame_newslot(call3268);
  params[0] = strlit3265;
  partcv[0] = 1;
  Object opresult3269 = callmethod(call3268, "==(1)", 1, partcv, params);
// compiled op node returning opresult3269 (depth = 6)
  Object if3263 = done;
  if (istrue(opresult3269)) {
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3270 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3271 == NULL) {
    strlit3271 = alloc_String(" {");
    gc_root(strlit3271);
  }
// compiled string node returning strlit3271 (depth = 7)
  gc_frame_newslot(strlit3271);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tryTok (depth = 7)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3271;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3272 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3270);
// compiled call node returning call3272 (depth = 6)
    gc_frame_newslot(call3272);
    if3263 = call3272;
  } else {
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3275 == NULL) {
    strlit3275 = alloc_String("rparen");
    gc_root(strlit3275);
  }
// compiled string node returning strlit3275 (depth = 8)
  int op_slot_right_3274 = gc_frame_newslot(strlit3275);
// starting to compile member node (depth = 8)
  int callframe3277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call3278 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3277);
// compiled member node returning call3278 (depth = 8)
  int op_slot_left_3274 = gc_frame_newslot(call3278);
  params[0] = strlit3275;
  partcv[0] = 1;
  Object opresult3279 = callmethod(call3278, "==(1)", 1, partcv, params);
// compiled op node returning opresult3279 (depth = 7)
  Object if3273 = done;
  if (istrue(opresult3279)) {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3281 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3281 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3283 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3283 (depth = 8)
  Object if3280 = done;
  if (istrue(opresult3283)) {
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3284 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3285);
  }
// compiled string node returning strlit3285 (depth = 9)
  gc_frame_newslot(strlit3285);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3286 = alloc_Boolean(1);
// compiled identifier node returning bool3286 (depth = 9)
  gc_frame_newslot(bool3286);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3285;
  params[1] = *var_lastToken;
  params[2] = bool3286;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3287 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3284);
// compiled call node returning call3287 (depth = 8)
    gc_frame_newslot(call3287);
    if3280 = call3287;
  } else {
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3288 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("(");
    gc_root(strlit3289);
  }
// compiled string node returning strlit3289 (depth = 9)
  gc_frame_newslot(strlit3289);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3290 = alloc_Boolean(1);
// compiled identifier node returning bool3290 (depth = 9)
  gc_frame_newslot(bool3290);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3289;
  params[1] = *var_lastToken;
  params[2] = bool3290;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3291 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3288);
// compiled call node returning call3291 (depth = 8)
    gc_frame_newslot(call3291);
    if3280 = call3291;
  }
// compiled if node returning if3280 (depth = 7)
    gc_frame_newslot(if3280);
    if3273 = if3280;
  } else {
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3294 == NULL) {
    strlit3294 = alloc_String("identifier");
    gc_root(strlit3294);
  }
// compiled string node returning strlit3294 (depth = 9)
  int op_slot_right_3293 = gc_frame_newslot(strlit3294);
// starting to compile member node (depth = 9)
  int callframe3296 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3297 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3296);
// compiled member node returning call3297 (depth = 9)
  int op_slot_left_3293 = gc_frame_newslot(call3297);
  params[0] = strlit3294;
  partcv[0] = 1;
  Object opresult3298 = callmethod(call3297, "==(1)", 1, partcv, params);
// compiled op node returning opresult3298 (depth = 8)
  Object if3292 = done;
  if (istrue(opresult3298)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3299 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3300 == NULL) {
    strlit3300 = alloc_String(" {");
    gc_root(strlit3300);
  }
// compiled string node returning strlit3300 (depth = 9)
  gc_frame_newslot(strlit3300);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tryTok (depth = 9)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3300;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3301 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3299);
// compiled call node returning call3301 (depth = 8)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3302 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3303 == NULL) {
    strlit3303 = alloc_String("} ");
    gc_root(strlit3303);
  }
// compiled string node returning strlit3303 (depth = 9)
  gc_frame_newslot(strlit3303);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3303;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3304 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3302);
// compiled call node returning call3304 (depth = 8)
    gc_frame_newslot(call3304);
    if3292 = call3304;
  } else {
  }
// compiled if node returning if3292 (depth = 7)
    gc_frame_newslot(if3292);
    if3273 = if3292;
  }
// compiled if node returning if3273 (depth = 6)
    gc_frame_newslot(if3273);
    if3263 = if3273;
  }
// compiled if node returning if3263 (depth = 5)
    gc_frame_newslot(if3263);
    if3255 = if3263;
  }
// compiled if node returning if3255 (depth = 4)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3305 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3307 == NULL) {
    strlit3307 = alloc_String("a block or an expression in parentheses after the 'try'.");
    gc_root(strlit3307);
  }
// compiled string node returning strlit3307 (depth = 6)
  int op_slot_right_3306 = gc_frame_newslot(strlit3307);
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3309 == NULL) {
    strlit3309 = alloc_String("a try(_)catch(_) statement must have ");
    gc_root(strlit3309);
  }
// compiled string node returning strlit3309 (depth = 6)
  int op_slot_left_3306 = gc_frame_newslot(strlit3309);
  params[0] = strlit3307;
  partcv[0] = 1;
  Object opresult3310 = callmethod(strlit3309, "++(1)", 1, partcv, params);
// compiled op node returning opresult3310 (depth = 5)
  gc_frame_newslot(opresult3310);
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3311 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tryTok (depth = 6)
  Object call3312 = callmethodflags(*var_tryTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3311);
// compiled member node returning call3312 (depth = 5)
  gc_frame_newslot(call3312);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3314 = alloc_Float64(1);
// compiled num node returning num3314 (depth = 6)
  int op_slot_right_3313 = gc_frame_newslot(num3314);
// starting to compile member node (depth = 6)
  int callframe3316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tryTok (depth = 7)
  Object call3317 = callmethodflags(*var_tryTok, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe3316);
// compiled member node returning call3317 (depth = 6)
  int op_slot_left_3313 = gc_frame_newslot(call3317);
  params[0] = num3314;
  partcv[0] = 1;
  Object sum3318 = callmethod(call3317, "+(1)", 1, partcv, params);
// compiled op node returning sum3318 (depth = 5)
  gc_frame_newslot(sum3318);
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3310;
  params[1] = call3312;
  params[2] = sum3318;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3319 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3305);
// compiled call node returning call3319 (depth = 4)
    gc_frame_newslot(call3319);
    if3196 = call3319;
  } else {
  }
// compiled if node returning if3196 (depth = 3)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3320 = gc_frame_new();
// call case 4: self request
  Object call3321 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3320);
// compiled member node returning call3321 (depth = 3)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3323 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3324 = alloc_Block(NULL, NULL, "parser", 1168);
  gc_frame_newslot(block3324);
// method "_apply"
  block_savedest(block3324);
  Object closure3325 = createclosure(2, "_apply");
  setclosureframe(closure3325, stackframe);
  addtoclosure(closure3325, var_blocksOK);
  addtoclosure(closure3325, selfslot);
  struct UserObject *uo3325 = (struct UserObject*)block3324;
  uo3325->data[0] = (Object)closure3325;
  Method *meth_meth_parser_3325__apply = addmethod2pos(block3324, "_apply", &meth_parser_3325__apply, 0);
  int argcv_meth_parser_3325__apply[] = {0};
  meth_meth_parser_3325__apply->type = alloc_MethodType(1, argcv_meth_parser_3325__apply);
  meth_meth_parser_3325__apply->definitionModule = modulename;
  meth_meth_parser_3325__apply->definitionLine = 3208;
// compiled block node returning block3324 (depth = 5)
  gc_frame_newslot(block3324);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block3324;
  partcv[0] = 1;
  Object call3329 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3323);
// compiled call node returning call3329 (depth = 4)
  Object if3322 = done;
  if (istrue(call3329)) {
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3330 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3331 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3332 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3331);
// compiled member node returning call3332 (depth = 6)
  Object call3333 = callmethodflags(call3332, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3330);
// compiled member node returning call3333 (depth = 5)
  *var_suggestion = call3333;
  if (call3333 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3334 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array3335 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit3336 == NULL) {
    strlit3336 = alloc_String("rparen");
    gc_root(strlit3336);
  }
// compiled string node returning strlit3336 (depth = 7)
  params[0] = strlit3336;
  partcv[0] = 1;
  callmethodflags(array3335, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3335 (depth = 6)
  gc_frame_newslot(array3335);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array3335;
  partcv[0] = 1;
  Object call3337 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3334);
// compiled call node returning call3337 (depth = 5)
  *var_nextTok = call3337;
  if (call3337 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3339 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3339 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3341 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3341 (depth = 5)
  Object if3338 = done;
  if (istrue(opresult3341)) {
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3342 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3343 == NULL) {
    strlit3343 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3343);
  }
// compiled string node returning strlit3343 (depth = 6)
  gc_frame_newslot(strlit3343);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3343;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3344 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3342);
// compiled call node returning call3344 (depth = 5)
    gc_frame_newslot(call3344);
    if3338 = call3344;
  } else {
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3345 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe3346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call3347 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3346);
// compiled member node returning call3347 (depth = 6)
  gc_frame_newslot(call3347);
// starting to compile identifier node (depth = 6)
  Object bool3348 = alloc_Boolean(1);
// compiled identifier node returning bool3348 (depth = 6)
  gc_frame_newslot(bool3348);
// starting to compile identifier node (depth = 6)
  Object bool3349 = alloc_Boolean(0);
// compiled identifier node returning bool3349 (depth = 6)
  gc_frame_newslot(bool3349);
// starting to compile string node (depth = 6)
  if (strlit3350 == NULL) {
    strlit3350 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3350);
  }
// compiled string node returning strlit3350 (depth = 6)
  gc_frame_newslot(strlit3350);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3347;
  params[2] = bool3348;
  params[3] = bool3349;
  params[4] = strlit3350;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3351 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3345);
// compiled call node returning call3351 (depth = 5)
    gc_frame_newslot(call3351);
    if3338 = call3351;
  }
// compiled if node returning if3338 (depth = 4)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3352 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3354 == NULL) {
    strlit3354 = alloc_String("a block or an expression in parentheses after the 'try'.");
    gc_root(strlit3354);
  }
// compiled string node returning strlit3354 (depth = 6)
  int op_slot_right_3353 = gc_frame_newslot(strlit3354);
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3356 == NULL) {
    strlit3356 = alloc_String("a try(_)catch(_) statement must have ");
    gc_root(strlit3356);
  }
// compiled string node returning strlit3356 (depth = 6)
  int op_slot_left_3353 = gc_frame_newslot(strlit3356);
  params[0] = strlit3354;
  partcv[0] = 1;
  Object opresult3357 = callmethod(strlit3356, "++(1)", 1, partcv, params);
// compiled op node returning opresult3357 (depth = 5)
  gc_frame_newslot(opresult3357);
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3358 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3359 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3358);
// compiled member node returning call3359 (depth = 5)
  gc_frame_newslot(call3359);
// starting to compile member node (depth = 5)
  int callframe3360 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3361 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3360);
// compiled member node returning call3361 (depth = 5)
  gc_frame_newslot(call3361);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3357;
  params[1] = call3359;
  params[2] = call3361;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3362 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3352);
// compiled call node returning call3362 (depth = 4)
    gc_frame_newslot(call3362);
    if3322 = call3362;
  } else {
  }
// compiled if node returning if3322 (depth = 3)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3365 == NULL) {
    strlit3365 = alloc_String("rparen");
    gc_root(strlit3365);
  }
// compiled string node returning strlit3365 (depth = 5)
  int op_slot_right_3364 = gc_frame_newslot(strlit3365);
// starting to compile member node (depth = 5)
  int callframe3367 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3368 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3367);
// compiled member node returning call3368 (depth = 5)
  int op_slot_left_3364 = gc_frame_newslot(call3368);
  params[0] = strlit3365;
  partcv[0] = 1;
  Object opresult3369 = callmethod(call3368, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3369 (depth = 4)
  Object if3363 = done;
  if (istrue(opresult3369)) {
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3370 = gc_frame_new();
// call case 4: self request
  Object call3371 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3370);
// compiled member node returning call3371 (depth = 4)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3372 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3374 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3373);
// compiled member node returning call3374 (depth = 6)
  Object call3375 = callmethodflags(call3374, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3372);
// compiled member node returning call3375 (depth = 5)
  *var_suggestion = call3375;
  if (call3375 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3376 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3377 == NULL) {
    strlit3377 = alloc_String(")");
    gc_root(strlit3377);
  }
// compiled string node returning strlit3377 (depth = 5)
  gc_frame_newslot(strlit3377);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3377;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3378 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3376);
// compiled call node returning call3378 (depth = 4)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3379 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3380 == NULL) {
    strlit3380 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3380);
  }
// compiled string node returning strlit3380 (depth = 5)
  gc_frame_newslot(strlit3380);
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3382 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3381);
// compiled member node returning call3382 (depth = 5)
  gc_frame_newslot(call3382);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3384 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3385 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3384);
// compiled member node returning call3385 (depth = 6)
  int op_slot_right_3383 = gc_frame_newslot(call3385);
// starting to compile member node (depth = 6)
  int callframe3387 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3388 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3387);
// compiled member node returning call3388 (depth = 6)
  int op_slot_left_3383 = gc_frame_newslot(call3388);
  params[0] = call3385;
  partcv[0] = 1;
  Object sum3389 = callmethod(call3388, "+(1)", 1, partcv, params);
// compiled op node returning sum3389 (depth = 5)
  gc_frame_newslot(sum3389);
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3380;
  params[1] = call3382;
  params[2] = sum3389;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3390 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3379);
// compiled call node returning call3390 (depth = 4)
    gc_frame_newslot(call3390);
    if3363 = call3390;
  } else {
  }
// compiled if node returning if3363 (depth = 3)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3391 = gc_frame_new();
// call case 4: self request
  Object call3392 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3391);
// compiled member node returning call3392 (depth = 3)
    gc_frame_newslot(call3392);
    if3190 = call3392;
  }
// compiled if node returning if3190 (depth = 2)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call3394 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3393);
// compiled member node returning call3394 (depth = 3)
  *var_mainblock = call3394;
  if (call3394 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3395 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3395 (depth = 3)
  *var_cases = array3395;
  if (array3395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3396 = alloc_Boolean(0);
// compiled identifier node returning bool3396 (depth = 3)
  *var_finally = bool3396;
  if (bool3396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3397 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3398 = alloc_Block(NULL, NULL, "parser", 1193);
  gc_frame_newslot(block3398);
// method "_apply"
  block_savedest(block3398);
  Object closure3399 = createclosure(2, "_apply");
  setclosureframe(closure3399, stackframe);
  addtoclosure(closure3399, var_sym);
  addtoclosure(closure3399, selfslot);
  struct UserObject *uo3399 = (struct UserObject*)block3398;
  uo3399->data[0] = (Object)closure3399;
  Method *meth_meth_parser_3399__apply = addmethod2pos(block3398, "_apply", &meth_parser_3399__apply, 0);
  int argcv_meth_parser_3399__apply[] = {0};
  meth_meth_parser_3399__apply->type = alloc_MethodType(1, argcv_meth_parser_3399__apply);
  meth_meth_parser_3399__apply->definitionModule = modulename;
  meth_meth_parser_3399__apply->definitionLine = 3208;
// compiled block node returning block3398 (depth = 3)
  gc_frame_newslot(block3398);
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block3413 = alloc_Block(NULL, NULL, "parser", 1193);
  gc_frame_newslot(block3413);
// method "_apply"
  block_savedest(block3413);
  Object closure3414 = createclosure(8, "_apply");
  setclosureframe(closure3414, stackframe);
  addtoclosure(closure3414, var_blocksOK);
  addtoclosure(closure3414, var_errormessages);
  addtoclosure(closure3414, var_sym);
  addtoclosure(closure3414, var_lastToken);
  addtoclosure(closure3414, var_tokens);
  addtoclosure(closure3414, var_values);
  addtoclosure(closure3414, var_cases);
  addtoclosure(closure3414, selfslot);
  struct UserObject *uo3414 = (struct UserObject*)block3413;
  uo3414->data[0] = (Object)closure3414;
  Method *meth_meth_parser_3414__apply = addmethod2pos(block3413, "_apply", &meth_parser_3414__apply, 0);
  int argcv_meth_parser_3414__apply[] = {0};
  meth_meth_parser_3414__apply->type = alloc_MethodType(1, argcv_meth_parser_3414__apply);
  meth_meth_parser_3414__apply->definitionModule = modulename;
  meth_meth_parser_3414__apply->definitionLine = 3208;
// compiled block node returning block3413 (depth = 3)
  gc_frame_newslot(block3413);
// call case 5: prelude request
  params[0] = block3398;
  params[1] = block3413;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3559 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3397);
// compiled call node returning call3559 (depth = 2)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3563 == NULL) {
    strlit3563 = alloc_String("case");
    gc_root(strlit3563);
  }
// compiled string node returning strlit3563 (depth = 5)
  int op_slot_right_3562 = gc_frame_newslot(strlit3563);
// starting to compile member node (depth = 5)
  int callframe3565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3566 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3565);
// compiled member node returning call3566 (depth = 5)
  int op_slot_left_3562 = gc_frame_newslot(call3566);
  params[0] = strlit3563;
  partcv[0] = 1;
  Object opresult3567 = callmethod(call3566, "==(1)", 1, partcv, params);
// compiled op node returning opresult3567 (depth = 4)
  int op_slot_right_3561 = gc_frame_newslot(opresult3567);
// starting to compile call node (depth = 4)
  int callframe3569 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3570 == NULL) {
    strlit3570 = alloc_String("identifier");
    gc_root(strlit3570);
  }
// compiled string node returning strlit3570 (depth = 5)
  gc_frame_newslot(strlit3570);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryTok (depth = 5)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3570;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3571 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3569);
// compiled call node returning call3571 (depth = 4)
  int op_slot_left_3561 = gc_frame_newslot(call3571);
  params[0] = opresult3567;
  partcv[0] = 1;
  Object opresult3572 = callmethod(call3571, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3572 (depth = 3)
  Object if3560 = done;
  if (istrue(opresult3572)) {
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3573 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3574 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call3575 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3574);
// compiled member node returning call3575 (depth = 5)
  Object call3576 = callmethodflags(call3575, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3573);
// compiled member node returning call3576 (depth = 4)
  *var_suggestion = call3576;
  if (call3576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3577 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3578 == NULL) {
    strlit3578 = alloc_String("catch");
    gc_root(strlit3578);
  }
// compiled string node returning strlit3578 (depth = 4)
  gc_frame_newslot(strlit3578);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3578;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3579 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3577);
// compiled call node returning call3579 (depth = 3)
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3580 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3582 == NULL) {
    strlit3582 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3582);
  }
// compiled string node returning strlit3582 (depth = 5)
  int op_slot_right_3581 = gc_frame_newslot(strlit3582);
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3585 == NULL) {
    strlit3585 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3585);
  }
// compiled string node returning strlit3585 (depth = 6)
  int op_slot_right_3584 = gc_frame_newslot(strlit3585);
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3587 == NULL) {
    strlit3587 = alloc_String("a try-catch statement starts with a ");
    gc_root(strlit3587);
  }
// compiled string node returning strlit3587 (depth = 6)
  int op_slot_left_3584 = gc_frame_newslot(strlit3587);
  params[0] = strlit3585;
  partcv[0] = 1;
  Object opresult3588 = callmethod(strlit3587, "++(1)", 1, partcv, params);
// compiled op node returning opresult3588 (depth = 5)
  int op_slot_left_3581 = gc_frame_newslot(opresult3588);
  params[0] = strlit3582;
  partcv[0] = 1;
  Object opresult3589 = callmethod(opresult3588, "++(1)", 1, partcv, params);
// compiled op node returning opresult3589 (depth = 4)
  gc_frame_newslot(opresult3589);
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3591 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3590);
// compiled member node returning call3591 (depth = 4)
  gc_frame_newslot(call3591);
// starting to compile member node (depth = 4)
  int callframe3592 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3593 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3592);
// compiled member node returning call3593 (depth = 4)
  gc_frame_newslot(call3593);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3595 = alloc_Float64(3);
// compiled num node returning num3595 (depth = 5)
  int op_slot_right_3594 = gc_frame_newslot(num3595);
// starting to compile member node (depth = 5)
  int callframe3597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3598 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3597);
// compiled member node returning call3598 (depth = 5)
  int op_slot_left_3594 = gc_frame_newslot(call3598);
  params[0] = num3595;
  partcv[0] = 1;
  Object sum3599 = callmethod(call3598, "+(1)", 1, partcv, params);
// compiled op node returning sum3599 (depth = 4)
  gc_frame_newslot(sum3599);
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3589;
  params[1] = call3591;
  params[2] = call3593;
  params[3] = sum3599;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3600 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3580);
// compiled call node returning call3600 (depth = 3)
    gc_frame_newslot(call3600);
    if3560 = call3600;
  } else {
  }
// compiled if node returning if3560 (depth = 2)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3604 == NULL) {
    strlit3604 = alloc_String("finally");
    gc_root(strlit3604);
  }
// compiled string node returning strlit3604 (depth = 5)
  int op_slot_right_3603 = gc_frame_newslot(strlit3604);
// starting to compile member node (depth = 5)
  int callframe3606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3607 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3606);
// compiled member node returning call3607 (depth = 5)
  int op_slot_left_3603 = gc_frame_newslot(call3607);
  params[0] = strlit3604;
  partcv[0] = 1;
  Object opresult3608 = callmethod(call3607, "==(1)", 1, partcv, params);
// compiled op node returning opresult3608 (depth = 4)
  int op_slot_right_3602 = gc_frame_newslot(opresult3608);
// starting to compile call node (depth = 4)
  int callframe3610 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3611 == NULL) {
    strlit3611 = alloc_String("identifier");
    gc_root(strlit3611);
  }
// compiled string node returning strlit3611 (depth = 5)
  gc_frame_newslot(strlit3611);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3611;
  partcv[0] = 1;
  Object call3612 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3610);
// compiled call node returning call3612 (depth = 4)
  int op_slot_left_3602 = gc_frame_newslot(call3612);
  params[0] = opresult3608;
  partcv[0] = 1;
  Object opresult3613 = callmethod(call3612, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3613 (depth = 3)
  Object if3601 = done;
  if (istrue(opresult3613)) {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3614 = gc_frame_new();
// call case 4: self request
  Object call3615 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3614);
// compiled member node returning call3615 (depth = 3)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3617 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3618 == NULL) {
    strlit3618 = alloc_String("lbrace");
    gc_root(strlit3618);
  }
// compiled string node returning strlit3618 (depth = 5)
  gc_frame_newslot(strlit3618);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3618;
  partcv[0] = 1;
  Object call3619 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3617);
// compiled call node returning call3619 (depth = 4)
  Object if3616 = done;
  if (istrue(call3619)) {
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3620 = gc_frame_new();
// call case 4: self request
  Object call3621 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3620);
// compiled member node returning call3621 (depth = 4)
    gc_frame_newslot(call3621);
    if3616 = call3621;
  } else {
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3623 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3624 == NULL) {
    strlit3624 = alloc_String("lparen");
    gc_root(strlit3624);
  }
// compiled string node returning strlit3624 (depth = 6)
  gc_frame_newslot(strlit3624);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3624;
  partcv[0] = 1;
  Object call3625 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3623);
// compiled call node returning call3625 (depth = 5)
  Object if3622 = done;
  if (istrue(call3625)) {
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3626 = gc_frame_new();
// call case 4: self request
  Object call3627 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3626);
// compiled member node returning call3627 (depth = 5)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3629 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3630 = alloc_Block(NULL, NULL, "parser", 1257);
  gc_frame_newslot(block3630);
// method "_apply"
  block_savedest(block3630);
  Object closure3631 = createclosure(2, "_apply");
  setclosureframe(closure3631, stackframe);
  addtoclosure(closure3631, var_blocksOK);
  addtoclosure(closure3631, selfslot);
  struct UserObject *uo3631 = (struct UserObject*)block3630;
  uo3631->data[0] = (Object)closure3631;
  Method *meth_meth_parser_3631__apply = addmethod2pos(block3630, "_apply", &meth_parser_3631__apply, 0);
  int argcv_meth_parser_3631__apply[] = {0};
  meth_meth_parser_3631__apply->type = alloc_MethodType(1, argcv_meth_parser_3631__apply);
  meth_meth_parser_3631__apply->definitionModule = modulename;
  meth_meth_parser_3631__apply->definitionLine = 3208;
// compiled block node returning block3630 (depth = 7)
  gc_frame_newslot(block3630);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block3630;
  partcv[0] = 1;
  Object call3635 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3629);
// compiled call node returning call3635 (depth = 6)
  Object if3628 = done;
  if (istrue(call3635)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3636 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3637 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3638 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3637);
// compiled member node returning call3638 (depth = 8)
  Object call3639 = callmethodflags(call3638, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3636);
// compiled member node returning call3639 (depth = 7)
  *var_suggestion = call3639;
  if (call3639 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3640 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array3641 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit3642 == NULL) {
    strlit3642 = alloc_String("rparen");
    gc_root(strlit3642);
  }
// compiled string node returning strlit3642 (depth = 9)
  params[0] = strlit3642;
  partcv[0] = 1;
  callmethodflags(array3641, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3641 (depth = 8)
  gc_frame_newslot(array3641);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array3641;
  partcv[0] = 1;
  Object call3643 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3640);
// compiled call node returning call3643 (depth = 7)
  *var_nextTok = call3643;
  if (call3643 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3645 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3645 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3647 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3647 (depth = 7)
  Object if3644 = done;
  if (istrue(opresult3647)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3648 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3649 == NULL) {
    strlit3649 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3649);
  }
// compiled string node returning strlit3649 (depth = 8)
  gc_frame_newslot(strlit3649);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3649;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3650 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3648);
// compiled call node returning call3650 (depth = 7)
    gc_frame_newslot(call3650);
    if3644 = call3650;
  } else {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3651 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe3652 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call3653 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3652);
// compiled member node returning call3653 (depth = 8)
  gc_frame_newslot(call3653);
// starting to compile identifier node (depth = 8)
  Object bool3654 = alloc_Boolean(1);
// compiled identifier node returning bool3654 (depth = 8)
  gc_frame_newslot(bool3654);
// starting to compile identifier node (depth = 8)
  Object bool3655 = alloc_Boolean(0);
// compiled identifier node returning bool3655 (depth = 8)
  gc_frame_newslot(bool3655);
// starting to compile string node (depth = 8)
  if (strlit3656 == NULL) {
    strlit3656 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3656);
  }
// compiled string node returning strlit3656 (depth = 8)
  gc_frame_newslot(strlit3656);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call3653;
  params[2] = bool3654;
  params[3] = bool3655;
  params[4] = strlit3656;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3657 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3651);
// compiled call node returning call3657 (depth = 7)
    gc_frame_newslot(call3657);
    if3644 = call3657;
  }
// compiled if node returning if3644 (depth = 6)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3658 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3659 == NULL) {
    strlit3659 = alloc_String("a try(_)catch(_)""\xe2""""\x80""""\xa6""finally(_) statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3659);
  }
// compiled string node returning strlit3659 (depth = 7)
  gc_frame_newslot(strlit3659);
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3661 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3660);
// compiled member node returning call3661 (depth = 7)
  gc_frame_newslot(call3661);
// starting to compile member node (depth = 7)
  int callframe3662 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3663 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3662);
// compiled member node returning call3663 (depth = 7)
  gc_frame_newslot(call3663);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3659;
  params[1] = call3661;
  params[2] = call3663;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3664 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3658);
// compiled call node returning call3664 (depth = 6)
    gc_frame_newslot(call3664);
    if3628 = call3664;
  } else {
  }
// compiled if node returning if3628 (depth = 5)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3667 == NULL) {
    strlit3667 = alloc_String("rparen");
    gc_root(strlit3667);
  }
// compiled string node returning strlit3667 (depth = 7)
  int op_slot_right_3666 = gc_frame_newslot(strlit3667);
// starting to compile member node (depth = 7)
  int callframe3669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3670 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3669);
// compiled member node returning call3670 (depth = 7)
  int op_slot_left_3666 = gc_frame_newslot(call3670);
  params[0] = strlit3667;
  partcv[0] = 1;
  Object opresult3671 = callmethod(call3670, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3671 (depth = 6)
  Object if3665 = done;
  if (istrue(opresult3671)) {
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3672 = gc_frame_new();
// call case 4: self request
  Object call3673 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3672);
// compiled member node returning call3673 (depth = 6)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3674 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3675 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3676 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3675);
// compiled member node returning call3676 (depth = 8)
  Object call3677 = callmethodflags(call3676, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3674);
// compiled member node returning call3677 (depth = 7)
  *var_suggestion = call3677;
  if (call3677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3678 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3679 == NULL) {
    strlit3679 = alloc_String(")");
    gc_root(strlit3679);
  }
// compiled string node returning strlit3679 (depth = 7)
  gc_frame_newslot(strlit3679);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3679;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3680 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3678);
// compiled call node returning call3680 (depth = 6)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3681 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3682 == NULL) {
    strlit3682 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3682);
  }
// compiled string node returning strlit3682 (depth = 7)
  gc_frame_newslot(strlit3682);
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3684 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3683);
// compiled member node returning call3684 (depth = 7)
  gc_frame_newslot(call3684);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3686 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3687 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3686);
// compiled member node returning call3687 (depth = 8)
  int op_slot_right_3685 = gc_frame_newslot(call3687);
// starting to compile member node (depth = 8)
  int callframe3689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3690 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3689);
// compiled member node returning call3690 (depth = 8)
  int op_slot_left_3685 = gc_frame_newslot(call3690);
  params[0] = call3687;
  partcv[0] = 1;
  Object sum3691 = callmethod(call3690, "+(1)", 1, partcv, params);
// compiled op node returning sum3691 (depth = 7)
  gc_frame_newslot(sum3691);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3682;
  params[1] = call3684;
  params[2] = sum3691;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3692 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3681);
// compiled call node returning call3692 (depth = 6)
    gc_frame_newslot(call3692);
    if3665 = call3692;
  } else {
  }
// compiled if node returning if3665 (depth = 5)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3693 = gc_frame_new();
// call case 4: self request
  Object call3694 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3693);
// compiled member node returning call3694 (depth = 5)
    gc_frame_newslot(call3694);
    if3622 = call3694;
  } else {
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array3695 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3695 (depth = 6)
  *var_suggestions = array3695;
  if (array3695 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3696 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3697 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3696);
// compiled call node returning call3697 (depth = 6)
  *var_nextTok = call3697;
  if (call3697 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3698 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call3700 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3699);
// compiled member node returning call3700 (depth = 7)
  Object call3701 = callmethodflags(call3700, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3698);
// compiled member node returning call3701 (depth = 6)
  *var_suggestion = call3701;
  if (call3701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_3703 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool3705 = alloc_Boolean(0);
// compiled identifier node returning bool3705 (depth = 7)
  int op_slot_left_3703 = gc_frame_newslot(bool3705);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3706 = callmethod(bool3705, "==(1)", 1, partcv, params);
// compiled op node returning opresult3706 (depth = 6)
  Object if3702 = done;
  if (istrue(opresult3706)) {
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3707 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3708 == NULL) {
    strlit3708 = alloc_String(" }");
    gc_root(strlit3708);
  }
// compiled string node returning strlit3708 (depth = 7)
  gc_frame_newslot(strlit3708);
// starting to compile member node (depth = 7)
  int callframe3709 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  Object call3710 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3709);
// compiled member node returning call3710 (depth = 7)
  gc_frame_newslot(call3710);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3708;
  params[1] = call3710;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3711 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3707);
// compiled call node returning call3711 (depth = 6)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3712 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3713 == NULL) {
    strlit3713 = alloc_String(" {");
    gc_root(strlit3713);
  }
// compiled string node returning strlit3713 (depth = 7)
  gc_frame_newslot(strlit3713);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3713;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3714 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3712);
// compiled call node returning call3714 (depth = 6)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3715 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3716 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3715);
// compiled call node returning call3716 (depth = 6)
    gc_frame_newslot(call3716);
    if3702 = call3716;
  } else {
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3718 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3718 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3720 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3720 (depth = 7)
  Object if3717 = done;
  if (istrue(opresult3720)) {
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3721 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3722 == NULL) {
    strlit3722 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3722);
  }
// compiled string node returning strlit3722 (depth = 8)
  gc_frame_newslot(strlit3722);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3722;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3723 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3721);
// compiled call node returning call3723 (depth = 7)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3724 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3725 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3724);
// compiled call node returning call3725 (depth = 7)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3726 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3728 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3727);
// compiled member node returning call3728 (depth = 9)
  Object call3729 = callmethodflags(call3728, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3726);
// compiled member node returning call3729 (depth = 8)
  *var_suggestion = call3729;
  if (call3729 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3731 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3732 == NULL) {
    strlit3732 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit3732);
  }
// compiled string node returning strlit3732 (depth = 8)
  gc_frame_newslot(strlit3732);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3732;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3733 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3731);
// compiled call node returning call3733 (depth = 7)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3734 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3735 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3734);
// compiled call node returning call3735 (depth = 7)
    gc_frame_newslot(call3735);
    if3717 = call3735;
  } else {
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3736 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3737 == NULL) {
    strlit3737 = alloc_String(" }");
    gc_root(strlit3737);
  }
// compiled string node returning strlit3737 (depth = 8)
  gc_frame_newslot(strlit3737);
// starting to compile member node (depth = 8)
  int callframe3738 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call3739 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3738);
// compiled member node returning call3739 (depth = 8)
  gc_frame_newslot(call3739);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3737;
  params[1] = call3739;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3740 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3736);
// compiled call node returning call3740 (depth = 7)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3741 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3742 == NULL) {
    strlit3742 = alloc_String(" {");
    gc_root(strlit3742);
  }
// compiled string node returning strlit3742 (depth = 8)
  gc_frame_newslot(strlit3742);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3742;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3743 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3741);
// compiled call node returning call3743 (depth = 7)
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3744 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3745 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3744);
// compiled call node returning call3745 (depth = 7)
    gc_frame_newslot(call3745);
    if3717 = call3745;
  }
// compiled if node returning if3717 (depth = 6)
    gc_frame_newslot(if3717);
    if3702 = if3717;
  }
// compiled if node returning if3702 (depth = 5)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3746 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3747 == NULL) {
    strlit3747 = alloc_String("a try(_)catch(_)""\xe2""""\x80""""\xa6""finally(_) statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3747);
  }
// compiled string node returning strlit3747 (depth = 6)
  gc_frame_newslot(strlit3747);
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3748 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3749 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3748);
// compiled member node returning call3749 (depth = 6)
  gc_frame_newslot(call3749);
// starting to compile member node (depth = 6)
  int callframe3750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3751 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3750);
// compiled member node returning call3751 (depth = 6)
  gc_frame_newslot(call3751);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3747;
  params[1] = call3749;
  params[2] = call3751;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3752 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3746);
// compiled call node returning call3752 (depth = 5)
    gc_frame_newslot(call3752);
    if3622 = call3752;
  }
// compiled if node returning if3622 (depth = 4)
    gc_frame_newslot(if3622);
    if3616 = if3622;
  }
// compiled if node returning if3616 (depth = 3)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call3754 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3753);
// compiled member node returning call3754 (depth = 4)
  *var_finally = call3754;
  if (call3754 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3601 = done;
  } else {
  }
// compiled if node returning if3601 (depth = 2)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3756 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe3757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tryTok (depth = 4)
  Object call3758 = callmethodflags(*var_tryTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3757);
// compiled member node returning call3758 (depth = 3)
  gc_frame_newslot(call3758);
// starting to compile member node (depth = 3)
  int callframe3759 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tryTok (depth = 4)
  Object call3760 = callmethodflags(*var_tryTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3759);
// compiled member node returning call3760 (depth = 3)
  gc_frame_newslot(call3760);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call3758;
  params[1] = call3760;
  partcv[0] = 2;
  Object call3761 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3756);
// compiled call node returning call3761 (depth = 2)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3762 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe3763 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3764 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call3765 = callmethodflags(*var_ast, "tryCatchNode", 0, partcv, params, 0);
  gc_frame_end(callframe3764);
// compiled member node returning call3765 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call3766 = callmethodflags(call3765, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe3763);
// compiled call node returning call3766 (depth = 3)
  gc_frame_newslot(call3766);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call3766;
  partcv[0] = 1;
  Object call3767 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3762);
// compiled call node returning call3767 (depth = 2)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_3801__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3805 == NULL) {
    strlit3805 = alloc_String("case");
    gc_root(strlit3805);
  }
// compiled string node returning strlit3805 (depth = 9)
  int op_slot_right_3804 = gc_frame_newslot(strlit3805);
// starting to compile member node (depth = 9)
  int callframe3807 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call3808 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3807);
// compiled member node returning call3808 (depth = 9)
  int op_slot_left_3804 = gc_frame_newslot(call3808);
  params[0] = strlit3805;
  partcv[0] = 1;
  Object opresult3809 = callmethod(call3808, "==(1)", 1, partcv, params);
// compiled op node returning opresult3809 (depth = 8)
  int op_slot_right_3803 = gc_frame_newslot(opresult3809);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3812 == NULL) {
    strlit3812 = alloc_String("identifier");
    gc_root(strlit3812);
  }
// compiled string node returning strlit3812 (depth = 9)
  int op_slot_right_3811 = gc_frame_newslot(strlit3812);
// starting to compile member node (depth = 9)
  int callframe3814 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call3815 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3814);
// compiled member node returning call3815 (depth = 9)
  int op_slot_left_3811 = gc_frame_newslot(call3815);
  params[0] = strlit3812;
  partcv[0] = 1;
  Object opresult3816 = callmethod(call3815, "==(1)", 1, partcv, params);
// compiled op node returning opresult3816 (depth = 8)
  int op_slot_left_3803 = gc_frame_newslot(opresult3816);
  params[0] = opresult3809;
  partcv[0] = 1;
  Object opresult3817 = callmethod(opresult3816, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3817 (depth = 7)
  int op_slot_right_3802 = gc_frame_newslot(opresult3817);
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3821 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_matchTok (depth = 10)
  Object call3822 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3821);
// compiled member node returning call3822 (depth = 9)
  int op_slot_right_3820 = gc_frame_newslot(call3822);
// starting to compile member node (depth = 9)
  int callframe3824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call3825 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3824);
// compiled member node returning call3825 (depth = 9)
  int op_slot_left_3820 = gc_frame_newslot(call3825);
  params[0] = call3822;
  partcv[0] = 1;
  Object opresult3826 = callmethod(call3825, "==(1)", 1, partcv, params);
// compiled op node returning opresult3826 (depth = 8)
  int op_slot_right_3819 = gc_frame_newslot(opresult3826);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3829 == NULL) {
    strlit3829 = alloc_String("rparen");
    gc_root(strlit3829);
  }
// compiled string node returning strlit3829 (depth = 9)
  int op_slot_right_3828 = gc_frame_newslot(strlit3829);
// starting to compile member node (depth = 9)
  int callframe3831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call3832 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3831);
// compiled member node returning call3832 (depth = 9)
  int op_slot_left_3828 = gc_frame_newslot(call3832);
  params[0] = strlit3829;
  partcv[0] = 1;
  Object opresult3833 = callmethod(call3832, "==(1)", 1, partcv, params);
// compiled op node returning opresult3833 (depth = 8)
  int op_slot_left_3819 = gc_frame_newslot(opresult3833);
  params[0] = opresult3826;
  partcv[0] = 1;
  Object opresult3834 = callmethod(opresult3833, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3834 (depth = 7)
  int op_slot_left_3802 = gc_frame_newslot(opresult3834);
  params[0] = opresult3817;
  partcv[0] = 1;
  Object opresult3835 = callmethod(opresult3834, "||(1)", 1, partcv, params);
// compiled op node returning opresult3835 (depth = 6)
  gc_frame_end(frame);
  return opresult3835;
}
Object meth_parser_3896__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe3897 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3898 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3897);
// compiled call node returning call3898 (depth = 5)
  gc_frame_end(frame);
  return call3898;
}
Object meth_parser_3965__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3968 == NULL) {
    strlit3968 = alloc_String("case");
    gc_root(strlit3968);
  }
// compiled string node returning strlit3968 (depth = 6)
  int op_slot_right_3967 = gc_frame_newslot(strlit3968);
// starting to compile member node (depth = 6)
  int callframe3970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3971 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3970);
// compiled member node returning call3971 (depth = 6)
  int op_slot_left_3967 = gc_frame_newslot(call3971);
  params[0] = strlit3968;
  partcv[0] = 1;
  Object opresult3972 = callmethod(call3971, "==(1)", 1, partcv, params);
// compiled op node returning opresult3972 (depth = 5)
  int op_slot_right_3966 = gc_frame_newslot(opresult3972);
// starting to compile call node (depth = 5)
  int callframe3974 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3975 == NULL) {
    strlit3975 = alloc_String("identifier");
    gc_root(strlit3975);
  }
// compiled string node returning strlit3975 (depth = 6)
  gc_frame_newslot(strlit3975);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3975;
  partcv[0] = 1;
  Object call3976 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3974);
// compiled call node returning call3976 (depth = 5)
  int op_slot_left_3966 = gc_frame_newslot(call3976);
  params[0] = opresult3972;
  partcv[0] = 1;
  Object opresult3977 = callmethod(call3976, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3977 (depth = 4)
  gc_frame_end(frame);
  return opresult3977;
}
Object meth_parser_3998__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe3999 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4000 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3999);
// compiled call node returning call4000 (depth = 9)
  gc_frame_end(frame);
  return call4000;
}
Object meth_parser_3980__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3981 = gc_frame_new();
// call case 4: self request
  Object call3982 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3981);
// compiled member node returning call3982 (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3984 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3985 == NULL) {
    strlit3985 = alloc_String("lbrace");
    gc_root(strlit3985);
  }
// compiled string node returning strlit3985 (depth = 6)
  gc_frame_newslot(strlit3985);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3985;
  partcv[0] = 1;
  Object call3986 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3984);
// compiled call node returning call3986 (depth = 5)
  Object if3983 = done;
  if (istrue(call3986)) {
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3987 = gc_frame_new();
// call case 4: self request
  Object call3988 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3987);
// compiled member node returning call3988 (depth = 5)
    gc_frame_newslot(call3988);
    if3983 = call3988;
  } else {
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3990 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3991 == NULL) {
    strlit3991 = alloc_String("lparen");
    gc_root(strlit3991);
  }
// compiled string node returning strlit3991 (depth = 7)
  gc_frame_newslot(strlit3991);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit3991;
  partcv[0] = 1;
  Object call3992 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3990);
// compiled call node returning call3992 (depth = 6)
  Object if3989 = done;
  if (istrue(call3992)) {
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3993 = gc_frame_new();
// call case 4: self request
  Object call3994 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3993);
// compiled member node returning call3994 (depth = 6)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3996 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3997 = alloc_Block(NULL, NULL, "parser", 1359);
  gc_frame_newslot(block3997);
// method "_apply"
  block_savedest(block3997);
  Object closure3998 = createclosure(2, "_apply");
  setclosureframe(closure3998, stackframe);
  addtoclosure(closure3998, var_blocksOK);
  addtoclosure(closure3998, selfslot);
  struct UserObject *uo3998 = (struct UserObject*)block3997;
  uo3998->data[0] = (Object)closure3998;
  Method *meth_meth_parser_3998__apply = addmethod2pos(block3997, "_apply", &meth_parser_3998__apply, 0);
  int argcv_meth_parser_3998__apply[] = {0};
  meth_meth_parser_3998__apply->type = alloc_MethodType(1, argcv_meth_parser_3998__apply);
  meth_meth_parser_3998__apply->definitionModule = modulename;
  meth_meth_parser_3998__apply->definitionLine = 3208;
// compiled block node returning block3997 (depth = 8)
  gc_frame_newslot(block3997);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block3997;
  partcv[0] = 1;
  Object call4002 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3996);
// compiled call node returning call4002 (depth = 7)
  Object if3995 = done;
  if (istrue(call4002)) {
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4003 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call4005 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 9)
  Object call4006 = callmethodflags(call4005, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4003);
// compiled member node returning call4006 (depth = 8)
  *var_suggestion = call4006;
  if (call4006 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4007 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array4008 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit4009 == NULL) {
    strlit4009 = alloc_String("rparen");
    gc_root(strlit4009);
  }
// compiled string node returning strlit4009 (depth = 10)
  params[0] = strlit4009;
  partcv[0] = 1;
  callmethodflags(array4008, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4008 (depth = 9)
  gc_frame_newslot(array4008);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array4008;
  partcv[0] = 1;
  Object call4010 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4007);
// compiled call node returning call4010 (depth = 8)
  *var_nextTok = call4010;
  if (call4010 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4012 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4012 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4014 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4014 (depth = 8)
  Object if4011 = done;
  if (istrue(opresult4014)) {
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4015 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4016 == NULL) {
    strlit4016 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4016);
  }
// compiled string node returning strlit4016 (depth = 9)
  gc_frame_newslot(strlit4016);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4016;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4017 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4015);
// compiled call node returning call4017 (depth = 8)
    gc_frame_newslot(call4017);
    if4011 = call4017;
  } else {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4018 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe4019 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call4020 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4019);
// compiled member node returning call4020 (depth = 9)
  gc_frame_newslot(call4020);
// starting to compile identifier node (depth = 9)
  Object bool4021 = alloc_Boolean(1);
// compiled identifier node returning bool4021 (depth = 9)
  gc_frame_newslot(bool4021);
// starting to compile identifier node (depth = 9)
  Object bool4022 = alloc_Boolean(0);
// compiled identifier node returning bool4022 (depth = 9)
  gc_frame_newslot(bool4022);
// starting to compile string node (depth = 9)
  if (strlit4023 == NULL) {
    strlit4023 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4023);
  }
// compiled string node returning strlit4023 (depth = 9)
  gc_frame_newslot(strlit4023);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4020;
  params[2] = bool4021;
  params[3] = bool4022;
  params[4] = strlit4023;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4024 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4018);
// compiled call node returning call4024 (depth = 8)
    gc_frame_newslot(call4024);
    if4011 = call4024;
  }
// compiled if node returning if4011 (depth = 7)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4025 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4026 == NULL) {
    strlit4026 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4026);
  }
// compiled string node returning strlit4026 (depth = 8)
  gc_frame_newslot(strlit4026);
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4028 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4027);
// compiled member node returning call4028 (depth = 8)
  gc_frame_newslot(call4028);
// starting to compile member node (depth = 8)
  int callframe4029 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4030 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4029);
// compiled member node returning call4030 (depth = 8)
  gc_frame_newslot(call4030);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4026;
  params[1] = call4028;
  params[2] = call4030;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4031 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4025);
// compiled call node returning call4031 (depth = 7)
    gc_frame_newslot(call4031);
    if3995 = call4031;
  } else {
  }
// compiled if node returning if3995 (depth = 6)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4034 == NULL) {
    strlit4034 = alloc_String("rparen");
    gc_root(strlit4034);
  }
// compiled string node returning strlit4034 (depth = 8)
  int op_slot_right_4033 = gc_frame_newslot(strlit4034);
// starting to compile member node (depth = 8)
  int callframe4036 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4037 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4036);
// compiled member node returning call4037 (depth = 8)
  int op_slot_left_4033 = gc_frame_newslot(call4037);
  params[0] = strlit4034;
  partcv[0] = 1;
  Object opresult4038 = callmethod(call4037, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4038 (depth = 7)
  Object if4032 = done;
  if (istrue(opresult4038)) {
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4039 = gc_frame_new();
// call case 4: self request
  Object call4040 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4039);
// compiled member node returning call4040 (depth = 7)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call4043 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4042);
// compiled member node returning call4043 (depth = 9)
  Object call4044 = callmethodflags(call4043, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4041);
// compiled member node returning call4044 (depth = 8)
  *var_suggestion = call4044;
  if (call4044 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4045 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4046 == NULL) {
    strlit4046 = alloc_String(")");
    gc_root(strlit4046);
  }
// compiled string node returning strlit4046 (depth = 8)
  gc_frame_newslot(strlit4046);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4046;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4047 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4045);
// compiled call node returning call4047 (depth = 7)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4048 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4049 == NULL) {
    strlit4049 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4049);
  }
// compiled string node returning strlit4049 (depth = 8)
  gc_frame_newslot(strlit4049);
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4051 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4050);
// compiled member node returning call4051 (depth = 8)
  gc_frame_newslot(call4051);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4054 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4053);
// compiled member node returning call4054 (depth = 9)
  int op_slot_right_4052 = gc_frame_newslot(call4054);
// starting to compile member node (depth = 9)
  int callframe4056 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4057 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4056);
// compiled member node returning call4057 (depth = 9)
  int op_slot_left_4052 = gc_frame_newslot(call4057);
  params[0] = call4054;
  partcv[0] = 1;
  Object sum4058 = callmethod(call4057, "+(1)", 1, partcv, params);
// compiled op node returning sum4058 (depth = 8)
  gc_frame_newslot(sum4058);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4049;
  params[1] = call4051;
  params[2] = sum4058;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4059 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4048);
// compiled call node returning call4059 (depth = 7)
    gc_frame_newslot(call4059);
    if4032 = call4059;
  } else {
  }
// compiled if node returning if4032 (depth = 6)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4060 = gc_frame_new();
// call case 4: self request
  Object call4061 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4060);
// compiled member node returning call4061 (depth = 6)
    gc_frame_newslot(call4061);
    if3989 = call4061;
  } else {
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4062 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4062 (depth = 7)
  *var_suggestions = array4062;
  if (array4062 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4063 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4064 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4063);
// compiled call node returning call4064 (depth = 7)
  *var_nextTok = call4064;
  if (call4064 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4065 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4066 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4067 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4066);
// compiled member node returning call4067 (depth = 8)
  Object call4068 = callmethodflags(call4067, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4065);
// compiled member node returning call4068 (depth = 7)
  *var_suggestion = call4068;
  if (call4068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_4070 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool4072 = alloc_Boolean(0);
// compiled identifier node returning bool4072 (depth = 8)
  int op_slot_left_4070 = gc_frame_newslot(bool4072);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4073 = callmethod(bool4072, "==(1)", 1, partcv, params);
// compiled op node returning opresult4073 (depth = 7)
  Object if4069 = done;
  if (istrue(opresult4073)) {
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4074 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4075 == NULL) {
    strlit4075 = alloc_String(" }");
    gc_root(strlit4075);
  }
// compiled string node returning strlit4075 (depth = 8)
  gc_frame_newslot(strlit4075);
// starting to compile member node (depth = 8)
  int callframe4076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call4077 = callmethodflags(*var_tokens, "last", 0, partcv, params, 0);
  gc_frame_end(callframe4076);
// compiled member node returning call4077 (depth = 8)
  gc_frame_newslot(call4077);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4075;
  params[1] = call4077;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4078 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4074);
// compiled call node returning call4078 (depth = 7)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4079 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4080 == NULL) {
    strlit4080 = alloc_String(" {");
    gc_root(strlit4080);
  }
// compiled string node returning strlit4080 (depth = 8)
  gc_frame_newslot(strlit4080);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4080;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4081 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4079);
// compiled call node returning call4081 (depth = 7)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4082 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4083 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4082);
// compiled call node returning call4083 (depth = 7)
    gc_frame_newslot(call4083);
    if4069 = call4083;
  } else {
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4085 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4085 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4087 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4087 (depth = 8)
  Object if4084 = done;
  if (istrue(opresult4087)) {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4088 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4089 == NULL) {
    strlit4089 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4089);
  }
// compiled string node returning strlit4089 (depth = 9)
  gc_frame_newslot(strlit4089);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4089;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4090 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4088);
// compiled call node returning call4090 (depth = 8)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4091 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4092 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4091);
// compiled call node returning call4092 (depth = 8)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4093 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call4095 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4094);
// compiled member node returning call4095 (depth = 10)
  Object call4096 = callmethodflags(call4095, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4093);
// compiled member node returning call4096 (depth = 9)
  *var_suggestion = call4096;
  if (call4096 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4098 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4099);
  }
// compiled string node returning strlit4099 (depth = 9)
  gc_frame_newslot(strlit4099);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4099;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4100 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4098);
// compiled call node returning call4100 (depth = 8)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4101 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4102 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4101);
// compiled call node returning call4102 (depth = 8)
    gc_frame_newslot(call4102);
    if4084 = call4102;
  } else {
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4103 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4104 == NULL) {
    strlit4104 = alloc_String(" }");
    gc_root(strlit4104);
  }
// compiled string node returning strlit4104 (depth = 9)
  gc_frame_newslot(strlit4104);
// starting to compile member node (depth = 9)
  int callframe4105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call4106 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4105);
// compiled member node returning call4106 (depth = 9)
  gc_frame_newslot(call4106);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4104;
  params[1] = call4106;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4107 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4103);
// compiled call node returning call4107 (depth = 8)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4108 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4109 == NULL) {
    strlit4109 = alloc_String(" {");
    gc_root(strlit4109);
  }
// compiled string node returning strlit4109 (depth = 9)
  gc_frame_newslot(strlit4109);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4109;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4110 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4108);
// compiled call node returning call4110 (depth = 8)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4111 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4112 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4111);
// compiled call node returning call4112 (depth = 8)
    gc_frame_newslot(call4112);
    if4084 = call4112;
  }
// compiled if node returning if4084 (depth = 7)
    gc_frame_newslot(if4084);
    if4069 = if4084;
  }
// compiled if node returning if4069 (depth = 6)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4113 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4114 == NULL) {
    strlit4114 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4114);
  }
// compiled string node returning strlit4114 (depth = 7)
  gc_frame_newslot(strlit4114);
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4116 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4115);
// compiled member node returning call4116 (depth = 7)
  gc_frame_newslot(call4116);
// starting to compile member node (depth = 7)
  int callframe4117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4118 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4117);
// compiled member node returning call4118 (depth = 7)
  gc_frame_newslot(call4118);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4114;
  params[1] = call4116;
  params[2] = call4118;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4119 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4113);
// compiled call node returning call4119 (depth = 6)
    gc_frame_newslot(call4119);
    if3989 = call4119;
  }
// compiled if node returning if3989 (depth = 5)
    gc_frame_newslot(if3989);
    if3983 = if3989;
  }
// compiled if node returning if3983 (depth = 4)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4120 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4121 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call4122 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4121);
// compiled member node returning call4122 (depth = 5)
  gc_frame_newslot(call4122);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4122;
  partcv[0] = 1;
  Object call4123 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4120);
// compiled call node returning call4123 (depth = 4)
  gc_frame_end(frame);
  return call4123;
}
Object meth_parser_3769_matchcase(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
// definebindings:
// definebindings:
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3771 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3774 == NULL) {
    strlit3774 = alloc_String("match");
    gc_root(strlit3774);
  }
// compiled string node returning strlit3774 (depth = 6)
  int op_slot_right_3773 = gc_frame_newslot(strlit3774);
// starting to compile member node (depth = 6)
  int callframe3776 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3777 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3776);
// compiled member node returning call3777 (depth = 6)
  int op_slot_left_3773 = gc_frame_newslot(call3777);
  params[0] = strlit3774;
  partcv[0] = 1;
  Object opresult3778 = callmethod(call3777, "==(1)", 1, partcv, params);
// compiled op node returning opresult3778 (depth = 5)
  int op_slot_right_3772 = gc_frame_newslot(opresult3778);
// starting to compile call node (depth = 5)
  int callframe3780 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3781 == NULL) {
    strlit3781 = alloc_String("identifier");
    gc_root(strlit3781);
  }
// compiled string node returning strlit3781 (depth = 6)
  gc_frame_newslot(strlit3781);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3781;
  partcv[0] = 1;
  Object call3782 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3780);
// compiled call node returning call3782 (depth = 5)
  int op_slot_left_3772 = gc_frame_newslot(call3782);
  params[0] = opresult3778;
  partcv[0] = 1;
  Object opresult3783 = callmethod(call3782, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3783 (depth = 4)
  partcv[0] = 0;
  Object call3784 = callmethodflags(opresult3783, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3771);
// compiled call node returning call3784 (depth = 3)
  Object if3770 = done;
  if (istrue(call3784)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3785 = alloc_Float64(0);
// compiled num node returning num3785 (depth = 4)
  return num3785;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3770 = undefined;
  } else {
  }
// compiled if node returning if3770 (depth = 2)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3786 = gc_frame_new();
// call case 4: self request
  Object call3787 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3786);
// compiled member node returning call3787 (depth = 2)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3790 == NULL) {
    strlit3790 = alloc_String("lparen");
    gc_root(strlit3790);
  }
// compiled string node returning strlit3790 (depth = 4)
  int op_slot_right_3789 = gc_frame_newslot(strlit3790);
// starting to compile member node (depth = 4)
  int callframe3792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3793 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3792);
// compiled member node returning call3793 (depth = 4)
  int op_slot_left_3789 = gc_frame_newslot(call3793);
  params[0] = strlit3790;
  partcv[0] = 1;
  Object opresult3794 = callmethod(call3793, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3794 (depth = 3)
  Object if3788 = done;
  if (istrue(opresult3794)) {
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3795 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call3797 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3796);
// compiled member node returning call3797 (depth = 5)
  Object call3798 = callmethodflags(call3797, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3795);
// compiled member node returning call3798 (depth = 4)
  *var_suggestion = call3798;
  if (call3798 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3799 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3800 = alloc_Block(NULL, NULL, "parser", 1314);
  gc_frame_newslot(block3800);
// method "_apply(_)"
  block_savedest(block3800);
  Object closure3801 = createclosure(2, "_apply(1)");
  setclosureframe(closure3801, stackframe);
  addtoclosure(closure3801, var_matchTok);
  addtoclosure(closure3801, selfslot);
  struct UserObject *uo3801 = (struct UserObject*)block3800;
  uo3801->data[0] = (Object)closure3801;
  Method *meth_meth_parser_3801__apply_40_1_41_ = addmethod2pos(block3800, "_apply(1)", &meth_parser_3801__apply_40_1_41_, 0);
  int argcv_meth_parser_3801__apply_40_1_41_[] = {1};
  meth_meth_parser_3801__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_3801__apply_40_1_41_);
  meth_meth_parser_3801__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_3801__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block3800 (depth = 5)
  gc_frame_newslot(block3800);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block3800;
  partcv[0] = 1;
  Object call3837 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3799);
// compiled call node returning call3837 (depth = 4)
  *var_nextTok = call3837;
  if (call3837 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_3839 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool3841 = alloc_Boolean(0);
// compiled identifier node returning bool3841 (depth = 5)
  int op_slot_left_3839 = gc_frame_newslot(bool3841);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3842 = callmethod(bool3841, "==(1)", 1, partcv, params);
// compiled op node returning opresult3842 (depth = 4)
  Object if3838 = done;
  if (istrue(opresult3842)) {
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3843 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3844 == NULL) {
    strlit3844 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3844);
  }
// compiled string node returning strlit3844 (depth = 5)
  gc_frame_newslot(strlit3844);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3844;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3845 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3843);
// compiled call node returning call3845 (depth = 4)
    gc_frame_newslot(call3845);
    if3838 = call3845;
  } else {
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3848 == NULL) {
    strlit3848 = alloc_String("rparen");
    gc_root(strlit3848);
  }
// compiled string node returning strlit3848 (depth = 6)
  int op_slot_right_3847 = gc_frame_newslot(strlit3848);
// starting to compile member node (depth = 6)
  int callframe3850 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call3851 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3850);
// compiled member node returning call3851 (depth = 6)
  int op_slot_left_3847 = gc_frame_newslot(call3851);
  params[0] = strlit3848;
  partcv[0] = 1;
  Object opresult3852 = callmethod(call3851, "==(1)", 1, partcv, params);
// compiled op node returning opresult3852 (depth = 5)
  Object if3846 = done;
  if (istrue(opresult3852)) {
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3854 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3854 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3856 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3856 (depth = 6)
  Object if3853 = done;
  if (istrue(opresult3856)) {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3857 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3858 == NULL) {
    strlit3858 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3858);
  }
// compiled string node returning strlit3858 (depth = 7)
  gc_frame_newslot(strlit3858);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3858;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3859 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3857);
// compiled call node returning call3859 (depth = 6)
    gc_frame_newslot(call3859);
    if3853 = call3859;
  } else {
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3860 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3861 == NULL) {
    strlit3861 = alloc_String("(");
    gc_root(strlit3861);
  }
// compiled string node returning strlit3861 (depth = 7)
  gc_frame_newslot(strlit3861);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3861;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3862 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3860);
// compiled call node returning call3862 (depth = 6)
    gc_frame_newslot(call3862);
    if3853 = call3862;
  }
// compiled if node returning if3853 (depth = 5)
    gc_frame_newslot(if3853);
    if3846 = if3853;
  } else {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3865 == NULL) {
    strlit3865 = alloc_String("identifier");
    gc_root(strlit3865);
  }
// compiled string node returning strlit3865 (depth = 7)
  int op_slot_right_3864 = gc_frame_newslot(strlit3865);
// starting to compile member node (depth = 7)
  int callframe3867 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3868 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3867);
// compiled member node returning call3868 (depth = 7)
  int op_slot_left_3864 = gc_frame_newslot(call3868);
  params[0] = strlit3865;
  partcv[0] = 1;
  Object opresult3869 = callmethod(call3868, "==(1)", 1, partcv, params);
// compiled op node returning opresult3869 (depth = 6)
  Object if3863 = done;
  if (istrue(opresult3869)) {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3870 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3871 == NULL) {
    strlit3871 = alloc_String("(");
    gc_root(strlit3871);
  }
// compiled string node returning strlit3871 (depth = 7)
  gc_frame_newslot(strlit3871);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3871;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3872 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3870);
// compiled call node returning call3872 (depth = 6)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3873 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3874 == NULL) {
    strlit3874 = alloc_String(")");
    gc_root(strlit3874);
  }
// compiled string node returning strlit3874 (depth = 7)
  gc_frame_newslot(strlit3874);
// starting to compile member node (depth = 7)
  int callframe3875 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3876 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3875);
// compiled member node returning call3876 (depth = 7)
  gc_frame_newslot(call3876);
// starting to compile identifier node (depth = 7)
  Object bool3877 = alloc_Boolean(1);
// compiled identifier node returning bool3877 (depth = 7)
  gc_frame_newslot(bool3877);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3874;
  params[1] = call3876;
  params[2] = bool3877;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3878 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3873);
// compiled call node returning call3878 (depth = 6)
    gc_frame_newslot(call3878);
    if3863 = call3878;
  } else {
  }
// compiled if node returning if3863 (depth = 5)
    gc_frame_newslot(if3863);
    if3846 = if3863;
  }
// compiled if node returning if3846 (depth = 4)
    gc_frame_newslot(if3846);
    if3838 = if3846;
  }
// compiled if node returning if3838 (depth = 3)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3879 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3880 == NULL) {
    strlit3880 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit3880);
  }
// compiled string node returning strlit3880 (depth = 4)
  gc_frame_newslot(strlit3880);
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  Object call3882 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3881);
// compiled member node returning call3882 (depth = 4)
  gc_frame_newslot(call3882);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3884 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  Object call3885 = callmethodflags(*var_matchTok, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3884);
// compiled member node returning call3885 (depth = 5)
  int op_slot_right_3883 = gc_frame_newslot(call3885);
// starting to compile member node (depth = 5)
  int callframe3887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  Object call3888 = callmethodflags(*var_matchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3887);
// compiled member node returning call3888 (depth = 5)
  int op_slot_left_3883 = gc_frame_newslot(call3888);
  params[0] = call3885;
  partcv[0] = 1;
  Object sum3889 = callmethod(call3888, "+(1)", 1, partcv, params);
// compiled op node returning sum3889 (depth = 4)
  gc_frame_newslot(sum3889);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit3880;
  params[1] = call3882;
  params[2] = sum3889;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3890 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3879);
// compiled call node returning call3890 (depth = 3)
    gc_frame_newslot(call3890);
    if3788 = call3890;
  } else {
  }
// compiled if node returning if3788 (depth = 2)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3891 = gc_frame_new();
// call case 4: self request
  Object call3892 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3891);
// compiled member node returning call3892 (depth = 2)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3894 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3895 = alloc_Block(NULL, NULL, "parser", 1332);
  gc_frame_newslot(block3895);
// method "_apply"
  block_savedest(block3895);
  Object closure3896 = createclosure(2, "_apply");
  setclosureframe(closure3896, stackframe);
  addtoclosure(closure3896, var_blocksOK);
  addtoclosure(closure3896, selfslot);
  struct UserObject *uo3896 = (struct UserObject*)block3895;
  uo3896->data[0] = (Object)closure3896;
  Method *meth_meth_parser_3896__apply = addmethod2pos(block3895, "_apply", &meth_parser_3896__apply, 0);
  int argcv_meth_parser_3896__apply[] = {0};
  meth_meth_parser_3896__apply->type = alloc_MethodType(1, argcv_meth_parser_3896__apply);
  meth_meth_parser_3896__apply->definitionModule = modulename;
  meth_meth_parser_3896__apply->definitionLine = 3208;
// compiled block node returning block3895 (depth = 4)
  gc_frame_newslot(block3895);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block3895;
  partcv[0] = 1;
  Object call3900 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3894);
// compiled call node returning call3900 (depth = 3)
  Object if3893 = done;
  if (istrue(call3900)) {
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3901 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call3903 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3902);
// compiled member node returning call3903 (depth = 5)
  Object call3904 = callmethodflags(call3903, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3901);
// compiled member node returning call3904 (depth = 4)
  *var_suggestion = call3904;
  if (call3904 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3905 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array3906 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit3907 == NULL) {
    strlit3907 = alloc_String("rparen");
    gc_root(strlit3907);
  }
// compiled string node returning strlit3907 (depth = 6)
  params[0] = strlit3907;
  partcv[0] = 1;
  callmethodflags(array3906, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3906 (depth = 5)
  gc_frame_newslot(array3906);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = array3906;
  partcv[0] = 1;
  Object call3908 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3905);
// compiled call node returning call3908 (depth = 4)
  *var_nextTok = call3908;
  if (call3908 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_3910 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_3910 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3912 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3912 (depth = 4)
  Object if3909 = done;
  if (istrue(opresult3912)) {
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3913 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3914 == NULL) {
    strlit3914 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3914);
  }
// compiled string node returning strlit3914 (depth = 5)
  gc_frame_newslot(strlit3914);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3914;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3915 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3913);
// compiled call node returning call3915 (depth = 4)
    gc_frame_newslot(call3915);
    if3909 = call3915;
  } else {
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3916 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe3917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  Object call3918 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3917);
// compiled member node returning call3918 (depth = 5)
  gc_frame_newslot(call3918);
// starting to compile identifier node (depth = 5)
  Object bool3919 = alloc_Boolean(1);
// compiled identifier node returning bool3919 (depth = 5)
  gc_frame_newslot(bool3919);
// starting to compile identifier node (depth = 5)
  Object bool3920 = alloc_Boolean(0);
// compiled identifier node returning bool3920 (depth = 5)
  gc_frame_newslot(bool3920);
// starting to compile string node (depth = 5)
  if (strlit3921 == NULL) {
    strlit3921 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3921);
  }
// compiled string node returning strlit3921 (depth = 5)
  gc_frame_newslot(strlit3921);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call3918;
  params[2] = bool3919;
  params[3] = bool3920;
  params[4] = strlit3921;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3922 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3916);
// compiled call node returning call3922 (depth = 4)
    gc_frame_newslot(call3922);
    if3909 = call3922;
  }
// compiled if node returning if3909 (depth = 3)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3923 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3924 == NULL) {
    strlit3924 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit3924);
  }
// compiled string node returning strlit3924 (depth = 4)
  gc_frame_newslot(strlit3924);
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3926 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3925);
// compiled member node returning call3926 (depth = 4)
  gc_frame_newslot(call3926);
// starting to compile member node (depth = 4)
  int callframe3927 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3928 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3927);
// compiled member node returning call3928 (depth = 4)
  gc_frame_newslot(call3928);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit3924;
  params[1] = call3926;
  params[2] = call3928;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3929 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3923);
// compiled call node returning call3929 (depth = 3)
    gc_frame_newslot(call3929);
    if3893 = call3929;
  } else {
  }
// compiled if node returning if3893 (depth = 2)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3930 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call3931 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3930);
// compiled member node returning call3931 (depth = 3)
  *var_matchee = call3931;
  if (call3931 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3934 == NULL) {
    strlit3934 = alloc_String("rparen");
    gc_root(strlit3934);
  }
// compiled string node returning strlit3934 (depth = 4)
  int op_slot_right_3933 = gc_frame_newslot(strlit3934);
// starting to compile member node (depth = 4)
  int callframe3936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3937 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3936);
// compiled member node returning call3937 (depth = 4)
  int op_slot_left_3933 = gc_frame_newslot(call3937);
  params[0] = strlit3934;
  partcv[0] = 1;
  Object opresult3938 = callmethod(call3937, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3938 (depth = 3)
  Object if3932 = done;
  if (istrue(opresult3938)) {
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3939 = gc_frame_new();
// call case 4: self request
  Object call3940 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compiled member node returning call3940 (depth = 3)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3941 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3942 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call3943 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3942);
// compiled member node returning call3943 (depth = 5)
  Object call3944 = callmethodflags(call3943, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3941);
// compiled member node returning call3944 (depth = 4)
  *var_suggestion = call3944;
  if (call3944 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3945 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3946 == NULL) {
    strlit3946 = alloc_String(")");
    gc_root(strlit3946);
  }
// compiled string node returning strlit3946 (depth = 4)
  gc_frame_newslot(strlit3946);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit3946;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3947 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3945);
// compiled call node returning call3947 (depth = 3)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3948 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3949 == NULL) {
    strlit3949 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3949);
  }
// compiled string node returning strlit3949 (depth = 4)
  gc_frame_newslot(strlit3949);
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3950 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call3951 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3950);
// compiled member node returning call3951 (depth = 4)
  gc_frame_newslot(call3951);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3954 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3953);
// compiled member node returning call3954 (depth = 5)
  int op_slot_right_3952 = gc_frame_newslot(call3954);
// starting to compile member node (depth = 5)
  int callframe3956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3957 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3956);
// compiled member node returning call3957 (depth = 5)
  int op_slot_left_3952 = gc_frame_newslot(call3957);
  params[0] = call3954;
  partcv[0] = 1;
  Object sum3958 = callmethod(call3957, "+(1)", 1, partcv, params);
// compiled op node returning sum3958 (depth = 4)
  gc_frame_newslot(sum3958);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit3949;
  params[1] = call3951;
  params[2] = sum3958;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3959 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3948);
// compiled call node returning call3959 (depth = 3)
    gc_frame_newslot(call3959);
    if3932 = call3959;
  } else {
  }
// compiled if node returning if3932 (depth = 2)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3960 = gc_frame_new();
// call case 4: self request
  Object call3961 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3960);
// compiled member node returning call3961 (depth = 2)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3962 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3962 (depth = 3)
  *var_cases = array3962;
  if (array3962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3963 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3964 = alloc_Block(NULL, NULL, "parser", 1353);
  gc_frame_newslot(block3964);
// method "_apply"
  block_savedest(block3964);
  Object closure3965 = createclosure(2, "_apply");
  setclosureframe(closure3965, stackframe);
  addtoclosure(closure3965, var_sym);
  addtoclosure(closure3965, selfslot);
  struct UserObject *uo3965 = (struct UserObject*)block3964;
  uo3965->data[0] = (Object)closure3965;
  Method *meth_meth_parser_3965__apply = addmethod2pos(block3964, "_apply", &meth_parser_3965__apply, 0);
  int argcv_meth_parser_3965__apply[] = {0};
  meth_meth_parser_3965__apply->type = alloc_MethodType(1, argcv_meth_parser_3965__apply);
  meth_meth_parser_3965__apply->definitionModule = modulename;
  meth_meth_parser_3965__apply->definitionLine = 3208;
// compiled block node returning block3964 (depth = 3)
  gc_frame_newslot(block3964);
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block3979 = alloc_Block(NULL, NULL, "parser", 1353);
  gc_frame_newslot(block3979);
// method "_apply"
  block_savedest(block3979);
  Object closure3980 = createclosure(8, "_apply");
  setclosureframe(closure3980, stackframe);
  addtoclosure(closure3980, var_blocksOK);
  addtoclosure(closure3980, var_errormessages);
  addtoclosure(closure3980, var_sym);
  addtoclosure(closure3980, var_lastToken);
  addtoclosure(closure3980, var_tokens);
  addtoclosure(closure3980, var_values);
  addtoclosure(closure3980, var_cases);
  addtoclosure(closure3980, selfslot);
  struct UserObject *uo3980 = (struct UserObject*)block3979;
  uo3980->data[0] = (Object)closure3980;
  Method *meth_meth_parser_3980__apply = addmethod2pos(block3979, "_apply", &meth_parser_3980__apply, 0);
  int argcv_meth_parser_3980__apply[] = {0};
  meth_meth_parser_3980__apply->type = alloc_MethodType(1, argcv_meth_parser_3980__apply);
  meth_meth_parser_3980__apply->definitionModule = modulename;
  meth_meth_parser_3980__apply->definitionLine = 3208;
// compiled block node returning block3979 (depth = 3)
  gc_frame_newslot(block3979);
// call case 5: prelude request
  params[0] = block3964;
  params[1] = block3979;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4125 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3963);
// compiled call node returning call4125 (depth = 2)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4126 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  Object call4128 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4127);
// compiled member node returning call4128 (depth = 3)
  gc_frame_newslot(call4128);
// starting to compile member node (depth = 3)
  int callframe4129 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  Object call4130 = callmethodflags(*var_matchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4129);
// compiled member node returning call4130 (depth = 3)
  gc_frame_newslot(call4130);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4128;
  params[1] = call4130;
  partcv[0] = 2;
  Object call4131 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4126);
// compiled call node returning call4131 (depth = 2)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4132 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4133 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4134 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call4135 = callmethodflags(*var_ast, "matchCaseNode", 0, partcv, params, 0);
  gc_frame_end(callframe4134);
// compiled member node returning call4135 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  partcv[0] = 2;
  Object call4136 = callmethodflags(call4135, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4133);
// compiled call node returning call4136 (depth = 3)
  gc_frame_newslot(call4136);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4136;
  partcv[0] = 1;
  Object call4137 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4132);
// compiled call node returning call4137 (depth = 2)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_4139_term(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4140 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4141 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4142 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4141);
// compiled member node returning call4142 (depth = 3)
  gc_frame_newslot(call4142);
// starting to compile member node (depth = 3)
  int callframe4143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4144 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4143);
// compiled member node returning call4144 (depth = 3)
  gc_frame_newslot(call4144);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4142;
  params[1] = call4144;
  partcv[0] = 2;
  Object call4145 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4140);
// compiled call node returning call4145 (depth = 2)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4147 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4148 == NULL) {
    strlit4148 = alloc_String("num");
    gc_root(strlit4148);
  }
// compiled string node returning strlit4148 (depth = 4)
  gc_frame_newslot(strlit4148);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4148;
  partcv[0] = 1;
  Object call4149 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4147);
// compiled call node returning call4149 (depth = 3)
  Object if4146 = done;
  if (istrue(call4149)) {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4150 = gc_frame_new();
// call case 4: self request
  Object call4151 = callmethodflags(self, "pushnum", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4150);
// compiled member node returning call4151 (depth = 3)
    gc_frame_newslot(call4151);
    if4146 = call4151;
  } else {
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4153 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4154 == NULL) {
    strlit4154 = alloc_String("string");
    gc_root(strlit4154);
  }
// compiled string node returning strlit4154 (depth = 5)
  gc_frame_newslot(strlit4154);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit4154;
  partcv[0] = 1;
  Object call4155 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4153);
// compiled call node returning call4155 (depth = 4)
  Object if4152 = done;
  if (istrue(call4155)) {
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4156 = gc_frame_new();
// call case 4: self request
  Object call4157 = callmethodflags(self, "pushstring", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4156);
// compiled member node returning call4157 (depth = 4)
    gc_frame_newslot(call4157);
    if4152 = call4157;
  } else {
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4161 == NULL) {
    strlit4161 = alloc_String("match");
    gc_root(strlit4161);
  }
// compiled string node returning strlit4161 (depth = 7)
  int op_slot_right_4160 = gc_frame_newslot(strlit4161);
// starting to compile member node (depth = 7)
  int callframe4163 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4164 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4163);
// compiled member node returning call4164 (depth = 7)
  int op_slot_left_4160 = gc_frame_newslot(call4164);
  params[0] = strlit4161;
  partcv[0] = 1;
  Object opresult4165 = callmethod(call4164, "==(1)", 1, partcv, params);
// compiled op node returning opresult4165 (depth = 6)
  int op_slot_right_4159 = gc_frame_newslot(opresult4165);
// starting to compile call node (depth = 6)
  int callframe4167 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4168 == NULL) {
    strlit4168 = alloc_String("identifier");
    gc_root(strlit4168);
  }
// compiled string node returning strlit4168 (depth = 7)
  gc_frame_newslot(strlit4168);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit4168;
  partcv[0] = 1;
  Object call4169 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4167);
// compiled call node returning call4169 (depth = 6)
  int op_slot_left_4159 = gc_frame_newslot(call4169);
  params[0] = opresult4165;
  partcv[0] = 1;
  Object opresult4170 = callmethod(call4169, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4170 (depth = 5)
  Object if4158 = done;
  if (istrue(opresult4170)) {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4171 = gc_frame_new();
// call case 4: self request
  Object call4172 = callmethodflags(self, "matchcase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4171);
// compiled member node returning call4172 (depth = 5)
    gc_frame_newslot(call4172);
    if4158 = call4172;
  } else {
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("try");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 8)
  int op_slot_right_4175 = gc_frame_newslot(strlit4176);
// starting to compile member node (depth = 8)
  int callframe4178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4179 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4178);
// compiled member node returning call4179 (depth = 8)
  int op_slot_left_4175 = gc_frame_newslot(call4179);
  params[0] = strlit4176;
  partcv[0] = 1;
  Object opresult4180 = callmethod(call4179, "==(1)", 1, partcv, params);
// compiled op node returning opresult4180 (depth = 7)
  int op_slot_right_4174 = gc_frame_newslot(opresult4180);
// starting to compile call node (depth = 7)
  int callframe4182 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4183 == NULL) {
    strlit4183 = alloc_String("identifier");
    gc_root(strlit4183);
  }
// compiled string node returning strlit4183 (depth = 8)
  gc_frame_newslot(strlit4183);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit4183;
  partcv[0] = 1;
  Object call4184 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4182);
// compiled call node returning call4184 (depth = 7)
  int op_slot_left_4174 = gc_frame_newslot(call4184);
  params[0] = opresult4180;
  partcv[0] = 1;
  Object opresult4185 = callmethod(call4184, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4185 (depth = 6)
  Object if4173 = done;
  if (istrue(opresult4185)) {
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4186 = gc_frame_new();
// call case 4: self request
  Object call4187 = callmethodflags(self, "trycatch", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4186);
// compiled member node returning call4187 (depth = 6)
    gc_frame_newslot(call4187);
    if4173 = call4187;
  } else {
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4189 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4190 == NULL) {
    strlit4190 = alloc_String("identifier");
    gc_root(strlit4190);
  }
// compiled string node returning strlit4190 (depth = 8)
  gc_frame_newslot(strlit4190);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit4190;
  partcv[0] = 1;
  Object call4191 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4189);
// compiled call node returning call4191 (depth = 7)
  Object if4188 = done;
  if (istrue(call4191)) {
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4192 = gc_frame_new();
// call case 4: self request
  Object call4193 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4192);
// compiled member node returning call4193 (depth = 7)
    gc_frame_newslot(call4193);
    if4188 = call4193;
  } else {
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4195 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4196 == NULL) {
    strlit4196 = alloc_String("object");
    gc_root(strlit4196);
  }
// compiled string node returning strlit4196 (depth = 9)
  gc_frame_newslot(strlit4196);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit4196;
  partcv[0] = 1;
  Object call4197 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4195);
// compiled call node returning call4197 (depth = 8)
  Object if4194 = done;
  if (istrue(call4197)) {
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4198 = gc_frame_new();
// call case 4: self request
  Object call4199 = callmethodflags(self, "doobject", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled member node returning call4199 (depth = 8)
    gc_frame_newslot(call4199);
    if4194 = call4199;
  } else {
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4201 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4202 == NULL) {
    strlit4202 = alloc_String("type");
    gc_root(strlit4202);
  }
// compiled string node returning strlit4202 (depth = 10)
  gc_frame_newslot(strlit4202);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit4202;
  partcv[0] = 1;
  Object call4203 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4201);
// compiled call node returning call4203 (depth = 9)
  Object if4200 = done;
  if (istrue(call4203)) {
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe4204 = gc_frame_new();
// call case 4: self request
  Object call4205 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4204);
// compiled member node returning call4205 (depth = 9)
    gc_frame_newslot(call4205);
    if4200 = call4205;
  } else {
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe4207 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4208 == NULL) {
    strlit4208 = alloc_String("lbrace");
    gc_root(strlit4208);
  }
// compiled string node returning strlit4208 (depth = 11)
  gc_frame_newslot(strlit4208);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = strlit4208;
  partcv[0] = 1;
  Object call4209 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4207);
// compiled call node returning call4209 (depth = 10)
  Object if4206 = done;
  if (istrue(call4209)) {
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe4210 = gc_frame_new();
// call case 4: self request
  Object call4211 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4210);
// compiled member node returning call4211 (depth = 10)
    gc_frame_newslot(call4211);
    if4206 = call4211;
  } else {
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe4213 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit4214 == NULL) {
    strlit4214 = alloc_String("lsquare");
    gc_root(strlit4214);
  }
// compiled string node returning strlit4214 (depth = 12)
  gc_frame_newslot(strlit4214);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning module_parser (depth = 12)
  params[0] = strlit4214;
  partcv[0] = 1;
  Object call4215 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4213);
// compiled call node returning call4215 (depth = 11)
  Object if4212 = done;
  if (istrue(call4215)) {
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe4216 = gc_frame_new();
// call case 4: self request
  Object call4217 = callmethodflags(self, "doarray", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4216);
// compiled member node returning call4217 (depth = 11)
    gc_frame_newslot(call4217);
    if4212 = call4217;
  } else {
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe4219 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit4220 == NULL) {
    strlit4220 = alloc_String("op");
    gc_root(strlit4220);
  }
// compiled string node returning strlit4220 (depth = 13)
  gc_frame_newslot(strlit4220);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning module_parser (depth = 13)
  params[0] = strlit4220;
  partcv[0] = 1;
  Object call4221 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4219);
// compiled call node returning call4221 (depth = 12)
  Object if4218 = done;
  if (istrue(call4221)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe4222 = gc_frame_new();
// call case 4: self request
  Object call4223 = callmethodflags(self, "prefixop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4222);
// compiled member node returning call4223 (depth = 12)
    gc_frame_newslot(call4223);
    if4218 = call4223;
  } else {
  }
// compiled if node returning if4218 (depth = 11)
    gc_frame_newslot(if4218);
    if4212 = if4218;
  }
// compiled if node returning if4212 (depth = 10)
    gc_frame_newslot(if4212);
    if4206 = if4212;
  }
// compiled if node returning if4206 (depth = 9)
    gc_frame_newslot(if4206);
    if4200 = if4206;
  }
// compiled if node returning if4200 (depth = 8)
    gc_frame_newslot(if4200);
    if4194 = if4200;
  }
// compiled if node returning if4194 (depth = 7)
    gc_frame_newslot(if4194);
    if4188 = if4194;
  }
// compiled if node returning if4188 (depth = 6)
    gc_frame_newslot(if4188);
    if4173 = if4188;
  }
// compiled if node returning if4173 (depth = 5)
    gc_frame_newslot(if4173);
    if4158 = if4173;
  }
// compiled if node returning if4158 (depth = 4)
    gc_frame_newslot(if4158);
    if4152 = if4158;
  }
// compiled if node returning if4152 (depth = 3)
    gc_frame_newslot(if4152);
    if4146 = if4152;
  }
// compiled if node returning if4146 (depth = 2)
  gc_frame_end(frame);
  return if4146;
}
Object meth_parser_4250__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe4251 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_acceptBlocks (depth = 8)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4252 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4251);
// compiled call node returning call4252 (depth = 7)
  gc_frame_end(frame);
  return call4252;
}
Object meth_parser_4224_expression_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expression(_)");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expression(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expression(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// definebindings:
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call4226 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4225);
// compiled member node returning call4226 (depth = 3)
  *var_sz = call4226;
  if (call4226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4227 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4229 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4228);
// compiled member node returning call4229 (depth = 3)
  gc_frame_newslot(call4229);
// starting to compile member node (depth = 3)
  int callframe4230 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4231 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4230);
// compiled member node returning call4231 (depth = 3)
  gc_frame_newslot(call4231);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4229;
  params[1] = call4231;
  partcv[0] = 2;
  Object call4232 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4227);
// compiled call node returning call4232 (depth = 2)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4234 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4235 == NULL) {
    strlit4235 = alloc_String("lparen");
    gc_root(strlit4235);
  }
// compiled string node returning strlit4235 (depth = 4)
  gc_frame_newslot(strlit4235);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4235;
  partcv[0] = 1;
  Object call4236 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4234);
// compiled call node returning call4236 (depth = 3)
  Object if4233 = done;
  if (istrue(call4236)) {
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4238 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4239 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4240 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4239);
// compiled member node returning call4240 (depth = 4)
  gc_frame_newslot(call4240);
// starting to compile member node (depth = 4)
  int callframe4241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4242 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4241);
// compiled member node returning call4242 (depth = 4)
  gc_frame_newslot(call4242);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4240;
  params[1] = call4242;
  partcv[0] = 2;
  Object call4243 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4238);
// compiled call node returning call4243 (depth = 3)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4244 = gc_frame_new();
// call case 4: self request
  Object call4245 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4244);
// compiled member node returning call4245 (depth = 3)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4247 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe4248 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4249 = alloc_Block(NULL, NULL, "parser", 1446);
  gc_frame_newslot(block4249);
// method "_apply"
  block_savedest(block4249);
  Object closure4250 = createclosure(2, "_apply");
  setclosureframe(closure4250, stackframe);
  addtoclosure(closure4250, var_acceptBlocks);
  addtoclosure(closure4250, selfslot);
  struct UserObject *uo4250 = (struct UserObject*)block4249;
  uo4250->data[0] = (Object)closure4250;
  Method *meth_meth_parser_4250__apply = addmethod2pos(block4249, "_apply", &meth_parser_4250__apply, 0);
  int argcv_meth_parser_4250__apply[] = {0};
  meth_meth_parser_4250__apply->type = alloc_MethodType(1, argcv_meth_parser_4250__apply);
  meth_meth_parser_4250__apply->definitionModule = modulename;
  meth_meth_parser_4250__apply->definitionLine = 3208;
// compiled block node returning block4249 (depth = 6)
  gc_frame_newslot(block4249);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block4249;
  partcv[0] = 1;
  Object call4254 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4248);
// compiled call node returning call4254 (depth = 5)
  Object call4255 = callmethodflags(call4254, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4247);
// compiled member node returning call4255 (depth = 4)
  Object if4246 = done;
  if (istrue(call4255)) {
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4256 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4258 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4257);
// compiled member node returning call4258 (depth = 6)
  Object call4259 = callmethodflags(call4258, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4256);
// compiled member node returning call4259 (depth = 5)
  *var_suggestion = call4259;
  if (call4259 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4260 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4261 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4262 == NULL) {
    strlit4262 = alloc_String("rparen");
    gc_root(strlit4262);
  }
// compiled string node returning strlit4262 (depth = 7)
  params[0] = strlit4262;
  partcv[0] = 1;
  callmethodflags(array4261, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4261 (depth = 6)
  gc_frame_newslot(array4261);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array4261;
  partcv[0] = 1;
  Object call4263 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4260);
// compiled call node returning call4263 (depth = 5)
  *var_nextTok = call4263;
  if (call4263 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4265 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4265 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4267 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4267 (depth = 5)
  Object if4264 = done;
  if (istrue(opresult4267)) {
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4268 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4269 == NULL) {
    strlit4269 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4269);
  }
// compiled string node returning strlit4269 (depth = 6)
  gc_frame_newslot(strlit4269);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4269;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4270 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4268);
// compiled call node returning call4270 (depth = 5)
    gc_frame_newslot(call4270);
    if4264 = call4270;
  } else {
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4271 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe4272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call4273 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4272);
// compiled member node returning call4273 (depth = 6)
  gc_frame_newslot(call4273);
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool4274 = alloc_Boolean(1);
// compiled identifier node returning bool4274 (depth = 6)
  gc_frame_newslot(bool4274);
// starting to compile identifier node (depth = 6)
  Object bool4275 = alloc_Boolean(0);
// compiled identifier node returning bool4275 (depth = 6)
  gc_frame_newslot(bool4275);
// starting to compile string node (depth = 6)
  if (strlit4276 == NULL) {
    strlit4276 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4276);
  }
// compiled string node returning strlit4276 (depth = 6)
  gc_frame_newslot(strlit4276);
// call case 6: other requests
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4273;
  params[2] = bool4274;
  params[3] = bool4275;
  params[4] = strlit4276;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4277 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4271);
// compiled call node returning call4277 (depth = 5)
    gc_frame_newslot(call4277);
    if4264 = call4277;
  }
// compiled if node returning if4264 (depth = 4)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4278 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4279 == NULL) {
    strlit4279 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit4279);
  }
// compiled string node returning strlit4279 (depth = 5)
  gc_frame_newslot(strlit4279);
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4280 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4281 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4280);
// compiled member node returning call4281 (depth = 5)
  gc_frame_newslot(call4281);
// starting to compile member node (depth = 5)
  int callframe4282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4283 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4282);
// compiled member node returning call4283 (depth = 5)
  gc_frame_newslot(call4283);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4279;
  params[1] = call4281;
  params[2] = call4283;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4284 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4278);
// compiled call node returning call4284 (depth = 4)
    gc_frame_newslot(call4284);
    if4246 = call4284;
  } else {
  }
// compiled if node returning if4246 (depth = 3)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4287 == NULL) {
    strlit4287 = alloc_String("rparen");
    gc_root(strlit4287);
  }
// compiled string node returning strlit4287 (depth = 5)
  int op_slot_right_4286 = gc_frame_newslot(strlit4287);
// starting to compile member node (depth = 5)
  int callframe4289 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4290 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4289);
// compiled member node returning call4290 (depth = 5)
  int op_slot_left_4286 = gc_frame_newslot(call4290);
  params[0] = strlit4287;
  partcv[0] = 1;
  Object opresult4291 = callmethod(call4290, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4291 (depth = 4)
  Object if4285 = done;
  if (istrue(opresult4291)) {
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4292 = gc_frame_new();
// call case 4: self request
  Object call4293 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4292);
// compiled member node returning call4293 (depth = 4)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4294 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4296 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4295);
// compiled member node returning call4296 (depth = 6)
  Object call4297 = callmethodflags(call4296, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4294);
// compiled member node returning call4297 (depth = 5)
  *var_suggestion = call4297;
  if (call4297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4298 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4299 == NULL) {
    strlit4299 = alloc_String(")");
    gc_root(strlit4299);
  }
// compiled string node returning strlit4299 (depth = 5)
  gc_frame_newslot(strlit4299);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4299;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4300 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4298);
// compiled call node returning call4300 (depth = 4)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4301 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4302 == NULL) {
    strlit4302 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4302);
  }
// compiled string node returning strlit4302 (depth = 5)
  gc_frame_newslot(strlit4302);
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4303 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call4304 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4303);
// compiled member node returning call4304 (depth = 5)
  gc_frame_newslot(call4304);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4306 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4307 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4306);
// compiled member node returning call4307 (depth = 6)
  int op_slot_right_4305 = gc_frame_newslot(call4307);
// starting to compile member node (depth = 6)
  int callframe4309 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4310 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4309);
// compiled member node returning call4310 (depth = 6)
  int op_slot_left_4305 = gc_frame_newslot(call4310);
  params[0] = call4307;
  partcv[0] = 1;
  Object sum4311 = callmethod(call4310, "+(1)", 1, partcv, params);
// compiled op node returning sum4311 (depth = 5)
  gc_frame_newslot(sum4311);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4302;
  params[1] = call4304;
  params[2] = sum4311;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4312 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4301);
// compiled call node returning call4312 (depth = 4)
    gc_frame_newslot(call4312);
    if4285 = call4312;
  } else {
  }
// compiled if node returning if4285 (depth = 3)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4314 = gc_frame_new();
// call case 4: self request
  Object call4315 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4314);
// compiled member node returning call4315 (depth = 3)
    gc_frame_newslot(call4315);
    if4233 = call4315;
  } else {
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4316 = gc_frame_new();
// call case 4: self request
  Object call4317 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4316);
// compiled member node returning call4317 (depth = 3)
    gc_frame_newslot(call4317);
    if4233 = call4317;
  }
// compiled if node returning if4233 (depth = 2)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_4319 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe4321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call4322 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4321);
// compiled member node returning call4322 (depth = 4)
  int op_slot_left_4319 = gc_frame_newslot(call4322);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult4323 = callmethod(call4322, ">(1)", 1, partcv, params);
// compiled op node returning opresult4323 (depth = 3)
  Object if4318 = done;
  if (istrue(opresult4323)) {
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4324 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4325 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 3)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4326 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4327 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4326);
// compiled call node returning call4327 (depth = 3)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4328 = gc_frame_new();
// call case 4: self request
  Object call4329 = callmethodflags(self, "valueexpressionrest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4328);
// compiled member node returning call4329 (depth = 3)
    gc_frame_newslot(call4329);
    if4318 = call4329;
  } else {
  }
// compiled if node returning if4318 (depth = 2)
  gc_frame_end(frame);
  return if4318;
}
Object meth_parser_4330_oprec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method oprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part oprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4333 == NULL) {
    strlit4333 = alloc_String("*");
    gc_root(strlit4333);
  }
// compiled string node returning strlit4333 (depth = 4)
  int op_slot_right_4332 = gc_frame_newslot(strlit4333);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_4332 = gc_frame_newslot(*var_o);
  params[0] = strlit4333;
  partcv[0] = 1;
  Object opresult4335 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4335 (depth = 3)
  Object if4331 = done;
  if (istrue(opresult4335)) {
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4336 = alloc_Float64(10);
// compiled num node returning num4336 (depth = 4)
  return num4336;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4331 = undefined;
  } else {
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4339 == NULL) {
    strlit4339 = alloc_String("/");
    gc_root(strlit4339);
  }
// compiled string node returning strlit4339 (depth = 5)
  int op_slot_right_4338 = gc_frame_newslot(strlit4339);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_4338 = gc_frame_newslot(*var_o);
  params[0] = strlit4339;
  partcv[0] = 1;
  Object opresult4341 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4341 (depth = 4)
  Object if4337 = done;
  if (istrue(opresult4341)) {
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4342 = alloc_Float64(10);
// compiled num node returning num4342 (depth = 5)
  return num4342;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4337 = undefined;
  } else {
  }
// compiled if node returning if4337 (depth = 3)
    gc_frame_newslot(if4337);
    if4331 = if4337;
  }
// compiled if node returning if4331 (depth = 2)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4343 = alloc_Float64(5);
// compiled num node returning num4343 (depth = 3)
  return num4343;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_4344_toprec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// definebindings:
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4347 = alloc_Float64(0);
// compiled num node returning num4347 (depth = 4)
  int op_slot_right_4346 = gc_frame_newslot(num4347);
// starting to compile member node (depth = 4)
  int callframe4349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  Object call4350 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4349);
// compiled member node returning call4350 (depth = 4)
  int op_slot_left_4346 = gc_frame_newslot(call4350);
  params[0] = num4347;
  partcv[0] = 1;
  Object opresult4351 = callmethod(call4350, ">(1)", 1, partcv, params);
// compiled op node returning opresult4351 (depth = 3)
  Object if4345 = done;
  if (istrue(opresult4351)) {
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4352 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  Object call4353 = callmethodflags(*var_ops, "last", 0, partcv, params, 0);
  gc_frame_end(callframe4352);
// compiled member node returning call4353 (depth = 4)
  *var_o = call4353;
  if (call4353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4354 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4355 = callmethodflags(module_parser, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4354);
// compiled call node returning call4355 (depth = 4)
  return call4355;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4345 = undefined;
  } else {
  }
// compiled if node returning if4345 (depth = 2)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4356 = alloc_Float64(0);
// compiled num node returning num4356 (depth = 2)
  gc_frame_end(frame);
  return num4356;
}
Object meth_parser_4365__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe4366 = gc_frame_new();
// call case 4: self request
  Object call4367 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4366);
// compiled member node returning call4367 (depth = 5)
  gc_frame_end(frame);
  return call4367;
}
Object meth_parser_4357_typeexpressionrest(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4359 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4360 == NULL) {
    strlit4360 = alloc_String("op");
    gc_root(strlit4360);
  }
// compiled string node returning strlit4360 (depth = 4)
  gc_frame_newslot(strlit4360);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4360;
  partcv[0] = 1;
  Object call4361 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4359);
// compiled call node returning call4361 (depth = 3)
  Object if4358 = done;
  if (istrue(call4361)) {
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4362 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4363 == NULL) {
    strlit4363 = alloc_String("type expression");
    gc_root(strlit4363);
  }
// compiled string node returning strlit4363 (depth = 4)
  gc_frame_newslot(strlit4363);
// starting to compile block node (depth = 4)
  Object block4364 = alloc_Block(NULL, NULL, "parser", 1502);
  gc_frame_newslot(block4364);
// method "_apply"
  block_savedest(block4364);
  Object closure4365 = createclosure(1, "_apply");
  setclosureframe(closure4365, stackframe);
  addtoclosure(closure4365, selfslot);
  struct UserObject *uo4365 = (struct UserObject*)block4364;
  uo4365->data[0] = (Object)closure4365;
  Method *meth_meth_parser_4365__apply = addmethod2pos(block4364, "_apply", &meth_parser_4365__apply, 0);
  int argcv_meth_parser_4365__apply[] = {0};
  meth_meth_parser_4365__apply->type = alloc_MethodType(1, argcv_meth_parser_4365__apply);
  meth_meth_parser_4365__apply->definitionModule = modulename;
  meth_meth_parser_4365__apply->definitionLine = 3208;
// compiled block node returning block4364 (depth = 4)
  gc_frame_newslot(block4364);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4363;
  params[1] = block4364;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4369 = callmethodflags(module_parser, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4362);
// compiled call node returning call4369 (depth = 3)
    gc_frame_newslot(call4369);
    if4358 = call4369;
  } else {
  }
// compiled if node returning if4358 (depth = 2)
  gc_frame_end(frame);
  return if4358;
}
Object meth_parser_4378__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe4379 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4380 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4379);
// compiled call node returning call4380 (depth = 5)
  gc_frame_end(frame);
  return call4380;
}
Object meth_parser_4370_valueexpressionrest(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4372 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4373 == NULL) {
    strlit4373 = alloc_String("op");
    gc_root(strlit4373);
  }
// compiled string node returning strlit4373 (depth = 4)
  gc_frame_newslot(strlit4373);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4373;
  partcv[0] = 1;
  Object call4374 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4372);
// compiled call node returning call4374 (depth = 3)
  Object if4371 = done;
  if (istrue(call4374)) {
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4375 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4376 == NULL) {
    strlit4376 = alloc_String("expression");
    gc_root(strlit4376);
  }
// compiled string node returning strlit4376 (depth = 4)
  gc_frame_newslot(strlit4376);
// starting to compile block node (depth = 4)
  Object block4377 = alloc_Block(NULL, NULL, "parser", 1508);
  gc_frame_newslot(block4377);
// method "_apply"
  block_savedest(block4377);
  Object closure4378 = createclosure(2, "_apply");
  setclosureframe(closure4378, stackframe);
  addtoclosure(closure4378, var_blocksOK);
  addtoclosure(closure4378, selfslot);
  struct UserObject *uo4378 = (struct UserObject*)block4377;
  uo4378->data[0] = (Object)closure4378;
  Method *meth_meth_parser_4378__apply = addmethod2pos(block4377, "_apply", &meth_parser_4378__apply, 0);
  int argcv_meth_parser_4378__apply[] = {0};
  meth_meth_parser_4378__apply->type = alloc_MethodType(1, argcv_meth_parser_4378__apply);
  meth_meth_parser_4378__apply->definitionModule = modulename;
  meth_meth_parser_4378__apply->definitionLine = 3208;
// compiled block node returning block4377 (depth = 4)
  gc_frame_newslot(block4377);
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4376;
  params[1] = block4377;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4382 = callmethodflags(module_parser, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4375);
// compiled call node returning call4382 (depth = 3)
    gc_frame_newslot(call4382);
    if4371 = call4382;
  } else {
  }
// compiled if node returning if4371 (depth = 2)
  gc_frame_end(frame);
  return if4371;
}
Object meth_parser_4398__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4400 == NULL) {
    strlit4400 = alloc_String("=");
    gc_root(strlit4400);
  }
// compiled string node returning strlit4400 (depth = 7)
  int op_slot_right_4399 = gc_frame_newslot(strlit4400);
// starting to compile member node (depth = 7)
  int callframe4402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4403 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4402);
// compiled member node returning call4403 (depth = 7)
  int op_slot_left_4399 = gc_frame_newslot(call4403);
  params[0] = strlit4400;
  partcv[0] = 1;
  Object opresult4404 = callmethod(call4403, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4404 (depth = 6)
  gc_frame_end(frame);
  return opresult4404;
}
Object meth_parser_4395__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block4397 = alloc_Block(NULL, NULL, "parser", 1532);
  gc_frame_newslot(block4397);
// method "_apply"
  block_savedest(block4397);
  Object closure4398 = createclosure(2, "_apply");
  setclosureframe(closure4398, stackframe);
  addtoclosure(closure4398, var_sym);
  addtoclosure(closure4398, selfslot);
  struct UserObject *uo4398 = (struct UserObject*)block4397;
  uo4398->data[0] = (Object)closure4398;
  Method *meth_meth_parser_4398__apply = addmethod2pos(block4397, "_apply", &meth_parser_4398__apply, 0);
  int argcv_meth_parser_4398__apply[] = {0};
  meth_meth_parser_4398__apply->type = alloc_MethodType(1, argcv_meth_parser_4398__apply);
  meth_meth_parser_4398__apply->definitionModule = modulename;
  meth_meth_parser_4398__apply->definitionLine = 3208;
// compiled block node returning block4397 (depth = 5)
  int op_slot_right_4396 = gc_frame_newslot(block4397);
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4407 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4408 == NULL) {
    strlit4408 = alloc_String("op");
    gc_root(strlit4408);
  }
// compiled string node returning strlit4408 (depth = 6)
  gc_frame_newslot(strlit4408);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4408;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4409 = callmethodflags(module_parser, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4407);
// compiled call node returning call4409 (depth = 5)
  int op_slot_left_4396 = gc_frame_newslot(call4409);
  params[0] = block4397;
  partcv[0] = 1;
  Object opresult4410 = callmethod(call4409, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4410 (depth = 4)
  gc_frame_end(frame);
  return opresult4410;
}
Object meth_parser_4535__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4538 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call4539 = callmethodflags(module_parser, "toprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4538);
// compiled call node returning call4539 (depth = 8)
  int op_slot_right_4537 = gc_frame_newslot(call4539);
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_4537 = gc_frame_newslot(*var_prec);
  params[0] = call4539;
  partcv[0] = 1;
  Object opresult4541 = callmethod(*var_prec, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4541 (depth = 7)
  int op_slot_right_4536 = gc_frame_newslot(opresult4541);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4544 = alloc_Float64(0);
// compiled num node returning num4544 (depth = 8)
  int op_slot_right_4543 = gc_frame_newslot(num4544);
// starting to compile member node (depth = 8)
  int callframe4546 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  Object call4547 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4546);
// compiled member node returning call4547 (depth = 8)
  int op_slot_left_4543 = gc_frame_newslot(call4547);
  params[0] = num4544;
  partcv[0] = 1;
  Object opresult4548 = callmethod(call4547, ">(1)", 1, partcv, params);
// compiled op node returning opresult4548 (depth = 7)
  int op_slot_left_4536 = gc_frame_newslot(opresult4548);
  params[0] = opresult4541;
  partcv[0] = 1;
  Object opresult4549 = callmethod(opresult4548, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4549 (depth = 6)
  gc_frame_end(frame);
  return opresult4549;
}
Object meth_parser_4552__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4553 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ops (depth = 8)
  Object call4554 = callmethodflags(*var_ops, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4553);
// compiled member node returning call4554 (depth = 7)
  *var_o2 = call4554;
  if (call4554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4556 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  Object call4557 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4556);
// compiled member node returning call4557 (depth = 7)
  *var_tmp2 = call4557;
  if (call4557 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  Object call4560 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4559);
// compiled member node returning call4560 (depth = 7)
  *var_tmp = call4560;
  if (call4560 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4562 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4563 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  Object call4564 = callmethodflags(*var_tmp, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4563);
// compiled member node returning call4564 (depth = 7)
  gc_frame_newslot(call4564);
// starting to compile member node (depth = 7)
  int callframe4565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  Object call4566 = callmethodflags(*var_tmp, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4565);
// compiled member node returning call4566 (depth = 7)
  gc_frame_newslot(call4566);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call4564;
  params[1] = call4566;
  partcv[0] = 2;
  Object call4567 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4562);
// compiled call node returning call4567 (depth = 6)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4568 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4569 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  Object call4570 = callmethodflags(*var_ast, "opNode", 0, partcv, params, 0);
  gc_frame_end(callframe4569);
// compiled member node returning call4570 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call4571 = callmethodflags(call4570, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4568);
// compiled call node returning call4571 (depth = 7)
  *var_tmp = call4571;
  if (call4571 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4573 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4574 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4573);
// compiled call node returning call4574 (depth = 6)
  gc_frame_end(frame);
  return call4574;
}
Object meth_parser_4750__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe4751 = gc_frame_new();
// call case 4: self request
  Object call4752 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4751);
// compiled member node returning call4752 (depth = 8)
  gc_frame_end(frame);
  return call4752;
}
Object meth_parser_4413__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_statementToken = getfromclosure(closure, 17);
  Object *var_acceptBlocks = getfromclosure(closure, 18);
  Object *var_values = getfromclosure(closure, 19);
  Object self = *(getfromclosure(closure, 20));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4415 = alloc_Float64(1);
// compiled num node returning num4415 (depth = 6)
  int op_slot_right_4414 = gc_frame_newslot(num4415);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_4414 = gc_frame_newslot(*var_opcount);
  params[0] = num4415;
  partcv[0] = 1;
  Object sum4417 = callmethod(*var_opcount, "+(1)", 1, partcv, params);
// compiled op node returning sum4417 (depth = 5)
  *var_opcount = sum4417;
  if (sum4417 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4419 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4420 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4419);
// compiled member node returning call4420 (depth = 5)
  *var_o = call4420;
  if (call4420 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4422 = gc_frame_new();
// call case 4: self request
  Object call4423 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4422);
// compiled member node returning call4423 (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4424 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4425 = callmethodflags(module_parser, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4424);
// compiled call node returning call4425 (depth = 5)
  *var_prec = call4425;
  if (call4425 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4430 == NULL) {
    strlit4430 = alloc_String("-");
    gc_root(strlit4430);
  }
// compiled string node returning strlit4430 (depth = 7)
  int op_slot_right_4429 = gc_frame_newslot(strlit4430);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_4429 = gc_frame_newslot(*var_o);
  params[0] = strlit4430;
  partcv[0] = 1;
  Object opresult4432 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4432 (depth = 6)
  int op_slot_right_4428 = gc_frame_newslot(opresult4432);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4436 == NULL) {
    strlit4436 = alloc_String("+");
    gc_root(strlit4436);
  }
// compiled string node returning strlit4436 (depth = 8)
  int op_slot_right_4435 = gc_frame_newslot(strlit4436);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_4435 = gc_frame_newslot(*var_o);
  params[0] = strlit4436;
  partcv[0] = 1;
  Object opresult4438 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4438 (depth = 7)
  int op_slot_right_4434 = gc_frame_newslot(opresult4438);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4442 == NULL) {
    strlit4442 = alloc_String("/");
    gc_root(strlit4442);
  }
// compiled string node returning strlit4442 (depth = 9)
  int op_slot_right_4441 = gc_frame_newslot(strlit4442);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4441 = gc_frame_newslot(*var_o);
  params[0] = strlit4442;
  partcv[0] = 1;
  Object opresult4444 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4444 (depth = 8)
  int op_slot_right_4440 = gc_frame_newslot(opresult4444);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4447 == NULL) {
    strlit4447 = alloc_String("*");
    gc_root(strlit4447);
  }
// compiled string node returning strlit4447 (depth = 9)
  int op_slot_right_4446 = gc_frame_newslot(strlit4447);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4446 = gc_frame_newslot(*var_o);
  params[0] = strlit4447;
  partcv[0] = 1;
  Object opresult4449 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4449 (depth = 8)
  int op_slot_left_4440 = gc_frame_newslot(opresult4449);
  params[0] = opresult4444;
  partcv[0] = 1;
  Object opresult4450 = callmethod(opresult4449, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4450 (depth = 7)
  int op_slot_left_4434 = gc_frame_newslot(opresult4450);
  params[0] = opresult4438;
  partcv[0] = 1;
  Object opresult4451 = callmethod(opresult4450, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4451 (depth = 6)
  int op_slot_left_4428 = gc_frame_newslot(opresult4451);
  params[0] = opresult4432;
  partcv[0] = 1;
  Object opresult4452 = callmethod(opresult4451, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4452 (depth = 5)
  Object if4427 = done;
  if (istrue(opresult4452)) {
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4453 = alloc_Boolean(0);
// compiled identifier node returning bool4453 (depth = 6)
  *var_allarith = bool4453;
  if (bool4453 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4427 = done;
  } else {
  }
// compiled if node returning if4427 (depth = 4)
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_allarith (depth = 7)
  Object call4458 = callmethodflags(*var_allarith, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4457);
// compiled member node returning call4458 (depth = 6)
  int op_slot_right_4456 = gc_frame_newslot(call4458);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_4461 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4461 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult4463 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4463 (depth = 7)
  int op_slot_right_4460 = gc_frame_newslot(opresult4463);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4466 == NULL) {
    strlit4466 = alloc_String("");
    gc_root(strlit4466);
  }
// compiled string node returning strlit4466 (depth = 8)
  int op_slot_right_4465 = gc_frame_newslot(strlit4466);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4465 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit4466;
  partcv[0] = 1;
  Object opresult4468 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4468 (depth = 7)
  int op_slot_left_4460 = gc_frame_newslot(opresult4468);
  params[0] = opresult4463;
  partcv[0] = 1;
  Object opresult4469 = callmethod(opresult4468, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4469 (depth = 6)
  int op_slot_left_4456 = gc_frame_newslot(opresult4469);
  params[0] = call4458;
  partcv[0] = 1;
  Object opresult4470 = callmethod(opresult4469, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4470 (depth = 5)
  Object if4455 = done;
  if (istrue(opresult4470)) {
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4471 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4471 (depth = 6)
  *var_suggestions = array4471;
  if (array4471 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4472 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4473 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4474 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4473);
// compiled member node returning call4474 (depth = 7)
  Object call4475 = callmethodflags(call4474, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4472);
// compiled member node returning call4475 (depth = 6)
  *var_suggestion = call4475;
  if (call4475 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4476 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4477 == NULL) {
    strlit4477 = alloc_String(")");
    gc_root(strlit4477);
  }
// compiled string node returning strlit4477 (depth = 6)
  gc_frame_newslot(strlit4477);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4477;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4478 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4476);
// compiled call node returning call4478 (depth = 5)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4479 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4480 == NULL) {
    strlit4480 = alloc_String("(");
    gc_root(strlit4480);
  }
// compiled string node returning strlit4480 (depth = 6)
  gc_frame_newslot(strlit4480);
// starting to compile member node (depth = 6)
  int callframe4481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4482 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4481);
// compiled member node returning call4482 (depth = 6)
  gc_frame_newslot(call4482);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4480;
  params[1] = call4482;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4483 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4479);
// compiled call node returning call4483 (depth = 5)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4484 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4485 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4484);
// compiled call node returning call4485 (depth = 5)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4486 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4487 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4488 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4487);
// compiled member node returning call4488 (depth = 7)
  Object call4489 = callmethodflags(call4488, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4486);
// compiled member node returning call4489 (depth = 6)
  *var_suggestion = call4489;
  if (call4489 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4491 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String(")");
    gc_root(strlit4492);
  }
// compiled string node returning strlit4492 (depth = 6)
  gc_frame_newslot(strlit4492);
// starting to compile member node (depth = 6)
  int callframe4493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4494 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4493);
// compiled member node returning call4494 (depth = 6)
  gc_frame_newslot(call4494);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4492;
  params[1] = call4494;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4495 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4491);
// compiled call node returning call4495 (depth = 5)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4496 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4497 == NULL) {
    strlit4497 = alloc_String("(");
    gc_root(strlit4497);
  }
// compiled string node returning strlit4497 (depth = 6)
  gc_frame_newslot(strlit4497);
// starting to compile member node (depth = 6)
  int callframe4498 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4499 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4501 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4500);
// compiled member node returning call4501 (depth = 8)
  Object call4502 = callmethodflags(call4501, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4499);
// compiled member node returning call4502 (depth = 7)
  Object call4503 = callmethodflags(call4502, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4498);
// compiled member node returning call4503 (depth = 6)
  gc_frame_newslot(call4503);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4497;
  params[1] = call4503;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4504 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4496);
// compiled call node returning call4504 (depth = 5)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4505 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4506 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4505);
// compiled call node returning call4506 (depth = 5)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4507 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4509 == NULL) {
    strlit4509 = alloc_String("and non-arithmetic operators requires parentheses.");
    gc_root(strlit4509);
  }
// compiled string node returning strlit4509 (depth = 7)
  int op_slot_right_4508 = gc_frame_newslot(strlit4509);
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4511 == NULL) {
    strlit4511 = alloc_String("an expression containing both arithmetic ");
    gc_root(strlit4511);
  }
// compiled string node returning strlit4511 (depth = 7)
  int op_slot_left_4508 = gc_frame_newslot(strlit4511);
  params[0] = strlit4509;
  partcv[0] = 1;
  Object opresult4512 = callmethod(strlit4511, "++(1)", 1, partcv, params);
// compiled op node returning opresult4512 (depth = 6)
  gc_frame_newslot(opresult4512);
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4513 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4514 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4515 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4517 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4516);
// compiled member node returning call4517 (depth = 9)
  Object call4518 = callmethodflags(call4517, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4515);
// compiled member node returning call4518 (depth = 8)
  Object call4519 = callmethodflags(call4518, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4514);
// compiled member node returning call4519 (depth = 7)
  Object call4520 = callmethodflags(call4519, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4513);
// compiled member node returning call4520 (depth = 6)
  gc_frame_newslot(call4520);
// starting to compile member node (depth = 6)
  int callframe4521 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4522 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4523 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4524 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4525 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4524);
// compiled member node returning call4525 (depth = 9)
  Object call4526 = callmethodflags(call4525, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4523);
// compiled member node returning call4526 (depth = 8)
  Object call4527 = callmethodflags(call4526, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4522);
// compiled member node returning call4527 (depth = 7)
  Object call4528 = callmethodflags(call4527, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4521);
// compiled member node returning call4528 (depth = 6)
  gc_frame_newslot(call4528);
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4530 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4529);
// compiled member node returning call4530 (depth = 6)
  gc_frame_newslot(call4530);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult4512;
  params[1] = call4520;
  params[2] = call4528;
  params[3] = call4530;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call4531 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4507);
// compiled call node returning call4531 (depth = 5)
    gc_frame_newslot(call4531);
    if4455 = call4531;
  } else {
  }
// compiled if node returning if4455 (depth = 4)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4533 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4534 = alloc_Block(NULL, NULL, "parser", 1559);
  gc_frame_newslot(block4534);
// method "_apply"
  block_savedest(block4534);
  Object closure4535 = createclosure(3, "_apply");
  setclosureframe(closure4535, stackframe);
  addtoclosure(closure4535, var_ops);
  addtoclosure(closure4535, var_prec);
  addtoclosure(closure4535, selfslot);
  struct UserObject *uo4535 = (struct UserObject*)block4534;
  uo4535->data[0] = (Object)closure4535;
  Method *meth_meth_parser_4535__apply = addmethod2pos(block4534, "_apply", &meth_parser_4535__apply, 0);
  int argcv_meth_parser_4535__apply[] = {0};
  meth_meth_parser_4535__apply->type = alloc_MethodType(1, argcv_meth_parser_4535__apply);
  meth_meth_parser_4535__apply->definitionModule = modulename;
  meth_meth_parser_4535__apply->definitionLine = 3208;
// compiled block node returning block4534 (depth = 5)
  gc_frame_newslot(block4534);
// starting to compile block node (depth = 5)
  Object block4551 = alloc_Block(NULL, NULL, "parser", 1559);
  gc_frame_newslot(block4551);
// method "_apply"
  block_savedest(block4551);
  Object closure4552 = createclosure(8, "_apply");
  setclosureframe(closure4552, stackframe);
  addtoclosure(closure4552, var_ops);
  addtoclosure(closure4552, var_o2);
  addtoclosure(closure4552, var_terms);
  addtoclosure(closure4552, var_tmp2);
  addtoclosure(closure4552, var_tmp);
  addtoclosure(closure4552, var_util);
  addtoclosure(closure4552, var_ast);
  addtoclosure(closure4552, selfslot);
  struct UserObject *uo4552 = (struct UserObject*)block4551;
  uo4552->data[0] = (Object)closure4552;
  Method *meth_meth_parser_4552__apply = addmethod2pos(block4551, "_apply", &meth_parser_4552__apply, 0);
  int argcv_meth_parser_4552__apply[] = {0};
  meth_meth_parser_4552__apply->type = alloc_MethodType(1, argcv_meth_parser_4552__apply);
  meth_meth_parser_4552__apply->definitionModule = modulename;
  meth_meth_parser_4552__apply->definitionLine = 3208;
// compiled block node returning block4551 (depth = 5)
  gc_frame_newslot(block4551);
// call case 5: prelude request
  params[0] = block4534;
  params[1] = block4551;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4576 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4533);
// compiled call node returning call4576 (depth = 4)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4577 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4578 = callmethodflags(*var_ops, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4577);
// compiled call node returning call4578 (depth = 4)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4580 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4581 == NULL) {
    strlit4581 = alloc_String("lparen");
    gc_root(strlit4581);
  }
// compiled string node returning strlit4581 (depth = 6)
  gc_frame_newslot(strlit4581);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4581;
  partcv[0] = 1;
  Object call4582 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4580);
// compiled call node returning call4582 (depth = 5)
  Object if4579 = done;
  if (istrue(call4582)) {
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4583 = gc_frame_new();
// call case 4: self request
  Object call4584 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4583);
// compiled member node returning call4584 (depth = 5)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4586 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe4587 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_recurse (depth = 8)
  gc_frame_newslot(*var_recurse);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call4588 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4587);
// compiled call node returning call4588 (depth = 7)
  Object call4589 = callmethodflags(call4588, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4586);
// compiled member node returning call4589 (depth = 6)
  Object if4585 = done;
  if (istrue(call4589)) {
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4590 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4592 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4591);
// compiled member node returning call4592 (depth = 8)
  Object call4593 = callmethodflags(call4592, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4590);
// compiled member node returning call4593 (depth = 7)
  *var_suggestion = call4593;
  if (call4593 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4594 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4595 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4596 == NULL) {
    strlit4596 = alloc_String("rparen");
    gc_root(strlit4596);
  }
// compiled string node returning strlit4596 (depth = 9)
  params[0] = strlit4596;
  partcv[0] = 1;
  callmethodflags(array4595, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4595 (depth = 8)
  gc_frame_newslot(array4595);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array4595;
  partcv[0] = 1;
  Object call4597 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4594);
// compiled call node returning call4597 (depth = 7)
  *var_nextTok = call4597;
  if (call4597 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4599 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4599 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4601 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4601 (depth = 7)
  Object if4598 = done;
  if (istrue(opresult4601)) {
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4602 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4604);
  }
// compiled string node returning strlit4604 (depth = 9)
  int op_slot_right_4603 = gc_frame_newslot(strlit4604);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4606 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4608 == NULL) {
    strlit4608 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit4608);
  }
// compiled string node returning strlit4608 (depth = 10)
  int op_slot_left_4606 = gc_frame_newslot(strlit4608);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4609 = callmethod(strlit4608, "++(1)", 1, partcv, params);
// compiled op node returning opresult4609 (depth = 9)
  int op_slot_left_4603 = gc_frame_newslot(opresult4609);
  params[0] = strlit4604;
  partcv[0] = 1;
  Object opresult4610 = callmethod(opresult4609, "++(1)", 1, partcv, params);
// compiled op node returning opresult4610 (depth = 8)
  gc_frame_newslot(opresult4610);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult4610;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4611 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4602);
// compiled call node returning call4611 (depth = 7)
    gc_frame_newslot(call4611);
    if4598 = call4611;
  } else {
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4612 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe4613 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call4614 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4613);
// compiled member node returning call4614 (depth = 8)
  gc_frame_newslot(call4614);
// starting to compile identifier node (depth = 8)
  Object bool4615 = alloc_Boolean(1);
// compiled identifier node returning bool4615 (depth = 8)
  gc_frame_newslot(bool4615);
// starting to compile identifier node (depth = 8)
  Object bool4616 = alloc_Boolean(0);
// compiled identifier node returning bool4616 (depth = 8)
  gc_frame_newslot(bool4616);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4618 == NULL) {
    strlit4618 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4618);
  }
// compiled string node returning strlit4618 (depth = 9)
  int op_slot_right_4617 = gc_frame_newslot(strlit4618);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4620 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit4622);
  }
// compiled string node returning strlit4622 (depth = 10)
  int op_slot_left_4620 = gc_frame_newslot(strlit4622);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4623 = callmethod(strlit4622, "++(1)", 1, partcv, params);
// compiled op node returning opresult4623 (depth = 9)
  int op_slot_left_4617 = gc_frame_newslot(opresult4623);
  params[0] = strlit4618;
  partcv[0] = 1;
  Object opresult4624 = callmethod(opresult4623, "++(1)", 1, partcv, params);
// compiled op node returning opresult4624 (depth = 8)
  gc_frame_newslot(opresult4624);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4614;
  params[2] = bool4615;
  params[3] = bool4616;
  params[4] = opresult4624;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4625 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4612);
// compiled call node returning call4625 (depth = 7)
    gc_frame_newslot(call4625);
    if4598 = call4625;
  }
// compiled if node returning if4598 (depth = 6)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4626 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4628 == NULL) {
    strlit4628 = alloc_String(".");
    gc_root(strlit4628);
  }
// compiled string node returning strlit4628 (depth = 8)
  int op_slot_right_4627 = gc_frame_newslot(strlit4628);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_4630 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit4632 == NULL) {
    strlit4632 = alloc_String("parentheses must contain a valid ");
    gc_root(strlit4632);
  }
// compiled string node returning strlit4632 (depth = 9)
  int op_slot_left_4630 = gc_frame_newslot(strlit4632);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4633 = callmethod(strlit4632, "++(1)", 1, partcv, params);
// compiled op node returning opresult4633 (depth = 8)
  int op_slot_left_4627 = gc_frame_newslot(opresult4633);
  params[0] = strlit4628;
  partcv[0] = 1;
  Object opresult4634 = callmethod(opresult4633, "++(1)", 1, partcv, params);
// compiled op node returning opresult4634 (depth = 7)
  gc_frame_newslot(opresult4634);
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4636 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4635);
// compiled member node returning call4636 (depth = 7)
  gc_frame_newslot(call4636);
// starting to compile member node (depth = 7)
  int callframe4637 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4638 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4637);
// compiled member node returning call4638 (depth = 7)
  gc_frame_newslot(call4638);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4634;
  params[1] = call4636;
  params[2] = call4638;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4639 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4626);
// compiled call node returning call4639 (depth = 6)
    gc_frame_newslot(call4639);
    if4585 = call4639;
  } else {
  }
// compiled if node returning if4585 (depth = 5)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4642 == NULL) {
    strlit4642 = alloc_String("rparen");
    gc_root(strlit4642);
  }
// compiled string node returning strlit4642 (depth = 7)
  int op_slot_right_4641 = gc_frame_newslot(strlit4642);
// starting to compile member node (depth = 7)
  int callframe4644 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4645 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4644);
// compiled member node returning call4645 (depth = 7)
  int op_slot_left_4641 = gc_frame_newslot(call4645);
  params[0] = strlit4642;
  partcv[0] = 1;
  Object opresult4646 = callmethod(call4645, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4646 (depth = 6)
  Object if4640 = done;
  if (istrue(opresult4646)) {
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4647 = gc_frame_new();
// call case 4: self request
  Object call4648 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4647);
// compiled member node returning call4648 (depth = 6)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4649 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4650 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4651 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4650);
// compiled member node returning call4651 (depth = 8)
  Object call4652 = callmethodflags(call4651, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4649);
// compiled member node returning call4652 (depth = 7)
  *var_suggestion = call4652;
  if (call4652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4653 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4654 == NULL) {
    strlit4654 = alloc_String(")");
    gc_root(strlit4654);
  }
// compiled string node returning strlit4654 (depth = 7)
  gc_frame_newslot(strlit4654);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4654;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4655 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4653);
// compiled call node returning call4655 (depth = 6)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4656 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4657 == NULL) {
    strlit4657 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4657);
  }
// compiled string node returning strlit4657 (depth = 7)
  gc_frame_newslot(strlit4657);
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4658 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call4659 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4658);
// compiled member node returning call4659 (depth = 7)
  gc_frame_newslot(call4659);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4662 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4661);
// compiled member node returning call4662 (depth = 8)
  int op_slot_right_4660 = gc_frame_newslot(call4662);
// starting to compile member node (depth = 8)
  int callframe4664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4665 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4664);
// compiled member node returning call4665 (depth = 8)
  int op_slot_left_4660 = gc_frame_newslot(call4665);
  params[0] = call4662;
  partcv[0] = 1;
  Object sum4666 = callmethod(call4665, "+(1)", 1, partcv, params);
// compiled op node returning sum4666 (depth = 7)
  gc_frame_newslot(sum4666);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4657;
  params[1] = call4659;
  params[2] = sum4666;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4667 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4656);
// compiled call node returning call4667 (depth = 6)
    gc_frame_newslot(call4667);
    if4640 = call4667;
  } else {
  }
// compiled if node returning if4640 (depth = 5)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4668 = gc_frame_new();
// call case 4: self request
  Object call4669 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4668);
// compiled member node returning call4669 (depth = 5)
    gc_frame_newslot(call4669);
    if4579 = call4669;
  } else {
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4671 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe4672 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_statementToken;
  partcv[0] = 1;
  Object call4673 = callmethodflags(module_parser, "tokenOnLineOfLastOr(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled call node returning call4673 (depth = 7)
  partcv[0] = 0;
  Object call4674 = callmethodflags(call4673, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4671);
// compiled call node returning call4674 (depth = 6)
  Object if4670 = done;
  if (istrue(call4674)) {
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4675 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4675 (depth = 7)
  *var_suggestions = array4675;
  if (array4675 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4676 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4677 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4678 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4677);
// compiled member node returning call4678 (depth = 8)
  Object call4679 = callmethodflags(call4678, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4676);
// compiled member node returning call4679 (depth = 7)
  *var_suggestion = call4679;
  if (call4679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4680 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool4681 = alloc_Boolean(1);
// compiled identifier node returning bool4681 (depth = 7)
  gc_frame_newslot(bool4681);
// starting to compile identifier node (depth = 7)
  Object bool4682 = alloc_Boolean(0);
// compiled identifier node returning bool4682 (depth = 7)
  gc_frame_newslot(bool4682);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool4681;
  params[2] = bool4682;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4683 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4680);
// compiled call node returning call4683 (depth = 6)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4684 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4685 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4684);
// compiled call node returning call4685 (depth = 6)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4686 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4688 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4687);
// compiled member node returning call4688 (depth = 8)
  Object call4689 = callmethodflags(call4688, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4686);
// compiled member node returning call4689 (depth = 7)
  *var_suggestion = call4689;
  if (call4689 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4691 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4693 == NULL) {
    strlit4693 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4693);
  }
// compiled string node returning strlit4693 (depth = 8)
  int op_slot_right_4692 = gc_frame_newslot(strlit4693);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_4695 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit4697 == NULL) {
    strlit4697 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4697);
  }
// compiled string node returning strlit4697 (depth = 9)
  int op_slot_left_4695 = gc_frame_newslot(strlit4697);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4698 = callmethod(strlit4697, "++(1)", 1, partcv, params);
// compiled op node returning opresult4698 (depth = 8)
  int op_slot_left_4692 = gc_frame_newslot(opresult4698);
  params[0] = strlit4693;
  partcv[0] = 1;
  Object opresult4699 = callmethod(opresult4698, "++(1)", 1, partcv, params);
// compiled op node returning opresult4699 (depth = 7)
  gc_frame_newslot(opresult4699);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult4699;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4700 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4691);
// compiled call node returning call4700 (depth = 6)
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4701 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4702 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4701);
// compiled call node returning call4702 (depth = 6)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4703 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4705 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4704);
// compiled member node returning call4705 (depth = 8)
  Object call4706 = callmethodflags(call4705, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4703);
// compiled member node returning call4706 (depth = 7)
  *var_suggestion = call4706;
  if (call4706 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4708 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4710 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe4711 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call4712 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4711);
// compiled member node returning call4712 (depth = 9)
  gc_frame_newslot(call4712);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4713 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call4714 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe4713);
// compiled member node returning call4714 (depth = 9)
  params[0] = call4712;
  partcv[0] = 1;
  Object call4715 = callmethodflags(call4714, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4710);
// compiled call node returning call4715 (depth = 8)
  int op_slot_right_4709 = gc_frame_newslot(call4715);
// starting to compile string node (depth = 8)
  if (strlit4717 == NULL) {
    strlit4717 = alloc_String(" ");
    gc_root(strlit4717);
  }
// compiled string node returning strlit4717 (depth = 8)
  int op_slot_left_4709 = gc_frame_newslot(strlit4717);
  params[0] = call4715;
  partcv[0] = 1;
  Object opresult4718 = callmethod(strlit4717, "++(1)", 1, partcv, params);
// compiled op node returning opresult4718 (depth = 7)
  gc_frame_newslot(opresult4718);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult4718;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4719 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4708);
// compiled call node returning call4719 (depth = 6)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4720 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4721 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4722 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4721);
// compiled member node returning call4722 (depth = 7)
  gc_frame_newslot(call4722);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call4722;
  partcv[0] = 1;
  Object call4723 = callmethodflags(*var_suggestion, "deleteLine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4720);
// compiled call node returning call4723 (depth = 6)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4724 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4725 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4724);
// compiled call node returning call4725 (depth = 6)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4726 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4728 == NULL) {
    strlit4728 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit4728);
  }
// compiled string node returning strlit4728 (depth = 8)
  int op_slot_right_4727 = gc_frame_newslot(strlit4728);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4732 = callmethodflags(*var_lastToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4731);
// compiled member node returning call4732 (depth = 9)
  int op_slot_right_4730 = gc_frame_newslot(call4732);
// starting to compile string node (depth = 9)
  if (strlit4734 == NULL) {
    strlit4734 = alloc_String("a valid expression must follow '");
    gc_root(strlit4734);
  }
// compiled string node returning strlit4734 (depth = 9)
  int op_slot_left_4730 = gc_frame_newslot(strlit4734);
  params[0] = call4732;
  partcv[0] = 1;
  Object opresult4735 = callmethod(strlit4734, "++(1)", 1, partcv, params);
// compiled op node returning opresult4735 (depth = 8)
  int op_slot_left_4727 = gc_frame_newslot(opresult4735);
  params[0] = strlit4728;
  partcv[0] = 1;
  Object opresult4736 = callmethod(opresult4735, "++(1)", 1, partcv, params);
// compiled op node returning opresult4736 (depth = 7)
  gc_frame_newslot(opresult4736);
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call4738 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4737);
// compiled member node returning call4738 (depth = 7)
  gc_frame_newslot(call4738);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4741 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4740);
// compiled member node returning call4741 (depth = 8)
  int op_slot_right_4739 = gc_frame_newslot(call4741);
// starting to compile member node (depth = 8)
  int callframe4743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4744 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4743);
// compiled member node returning call4744 (depth = 8)
  int op_slot_left_4739 = gc_frame_newslot(call4744);
  params[0] = call4741;
  partcv[0] = 1;
  Object sum4745 = callmethod(call4744, "+(1)", 1, partcv, params);
// compiled op node returning sum4745 (depth = 7)
  gc_frame_newslot(sum4745);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4736;
  params[1] = call4738;
  params[2] = sum4745;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4746 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4726);
// compiled call node returning call4746 (depth = 6)
    gc_frame_newslot(call4746);
    if4670 = call4746;
  } else {
  }
// compiled if node returning if4670 (depth = 5)
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4748 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4749 = alloc_Block(NULL, NULL, "parser", 1616);
  gc_frame_newslot(block4749);
// method "_apply"
  block_savedest(block4749);
  Object closure4750 = createclosure(1, "_apply");
  setclosureframe(closure4750, stackframe);
  addtoclosure(closure4750, selfslot);
  struct UserObject *uo4750 = (struct UserObject*)block4749;
  uo4750->data[0] = (Object)closure4750;
  Method *meth_meth_parser_4750__apply = addmethod2pos(block4749, "_apply", &meth_parser_4750__apply, 0);
  int argcv_meth_parser_4750__apply[] = {0};
  meth_meth_parser_4750__apply->type = alloc_MethodType(1, argcv_meth_parser_4750__apply);
  meth_meth_parser_4750__apply->definitionModule = modulename;
  meth_meth_parser_4750__apply->definitionLine = 3208;
// compiled block node returning block4749 (depth = 7)
  gc_frame_newslot(block4749);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block4749;
  partcv[0] = 1;
  Object call4754 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4748);
// compiled call node returning call4754 (depth = 6)
  Object if4747 = done;
  if (istrue(call4754)) {
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4755 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4755 (depth = 7)
  *var_suggestions = array4755;
  if (array4755 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4756 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4758 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4757);
// compiled member node returning call4758 (depth = 8)
  Object call4759 = callmethodflags(call4758, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4756);
// compiled member node returning call4759 (depth = 7)
  *var_suggestion = call4759;
  if (call4759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4760 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4761 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4762 == NULL) {
    strlit4762 = alloc_String("comma");
    gc_root(strlit4762);
  }
// compiled string node returning strlit4762 (depth = 9)
  params[0] = strlit4762;
  partcv[0] = 1;
  callmethodflags(array4761, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4763 == NULL) {
    strlit4763 = alloc_String("rparen");
    gc_root(strlit4763);
  }
// compiled string node returning strlit4763 (depth = 9)
  params[0] = strlit4763;
  partcv[0] = 1;
  callmethodflags(array4761, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4764 == NULL) {
    strlit4764 = alloc_String("rsquare");
    gc_root(strlit4764);
  }
// compiled string node returning strlit4764 (depth = 9)
  params[0] = strlit4764;
  partcv[0] = 1;
  callmethodflags(array4761, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4765 == NULL) {
    strlit4765 = alloc_String("rbrace");
    gc_root(strlit4765);
  }
// compiled string node returning strlit4765 (depth = 9)
  params[0] = strlit4765;
  partcv[0] = 1;
  callmethodflags(array4761, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4761 (depth = 8)
  gc_frame_newslot(array4761);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array4761;
  partcv[0] = 1;
  Object call4766 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4760);
// compiled call node returning call4766 (depth = 7)
  *var_nextTok = call4766;
  if (call4766 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4768 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4768 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4770 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4770 (depth = 7)
  Object if4767 = done;
  if (istrue(opresult4770)) {
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4771 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4773 == NULL) {
    strlit4773 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4773);
  }
// compiled string node returning strlit4773 (depth = 9)
  int op_slot_right_4772 = gc_frame_newslot(strlit4773);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4775 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4777 == NULL) {
    strlit4777 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4777);
  }
// compiled string node returning strlit4777 (depth = 10)
  int op_slot_left_4775 = gc_frame_newslot(strlit4777);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4778 = callmethod(strlit4777, "++(1)", 1, partcv, params);
// compiled op node returning opresult4778 (depth = 9)
  int op_slot_left_4772 = gc_frame_newslot(opresult4778);
  params[0] = strlit4773;
  partcv[0] = 1;
  Object opresult4779 = callmethod(opresult4778, "++(1)", 1, partcv, params);
// compiled op node returning opresult4779 (depth = 8)
  gc_frame_newslot(opresult4779);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult4779;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4780 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4771);
// compiled call node returning call4780 (depth = 7)
    gc_frame_newslot(call4780);
    if4767 = call4780;
  } else {
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4781 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe4782 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call4783 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4782);
// compiled member node returning call4783 (depth = 8)
  gc_frame_newslot(call4783);
// starting to compile identifier node (depth = 8)
  Object bool4784 = alloc_Boolean(1);
// compiled identifier node returning bool4784 (depth = 8)
  gc_frame_newslot(bool4784);
// starting to compile identifier node (depth = 8)
  Object bool4785 = alloc_Boolean(0);
// compiled identifier node returning bool4785 (depth = 8)
  gc_frame_newslot(bool4785);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4787 == NULL) {
    strlit4787 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4787);
  }
// compiled string node returning strlit4787 (depth = 9)
  int op_slot_right_4786 = gc_frame_newslot(strlit4787);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4789 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4791 == NULL) {
    strlit4791 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4791);
  }
// compiled string node returning strlit4791 (depth = 10)
  int op_slot_left_4789 = gc_frame_newslot(strlit4791);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4792 = callmethod(strlit4791, "++(1)", 1, partcv, params);
// compiled op node returning opresult4792 (depth = 9)
  int op_slot_left_4786 = gc_frame_newslot(opresult4792);
  params[0] = strlit4787;
  partcv[0] = 1;
  Object opresult4793 = callmethod(opresult4792, "++(1)", 1, partcv, params);
// compiled op node returning opresult4793 (depth = 8)
  gc_frame_newslot(opresult4793);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4783;
  params[2] = bool4784;
  params[3] = bool4785;
  params[4] = opresult4793;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4794 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4781);
// compiled call node returning call4794 (depth = 7)
    gc_frame_newslot(call4794);
    if4767 = call4794;
  }
// compiled if node returning if4767 (depth = 6)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4795 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4796 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4795);
// compiled call node returning call4796 (depth = 6)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4797 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4798 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4799 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4798);
// compiled member node returning call4799 (depth = 8)
  Object call4800 = callmethodflags(call4799, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4797);
// compiled member node returning call4800 (depth = 7)
  *var_suggestion = call4800;
  if (call4800 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4802 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe4803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call4804 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4803);
// compiled member node returning call4804 (depth = 7)
  gc_frame_newslot(call4804);
// starting to compile identifier node (depth = 7)
  Object bool4805 = alloc_Boolean(1);
// compiled identifier node returning bool4805 (depth = 7)
  gc_frame_newslot(bool4805);
// starting to compile identifier node (depth = 7)
  Object bool4806 = alloc_Boolean(0);
// compiled identifier node returning bool4806 (depth = 7)
  gc_frame_newslot(bool4806);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call4804;
  params[2] = bool4805;
  params[3] = bool4806;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4807 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4802);
// compiled call node returning call4807 (depth = 6)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4808 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4809 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4808);
// compiled call node returning call4809 (depth = 6)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4810 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 8)
  int op_slot_right_4811 = gc_frame_newslot(strlit4812);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4816 = callmethodflags(*var_lastToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4815);
// compiled member node returning call4816 (depth = 9)
  int op_slot_right_4814 = gc_frame_newslot(call4816);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String(" must follow '");
    gc_root(strlit4819);
  }
// compiled string node returning strlit4819 (depth = 10)
  int op_slot_right_4818 = gc_frame_newslot(strlit4819);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_4821 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit4823 == NULL) {
    strlit4823 = alloc_String("a valid ");
    gc_root(strlit4823);
  }
// compiled string node returning strlit4823 (depth = 11)
  int op_slot_left_4821 = gc_frame_newslot(strlit4823);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4824 = callmethod(strlit4823, "++(1)", 1, partcv, params);
// compiled op node returning opresult4824 (depth = 10)
  int op_slot_left_4818 = gc_frame_newslot(opresult4824);
  params[0] = strlit4819;
  partcv[0] = 1;
  Object opresult4825 = callmethod(opresult4824, "++(1)", 1, partcv, params);
// compiled op node returning opresult4825 (depth = 9)
  int op_slot_left_4814 = gc_frame_newslot(opresult4825);
  params[0] = call4816;
  partcv[0] = 1;
  Object opresult4826 = callmethod(opresult4825, "++(1)", 1, partcv, params);
// compiled op node returning opresult4826 (depth = 8)
  int op_slot_left_4811 = gc_frame_newslot(opresult4826);
  params[0] = strlit4812;
  partcv[0] = 1;
  Object opresult4827 = callmethod(opresult4826, "++(1)", 1, partcv, params);
// compiled op node returning opresult4827 (depth = 7)
  gc_frame_newslot(opresult4827);
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4828 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call4829 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4828);
// compiled member node returning call4829 (depth = 7)
  gc_frame_newslot(call4829);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4832 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4831);
// compiled member node returning call4832 (depth = 8)
  int op_slot_right_4830 = gc_frame_newslot(call4832);
// starting to compile member node (depth = 8)
  int callframe4834 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4835 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4834);
// compiled member node returning call4835 (depth = 8)
  int op_slot_left_4830 = gc_frame_newslot(call4835);
  params[0] = call4832;
  partcv[0] = 1;
  Object sum4836 = callmethod(call4835, "+(1)", 1, partcv, params);
// compiled op node returning sum4836 (depth = 7)
  gc_frame_newslot(sum4836);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4827;
  params[1] = call4829;
  params[2] = sum4836;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4837 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4810);
// compiled call node returning call4837 (depth = 6)
    gc_frame_newslot(call4837);
    if4747 = call4837;
  } else {
  }
// compiled if node returning if4747 (depth = 5)
    gc_frame_newslot(if4747);
    if4579 = if4747;
  }
// compiled if node returning if4579 (depth = 4)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4838 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4839 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4838);
// compiled call node returning call4839 (depth = 4)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4840 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4841 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4840);
// compiled call node returning call4841 (depth = 4)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4842 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call4843 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4842);
// compiled member node returning call4843 (depth = 5)
  *var_tmp = call4843;
  if (call4843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4845 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4846 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4845);
// compiled call node returning call4846 (depth = 4)
  gc_frame_end(frame);
  return call4846;
}
Object meth_parser_4851__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4853 = alloc_Float64(0);
// compiled num node returning num4853 (depth = 5)
  int op_slot_right_4852 = gc_frame_newslot(num4853);
// starting to compile member node (depth = 5)
  int callframe4855 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  Object call4856 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4855);
// compiled member node returning call4856 (depth = 5)
  int op_slot_left_4852 = gc_frame_newslot(call4856);
  params[0] = num4853;
  partcv[0] = 1;
  Object opresult4857 = callmethod(call4856, ">(1)", 1, partcv, params);
// compiled op node returning opresult4857 (depth = 4)
  gc_frame_end(frame);
  return opresult4857;
}
Object meth_parser_4860__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4861 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  Object call4862 = callmethodflags(*var_ops, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4861);
// compiled member node returning call4862 (depth = 5)
  *var_o = call4862;
  if (call4862 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  Object call4865 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4864);
// compiled member node returning call4865 (depth = 5)
  *var_tmp2 = call4865;
  if (call4865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4867 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  Object call4868 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4867);
// compiled member node returning call4868 (depth = 5)
  *var_tmp = call4868;
  if (call4868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4870 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4871 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  Object call4872 = callmethodflags(*var_tmp, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4871);
// compiled member node returning call4872 (depth = 5)
  gc_frame_newslot(call4872);
// starting to compile member node (depth = 5)
  int callframe4873 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  Object call4874 = callmethodflags(*var_tmp, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4873);
// compiled member node returning call4874 (depth = 5)
  gc_frame_newslot(call4874);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call4872;
  params[1] = call4874;
  partcv[0] = 2;
  Object call4875 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4870);
// compiled call node returning call4875 (depth = 4)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4876 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4877 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call4878 = callmethodflags(*var_ast, "opNode", 0, partcv, params, 0);
  gc_frame_end(callframe4877);
// compiled member node returning call4878 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call4879 = callmethodflags(call4878, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4876);
// compiled call node returning call4879 (depth = 5)
  *var_tmp = call4879;
  if (call4879 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4881 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4882 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4881);
// compiled call node returning call4882 (depth = 4)
  gc_frame_end(frame);
  return call4882;
}
Object meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest(1)recursingWith(1)blocks(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  Object params[3];
  int partcv[2];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for expressionrest(_)recursingWith(_)blocks(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expressionrest(_)");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part recursingWith(_)");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blocks(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_startIndent = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "startIndent");
  Object *var_terms = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "terms");
  Object *var_ops = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ops");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_o2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "o2");
  Object *var_tmp2 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp2");
  Object *var_tmp = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tmp");
  Object *var_prec = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "prec");
  Object *var_allarith = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "allarith");
  Object *var_opcount = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opcount");
  Object *var_opdtype = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "opdtype");
// definebindings:
// definebindings:
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4384 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4384 (depth = 3)
  *var_terms = array4384;
  if (array4384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4385 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4385 (depth = 3)
  *var_ops = array4385;
  if (array4385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call4387 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4386);
// compiled member node returning call4387 (depth = 3)
  *var_tmp = call4387;
  if (call4387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4388 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4389 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4388);
// compiled call node returning call4389 (depth = 2)
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4390 = alloc_Boolean(1);
// compiled identifier node returning bool4390 (depth = 3)
  *var_allarith = bool4390;
  if (bool4390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4391 = alloc_Float64(0);
// compiled num node returning num4391 (depth = 3)
  *var_opcount = num4391;
  if (num4391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4392 == NULL) {
    strlit4392 = alloc_String("");
    gc_root(strlit4392);
  }
// compiled string node returning strlit4392 (depth = 3)
  *var_opdtype = strlit4392;
  if (strlit4392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4393 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4394 = alloc_Block(NULL, NULL, "parser", 1531);
  gc_frame_newslot(block4394);
// method "_apply"
  block_savedest(block4394);
  Object closure4395 = createclosure(3, "_apply");
  setclosureframe(closure4395, stackframe);
  addtoclosure(closure4395, var_sym);
  addtoclosure(closure4395, var_statementToken);
  addtoclosure(closure4395, selfslot);
  struct UserObject *uo4395 = (struct UserObject*)block4394;
  uo4395->data[0] = (Object)closure4395;
  Method *meth_meth_parser_4395__apply = addmethod2pos(block4394, "_apply", &meth_parser_4395__apply, 0);
  int argcv_meth_parser_4395__apply[] = {0};
  meth_meth_parser_4395__apply->type = alloc_MethodType(1, argcv_meth_parser_4395__apply);
  meth_meth_parser_4395__apply->definitionModule = modulename;
  meth_meth_parser_4395__apply->definitionLine = 3208;
// compiled block node returning block4394 (depth = 3)
  gc_frame_newslot(block4394);
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4412 = alloc_Block(NULL, NULL, "parser", 1532);
  gc_frame_newslot(block4412);
// method "_apply"
  block_savedest(block4412);
  Object closure4413 = createclosure(21, "_apply");
  setclosureframe(closure4413, stackframe);
  addtoclosure(closure4413, var_opcount);
  addtoclosure(closure4413, var_sym);
  addtoclosure(closure4413, var_o);
  addtoclosure(closure4413, var_prec);
  addtoclosure(closure4413, var_allarith);
  addtoclosure(closure4413, var_opdtype);
  addtoclosure(closure4413, var_errormessages);
  addtoclosure(closure4413, var_lastToken);
  addtoclosure(closure4413, var_ops);
  addtoclosure(closure4413, var_o2);
  addtoclosure(closure4413, var_terms);
  addtoclosure(closure4413, var_tmp2);
  addtoclosure(closure4413, var_tmp);
  addtoclosure(closure4413, var_util);
  addtoclosure(closure4413, var_ast);
  addtoclosure(closure4413, var_recurse);
  addtoclosure(closure4413, var_name);
  addtoclosure(closure4413, var_statementToken);
  addtoclosure(closure4413, var_acceptBlocks);
  addtoclosure(closure4413, var_values);
  addtoclosure(closure4413, selfslot);
  struct UserObject *uo4413 = (struct UserObject*)block4412;
  uo4413->data[0] = (Object)closure4413;
  Method *meth_meth_parser_4413__apply = addmethod2pos(block4412, "_apply", &meth_parser_4413__apply, 0);
  int argcv_meth_parser_4413__apply[] = {0};
  meth_meth_parser_4413__apply->type = alloc_MethodType(1, argcv_meth_parser_4413__apply);
  meth_meth_parser_4413__apply->definitionModule = modulename;
  meth_meth_parser_4413__apply->definitionLine = 3208;
// compiled block node returning block4412 (depth = 3)
  gc_frame_newslot(block4412);
// call case 5: prelude request
  params[0] = block4394;
  params[1] = block4412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4848 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4393);
// compiled call node returning call4848 (depth = 2)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4849 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4850 = alloc_Block(NULL, NULL, "parser", 1643);
  gc_frame_newslot(block4850);
// method "_apply"
  block_savedest(block4850);
  Object closure4851 = createclosure(2, "_apply");
  setclosureframe(closure4851, stackframe);
  addtoclosure(closure4851, var_ops);
  addtoclosure(closure4851, selfslot);
  struct UserObject *uo4851 = (struct UserObject*)block4850;
  uo4851->data[0] = (Object)closure4851;
  Method *meth_meth_parser_4851__apply = addmethod2pos(block4850, "_apply", &meth_parser_4851__apply, 0);
  int argcv_meth_parser_4851__apply[] = {0};
  meth_meth_parser_4851__apply->type = alloc_MethodType(1, argcv_meth_parser_4851__apply);
  meth_meth_parser_4851__apply->definitionModule = modulename;
  meth_meth_parser_4851__apply->definitionLine = 3208;
// compiled block node returning block4850 (depth = 3)
  gc_frame_newslot(block4850);
// starting to compile block node (depth = 3)
  Object block4859 = alloc_Block(NULL, NULL, "parser", 1643);
  gc_frame_newslot(block4859);
// method "_apply"
  block_savedest(block4859);
  Object closure4860 = createclosure(8, "_apply");
  setclosureframe(closure4860, stackframe);
  addtoclosure(closure4860, var_ops);
  addtoclosure(closure4860, var_o);
  addtoclosure(closure4860, var_terms);
  addtoclosure(closure4860, var_tmp2);
  addtoclosure(closure4860, var_tmp);
  addtoclosure(closure4860, var_util);
  addtoclosure(closure4860, var_ast);
  addtoclosure(closure4860, selfslot);
  struct UserObject *uo4860 = (struct UserObject*)block4859;
  uo4860->data[0] = (Object)closure4860;
  Method *meth_meth_parser_4860__apply = addmethod2pos(block4859, "_apply", &meth_parser_4860__apply, 0);
  int argcv_meth_parser_4860__apply[] = {0};
  meth_meth_parser_4860__apply->type = alloc_MethodType(1, argcv_meth_parser_4860__apply);
  meth_meth_parser_4860__apply->definitionModule = modulename;
  meth_meth_parser_4860__apply->definitionLine = 3208;
// compiled block node returning block4859 (depth = 3)
  gc_frame_newslot(block4859);
// call case 5: prelude request
  params[0] = block4850;
  params[1] = block4859;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4884 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4849);
// compiled call node returning call4884 (depth = 2)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4885 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_terms (depth = 4)
  Object call4886 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4885);
// compiled member node returning call4886 (depth = 3)
  *var_tmp = call4886;
  if (call4886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4888 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4889 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4888);
// compiled call node returning call4889 (depth = 2)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4892 = alloc_Float64(0);
// compiled num node returning num4892 (depth = 4)
  int op_slot_right_4891 = gc_frame_newslot(num4892);
// starting to compile member node (depth = 4)
  int callframe4894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  Object call4895 = callmethodflags(*var_terms, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4894);
// compiled member node returning call4895 (depth = 4)
  int op_slot_left_4891 = gc_frame_newslot(call4895);
  params[0] = num4892;
  partcv[0] = 1;
  Object opresult4896 = callmethod(call4895, ">(1)", 1, partcv, params);
// compiled op node returning opresult4896 (depth = 3)
  Object if4890 = done;
  if (istrue(opresult4896)) {
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4897 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4898 == NULL) {
    strlit4898 = alloc_String("values left on term stack.");
    gc_root(strlit4898);
  }
// compiled string node returning strlit4898 (depth = 4)
  gc_frame_newslot(strlit4898);
// starting to compile member node (depth = 4)
  int callframe4899 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4900 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4899);
// compiled member node returning call4900 (depth = 4)
  gc_frame_newslot(call4900);
// starting to compile member node (depth = 4)
  int callframe4901 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4902 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4901);
// compiled member node returning call4902 (depth = 4)
  gc_frame_newslot(call4902);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4898;
  params[1] = call4900;
  params[2] = call4902;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call4903 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe4897);
// compiled call node returning call4903 (depth = 3)
    gc_frame_newslot(call4903);
    if4890 = call4903;
  } else {
  }
// compiled if node returning if4890 (depth = 2)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startIndent (depth = 3)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_4905_dotrest_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method dotrest(_)");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part dotrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "startIndent");
  Object *var_lookuptarget = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lookuptarget");
// definebindings:
  Object *var_dro = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dro");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
// definebindings:
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4907 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4908 == NULL) {
    strlit4908 = alloc_String("dot");
    gc_root(strlit4908);
  }
// compiled string node returning strlit4908 (depth = 4)
  gc_frame_newslot(strlit4908);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4908;
  partcv[0] = 1;
  Object call4909 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4907);
// compiled call node returning call4909 (depth = 3)
  Object if4906 = done;
  if (istrue(call4909)) {
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4910 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4911 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4912 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4911);
// compiled member node returning call4912 (depth = 4)
  gc_frame_newslot(call4912);
// starting to compile member node (depth = 4)
  int callframe4913 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4914 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4913);
// compiled member node returning call4914 (depth = 4)
  gc_frame_newslot(call4914);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4912;
  params[1] = call4914;
  partcv[0] = 2;
  Object call4915 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4910);
// compiled call node returning call4915 (depth = 3)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call4917 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4916);
// compiled member node returning call4917 (depth = 4)
  *var_lookuptarget = call4917;
  if (call4917 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4918 = gc_frame_new();
// call case 4: self request
  Object call4919 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4918);
// compiled member node returning call4919 (depth = 3)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4921 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4922 == NULL) {
    strlit4922 = alloc_String("identifier");
    gc_root(strlit4922);
  }
// compiled string node returning strlit4922 (depth = 5)
  gc_frame_newslot(strlit4922);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit4922;
  partcv[0] = 1;
  Object call4923 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4921);
// compiled call node returning call4923 (depth = 4)
  Object if4920 = done;
  if (istrue(call4923)) {
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4924 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4926 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4925);
// compiled member node returning call4926 (depth = 5)
  gc_frame_newslot(call4926);
// starting to compile member node (depth = 5)
  int callframe4927 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4928 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4927);
// compiled member node returning call4928 (depth = 5)
  gc_frame_newslot(call4928);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call4926;
  params[1] = call4928;
  partcv[0] = 2;
  Object call4929 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4924);
// compiled call node returning call4929 (depth = 4)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4930 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call4932 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4931);
// compiled member node returning call4932 (depth = 6)
  gc_frame_newslot(call4932);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4933 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call4934 = callmethodflags(*var_ast, "memberNode", 0, partcv, params, 0);
  gc_frame_end(callframe4933);
// compiled member node returning call4934 (depth = 6)
  params[0] = call4932;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call4935 = callmethodflags(call4934, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4930);
// compiled call node returning call4935 (depth = 5)
  *var_dro = call4935;
  if (call4935 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4936 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call4937 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4936);
// compiled call node returning call4937 (depth = 4)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4938 = gc_frame_new();
// call case 4: self request
  Object call4939 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4938);
// compiled member node returning call4939 (depth = 4)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4941 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4942 == NULL) {
    strlit4942 = alloc_String("dot");
    gc_root(strlit4942);
  }
// compiled string node returning strlit4942 (depth = 6)
  gc_frame_newslot(strlit4942);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4942;
  partcv[0] = 1;
  Object call4943 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4941);
// compiled call node returning call4943 (depth = 5)
  Object if4940 = done;
  if (istrue(call4943)) {
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4944 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4945 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4944);
// compiled call node returning call4945 (depth = 5)
    gc_frame_newslot(call4945);
    if4940 = call4945;
  } else {
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4947 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4948 == NULL) {
    strlit4948 = alloc_String("lgeneric");
    gc_root(strlit4948);
  }
// compiled string node returning strlit4948 (depth = 7)
  gc_frame_newslot(strlit4948);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit4948;
  partcv[0] = 1;
  Object call4949 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4947);
// compiled call node returning call4949 (depth = 6)
  Object if4946 = done;
  if (istrue(call4949)) {
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4950 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4951 = gc_frame_new();
// call case 4: self request
  Object call4952 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4951);
// compiled member node returning call4952 (depth = 7)
  gc_frame_newslot(call4952);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dro (depth = 7)
  params[0] = call4952;
  partcv[0] = 1;
  Object call4953 = callmethodflags(*var_dro, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4950);
// compiled call node returning call4953 (depth = 6)
    gc_frame_newslot(call4953);
    if4946 = call4953;
  } else {
  }
// compiled if node returning if4946 (depth = 5)
    gc_frame_newslot(if4946);
    if4940 = if4946;
  }
// compiled if node returning if4940 (depth = 4)
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4956 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4957 == NULL) {
    strlit4957 = alloc_String("lsquare");
    gc_root(strlit4957);
  }
// compiled string node returning strlit4957 (depth = 7)
  gc_frame_newslot(strlit4957);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit4957;
  partcv[0] = 1;
  Object call4958 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4956);
// compiled call node returning call4958 (depth = 6)
  int op_slot_right_4955 = gc_frame_newslot(call4958);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4961 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String("string");
    gc_root(strlit4962);
  }
// compiled string node returning strlit4962 (depth = 8)
  gc_frame_newslot(strlit4962);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit4962;
  partcv[0] = 1;
  Object call4963 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4961);
// compiled call node returning call4963 (depth = 7)
  int op_slot_right_4960 = gc_frame_newslot(call4963);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4966 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4967 == NULL) {
    strlit4967 = alloc_String("num");
    gc_root(strlit4967);
  }
// compiled string node returning strlit4967 (depth = 9)
  gc_frame_newslot(strlit4967);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit4967;
  partcv[0] = 1;
  Object call4968 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4966);
// compiled call node returning call4968 (depth = 8)
  int op_slot_right_4965 = gc_frame_newslot(call4968);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4972 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4973 == NULL) {
    strlit4973 = alloc_String("lbrace");
    gc_root(strlit4973);
  }
// compiled string node returning strlit4973 (depth = 11)
  gc_frame_newslot(strlit4973);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = strlit4973;
  partcv[0] = 1;
  Object call4974 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4972);
// compiled call node returning call4974 (depth = 10)
  int op_slot_right_4971 = gc_frame_newslot(call4974);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_acceptBlocks (depth = 10)
  int op_slot_left_4971 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call4974;
  partcv[0] = 1;
  Object opresult4976 = callmethod(*var_acceptBlocks, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4976 (depth = 9)
  int op_slot_right_4970 = gc_frame_newslot(opresult4976);
// starting to compile call node (depth = 9)
  int callframe4978 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4979 == NULL) {
    strlit4979 = alloc_String("lparen");
    gc_root(strlit4979);
  }
// compiled string node returning strlit4979 (depth = 10)
  gc_frame_newslot(strlit4979);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit4979;
  partcv[0] = 1;
  Object call4980 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4978);
// compiled call node returning call4980 (depth = 9)
  int op_slot_left_4970 = gc_frame_newslot(call4980);
  params[0] = opresult4976;
  partcv[0] = 1;
  Object opresult4981 = callmethod(call4980, "||(1)", 1, partcv, params);
// compiled op node returning opresult4981 (depth = 8)
  int op_slot_left_4965 = gc_frame_newslot(opresult4981);
  params[0] = call4968;
  partcv[0] = 1;
  Object opresult4982 = callmethod(opresult4981, "||(1)", 1, partcv, params);
// compiled op node returning opresult4982 (depth = 7)
  int op_slot_left_4960 = gc_frame_newslot(opresult4982);
  params[0] = call4963;
  partcv[0] = 1;
  Object opresult4983 = callmethod(opresult4982, "||(1)", 1, partcv, params);
// compiled op node returning opresult4983 (depth = 6)
  int op_slot_left_4955 = gc_frame_newslot(opresult4983);
  params[0] = call4958;
  partcv[0] = 1;
  Object opresult4984 = callmethod(opresult4983, "||(1)", 1, partcv, params);
// compiled op node returning opresult4984 (depth = 5)
  Object if4954 = done;
  if (istrue(opresult4984)) {
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4985 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4986 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4985);
// compiled call node returning call4986 (depth = 5)
    gc_frame_newslot(call4986);
    if4954 = call4986;
  } else {
  }
// compiled if node returning if4954 (depth = 4)
    gc_frame_newslot(if4954);
    if4920 = if4954;
  } else {
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array4987 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4987 (depth = 5)
  *var_suggestions = array4987;
  if (array4987 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4988 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4989 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4990 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4989);
// compiled member node returning call4990 (depth = 6)
  Object call4991 = callmethodflags(call4990, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4988);
// compiled member node returning call4991 (depth = 5)
  *var_suggestion = call4991;
  if (call4991 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4992 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4993 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4992);
// compiled call node returning call4993 (depth = 4)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4994 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4995 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4994);
// compiled call node returning call4995 (depth = 4)
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4996 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4997 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4998 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4997);
// compiled member node returning call4998 (depth = 6)
  Object call4999 = callmethodflags(call4998, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4996);
// compiled member node returning call4999 (depth = 5)
  *var_suggestion = call4999;
  if (call4999 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5001 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5002 == NULL) {
    strlit5002 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5002);
  }
// compiled string node returning strlit5002 (depth = 5)
  gc_frame_newslot(strlit5002);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5002;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5003 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5001);
// compiled call node returning call5003 (depth = 4)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5004 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5005 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5004);
// compiled call node returning call5005 (depth = 4)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5006 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5007 == NULL) {
    strlit5007 = alloc_String("a field or method name must follow a '.'.");
    gc_root(strlit5007);
  }
// compiled string node returning strlit5007 (depth = 5)
  gc_frame_newslot(strlit5007);
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5008 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5009 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5008);
// compiled member node returning call5009 (depth = 5)
  gc_frame_newslot(call5009);
// starting to compile member node (depth = 5)
  int callframe5010 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5011 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5010);
// compiled member node returning call5011 (depth = 5)
  gc_frame_newslot(call5011);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5007;
  params[1] = call5009;
  params[2] = call5011;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5012 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5006);
// compiled call node returning call5012 (depth = 4)
    gc_frame_newslot(call5012);
    if4920 = call5012;
  }
// compiled if node returning if4920 (depth = 3)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if4906 = done;
  } else {
  }
// compiled if node returning if4906 (depth = 2)
  gc_frame_end(frame);
  return if4906;
}
Object meth_parser_5095__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5096 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5097 == NULL) {
    strlit5097 = alloc_String("identifier");
    gc_root(strlit5097);
  }
// compiled string node returning strlit5097 (depth = 6)
  gc_frame_newslot(strlit5097);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5097;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5098 = callmethodflags(module_parser, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5096);
// compiled call node returning call5098 (depth = 5)
  gc_frame_end(frame);
  return call5098;
}
Object meth_parser_5101__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_meth = getfromclosure(closure, 2);
  Object *var_acceptBlocks = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_lnum = getfromclosure(closure, 6);
  Object *var_lpos = getfromclosure(closure, 7);
  Object *var_argumentParts = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_argList = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "argList");
  Object *var_namePart = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "namePart");
  Object *var_argsFound = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "argsFound");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_more = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "more");
  Object *var_reqStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "reqStart");
  Object *var_reqEnd = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "reqEnd");
  Object *var_reqRange = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "reqRange");
// definebindings:
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array5102 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5102 (depth = 6)
  *var_argList = array5102;
  if (array5102 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5103 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe5104 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5106 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5105);
// compiled member node returning call5106 (depth = 8)
  gc_frame_newslot(call5106);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_argList (depth = 8)
  gc_frame_newslot(*var_argList);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5107 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  Object call5108 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe5107);
// compiled member node returning call5108 (depth = 8)
  params[0] = call5106;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5109 = callmethodflags(call5108, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5104);
// compiled call node returning call5109 (depth = 7)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call5110 = callmethodflags(call5109, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5103);
// compiled call node returning call5110 (depth = 6)
  *var_namePart = call5110;
  if (call5110 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5111 = gc_frame_new();
// call case 4: self request
  Object call5112 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5111);
// compiled member node returning call5112 (depth = 5)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_namePart (depth = 7)
  gc_frame_newslot(*var_namePart);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_meth;
  params[1] = *var_namePart;
  params[2] = *var_acceptBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5114 = callmethodflags(module_parser, "parseArgumentsFor(1)into(1)acceptBlocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5113);
// compiled call node returning call5114 (depth = 6)
  *var_argsFound = call5114;
  if (call5114 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_argsFound (depth = 7)
  Object call5117 = callmethodflags(*var_argsFound, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5116);
// compiled member node returning call5117 (depth = 6)
  Object if5115 = done;
  if (istrue(call5117)) {
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5118 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5119 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5120 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5119);
// compiled member node returning call5120 (depth = 8)
  Object call5121 = callmethodflags(call5120, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5118);
// compiled member node returning call5121 (depth = 7)
  *var_suggestion = call5121;
  if (call5121 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5122 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5123 == NULL) {
    strlit5123 = alloc_String("(""\xe2""""\x80""""\xb9""expression""\xe2""""\x80""""\xba"")");
    gc_root(strlit5123);
  }
// compiled string node returning strlit5123 (depth = 7)
  gc_frame_newslot(strlit5123);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5123;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5124 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5122);
// compiled call node returning call5124 (depth = 6)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5126 = gc_frame_new();
// call case 4: self request
  Object call5127 = callmethodflags(self, "indentHasIncreased", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5126);
// compiled member node returning call5127 (depth = 8)
  Object if5125 = done;
struct StackFrameObject *iftmpstackframe5125 = stackframe;
  if (istrue(call5127)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5125);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5129 == NULL) {
    strlit5129 = alloc_String(" the previous line; is that what you intended?");
    gc_root(strlit5129);
  }
// compiled string node returning strlit5129 (depth = 9)
  int op_slot_right_5128 = gc_frame_newslot(strlit5129);
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5131 == NULL) {
    strlit5131 = alloc_String("  The indentation tells me that this is a continuation of");
    gc_root(strlit5131);
  }
// compiled string node returning strlit5131 (depth = 9)
  int op_slot_left_5128 = gc_frame_newslot(strlit5131);
  params[0] = strlit5129;
  partcv[0] = 1;
  Object opresult5132 = callmethod(strlit5131, "++(1)", 1, partcv, params);
// compiled op node returning opresult5132 (depth = 8)
    gc_frame_newslot(opresult5132);
    if5125 = opresult5132;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5125);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit5133 == NULL) {
    strlit5133 = alloc_String("");
    gc_root(strlit5133);
  }
// compiled string node returning strlit5133 (depth = 8)
    gc_frame_newslot(strlit5133);
    if5125 = strlit5133;
  }
stackframe = iftmpstackframe5125;
// compiled if node returning if5125 (depth = 7)
  *var_more = if5125;
  if (if5125 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5134 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lnum (depth = 8)
  gc_frame_newslot(*var_lnum);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lpos (depth = 8)
  gc_frame_newslot(*var_lpos);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = *var_lnum;
  params[1] = *var_lpos;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5135 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5134);
// compiled call node returning call5135 (depth = 7)
  *var_reqStart = call5135;
  if (call5135 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5136 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5137 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5138 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5137);
// compiled member node returning call5138 (depth = 8)
  gc_frame_newslot(call5138);
// starting to compile member node (depth = 8)
  int callframe5139 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5140 = callmethodflags(*var_lastToken, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe5139);
// compiled member node returning call5140 (depth = 8)
  gc_frame_newslot(call5140);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = call5138;
  params[1] = call5140;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5141 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5136);
// compiled call node returning call5141 (depth = 7)
  *var_reqEnd = call5141;
  if (call5141 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5142 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_reqStart (depth = 8)
  gc_frame_newslot(*var_reqStart);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_reqEnd (depth = 8)
  gc_frame_newslot(*var_reqEnd);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = *var_reqStart;
  params[1] = *var_reqEnd;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5143 = callmethodflags(*var_ast, "start(1)end(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5142);
// compiled call node returning call5143 (depth = 7)
  *var_reqRange = call5143;
  if (call5143 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5144 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_more (depth = 8)
  int op_slot_right_5145 = gc_frame_newslot(*var_more);
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5148 == NULL) {
    strlit5148 = alloc_String(" either parenthesized or self-delimiting.");
    gc_root(strlit5148);
  }
// compiled string node returning strlit5148 (depth = 9)
  int op_slot_right_5147 = gc_frame_newslot(strlit5148);
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5150 == NULL) {
    strlit5150 = alloc_String("a multi-part method request must end with an argument list,");
    gc_root(strlit5150);
  }
// compiled string node returning strlit5150 (depth = 9)
  int op_slot_left_5147 = gc_frame_newslot(strlit5150);
  params[0] = strlit5148;
  partcv[0] = 1;
  Object opresult5151 = callmethod(strlit5150, "++(1)", 1, partcv, params);
// compiled op node returning opresult5151 (depth = 8)
  int op_slot_left_5145 = gc_frame_newslot(opresult5151);
  params[0] = *var_more;
  partcv[0] = 1;
  Object opresult5152 = callmethod(opresult5151, "++(1)", 1, partcv, params);
// compiled op node returning opresult5152 (depth = 7)
  gc_frame_newslot(opresult5152);
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_reqRange (depth = 7)
  gc_frame_newslot(*var_reqRange);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5152;
  params[1] = *var_reqRange;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5153 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(1)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5144);
// compiled call node returning call5153 (depth = 6)
    gc_frame_newslot(call5153);
    if5115 = call5153;
  } else {
  }
// compiled if node returning if5115 (depth = 5)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5154 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_namePart (depth = 6)
  gc_frame_newslot(*var_namePart);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_argumentParts (depth = 6)
  params[0] = *var_namePart;
  partcv[0] = 1;
  Object call5155 = callmethodflags(*var_argumentParts, "addLast(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5154);
// compiled call node returning call5155 (depth = 5)
  gc_frame_end(frame);
  return call5155;
}
Object meth_parser_5014_callrest_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method callrest(_)");
  Object params[3];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part callrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_argumentParts = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "argumentParts");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_foundArgs = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "foundArgs");
  Object *var_tok = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tok");
  Object *var_genericIdents = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "genericIdents");
  Object *var_g = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "g");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_realRcvr = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "realRcvr");
// definebindings:
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5017 = alloc_Float64(0);
// compiled num node returning num5017 (depth = 4)
  int op_slot_right_5016 = gc_frame_newslot(num5017);
// starting to compile member node (depth = 4)
  int callframe5019 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5020 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5019);
// compiled member node returning call5020 (depth = 4)
  int op_slot_left_5016 = gc_frame_newslot(call5020);
  params[0] = num5017;
  partcv[0] = 1;
  Object opresult5021 = callmethod(call5020, "==(1)", 1, partcv, params);
// compiled op node returning opresult5021 (depth = 3)
  Object if5015 = done;
  if (istrue(opresult5021)) {
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5015 = undefined;
  } else {
  }
// compiled if node returning if5015 (depth = 2)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5022 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call5023 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5022);
// compiled member node returning call5023 (depth = 3)
  *var_meth = call5023;
  if (call5023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5026 == NULL) {
    strlit5026 = alloc_String("identifier");
    gc_root(strlit5026);
  }
// compiled string node returning strlit5026 (depth = 4)
  int op_slot_right_5025 = gc_frame_newslot(strlit5026);
// starting to compile member node (depth = 4)
  int callframe5028 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call5029 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5028);
// compiled member node returning call5029 (depth = 4)
  int op_slot_left_5025 = gc_frame_newslot(call5029);
  params[0] = strlit5026;
  partcv[0] = 1;
  Object opresult5030 = callmethod(call5029, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5030 (depth = 3)
  Object if5024 = done;
  if (istrue(opresult5030)) {
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5033 == NULL) {
    strlit5033 = alloc_String("member");
    gc_root(strlit5033);
  }
// compiled string node returning strlit5033 (depth = 5)
  int op_slot_right_5032 = gc_frame_newslot(strlit5033);
// starting to compile member node (depth = 5)
  int callframe5035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call5036 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5035);
// compiled member node returning call5036 (depth = 5)
  int op_slot_left_5032 = gc_frame_newslot(call5036);
  params[0] = strlit5033;
  partcv[0] = 1;
  Object opresult5037 = callmethod(call5036, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5037 (depth = 4)
  Object if5031 = done;
  if (istrue(opresult5037)) {
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5038 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5039 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5038);
// compiled call node returning call5039 (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5031 = undefined;
  } else {
  }
// compiled if node returning if5031 (depth = 3)
    gc_frame_newslot(if5031);
    if5024 = if5031;
  } else {
  }
// compiled if node returning if5024 (depth = 2)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5040 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5041 = callmethodflags(*var_meth, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5040);
// compiled member node returning call5041 (depth = 3)
  *var_lnum = call5041;
  if (call5041 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5043 = callmethodflags(*var_meth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5042);
// compiled member node returning call5043 (depth = 3)
  *var_lpos = call5043;
  if (call5043 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5045 = callmethodflags(*var_meth, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe5044);
// compiled member node returning call5045 (depth = 3)
  *var_methn = call5045;
  if (call5045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5046 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5046 (depth = 3)
  *var_argumentParts = array5046;
  if (array5046 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5047 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5048 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methn (depth = 5)
  gc_frame_newslot(*var_methn);
// starting to compile array node (depth = 5)
  Object array5049 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5049 (depth = 5)
  gc_frame_newslot(array5049);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call5051 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe5050);
// compiled member node returning call5051 (depth = 5)
  params[0] = *var_methn;
  params[1] = array5049;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5052 = callmethodflags(call5051, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5048);
// compiled call node returning call5052 (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5053 = callmethodflags(call5052, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5047);
// compiled call node returning call5053 (depth = 3)
  *var_part = call5053;
  if (call5053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5054 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_argumentParts (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5055 = callmethodflags(*var_argumentParts, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5054);
// compiled call node returning call5055 (depth = 2)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5056 = alloc_Boolean(0);
// compiled identifier node returning bool5056 (depth = 3)
  *var_foundArgs = bool5056;
  if (bool5056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5057 = alloc_Boolean(0);
// compiled identifier node returning bool5057 (depth = 3)
  *var_genericIdents = bool5057;
  if (bool5057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5058 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5059 = callmethodflags(*var_meth, "generics", 0, partcv, params, 0);
  gc_frame_end(callframe5058);
// compiled member node returning call5059 (depth = 3)
  *var_g = call5059;
  if (call5059 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_g (depth = 4)
  int op_slot_right_5061 = gc_frame_newslot(*var_g);
// starting to compile identifier node (depth = 4)
  Object bool5063 = alloc_Boolean(0);
// compiled identifier node returning bool5063 (depth = 4)
  int op_slot_left_5061 = gc_frame_newslot(bool5063);
  params[0] = *var_g;
  partcv[0] = 1;
  Object opresult5064 = callmethod(bool5063, "==(1)", 1, partcv, params);
// compiled op node returning opresult5064 (depth = 3)
  Object if5060 = done;
  if (istrue(opresult5064)) {
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5066 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5067 == NULL) {
    strlit5067 = alloc_String("lgeneric");
    gc_root(strlit5067);
  }
// compiled string node returning strlit5067 (depth = 5)
  gc_frame_newslot(strlit5067);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit5067;
  partcv[0] = 1;
  Object call5068 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5066);
// compiled call node returning call5068 (depth = 4)
  Object if5065 = done;
  if (istrue(call5068)) {
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5069 = gc_frame_new();
// call case 4: self request
  Object call5070 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5069);
// compiled member node returning call5070 (depth = 5)
  *var_genericIdents = call5070;
  if (call5070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5065 = done;
  } else {
  }
// compiled if node returning if5065 (depth = 3)
    gc_frame_newslot(if5065);
    if5060 = if5065;
  } else {
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_g (depth = 4)
  *var_genericIdents = *var_g;
  if (*var_g == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5060 = done;
  }
// compiled if node returning if5060 (depth = 2)
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5073 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_meth;
  params[1] = *var_part;
  params[2] = *var_acceptBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5074 = callmethodflags(module_parser, "parseArgumentsFor(1)into(1)acceptBlocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compiled call node returning call5074 (depth = 3)
  *var_foundArgs = call5074;
  if (call5074 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_foundArgs (depth = 3)
  Object if5076 = done;
  if (istrue(*var_foundArgs)) {
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5078 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call5079 = callmethodflags(*var_meth, "isIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe5078);
// compiled member node returning call5079 (depth = 5)
  Object if5077 = done;
struct StackFrameObject *iftmpstackframe5077 = stackframe;
  if (istrue(call5079)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5077);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5080 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5081 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5082 = callmethodflags(*var_ast, "implicit", 0, partcv, params, 0);
  gc_frame_end(callframe5081);
// compiled member node returning call5082 (depth = 6)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5083 = callmethodflags(call5082, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5080);
// compiled call node returning call5083 (depth = 5)
    gc_frame_newslot(call5083);
    if5077 = call5083;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5077);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5084 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call5085 = callmethodflags(*var_meth, "receiver", 0, partcv, params, 0);
  gc_frame_end(callframe5084);
// compiled member node returning call5085 (depth = 5)
    gc_frame_newslot(call5085);
    if5077 = call5085;
  }
stackframe = iftmpstackframe5077;
// compiled if node returning if5077 (depth = 4)
  *var_realRcvr = if5077;
  if (if5077 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5086 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_realRcvr (depth = 5)
  gc_frame_newslot(*var_realRcvr);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe5087 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_realRcvr (depth = 6)
  gc_frame_newslot(*var_realRcvr);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_argumentParts (depth = 6)
  gc_frame_newslot(*var_argumentParts);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5088 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5089 = callmethodflags(*var_ast, "callNode", 0, partcv, params, 0);
  gc_frame_end(callframe5088);
// compiled member node returning call5089 (depth = 6)
  params[0] = *var_realRcvr;
  params[1] = *var_argumentParts;
  partcv[0] = 2;
  Object call5090 = callmethodflags(call5089, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5087);
// compiled call node returning call5090 (depth = 5)
  params[0] = *var_realRcvr;
  partcv[0] = 1;
  Object call5091 = callmethodflags(call5090, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5086);
// compiled call node returning call5091 (depth = 4)
  *var_meth = call5091;
  if (call5091 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5093 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5094 = alloc_Block(NULL, NULL, "parser", 1753);
  gc_frame_newslot(block5094);
// method "_apply"
  block_savedest(block5094);
  Object closure5095 = createclosure(2, "_apply");
  setclosureframe(closure5095, stackframe);
  addtoclosure(closure5095, var_statementToken);
  addtoclosure(closure5095, selfslot);
  struct UserObject *uo5095 = (struct UserObject*)block5094;
  uo5095->data[0] = (Object)closure5095;
  Method *meth_meth_parser_5095__apply = addmethod2pos(block5094, "_apply", &meth_parser_5095__apply, 0);
  int argcv_meth_parser_5095__apply[] = {0};
  meth_meth_parser_5095__apply->type = alloc_MethodType(1, argcv_meth_parser_5095__apply);
  meth_meth_parser_5095__apply->definitionModule = modulename;
  meth_meth_parser_5095__apply->definitionLine = 3208;
// compiled block node returning block5094 (depth = 4)
  gc_frame_newslot(block5094);
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5100 = alloc_Block(NULL, NULL, "parser", 1753);
  gc_frame_newslot(block5100);
// method "_apply"
  block_savedest(block5100);
  Object closure5101 = createclosure(10, "_apply");
  setclosureframe(closure5101, stackframe);
  addtoclosure(closure5101, var_sym);
  addtoclosure(closure5101, var_ast);
  addtoclosure(closure5101, var_meth);
  addtoclosure(closure5101, var_acceptBlocks);
  addtoclosure(closure5101, var_errormessages);
  addtoclosure(closure5101, var_lastToken);
  addtoclosure(closure5101, var_lnum);
  addtoclosure(closure5101, var_lpos);
  addtoclosure(closure5101, var_argumentParts);
  addtoclosure(closure5101, selfslot);
  struct UserObject *uo5101 = (struct UserObject*)block5100;
  uo5101->data[0] = (Object)closure5101;
  Method *meth_meth_parser_5101__apply = addmethod2pos(block5100, "_apply", &meth_parser_5101__apply, 0);
  int argcv_meth_parser_5101__apply[] = {0};
  meth_meth_parser_5101__apply->type = alloc_MethodType(1, argcv_meth_parser_5101__apply);
  meth_meth_parser_5101__apply->definitionModule = modulename;
  meth_meth_parser_5101__apply->definitionLine = 3208;
// compiled block node returning block5100 (depth = 4)
  gc_frame_newslot(block5100);
// call case 5: prelude request
  params[0] = block5094;
  params[1] = block5100;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5157 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5093);
// compiled call node returning call5157 (depth = 3)
    gc_frame_newslot(call5157);
    if5076 = call5157;
  } else {
  }
// compiled if node returning if5076 (depth = 2)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5158 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericIdents (depth = 3)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5159 = callmethodflags(*var_meth, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5158);
// compiled call node returning call5159 (depth = 2)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5160 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5161 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5160);
// compiled call node returning call5161 (depth = 2)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5162 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_parser (depth = 3)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5163 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5162);
// compiled call node returning call5163 (depth = 2)
  gc_frame_end(frame);
  return call5163;
}
Object meth_parser_5176__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe5177 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5178 == NULL) {
    strlit5178 = alloc_String("lbrace");
    gc_root(strlit5178);
  }
// compiled string node returning strlit5178 (depth = 7)
  gc_frame_newslot(strlit5178);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5178;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5179 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5177);
// compiled call node returning call5179 (depth = 6)
  gc_frame_end(frame);
  return call5179;
}
Object meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseArgumentsFor(1)into(1)acceptBlocks(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseArgumentsFor(_)into(_)acceptBlocks(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseArgumentsFor(_)");
  Object *var_part = &(stackframe->slots[1]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptBlocks(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_tok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "tok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5166 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5167 == NULL) {
    strlit5167 = alloc_String("lparen");
    gc_root(strlit5167);
  }
// compiled string node returning strlit5167 (depth = 4)
  gc_frame_newslot(strlit5167);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5167;
  partcv[0] = 1;
  Object call5168 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5166);
// compiled call node returning call5168 (depth = 3)
  Object if5165 = done;
  if (istrue(call5168)) {
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5170 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_part;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5171 = callmethodflags(module_parser, "parenthesizedArgs(1)startingWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5170);
// compiled call node returning call5171 (depth = 3)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5172 = alloc_Boolean(1);
// compiled identifier node returning bool5172 (depth = 3)
    gc_frame_newslot(bool5172);
    if5165 = bool5172;
  } else {
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block5175 = alloc_Block(NULL, NULL, "parser", 1793);
  gc_frame_newslot(block5175);
// method "_apply"
  block_savedest(block5175);
  Object closure5176 = createclosure(2, "_apply");
  setclosureframe(closure5176, stackframe);
  addtoclosure(closure5176, var_statementToken);
  addtoclosure(closure5176, selfslot);
  struct UserObject *uo5176 = (struct UserObject*)block5175;
  uo5176->data[0] = (Object)closure5176;
  Method *meth_meth_parser_5176__apply = addmethod2pos(block5175, "_apply", &meth_parser_5176__apply, 0);
  int argcv_meth_parser_5176__apply[] = {0};
  meth_meth_parser_5176__apply->type = alloc_MethodType(1, argcv_meth_parser_5176__apply);
  meth_meth_parser_5176__apply->definitionModule = modulename;
  meth_meth_parser_5176__apply->definitionLine = 3208;
// compiled block node returning block5175 (depth = 5)
  int op_slot_right_5174 = gc_frame_newslot(block5175);
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  Object call5183 = callmethodflags(*var_acceptBlocks, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5182);
// compiled member node returning call5183 (depth = 5)
  int op_slot_left_5174 = gc_frame_newslot(call5183);
  params[0] = block5175;
  partcv[0] = 1;
  Object opresult5184 = callmethod(call5183, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5184 (depth = 4)
  Object if5173 = done;
  if (istrue(opresult5184)) {
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5185 = alloc_Boolean(0);
// compiled identifier node returning bool5185 (depth = 4)
    gc_frame_newslot(bool5185);
    if5173 = bool5185;
  } else {
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5187 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call5188 = callmethodflags(module_parser, "acceptArgumentOnLineOf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5187);
// compiled call node returning call5188 (depth = 5)
  Object if5186 = done;
  if (istrue(call5188)) {
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5190 = gc_frame_new();
// call case 4: self request
  Object call5191 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5190);
// compiled member node returning call5191 (depth = 5)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5192 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5194 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5193);
// compiled member node returning call5194 (depth = 6)
  gc_frame_newslot(call5194);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call5196 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5195);
// compiled member node returning call5196 (depth = 6)
  params[0] = call5194;
  partcv[0] = 1;
  Object call5197 = callmethodflags(call5196, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5192);
// compiled call node returning call5197 (depth = 5)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5198 = alloc_Boolean(1);
// compiled identifier node returning bool5198 (depth = 5)
    gc_frame_newslot(bool5198);
    if5186 = bool5198;
  } else {
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5199 = alloc_Boolean(0);
// compiled identifier node returning bool5199 (depth = 5)
    gc_frame_newslot(bool5199);
    if5186 = bool5199;
  }
// compiled if node returning if5186 (depth = 4)
    gc_frame_newslot(if5186);
    if5173 = if5186;
  }
// compiled if node returning if5173 (depth = 3)
    gc_frame_newslot(if5173);
    if5165 = if5173;
  }
// compiled if node returning if5165 (depth = 2)
  gc_frame_end(frame);
  return if5165;
}
Object meth_parser_5206__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5207 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5208 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5207);
// compiled call node returning call5208 (depth = 5)
  gc_frame_end(frame);
  return call5208;
}
Object meth_parser_5213__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5214 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5215 == NULL) {
    strlit5215 = alloc_String("comma");
    gc_root(strlit5215);
  }
// compiled string node returning strlit5215 (depth = 6)
  gc_frame_newslot(strlit5215);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5215;
  partcv[0] = 1;
  Object call5216 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5214);
// compiled call node returning call5216 (depth = 5)
  gc_frame_end(frame);
  return call5216;
}
Object meth_parser_5231__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe5232 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5233 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5232);
// compiled call node returning call5233 (depth = 8)
  gc_frame_end(frame);
  return call5233;
}
Object meth_parser_5219__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5220 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5221 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5222 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5221);
// compiled member node returning call5222 (depth = 6)
  gc_frame_newslot(call5222);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5223 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call5224 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5223);
// compiled member node returning call5224 (depth = 6)
  params[0] = call5222;
  partcv[0] = 1;
  Object call5225 = callmethodflags(call5224, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5220);
// compiled call node returning call5225 (depth = 5)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5226 = gc_frame_new();
// call case 4: self request
  Object call5227 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5226);
// compiled member node returning call5227 (depth = 5)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5229 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5230 = alloc_Block(NULL, NULL, "parser", 1811);
  gc_frame_newslot(block5230);
// method "_apply"
  block_savedest(block5230);
  Object closure5231 = createclosure(2, "_apply");
  setclosureframe(closure5231, stackframe);
  addtoclosure(closure5231, var_blocksOK);
  addtoclosure(closure5231, selfslot);
  struct UserObject *uo5231 = (struct UserObject*)block5230;
  uo5231->data[0] = (Object)closure5231;
  Method *meth_meth_parser_5231__apply = addmethod2pos(block5230, "_apply", &meth_parser_5231__apply, 0);
  int argcv_meth_parser_5231__apply[] = {0};
  meth_meth_parser_5231__apply->type = alloc_MethodType(1, argcv_meth_parser_5231__apply);
  meth_meth_parser_5231__apply->definitionModule = modulename;
  meth_meth_parser_5231__apply->definitionLine = 3208;
// compiled block node returning block5230 (depth = 7)
  gc_frame_newslot(block5230);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block5230;
  partcv[0] = 1;
  Object call5235 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5229);
// compiled call node returning call5235 (depth = 6)
  Object if5228 = done;
  if (istrue(call5235)) {
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5236 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5236 (depth = 7)
  *var_suggestions = array5236;
  if (array5236 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5237 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5238 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5239 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5238);
// compiled member node returning call5239 (depth = 8)
  Object call5240 = callmethodflags(call5239, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5237);
// compiled member node returning call5240 (depth = 7)
  *var_suggestion = call5240;
  if (call5240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5241 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5242 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5243 == NULL) {
    strlit5243 = alloc_String("rparen");
    gc_root(strlit5243);
  }
// compiled string node returning strlit5243 (depth = 9)
  params[0] = strlit5243;
  partcv[0] = 1;
  callmethodflags(array5242, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5242 (depth = 8)
  gc_frame_newslot(array5242);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array5242;
  partcv[0] = 1;
  Object call5244 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled call node returning call5244 (depth = 7)
  *var_nextTok = call5244;
  if (call5244 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5246 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5246 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5248 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5248 (depth = 7)
  Object if5245 = done;
  if (istrue(opresult5248)) {
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5249 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5250 == NULL) {
    strlit5250 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5250);
  }
// compiled string node returning strlit5250 (depth = 8)
  gc_frame_newslot(strlit5250);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit5250;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5251 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5249);
// compiled call node returning call5251 (depth = 7)
    gc_frame_newslot(call5251);
    if5245 = call5251;
  } else {
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5252 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call5254 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5253);
// compiled member node returning call5254 (depth = 8)
  gc_frame_newslot(call5254);
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool5255 = alloc_Boolean(1);
// compiled identifier node returning bool5255 (depth = 8)
  gc_frame_newslot(bool5255);
// starting to compile identifier node (depth = 8)
  Object bool5256 = alloc_Boolean(0);
// compiled identifier node returning bool5256 (depth = 8)
  gc_frame_newslot(bool5256);
// starting to compile string node (depth = 8)
  if (strlit5257 == NULL) {
    strlit5257 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5257);
  }
// compiled string node returning strlit5257 (depth = 8)
  gc_frame_newslot(strlit5257);
// call case 6: other requests
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5254;
  params[2] = bool5255;
  params[3] = bool5256;
  params[4] = strlit5257;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5258 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5252);
// compiled call node returning call5258 (depth = 7)
    gc_frame_newslot(call5258);
    if5245 = call5258;
  }
// compiled if node returning if5245 (depth = 6)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5259 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5260 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5259);
// compiled call node returning call5260 (depth = 6)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5261 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5263 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5262);
// compiled member node returning call5263 (depth = 8)
  Object call5264 = callmethodflags(call5263, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5261);
// compiled member node returning call5264 (depth = 7)
  *var_suggestion = call5264;
  if (call5264 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5266 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe5267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call5268 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5267);
// compiled member node returning call5268 (depth = 7)
  gc_frame_newslot(call5268);
// starting to compile identifier node (depth = 7)
  Object bool5269 = alloc_Boolean(1);
// compiled identifier node returning bool5269 (depth = 7)
  gc_frame_newslot(bool5269);
// starting to compile identifier node (depth = 7)
  Object bool5270 = alloc_Boolean(0);
// compiled identifier node returning bool5270 (depth = 7)
  gc_frame_newslot(bool5270);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5268;
  params[2] = bool5269;
  params[3] = bool5270;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5271 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5266);
// compiled call node returning call5271 (depth = 6)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5272 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5273 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5272);
// compiled call node returning call5273 (depth = 6)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5274 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5275 == NULL) {
    strlit5275 = alloc_String("an argument list must have an expression after a ','.");
    gc_root(strlit5275);
  }
// compiled string node returning strlit5275 (depth = 7)
  gc_frame_newslot(strlit5275);
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5276 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5277 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5276);
// compiled member node returning call5277 (depth = 7)
  gc_frame_newslot(call5277);
// starting to compile member node (depth = 7)
  int callframe5278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5279 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5278);
// compiled member node returning call5279 (depth = 7)
  gc_frame_newslot(call5279);
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5275;
  params[1] = call5277;
  params[2] = call5279;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5280 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5274);
// compiled call node returning call5280 (depth = 6)
    gc_frame_newslot(call5280);
    if5228 = call5280;
  } else {
  }
// compiled if node returning if5228 (depth = 5)
  gc_frame_end(frame);
  return if5228;
}
Object meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArgs(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArgs(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArgs(_)startingWith(_)");
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for parenthesizedArgs(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parenthesizedArgs(_)");
  Object *var_tok = &(stackframe->slots[1]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_rng = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rng");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5201 = gc_frame_new();
// call case 4: self request
  Object call5202 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5201);
// compiled member node returning call5202 (depth = 2)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5204 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5205 = alloc_Block(NULL, NULL, "parser", 1807);
  gc_frame_newslot(block5205);
// method "_apply"
  block_savedest(block5205);
  Object closure5206 = createclosure(2, "_apply");
  setclosureframe(closure5206, stackframe);
  addtoclosure(closure5206, var_blocksOK);
  addtoclosure(closure5206, selfslot);
  struct UserObject *uo5206 = (struct UserObject*)block5205;
  uo5206->data[0] = (Object)closure5206;
  Method *meth_meth_parser_5206__apply = addmethod2pos(block5205, "_apply", &meth_parser_5206__apply, 0);
  int argcv_meth_parser_5206__apply[] = {0};
  meth_meth_parser_5206__apply->type = alloc_MethodType(1, argcv_meth_parser_5206__apply);
  meth_meth_parser_5206__apply->definitionModule = modulename;
  meth_meth_parser_5206__apply->definitionLine = 3208;
// compiled block node returning block5205 (depth = 4)
  gc_frame_newslot(block5205);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block5205;
  partcv[0] = 1;
  Object call5210 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5204);
// compiled call node returning call5210 (depth = 3)
  Object if5203 = done;
  if (istrue(call5210)) {
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5211 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5212 = alloc_Block(NULL, NULL, "parser", 1808);
  gc_frame_newslot(block5212);
// method "_apply"
  block_savedest(block5212);
  Object closure5213 = createclosure(1, "_apply");
  setclosureframe(closure5213, stackframe);
  addtoclosure(closure5213, selfslot);
  struct UserObject *uo5213 = (struct UserObject*)block5212;
  uo5213->data[0] = (Object)closure5213;
  Method *meth_meth_parser_5213__apply = addmethod2pos(block5212, "_apply", &meth_parser_5213__apply, 0);
  int argcv_meth_parser_5213__apply[] = {0};
  meth_meth_parser_5213__apply->type = alloc_MethodType(1, argcv_meth_parser_5213__apply);
  meth_meth_parser_5213__apply->definitionModule = modulename;
  meth_meth_parser_5213__apply->definitionLine = 3208;
// compiled block node returning block5212 (depth = 4)
  gc_frame_newslot(block5212);
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5218 = alloc_Block(NULL, NULL, "parser", 1808);
  gc_frame_newslot(block5218);
// method "_apply"
  block_savedest(block5218);
  Object closure5219 = createclosure(7, "_apply");
  setclosureframe(closure5219, stackframe);
  addtoclosure(closure5219, var_values);
  addtoclosure(closure5219, var_part);
  addtoclosure(closure5219, var_blocksOK);
  addtoclosure(closure5219, var_errormessages);
  addtoclosure(closure5219, var_sym);
  addtoclosure(closure5219, var_lastToken);
  addtoclosure(closure5219, selfslot);
  struct UserObject *uo5219 = (struct UserObject*)block5218;
  uo5219->data[0] = (Object)closure5219;
  Method *meth_meth_parser_5219__apply = addmethod2pos(block5218, "_apply", &meth_parser_5219__apply, 0);
  int argcv_meth_parser_5219__apply[] = {0};
  meth_meth_parser_5219__apply->type = alloc_MethodType(1, argcv_meth_parser_5219__apply);
  meth_meth_parser_5219__apply->definitionModule = modulename;
  meth_meth_parser_5219__apply->definitionLine = 3208;
// compiled block node returning block5218 (depth = 4)
  gc_frame_newslot(block5218);
// call case 5: prelude request
  params[0] = block5212;
  params[1] = block5218;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5282 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5211);
// compiled call node returning call5282 (depth = 3)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5283 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5285 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5284);
// compiled member node returning call5285 (depth = 4)
  gc_frame_newslot(call5285);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  Object call5287 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5286);
// compiled member node returning call5287 (depth = 4)
  params[0] = call5285;
  partcv[0] = 1;
  Object call5288 = callmethodflags(call5287, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5283);
// compiled call node returning call5288 (depth = 3)
    gc_frame_newslot(call5288);
    if5203 = call5288;
  } else {
  }
// compiled if node returning if5203 (depth = 2)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5291 == NULL) {
    strlit5291 = alloc_String("rparen");
    gc_root(strlit5291);
  }
// compiled string node returning strlit5291 (depth = 4)
  int op_slot_right_5290 = gc_frame_newslot(strlit5291);
// starting to compile member node (depth = 4)
  int callframe5293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5294 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5293);
// compiled member node returning call5294 (depth = 4)
  int op_slot_left_5290 = gc_frame_newslot(call5294);
  params[0] = strlit5291;
  partcv[0] = 1;
  Object opresult5295 = callmethod(call5294, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5295 (depth = 3)
  Object if5289 = done;
  if (istrue(opresult5295)) {
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5296 = gc_frame_new();
// call case 4: self request
  Object call5297 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5296);
// compiled member node returning call5297 (depth = 3)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5298 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5299 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call5300 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5299);
// compiled member node returning call5300 (depth = 5)
  Object call5301 = callmethodflags(call5300, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5298);
// compiled member node returning call5301 (depth = 4)
  *var_suggestion = call5301;
  if (call5301 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5302 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5303 == NULL) {
    strlit5303 = alloc_String(")");
    gc_root(strlit5303);
  }
// compiled string node returning strlit5303 (depth = 4)
  gc_frame_newslot(strlit5303);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5303;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5304 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5302);
// compiled call node returning call5304 (depth = 3)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5305 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5306 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5307 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call5308 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5307);
// compiled member node returning call5308 (depth = 6)
  gc_frame_newslot(call5308);
// starting to compile member node (depth = 6)
  int callframe5309 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call5310 = callmethodflags(*var_tok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5309);
// compiled member node returning call5310 (depth = 6)
  gc_frame_newslot(call5310);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  params[0] = call5308;
  params[1] = call5310;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5311 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5306);
// compiled call node returning call5311 (depth = 5)
  gc_frame_newslot(call5311);
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5312 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5313 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call5314 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5313);
// compiled member node returning call5314 (depth = 6)
  gc_frame_newslot(call5314);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5317 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5316);
// compiled member node returning call5317 (depth = 7)
  int op_slot_right_5315 = gc_frame_newslot(call5317);
// starting to compile member node (depth = 7)
  int callframe5319 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5320 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5319);
// compiled member node returning call5320 (depth = 7)
  int op_slot_left_5315 = gc_frame_newslot(call5320);
  params[0] = call5317;
  partcv[0] = 1;
  Object sum5321 = callmethod(call5320, "+(1)", 1, partcv, params);
// compiled op node returning sum5321 (depth = 6)
  gc_frame_newslot(sum5321);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  params[0] = call5314;
  params[1] = sum5321;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5322 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5312);
// compiled call node returning call5322 (depth = 5)
  gc_frame_newslot(call5322);
// call case 6: other requests
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  params[0] = call5311;
  params[1] = call5322;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5323 = callmethodflags(*var_ast, "start(1)end(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5305);
// compiled call node returning call5323 (depth = 4)
  *var_rng = call5323;
  if (call5323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5324 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5325 == NULL) {
    strlit5325 = alloc_String("an argument list beginning with a '(' must end with a ')'.");
    gc_root(strlit5325);
  }
// compiled string node returning strlit5325 (depth = 4)
  gc_frame_newslot(strlit5325);
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rng (depth = 4)
  gc_frame_newslot(*var_rng);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5325;
  params[1] = *var_rng;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5326 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(1)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5324);
// compiled call node returning call5326 (depth = 3)
    gc_frame_newslot(call5326);
    if5289 = call5326;
  } else {
  }
// compiled if node returning if5289 (depth = 2)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5329 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  Object call5330 = callmethodflags(*var_part, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5329);
// compiled member node returning call5330 (depth = 4)
  int op_slot_right_5328 = gc_frame_newslot(call5330);
// starting to compile member node (depth = 4)
  int callframe5332 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5333 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5332);
// compiled member node returning call5333 (depth = 4)
  int op_slot_left_5328 = gc_frame_newslot(call5333);
  params[0] = call5330;
  partcv[0] = 1;
  Object opresult5334 = callmethod(call5333, "==(1)", 1, partcv, params);
// compiled op node returning opresult5334 (depth = 3)
  Object if5327 = done;
  if (istrue(opresult5334)) {
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5335 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5337 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call5338 = callmethodflags(*var_part, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5337);
// compiled member node returning call5338 (depth = 5)
  int op_slot_right_5336 = gc_frame_newslot(call5338);
// starting to compile member node (depth = 5)
  int callframe5340 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5341 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5340);
// compiled member node returning call5341 (depth = 5)
  int op_slot_left_5336 = gc_frame_newslot(call5341);
  params[0] = call5338;
  partcv[0] = 1;
  Object diff5342 = callmethod(call5341, "-(1)", 1, partcv, params);
// compiled op node returning diff5342 (depth = 4)
  gc_frame_newslot(diff5342);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = diff5342;
  partcv[0] = 1;
  Object call5343 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5335);
// compiled call node returning call5343 (depth = 3)
    gc_frame_newslot(call5343);
    if5327 = call5343;
  } else {
  }
// compiled if node returning if5327 (depth = 2)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5344 = gc_frame_new();
// call case 4: self request
  Object call5345 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5344);
// compiled member node returning call5345 (depth = 2)
  gc_frame_end(frame);
  return call5345;
}
Object meth_parser_5362__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe5363 = gc_frame_new();
// call case 4: self request
  Object call5364 = callmethodflags(self, "typeArg", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5363);
// compiled member node returning call5364 (depth = 6)
  gc_frame_end(frame);
  return call5364;
}
Object meth_parser_5359__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe5360 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5361 = alloc_Block(NULL, NULL, "parser", 1854);
  gc_frame_newslot(block5361);
// method "_apply"
  block_savedest(block5361);
  Object closure5362 = createclosure(1, "_apply");
  setclosureframe(closure5362, stackframe);
  addtoclosure(closure5362, selfslot);
  struct UserObject *uo5362 = (struct UserObject*)block5361;
  uo5362->data[0] = (Object)closure5362;
  Method *meth_meth_parser_5362__apply = addmethod2pos(block5361, "_apply", &meth_parser_5362__apply, 0);
  int argcv_meth_parser_5362__apply[] = {0};
  meth_meth_parser_5362__apply->type = alloc_MethodType(1, argcv_meth_parser_5362__apply);
  meth_meth_parser_5362__apply->definitionModule = modulename;
  meth_meth_parser_5362__apply->definitionLine = 3208;
// compiled block node returning block5361 (depth = 5)
  gc_frame_newslot(block5361);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block5361;
  partcv[0] = 1;
  Object call5366 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5360);
// compiled call node returning call5366 (depth = 4)
  gc_frame_end(frame);
  return call5366;
}
Object meth_parser_5369__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5370 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call5372 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5371);
// compiled member node returning call5372 (depth = 5)
  gc_frame_newslot(call5372);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call5372;
  partcv[0] = 1;
  Object call5373 = callmethodflags(*var_args, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5370);
// compiled call node returning call5373 (depth = 4)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5376 == NULL) {
    strlit5376 = alloc_String("comma");
    gc_root(strlit5376);
  }
// compiled string node returning strlit5376 (depth = 6)
  int op_slot_right_5375 = gc_frame_newslot(strlit5376);
// starting to compile member node (depth = 6)
  int callframe5378 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5379 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5378);
// compiled member node returning call5379 (depth = 6)
  int op_slot_left_5375 = gc_frame_newslot(call5379);
  params[0] = strlit5376;
  partcv[0] = 1;
  Object opresult5380 = callmethod(call5379, "==(1)", 1, partcv, params);
// compiled op node returning opresult5380 (depth = 5)
  Object if5374 = done;
  if (istrue(opresult5380)) {
// starting to compile member node (depth = 5)
  int callframe5381 = gc_frame_new();
// call case 4: self request
  Object call5382 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled member node returning call5382 (depth = 5)
    gc_frame_newslot(call5382);
    if5374 = call5382;
  } else {
  }
// compiled if node returning if5374 (depth = 4)
  gc_frame_end(frame);
  return if5374;
}
Object meth_parser_5346_typeArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_args = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "args");
// definebindings:
// definebindings:
  Object *var_startToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "startToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// definebindings:
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5347 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5347 (depth = 3)
  *var_args = array5347;
  if (array5347 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5350 == NULL) {
    strlit5350 = alloc_String("lgeneric");
    gc_root(strlit5350);
  }
// compiled string node returning strlit5350 (depth = 4)
  int op_slot_right_5349 = gc_frame_newslot(strlit5350);
// starting to compile member node (depth = 4)
  int callframe5352 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5353 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5352);
// compiled member node returning call5353 (depth = 4)
  int op_slot_left_5349 = gc_frame_newslot(call5353);
  params[0] = strlit5350;
  partcv[0] = 1;
  Object opresult5354 = callmethod(call5353, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5354 (depth = 3)
  Object if5348 = done;
  if (istrue(opresult5354)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5348 = undefined;
  } else {
  }
// compiled if node returning if5348 (depth = 2)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5355 = gc_frame_new();
// call case 4: self request
  Object call5356 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5355);
// compiled member node returning call5356 (depth = 2)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5357 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5358 = alloc_Block(NULL, NULL, "parser", 1854);
  gc_frame_newslot(block5358);
// method "_apply"
  block_savedest(block5358);
  Object closure5359 = createclosure(1, "_apply");
  setclosureframe(closure5359, stackframe);
  addtoclosure(closure5359, selfslot);
  struct UserObject *uo5359 = (struct UserObject*)block5358;
  uo5359->data[0] = (Object)closure5359;
  Method *meth_meth_parser_5359__apply = addmethod2pos(block5358, "_apply", &meth_parser_5359__apply, 0);
  int argcv_meth_parser_5359__apply[] = {0};
  meth_meth_parser_5359__apply->type = alloc_MethodType(1, argcv_meth_parser_5359__apply);
  meth_meth_parser_5359__apply->definitionModule = modulename;
  meth_meth_parser_5359__apply->definitionLine = 3208;
// compiled block node returning block5358 (depth = 3)
  gc_frame_newslot(block5358);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5368 = alloc_Block(NULL, NULL, "parser", 1854);
  gc_frame_newslot(block5368);
// method "_apply"
  block_savedest(block5368);
  Object closure5369 = createclosure(4, "_apply");
  setclosureframe(closure5369, stackframe);
  addtoclosure(closure5369, var_values);
  addtoclosure(closure5369, var_args);
  addtoclosure(closure5369, var_sym);
  addtoclosure(closure5369, selfslot);
  struct UserObject *uo5369 = (struct UserObject*)block5368;
  uo5369->data[0] = (Object)closure5369;
  Method *meth_meth_parser_5369__apply = addmethod2pos(block5368, "_apply", &meth_parser_5369__apply, 0);
  int argcv_meth_parser_5369__apply[] = {0};
  meth_meth_parser_5369__apply->type = alloc_MethodType(1, argcv_meth_parser_5369__apply);
  meth_meth_parser_5369__apply->definitionModule = modulename;
  meth_meth_parser_5369__apply->definitionLine = 3208;
// compiled block node returning block5368 (depth = 3)
  gc_frame_newslot(block5368);
// call case 5: prelude request
  params[0] = block5358;
  params[1] = block5368;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5384 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5357);
// compiled call node returning call5384 (depth = 2)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5387 == NULL) {
    strlit5387 = alloc_String("rgeneric");
    gc_root(strlit5387);
  }
// compiled string node returning strlit5387 (depth = 4)
  int op_slot_right_5386 = gc_frame_newslot(strlit5387);
// starting to compile member node (depth = 4)
  int callframe5389 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5390 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5389);
// compiled member node returning call5390 (depth = 4)
  int op_slot_left_5386 = gc_frame_newslot(call5390);
  params[0] = strlit5387;
  partcv[0] = 1;
  Object opresult5391 = callmethod(call5390, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5391 (depth = 3)
  Object if5385 = done;
  if (istrue(opresult5391)) {
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5392 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call5394 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5393);
// compiled member node returning call5394 (depth = 5)
  Object call5395 = callmethodflags(call5394, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5392);
// compiled member node returning call5395 (depth = 4)
  *var_suggestion = call5395;
  if (call5395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5396 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5397 == NULL) {
    strlit5397 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit5397);
  }
// compiled string node returning strlit5397 (depth = 4)
  gc_frame_newslot(strlit5397);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5397;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5398 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5396);
// compiled call node returning call5398 (depth = 3)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5399 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5400 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call5401 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5400);
// compiled member node returning call5401 (depth = 5)
  Object call5402 = callmethodflags(call5401, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5399);
// compiled member node returning call5402 (depth = 4)
  *var_suggestion2 = call5402;
  if (call5402 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5403 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5404 == NULL) {
    strlit5404 = alloc_String(" ");
    gc_root(strlit5404);
  }
// compiled string node returning strlit5404 (depth = 4)
  gc_frame_newslot(strlit5404);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit5404;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5405 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5403);
// compiled call node returning call5405 (depth = 3)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array5406 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array5406, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array5406, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5406 (depth = 4)
  *var_suggestions = array5406;
  if (array5406 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5407 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5408 == NULL) {
    strlit5408 = alloc_String("a method request containing a '""\xe2""""\x9f""""\xa6""' must have a matching '""\xe2""""\x9f""""\xa7""'. ");
    gc_root(strlit5408);
  }
// compiled string node returning strlit5408 (depth = 4)
  gc_frame_newslot(strlit5408);
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call5410 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5409);
// compiled member node returning call5410 (depth = 4)
  gc_frame_newslot(call5410);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5412 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call5413 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5412);
// compiled member node returning call5413 (depth = 5)
  int op_slot_right_5411 = gc_frame_newslot(call5413);
// starting to compile member node (depth = 5)
  int callframe5415 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call5416 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5415);
// compiled member node returning call5416 (depth = 5)
  int op_slot_left_5411 = gc_frame_newslot(call5416);
  params[0] = call5413;
  partcv[0] = 1;
  Object sum5417 = callmethod(call5416, "+(1)", 1, partcv, params);
// compiled op node returning sum5417 (depth = 4)
  gc_frame_newslot(sum5417);
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5408;
  params[1] = call5410;
  params[2] = sum5417;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5418 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5407);
// compiled call node returning call5418 (depth = 3)
    gc_frame_newslot(call5418);
    if5385 = call5418;
  } else {
  }
// compiled if node returning if5385 (depth = 2)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5419 = gc_frame_new();
// call case 4: self request
  Object call5420 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5419);
// compiled member node returning call5420 (depth = 2)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_5421_typeArg(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5423 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5424 == NULL) {
    strlit5424 = alloc_String("identifier");
    gc_root(strlit5424);
  }
// compiled string node returning strlit5424 (depth = 4)
  gc_frame_newslot(strlit5424);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5424;
  partcv[0] = 1;
  Object call5425 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5423);
// compiled call node returning call5425 (depth = 3)
  Object if5422 = done;
  if (istrue(call5425)) {
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5426 = gc_frame_new();
// call case 4: self request
  Object call5427 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5426);
// compiled member node returning call5427 (depth = 3)
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5430 == NULL) {
    strlit5430 = alloc_String("lgeneric");
    gc_root(strlit5430);
  }
// compiled string node returning strlit5430 (depth = 5)
  int op_slot_right_5429 = gc_frame_newslot(strlit5430);
// starting to compile member node (depth = 5)
  int callframe5432 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5433 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5432);
// compiled member node returning call5433 (depth = 5)
  int op_slot_left_5429 = gc_frame_newslot(call5433);
  params[0] = strlit5430;
  partcv[0] = 1;
  Object opresult5434 = callmethod(call5433, "==(1)", 1, partcv, params);
// compiled op node returning opresult5434 (depth = 4)
  Object if5428 = done;
  if (istrue(opresult5434)) {
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5435 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5436 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5437 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5438 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5437);
// compiled member node returning call5438 (depth = 6)
  gc_frame_newslot(call5438);
// starting to compile member node (depth = 6)
  int callframe5439 = gc_frame_new();
// call case 4: self request
  Object call5440 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5439);
// compiled member node returning call5440 (depth = 6)
  gc_frame_newslot(call5440);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5442 = callmethodflags(*var_ast, "genericNode", 0, partcv, params, 0);
  gc_frame_end(callframe5441);
// compiled member node returning call5442 (depth = 6)
  params[0] = call5438;
  params[1] = call5440;
  partcv[0] = 2;
  Object call5443 = callmethodflags(call5442, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5436);
// compiled call node returning call5443 (depth = 5)
  gc_frame_newslot(call5443);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call5443;
  partcv[0] = 1;
  Object call5444 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5435);
// compiled call node returning call5444 (depth = 4)
    gc_frame_newslot(call5444);
    if5428 = call5444;
  } else {
  }
// compiled if node returning if5428 (depth = 3)
    gc_frame_newslot(if5428);
    if5422 = if5428;
  } else {
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5445 = gc_frame_new();
// call case 4: self request
  Object call5446 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compiled member node returning call5446 (depth = 3)
    gc_frame_newslot(call5446);
    if5422 = call5446;
  }
// compiled if node returning if5422 (depth = 2)
  gc_frame_end(frame);
  return if5422;
}
Object meth_parser_5454__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5458 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5457);
// compiled member node returning call5458 (depth = 7)
  int op_slot_right_5456 = gc_frame_newslot(call5458);
// starting to compile member node (depth = 7)
  int callframe5460 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  Object call5461 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5460);
// compiled member node returning call5461 (depth = 7)
  int op_slot_left_5456 = gc_frame_newslot(call5461);
  params[0] = call5458;
  partcv[0] = 1;
  Object opresult5462 = callmethod(call5461, "==(1)", 1, partcv, params);
// compiled op node returning opresult5462 (depth = 6)
  int op_slot_right_5455 = gc_frame_newslot(opresult5462);
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5466 == NULL) {
    strlit5466 = alloc_String("=");
    gc_root(strlit5466);
  }
// compiled string node returning strlit5466 (depth = 8)
  int op_slot_right_5465 = gc_frame_newslot(strlit5466);
// starting to compile member node (depth = 8)
  int callframe5468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  Object call5469 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5468);
// compiled member node returning call5469 (depth = 8)
  int op_slot_left_5465 = gc_frame_newslot(call5469);
  params[0] = strlit5466;
  partcv[0] = 1;
  Object opresult5470 = callmethod(call5469, "==(1)", 1, partcv, params);
// compiled op node returning opresult5470 (depth = 7)
  int op_slot_right_5464 = gc_frame_newslot(opresult5470);
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5473 == NULL) {
    strlit5473 = alloc_String("op");
    gc_root(strlit5473);
  }
// compiled string node returning strlit5473 (depth = 8)
  int op_slot_right_5472 = gc_frame_newslot(strlit5473);
// starting to compile member node (depth = 8)
  int callframe5475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  Object call5476 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5475);
// compiled member node returning call5476 (depth = 8)
  int op_slot_left_5472 = gc_frame_newslot(call5476);
  params[0] = strlit5473;
  partcv[0] = 1;
  Object opresult5477 = callmethod(call5476, "==(1)", 1, partcv, params);
// compiled op node returning opresult5477 (depth = 7)
  int op_slot_left_5464 = gc_frame_newslot(opresult5477);
  params[0] = opresult5470;
  partcv[0] = 1;
  Object opresult5478 = callmethod(opresult5477, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5478 (depth = 6)
  int op_slot_left_5455 = gc_frame_newslot(opresult5478);
  params[0] = opresult5462;
  partcv[0] = 1;
  Object opresult5479 = callmethod(opresult5478, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5479 (depth = 5)
  gc_frame_end(frame);
  return opresult5479;
}
Object meth_parser_5447_errorDefNoName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefNoName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextToken");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5448 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5450 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5449);
// compiled member node returning call5450 (depth = 4)
  Object call5451 = callmethodflags(call5450, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5448);
// compiled member node returning call5451 (depth = 3)
  *var_suggestion = call5451;
  if (call5451 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5452 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5453 = alloc_Block(NULL, NULL, "parser", 1889);
  gc_frame_newslot(block5453);
// method "_apply(_)"
  block_savedest(block5453);
  Object closure5454 = createclosure(2, "_apply(1)");
  setclosureframe(closure5454, stackframe);
  addtoclosure(closure5454, var_sym);
  addtoclosure(closure5454, selfslot);
  struct UserObject *uo5454 = (struct UserObject*)block5453;
  uo5454->data[0] = (Object)closure5454;
  Method *meth_meth_parser_5454__apply_40_1_41_ = addmethod2pos(block5453, "_apply(1)", &meth_parser_5454__apply_40_1_41_, 0);
  int argcv_meth_parser_5454__apply_40_1_41_[] = {1};
  meth_meth_parser_5454__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5454__apply_40_1_41_);
  meth_meth_parser_5454__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5454__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block5453 (depth = 4)
  gc_frame_newslot(block5453);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block5453;
  partcv[0] = 1;
  Object call5481 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5452);
// compiled call node returning call5481 (depth = 3)
  *var_nextToken = call5481;
  if (call5481 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextToken (depth = 4)
  int op_slot_right_5483 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 4)
  Object bool5485 = alloc_Boolean(0);
// compiled identifier node returning bool5485 (depth = 4)
  int op_slot_left_5483 = gc_frame_newslot(bool5485);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult5486 = callmethod(bool5485, "==(1)", 1, partcv, params);
// compiled op node returning opresult5486 (depth = 3)
  Object if5482 = done;
  if (istrue(opresult5486)) {
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5487 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5488 == NULL) {
    strlit5488 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit5488);
  }
// compiled string node returning strlit5488 (depth = 4)
  gc_frame_newslot(strlit5488);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5488;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5489 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5487);
// compiled call node returning call5489 (depth = 3)
    gc_frame_newslot(call5489);
    if5482 = call5489;
  } else {
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_5491 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextToken (depth = 5)
  int op_slot_left_5491 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5493 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult5493 (depth = 4)
  Object if5490 = done;
  if (istrue(opresult5493)) {
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5494 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5495 == NULL) {
    strlit5495 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit5495);
  }
// compiled string node returning strlit5495 (depth = 5)
  gc_frame_newslot(strlit5495);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5495;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5496 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5494);
// compiled call node returning call5496 (depth = 4)
    gc_frame_newslot(call5496);
    if5490 = call5496;
  } else {
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5497 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe5498 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  Object call5499 = callmethodflags(*var_nextToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5498);
// compiled member node returning call5499 (depth = 5)
  gc_frame_newslot(call5499);
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5500 = alloc_Boolean(0);
// compiled identifier node returning bool5500 (depth = 5)
  gc_frame_newslot(bool5500);
// starting to compile identifier node (depth = 5)
  Object bool5501 = alloc_Boolean(1);
// compiled identifier node returning bool5501 (depth = 5)
  gc_frame_newslot(bool5501);
// starting to compile string node (depth = 5)
  if (strlit5502 == NULL) {
    strlit5502 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit5502);
  }
// compiled string node returning strlit5502 (depth = 5)
  gc_frame_newslot(strlit5502);
// call case 6: other requests
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call5499;
  params[2] = bool5500;
  params[3] = bool5501;
  params[4] = strlit5502;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5503 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5497);
// compiled call node returning call5503 (depth = 4)
    gc_frame_newslot(call5503);
    if5490 = call5503;
  }
// compiled if node returning if5490 (depth = 3)
    gc_frame_newslot(if5490);
    if5482 = if5490;
  }
// compiled if node returning if5482 (depth = 2)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5504 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5506 == NULL) {
    strlit5506 = alloc_String("and a value after the 'def'.");
    gc_root(strlit5506);
  }
// compiled string node returning strlit5506 (depth = 4)
  int op_slot_right_5505 = gc_frame_newslot(strlit5506);
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5508 == NULL) {
    strlit5508 = alloc_String("a definition must have a name, '=', ");
    gc_root(strlit5508);
  }
// compiled string node returning strlit5508 (depth = 4)
  int op_slot_left_5505 = gc_frame_newslot(strlit5508);
  params[0] = strlit5506;
  partcv[0] = 1;
  Object opresult5509 = callmethod(strlit5508, "++(1)", 1, partcv, params);
// compiled op node returning opresult5509 (depth = 3)
  gc_frame_newslot(opresult5509);
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5511 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5510);
// compiled member node returning call5511 (depth = 3)
  gc_frame_newslot(call5511);
// starting to compile member node (depth = 3)
  int callframe5512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5513 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5512);
// compiled member node returning call5513 (depth = 3)
  gc_frame_newslot(call5513);
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5509;
  params[1] = call5511;
  params[2] = call5513;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5514 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5504);
// compiled call node returning call5514 (depth = 2)
  gc_frame_end(frame);
  return call5514;
}
Object meth_parser_5515_errorDefNoExpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefNoExpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5516 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5517 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5518 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5517);
// compiled member node returning call5518 (depth = 4)
  Object call5519 = callmethodflags(call5518, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5516);
// compiled member node returning call5519 (depth = 3)
  *var_suggestion = call5519;
  if (call5519 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5520 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array5521 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5521 (depth = 4)
  gc_frame_newslot(array5521);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array5521;
  partcv[0] = 1;
  Object call5522 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5520);
// compiled call node returning call5522 (depth = 3)
  *var_nextTok = call5522;
  if (call5522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_5524 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_5524 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5526 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5526 (depth = 3)
  Object if5523 = done;
  if (istrue(opresult5526)) {
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5527 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5528 == NULL) {
    strlit5528 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5528);
  }
// compiled string node returning strlit5528 (depth = 4)
  gc_frame_newslot(strlit5528);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5528;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5529 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5527);
// compiled call node returning call5529 (depth = 3)
    gc_frame_newslot(call5529);
    if5523 = call5529;
  } else {
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5530 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe5531 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  Object call5532 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5531);
// compiled member node returning call5532 (depth = 4)
  gc_frame_newslot(call5532);
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5533 = alloc_Boolean(1);
// compiled identifier node returning bool5533 (depth = 4)
  gc_frame_newslot(bool5533);
// starting to compile identifier node (depth = 4)
  Object bool5534 = alloc_Boolean(0);
// compiled identifier node returning bool5534 (depth = 4)
  gc_frame_newslot(bool5534);
// starting to compile string node (depth = 4)
  if (strlit5535 == NULL) {
    strlit5535 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5535);
  }
// compiled string node returning strlit5535 (depth = 4)
  gc_frame_newslot(strlit5535);
// call case 6: other requests
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call5532;
  params[2] = bool5533;
  params[3] = bool5534;
  params[4] = strlit5535;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5536 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5530);
// compiled call node returning call5536 (depth = 3)
    gc_frame_newslot(call5536);
    if5523 = call5536;
  }
// compiled if node returning if5523 (depth = 2)
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5537 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5538 == NULL) {
    strlit5538 = alloc_String("a definition must have a value after the '='.");
    gc_root(strlit5538);
  }
// compiled string node returning strlit5538 (depth = 3)
  gc_frame_newslot(strlit5538);
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5539 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  Object call5540 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5539);
// compiled member node returning call5540 (depth = 3)
  gc_frame_newslot(call5540);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call5543 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5542);
// compiled member node returning call5543 (depth = 4)
  int op_slot_right_5541 = gc_frame_newslot(call5543);
// starting to compile member node (depth = 4)
  int callframe5545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call5546 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5545);
// compiled member node returning call5546 (depth = 4)
  int op_slot_left_5541 = gc_frame_newslot(call5546);
  params[0] = call5543;
  partcv[0] = 1;
  Object sum5547 = callmethod(call5546, "+(1)", 1, partcv, params);
// compiled op node returning sum5547 (depth = 3)
  gc_frame_newslot(sum5547);
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit5538;
  params[1] = call5540;
  params[2] = sum5547;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5548 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5537);
// compiled call node returning call5548 (depth = 2)
  gc_frame_end(frame);
  return call5548;
}
Object meth_parser_5549_errorDefUsesAssign_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefUsesAssign(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method errorDefUsesAssign(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for errorDefUsesAssign(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_defTok = &(stackframe->slots[0]);
  *var_defTok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part errorDefUsesAssign(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5550 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5550 (depth = 3)
  *var_suggestions = array5550;
  if (array5550 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5551 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5553 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5552);
// compiled member node returning call5553 (depth = 4)
  Object call5554 = callmethodflags(call5553, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5551);
// compiled member node returning call5554 (depth = 3)
  *var_suggestion = call5554;
  if (call5554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5555 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 3)
  if (strlit5556 == NULL) {
    strlit5556 = alloc_String("=");
    gc_root(strlit5556);
  }
// compiled string node returning strlit5556 (depth = 3)
  gc_frame_newslot(strlit5556);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_sym;
  params[1] = strlit5556;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5557 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5555);
// compiled call node returning call5557 (depth = 2)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5558 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5559 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5558);
// compiled call node returning call5559 (depth = 2)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5560 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5561 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5562 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5561);
// compiled member node returning call5562 (depth = 4)
  Object call5563 = callmethodflags(call5562, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5560);
// compiled member node returning call5563 (depth = 3)
  *var_suggestion = call5563;
  if (call5563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5565 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defTok (depth = 3)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 3)
  if (strlit5566 == NULL) {
    strlit5566 = alloc_String("var");
    gc_root(strlit5566);
  }
// compiled string node returning strlit5566 (depth = 3)
  gc_frame_newslot(strlit5566);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_defTok;
  params[1] = strlit5566;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5567 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5565);
// compiled call node returning call5567 (depth = 2)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5568 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5569 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5568);
// compiled call node returning call5569 (depth = 2)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5570 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5572 == NULL) {
    strlit5572 = alloc_String("A variable declaration uses 'var' and ':='.");
    gc_root(strlit5572);
  }
// compiled string node returning strlit5572 (depth = 4)
  int op_slot_right_5571 = gc_frame_newslot(strlit5572);
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5574 == NULL) {
    strlit5574 = alloc_String("a definition must use '=' instead of ':='. ");
    gc_root(strlit5574);
  }
// compiled string node returning strlit5574 (depth = 4)
  int op_slot_left_5571 = gc_frame_newslot(strlit5574);
  params[0] = strlit5572;
  partcv[0] = 1;
  Object opresult5575 = callmethod(strlit5574, "++(1)", 1, partcv, params);
// compiled op node returning opresult5575 (depth = 3)
  gc_frame_newslot(opresult5575);
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5577 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5576);
// compiled member node returning call5577 (depth = 3)
  gc_frame_newslot(call5577);
// starting to compile member node (depth = 3)
  int callframe5578 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5579 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5578);
// compiled member node returning call5579 (depth = 3)
  gc_frame_newslot(call5579);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5581 = alloc_Float64(1);
// compiled num node returning num5581 (depth = 4)
  int op_slot_right_5580 = gc_frame_newslot(num5581);
// starting to compile member node (depth = 4)
  int callframe5583 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5584 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5583);
// compiled member node returning call5584 (depth = 4)
  int op_slot_left_5580 = gc_frame_newslot(call5584);
  params[0] = num5581;
  partcv[0] = 1;
  Object sum5585 = callmethod(call5584, "+(1)", 1, partcv, params);
// compiled op node returning sum5585 (depth = 3)
  gc_frame_newslot(sum5585);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5575;
  params[1] = call5577;
  params[2] = call5579;
  params[3] = sum5585;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5586 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5570);
// compiled call node returning call5586 (depth = 2)
  gc_frame_end(frame);
  return call5586;
}
Object meth_parser_5587_errorDefMissingRhs_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefMissingRhs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method errorDefMissingRhs(_)");
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for errorDefMissingRhs(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_defTok = &(stackframe->slots[0]);
  *var_defTok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part errorDefMissingRhs(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5588 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5588 (depth = 3)
  *var_suggestions = array5588;
  if (array5588 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5589 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5591 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 4)
  Object call5592 = callmethodflags(call5591, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5589);
// compiled member node returning call5592 (depth = 3)
  *var_suggestion = call5592;
  if (call5592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5593 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5594 == NULL) {
    strlit5594 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5594);
  }
// compiled string node returning strlit5594 (depth = 3)
  gc_frame_newslot(strlit5594);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = strlit5594;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5595 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5593);
// compiled call node returning call5595 (depth = 2)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5596 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5597 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5596);
// compiled call node returning call5597 (depth = 2)
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5598 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5599 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  Object call5600 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5599);
// compiled member node returning call5600 (depth = 4)
  Object call5601 = callmethodflags(call5600, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5598);
// compiled member node returning call5601 (depth = 3)
  *var_suggestion = call5601;
  if (call5601 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5603 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defTok (depth = 3)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 3)
  if (strlit5604 == NULL) {
    strlit5604 = alloc_String("var");
    gc_root(strlit5604);
  }
// compiled string node returning strlit5604 (depth = 3)
  gc_frame_newslot(strlit5604);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_defTok;
  params[1] = strlit5604;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5605 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5603);
// compiled call node returning call5605 (depth = 2)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5606 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5607 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5606);
// compiled call node returning call5607 (depth = 2)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5608 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5610 == NULL) {
    strlit5610 = alloc_String("A variable declaration does not require a value but uses 'var', not 'def'.");
    gc_root(strlit5610);
  }
// compiled string node returning strlit5610 (depth = 4)
  int op_slot_right_5609 = gc_frame_newslot(strlit5610);
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5612 == NULL) {
    strlit5612 = alloc_String("a definition must have '=' and a value after the name. ");
    gc_root(strlit5612);
  }
// compiled string node returning strlit5612 (depth = 4)
  int op_slot_left_5609 = gc_frame_newslot(strlit5612);
  params[0] = strlit5610;
  partcv[0] = 1;
  Object opresult5613 = callmethod(strlit5612, "++(1)", 1, partcv, params);
// compiled op node returning opresult5613 (depth = 3)
  gc_frame_newslot(opresult5613);
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5615 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5614);
// compiled member node returning call5615 (depth = 3)
  gc_frame_newslot(call5615);
// starting to compile member node (depth = 3)
  int callframe5616 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5617 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5616);
// compiled member node returning call5617 (depth = 3)
  gc_frame_newslot(call5617);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5613;
  params[1] = call5615;
  params[2] = call5617;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5618 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5608);
// compiled call node returning call5618 (depth = 2)
  gc_frame_end(frame);
  return call5618;
}
Object meth_parser_5669__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5670 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5671 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5670);
// compiled call node returning call5671 (depth = 7)
  gc_frame_end(frame);
  return call5671;
}
Object meth_parser_5619_defdec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
  Object *var_line = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "line");
  Object *var_pos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pos");
  Object *var_defTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "defTok");
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_name = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "name");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "o");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5621 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5622 == NULL) {
    strlit5622 = alloc_String("def");
    gc_root(strlit5622);
  }
// compiled string node returning strlit5622 (depth = 4)
  gc_frame_newslot(strlit5622);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5622;
  partcv[0] = 1;
  Object call5623 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5621);
// compiled call node returning call5623 (depth = 3)
  Object if5620 = done;
  if (istrue(call5623)) {
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5624 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5625 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5624);
// compiled member node returning call5625 (depth = 4)
  *var_line = call5625;
  if (call5625 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5627 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5626);
// compiled member node returning call5627 (depth = 4)
  *var_pos = call5627;
  if (call5627 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5628 = gc_frame_new();
// call case 4: self request
  Object call5629 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5628);
// compiled member node returning call5629 (depth = 3)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5632 == NULL) {
    strlit5632 = alloc_String("identifier");
    gc_root(strlit5632);
  }
// compiled string node returning strlit5632 (depth = 5)
  int op_slot_right_5631 = gc_frame_newslot(strlit5632);
// starting to compile member node (depth = 5)
  int callframe5634 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5635 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5634);
// compiled member node returning call5635 (depth = 5)
  int op_slot_left_5631 = gc_frame_newslot(call5635);
  params[0] = strlit5632;
  partcv[0] = 1;
  Object opresult5636 = callmethod(call5635, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5636 (depth = 4)
  Object if5630 = done;
  if (istrue(opresult5636)) {
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5637 = gc_frame_new();
// call case 4: self request
  Object call5638 = callmethodflags(self, "errorDefNoName", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5637);
// compiled member node returning call5638 (depth = 4)
    gc_frame_newslot(call5638);
    if5630 = call5638;
  } else {
  }
// compiled if node returning if5630 (depth = 3)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5639 = gc_frame_new();
// call case 4: self request
  Object call5640 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5639);
// compiled member node returning call5640 (depth = 3)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5641 = alloc_Boolean(0);
// compiled identifier node returning bool5641 (depth = 4)
  *var_val = bool5641;
  if (bool5641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5642 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5643 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5642);
// compiled member node returning call5643 (depth = 4)
  *var_name = call5643;
  if (call5643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5644 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5645 = alloc_Boolean(1);
// compiled identifier node returning bool5645 (depth = 4)
  gc_frame_newslot(bool5645);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool5645;
  partcv[0] = 1;
  Object call5646 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5644);
// compiled call node returning call5646 (depth = 3)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5647 = gc_frame_new();
// call case 4: self request
  Object call5648 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5647);
// compiled member node returning call5648 (depth = 4)
  *var_dtype = call5648;
  if (call5648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5649 = gc_frame_new();
// call case 4: self request
  Object call5650 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5649);
// compiled member node returning call5650 (depth = 4)
  *var_anns = call5650;
  if (call5650 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5654 == NULL) {
    strlit5654 = alloc_String("=");
    gc_root(strlit5654);
  }
// compiled string node returning strlit5654 (depth = 6)
  int op_slot_right_5653 = gc_frame_newslot(strlit5654);
// starting to compile member node (depth = 6)
  int callframe5656 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5657 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5656);
// compiled member node returning call5657 (depth = 6)
  int op_slot_left_5653 = gc_frame_newslot(call5657);
  params[0] = strlit5654;
  partcv[0] = 1;
  Object opresult5658 = callmethod(call5657, "==(1)", 1, partcv, params);
// compiled op node returning opresult5658 (depth = 5)
  int op_slot_right_5652 = gc_frame_newslot(opresult5658);
// starting to compile call node (depth = 5)
  int callframe5660 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5661 == NULL) {
    strlit5661 = alloc_String("op");
    gc_root(strlit5661);
  }
// compiled string node returning strlit5661 (depth = 6)
  gc_frame_newslot(strlit5661);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5661;
  partcv[0] = 1;
  Object call5662 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5660);
// compiled call node returning call5662 (depth = 5)
  int op_slot_left_5652 = gc_frame_newslot(call5662);
  params[0] = opresult5658;
  partcv[0] = 1;
  Object opresult5663 = callmethod(call5662, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5663 (depth = 4)
  Object if5651 = done;
  if (istrue(opresult5663)) {
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5664 = gc_frame_new();
// call case 4: self request
  Object call5665 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compiled member node returning call5665 (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5667 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5668 = alloc_Block(NULL, NULL, "parser", 1964);
  gc_frame_newslot(block5668);
// method "_apply"
  block_savedest(block5668);
  Object closure5669 = createclosure(2, "_apply");
  setclosureframe(closure5669, stackframe);
  addtoclosure(closure5669, var_blocksOK);
  addtoclosure(closure5669, selfslot);
  struct UserObject *uo5669 = (struct UserObject*)block5668;
  uo5669->data[0] = (Object)closure5669;
  Method *meth_meth_parser_5669__apply = addmethod2pos(block5668, "_apply", &meth_parser_5669__apply, 0);
  int argcv_meth_parser_5669__apply[] = {0};
  meth_meth_parser_5669__apply->type = alloc_MethodType(1, argcv_meth_parser_5669__apply);
  meth_meth_parser_5669__apply->definitionModule = modulename;
  meth_meth_parser_5669__apply->definitionLine = 3208;
// compiled block node returning block5668 (depth = 6)
  gc_frame_newslot(block5668);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5668;
  partcv[0] = 1;
  Object call5673 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5667);
// compiled call node returning call5673 (depth = 5)
  Object if5666 = done;
  if (istrue(call5673)) {
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5674 = gc_frame_new();
// call case 4: self request
  Object call5675 = callmethodflags(self, "errorDefNoExpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5674);
// compiled member node returning call5675 (depth = 5)
    gc_frame_newslot(call5675);
    if5666 = call5675;
  } else {
  }
// compiled if node returning if5666 (depth = 4)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5676 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call5677 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5676);
// compiled member node returning call5677 (depth = 5)
  *var_val = call5677;
  if (call5677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5651 = done;
  } else {
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5680 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5681 == NULL) {
    strlit5681 = alloc_String("bind");
    gc_root(strlit5681);
  }
// compiled string node returning strlit5681 (depth = 6)
  gc_frame_newslot(strlit5681);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5681;
  partcv[0] = 1;
  Object call5682 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5680);
// compiled call node returning call5682 (depth = 5)
  Object if5679 = done;
  if (istrue(call5682)) {
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5683 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5684 = callmethodflags(module_parser, "errorDefUsesAssign(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5683);
// compiled call node returning call5684 (depth = 5)
    gc_frame_newslot(call5684);
    if5679 = call5684;
  } else {
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5685 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5686 = callmethodflags(module_parser, "errorDefMissingRhs(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5685);
// compiled call node returning call5686 (depth = 5)
    gc_frame_newslot(call5686);
    if5679 = call5686;
  }
// compiled if node returning if5679 (depth = 4)
    gc_frame_newslot(if5679);
    if5651 = if5679;
  }
// compiled if node returning if5651 (depth = 3)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5687 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5688 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  Object call5689 = callmethodflags(*var_defTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5688);
// compiled member node returning call5689 (depth = 4)
  gc_frame_newslot(call5689);
// starting to compile member node (depth = 4)
  int callframe5690 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  Object call5691 = callmethodflags(*var_defTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5690);
// compiled member node returning call5691 (depth = 4)
  gc_frame_newslot(call5691);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5689;
  params[1] = call5691;
  partcv[0] = 2;
  Object call5692 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5687);
// compiled call node returning call5692 (depth = 3)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5693 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call5695 = callmethodflags(*var_ast, "defDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe5694);
// compiled member node returning call5695 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call5696 = callmethodflags(call5695, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5693);
// compiled call node returning call5696 (depth = 4)
  *var_o = call5696;
  if (call5696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_5698 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool5700 = alloc_Boolean(0);
// compiled identifier node returning bool5700 (depth = 5)
  int op_slot_left_5698 = gc_frame_newslot(bool5700);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult5701 = callmethod(bool5700, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5701 (depth = 4)
  Object if5697 = done;
  if (istrue(opresult5701)) {
// starting to compile call node (depth = 4)
  int callframe5702 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5703 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call5704 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe5703);
// compiled member node returning call5704 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call5705 = callmethodflags(call5704, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5702);
// compiled call node returning call5705 (depth = 4)
    gc_frame_newslot(call5705);
    if5697 = call5705;
  } else {
  }
// compiled if node returning if5697 (depth = 3)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5706 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defTok (depth = 4)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5707 = callmethodflags(*var_o, "startToken:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5706);
// compiled call node returning call5707 (depth = 3)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5708 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5709 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5708);
// compiled call node returning call5709 (depth = 3)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5710 = gc_frame_new();
// call case 4: self request
  Object call5711 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5710);
// compiled member node returning call5711 (depth = 3)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5620 = done;
  } else {
  }
// compiled if node returning if5620 (depth = 2)
  gc_frame_end(frame);
  return if5620;
}
Object meth_parser_5737__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call5741 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5740);
// compiled member node returning call5741 (depth = 9)
  int op_slot_right_5739 = gc_frame_newslot(call5741);
// starting to compile member node (depth = 9)
  int callframe5743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call5744 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5743);
// compiled member node returning call5744 (depth = 9)
  int op_slot_left_5739 = gc_frame_newslot(call5744);
  params[0] = call5741;
  partcv[0] = 1;
  Object opresult5745 = callmethod(call5744, "==(1)", 1, partcv, params);
// compiled op node returning opresult5745 (depth = 8)
  int op_slot_right_5738 = gc_frame_newslot(opresult5745);
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5748 == NULL) {
    strlit5748 = alloc_String("bind");
    gc_root(strlit5748);
  }
// compiled string node returning strlit5748 (depth = 9)
  int op_slot_right_5747 = gc_frame_newslot(strlit5748);
// starting to compile member node (depth = 9)
  int callframe5750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call5751 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5750);
// compiled member node returning call5751 (depth = 9)
  int op_slot_left_5747 = gc_frame_newslot(call5751);
  params[0] = strlit5748;
  partcv[0] = 1;
  Object opresult5752 = callmethod(call5751, "==(1)", 1, partcv, params);
// compiled op node returning opresult5752 (depth = 8)
  int op_slot_left_5738 = gc_frame_newslot(opresult5752);
  params[0] = opresult5745;
  partcv[0] = 1;
  Object opresult5753 = callmethod(opresult5752, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5753 (depth = 7)
  gc_frame_end(frame);
  return opresult5753;
}
Object meth_parser_5759__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5760 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_5760 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5762 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult5762 (depth = 7)
  gc_frame_end(frame);
  return opresult5762;
}
Object meth_parser_5808__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5809 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5810 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5809);
// compiled call node returning call5810 (depth = 7)
  gc_frame_end(frame);
  return call5810;
}
Object meth_parser_5713_vardec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
  Object *var_line = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "line");
  Object *var_pos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pos");
  Object *var_varTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "varTok");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_nextToken = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextToken");
// definebindings:
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "val");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_nextTok = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5715 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5716 == NULL) {
    strlit5716 = alloc_String("var");
    gc_root(strlit5716);
  }
// compiled string node returning strlit5716 (depth = 4)
  gc_frame_newslot(strlit5716);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5716;
  partcv[0] = 1;
  Object call5717 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5715);
// compiled call node returning call5717 (depth = 3)
  Object if5714 = done;
  if (istrue(call5717)) {
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5719 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5718);
// compiled member node returning call5719 (depth = 4)
  *var_line = call5719;
  if (call5719 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5720 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5721 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5720);
// compiled member node returning call5721 (depth = 4)
  *var_pos = call5721;
  if (call5721 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5722 = gc_frame_new();
// call case 4: self request
  Object call5723 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5722);
// compiled member node returning call5723 (depth = 3)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5726 == NULL) {
    strlit5726 = alloc_String("identifier");
    gc_root(strlit5726);
  }
// compiled string node returning strlit5726 (depth = 5)
  int op_slot_right_5725 = gc_frame_newslot(strlit5726);
// starting to compile member node (depth = 5)
  int callframe5728 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5729 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5728);
// compiled member node returning call5729 (depth = 5)
  int op_slot_left_5725 = gc_frame_newslot(call5729);
  params[0] = strlit5726;
  partcv[0] = 1;
  Object opresult5730 = callmethod(call5729, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5730 (depth = 4)
  Object if5724 = done;
  if (istrue(opresult5730)) {
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5731 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5732 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call5733 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5732);
// compiled member node returning call5733 (depth = 6)
  Object call5734 = callmethodflags(call5733, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5731);
// compiled member node returning call5734 (depth = 5)
  *var_suggestion = call5734;
  if (call5734 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5735 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5736 = alloc_Block(NULL, NULL, "parser", 1994);
  gc_frame_newslot(block5736);
// method "_apply(_)"
  block_savedest(block5736);
  Object closure5737 = createclosure(2, "_apply(1)");
  setclosureframe(closure5737, stackframe);
  addtoclosure(closure5737, var_sym);
  addtoclosure(closure5737, selfslot);
  struct UserObject *uo5737 = (struct UserObject*)block5736;
  uo5737->data[0] = (Object)closure5737;
  Method *meth_meth_parser_5737__apply_40_1_41_ = addmethod2pos(block5736, "_apply(1)", &meth_parser_5737__apply_40_1_41_, 0);
  int argcv_meth_parser_5737__apply_40_1_41_[] = {1};
  meth_meth_parser_5737__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5737__apply_40_1_41_);
  meth_meth_parser_5737__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5737__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block5736 (depth = 6)
  gc_frame_newslot(block5736);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5736;
  partcv[0] = 1;
  Object call5755 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5735);
// compiled call node returning call5755 (depth = 5)
  *var_nextToken = call5755;
  if (call5755 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block5758 = alloc_Block(NULL, NULL, "parser", 1996);
  gc_frame_newslot(block5758);
// method "_apply"
  block_savedest(block5758);
  Object closure5759 = createclosure(3, "_apply");
  setclosureframe(closure5759, stackframe);
  addtoclosure(closure5759, var_sym);
  addtoclosure(closure5759, var_nextToken);
  addtoclosure(closure5759, selfslot);
  struct UserObject *uo5759 = (struct UserObject*)block5758;
  uo5759->data[0] = (Object)closure5759;
  Method *meth_meth_parser_5759__apply = addmethod2pos(block5758, "_apply", &meth_parser_5759__apply, 0);
  int argcv_meth_parser_5759__apply[] = {0};
  meth_meth_parser_5759__apply->type = alloc_MethodType(1, argcv_meth_parser_5759__apply);
  meth_meth_parser_5759__apply->definitionModule = modulename;
  meth_meth_parser_5759__apply->definitionLine = 3208;
// compiled block node returning block5758 (depth = 6)
  int op_slot_right_5757 = gc_frame_newslot(block5758);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_right_5765 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 7)
  Object bool5767 = alloc_Boolean(0);
// compiled identifier node returning bool5767 (depth = 7)
  int op_slot_left_5765 = gc_frame_newslot(bool5767);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult5768 = callmethod(bool5767, "==(1)", 1, partcv, params);
// compiled op node returning opresult5768 (depth = 6)
  int op_slot_left_5757 = gc_frame_newslot(opresult5768);
  params[0] = block5758;
  partcv[0] = 1;
  Object opresult5769 = callmethod(opresult5768, "||(1)", 1, partcv, params);
// compiled op node returning opresult5769 (depth = 5)
  Object if5756 = done;
  if (istrue(opresult5769)) {
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5770 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5771 == NULL) {
    strlit5771 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit5771);
  }
// compiled string node returning strlit5771 (depth = 6)
  gc_frame_newslot(strlit5771);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5771;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5772 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5770);
// compiled call node returning call5772 (depth = 5)
    gc_frame_newslot(call5772);
    if5756 = call5772;
  } else {
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5773 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe5774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  Object call5775 = callmethodflags(*var_nextToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5774);
// compiled member node returning call5775 (depth = 6)
  gc_frame_newslot(call5775);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool5776 = alloc_Boolean(0);
// compiled identifier node returning bool5776 (depth = 6)
  gc_frame_newslot(bool5776);
// starting to compile identifier node (depth = 6)
  Object bool5777 = alloc_Boolean(1);
// compiled identifier node returning bool5777 (depth = 6)
  gc_frame_newslot(bool5777);
// starting to compile string node (depth = 6)
  if (strlit5778 == NULL) {
    strlit5778 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit5778);
  }
// compiled string node returning strlit5778 (depth = 6)
  gc_frame_newslot(strlit5778);
// call case 6: other requests
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5775;
  params[2] = bool5776;
  params[3] = bool5777;
  params[4] = strlit5778;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5779 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5773);
// compiled call node returning call5779 (depth = 5)
    gc_frame_newslot(call5779);
    if5756 = call5779;
  }
// compiled if node returning if5756 (depth = 4)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5780 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5781 == NULL) {
    strlit5781 = alloc_String("a variable declaration must have a name after the 'var'.");
    gc_root(strlit5781);
  }
// compiled string node returning strlit5781 (depth = 5)
  gc_frame_newslot(strlit5781);
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5782 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5783 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5782);
// compiled member node returning call5783 (depth = 5)
  gc_frame_newslot(call5783);
// starting to compile member node (depth = 5)
  int callframe5784 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5785 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5784);
// compiled member node returning call5785 (depth = 5)
  gc_frame_newslot(call5785);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5781;
  params[1] = call5783;
  params[2] = call5785;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5786 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5780);
// compiled call node returning call5786 (depth = 4)
    gc_frame_newslot(call5786);
    if5724 = call5786;
  } else {
  }
// compiled if node returning if5724 (depth = 3)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5787 = gc_frame_new();
// call case 4: self request
  Object call5788 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5787);
// compiled member node returning call5788 (depth = 3)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5789 = alloc_Boolean(0);
// compiled identifier node returning bool5789 (depth = 4)
  *var_val = bool5789;
  if (bool5789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5790 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5791 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5790);
// compiled member node returning call5791 (depth = 4)
  *var_name = call5791;
  if (call5791 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5792 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5793 = alloc_Boolean(1);
// compiled identifier node returning bool5793 (depth = 4)
  gc_frame_newslot(bool5793);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool5793;
  partcv[0] = 1;
  Object call5794 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5792);
// compiled call node returning call5794 (depth = 3)
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5795 = gc_frame_new();
// call case 4: self request
  Object call5796 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5795);
// compiled member node returning call5796 (depth = 4)
  *var_dtype = call5796;
  if (call5796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5797 = gc_frame_new();
// call case 4: self request
  Object call5798 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5797);
// compiled member node returning call5798 (depth = 4)
  *var_anns = call5798;
  if (call5798 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5800 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5801 == NULL) {
    strlit5801 = alloc_String("bind");
    gc_root(strlit5801);
  }
// compiled string node returning strlit5801 (depth = 5)
  gc_frame_newslot(strlit5801);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit5801;
  partcv[0] = 1;
  Object call5802 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5800);
// compiled call node returning call5802 (depth = 4)
  Object if5799 = done;
  if (istrue(call5802)) {
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5803 = gc_frame_new();
// call case 4: self request
  Object call5804 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5803);
// compiled member node returning call5804 (depth = 4)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5806 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5807 = alloc_Block(NULL, NULL, "parser", 2013);
  gc_frame_newslot(block5807);
// method "_apply"
  block_savedest(block5807);
  Object closure5808 = createclosure(2, "_apply");
  setclosureframe(closure5808, stackframe);
  addtoclosure(closure5808, var_blocksOK);
  addtoclosure(closure5808, selfslot);
  struct UserObject *uo5808 = (struct UserObject*)block5807;
  uo5808->data[0] = (Object)closure5808;
  Method *meth_meth_parser_5808__apply = addmethod2pos(block5807, "_apply", &meth_parser_5808__apply, 0);
  int argcv_meth_parser_5808__apply[] = {0};
  meth_meth_parser_5808__apply->type = alloc_MethodType(1, argcv_meth_parser_5808__apply);
  meth_meth_parser_5808__apply->definitionModule = modulename;
  meth_meth_parser_5808__apply->definitionLine = 3208;
// compiled block node returning block5807 (depth = 6)
  gc_frame_newslot(block5807);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5807;
  partcv[0] = 1;
  Object call5812 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5806);
// compiled call node returning call5812 (depth = 5)
  Object if5805 = done;
  if (istrue(call5812)) {
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array5813 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5813 (depth = 6)
  *var_suggestions = array5813;
  if (array5813 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call5816 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5815);
// compiled member node returning call5816 (depth = 7)
  Object call5817 = callmethodflags(call5816, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5814);
// compiled member node returning call5817 (depth = 6)
  *var_suggestion = call5817;
  if (call5817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5818 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array5819 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5819 (depth = 7)
  gc_frame_newslot(array5819);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array5819;
  partcv[0] = 1;
  Object call5820 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5818);
// compiled call node returning call5820 (depth = 6)
  *var_nextTok = call5820;
  if (call5820 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_5822 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_5822 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5824 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5824 (depth = 6)
  Object if5821 = done;
  if (istrue(opresult5824)) {
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5825 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5826 == NULL) {
    strlit5826 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5826);
  }
// compiled string node returning strlit5826 (depth = 7)
  gc_frame_newslot(strlit5826);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5826;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5827 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5825);
// compiled call node returning call5827 (depth = 6)
    gc_frame_newslot(call5827);
    if5821 = call5827;
  } else {
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5828 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe5829 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call5830 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5829);
// compiled member node returning call5830 (depth = 7)
  gc_frame_newslot(call5830);
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool5831 = alloc_Boolean(1);
// compiled identifier node returning bool5831 (depth = 7)
  gc_frame_newslot(bool5831);
// starting to compile identifier node (depth = 7)
  Object bool5832 = alloc_Boolean(0);
// compiled identifier node returning bool5832 (depth = 7)
  gc_frame_newslot(bool5832);
// starting to compile string node (depth = 7)
  if (strlit5833 == NULL) {
    strlit5833 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5833);
  }
// compiled string node returning strlit5833 (depth = 7)
  gc_frame_newslot(strlit5833);
// call case 6: other requests
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call5830;
  params[2] = bool5831;
  params[3] = bool5832;
  params[4] = strlit5833;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5834 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5828);
// compiled call node returning call5834 (depth = 6)
    gc_frame_newslot(call5834);
    if5821 = call5834;
  }
// compiled if node returning if5821 (depth = 5)
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5835 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5836 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5835);
// compiled call node returning call5836 (depth = 5)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5837 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5838 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call5839 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5838);
// compiled member node returning call5839 (depth = 7)
  Object call5840 = callmethodflags(call5839, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5837);
// compiled member node returning call5840 (depth = 6)
  *var_suggestion = call5840;
  if (call5840 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5842 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
  int callframe5843 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call5844 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5843);
// compiled member node returning call5844 (depth = 6)
  gc_frame_newslot(call5844);
// starting to compile identifier node (depth = 6)
  Object bool5845 = alloc_Boolean(1);
// compiled identifier node returning bool5845 (depth = 6)
  gc_frame_newslot(bool5845);
// starting to compile identifier node (depth = 6)
  Object bool5846 = alloc_Boolean(0);
// compiled identifier node returning bool5846 (depth = 6)
  gc_frame_newslot(bool5846);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call5844;
  params[2] = bool5845;
  params[3] = bool5846;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5847 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5842);
// compiled call node returning call5847 (depth = 5)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5848 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5849 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5848);
// compiled call node returning call5849 (depth = 5)
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5850 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5852 == NULL) {
    strlit5852 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit5852);
  }
// compiled string node returning strlit5852 (depth = 7)
  int op_slot_right_5851 = gc_frame_newslot(strlit5852);
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5854 == NULL) {
    strlit5854 = alloc_String("a variable declaration must have a value after the ':='. ");
    gc_root(strlit5854);
  }
// compiled string node returning strlit5854 (depth = 7)
  int op_slot_left_5851 = gc_frame_newslot(strlit5854);
  params[0] = strlit5852;
  partcv[0] = 1;
  Object opresult5855 = callmethod(strlit5854, "++(1)", 1, partcv, params);
// compiled op node returning opresult5855 (depth = 6)
  gc_frame_newslot(opresult5855);
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5856 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call5857 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5856);
// compiled member node returning call5857 (depth = 6)
  gc_frame_newslot(call5857);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5859 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5860 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5859);
// compiled member node returning call5860 (depth = 7)
  int op_slot_right_5858 = gc_frame_newslot(call5860);
// starting to compile member node (depth = 7)
  int callframe5862 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5863 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5862);
// compiled member node returning call5863 (depth = 7)
  int op_slot_left_5858 = gc_frame_newslot(call5863);
  params[0] = call5860;
  partcv[0] = 1;
  Object sum5864 = callmethod(call5863, "+(1)", 1, partcv, params);
// compiled op node returning sum5864 (depth = 6)
  gc_frame_newslot(sum5864);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult5855;
  params[1] = call5857;
  params[2] = sum5864;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5865 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5850);
// compiled call node returning call5865 (depth = 5)
    gc_frame_newslot(call5865);
    if5805 = call5865;
  } else {
  }
// compiled if node returning if5805 (depth = 4)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5866 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call5867 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5866);
// compiled member node returning call5867 (depth = 5)
  *var_val = call5867;
  if (call5867 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5799 = done;
  } else {
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5872 == NULL) {
    strlit5872 = alloc_String("=");
    gc_root(strlit5872);
  }
// compiled string node returning strlit5872 (depth = 7)
  int op_slot_right_5871 = gc_frame_newslot(strlit5872);
// starting to compile member node (depth = 7)
  int callframe5874 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5875 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5874);
// compiled member node returning call5875 (depth = 7)
  int op_slot_left_5871 = gc_frame_newslot(call5875);
  params[0] = strlit5872;
  partcv[0] = 1;
  Object opresult5876 = callmethod(call5875, "==(1)", 1, partcv, params);
// compiled op node returning opresult5876 (depth = 6)
  int op_slot_right_5870 = gc_frame_newslot(opresult5876);
// starting to compile call node (depth = 6)
  int callframe5878 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5879 == NULL) {
    strlit5879 = alloc_String("op");
    gc_root(strlit5879);
  }
// compiled string node returning strlit5879 (depth = 7)
  gc_frame_newslot(strlit5879);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5879;
  partcv[0] = 1;
  Object call5880 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5878);
// compiled call node returning call5880 (depth = 6)
  int op_slot_left_5870 = gc_frame_newslot(call5880);
  params[0] = opresult5876;
  partcv[0] = 1;
  Object opresult5881 = callmethod(call5880, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5881 (depth = 5)
  Object if5869 = done;
  if (istrue(opresult5881)) {
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array5882 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5882 (depth = 6)
  *var_suggestions = array5882;
  if (array5882 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5883 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5884 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call5885 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5884);
// compiled member node returning call5885 (depth = 7)
  Object call5886 = callmethodflags(call5885, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5883);
// compiled member node returning call5886 (depth = 6)
  *var_suggestion = call5886;
  if (call5886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5887 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit5888 == NULL) {
    strlit5888 = alloc_String(":=");
    gc_root(strlit5888);
  }
// compiled string node returning strlit5888 (depth = 6)
  gc_frame_newslot(strlit5888);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit5888;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5889 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5887);
// compiled call node returning call5889 (depth = 5)
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5890 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5891 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5890);
// compiled call node returning call5891 (depth = 5)
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5892 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5893 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call5894 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5893);
// compiled member node returning call5894 (depth = 7)
  Object call5895 = callmethodflags(call5894, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5892);
// compiled member node returning call5895 (depth = 6)
  *var_suggestion = call5895;
  if (call5895 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5897 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit5898 == NULL) {
    strlit5898 = alloc_String("def");
    gc_root(strlit5898);
  }
// compiled string node returning strlit5898 (depth = 6)
  gc_frame_newslot(strlit5898);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit5898;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5899 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5897);
// compiled call node returning call5899 (depth = 5)
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5900 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5901 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5900);
// compiled call node returning call5901 (depth = 5)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5902 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5903 == NULL) {
    strlit5903 = alloc_String("a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit5903);
  }
// compiled string node returning strlit5903 (depth = 6)
  gc_frame_newslot(strlit5903);
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5904 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5905 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5904);
// compiled member node returning call5905 (depth = 6)
  gc_frame_newslot(call5905);
// starting to compile member node (depth = 6)
  int callframe5906 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5907 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5906);
// compiled member node returning call5907 (depth = 6)
  gc_frame_newslot(call5907);
// starting to compile member node (depth = 6)
  int callframe5908 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5909 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5908);
// compiled member node returning call5909 (depth = 6)
  gc_frame_newslot(call5909);
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit5903;
  params[1] = call5905;
  params[2] = call5907;
  params[3] = call5909;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5910 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5902);
// compiled call node returning call5910 (depth = 5)
    gc_frame_newslot(call5910);
    if5869 = call5910;
  } else {
  }
// compiled if node returning if5869 (depth = 4)
    gc_frame_newslot(if5869);
    if5799 = if5869;
  }
// compiled if node returning if5799 (depth = 3)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5911 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call5912 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5911);
// compiled call node returning call5912 (depth = 3)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5913 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5914 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call5915 = callmethodflags(*var_ast, "varDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe5914);
// compiled member node returning call5915 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call5916 = callmethodflags(call5915, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5913);
// compiled call node returning call5916 (depth = 4)
  *var_o = call5916;
  if (call5916 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_5918 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool5920 = alloc_Boolean(0);
// compiled identifier node returning bool5920 (depth = 5)
  int op_slot_left_5918 = gc_frame_newslot(bool5920);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult5921 = callmethod(bool5920, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5921 (depth = 4)
  Object if5917 = done;
  if (istrue(opresult5921)) {
// starting to compile call node (depth = 4)
  int callframe5922 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5923 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call5924 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe5923);
// compiled member node returning call5924 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call5925 = callmethodflags(call5924, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5922);
// compiled call node returning call5925 (depth = 4)
    gc_frame_newslot(call5925);
    if5917 = call5925;
  } else {
  }
// compiled if node returning if5917 (depth = 3)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5926 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5927 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5926);
// compiled call node returning call5927 (depth = 3)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5928 = gc_frame_new();
// call case 4: self request
  Object call5929 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5928);
// compiled member node returning call5929 (depth = 3)
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5714 = done;
  } else {
  }
// compiled if node returning if5714 (depth = 2)
  gc_frame_end(frame);
  return if5714;
}
Object meth_parser_5942__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe5943 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5944 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5943);
// compiled call node returning call5944 (depth = 6)
  gc_frame_end(frame);
  return call5944;
}
Object meth_parser_5949__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe5950 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5951 == NULL) {
    strlit5951 = alloc_String("comma");
    gc_root(strlit5951);
  }
// compiled string node returning strlit5951 (depth = 7)
  gc_frame_newslot(strlit5951);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5951;
  partcv[0] = 1;
  Object call5952 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5950);
// compiled call node returning call5952 (depth = 6)
  gc_frame_end(frame);
  return call5952;
}
Object meth_parser_5966__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe5967 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5968 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5967);
// compiled call node returning call5968 (depth = 9)
  gc_frame_end(frame);
  return call5968;
}
Object meth_parser_5955__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call5957 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5956);
// compiled member node returning call5957 (depth = 7)
  *var_tmp = call5957;
  if (call5957 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5959 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5960 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5959);
// compiled call node returning call5960 (depth = 6)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5961 = gc_frame_new();
// call case 4: self request
  Object call5962 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5961);
// compiled member node returning call5962 (depth = 6)
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5964 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5965 = alloc_Block(NULL, NULL, "parser", 2067);
  gc_frame_newslot(block5965);
// method "_apply"
  block_savedest(block5965);
  Object closure5966 = createclosure(2, "_apply");
  setclosureframe(closure5966, stackframe);
  addtoclosure(closure5966, var_blocksOK);
  addtoclosure(closure5966, selfslot);
  struct UserObject *uo5966 = (struct UserObject*)block5965;
  uo5966->data[0] = (Object)closure5966;
  Method *meth_meth_parser_5966__apply = addmethod2pos(block5965, "_apply", &meth_parser_5966__apply, 0);
  int argcv_meth_parser_5966__apply[] = {0};
  meth_meth_parser_5966__apply->type = alloc_MethodType(1, argcv_meth_parser_5966__apply);
  meth_meth_parser_5966__apply->definitionModule = modulename;
  meth_meth_parser_5966__apply->definitionLine = 3208;
// compiled block node returning block5965 (depth = 8)
  gc_frame_newslot(block5965);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block5965;
  partcv[0] = 1;
  Object call5970 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5964);
// compiled call node returning call5970 (depth = 7)
  Object if5963 = done;
  if (istrue(call5970)) {
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array5971 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5971 (depth = 8)
  *var_suggestions = array5971;
  if (array5971 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5972 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5973 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call5974 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5973);
// compiled member node returning call5974 (depth = 9)
  Object call5975 = callmethodflags(call5974, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5972);
// compiled member node returning call5975 (depth = 8)
  *var_suggestion = call5975;
  if (call5975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5976 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array5977 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit5978 == NULL) {
    strlit5978 = alloc_String("rsquare");
    gc_root(strlit5978);
  }
// compiled string node returning strlit5978 (depth = 10)
  params[0] = strlit5978;
  partcv[0] = 1;
  callmethodflags(array5977, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5977 (depth = 9)
  gc_frame_newslot(array5977);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array5977;
  partcv[0] = 1;
  Object call5979 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5976);
// compiled call node returning call5979 (depth = 8)
  *var_nextTok = call5979;
  if (call5979 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_5981 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_5981 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5983 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5983 (depth = 8)
  Object if5980 = done;
  if (istrue(opresult5983)) {
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5984 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5985 == NULL) {
    strlit5985 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5985);
  }
// compiled string node returning strlit5985 (depth = 9)
  gc_frame_newslot(strlit5985);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit5985;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5986 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5984);
// compiled call node returning call5986 (depth = 8)
    gc_frame_newslot(call5986);
    if5980 = call5986;
  } else {
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5987 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe5988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call5989 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5988);
// compiled member node returning call5989 (depth = 9)
  gc_frame_newslot(call5989);
// starting to compile identifier node (depth = 9)
  Object bool5990 = alloc_Boolean(1);
// compiled identifier node returning bool5990 (depth = 9)
  gc_frame_newslot(bool5990);
// starting to compile identifier node (depth = 9)
  Object bool5991 = alloc_Boolean(0);
// compiled identifier node returning bool5991 (depth = 9)
  gc_frame_newslot(bool5991);
// starting to compile string node (depth = 9)
  if (strlit5992 == NULL) {
    strlit5992 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5992);
  }
// compiled string node returning strlit5992 (depth = 9)
  gc_frame_newslot(strlit5992);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call5989;
  params[2] = bool5990;
  params[3] = bool5991;
  params[4] = strlit5992;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5993 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5987);
// compiled call node returning call5993 (depth = 8)
    gc_frame_newslot(call5993);
    if5980 = call5993;
  }
// compiled if node returning if5980 (depth = 7)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5994 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5995 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5994);
// compiled call node returning call5995 (depth = 7)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5996 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5997 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call5998 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5997);
// compiled member node returning call5998 (depth = 9)
  Object call5999 = callmethodflags(call5998, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5996);
// compiled member node returning call5999 (depth = 8)
  *var_suggestion = call5999;
  if (call5999 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6001 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe6002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call6003 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6002);
// compiled member node returning call6003 (depth = 8)
  gc_frame_newslot(call6003);
// starting to compile identifier node (depth = 8)
  Object bool6004 = alloc_Boolean(1);
// compiled identifier node returning bool6004 (depth = 8)
  gc_frame_newslot(bool6004);
// starting to compile identifier node (depth = 8)
  Object bool6005 = alloc_Boolean(0);
// compiled identifier node returning bool6005 (depth = 8)
  gc_frame_newslot(bool6005);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call6003;
  params[2] = bool6004;
  params[3] = bool6005;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6006 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6001);
// compiled call node returning call6006 (depth = 7)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6007 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6008 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6007);
// compiled call node returning call6008 (depth = 7)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6009 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6010 == NULL) {
    strlit6010 = alloc_String("a collection must contain zero or more expressions separated by commas.");
    gc_root(strlit6010);
  }
// compiled string node returning strlit6010 (depth = 8)
  gc_frame_newslot(strlit6010);
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6012 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6011);
// compiled member node returning call6012 (depth = 8)
  gc_frame_newslot(call6012);
// starting to compile member node (depth = 8)
  int callframe6013 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6014 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6013);
// compiled member node returning call6014 (depth = 8)
  gc_frame_newslot(call6014);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6010;
  params[1] = call6012;
  params[2] = call6014;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6015 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6009);
// compiled call node returning call6015 (depth = 7)
    gc_frame_newslot(call6015);
    if5963 = call6015;
  } else {
  }
// compiled if node returning if5963 (depth = 6)
  gc_frame_end(frame);
  return if5963;
}
Object meth_parser_5931_doarray(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// definebindings:
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5933 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5934 == NULL) {
    strlit5934 = alloc_String("lsquare");
    gc_root(strlit5934);
  }
// compiled string node returning strlit5934 (depth = 4)
  gc_frame_newslot(strlit5934);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5934;
  partcv[0] = 1;
  Object call5935 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5933);
// compiled call node returning call5935 (depth = 3)
  Object if5932 = done;
  if (istrue(call5935)) {
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5936 = gc_frame_new();
// call case 4: self request
  Object call5937 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5936);
// compiled member node returning call5937 (depth = 3)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array5938 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5938 (depth = 4)
  *var_params = array5938;
  if (array5938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5940 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5941 = alloc_Block(NULL, NULL, "parser", 2062);
  gc_frame_newslot(block5941);
// method "_apply"
  block_savedest(block5941);
  Object closure5942 = createclosure(2, "_apply");
  setclosureframe(closure5942, stackframe);
  addtoclosure(closure5942, var_blocksOK);
  addtoclosure(closure5942, selfslot);
  struct UserObject *uo5942 = (struct UserObject*)block5941;
  uo5942->data[0] = (Object)closure5942;
  Method *meth_meth_parser_5942__apply = addmethod2pos(block5941, "_apply", &meth_parser_5942__apply, 0);
  int argcv_meth_parser_5942__apply[] = {0};
  meth_meth_parser_5942__apply->type = alloc_MethodType(1, argcv_meth_parser_5942__apply);
  meth_meth_parser_5942__apply->definitionModule = modulename;
  meth_meth_parser_5942__apply->definitionLine = 3208;
// compiled block node returning block5941 (depth = 5)
  gc_frame_newslot(block5941);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block5941;
  partcv[0] = 1;
  Object call5946 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5940);
// compiled call node returning call5946 (depth = 4)
  Object if5939 = done;
  if (istrue(call5946)) {
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5947 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5948 = alloc_Block(NULL, NULL, "parser", 2063);
  gc_frame_newslot(block5948);
// method "_apply"
  block_savedest(block5948);
  Object closure5949 = createclosure(1, "_apply");
  setclosureframe(closure5949, stackframe);
  addtoclosure(closure5949, selfslot);
  struct UserObject *uo5949 = (struct UserObject*)block5948;
  uo5949->data[0] = (Object)closure5949;
  Method *meth_meth_parser_5949__apply = addmethod2pos(block5948, "_apply", &meth_parser_5949__apply, 0);
  int argcv_meth_parser_5949__apply[] = {0};
  meth_meth_parser_5949__apply->type = alloc_MethodType(1, argcv_meth_parser_5949__apply);
  meth_meth_parser_5949__apply->definitionModule = modulename;
  meth_meth_parser_5949__apply->definitionLine = 3208;
// compiled block node returning block5948 (depth = 5)
  gc_frame_newslot(block5948);
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5954 = alloc_Block(NULL, NULL, "parser", 2063);
  gc_frame_newslot(block5954);
// method "_apply"
  block_savedest(block5954);
  Object closure5955 = createclosure(8, "_apply");
  setclosureframe(closure5955, stackframe);
  addtoclosure(closure5955, var_values);
  addtoclosure(closure5955, var_tmp);
  addtoclosure(closure5955, var_params);
  addtoclosure(closure5955, var_blocksOK);
  addtoclosure(closure5955, var_errormessages);
  addtoclosure(closure5955, var_sym);
  addtoclosure(closure5955, var_lastToken);
  addtoclosure(closure5955, selfslot);
  struct UserObject *uo5955 = (struct UserObject*)block5954;
  uo5955->data[0] = (Object)closure5955;
  Method *meth_meth_parser_5955__apply = addmethod2pos(block5954, "_apply", &meth_parser_5955__apply, 0);
  int argcv_meth_parser_5955__apply[] = {0};
  meth_meth_parser_5955__apply->type = alloc_MethodType(1, argcv_meth_parser_5955__apply);
  meth_meth_parser_5955__apply->definitionModule = modulename;
  meth_meth_parser_5955__apply->definitionLine = 3208;
// compiled block node returning block5954 (depth = 5)
  gc_frame_newslot(block5954);
// call case 5: prelude request
  params[0] = block5948;
  params[1] = block5954;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6017 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5947);
// compiled call node returning call6017 (depth = 4)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6019 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6018);
// compiled member node returning call6019 (depth = 5)
  *var_tmp = call6019;
  if (call6019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6021 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6022 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6021);
// compiled call node returning call6022 (depth = 4)
    gc_frame_newslot(call6022);
    if5939 = call6022;
  } else {
  }
// compiled if node returning if5939 (depth = 3)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6025 == NULL) {
    strlit6025 = alloc_String("rsquare");
    gc_root(strlit6025);
  }
// compiled string node returning strlit6025 (depth = 5)
  int op_slot_right_6024 = gc_frame_newslot(strlit6025);
// starting to compile member node (depth = 5)
  int callframe6027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6028 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6027);
// compiled member node returning call6028 (depth = 5)
  int op_slot_left_6024 = gc_frame_newslot(call6028);
  params[0] = strlit6025;
  partcv[0] = 1;
  Object opresult6029 = callmethod(call6028, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6029 (depth = 4)
  Object if6023 = done;
  if (istrue(opresult6029)) {
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6030 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6031 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6032 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6031);
// compiled member node returning call6032 (depth = 6)
  Object call6033 = callmethodflags(call6032, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6030);
// compiled member node returning call6033 (depth = 5)
  *var_suggestion = call6033;
  if (call6033 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6034 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6035 == NULL) {
    strlit6035 = alloc_String("]");
    gc_root(strlit6035);
  }
// compiled string node returning strlit6035 (depth = 5)
  gc_frame_newslot(strlit6035);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6035;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6036 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6034);
// compiled call node returning call6036 (depth = 4)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6037 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6038 == NULL) {
    strlit6038 = alloc_String("a collection beginning with a '[' must end with a ']'.");
    gc_root(strlit6038);
  }
// compiled string node returning strlit6038 (depth = 5)
  gc_frame_newslot(strlit6038);
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6039 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6040 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6039);
// compiled member node returning call6040 (depth = 5)
  gc_frame_newslot(call6040);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6043 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6042);
// compiled member node returning call6043 (depth = 6)
  int op_slot_right_6041 = gc_frame_newslot(call6043);
// starting to compile member node (depth = 6)
  int callframe6045 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6046 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6045);
// compiled member node returning call6046 (depth = 6)
  int op_slot_left_6041 = gc_frame_newslot(call6046);
  params[0] = call6043;
  partcv[0] = 1;
  Object sum6047 = callmethod(call6046, "+(1)", 1, partcv, params);
// compiled op node returning sum6047 (depth = 5)
  gc_frame_newslot(sum6047);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6038;
  params[1] = call6040;
  params[2] = sum6047;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6048 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6037);
// compiled call node returning call6048 (depth = 4)
    gc_frame_newslot(call6048);
    if6023 = call6048;
  } else {
  }
// compiled if node returning if6023 (depth = 3)
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6049 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6051 = callmethodflags(*var_ast, "arrayNode", 0, partcv, params, 0);
  gc_frame_end(callframe6050);
// compiled member node returning call6051 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call6052 = callmethodflags(call6051, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6049);
// compiled call node returning call6052 (depth = 4)
  *var_o = call6052;
  if (call6052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6053 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6054 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6053);
// compiled call node returning call6054 (depth = 3)
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6055 = gc_frame_new();
// call case 4: self request
  Object call6056 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6055);
// compiled member node returning call6056 (depth = 3)
    gc_frame_newslot(call6056);
    if5932 = call6056;
  } else {
  }
// compiled if node returning if5932 (depth = 2)
  gc_frame_end(frame);
  return if5932;
}
Object meth_parser_6057_dodialect(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_moduleObject = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_dn = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dn");
// definebindings:
// definebindings:
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6059 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6060 == NULL) {
    strlit6060 = alloc_String("dialect");
    gc_root(strlit6060);
  }
// compiled string node returning strlit6060 (depth = 4)
  gc_frame_newslot(strlit6060);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6060;
  partcv[0] = 1;
  Object call6061 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6059);
// compiled call node returning call6061 (depth = 3)
  Object if6058 = done;
  if (istrue(call6061)) {
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6062 = gc_frame_new();
// call case 4: self request
  Object call6063 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6062);
// compiled member node returning call6063 (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6066 == NULL) {
    strlit6066 = alloc_String("string");
    gc_root(strlit6066);
  }
// compiled string node returning strlit6066 (depth = 5)
  int op_slot_right_6065 = gc_frame_newslot(strlit6066);
// starting to compile member node (depth = 5)
  int callframe6068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6069 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6068);
// compiled member node returning call6069 (depth = 5)
  int op_slot_left_6065 = gc_frame_newslot(call6069);
  params[0] = strlit6066;
  partcv[0] = 1;
  Object opresult6070 = callmethod(call6069, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6070 (depth = 4)
  Object if6064 = done;
  if (istrue(opresult6070)) {
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6071 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6073 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6072);
// compiled member node returning call6073 (depth = 6)
  Object call6074 = callmethodflags(call6073, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6071);
// compiled member node returning call6074 (depth = 5)
  *var_suggestion = call6074;
  if (call6074 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6078 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6079 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6078);
// compiled member node returning call6079 (depth = 7)
  int op_slot_right_6077 = gc_frame_newslot(call6079);
// starting to compile member node (depth = 7)
  int callframe6081 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6082 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6081);
// compiled member node returning call6082 (depth = 7)
  int op_slot_left_6077 = gc_frame_newslot(call6082);
  params[0] = call6079;
  partcv[0] = 1;
  Object opresult6083 = callmethod(call6082, "==(1)", 1, partcv, params);
// compiled op node returning opresult6083 (depth = 6)
  int op_slot_right_6076 = gc_frame_newslot(opresult6083);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6086 == NULL) {
    strlit6086 = alloc_String("identifier");
    gc_root(strlit6086);
  }
// compiled string node returning strlit6086 (depth = 7)
  int op_slot_right_6085 = gc_frame_newslot(strlit6086);
// starting to compile member node (depth = 7)
  int callframe6088 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6089 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6088);
// compiled member node returning call6089 (depth = 7)
  int op_slot_left_6085 = gc_frame_newslot(call6089);
  params[0] = strlit6086;
  partcv[0] = 1;
  Object opresult6090 = callmethod(call6089, "==(1)", 1, partcv, params);
// compiled op node returning opresult6090 (depth = 6)
  int op_slot_left_6076 = gc_frame_newslot(opresult6090);
  params[0] = opresult6083;
  partcv[0] = 1;
  Object opresult6091 = callmethod(opresult6090, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6091 (depth = 5)
  Object if6075 = done;
  if (istrue(opresult6091)) {
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6092 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6094 == NULL) {
    strlit6094 = alloc_String("""\x22""");
    gc_root(strlit6094);
  }
// compiled string node returning strlit6094 (depth = 7)
  int op_slot_right_6093 = gc_frame_newslot(strlit6094);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6097 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6098 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6097);
// compiled member node returning call6098 (depth = 8)
  int op_slot_right_6096 = gc_frame_newslot(call6098);
// starting to compile string node (depth = 8)
  if (strlit6100 == NULL) {
    strlit6100 = alloc_String("""\x22""");
    gc_root(strlit6100);
  }
// compiled string node returning strlit6100 (depth = 8)
  int op_slot_left_6096 = gc_frame_newslot(strlit6100);
  params[0] = call6098;
  partcv[0] = 1;
  Object opresult6101 = callmethod(strlit6100, "++(1)", 1, partcv, params);
// compiled op node returning opresult6101 (depth = 7)
  int op_slot_left_6093 = gc_frame_newslot(opresult6101);
  params[0] = strlit6094;
  partcv[0] = 1;
  Object opresult6102 = callmethod(opresult6101, "++(1)", 1, partcv, params);
// compiled op node returning opresult6102 (depth = 6)
  gc_frame_newslot(opresult6102);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult6102;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6103 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6092);
// compiled call node returning call6103 (depth = 5)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6105 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6104);
// compiled member node returning call6105 (depth = 6)
  *var_errorPos = call6105;
  if (call6105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6075 = done;
  } else {
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6107 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6108 == NULL) {
    strlit6108 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit6108);
  }
// compiled string node returning strlit6108 (depth = 6)
  gc_frame_newslot(strlit6108);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6108;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6109 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6107);
// compiled call node returning call6109 (depth = 5)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6111 = alloc_Float64(1);
// compiled num node returning num6111 (depth = 7)
  int op_slot_right_6110 = gc_frame_newslot(num6111);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6114 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call6115 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6114);
// compiled member node returning call6115 (depth = 8)
  int op_slot_right_6113 = gc_frame_newslot(call6115);
// starting to compile member node (depth = 8)
  int callframe6117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call6118 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6117);
// compiled member node returning call6118 (depth = 8)
  int op_slot_left_6113 = gc_frame_newslot(call6118);
  params[0] = call6115;
  partcv[0] = 1;
  Object sum6119 = callmethod(call6118, "+(1)", 1, partcv, params);
// compiled op node returning sum6119 (depth = 7)
  int op_slot_left_6110 = gc_frame_newslot(sum6119);
  params[0] = num6111;
  partcv[0] = 1;
  Object sum6120 = callmethod(sum6119, "+(1)", 1, partcv, params);
// compiled op node returning sum6120 (depth = 6)
  *var_errorPos = sum6120;
  if (sum6120 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6075 = done;
  }
// compiled if node returning if6075 (depth = 4)
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6122 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6124 == NULL) {
    strlit6124 = alloc_String("of the dialect in quotes after the word 'dialect'.");
    gc_root(strlit6124);
  }
// compiled string node returning strlit6124 (depth = 6)
  int op_slot_right_6123 = gc_frame_newslot(strlit6124);
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6126 == NULL) {
    strlit6126 = alloc_String("a dialect statement must have the name ");
    gc_root(strlit6126);
  }
// compiled string node returning strlit6126 (depth = 6)
  int op_slot_left_6123 = gc_frame_newslot(strlit6126);
  params[0] = strlit6124;
  partcv[0] = 1;
  Object opresult6127 = callmethod(strlit6126, "++(1)", 1, partcv, params);
// compiled op node returning opresult6127 (depth = 5)
  gc_frame_newslot(opresult6127);
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6128 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6129 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6128);
// compiled member node returning call6129 (depth = 5)
  gc_frame_newslot(call6129);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult6127;
  params[1] = call6129;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6130 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6122);
// compiled call node returning call6130 (depth = 4)
    gc_frame_newslot(call6130);
    if6064 = call6130;
  } else {
  }
// compiled if node returning if6064 (depth = 3)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call6133 = callmethodflags(*var_values, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe6132);
// compiled member node returning call6133 (depth = 4)
  Object if6131 = done;
  if (istrue(call6133)) {
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6134 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6135 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call6136 = callmethodflags(*var_ast, "dialectNode", 0, partcv, params, 0);
  gc_frame_end(callframe6135);
// compiled member node returning call6136 (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6137 = callmethodflags(call6136, "fromToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6134);
// compiled call node returning call6137 (depth = 5)
  *var_dn = call6137;
  if (call6137 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6138 = gc_frame_new();
// call case 4: self request
  Object call6139 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6138);
// compiled member node returning call6139 (depth = 4)
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6140 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dn (depth = 5)
  gc_frame_newslot(*var_dn);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleObject (depth = 5)
  params[0] = *var_dn;
  partcv[0] = 1;
  Object call6141 = callmethodflags(*var_moduleObject, "theDialect:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6140);
// compiled call node returning call6141 (depth = 4)
    gc_frame_newslot(call6141);
    if6131 = call6141;
  } else {
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6142 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num6143 = alloc_Float64(50);
// compiled num node returning num6143 (depth = 5)
  gc_frame_newslot(num6143);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6145 == NULL) {
    strlit6145 = alloc_String("");
    gc_root(strlit6145);
  }
// compiled string node returning strlit6145 (depth = 6)
  int op_slot_right_6144 = gc_frame_newslot(strlit6145);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  int op_slot_right_6147 = gc_frame_newslot(*var_values);
// starting to compile string node (depth = 7)
  if (strlit6149 == NULL) {
    strlit6149 = alloc_String("values = ");
    gc_root(strlit6149);
  }
// compiled string node returning strlit6149 (depth = 7)
  int op_slot_left_6147 = gc_frame_newslot(strlit6149);
  params[0] = *var_values;
  partcv[0] = 1;
  Object opresult6150 = callmethod(strlit6149, "++(1)", 1, partcv, params);
// compiled op node returning opresult6150 (depth = 6)
  int op_slot_left_6144 = gc_frame_newslot(opresult6150);
  params[0] = strlit6145;
  partcv[0] = 1;
  Object opresult6151 = callmethod(opresult6150, "++(1)", 1, partcv, params);
// compiled op node returning opresult6151 (depth = 5)
  gc_frame_newslot(opresult6151);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = num6143;
  params[1] = opresult6151;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6152 = callmethodflags(*var_util, "log(1)verbose(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6142);
// compiled call node returning call6152 (depth = 4)
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6153 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6154 == NULL) {
    strlit6154 = alloc_String("a dialect statement must be at the start of the module.");
    gc_root(strlit6154);
  }
// compiled string node returning strlit6154 (depth = 5)
  gc_frame_newslot(strlit6154);
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6155 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6156 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6155);
// compiled member node returning call6156 (depth = 5)
  gc_frame_newslot(call6156);
// call case 6: other requests
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6154;
  params[1] = call6156;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6157 = callmethodflags(*var_errormessages, "syntaxError(1)atLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6153);
// compiled call node returning call6157 (depth = 4)
    gc_frame_newslot(call6157);
    if6131 = call6157;
  }
// compiled if node returning if6131 (depth = 3)
    gc_frame_newslot(if6131);
    if6058 = if6131;
  } else {
  }
// compiled if node returning if6058 (depth = 2)
  gc_frame_end(frame);
  return if6058;
}
Object meth_parser_6189__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6190 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_noBlocks (depth = 7)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call6191 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6190);
// compiled call node returning call6191 (depth = 6)
  gc_frame_end(frame);
  return call6191;
}
Object meth_parser_6298__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_inhNode = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe6299 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inhNode (depth = 6)
  gc_frame_newslot(*var_inhNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_inhNode;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6300 = callmethodflags(module_parser, "inheritModifier(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6299);
// compiled call node returning call6300 (depth = 5)
  gc_frame_end(frame);
  return call6300;
}
Object meth_parser_6303__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6158_inheritOrUse(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritOrUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_noBlocks = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_values = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
  Object *var_msg = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "msg");
// definebindings:
// definebindings:
// definebindings:
  Object *var_inhNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inhNode");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6160 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6161 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6162 == NULL) {
    strlit6162 = alloc_String("keyword");
    gc_root(strlit6162);
  }
// compiled string node returning strlit6162 (depth = 5)
  gc_frame_newslot(strlit6162);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6162;
  partcv[0] = 1;
  Object call6163 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6161);
// compiled call node returning call6163 (depth = 4)
  partcv[0] = 0;
  Object call6164 = callmethodflags(call6163, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe6160);
// compiled call node returning call6164 (depth = 3)
  Object if6159 = done;
  if (istrue(call6164)) {
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6159 = undefined;
  } else {
  }
// compiled if node returning if6159 (depth = 2)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6168 == NULL) {
    strlit6168 = alloc_String("use");
    gc_root(strlit6168);
  }
// compiled string node returning strlit6168 (depth = 5)
  int op_slot_right_6167 = gc_frame_newslot(strlit6168);
// starting to compile member node (depth = 5)
  int callframe6170 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6171 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6170);
// compiled member node returning call6171 (depth = 5)
  int op_slot_left_6167 = gc_frame_newslot(call6171);
  params[0] = strlit6168;
  partcv[0] = 1;
  Object opresult6172 = callmethod(call6171, "==(1)", 1, partcv, params);
// compiled op node returning opresult6172 (depth = 4)
  int op_slot_right_6166 = gc_frame_newslot(opresult6172);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6175 == NULL) {
    strlit6175 = alloc_String("inherit");
    gc_root(strlit6175);
  }
// compiled string node returning strlit6175 (depth = 5)
  int op_slot_right_6174 = gc_frame_newslot(strlit6175);
// starting to compile member node (depth = 5)
  int callframe6177 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6178 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6177);
// compiled member node returning call6178 (depth = 5)
  int op_slot_left_6174 = gc_frame_newslot(call6178);
  params[0] = strlit6175;
  partcv[0] = 1;
  Object opresult6179 = callmethod(call6178, "==(1)", 1, partcv, params);
// compiled op node returning opresult6179 (depth = 4)
  int op_slot_left_6166 = gc_frame_newslot(opresult6179);
  params[0] = opresult6172;
  partcv[0] = 1;
  Object opresult6180 = callmethod(opresult6179, "||(1)", 1, partcv, params);
// compiled op node returning opresult6180 (depth = 3)
  Object if6165 = done;
  if (istrue(opresult6180)) {
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6182 = gc_frame_new();
// call case 4: self request
  Object call6183 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6182);
// compiled member node returning call6183 (depth = 3)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6184 = gc_frame_new();
// call case 4: self request
  Object call6185 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6184);
// compiled member node returning call6185 (depth = 3)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6187 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6188 = alloc_Block(NULL, NULL, "parser", 2139);
  gc_frame_newslot(block6188);
// method "_apply"
  block_savedest(block6188);
  Object closure6189 = createclosure(2, "_apply");
  setclosureframe(closure6189, stackframe);
  addtoclosure(closure6189, var_noBlocks);
  addtoclosure(closure6189, selfslot);
  struct UserObject *uo6189 = (struct UserObject*)block6188;
  uo6189->data[0] = (Object)closure6189;
  Method *meth_meth_parser_6189__apply = addmethod2pos(block6188, "_apply", &meth_parser_6189__apply, 0);
  int argcv_meth_parser_6189__apply[] = {0};
  meth_meth_parser_6189__apply->type = alloc_MethodType(1, argcv_meth_parser_6189__apply);
  meth_meth_parser_6189__apply->definitionModule = modulename;
  meth_meth_parser_6189__apply->definitionLine = 3208;
// compiled block node returning block6188 (depth = 5)
  gc_frame_newslot(block6188);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block6188;
  partcv[0] = 1;
  Object call6193 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6187);
// compiled call node returning call6193 (depth = 4)
  Object if6186 = done;
  if (istrue(call6193)) {
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array6194 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6194 (depth = 5)
  *var_suggestions = array6194;
  if (array6194 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6195 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6196 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6197 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6196);
// compiled member node returning call6197 (depth = 6)
  Object call6198 = callmethodflags(call6197, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6195);
// compiled member node returning call6198 (depth = 5)
  *var_suggestion = call6198;
  if (call6198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6199 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array6200 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit6201 == NULL) {
    strlit6201 = alloc_String("rsquare");
    gc_root(strlit6201);
  }
// compiled string node returning strlit6201 (depth = 7)
  params[0] = strlit6201;
  partcv[0] = 1;
  callmethodflags(array6200, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6200 (depth = 6)
  gc_frame_newslot(array6200);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array6200;
  partcv[0] = 1;
  Object call6202 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6199);
// compiled call node returning call6202 (depth = 5)
  *var_nextTok = call6202;
  if (call6202 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_6204 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_6204 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6206 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6206 (depth = 5)
  Object if6203 = done;
  if (istrue(opresult6206)) {
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6207 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6208 == NULL) {
    strlit6208 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit6208);
  }
// compiled string node returning strlit6208 (depth = 6)
  gc_frame_newslot(strlit6208);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6208;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6209 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6207);
// compiled call node returning call6209 (depth = 5)
    gc_frame_newslot(call6209);
    if6203 = call6209;
  } else {
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6210 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe6211 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call6212 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6211);
// compiled member node returning call6212 (depth = 6)
  gc_frame_newslot(call6212);
// starting to compile identifier node (depth = 6)
  Object bool6213 = alloc_Boolean(1);
// compiled identifier node returning bool6213 (depth = 6)
  gc_frame_newslot(bool6213);
// starting to compile identifier node (depth = 6)
  Object bool6214 = alloc_Boolean(0);
// compiled identifier node returning bool6214 (depth = 6)
  gc_frame_newslot(bool6214);
// starting to compile string node (depth = 6)
  if (strlit6215 == NULL) {
    strlit6215 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit6215);
  }
// compiled string node returning strlit6215 (depth = 6)
  gc_frame_newslot(strlit6215);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call6212;
  params[2] = bool6213;
  params[3] = bool6214;
  params[4] = strlit6215;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6216 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6210);
// compiled call node returning call6216 (depth = 5)
    gc_frame_newslot(call6216);
    if6203 = call6216;
  }
// compiled if node returning if6203 (depth = 4)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6217 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6218 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6217);
// compiled call node returning call6218 (depth = 4)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6219 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6220 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6221 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6220);
// compiled member node returning call6221 (depth = 6)
  Object call6222 = callmethodflags(call6221, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6219);
// compiled member node returning call6222 (depth = 5)
  *var_suggestion = call6222;
  if (call6222 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6224 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
  int callframe6225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  Object call6226 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6225);
// compiled member node returning call6226 (depth = 5)
  gc_frame_newslot(call6226);
// starting to compile identifier node (depth = 5)
  Object bool6227 = alloc_Boolean(1);
// compiled identifier node returning bool6227 (depth = 5)
  gc_frame_newslot(bool6227);
// starting to compile identifier node (depth = 5)
  Object bool6228 = alloc_Boolean(0);
// compiled identifier node returning bool6228 (depth = 5)
  gc_frame_newslot(bool6228);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call6226;
  params[2] = bool6227;
  params[3] = bool6228;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6229 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6224);
// compiled call node returning call6229 (depth = 4)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6230 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6231 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6230);
// compiled call node returning call6231 (depth = 4)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6233 == NULL) {
    strlit6233 = alloc_String(" keyword must be followed by an expression that creates ");
    gc_root(strlit6233);
  }
// compiled string node returning strlit6233 (depth = 6)
  int op_slot_right_6232 = gc_frame_newslot(strlit6233);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6236 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  Object call6237 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6236);
// compiled member node returning call6237 (depth = 7)
  int op_slot_right_6235 = gc_frame_newslot(call6237);
// starting to compile string node (depth = 7)
  if (strlit6239 == NULL) {
    strlit6239 = alloc_String("The ");
    gc_root(strlit6239);
  }
// compiled string node returning strlit6239 (depth = 7)
  int op_slot_left_6235 = gc_frame_newslot(strlit6239);
  params[0] = call6237;
  partcv[0] = 1;
  Object opresult6240 = callmethod(strlit6239, "++(1)", 1, partcv, params);
// compiled op node returning opresult6240 (depth = 6)
  int op_slot_left_6232 = gc_frame_newslot(opresult6240);
  params[0] = strlit6233;
  partcv[0] = 1;
  Object opresult6241 = callmethod(opresult6240, "++(1)", 1, partcv, params);
// compiled op node returning opresult6241 (depth = 5)
  *var_msg = opresult6241;
  if (opresult6241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6244 == NULL) {
    strlit6244 = alloc_String("use");
    gc_root(strlit6244);
  }
// compiled string node returning strlit6244 (depth = 6)
  int op_slot_right_6243 = gc_frame_newslot(strlit6244);
// starting to compile member node (depth = 6)
  int callframe6246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call6247 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6246);
// compiled member node returning call6247 (depth = 6)
  int op_slot_left_6243 = gc_frame_newslot(call6247);
  params[0] = strlit6244;
  partcv[0] = 1;
  Object opresult6248 = callmethod(call6247, "==(1)", 1, partcv, params);
// compiled op node returning opresult6248 (depth = 5)
  Object if6242 = done;
  if (istrue(opresult6248)) {
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6250 == NULL) {
    strlit6250 = alloc_String("the trait being used.");
    gc_root(strlit6250);
  }
// compiled string node returning strlit6250 (depth = 7)
  int op_slot_right_6249 = gc_frame_newslot(strlit6250);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_6249 = gc_frame_newslot(*var_msg);
  params[0] = strlit6250;
  partcv[0] = 1;
  Object opresult6252 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult6252 (depth = 6)
  *var_msg = opresult6252;
  if (opresult6252 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6242 = done;
  } else {
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6255 == NULL) {
    strlit6255 = alloc_String("the object being inherited.");
    gc_root(strlit6255);
  }
// compiled string node returning strlit6255 (depth = 7)
  int op_slot_right_6254 = gc_frame_newslot(strlit6255);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_6254 = gc_frame_newslot(*var_msg);
  params[0] = strlit6255;
  partcv[0] = 1;
  Object opresult6257 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult6257 (depth = 6)
  *var_msg = opresult6257;
  if (opresult6257 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6242 = done;
  }
// compiled if node returning if6242 (depth = 4)
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6259 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_msg (depth = 5)
  gc_frame_newslot(*var_msg);
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6260 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6261 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6260);
// compiled member node returning call6261 (depth = 5)
  gc_frame_newslot(call6261);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6263 = alloc_Float64(1);
// compiled num node returning num6263 (depth = 6)
  int op_slot_right_6262 = gc_frame_newslot(num6263);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6266 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6267 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6266);
// compiled member node returning call6267 (depth = 7)
  int op_slot_right_6265 = gc_frame_newslot(call6267);
// starting to compile member node (depth = 7)
  int callframe6269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6270 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6269);
// compiled member node returning call6270 (depth = 7)
  int op_slot_left_6265 = gc_frame_newslot(call6270);
  params[0] = call6267;
  partcv[0] = 1;
  Object sum6271 = callmethod(call6270, "+(1)", 1, partcv, params);
// compiled op node returning sum6271 (depth = 6)
  int op_slot_left_6262 = gc_frame_newslot(sum6271);
  params[0] = num6263;
  partcv[0] = 1;
  Object sum6272 = callmethod(sum6271, "+(1)", 1, partcv, params);
// compiled op node returning sum6272 (depth = 5)
  gc_frame_newslot(sum6272);
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = *var_msg;
  params[1] = call6261;
  params[2] = sum6272;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6273 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6259);
// compiled call node returning call6273 (depth = 4)
    gc_frame_newslot(call6273);
    if6186 = call6273;
  } else {
  }
// compiled if node returning if6186 (depth = 3)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6274 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6275 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call6276 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6275);
// compiled member node returning call6276 (depth = 4)
  gc_frame_newslot(call6276);
// starting to compile member node (depth = 4)
  int callframe6277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call6278 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6277);
// compiled member node returning call6278 (depth = 4)
  gc_frame_newslot(call6278);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call6276;
  params[1] = call6278;
  partcv[0] = 2;
  Object call6279 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6274);
// compiled call node returning call6279 (depth = 3)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6280 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6281 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6282 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6281);
// compiled member node returning call6282 (depth = 5)
  gc_frame_newslot(call6282);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6284 = callmethodflags(*var_ast, "inheritNode", 0, partcv, params, 0);
  gc_frame_end(callframe6283);
// compiled member node returning call6284 (depth = 5)
  params[0] = call6282;
  partcv[0] = 1;
  Object call6285 = callmethodflags(call6284, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6280);
// compiled call node returning call6285 (depth = 4)
  *var_inhNode = call6285;
  if (call6285 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6288 == NULL) {
    strlit6288 = alloc_String("use");
    gc_root(strlit6288);
  }
// compiled string node returning strlit6288 (depth = 5)
  int op_slot_right_6287 = gc_frame_newslot(strlit6288);
// starting to compile member node (depth = 5)
  int callframe6290 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call6291 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6290);
// compiled member node returning call6291 (depth = 5)
  int op_slot_left_6287 = gc_frame_newslot(call6291);
  params[0] = strlit6288;
  partcv[0] = 1;
  Object opresult6292 = callmethod(call6291, "==(1)", 1, partcv, params);
// compiled op node returning opresult6292 (depth = 4)
  Object if6286 = done;
  if (istrue(opresult6292)) {
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6293 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6294 = alloc_Boolean(1);
// compiled identifier node returning bool6294 (depth = 5)
  gc_frame_newslot(bool6294);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inhNode (depth = 5)
  params[0] = bool6294;
  partcv[0] = 1;
  Object call6295 = callmethodflags(*var_inhNode, "isUse:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6293);
// compiled call node returning call6295 (depth = 4)
    gc_frame_newslot(call6295);
    if6286 = call6295;
  } else {
  }
// compiled if node returning if6286 (depth = 3)
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6296 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6297 = alloc_Block(NULL, NULL, "parser", 2167);
  gc_frame_newslot(block6297);
// method "_apply"
  block_savedest(block6297);
  Object closure6298 = createclosure(3, "_apply");
  setclosureframe(closure6298, stackframe);
  addtoclosure(closure6298, var_inhNode);
  addtoclosure(closure6298, var_btok);
  addtoclosure(closure6298, selfslot);
  struct UserObject *uo6298 = (struct UserObject*)block6297;
  uo6298->data[0] = (Object)closure6298;
  Method *meth_meth_parser_6298__apply = addmethod2pos(block6297, "_apply", &meth_parser_6298__apply, 0);
  int argcv_meth_parser_6298__apply[] = {0};
  meth_meth_parser_6298__apply->type = alloc_MethodType(1, argcv_meth_parser_6298__apply);
  meth_meth_parser_6298__apply->definitionModule = modulename;
  meth_meth_parser_6298__apply->definitionLine = 3208;
// compiled block node returning block6297 (depth = 4)
  gc_frame_newslot(block6297);
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6302 = alloc_Block(NULL, NULL, "parser", 2167);
  gc_frame_newslot(block6302);
// method "_apply"
  block_savedest(block6302);
  Object closure6303 = createclosure(1, "_apply");
  setclosureframe(closure6303, stackframe);
  addtoclosure(closure6303, selfslot);
  struct UserObject *uo6303 = (struct UserObject*)block6302;
  uo6303->data[0] = (Object)closure6303;
  Method *meth_meth_parser_6303__apply = addmethod2pos(block6302, "_apply", &meth_parser_6303__apply, 0);
  int argcv_meth_parser_6303__apply[] = {0};
  meth_meth_parser_6303__apply->type = alloc_MethodType(1, argcv_meth_parser_6303__apply);
  meth_meth_parser_6303__apply->definitionModule = modulename;
  meth_meth_parser_6303__apply->definitionLine = 3208;
// compiled block node returning block6302 (depth = 4)
  gc_frame_newslot(block6302);
// call case 5: prelude request
  params[0] = block6297;
  params[1] = block6302;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6305 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6296);
// compiled call node returning call6305 (depth = 3)
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6306 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call6307 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6306);
// compiled call node returning call6307 (depth = 3)
    gc_frame_newslot(call6307);
    if6165 = call6307;
  } else {
  }
// compiled if node returning if6165 (depth = 2)
  gc_frame_end(frame);
  return if6165;
}
Object meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritModifier(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritModifier(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritModifier(_)onLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for inheritModifier(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inheritModifier(_)");
  Object *var_startToken = &(stackframe->slots[1]);
  *var_startToken = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6310 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6311 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6312 == NULL) {
    strlit6312 = alloc_String("keyword");
    gc_root(strlit6312);
  }
// compiled string node returning strlit6312 (depth = 5)
  gc_frame_newslot(strlit6312);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6312;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6313 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6311);
// compiled call node returning call6313 (depth = 4)
  partcv[0] = 0;
  Object call6314 = callmethodflags(call6313, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe6310);
// compiled call node returning call6314 (depth = 3)
  Object if6309 = done;
  if (istrue(call6314)) {
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6315 = alloc_Boolean(0);
// compiled identifier node returning bool6315 (depth = 4)
  return bool6315;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6309 = undefined;
  } else {
  }
// compiled if node returning if6309 (depth = 2)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6318 == NULL) {
    strlit6318 = alloc_String("alias");
    gc_root(strlit6318);
  }
// compiled string node returning strlit6318 (depth = 4)
  int op_slot_right_6317 = gc_frame_newslot(strlit6318);
// starting to compile member node (depth = 4)
  int callframe6320 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6321 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6320);
// compiled member node returning call6321 (depth = 4)
  int op_slot_left_6317 = gc_frame_newslot(call6321);
  params[0] = strlit6318;
  partcv[0] = 1;
  Object opresult6322 = callmethod(call6321, "==(1)", 1, partcv, params);
// compiled op node returning opresult6322 (depth = 3)
  Object if6316 = done;
  if (istrue(opresult6322)) {
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6323 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_node;
  partcv[0] = 1;
  Object call6324 = callmethodflags(module_parser, "parseAlias(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6323);
// compiled call node returning call6324 (depth = 3)
    gc_frame_newslot(call6324);
    if6316 = call6324;
  } else {
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6327 == NULL) {
    strlit6327 = alloc_String("exclude");
    gc_root(strlit6327);
  }
// compiled string node returning strlit6327 (depth = 5)
  int op_slot_right_6326 = gc_frame_newslot(strlit6327);
// starting to compile member node (depth = 5)
  int callframe6329 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6330 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6329);
// compiled member node returning call6330 (depth = 5)
  int op_slot_left_6326 = gc_frame_newslot(call6330);
  params[0] = strlit6327;
  partcv[0] = 1;
  Object opresult6331 = callmethod(call6330, "==(1)", 1, partcv, params);
// compiled op node returning opresult6331 (depth = 4)
  Object if6325 = done;
  if (istrue(opresult6331)) {
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6332 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  gc_frame_newslot(*var_node);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_node;
  partcv[0] = 1;
  Object call6333 = callmethodflags(module_parser, "parseExclude(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6332);
// compiled call node returning call6333 (depth = 4)
    gc_frame_newslot(call6333);
    if6325 = call6333;
  } else {
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6334 = alloc_Boolean(0);
// compiled identifier node returning bool6334 (depth = 4)
    gc_frame_newslot(bool6334);
    if6325 = bool6334;
  }
// compiled if node returning if6325 (depth = 3)
    gc_frame_newslot(if6325);
    if6316 = if6325;
  }
// compiled if node returning if6316 (depth = 2)
  gc_frame_end(frame);
  return if6316;
}
Object meth_parser_6335_parseAlias_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseAlias(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseAlias(_)");
  Object params[4];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseAlias(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseAlias(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newMeth");
// definebindings:
  Object *var_oldMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldMeth");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6336 = gc_frame_new();
// call case 4: self request
  Object call6337 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6336);
// compiled member node returning call6337 (depth = 2)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6338 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6339 = alloc_Boolean(1);
// compiled identifier node returning bool6339 (depth = 4)
  gc_frame_newslot(bool6339);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool6339;
  partcv[0] = 1;
  Object call6340 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6338);
// compiled call node returning call6340 (depth = 3)
  *var_newMeth = call6340;
  if (call6340 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6344 == NULL) {
    strlit6344 = alloc_String("=");
    gc_root(strlit6344);
  }
// compiled string node returning strlit6344 (depth = 5)
  int op_slot_right_6343 = gc_frame_newslot(strlit6344);
// starting to compile member node (depth = 5)
  int callframe6346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6347 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6346);
// compiled member node returning call6347 (depth = 5)
  int op_slot_left_6343 = gc_frame_newslot(call6347);
  params[0] = strlit6344;
  partcv[0] = 1;
  Object opresult6348 = callmethod(call6347, "==(1)", 1, partcv, params);
// compiled op node returning opresult6348 (depth = 4)
  int op_slot_right_6342 = gc_frame_newslot(opresult6348);
// starting to compile call node (depth = 4)
  int callframe6350 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6351 == NULL) {
    strlit6351 = alloc_String("op");
    gc_root(strlit6351);
  }
// compiled string node returning strlit6351 (depth = 5)
  gc_frame_newslot(strlit6351);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6351;
  partcv[0] = 1;
  Object call6352 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6350);
// compiled call node returning call6352 (depth = 4)
  int op_slot_left_6342 = gc_frame_newslot(call6352);
  params[0] = opresult6348;
  partcv[0] = 1;
  Object opresult6353 = callmethod(call6352, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6353 (depth = 3)
  Object if6341 = done;
  if (istrue(opresult6353)) {
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6354 = gc_frame_new();
// call case 4: self request
  Object call6355 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6354);
// compiled member node returning call6355 (depth = 3)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6356 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe6357 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool6358 = alloc_Boolean(1);
// compiled identifier node returning bool6358 (depth = 6)
  gc_frame_newslot(bool6358);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = bool6358;
  partcv[0] = 1;
  Object call6359 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6357);
// compiled call node returning call6359 (depth = 5)
  Object call6360 = callmethodflags(call6359, "appliedOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe6356);
// compiled member node returning call6360 (depth = 4)
  *var_oldMeth = call6360;
  if (call6360 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  Object call6364 = callmethodflags(*var_oldMeth, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe6363);
// compiled member node returning call6364 (depth = 5)
  int op_slot_right_6362 = gc_frame_newslot(call6364);
// starting to compile member node (depth = 5)
  int callframe6366 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call6367 = callmethodflags(*var_newMeth, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe6366);
// compiled member node returning call6367 (depth = 5)
  int op_slot_left_6362 = gc_frame_newslot(call6367);
  params[0] = call6364;
  partcv[0] = 1;
  Object opresult6368 = callmethod(call6367, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6368 (depth = 4)
  Object if6361 = done;
  if (istrue(opresult6368)) {
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6369 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6370 == NULL) {
    strlit6370 = alloc_String("a method and its alias must have the same number of parameters");
    gc_root(strlit6370);
  }
// compiled string node returning strlit6370 (depth = 5)
  gc_frame_newslot(strlit6370);
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call6372 = callmethodflags(*var_newMeth, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6371);
// compiled member node returning call6372 (depth = 5)
  gc_frame_newslot(call6372);
// starting to compile member node (depth = 5)
  int callframe6373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call6374 = callmethodflags(*var_newMeth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6373);
// compiled member node returning call6374 (depth = 5)
  gc_frame_newslot(call6374);
// starting to compile member node (depth = 5)
  int callframe6375 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  Object call6376 = callmethodflags(*var_oldMeth, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe6375);
// compiled member node returning call6376 (depth = 5)
  gc_frame_newslot(call6376);
// call case 6: other requests
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6370;
  params[1] = call6372;
  params[2] = call6374;
  params[3] = call6376;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6377 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6369);
// compiled call node returning call6377 (depth = 4)
    gc_frame_newslot(call6377);
    if6361 = call6377;
  } else {
  }
// compiled if node returning if6361 (depth = 3)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6378 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6379 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newMeth (depth = 5)
  Object call6380 = callmethodflags(*var_newMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe6379);
// compiled member node returning call6380 (depth = 4)
  gc_frame_newslot(call6380);
// starting to compile member node (depth = 4)
  int callframe6381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldMeth (depth = 5)
  Object call6382 = callmethodflags(*var_oldMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe6381);
// compiled member node returning call6382 (depth = 4)
  gc_frame_newslot(call6382);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = call6380;
  params[1] = call6382;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6383 = callmethodflags(*var_node, "addAlias(1)for(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6378);
// compiled call node returning call6383 (depth = 3)
    gc_frame_newslot(call6383);
    if6341 = call6383;
  } else {
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6384 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6386 == NULL) {
    strlit6386 = alloc_String("'""\xe2""""\x80""""\xb9""newMethodName""\xe2""""\x80""""\xba"" = ""\xe2""""\x80""""\xb9""oldMethodName""\xe2""""\x80""""\xba""'");
    gc_root(strlit6386);
  }
// compiled string node returning strlit6386 (depth = 5)
  int op_slot_right_6385 = gc_frame_newslot(strlit6386);
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6388 == NULL) {
    strlit6388 = alloc_String("an alias modifier must take the form ");
    gc_root(strlit6388);
  }
// compiled string node returning strlit6388 (depth = 5)
  int op_slot_left_6385 = gc_frame_newslot(strlit6388);
  params[0] = strlit6386;
  partcv[0] = 1;
  Object opresult6389 = callmethod(strlit6388, "++(1)", 1, partcv, params);
// compiled op node returning opresult6389 (depth = 4)
  gc_frame_newslot(opresult6389);
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call6391 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6390);
// compiled member node returning call6391 (depth = 4)
  gc_frame_newslot(call6391);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6394 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6393);
// compiled member node returning call6394 (depth = 5)
  int op_slot_right_6392 = gc_frame_newslot(call6394);
// starting to compile member node (depth = 5)
  int callframe6396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6397 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6396);
// compiled member node returning call6397 (depth = 5)
  int op_slot_left_6392 = gc_frame_newslot(call6397);
  params[0] = call6394;
  partcv[0] = 1;
  Object sum6398 = callmethod(call6397, "+(1)", 1, partcv, params);
// compiled op node returning sum6398 (depth = 4)
  gc_frame_newslot(sum6398);
// call case 6: other requests
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6389;
  params[1] = call6391;
  params[2] = sum6398;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call6399 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe6384);
// compiled call node returning call6399 (depth = 3)
    gc_frame_newslot(call6399);
    if6341 = call6399;
  }
// compiled if node returning if6341 (depth = 2)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6400 = alloc_Boolean(1);
// compiled identifier node returning bool6400 (depth = 3)
  return bool6400;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_6401_parseExclude_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parseExclude(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseExclude(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseExclude(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseExclude(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_excludedMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "excludedMeth");
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6402 = gc_frame_new();
// call case 4: self request
  Object call6403 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6402);
// compiled member node returning call6403 (depth = 2)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6404 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6405 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6406 = alloc_Boolean(1);
// compiled identifier node returning bool6406 (depth = 5)
  gc_frame_newslot(bool6406);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = bool6406;
  partcv[0] = 1;
  Object call6407 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6405);
// compiled call node returning call6407 (depth = 4)
  Object call6408 = callmethodflags(call6407, "appliedOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe6404);
// compiled member node returning call6408 (depth = 3)
  *var_excludedMeth = call6408;
  if (call6408 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6409 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6410 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_excludedMeth (depth = 4)
  Object call6411 = callmethodflags(*var_excludedMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe6410);
// compiled member node returning call6411 (depth = 3)
  gc_frame_newslot(call6411);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = call6411;
  partcv[0] = 1;
  Object call6412 = callmethodflags(*var_node, "addExclusion(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6409);
// compiled call node returning call6412 (depth = 2)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6413 = alloc_Boolean(1);
// compiled identifier node returning bool6413 (depth = 3)
  return bool6413;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_6414_doobject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6416 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6417 == NULL) {
    strlit6417 = alloc_String("object");
    gc_root(strlit6417);
  }
// compiled string node returning strlit6417 (depth = 4)
  gc_frame_newslot(strlit6417);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6417;
  partcv[0] = 1;
  Object call6418 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6416);
// compiled call node returning call6418 (depth = 3)
  Object if6415 = done;
  if (istrue(call6418)) {
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6419 = gc_frame_new();
// call case 4: self request
  Object call6420 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6419);
// compiled member node returning call6420 (depth = 3)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6421 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6422 == NULL) {
    strlit6422 = alloc_String("an object constructor");
    gc_root(strlit6422);
  }
// compiled string node returning strlit6422 (depth = 4)
  gc_frame_newslot(strlit6422);
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 4)
  if (strlit6423 == NULL) {
    strlit6423 = alloc_String("'object'");
    gc_root(strlit6423);
  }
// compiled string node returning strlit6423 (depth = 4)
  gc_frame_newslot(strlit6423);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6422;
  params[1] = *var_lastToken;
  params[2] = strlit6423;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6424 = callmethodflags(module_parser, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6421);
// compiled call node returning call6424 (depth = 3)
    gc_frame_newslot(call6424);
    if6415 = call6424;
  } else {
  }
// compiled if node returning if6415 (depth = 2)
  gc_frame_end(frame);
  return if6415;
}
Object meth_parser_6441__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6443 == NULL) {
    strlit6443 = alloc_String("rbrace");
    gc_root(strlit6443);
  }
// compiled string node returning strlit6443 (depth = 7)
  int op_slot_right_6442 = gc_frame_newslot(strlit6443);
// starting to compile member node (depth = 7)
  int callframe6445 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  Object call6446 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6445);
// compiled member node returning call6446 (depth = 7)
  int op_slot_left_6442 = gc_frame_newslot(call6446);
  params[0] = strlit6443;
  partcv[0] = 1;
  Object opresult6447 = callmethod(call6446, "==(1)", 1, partcv, params);
// compiled op node returning opresult6447 (depth = 6)
  gc_frame_end(frame);
  return opresult6447;
}
Object meth_parser_6521__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6523 == NULL) {
    strlit6523 = alloc_String("eof");
    gc_root(strlit6523);
  }
// compiled string node returning strlit6523 (depth = 7)
  int op_slot_right_6522 = gc_frame_newslot(strlit6523);
// starting to compile member node (depth = 7)
  int callframe6525 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6526 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6525);
// compiled member node returning call6526 (depth = 7)
  int op_slot_left_6522 = gc_frame_newslot(call6526);
  params[0] = strlit6523;
  partcv[0] = 1;
  Object opresult6527 = callmethod(call6526, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6527 (depth = 6)
  gc_frame_end(frame);
  return opresult6527;
}
Object meth_parser_6518__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6520 = alloc_Block(NULL, NULL, "parser", 2252);
  gc_frame_newslot(block6520);
// method "_apply"
  block_savedest(block6520);
  Object closure6521 = createclosure(2, "_apply");
  setclosureframe(closure6521, stackframe);
  addtoclosure(closure6521, var_sym);
  addtoclosure(closure6521, selfslot);
  struct UserObject *uo6521 = (struct UserObject*)block6520;
  uo6521->data[0] = (Object)closure6521;
  Method *meth_meth_parser_6521__apply = addmethod2pos(block6520, "_apply", &meth_parser_6521__apply, 0);
  int argcv_meth_parser_6521__apply[] = {0};
  meth_meth_parser_6521__apply->type = alloc_MethodType(1, argcv_meth_parser_6521__apply);
  meth_meth_parser_6521__apply->definitionModule = modulename;
  meth_meth_parser_6521__apply->definitionLine = 3208;
// compiled block node returning block6520 (depth = 5)
  int op_slot_right_6519 = gc_frame_newslot(block6520);
// starting to compile member node (depth = 5)
  int callframe6530 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe6531 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6532 == NULL) {
    strlit6532 = alloc_String("rbrace");
    gc_root(strlit6532);
  }
// compiled string node returning strlit6532 (depth = 7)
  gc_frame_newslot(strlit6532);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit6532;
  partcv[0] = 1;
  Object call6533 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6531);
// compiled call node returning call6533 (depth = 6)
  Object call6534 = callmethodflags(call6533, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6530);
// compiled member node returning call6534 (depth = 5)
  int op_slot_left_6519 = gc_frame_newslot(call6534);
  params[0] = block6520;
  partcv[0] = 1;
  Object opresult6535 = callmethod(call6534, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6535 (depth = 4)
  gc_frame_end(frame);
  return opresult6535;
}
Object meth_parser_6544__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe6545 = gc_frame_new();
// call case 4: self request
  Object call6546 = callmethodflags(self, "inheritOrUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6545);
// compiled member node returning call6546 (depth = 7)
  gc_frame_end(frame);
  return call6546;
}
Object meth_parser_6624__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe6625 = gc_frame_new();
// call case 4: self request
  Object call6626 = callmethodflags(self, "methoddec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6625);
// compiled member node returning call6626 (depth = 8)
  gc_frame_end(frame);
  return call6626;
}
Object meth_parser_6634__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 9)
  int callframe6635 = gc_frame_new();
// call case 4: self request
  Object call6636 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6635);
// compiled member node returning call6636 (depth = 9)
  gc_frame_end(frame);
  return call6636;
}
Object meth_parser_6538__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inPreamble = getfromclosure(closure, 1);
  Object *var_usedTraits = getfromclosure(closure, 2);
  Object *var_superObject = getfromclosure(closure, 3);
  Object *var_constructName = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6539 = gc_frame_new();
// call case 4: self request
  Object call6540 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6539);
// compiled member node returning call6540 (depth = 4)
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6542 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6543 = alloc_Block(NULL, NULL, "parser", 2254);
  gc_frame_newslot(block6543);
// method "_apply"
  block_savedest(block6543);
  Object closure6544 = createclosure(1, "_apply");
  setclosureframe(closure6544, stackframe);
  addtoclosure(closure6544, selfslot);
  struct UserObject *uo6544 = (struct UserObject*)block6543;
  uo6544->data[0] = (Object)closure6544;
  Method *meth_meth_parser_6544__apply = addmethod2pos(block6543, "_apply", &meth_parser_6544__apply, 0);
  int argcv_meth_parser_6544__apply[] = {0};
  meth_meth_parser_6544__apply->type = alloc_MethodType(1, argcv_meth_parser_6544__apply);
  meth_meth_parser_6544__apply->definitionModule = modulename;
  meth_meth_parser_6544__apply->definitionLine = 3208;
// compiled block node returning block6543 (depth = 6)
  gc_frame_newslot(block6543);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block6543;
  partcv[0] = 1;
  Object call6548 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6542);
// compiled call node returning call6548 (depth = 5)
  Object if6541 = done;
  if (istrue(call6548)) {
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call6550 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6549);
// compiled member node returning call6550 (depth = 6)
  *var_parentNode = call6550;
  if (call6550 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inPreamble (depth = 6)
  Object if6551 = done;
  if (istrue(*var_inPreamble)) {
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6553 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call6554 = callmethodflags(*var_parentNode, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe6553);
// compiled member node returning call6554 (depth = 7)
  Object if6552 = done;
  if (istrue(call6554)) {
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6555 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_usedTraits (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call6556 = callmethodflags(*var_usedTraits, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6555);
// compiled call node returning call6556 (depth = 7)
    gc_frame_newslot(call6556);
    if6552 = call6556;
  } else {
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6558 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_usedTraits (depth = 9)
  Object call6559 = callmethodflags(*var_usedTraits, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe6558);
// compiled member node returning call6559 (depth = 8)
  Object if6557 = done;
  if (istrue(call6559)) {
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  *var_superObject = *var_parentNode;
  if (*var_parentNode == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if6557 = done;
  } else {
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6561 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6564 == NULL) {
    strlit6564 = alloc_String("");
    gc_root(strlit6564);
  }
// compiled string node returning strlit6564 (depth = 11)
  int op_slot_right_6563 = gc_frame_newslot(strlit6564);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_constructName (depth = 12)
  int op_slot_right_6566 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 12)
  if (strlit6568 == NULL) {
    strlit6568 = alloc_String("before 'use' in ");
    gc_root(strlit6568);
  }
// compiled string node returning strlit6568 (depth = 12)
  int op_slot_left_6566 = gc_frame_newslot(strlit6568);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6569 = callmethod(strlit6568, "++(1)", 1, partcv, params);
// compiled op node returning opresult6569 (depth = 11)
  int op_slot_left_6563 = gc_frame_newslot(opresult6569);
  params[0] = strlit6564;
  partcv[0] = 1;
  Object opresult6570 = callmethod(opresult6569, "++(1)", 1, partcv, params);
// compiled op node returning opresult6570 (depth = 10)
  int op_slot_right_6562 = gc_frame_newslot(opresult6570);
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit6572 == NULL) {
    strlit6572 = alloc_String("'inherit' must come ");
    gc_root(strlit6572);
  }
// compiled string node returning strlit6572 (depth = 10)
  int op_slot_left_6562 = gc_frame_newslot(strlit6572);
  params[0] = opresult6570;
  partcv[0] = 1;
  Object opresult6573 = callmethod(strlit6572, "++(1)", 1, partcv, params);
// compiled op node returning opresult6573 (depth = 9)
  gc_frame_newslot(opresult6573);
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6574 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call6575 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6574);
// compiled member node returning call6575 (depth = 9)
  gc_frame_newslot(call6575);
// starting to compile member node (depth = 9)
  int callframe6576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call6577 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6576);
// compiled member node returning call6577 (depth = 9)
  gc_frame_newslot(call6577);
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6579 = alloc_Float64(7);
// compiled num node returning num6579 (depth = 10)
  int op_slot_right_6578 = gc_frame_newslot(num6579);
// starting to compile member node (depth = 10)
  int callframe6581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  Object call6582 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6581);
// compiled member node returning call6582 (depth = 10)
  int op_slot_left_6578 = gc_frame_newslot(call6582);
  params[0] = num6579;
  partcv[0] = 1;
  Object sum6583 = callmethod(call6582, "+(1)", 1, partcv, params);
// compiled op node returning sum6583 (depth = 9)
  gc_frame_newslot(sum6583);
// call case 6: other requests
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult6573;
  params[1] = call6575;
  params[2] = call6577;
  params[3] = sum6583;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6584 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6561);
// compiled call node returning call6584 (depth = 8)
    gc_frame_newslot(call6584);
    if6557 = call6584;
  }
// compiled if node returning if6557 (depth = 7)
    gc_frame_newslot(if6557);
    if6552 = if6557;
  }
// compiled if node returning if6552 (depth = 6)
    gc_frame_newslot(if6552);
    if6551 = if6552;
  } else {
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6585 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6588 == NULL) {
    strlit6588 = alloc_String("");
    gc_root(strlit6588);
  }
// compiled string node returning strlit6588 (depth = 9)
  int op_slot_right_6587 = gc_frame_newslot(strlit6588);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_constructName (depth = 10)
  int op_slot_right_6590 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 10)
  if (strlit6592 == NULL) {
    strlit6592 = alloc_String("come at the start of ");
    gc_root(strlit6592);
  }
// compiled string node returning strlit6592 (depth = 10)
  int op_slot_left_6590 = gc_frame_newslot(strlit6592);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6593 = callmethod(strlit6592, "++(1)", 1, partcv, params);
// compiled op node returning opresult6593 (depth = 9)
  int op_slot_left_6587 = gc_frame_newslot(opresult6593);
  params[0] = strlit6588;
  partcv[0] = 1;
  Object opresult6594 = callmethod(opresult6593, "++(1)", 1, partcv, params);
// compiled op node returning opresult6594 (depth = 8)
  int op_slot_right_6586 = gc_frame_newslot(opresult6594);
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6597 == NULL) {
    strlit6597 = alloc_String("' must ");
    gc_root(strlit6597);
  }
// compiled string node returning strlit6597 (depth = 9)
  int op_slot_right_6596 = gc_frame_newslot(strlit6597);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe6600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  Object call6601 = callmethodflags(*var_parentNode, "statementName", 0, partcv, params, 0);
  gc_frame_end(callframe6600);
// compiled member node returning call6601 (depth = 10)
  int op_slot_right_6599 = gc_frame_newslot(call6601);
// starting to compile string node (depth = 10)
  if (strlit6603 == NULL) {
    strlit6603 = alloc_String("'");
    gc_root(strlit6603);
  }
// compiled string node returning strlit6603 (depth = 10)
  int op_slot_left_6599 = gc_frame_newslot(strlit6603);
  params[0] = call6601;
  partcv[0] = 1;
  Object opresult6604 = callmethod(strlit6603, "++(1)", 1, partcv, params);
// compiled op node returning opresult6604 (depth = 9)
  int op_slot_left_6596 = gc_frame_newslot(opresult6604);
  params[0] = strlit6597;
  partcv[0] = 1;
  Object opresult6605 = callmethod(opresult6604, "++(1)", 1, partcv, params);
// compiled op node returning opresult6605 (depth = 8)
  int op_slot_left_6586 = gc_frame_newslot(opresult6605);
  params[0] = opresult6594;
  partcv[0] = 1;
  Object opresult6606 = callmethod(opresult6605, "++(1)", 1, partcv, params);
// compiled op node returning opresult6606 (depth = 7)
  gc_frame_newslot(opresult6606);
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe6607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call6608 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6607);
// compiled member node returning call6608 (depth = 7)
  gc_frame_newslot(call6608);
// starting to compile member node (depth = 7)
  int callframe6609 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call6610 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6609);
// compiled member node returning call6610 (depth = 7)
  gc_frame_newslot(call6610);
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6612 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6613 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call6614 = callmethodflags(*var_parentNode, "statementName", 0, partcv, params, 0);
  gc_frame_end(callframe6613);
// compiled member node returning call6614 (depth = 9)
  Object call6615 = callmethodflags(call6614, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6612);
// compiled member node returning call6615 (depth = 8)
  int op_slot_right_6611 = gc_frame_newslot(call6615);
// starting to compile member node (depth = 8)
  int callframe6617 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  Object call6618 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6617);
// compiled member node returning call6618 (depth = 8)
  int op_slot_left_6611 = gc_frame_newslot(call6618);
  params[0] = call6615;
  partcv[0] = 1;
  Object sum6619 = callmethod(call6618, "+(1)", 1, partcv, params);
// compiled op node returning sum6619 (depth = 7)
  gc_frame_newslot(sum6619);
// call case 6: other requests
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult6606;
  params[1] = call6608;
  params[2] = call6610;
  params[3] = sum6619;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6620 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6585);
// compiled call node returning call6620 (depth = 6)
    gc_frame_newslot(call6620);
    if6551 = call6620;
  }
// compiled if node returning if6551 (depth = 5)
    gc_frame_newslot(if6551);
    if6541 = if6551;
  } else {
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6622 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block6623 = alloc_Block(NULL, NULL, "parser", 2273);
  gc_frame_newslot(block6623);
// method "_apply"
  block_savedest(block6623);
  Object closure6624 = createclosure(1, "_apply");
  setclosureframe(closure6624, stackframe);
  addtoclosure(closure6624, selfslot);
  struct UserObject *uo6624 = (struct UserObject*)block6623;
  uo6624->data[0] = (Object)closure6624;
  Method *meth_meth_parser_6624__apply = addmethod2pos(block6623, "_apply", &meth_parser_6624__apply, 0);
  int argcv_meth_parser_6624__apply[] = {0};
  meth_meth_parser_6624__apply->type = alloc_MethodType(1, argcv_meth_parser_6624__apply);
  meth_meth_parser_6624__apply->definitionModule = modulename;
  meth_meth_parser_6624__apply->definitionLine = 3208;
// compiled block node returning block6623 (depth = 7)
  gc_frame_newslot(block6623);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block6623;
  partcv[0] = 1;
  Object call6628 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6622);
// compiled call node returning call6628 (depth = 6)
  Object if6621 = done;
  if (istrue(call6628)) {
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6629 = alloc_Boolean(0);
// compiled identifier node returning bool6629 (depth = 7)
  *var_inPreamble = bool6629;
  if (bool6629 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6621 = done;
  } else {
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6632 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6633 = alloc_Block(NULL, NULL, "parser", 2275);
  gc_frame_newslot(block6633);
// method "_apply"
  block_savedest(block6633);
  Object closure6634 = createclosure(1, "_apply");
  setclosureframe(closure6634, stackframe);
  addtoclosure(closure6634, selfslot);
  struct UserObject *uo6634 = (struct UserObject*)block6633;
  uo6634->data[0] = (Object)closure6634;
  Method *meth_meth_parser_6634__apply = addmethod2pos(block6633, "_apply", &meth_parser_6634__apply, 0);
  int argcv_meth_parser_6634__apply[] = {0};
  meth_meth_parser_6634__apply->type = alloc_MethodType(1, argcv_meth_parser_6634__apply);
  meth_meth_parser_6634__apply->definitionModule = modulename;
  meth_meth_parser_6634__apply->definitionLine = 3208;
// compiled block node returning block6633 (depth = 8)
  gc_frame_newslot(block6633);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block6633;
  partcv[0] = 1;
  Object call6638 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6632);
// compiled call node returning call6638 (depth = 7)
  Object if6631 = done;
  if (istrue(call6638)) {
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool6639 = alloc_Boolean(0);
// compiled identifier node returning bool6639 (depth = 8)
  *var_inPreamble = bool6639;
  if (bool6639 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6631 = done;
  } else {
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6641 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6644 == NULL) {
    strlit6644 = alloc_String("");
    gc_root(strlit6644);
  }
// compiled string node returning strlit6644 (depth = 10)
  int op_slot_right_6643 = gc_frame_newslot(strlit6644);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_constructName (depth = 11)
  int op_slot_right_6646 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 11)
  if (strlit6648 == NULL) {
    strlit6648 = alloc_String("of of ");
    gc_root(strlit6648);
  }
// compiled string node returning strlit6648 (depth = 11)
  int op_slot_left_6646 = gc_frame_newslot(strlit6648);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6649 = callmethod(strlit6648, "++(1)", 1, partcv, params);
// compiled op node returning opresult6649 (depth = 10)
  int op_slot_left_6643 = gc_frame_newslot(opresult6649);
  params[0] = strlit6644;
  partcv[0] = 1;
  Object opresult6650 = callmethod(opresult6649, "++(1)", 1, partcv, params);
// compiled op node returning opresult6650 (depth = 9)
  int op_slot_right_6642 = gc_frame_newslot(opresult6650);
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6653 == NULL) {
    strlit6653 = alloc_String("' in body ");
    gc_root(strlit6653);
  }
// compiled string node returning strlit6653 (depth = 10)
  int op_slot_right_6652 = gc_frame_newslot(strlit6653);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe6656 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call6657 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6656);
// compiled member node returning call6657 (depth = 11)
  int op_slot_right_6655 = gc_frame_newslot(call6657);
// starting to compile string node (depth = 11)
  if (strlit6659 == NULL) {
    strlit6659 = alloc_String("unexpected symbol '");
    gc_root(strlit6659);
  }
// compiled string node returning strlit6659 (depth = 11)
  int op_slot_left_6655 = gc_frame_newslot(strlit6659);
  params[0] = call6657;
  partcv[0] = 1;
  Object opresult6660 = callmethod(strlit6659, "++(1)", 1, partcv, params);
// compiled op node returning opresult6660 (depth = 10)
  int op_slot_left_6652 = gc_frame_newslot(opresult6660);
  params[0] = strlit6653;
  partcv[0] = 1;
  Object opresult6661 = callmethod(opresult6660, "++(1)", 1, partcv, params);
// compiled op node returning opresult6661 (depth = 9)
  int op_slot_left_6642 = gc_frame_newslot(opresult6661);
  params[0] = opresult6650;
  partcv[0] = 1;
  Object opresult6662 = callmethod(opresult6661, "++(1)", 1, partcv, params);
// compiled op node returning opresult6662 (depth = 8)
  gc_frame_newslot(opresult6662);
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6663 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6664 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6663);
// compiled member node returning call6664 (depth = 8)
  gc_frame_newslot(call6664);
// starting to compile member node (depth = 8)
  int callframe6665 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6666 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6665);
// compiled member node returning call6666 (depth = 8)
  gc_frame_newslot(call6666);
// starting to compile member node (depth = 8)
  int callframe6667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6668 = callmethodflags(*var_sym, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe6667);
// compiled member node returning call6668 (depth = 8)
  gc_frame_newslot(call6668);
// call case 6: other requests
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult6662;
  params[1] = call6664;
  params[2] = call6666;
  params[3] = call6668;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6669 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6641);
// compiled call node returning call6669 (depth = 7)
    gc_frame_newslot(call6669);
    if6631 = call6669;
  }
// compiled if node returning if6631 (depth = 6)
    gc_frame_newslot(if6631);
    if6621 = if6631;
  }
// compiled if node returning if6621 (depth = 5)
    gc_frame_newslot(if6621);
    if6541 = if6621;
  }
// compiled if node returning if6541 (depth = 4)
  gc_frame_end(frame);
  return if6541;
}
Object meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseObjectConstructorBody(_)startingWith(_)after(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_constructName = &(stackframe->slots[0]);
  *var_constructName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseObjectConstructorBody(_)");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *var_prev = &(stackframe->slots[2]);
  *var_prev = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_localMinIndentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "localMinIndentLevel");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_originalValues = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "originalValues");
  Object *var_superObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "superObject");
  Object *var_usedTraits = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "usedTraits");
  Object *var_inPreamble = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "inPreamble");
  Object *var_body = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "body");
  Object *var_objNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "objNode");
// definebindings:
// definebindings:
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6426 = gc_frame_new();
// call case 4: self request
  Object call6427 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6426);
// compiled member node returning call6427 (depth = 3)
  *var_anns = call6427;
  if (call6427 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6430 == NULL) {
    strlit6430 = alloc_String("lbrace");
    gc_root(strlit6430);
  }
// compiled string node returning strlit6430 (depth = 4)
  int op_slot_right_6429 = gc_frame_newslot(strlit6430);
// starting to compile member node (depth = 4)
  int callframe6432 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6433 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6432);
// compiled member node returning call6433 (depth = 4)
  int op_slot_left_6429 = gc_frame_newslot(call6433);
  params[0] = strlit6430;
  partcv[0] = 1;
  Object opresult6434 = callmethod(call6433, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6434 (depth = 3)
  Object if6428 = done;
  if (istrue(opresult6434)) {
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6435 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6436 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call6437 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6436);
// compiled member node returning call6437 (depth = 5)
  Object call6438 = callmethodflags(call6437, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6435);
// compiled member node returning call6438 (depth = 4)
  *var_suggestion = call6438;
  if (call6438 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6439 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6440 = alloc_Block(NULL, NULL, "parser", 2231);
  gc_frame_newslot(block6440);
// method "_apply(_)"
  block_savedest(block6440);
  Object closure6441 = createclosure(1, "_apply(1)");
  setclosureframe(closure6441, stackframe);
  addtoclosure(closure6441, selfslot);
  struct UserObject *uo6441 = (struct UserObject*)block6440;
  uo6441->data[0] = (Object)closure6441;
  Method *meth_meth_parser_6441__apply_40_1_41_ = addmethod2pos(block6440, "_apply(1)", &meth_parser_6441__apply_40_1_41_, 0);
  int argcv_meth_parser_6441__apply_40_1_41_[] = {1};
  meth_meth_parser_6441__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6441__apply_40_1_41_);
  meth_meth_parser_6441__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6441__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block6440 (depth = 5)
  gc_frame_newslot(block6440);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block6440;
  partcv[0] = 1;
  Object call6449 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6439);
// compiled call node returning call6449 (depth = 4)
  *var_nextTok = call6449;
  if (call6449 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_6451 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool6453 = alloc_Boolean(0);
// compiled identifier node returning bool6453 (depth = 5)
  int op_slot_left_6451 = gc_frame_newslot(bool6453);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult6454 = callmethod(bool6453, "==(1)", 1, partcv, params);
// compiled op node returning opresult6454 (depth = 4)
  Object if6450 = done;
  if (istrue(opresult6454)) {
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6455 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6456 == NULL) {
    strlit6456 = alloc_String(" {}");
    gc_root(strlit6456);
  }
// compiled string node returning strlit6456 (depth = 5)
  gc_frame_newslot(strlit6456);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6456;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6457 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6455);
// compiled call node returning call6457 (depth = 4)
    gc_frame_newslot(call6457);
    if6450 = call6457;
  } else {
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6458 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6459 == NULL) {
    strlit6459 = alloc_String(" {");
    gc_root(strlit6459);
  }
// compiled string node returning strlit6459 (depth = 5)
  gc_frame_newslot(strlit6459);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6459;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6460 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6458);
// compiled call node returning call6460 (depth = 4)
    gc_frame_newslot(call6460);
    if6450 = call6460;
  }
// compiled if node returning if6450 (depth = 3)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6461 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6463 == NULL) {
    strlit6463 = alloc_String(".");
    gc_root(strlit6463);
  }
// compiled string node returning strlit6463 (depth = 5)
  int op_slot_right_6462 = gc_frame_newslot(strlit6463);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_prev (depth = 6)
  int op_slot_right_6465 = gc_frame_newslot(*var_prev);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6468 == NULL) {
    strlit6468 = alloc_String(" must have a '{' after the ");
    gc_root(strlit6468);
  }
// compiled string node returning strlit6468 (depth = 7)
  int op_slot_right_6467 = gc_frame_newslot(strlit6468);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_constructName (depth = 8)
  int op_slot_right_6470 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 8)
  if (strlit6472 == NULL) {
    strlit6472 = alloc_String("");
    gc_root(strlit6472);
  }
// compiled string node returning strlit6472 (depth = 8)
  int op_slot_left_6470 = gc_frame_newslot(strlit6472);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6473 = callmethod(strlit6472, "++(1)", 1, partcv, params);
// compiled op node returning opresult6473 (depth = 7)
  int op_slot_left_6467 = gc_frame_newslot(opresult6473);
  params[0] = strlit6468;
  partcv[0] = 1;
  Object opresult6474 = callmethod(opresult6473, "++(1)", 1, partcv, params);
// compiled op node returning opresult6474 (depth = 6)
  int op_slot_left_6465 = gc_frame_newslot(opresult6474);
  params[0] = *var_prev;
  partcv[0] = 1;
  Object opresult6475 = callmethod(opresult6474, "++(1)", 1, partcv, params);
// compiled op node returning opresult6475 (depth = 5)
  int op_slot_left_6462 = gc_frame_newslot(opresult6475);
  params[0] = strlit6463;
  partcv[0] = 1;
  Object opresult6476 = callmethod(opresult6475, "++(1)", 1, partcv, params);
// compiled op node returning opresult6476 (depth = 4)
  gc_frame_newslot(opresult6476);
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6477 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call6478 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6477);
// compiled member node returning call6478 (depth = 4)
  gc_frame_newslot(call6478);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6481 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6480);
// compiled member node returning call6481 (depth = 5)
  int op_slot_right_6479 = gc_frame_newslot(call6481);
// starting to compile member node (depth = 5)
  int callframe6483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6484 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6483);
// compiled member node returning call6484 (depth = 5)
  int op_slot_left_6479 = gc_frame_newslot(call6484);
  params[0] = call6481;
  partcv[0] = 1;
  Object sum6485 = callmethod(call6484, "+(1)", 1, partcv, params);
// compiled op node returning sum6485 (depth = 4)
  gc_frame_newslot(sum6485);
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6476;
  params[1] = call6478;
  params[2] = sum6485;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6486 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6461);
// compiled call node returning call6486 (depth = 3)
    gc_frame_newslot(call6486);
    if6428 = call6486;
  } else {
  }
// compiled if node returning if6428 (depth = 2)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6487 = gc_frame_new();
// call case 4: self request
  Object call6488 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6487);
// compiled member node returning call6488 (depth = 2)
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6491 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementToken (depth = 5)
  Object call6492 = callmethodflags(*var_statementToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6491);
// compiled member node returning call6492 (depth = 4)
  int op_slot_right_6490 = gc_frame_newslot(call6492);
// starting to compile member node (depth = 4)
  int callframe6494 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6495 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6494);
// compiled member node returning call6495 (depth = 4)
  int op_slot_left_6490 = gc_frame_newslot(call6495);
  params[0] = call6492;
  partcv[0] = 1;
  Object opresult6496 = callmethod(call6495, "==(1)", 1, partcv, params);
// compiled op node returning opresult6496 (depth = 3)
  Object if6489 = done;
  if (istrue(opresult6496)) {
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6498 = alloc_Float64(2);
// compiled num node returning num6498 (depth = 5)
  int op_slot_right_6497 = gc_frame_newslot(num6498);
// starting to compile member node (depth = 5)
  int callframe6500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6501 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6500);
// compiled member node returning call6501 (depth = 5)
  int op_slot_left_6497 = gc_frame_newslot(call6501);
  params[0] = num6498;
  partcv[0] = 1;
  Object diff6502 = callmethod(call6501, "-(1)", 1, partcv, params);
// compiled op node returning diff6502 (depth = 4)
  *var_minIndentLevel = diff6502;
  if (diff6502 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6489 = done;
  } else {
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6505 = alloc_Float64(2);
// compiled num node returning num6505 (depth = 5)
  int op_slot_right_6504 = gc_frame_newslot(num6505);
// starting to compile member node (depth = 5)
  int callframe6507 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  Object call6508 = callmethodflags(*var_statementToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe6507);
// compiled member node returning call6508 (depth = 5)
  int op_slot_left_6504 = gc_frame_newslot(call6508);
  params[0] = num6505;
  partcv[0] = 1;
  Object sum6509 = callmethod(call6508, "+(1)", 1, partcv, params);
// compiled op node returning sum6509 (depth = 4)
  *var_minIndentLevel = sum6509;
  if (sum6509 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6489 = done;
  }
// compiled if node returning if6489 (depth = 2)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6511 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6511 (depth = 3)
  *var_values = array6511;
  if (array6511 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6513 = alloc_Boolean(0);
// compiled identifier node returning bool6513 (depth = 3)
  *var_superObject = bool6513;
  if (bool6513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6514 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6514 (depth = 3)
  *var_usedTraits = array6514;
  if (array6514 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6515 = alloc_Boolean(1);
// compiled identifier node returning bool6515 (depth = 3)
  *var_inPreamble = bool6515;
  if (bool6515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6516 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6517 = alloc_Block(NULL, NULL, "parser", 2252);
  gc_frame_newslot(block6517);
// method "_apply"
  block_savedest(block6517);
  Object closure6518 = createclosure(2, "_apply");
  setclosureframe(closure6518, stackframe);
  addtoclosure(closure6518, var_sym);
  addtoclosure(closure6518, selfslot);
  struct UserObject *uo6518 = (struct UserObject*)block6517;
  uo6518->data[0] = (Object)closure6518;
  Method *meth_meth_parser_6518__apply = addmethod2pos(block6517, "_apply", &meth_parser_6518__apply, 0);
  int argcv_meth_parser_6518__apply[] = {0};
  meth_meth_parser_6518__apply->type = alloc_MethodType(1, argcv_meth_parser_6518__apply);
  meth_meth_parser_6518__apply->definitionModule = modulename;
  meth_meth_parser_6518__apply->definitionLine = 3208;
// compiled block node returning block6517 (depth = 3)
  gc_frame_newslot(block6517);
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6537 = alloc_Block(NULL, NULL, "parser", 2252);
  gc_frame_newslot(block6537);
// method "_apply"
  block_savedest(block6537);
  Object closure6538 = createclosure(8, "_apply");
  setclosureframe(closure6538, stackframe);
  addtoclosure(closure6538, var_values);
  addtoclosure(closure6538, var_inPreamble);
  addtoclosure(closure6538, var_usedTraits);
  addtoclosure(closure6538, var_superObject);
  addtoclosure(closure6538, var_constructName);
  addtoclosure(closure6538, var_errormessages);
  addtoclosure(closure6538, var_sym);
  addtoclosure(closure6538, selfslot);
  struct UserObject *uo6538 = (struct UserObject*)block6537;
  uo6538->data[0] = (Object)closure6538;
  Method *meth_meth_parser_6538__apply = addmethod2pos(block6537, "_apply", &meth_parser_6538__apply, 0);
  int argcv_meth_parser_6538__apply[] = {0};
  meth_meth_parser_6538__apply->type = alloc_MethodType(1, argcv_meth_parser_6538__apply);
  meth_meth_parser_6538__apply->definitionModule = modulename;
  meth_meth_parser_6538__apply->definitionLine = 3208;
// compiled block node returning block6537 (depth = 3)
  gc_frame_newslot(block6537);
// call case 5: prelude request
  params[0] = block6517;
  params[1] = block6537;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6671 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6516);
// compiled call node returning call6671 (depth = 2)
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_body = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_originalValues (depth = 3)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6673 = gc_frame_new();
// call case 4: self request
  Object call6674 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6673);
// compiled member node returning call6674 (depth = 2)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6675 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6676 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_superObject (depth = 5)
  gc_frame_newslot(*var_superObject);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6677 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6678 = callmethodflags(*var_ast, "objectNode", 0, partcv, params, 0);
  gc_frame_end(callframe6677);
// compiled member node returning call6678 (depth = 5)
  params[0] = *var_body;
  params[1] = *var_superObject;
  partcv[0] = 2;
  Object call6679 = callmethodflags(call6678, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6676);
// compiled call node returning call6679 (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call6680 = callmethodflags(call6679, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6675);
// compiled call node returning call6680 (depth = 3)
  *var_objNode = call6680;
  if (call6680 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  int op_slot_right_6682 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 4)
  Object bool6684 = alloc_Boolean(0);
// compiled identifier node returning bool6684 (depth = 4)
  int op_slot_left_6682 = gc_frame_newslot(bool6684);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult6685 = callmethod(bool6684, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6685 (depth = 3)
  Object if6681 = done;
  if (istrue(opresult6685)) {
// starting to compile call node (depth = 3)
  int callframe6686 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  Object call6688 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6687);
// compiled member node returning call6688 (depth = 4)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call6689 = callmethodflags(call6688, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6686);
// compiled call node returning call6689 (depth = 3)
    gc_frame_newslot(call6689);
    if6681 = call6689;
  } else {
  }
// compiled if node returning if6681 (depth = 2)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6690 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_usedTraits (depth = 3)
  gc_frame_newslot(*var_usedTraits);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = *var_usedTraits;
  partcv[0] = 1;
  Object call6691 = callmethodflags(*var_objNode, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6690);
// compiled call node returning call6691 (depth = 2)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6692 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  gc_frame_newslot(*var_objNode);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_objNode;
  partcv[0] = 1;
  Object call6693 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6692);
// compiled call node returning call6693 (depth = 2)
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6695_doclass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
  Object *var_objName = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "objName");
// definebindings:
// definebindings:
  Object *var_meth = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "meth");
  Object *var_objNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "objNode");
// definebindings:
  Object *var_asStringBody = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "asStringBody");
  Object *var_signature = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "signature");
  Object *var_asStringMeth = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "asStringMeth");
  Object *var_metaBody = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "metaBody");
  Object *var_metaObj = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "metaObj");
  Object *var_defDec = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "defDec");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6696 = gc_frame_new();
// call case 4: self request
  Object call6697 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6696);
// compiled member node returning call6697 (depth = 2)
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6700 == NULL) {
    strlit6700 = alloc_String("identifier");
    gc_root(strlit6700);
  }
// compiled string node returning strlit6700 (depth = 4)
  int op_slot_right_6699 = gc_frame_newslot(strlit6700);
// starting to compile member node (depth = 4)
  int callframe6702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6703 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6702);
// compiled member node returning call6703 (depth = 4)
  int op_slot_left_6699 = gc_frame_newslot(call6703);
  params[0] = strlit6700;
  partcv[0] = 1;
  Object opresult6704 = callmethod(call6703, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6704 (depth = 3)
  Object if6698 = done;
  if (istrue(opresult6704)) {
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6705 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6705 (depth = 4)
  *var_suggestions = array6705;
  if (array6705 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6708 == NULL) {
    strlit6708 = alloc_String("lbrace");
    gc_root(strlit6708);
  }
// compiled string node returning strlit6708 (depth = 5)
  int op_slot_right_6707 = gc_frame_newslot(strlit6708);
// starting to compile member node (depth = 5)
  int callframe6710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6711 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6710);
// compiled member node returning call6711 (depth = 5)
  int op_slot_left_6707 = gc_frame_newslot(call6711);
  params[0] = strlit6708;
  partcv[0] = 1;
  Object opresult6712 = callmethod(call6711, "==(1)", 1, partcv, params);
// compiled op node returning opresult6712 (depth = 4)
  Object if6706 = done;
  if (istrue(opresult6712)) {
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6713 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6715 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6714);
// compiled member node returning call6715 (depth = 6)
  Object call6716 = callmethodflags(call6715, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6713);
// compiled member node returning call6716 (depth = 5)
  *var_suggestion = call6716;
  if (call6716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6717 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6718 == NULL) {
    strlit6718 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit6718);
  }
// compiled string node returning strlit6718 (depth = 5)
  gc_frame_newslot(strlit6718);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6718;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6719 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6717);
// compiled call node returning call6719 (depth = 4)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6720 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6721 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6720);
// compiled call node returning call6721 (depth = 4)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6722 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6724 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6723);
// compiled member node returning call6724 (depth = 6)
  Object call6725 = callmethodflags(call6724, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6722);
// compiled member node returning call6725 (depth = 5)
  *var_suggestion = call6725;
  if (call6725 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6727 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 5)
  if (strlit6728 == NULL) {
    strlit6728 = alloc_String("object");
    gc_root(strlit6728);
  }
// compiled string node returning strlit6728 (depth = 5)
  gc_frame_newslot(strlit6728);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = strlit6728;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6729 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6727);
// compiled call node returning call6729 (depth = 4)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6730 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6731 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6730);
// compiled call node returning call6731 (depth = 4)
    gc_frame_newslot(call6731);
    if6706 = call6731;
  } else {
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6732 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6733 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6734 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6733);
// compiled member node returning call6734 (depth = 6)
  Object call6735 = callmethodflags(call6734, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6732);
// compiled member node returning call6735 (depth = 5)
  *var_suggestion = call6735;
  if (call6735 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6736 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6737 == NULL) {
    strlit6737 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit6737);
  }
// compiled string node returning strlit6737 (depth = 5)
  gc_frame_newslot(strlit6737);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6737;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6738 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6736);
// compiled call node returning call6738 (depth = 4)
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6739 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6740 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6739);
// compiled call node returning call6740 (depth = 4)
    gc_frame_newslot(call6740);
    if6706 = call6740;
  }
// compiled if node returning if6706 (depth = 3)
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6741 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6742 == NULL) {
    strlit6742 = alloc_String("a class must have a name after the 'class'.");
    gc_root(strlit6742);
  }
// compiled string node returning strlit6742 (depth = 4)
  gc_frame_newslot(strlit6742);
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call6744 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6743);
// compiled member node returning call6744 (depth = 4)
  gc_frame_newslot(call6744);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6746 = alloc_Float64(1);
// compiled num node returning num6746 (depth = 5)
  int op_slot_right_6745 = gc_frame_newslot(num6746);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6749 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6750 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6749);
// compiled member node returning call6750 (depth = 6)
  int op_slot_right_6748 = gc_frame_newslot(call6750);
// starting to compile member node (depth = 6)
  int callframe6752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6753 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6752);
// compiled member node returning call6753 (depth = 6)
  int op_slot_left_6748 = gc_frame_newslot(call6753);
  params[0] = call6750;
  partcv[0] = 1;
  Object sum6754 = callmethod(call6753, "+(1)", 1, partcv, params);
// compiled op node returning sum6754 (depth = 5)
  int op_slot_left_6745 = gc_frame_newslot(sum6754);
  params[0] = num6746;
  partcv[0] = 1;
  Object sum6755 = callmethod(sum6754, "+(1)", 1, partcv, params);
// compiled op node returning sum6755 (depth = 4)
  gc_frame_newslot(sum6755);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6742;
  params[1] = call6744;
  params[2] = sum6755;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6756 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6741);
// compiled call node returning call6756 (depth = 3)
    gc_frame_newslot(call6756);
    if6698 = call6756;
  } else {
  }
// compiled if node returning if6698 (depth = 2)
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6757 = alloc_Boolean(0);
// compiled identifier node returning bool6757 (depth = 3)
  *var_objName = bool6757;
  if (bool6757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6760 == NULL) {
    strlit6760 = alloc_String("dot");
    gc_root(strlit6760);
  }
// compiled string node returning strlit6760 (depth = 4)
  int op_slot_right_6759 = gc_frame_newslot(strlit6760);
// starting to compile member node (depth = 4)
  int callframe6762 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call6764 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe6763);
// compiled member node returning call6764 (depth = 5)
  Object call6765 = callmethodflags(call6764, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6762);
// compiled member node returning call6765 (depth = 4)
  int op_slot_left_6759 = gc_frame_newslot(call6765);
  params[0] = strlit6760;
  partcv[0] = 1;
  Object opresult6766 = callmethod(call6765, "==(1)", 1, partcv, params);
// compiled op node returning opresult6766 (depth = 3)
  Object if6758 = done;
  if (istrue(opresult6766)) {
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6767 = gc_frame_new();
// call case 4: self request
  Object call6768 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6767);
// compiled member node returning call6768 (depth = 3)
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6769 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call6770 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6769);
// compiled member node returning call6770 (depth = 4)
  *var_objName = call6770;
  if (call6770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6772 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6773 = alloc_Boolean(1);
// compiled identifier node returning bool6773 (depth = 4)
  gc_frame_newslot(bool6773);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  params[0] = bool6773;
  partcv[0] = 1;
  Object call6774 = callmethodflags(*var_objName, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6772);
// compiled call node returning call6774 (depth = 3)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6775 = gc_frame_new();
// call case 4: self request
  Object call6776 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6775);
// compiled member node returning call6776 (depth = 3)
    gc_frame_newslot(call6776);
    if6758 = call6776;
  } else {
  }
// compiled if node returning if6758 (depth = 2)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6777 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6778 = alloc_Boolean(0);
// compiled identifier node returning bool6778 (depth = 4)
  gc_frame_newslot(bool6778);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool6778;
  partcv[0] = 1;
  Object call6779 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6777);
// compiled call node returning call6779 (depth = 3)
  *var_meth = call6779;
  if (call6779 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6780 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call6781 = callmethodflags(*var_meth, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6780);
// compiled call node returning call6781 (depth = 2)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6782 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit6783 == NULL) {
    strlit6783 = alloc_String("a class");
    gc_root(strlit6783);
  }
// compiled string node returning strlit6783 (depth = 3)
  gc_frame_newslot(strlit6783);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 3)
  if (strlit6784 == NULL) {
    strlit6784 = alloc_String("method header");
    gc_root(strlit6784);
  }
// compiled string node returning strlit6784 (depth = 3)
  gc_frame_newslot(strlit6784);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_parser (depth = 3)
  params[0] = strlit6783;
  params[1] = *var_btok;
  params[2] = strlit6784;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6785 = callmethodflags(module_parser, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6782);
// compiled call node returning call6785 (depth = 2)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6786 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call6787 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6786);
// compiled member node returning call6787 (depth = 3)
  *var_objNode = call6787;
  if (call6787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6788 = gc_frame_new();
// starting to compile array node (depth = 3)
  Object array6789 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array6789, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6789 (depth = 3)
  gc_frame_newslot(array6789);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = array6789;
  partcv[0] = 1;
  Object call6790 = callmethodflags(*var_meth, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6788);
// compiled call node returning call6790 (depth = 2)
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6791 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool6792 = alloc_Boolean(1);
// compiled identifier node returning bool6792 (depth = 3)
  gc_frame_newslot(bool6792);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool6792;
  partcv[0] = 1;
  Object call6793 = callmethodflags(*var_meth, "usesClassSyntax:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6791);
// compiled call node returning call6793 (depth = 2)
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6794 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  Object call6796 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6795);
// compiled member node returning call6796 (depth = 3)
  gc_frame_newslot(call6796);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe6797 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call6798 = callmethodflags(*var_meth, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6797);
// compiled member node returning call6798 (depth = 3)
  params[0] = call6796;
  partcv[0] = 1;
  Object call6799 = callmethodflags(call6798, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6794);
// compiled call node returning call6799 (depth = 2)
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  int op_slot_right_6801 = gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 4)
  Object bool6803 = alloc_Boolean(0);
// compiled identifier node returning bool6803 (depth = 4)
  int op_slot_left_6801 = gc_frame_newslot(bool6803);
  params[0] = *var_objName;
  partcv[0] = 1;
  Object opresult6804 = callmethod(bool6803, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6804 (depth = 3)
  Object if6800 = done;
  if (istrue(opresult6804)) {
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6805 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6806 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call6807 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6806);
// compiled member node returning call6807 (depth = 4)
  gc_frame_newslot(call6807);
// starting to compile member node (depth = 4)
  int callframe6808 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call6809 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6808);
// compiled member node returning call6809 (depth = 4)
  gc_frame_newslot(call6809);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call6807;
  params[1] = call6809;
  partcv[0] = 2;
  Object call6810 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6805);
// compiled call node returning call6810 (depth = 3)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6811 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6813 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call6814 = callmethodflags(*var_meth, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe6813);
// compiled member node returning call6814 (depth = 5)
  int op_slot_right_6812 = gc_frame_newslot(call6814);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6817 == NULL) {
    strlit6817 = alloc_String(".");
    gc_root(strlit6817);
  }
// compiled string node returning strlit6817 (depth = 6)
  int op_slot_right_6816 = gc_frame_newslot(strlit6817);
// starting to compile member node (depth = 6)
  int callframe6819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_objName (depth = 7)
  Object call6820 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe6819);
// compiled member node returning call6820 (depth = 6)
  int op_slot_left_6816 = gc_frame_newslot(call6820);
  params[0] = strlit6817;
  partcv[0] = 1;
  Object opresult6821 = callmethod(call6820, "++(1)", 1, partcv, params);
// compiled op node returning opresult6821 (depth = 5)
  int op_slot_left_6812 = gc_frame_newslot(opresult6821);
  params[0] = call6814;
  partcv[0] = 1;
  Object opresult6822 = callmethod(opresult6821, "++(1)", 1, partcv, params);
// compiled op node returning opresult6822 (depth = 4)
  gc_frame_newslot(opresult6822);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = opresult6822;
  partcv[0] = 1;
  Object call6823 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6811);
// compiled call node returning call6823 (depth = 3)
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6824 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe6825 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6827 == NULL) {
    strlit6827 = alloc_String("");
    gc_root(strlit6827);
  }
// compiled string node returning strlit6827 (depth = 7)
  int op_slot_right_6826 = gc_frame_newslot(strlit6827);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6830 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_objName (depth = 9)
  Object call6831 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe6830);
// compiled member node returning call6831 (depth = 8)
  int op_slot_right_6829 = gc_frame_newslot(call6831);
// starting to compile string node (depth = 8)
  if (strlit6833 == NULL) {
    strlit6833 = alloc_String("class ");
    gc_root(strlit6833);
  }
// compiled string node returning strlit6833 (depth = 8)
  int op_slot_left_6829 = gc_frame_newslot(strlit6833);
  params[0] = call6831;
  partcv[0] = 1;
  Object opresult6834 = callmethod(strlit6833, "++(1)", 1, partcv, params);
// compiled op node returning opresult6834 (depth = 7)
  int op_slot_left_6826 = gc_frame_newslot(opresult6834);
  params[0] = strlit6827;
  partcv[0] = 1;
  Object opresult6835 = callmethod(opresult6834, "++(1)", 1, partcv, params);
// compiled op node returning opresult6835 (depth = 6)
  gc_frame_newslot(opresult6835);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6836 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call6837 = callmethodflags(*var_ast, "stringNode", 0, partcv, params, 0);
  gc_frame_end(callframe6836);
// compiled member node returning call6837 (depth = 6)
  params[0] = opresult6835;
  partcv[0] = 1;
  Object call6838 = callmethodflags(call6837, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6825);
// compiled call node returning call6838 (depth = 5)
  params[0] = call6838;
  partcv[0] = 1;
  callmethodflags(array6824, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6824 (depth = 4)
  *var_asStringBody = array6824;
  if (array6824 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6839 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe6840 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6841 == NULL) {
    strlit6841 = alloc_String("asString");
    gc_root(strlit6841);
  }
// compiled string node returning strlit6841 (depth = 6)
  gc_frame_newslot(strlit6841);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6842 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call6843 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe6842);
// compiled member node returning call6843 (depth = 6)
  params[0] = strlit6841;
  partcv[0] = 1;
  Object call6844 = callmethodflags(call6843, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6840);
// compiled call node returning call6844 (depth = 5)
  params[0] = call6844;
  partcv[0] = 1;
  callmethodflags(array6839, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6839 (depth = 4)
  *var_signature = array6839;
  if (array6839 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6845 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringBody (depth = 5)
  gc_frame_newslot(*var_asStringBody);
// starting to compile identifier node (depth = 5)
  Object bool6846 = alloc_Boolean(0);
// compiled identifier node returning bool6846 (depth = 5)
  gc_frame_newslot(bool6846);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6847 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6848 = callmethodflags(*var_ast, "methodNode", 0, partcv, params, 0);
  gc_frame_end(callframe6847);
// compiled member node returning call6848 (depth = 5)
  params[0] = *var_signature;
  params[1] = *var_asStringBody;
  params[2] = bool6846;
  partcv[0] = 3;
  Object call6849 = callmethodflags(call6848, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe6845);
// compiled call node returning call6849 (depth = 4)
  *var_asStringMeth = call6849;
  if (call6849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6850 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  callmethodflags(array6850, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringMeth (depth = 5)
  params[0] = *var_asStringMeth;
  partcv[0] = 1;
  callmethodflags(array6850, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6850 (depth = 4)
  *var_metaBody = array6850;
  if (array6850 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6851 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaBody (depth = 5)
  gc_frame_newslot(*var_metaBody);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6853 == NULL) {
    strlit6853 = alloc_String("");
    gc_root(strlit6853);
  }
// compiled string node returning strlit6853 (depth = 6)
  int op_slot_right_6852 = gc_frame_newslot(strlit6853);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6856 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_objName (depth = 8)
  Object call6857 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe6856);
// compiled member node returning call6857 (depth = 7)
  int op_slot_right_6855 = gc_frame_newslot(call6857);
// starting to compile string node (depth = 7)
  if (strlit6859 == NULL) {
    strlit6859 = alloc_String("class ");
    gc_root(strlit6859);
  }
// compiled string node returning strlit6859 (depth = 7)
  int op_slot_left_6855 = gc_frame_newslot(strlit6859);
  params[0] = call6857;
  partcv[0] = 1;
  Object opresult6860 = callmethod(strlit6859, "++(1)", 1, partcv, params);
// compiled op node returning opresult6860 (depth = 6)
  int op_slot_left_6852 = gc_frame_newslot(opresult6860);
  params[0] = strlit6853;
  partcv[0] = 1;
  Object opresult6861 = callmethod(opresult6860, "++(1)", 1, partcv, params);
// compiled op node returning opresult6861 (depth = 5)
  gc_frame_newslot(opresult6861);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6862 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6863 = callmethodflags(*var_ast, "objectNode", 0, partcv, params, 0);
  gc_frame_end(callframe6862);
// compiled member node returning call6863 (depth = 5)
  params[0] = *var_metaBody;
  params[1] = opresult6861;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6864 = callmethodflags(call6863, "body(1)named(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6851);
// compiled call node returning call6864 (depth = 4)
  *var_metaObj = call6864;
  if (call6864 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6865 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objName (depth = 5)
  gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaObj (depth = 5)
  gc_frame_newslot(*var_metaObj);
// starting to compile member node (depth = 5)
  int callframe6866 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6867 = callmethodflags(*var_ast, "unknownType", 0, partcv, params, 0);
  gc_frame_end(callframe6866);
// compiled member node returning call6867 (depth = 5)
  gc_frame_newslot(call6867);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6868 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6869 = callmethodflags(*var_ast, "defDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe6868);
// compiled member node returning call6869 (depth = 5)
  params[0] = *var_objName;
  params[1] = *var_metaObj;
  params[2] = call6867;
  partcv[0] = 3;
  Object call6870 = callmethodflags(call6869, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe6865);
// compiled call node returning call6870 (depth = 4)
  *var_defDec = call6870;
  if (call6870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6871 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call6872 = callmethodflags(*var_defDec, "startToken:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6871);
// compiled call node returning call6872 (depth = 3)
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6873 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6874 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6875 == NULL) {
    strlit6875 = alloc_String("public");
    gc_root(strlit6875);
  }
// compiled string node returning strlit6875 (depth = 5)
  gc_frame_newslot(strlit6875);
// starting to compile identifier node (depth = 5)
  Object bool6876 = alloc_Boolean(0);
// compiled identifier node returning bool6876 (depth = 5)
  gc_frame_newslot(bool6876);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6877 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6878 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe6877);
// compiled member node returning call6878 (depth = 5)
  params[0] = strlit6875;
  params[1] = bool6876;
  partcv[0] = 2;
  Object call6879 = callmethodflags(call6878, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6874);
// compiled call node returning call6879 (depth = 4)
  gc_frame_newslot(call6879);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDec (depth = 5)
  Object call6881 = callmethodflags(*var_defDec, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6880);
// compiled member node returning call6881 (depth = 4)
  params[0] = call6879;
  partcv[0] = 1;
  Object call6882 = callmethodflags(call6881, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6873);
// compiled call node returning call6882 (depth = 3)
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6883 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  gc_frame_newslot(*var_defDec);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_defDec;
  partcv[0] = 1;
  Object call6884 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6883);
// compiled call node returning call6884 (depth = 3)
    gc_frame_newslot(call6884);
    if6800 = call6884;
  } else {
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6885 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6886 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call6887 = callmethodflags(*var_meth, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe6886);
// compiled member node returning call6887 (depth = 4)
  gc_frame_newslot(call6887);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call6887;
  partcv[0] = 1;
  Object call6888 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6885);
// compiled call node returning call6888 (depth = 3)
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6891 == NULL) {
    strlit6891 = alloc_String("class");
    gc_root(strlit6891);
  }
// compiled string node returning strlit6891 (depth = 5)
  int op_slot_right_6890 = gc_frame_newslot(strlit6891);
// starting to compile member node (depth = 5)
  int callframe6893 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call6894 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6893);
// compiled member node returning call6894 (depth = 5)
  int op_slot_left_6890 = gc_frame_newslot(call6894);
  params[0] = strlit6891;
  partcv[0] = 1;
  Object opresult6895 = callmethod(call6894, "==(1)", 1, partcv, params);
// compiled op node returning opresult6895 (depth = 4)
  Object if6889 = done;
  if (istrue(opresult6895)) {
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6896 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6897 = alloc_Boolean(1);
// compiled identifier node returning bool6897 (depth = 5)
  gc_frame_newslot(bool6897);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = bool6897;
  partcv[0] = 1;
  Object call6898 = callmethodflags(*var_objNode, "inClass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6896);
// compiled call node returning call6898 (depth = 4)
    gc_frame_newslot(call6898);
    if6889 = call6898;
  } else {
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6901 == NULL) {
    strlit6901 = alloc_String("trait");
    gc_root(strlit6901);
  }
// compiled string node returning strlit6901 (depth = 6)
  int op_slot_right_6900 = gc_frame_newslot(strlit6901);
// starting to compile member node (depth = 6)
  int callframe6903 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call6904 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6903);
// compiled member node returning call6904 (depth = 6)
  int op_slot_left_6900 = gc_frame_newslot(call6904);
  params[0] = strlit6901;
  partcv[0] = 1;
  Object opresult6905 = callmethod(call6904, "==(1)", 1, partcv, params);
// compiled op node returning opresult6905 (depth = 5)
  Object if6899 = done;
  if (istrue(opresult6905)) {
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6906 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool6907 = alloc_Boolean(1);
// compiled identifier node returning bool6907 (depth = 6)
  gc_frame_newslot(bool6907);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = bool6907;
  partcv[0] = 1;
  Object call6908 = callmethodflags(*var_objNode, "inTrait:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6906);
// compiled call node returning call6908 (depth = 5)
    gc_frame_newslot(call6908);
    if6899 = call6908;
  } else {
  }
// compiled if node returning if6899 (depth = 4)
    gc_frame_newslot(if6899);
    if6889 = if6899;
  }
// compiled if node returning if6889 (depth = 3)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6909 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6910 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6909);
// compiled call node returning call6910 (depth = 3)
    gc_frame_newslot(call6910);
    if6800 = call6910;
  }
// compiled if node returning if6800 (depth = 2)
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6911 = gc_frame_new();
// call case 4: self request
  Object call6912 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6911);
// compiled member node returning call6912 (depth = 2)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6918__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6920 == NULL) {
    strlit6920 = alloc_String("method");
    gc_root(strlit6920);
  }
// compiled string node returning strlit6920 (depth = 6)
  int op_slot_right_6919 = gc_frame_newslot(strlit6920);
// starting to compile member node (depth = 6)
  int callframe6922 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6923 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  Object call6924 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe6923);
// compiled member node returning call6924 (depth = 7)
  Object call6925 = callmethodflags(call6924, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6922);
// compiled member node returning call6925 (depth = 6)
  int op_slot_left_6919 = gc_frame_newslot(call6925);
  params[0] = strlit6920;
  partcv[0] = 1;
  Object opresult6926 = callmethod(call6925, "==(1)", 1, partcv, params);
// compiled op node returning opresult6926 (depth = 5)
  gc_frame_end(frame);
  return opresult6926;
}
Object meth_parser_6931__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6933 == NULL) {
    strlit6933 = alloc_String("keyword");
    gc_root(strlit6933);
  }
// compiled string node returning strlit6933 (depth = 7)
  int op_slot_right_6932 = gc_frame_newslot(strlit6933);
// starting to compile member node (depth = 7)
  int callframe6935 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call6937 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe6936);
// compiled member node returning call6937 (depth = 8)
  Object call6938 = callmethodflags(call6937, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6935);
// compiled member node returning call6938 (depth = 7)
  int op_slot_left_6932 = gc_frame_newslot(call6938);
  params[0] = strlit6933;
  partcv[0] = 1;
  Object opresult6939 = callmethod(call6938, "==(1)", 1, partcv, params);
// compiled op node returning opresult6939 (depth = 6)
  gc_frame_end(frame);
  return opresult6939;
}
Object meth_parser_6914_dofactoryMethod(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
  Object *var_meth = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "meth");
  Object *var_objNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "objNode");
// definebindings:
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6917 = alloc_Block(NULL, NULL, "parser", 2385);
  gc_frame_newslot(block6917);
// method "_apply"
  block_savedest(block6917);
  Object closure6918 = createclosure(2, "_apply");
  setclosureframe(closure6918, stackframe);
  addtoclosure(closure6918, var_tokens);
  addtoclosure(closure6918, selfslot);
  struct UserObject *uo6918 = (struct UserObject*)block6917;
  uo6918->data[0] = (Object)closure6918;
  Method *meth_meth_parser_6918__apply = addmethod2pos(block6917, "_apply", &meth_parser_6918__apply, 0);
  int argcv_meth_parser_6918__apply[] = {0};
  meth_meth_parser_6918__apply->type = alloc_MethodType(1, argcv_meth_parser_6918__apply);
  meth_meth_parser_6918__apply->definitionModule = modulename;
  meth_meth_parser_6918__apply->definitionLine = 3208;
// compiled block node returning block6917 (depth = 4)
  int op_slot_right_6916 = gc_frame_newslot(block6917);
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6930 = alloc_Block(NULL, NULL, "parser", 2384);
  gc_frame_newslot(block6930);
// method "_apply"
  block_savedest(block6930);
  Object closure6931 = createclosure(2, "_apply");
  setclosureframe(closure6931, stackframe);
  addtoclosure(closure6931, var_tokens);
  addtoclosure(closure6931, selfslot);
  struct UserObject *uo6931 = (struct UserObject*)block6930;
  uo6931->data[0] = (Object)closure6931;
  Method *meth_meth_parser_6931__apply = addmethod2pos(block6930, "_apply", &meth_parser_6931__apply, 0);
  int argcv_meth_parser_6931__apply[] = {0};
  meth_meth_parser_6931__apply->type = alloc_MethodType(1, argcv_meth_parser_6931__apply);
  meth_meth_parser_6931__apply->definitionModule = modulename;
  meth_meth_parser_6931__apply->definitionLine = 3208;
// compiled block node returning block6930 (depth = 5)
  int op_slot_right_6929 = gc_frame_newslot(block6930);
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6942 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6943 == NULL) {
    strlit6943 = alloc_String("factory");
    gc_root(strlit6943);
  }
// compiled string node returning strlit6943 (depth = 6)
  gc_frame_newslot(strlit6943);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit6943;
  partcv[0] = 1;
  Object call6944 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6942);
// compiled call node returning call6944 (depth = 5)
  int op_slot_left_6929 = gc_frame_newslot(call6944);
  params[0] = block6930;
  partcv[0] = 1;
  Object opresult6945 = callmethod(call6944, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6945 (depth = 4)
  int op_slot_left_6916 = gc_frame_newslot(opresult6945);
  params[0] = block6917;
  partcv[0] = 1;
  Object opresult6946 = callmethod(opresult6945, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6946 (depth = 3)
  Object if6915 = done;
  if (istrue(opresult6946)) {
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6947 = gc_frame_new();
// call case 4: self request
  Object call6948 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6947);
// compiled member node returning call6948 (depth = 3)
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6949 = gc_frame_new();
// call case 4: self request
  Object call6950 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6949);
// compiled member node returning call6950 (depth = 3)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6953 == NULL) {
    strlit6953 = alloc_String("identifier");
    gc_root(strlit6953);
  }
// compiled string node returning strlit6953 (depth = 5)
  int op_slot_right_6952 = gc_frame_newslot(strlit6953);
// starting to compile member node (depth = 5)
  int callframe6955 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6956 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6955);
// compiled member node returning call6956 (depth = 5)
  int op_slot_left_6952 = gc_frame_newslot(call6956);
  params[0] = strlit6953;
  partcv[0] = 1;
  Object opresult6957 = callmethod(call6956, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6957 (depth = 4)
  Object if6951 = done;
  if (istrue(opresult6957)) {
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array6958 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6958 (depth = 5)
  *var_suggestions = array6958;
  if (array6958 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6961 == NULL) {
    strlit6961 = alloc_String("lbrace");
    gc_root(strlit6961);
  }
// compiled string node returning strlit6961 (depth = 6)
  int op_slot_right_6960 = gc_frame_newslot(strlit6961);
// starting to compile member node (depth = 6)
  int callframe6963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6964 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6963);
// compiled member node returning call6964 (depth = 6)
  int op_slot_left_6960 = gc_frame_newslot(call6964);
  params[0] = strlit6961;
  partcv[0] = 1;
  Object opresult6965 = callmethod(call6964, "==(1)", 1, partcv, params);
// compiled op node returning opresult6965 (depth = 5)
  Object if6959 = done;
  if (istrue(opresult6965)) {
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6966 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6968 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6967);
// compiled member node returning call6968 (depth = 7)
  Object call6969 = callmethodflags(call6968, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6966);
// compiled member node returning call6969 (depth = 6)
  *var_suggestion = call6969;
  if (call6969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6970 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6971 == NULL) {
    strlit6971 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit6971);
  }
// compiled string node returning strlit6971 (depth = 6)
  gc_frame_newslot(strlit6971);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6971;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6972 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6970);
// compiled call node returning call6972 (depth = 5)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6973 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6974 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6973);
// compiled call node returning call6974 (depth = 5)
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6975 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6977 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6976);
// compiled member node returning call6977 (depth = 7)
  Object call6978 = callmethodflags(call6977, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6975);
// compiled member node returning call6978 (depth = 6)
  *var_suggestion = call6978;
  if (call6978 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6980 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit6981 == NULL) {
    strlit6981 = alloc_String("object");
    gc_root(strlit6981);
  }
// compiled string node returning strlit6981 (depth = 6)
  gc_frame_newslot(strlit6981);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit6981;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6982 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6980);
// compiled call node returning call6982 (depth = 5)
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6984 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6983);
// compiled call node returning call6984 (depth = 5)
    gc_frame_newslot(call6984);
    if6959 = call6984;
  } else {
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6985 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6986 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6987 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6986);
// compiled member node returning call6987 (depth = 7)
  Object call6988 = callmethodflags(call6987, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6985);
// compiled member node returning call6988 (depth = 6)
  *var_suggestion = call6988;
  if (call6988 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6989 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6990 == NULL) {
    strlit6990 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit6990);
  }
// compiled string node returning strlit6990 (depth = 6)
  gc_frame_newslot(strlit6990);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6990;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6991 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6989);
// compiled call node returning call6991 (depth = 5)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6992 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6993 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6992);
// compiled call node returning call6993 (depth = 5)
    gc_frame_newslot(call6993);
    if6959 = call6993;
  }
// compiled if node returning if6959 (depth = 4)
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6994 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6995 == NULL) {
    strlit6995 = alloc_String("a factory method must have a name after the 'method'.");
    gc_root(strlit6995);
  }
// compiled string node returning strlit6995 (depth = 5)
  gc_frame_newslot(strlit6995);
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6996 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6997 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6996);
// compiled member node returning call6997 (depth = 5)
  gc_frame_newslot(call6997);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6999 = alloc_Float64(1);
// compiled num node returning num6999 (depth = 6)
  int op_slot_right_6998 = gc_frame_newslot(num6999);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7003 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7002);
// compiled member node returning call7003 (depth = 7)
  int op_slot_right_7001 = gc_frame_newslot(call7003);
// starting to compile member node (depth = 7)
  int callframe7005 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7006 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7005);
// compiled member node returning call7006 (depth = 7)
  int op_slot_left_7001 = gc_frame_newslot(call7006);
  params[0] = call7003;
  partcv[0] = 1;
  Object sum7007 = callmethod(call7006, "+(1)", 1, partcv, params);
// compiled op node returning sum7007 (depth = 6)
  int op_slot_left_6998 = gc_frame_newslot(sum7007);
  params[0] = num6999;
  partcv[0] = 1;
  Object sum7008 = callmethod(sum7007, "+(1)", 1, partcv, params);
// compiled op node returning sum7008 (depth = 5)
  gc_frame_newslot(sum7008);
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6995;
  params[1] = call6997;
  params[2] = sum7008;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7009 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6994);
// compiled call node returning call7009 (depth = 4)
    gc_frame_newslot(call7009);
    if6951 = call7009;
  } else {
  }
// compiled if node returning if6951 (depth = 3)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7010 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7011 = alloc_Boolean(0);
// compiled identifier node returning bool7011 (depth = 5)
  gc_frame_newslot(bool7011);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = bool7011;
  partcv[0] = 1;
  Object call7012 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7010);
// compiled call node returning call7012 (depth = 4)
  *var_meth = call7012;
  if (call7012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7013 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7014 == NULL) {
    strlit7014 = alloc_String("a factory method");
    gc_root(strlit7014);
  }
// compiled string node returning strlit7014 (depth = 4)
  gc_frame_newslot(strlit7014);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 4)
  if (strlit7015 == NULL) {
    strlit7015 = alloc_String("method header");
    gc_root(strlit7015);
  }
// compiled string node returning strlit7015 (depth = 4)
  gc_frame_newslot(strlit7015);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7014;
  params[1] = *var_btok;
  params[2] = strlit7015;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7016 = callmethodflags(module_parser, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7013);
// compiled call node returning call7016 (depth = 3)
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7017 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call7018 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7017);
// compiled member node returning call7018 (depth = 4)
  *var_objNode = call7018;
  if (call7018 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7019 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call7021 = callmethodflags(*var_meth, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe7020);
// compiled member node returning call7021 (depth = 4)
  gc_frame_newslot(call7021);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call7021;
  partcv[0] = 1;
  Object call7022 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7019);
// compiled call node returning call7022 (depth = 3)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7023 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call7025 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7024);
// compiled member node returning call7025 (depth = 4)
  gc_frame_newslot(call7025);
// starting to compile member node (depth = 4)
  int callframe7026 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call7027 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7026);
// compiled member node returning call7027 (depth = 4)
  gc_frame_newslot(call7027);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7025;
  params[1] = call7027;
  partcv[0] = 2;
  Object call7028 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7023);
// compiled call node returning call7028 (depth = 3)
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7029 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array7030 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array7030, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7030 (depth = 4)
  gc_frame_newslot(array7030);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = array7030;
  partcv[0] = 1;
  Object call7031 = callmethodflags(*var_meth, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7029);
// compiled call node returning call7031 (depth = 3)
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7032 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  Object call7034 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7033);
// compiled member node returning call7034 (depth = 4)
  gc_frame_newslot(call7034);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call7036 = callmethodflags(*var_meth, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7035);
// compiled member node returning call7036 (depth = 4)
  params[0] = call7034;
  partcv[0] = 1;
  Object call7037 = callmethodflags(call7036, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7032);
// compiled call node returning call7037 (depth = 3)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7038 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call7039 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7038);
// compiled call node returning call7039 (depth = 3)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7040 = gc_frame_new();
// call case 4: self request
  Object call7041 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7040);
// compiled member node returning call7041 (depth = 3)
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6915 = done;
  } else {
  }
// compiled if node returning if6915 (depth = 2)
  gc_frame_end(frame);
  return if6915;
}
Object meth_parser_7096__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe7097 = gc_frame_new();
// call case 4: self request
  Object call7098 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled member node returning call7098 (depth = 8)
  gc_frame_end(frame);
  return call7098;
}
Object meth_parser_7093__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe7094 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7095 = alloc_Block(NULL, NULL, "parser", 2448);
  gc_frame_newslot(block7095);
// method "_apply"
  block_savedest(block7095);
  Object closure7096 = createclosure(1, "_apply");
  setclosureframe(closure7096, stackframe);
  addtoclosure(closure7096, selfslot);
  struct UserObject *uo7096 = (struct UserObject*)block7095;
  uo7096->data[0] = (Object)closure7096;
  Method *meth_meth_parser_7096__apply = addmethod2pos(block7095, "_apply", &meth_parser_7096__apply, 0);
  int argcv_meth_parser_7096__apply[] = {0};
  meth_meth_parser_7096__apply->type = alloc_MethodType(1, argcv_meth_parser_7096__apply);
  meth_meth_parser_7096__apply->definitionModule = modulename;
  meth_meth_parser_7096__apply->definitionLine = 3208;
// compiled block node returning block7095 (depth = 7)
  gc_frame_newslot(block7095);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block7095;
  partcv[0] = 1;
  Object call7100 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7094);
// compiled call node returning call7100 (depth = 6)
  gc_frame_end(frame);
  return call7100;
}
Object meth_parser_7103__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_parser_7043_methoddec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_minIndentLevel = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_methNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methNode");
  Object *var_localMin = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "localMin");
  Object *var_anns = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "anns");
  Object *var_originalValues = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "originalValues");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7045 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7046 == NULL) {
    strlit7046 = alloc_String("method");
    gc_root(strlit7046);
  }
// compiled string node returning strlit7046 (depth = 4)
  gc_frame_newslot(strlit7046);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7046;
  partcv[0] = 1;
  Object call7047 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7045);
// compiled call node returning call7047 (depth = 3)
  Object if7044 = done;
  if (istrue(call7047)) {
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7048 = gc_frame_new();
// call case 4: self request
  Object call7049 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7048);
// compiled member node returning call7049 (depth = 3)
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7051 = gc_frame_new();
// call case 4: self request
  Object call7052 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7051);
// compiled member node returning call7052 (depth = 3)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7053 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe7054 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool7055 = alloc_Boolean(0);
// compiled identifier node returning bool7055 (depth = 6)
  gc_frame_newslot(bool7055);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = bool7055;
  partcv[0] = 1;
  Object call7056 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7054);
// compiled call node returning call7056 (depth = 5)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call7057 = callmethodflags(call7056, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7053);
// compiled call node returning call7057 (depth = 4)
  *var_methNode = call7057;
  if (call7057 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7058 = gc_frame_new();
// call case 4: self request
  Object call7059 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7058);
// compiled member node returning call7059 (depth = 4)
  *var_anns = call7059;
  if (call7059 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7060 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7060 (depth = 4)
  *var_values = array7060;
  if (array7060 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7063 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7064 == NULL) {
    strlit7064 = alloc_String("lbrace");
    gc_root(strlit7064);
  }
// compiled string node returning strlit7064 (depth = 5)
  gc_frame_newslot(strlit7064);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit7064;
  partcv[0] = 1;
  Object call7065 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7063);
// compiled call node returning call7065 (depth = 4)
  Object if7062 = done;
  if (istrue(call7065)) {
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7066 = gc_frame_new();
// call case 4: self request
  Object call7067 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7066);
// compiled member node returning call7067 (depth = 4)
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call7072 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7071);
// compiled member node returning call7072 (depth = 6)
  int op_slot_right_7070 = gc_frame_newslot(call7072);
// starting to compile member node (depth = 6)
  int callframe7074 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7075 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7074);
// compiled member node returning call7075 (depth = 6)
  int op_slot_left_7070 = gc_frame_newslot(call7075);
  params[0] = call7072;
  partcv[0] = 1;
  Object opresult7076 = callmethod(call7075, "==(1)", 1, partcv, params);
// compiled op node returning opresult7076 (depth = 5)
  Object if7069 = done;
  if (istrue(opresult7076)) {
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7078 = alloc_Float64(1);
// compiled num node returning num7078 (depth = 7)
  int op_slot_right_7077 = gc_frame_newslot(num7078);
// starting to compile member node (depth = 7)
  int callframe7080 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7081 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7080);
// compiled member node returning call7081 (depth = 7)
  int op_slot_left_7077 = gc_frame_newslot(call7081);
  params[0] = num7078;
  partcv[0] = 1;
  Object diff7082 = callmethod(call7081, "-(1)", 1, partcv, params);
// compiled op node returning diff7082 (depth = 6)
  *var_minIndentLevel = diff7082;
  if (diff7082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7069 = done;
  } else {
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7085 = alloc_Float64(2);
// compiled num node returning num7085 (depth = 7)
  int op_slot_right_7084 = gc_frame_newslot(num7085);
// starting to compile member node (depth = 7)
  int callframe7087 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  Object call7088 = callmethodflags(*var_btok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe7087);
// compiled member node returning call7088 (depth = 7)
  int op_slot_left_7084 = gc_frame_newslot(call7088);
  params[0] = num7085;
  partcv[0] = 1;
  Object sum7089 = callmethod(call7088, "+(1)", 1, partcv, params);
// compiled op node returning sum7089 (depth = 6)
  *var_minIndentLevel = sum7089;
  if (sum7089 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7069 = done;
  }
// compiled if node returning if7069 (depth = 4)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7091 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7092 = alloc_Block(NULL, NULL, "parser", 2448);
  gc_frame_newslot(block7092);
// method "_apply"
  block_savedest(block7092);
  Object closure7093 = createclosure(1, "_apply");
  setclosureframe(closure7093, stackframe);
  addtoclosure(closure7093, selfslot);
  struct UserObject *uo7093 = (struct UserObject*)block7092;
  uo7093->data[0] = (Object)closure7093;
  Method *meth_meth_parser_7093__apply = addmethod2pos(block7092, "_apply", &meth_parser_7093__apply, 0);
  int argcv_meth_parser_7093__apply[] = {0};
  meth_meth_parser_7093__apply->type = alloc_MethodType(1, argcv_meth_parser_7093__apply);
  meth_meth_parser_7093__apply->definitionModule = modulename;
  meth_meth_parser_7093__apply->definitionLine = 3208;
// compiled block node returning block7092 (depth = 5)
  gc_frame_newslot(block7092);
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block7102 = alloc_Block(NULL, NULL, "parser", 2448);
  gc_frame_newslot(block7102);
// method "_apply"
  block_savedest(block7102);
  Object closure7103 = createclosure(1, "_apply");
  setclosureframe(closure7103, stackframe);
  addtoclosure(closure7103, selfslot);
  struct UserObject *uo7103 = (struct UserObject*)block7102;
  uo7103->data[0] = (Object)closure7103;
  Method *meth_meth_parser_7103__apply = addmethod2pos(block7102, "_apply", &meth_parser_7103__apply, 0);
  int argcv_meth_parser_7103__apply[] = {0};
  meth_meth_parser_7103__apply->type = alloc_MethodType(1, argcv_meth_parser_7103__apply);
  meth_meth_parser_7103__apply->definitionModule = modulename;
  meth_meth_parser_7103__apply->definitionLine = 3208;
// compiled block node returning block7102 (depth = 5)
  gc_frame_newslot(block7102);
// call case 5: prelude request
  params[0] = block7092;
  params[1] = block7102;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7105 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7091);
// compiled call node returning call7105 (depth = 4)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7108 == NULL) {
    strlit7108 = alloc_String("rbrace");
    gc_root(strlit7108);
  }
// compiled string node returning strlit7108 (depth = 6)
  int op_slot_right_7107 = gc_frame_newslot(strlit7108);
// starting to compile member node (depth = 6)
  int callframe7110 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7111 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7110);
// compiled member node returning call7111 (depth = 6)
  int op_slot_left_7107 = gc_frame_newslot(call7111);
  params[0] = strlit7108;
  partcv[0] = 1;
  Object opresult7112 = callmethod(call7111, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7112 (depth = 5)
  Object if7106 = done;
  if (istrue(opresult7112)) {
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7113 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7114 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call7115 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7114);
// compiled member node returning call7115 (depth = 7)
  Object call7116 = callmethodflags(call7115, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7113);
// compiled member node returning call7116 (depth = 6)
  *var_suggestion = call7116;
  if (call7116 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7117 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool7118 = alloc_Boolean(0);
// compiled identifier node returning bool7118 (depth = 7)
  gc_frame_newslot(bool7118);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool7118;
  partcv[0] = 2;
  Object call7119 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7117);
// compiled call node returning call7119 (depth = 6)
  *var_closingBrace = call7119;
  if (call7119 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7121 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call7123 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe7122);
// compiled member node returning call7123 (depth = 7)
  Object call7124 = callmethodflags(call7123, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7121);
// compiled member node returning call7124 (depth = 6)
  Object if7120 = done;
  if (istrue(call7124)) {
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7127 == NULL) {
    strlit7127 = alloc_String("eof");
    gc_root(strlit7127);
  }
// compiled string node returning strlit7127 (depth = 8)
  int op_slot_right_7126 = gc_frame_newslot(strlit7127);
// starting to compile member node (depth = 8)
  int callframe7129 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7130 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7129);
// compiled member node returning call7130 (depth = 8)
  int op_slot_left_7126 = gc_frame_newslot(call7130);
  params[0] = strlit7127;
  partcv[0] = 1;
  Object opresult7131 = callmethod(call7130, "==(1)", 1, partcv, params);
// compiled op node returning opresult7131 (depth = 7)
  Object if7125 = done;
  if (istrue(opresult7131)) {
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7132 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit7134 == NULL) {
    strlit7134 = alloc_String("a method declaration.");
    gc_root(strlit7134);
  }
// compiled string node returning strlit7134 (depth = 9)
  int op_slot_right_7133 = gc_frame_newslot(strlit7134);
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7137 == NULL) {
    strlit7137 = alloc_String("found while searching for the '}' to close ");
    gc_root(strlit7137);
  }
// compiled string node returning strlit7137 (depth = 10)
  int op_slot_right_7136 = gc_frame_newslot(strlit7137);
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7139 == NULL) {
    strlit7139 = alloc_String("end of program ");
    gc_root(strlit7139);
  }
// compiled string node returning strlit7139 (depth = 10)
  int op_slot_left_7136 = gc_frame_newslot(strlit7139);
  params[0] = strlit7137;
  partcv[0] = 1;
  Object opresult7140 = callmethod(strlit7139, "++(1)", 1, partcv, params);
// compiled op node returning opresult7140 (depth = 9)
  int op_slot_left_7133 = gc_frame_newslot(opresult7140);
  params[0] = strlit7134;
  partcv[0] = 1;
  Object opresult7141 = callmethod(opresult7140, "++(1)", 1, partcv, params);
// compiled op node returning opresult7141 (depth = 8)
  gc_frame_newslot(opresult7141);
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7142 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7143 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7142);
// compiled member node returning call7143 (depth = 8)
  gc_frame_newslot(call7143);
// starting to compile member node (depth = 8)
  int callframe7144 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7145 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7144);
// compiled member node returning call7145 (depth = 8)
  gc_frame_newslot(call7145);
// call case 6: other requests
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7141;
  params[1] = call7143;
  params[2] = call7145;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7146 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7132);
// compiled call node returning call7146 (depth = 7)
    gc_frame_newslot(call7146);
    if7125 = call7146;
  } else {
  }
// compiled if node returning if7125 (depth = 6)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_7148 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe7150 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call7151 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe7150);
// compiled member node returning call7151 (depth = 8)
  int op_slot_left_7148 = gc_frame_newslot(call7151);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7152 = callmethod(call7151, "==(1)", 1, partcv, params);
// compiled op node returning opresult7152 (depth = 7)
  Object if7147 = done;
  if (istrue(opresult7152)) {
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7153 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7154 == NULL) {
    strlit7154 = alloc_String("}");
    gc_root(strlit7154);
  }
// compiled string node returning strlit7154 (depth = 8)
  gc_frame_newslot(strlit7154);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit7154;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7155 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7153);
// compiled call node returning call7155 (depth = 7)
    gc_frame_newslot(call7155);
    if7147 = call7155;
  } else {
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7156 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7158 = alloc_Float64(0.1);
// compiled num node returning num7158 (depth = 9)
  int op_slot_right_7157 = gc_frame_newslot(num7158);
// starting to compile member node (depth = 9)
  int callframe7160 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call7162 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe7161);
// compiled member node returning call7162 (depth = 10)
  Object call7163 = callmethodflags(call7162, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7160);
// compiled member node returning call7163 (depth = 9)
  int op_slot_left_7157 = gc_frame_newslot(call7163);
  params[0] = num7158;
  partcv[0] = 1;
  Object sum7164 = callmethod(call7163, "+(1)", 1, partcv, params);
// compiled op node returning sum7164 (depth = 8)
  gc_frame_newslot(sum7164);
// starting to compile string node (depth = 8)
  if (strlit7165 == NULL) {
    strlit7165 = alloc_String("}");
    gc_root(strlit7165);
  }
// compiled string node returning strlit7165 (depth = 8)
  gc_frame_newslot(strlit7165);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum7164;
  params[1] = strlit7165;
  partcv[0] = 2;
  Object call7166 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7156);
// compiled call node returning call7166 (depth = 7)
    gc_frame_newslot(call7166);
    if7147 = call7166;
  }
// compiled if node returning if7147 (depth = 6)
    gc_frame_newslot(if7147);
    if7120 = if7147;
  } else {
  }
// compiled if node returning if7120 (depth = 5)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7167 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call7168 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7167);
// compiled call node returning call7168 (depth = 5)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7169 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7170 == NULL) {
    strlit7170 = alloc_String("a method must end with a '}'.");
    gc_root(strlit7170);
  }
// compiled string node returning strlit7170 (depth = 6)
  gc_frame_newslot(strlit7170);
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7171 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7172 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7171);
// compiled member node returning call7172 (depth = 6)
  gc_frame_newslot(call7172);
// starting to compile member node (depth = 6)
  int callframe7173 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7174 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7173);
// compiled member node returning call7174 (depth = 6)
  gc_frame_newslot(call7174);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7170;
  params[1] = call7172;
  params[2] = call7174;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7175 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7169);
// compiled call node returning call7175 (depth = 5)
    gc_frame_newslot(call7175);
    if7106 = call7175;
  } else {
  }
// compiled if node returning if7106 (depth = 4)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7176 = gc_frame_new();
// call case 4: self request
  Object call7177 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7176);
// compiled member node returning call7177 (depth = 4)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7062 = done;
  } else {
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7179 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7180 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7181 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7180);
// compiled member node returning call7181 (depth = 6)
  Object call7182 = callmethodflags(call7181, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7179);
// compiled member node returning call7182 (depth = 5)
  *var_suggestion = call7182;
  if (call7182 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7183 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool7184 = alloc_Boolean(1);
// compiled identifier node returning bool7184 (depth = 6)
  gc_frame_newslot(bool7184);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_btok;
  params[1] = bool7184;
  partcv[0] = 2;
  Object call7185 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7183);
// compiled call node returning call7185 (depth = 5)
  *var_closingBrace = call7185;
  if (call7185 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7187 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7188 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_closingBrace (depth = 7)
  Object call7189 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe7188);
// compiled member node returning call7189 (depth = 6)
  Object call7190 = callmethodflags(call7189, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7187);
// compiled member node returning call7190 (depth = 5)
  Object if7186 = done;
  if (istrue(call7190)) {
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_7192 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe7194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call7195 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe7194);
// compiled member node returning call7195 (depth = 7)
  int op_slot_left_7192 = gc_frame_newslot(call7195);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult7196 = callmethod(call7195, "==(1)", 1, partcv, params);
// compiled op node returning opresult7196 (depth = 6)
  Object if7191 = done;
  if (istrue(opresult7196)) {
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7197 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7198 == NULL) {
    strlit7198 = alloc_String(" {}");
    gc_root(strlit7198);
  }
// compiled string node returning strlit7198 (depth = 7)
  gc_frame_newslot(strlit7198);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool7199 = alloc_Boolean(1);
// compiled identifier node returning bool7199 (depth = 7)
  gc_frame_newslot(bool7199);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7198;
  params[1] = *var_lastToken;
  params[2] = bool7199;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7200 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7197);
// compiled call node returning call7200 (depth = 6)
    gc_frame_newslot(call7200);
    if7191 = call7200;
  } else {
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7201 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7203 = alloc_Float64(0.1);
// compiled num node returning num7203 (depth = 8)
  int op_slot_right_7202 = gc_frame_newslot(num7203);
// starting to compile member node (depth = 8)
  int callframe7205 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7206 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call7207 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe7206);
// compiled member node returning call7207 (depth = 9)
  Object call7208 = callmethodflags(call7207, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7205);
// compiled member node returning call7208 (depth = 8)
  int op_slot_left_7202 = gc_frame_newslot(call7208);
  params[0] = num7203;
  partcv[0] = 1;
  Object sum7209 = callmethod(call7208, "+(1)", 1, partcv, params);
// compiled op node returning sum7209 (depth = 7)
  gc_frame_newslot(sum7209);
// starting to compile string node (depth = 7)
  if (strlit7210 == NULL) {
    strlit7210 = alloc_String("}");
    gc_root(strlit7210);
  }
// compiled string node returning strlit7210 (depth = 7)
  gc_frame_newslot(strlit7210);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum7209;
  params[1] = strlit7210;
  partcv[0] = 2;
  Object call7211 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7201);
// compiled call node returning call7211 (depth = 6)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7212 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7213 == NULL) {
    strlit7213 = alloc_String(" {");
    gc_root(strlit7213);
  }
// compiled string node returning strlit7213 (depth = 7)
  gc_frame_newslot(strlit7213);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool7214 = alloc_Boolean(1);
// compiled identifier node returning bool7214 (depth = 7)
  gc_frame_newslot(bool7214);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7213;
  params[1] = *var_lastToken;
  params[2] = bool7214;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7215 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7212);
// compiled call node returning call7215 (depth = 6)
    gc_frame_newslot(call7215);
    if7191 = call7215;
  }
// compiled if node returning if7191 (depth = 5)
    gc_frame_newslot(if7191);
    if7186 = if7191;
  } else {
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7216 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7217 == NULL) {
    strlit7217 = alloc_String(" {");
    gc_root(strlit7217);
  }
// compiled string node returning strlit7217 (depth = 6)
  gc_frame_newslot(strlit7217);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool7218 = alloc_Boolean(1);
// compiled identifier node returning bool7218 (depth = 6)
  gc_frame_newslot(bool7218);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7217;
  params[1] = *var_lastToken;
  params[2] = bool7218;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7219 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7216);
// compiled call node returning call7219 (depth = 5)
    gc_frame_newslot(call7219);
    if7186 = call7219;
  }
// compiled if node returning if7186 (depth = 4)
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7220 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7221 == NULL) {
    strlit7221 = alloc_String("a method must have a '{' after the name.");
    gc_root(strlit7221);
  }
// compiled string node returning strlit7221 (depth = 5)
  gc_frame_newslot(strlit7221);
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7222 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7223 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7222);
// compiled member node returning call7223 (depth = 5)
  gc_frame_newslot(call7223);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7226 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7225);
// compiled member node returning call7226 (depth = 6)
  int op_slot_right_7224 = gc_frame_newslot(call7226);
// starting to compile member node (depth = 6)
  int callframe7228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7229 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7228);
// compiled member node returning call7229 (depth = 6)
  int op_slot_left_7224 = gc_frame_newslot(call7229);
  params[0] = call7226;
  partcv[0] = 1;
  Object sum7230 = callmethod(call7229, "+(1)", 1, partcv, params);
// compiled op node returning sum7230 (depth = 5)
  gc_frame_newslot(sum7230);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7221;
  params[1] = call7223;
  params[2] = sum7230;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7231 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7220);
// compiled call node returning call7231 (depth = 4)
    gc_frame_newslot(call7231);
    if7062 = call7231;
  }
// compiled if node returning if7062 (depth = 3)
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7232 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call7233 = callmethodflags(*var_methNode, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7232);
// compiled call node returning call7233 (depth = 3)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_originalValues (depth = 4)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7235 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7236 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call7237 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7236);
// compiled member node returning call7237 (depth = 4)
  gc_frame_newslot(call7237);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7237;
  partcv[0] = 1;
  Object call7238 = callmethodflags(*var_util, "setline(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7235);
// compiled call node returning call7238 (depth = 3)
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_7240 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool7242 = alloc_Boolean(0);
// compiled identifier node returning bool7242 (depth = 5)
  int op_slot_left_7240 = gc_frame_newslot(bool7242);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7243 = callmethod(bool7242, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7243 (depth = 4)
  Object if7239 = done;
  if (istrue(opresult7243)) {
// starting to compile call node (depth = 4)
  int callframe7244 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7245 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  Object call7246 = callmethodflags(*var_methNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7245);
// compiled member node returning call7246 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7247 = callmethodflags(call7246, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7244);
// compiled call node returning call7247 (depth = 4)
    gc_frame_newslot(call7247);
    if7239 = call7247;
  } else {
  }
// compiled if node returning if7239 (depth = 3)
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7248 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  gc_frame_newslot(*var_methNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_methNode;
  partcv[0] = 1;
  Object call7249 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7248);
// compiled call node returning call7249 (depth = 3)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7250 = gc_frame_new();
// call case 4: self request
  Object call7251 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7250);
// compiled member node returning call7251 (depth = 3)
    gc_frame_newslot(call7251);
    if7044 = call7251;
  } else {
  }
// compiled if node returning if7044 (depth = 2)
  gc_frame_end(frame);
  return if7044;
}
Object meth_parser_7257__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7259 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7260 == NULL) {
    strlit7260 = alloc_String("identifier");
    gc_root(strlit7260);
  }
// compiled string node returning strlit7260 (depth = 6)
  gc_frame_newslot(strlit7260);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7260;
  partcv[0] = 1;
  Object call7261 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7259);
// compiled call node returning call7261 (depth = 5)
  int op_slot_right_7258 = gc_frame_newslot(call7261);
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7264 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7265 == NULL) {
    strlit7265 = alloc_String("identifier");
    gc_root(strlit7265);
  }
// compiled string node returning strlit7265 (depth = 7)
  gc_frame_newslot(strlit7265);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7265;
  partcv[0] = 1;
  Object call7266 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7264);
// compiled call node returning call7266 (depth = 6)
  int op_slot_right_7263 = gc_frame_newslot(call7266);
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call7269 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7268);
// compiled call node returning call7269 (depth = 6)
  int op_slot_left_7263 = gc_frame_newslot(call7269);
  params[0] = call7266;
  partcv[0] = 1;
  Object opresult7270 = callmethod(call7269, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7270 (depth = 5)
  int op_slot_left_7258 = gc_frame_newslot(opresult7270);
  params[0] = call7261;
  partcv[0] = 1;
  Object opresult7271 = callmethod(opresult7270, "||(1)", 1, partcv, params);
// compiled op node returning opresult7271 (depth = 4)
  gc_frame_end(frame);
  return opresult7271;
}
Object meth_parser_7314__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7318 == NULL) {
    strlit7318 = alloc_String("*");
    gc_root(strlit7318);
  }
// compiled string node returning strlit7318 (depth = 9)
  int op_slot_right_7317 = gc_frame_newslot(strlit7318);
// starting to compile member node (depth = 9)
  int callframe7320 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call7321 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7320);
// compiled member node returning call7321 (depth = 9)
  int op_slot_left_7317 = gc_frame_newslot(call7321);
  params[0] = strlit7318;
  partcv[0] = 1;
  Object opresult7322 = callmethod(call7321, "==(1)", 1, partcv, params);
// compiled op node returning opresult7322 (depth = 8)
  int op_slot_right_7316 = gc_frame_newslot(opresult7322);
// starting to compile call node (depth = 8)
  int callframe7324 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7325 == NULL) {
    strlit7325 = alloc_String("op");
    gc_root(strlit7325);
  }
// compiled string node returning strlit7325 (depth = 9)
  gc_frame_newslot(strlit7325);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit7325;
  partcv[0] = 1;
  Object call7326 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7324);
// compiled call node returning call7326 (depth = 8)
  int op_slot_left_7316 = gc_frame_newslot(call7326);
  params[0] = opresult7322;
  partcv[0] = 1;
  Object opresult7327 = callmethod(call7326, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7327 (depth = 7)
  int op_slot_right_7315 = gc_frame_newslot(opresult7327);
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7329 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7330 == NULL) {
    strlit7330 = alloc_String("identifier");
    gc_root(strlit7330);
  }
// compiled string node returning strlit7330 (depth = 8)
  gc_frame_newslot(strlit7330);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7330;
  partcv[0] = 1;
  Object call7331 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7329);
// compiled call node returning call7331 (depth = 7)
  int op_slot_left_7315 = gc_frame_newslot(call7331);
  params[0] = opresult7327;
  partcv[0] = 1;
  Object opresult7332 = callmethod(call7331, "||(1)", 1, partcv, params);
// compiled op node returning opresult7332 (depth = 6)
  gc_frame_end(frame);
  return opresult7332;
}
Object meth_parser_7335__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_part = getfromclosure(closure, 4);
  Object *var_comma = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nxt = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "nxt");
// definebindings:
// definebindings:
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7337 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7338 == NULL) {
    strlit7338 = alloc_String("op");
    gc_root(strlit7338);
  }
// compiled string node returning strlit7338 (depth = 8)
  gc_frame_newslot(strlit7338);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7338;
  partcv[0] = 1;
  Object call7339 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7337);
// compiled call node returning call7339 (depth = 7)
  Object if7336 = done;
  if (istrue(call7339)) {
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7340 = gc_frame_new();
// call case 4: self request
  Object call7341 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7340);
// compiled member node returning call7341 (depth = 7)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7342 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7344 == NULL) {
    strlit7344 = alloc_String(" an Iterable.");
    gc_root(strlit7344);
  }
// compiled string node returning strlit7344 (depth = 9)
  int op_slot_right_7343 = gc_frame_newslot(strlit7344);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7347 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call7348 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7347);
// compiled member node returning call7348 (depth = 10)
  int op_slot_right_7346 = gc_frame_newslot(call7348);
// starting to compile string node (depth = 10)
  if (strlit7350 == NULL) {
    strlit7350 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit7350);
  }
// compiled string node returning strlit7350 (depth = 10)
  int op_slot_left_7346 = gc_frame_newslot(strlit7350);
  params[0] = call7348;
  partcv[0] = 1;
  Object opresult7351 = callmethod(strlit7350, "++(1)", 1, partcv, params);
// compiled op node returning opresult7351 (depth = 9)
  int op_slot_left_7343 = gc_frame_newslot(opresult7351);
  params[0] = strlit7344;
  partcv[0] = 1;
  Object opresult7352 = callmethod(opresult7351, "++(1)", 1, partcv, params);
// compiled op node returning opresult7352 (depth = 8)
  gc_frame_newslot(opresult7352);
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7353 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7354 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7353);
// compiled member node returning call7354 (depth = 8)
  gc_frame_newslot(call7354);
// starting to compile member node (depth = 8)
  int callframe7355 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7356 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7355);
// compiled member node returning call7356 (depth = 8)
  gc_frame_newslot(call7356);
// call case 6: other requests
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7352;
  params[1] = call7354;
  params[2] = call7356;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7357 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7342);
// compiled call node returning call7357 (depth = 7)
    gc_frame_newslot(call7357);
    if7336 = call7357;
  } else {
  }
// compiled if node returning if7336 (depth = 6)
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7358 = gc_frame_new();
// call case 4: self request
  Object call7359 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7358);
// compiled member node returning call7359 (depth = 6)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7360 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call7361 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7360);
// compiled member node returning call7361 (depth = 7)
  *var_nxt = call7361;
  if (call7361 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7362 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool7363 = alloc_Boolean(1);
// compiled identifier node returning bool7363 (depth = 7)
  gc_frame_newslot(bool7363);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = bool7363;
  partcv[0] = 1;
  Object call7364 = callmethodflags(*var_nxt, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7362);
// compiled call node returning call7364 (depth = 6)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7365 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe7366 = gc_frame_new();
// call case 4: self request
  Object call7367 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7366);
// compiled member node returning call7367 (depth = 7)
  gc_frame_newslot(call7367);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = call7367;
  partcv[0] = 1;
  Object call7368 = callmethodflags(*var_nxt, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7365);
// compiled call node returning call7368 (depth = 6)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7369 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  gc_frame_newslot(*var_nxt);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call7371 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe7370);
// compiled member node returning call7371 (depth = 7)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7372 = callmethodflags(call7371, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7369);
// compiled call node returning call7372 (depth = 6)
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7374 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7375 == NULL) {
    strlit7375 = alloc_String("comma");
    gc_root(strlit7375);
  }
// compiled string node returning strlit7375 (depth = 8)
  gc_frame_newslot(strlit7375);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7375;
  partcv[0] = 1;
  Object call7376 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7374);
// compiled call node returning call7376 (depth = 7)
  Object if7373 = done;
  if (istrue(call7376)) {
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7378 = gc_frame_new();
// call case 4: self request
  Object call7379 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7378);
// compiled member node returning call7379 (depth = 7)
    gc_frame_newslot(call7379);
    if7373 = call7379;
  } else {
  }
// compiled if node returning if7373 (depth = 6)
  gc_frame_end(frame);
  return if7373;
}
Object meth_parser_7274__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_signature = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
  Object *var_comma = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "comma");
// definebindings:
// definebindings:
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7275 = gc_frame_new();
// call case 4: self request
  Object call7276 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7275);
// compiled member node returning call7276 (depth = 4)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7277 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe7278 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call7280 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7279);
// compiled member node returning call7280 (depth = 7)
  Object call7281 = callmethodflags(call7280, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe7278);
// compiled member node returning call7281 (depth = 6)
  gc_frame_newslot(call7281);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call7283 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe7282);
// compiled member node returning call7283 (depth = 6)
  params[0] = call7281;
  partcv[0] = 1;
  Object call7284 = callmethodflags(call7283, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7277);
// compiled call node returning call7284 (depth = 5)
  *var_part = call7284;
  if (call7284 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7286 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe7287 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7288 == NULL) {
    strlit7288 = alloc_String("lparen");
    gc_root(strlit7288);
  }
// compiled string node returning strlit7288 (depth = 7)
  gc_frame_newslot(strlit7288);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7288;
  partcv[0] = 1;
  Object call7289 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7287);
// compiled call node returning call7289 (depth = 6)
  Object call7290 = callmethodflags(call7289, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7286);
// compiled member node returning call7290 (depth = 5)
  Object if7285 = done;
  if (istrue(call7290)) {
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7291 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call7293 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7292);
// compiled member node returning call7293 (depth = 7)
  Object call7294 = callmethodflags(call7293, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7291);
// compiled member node returning call7294 (depth = 6)
  *var_suggestion = call7294;
  if (call7294 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7295 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7296 == NULL) {
    strlit7296 = alloc_String("()");
    gc_root(strlit7296);
  }
// compiled string node returning strlit7296 (depth = 6)
  gc_frame_newslot(strlit7296);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7296;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7297 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7295);
// compiled call node returning call7297 (depth = 5)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7298 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7300 == NULL) {
    strlit7300 = alloc_String("parameter lists must have parentheses around each parameter list.");
    gc_root(strlit7300);
  }
// compiled string node returning strlit7300 (depth = 7)
  int op_slot_right_7299 = gc_frame_newslot(strlit7300);
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7302 == NULL) {
    strlit7302 = alloc_String("the declaration of a method with multiple ");
    gc_root(strlit7302);
  }
// compiled string node returning strlit7302 (depth = 7)
  int op_slot_left_7299 = gc_frame_newslot(strlit7302);
  params[0] = strlit7300;
  partcv[0] = 1;
  Object opresult7303 = callmethod(strlit7302, "++(1)", 1, partcv, params);
// compiled op node returning opresult7303 (depth = 6)
  gc_frame_newslot(opresult7303);
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7304 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7305 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7304);
// compiled member node returning call7305 (depth = 6)
  gc_frame_newslot(call7305);
// starting to compile member node (depth = 6)
  int callframe7306 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7307 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7306);
// compiled member node returning call7307 (depth = 6)
  gc_frame_newslot(call7307);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7303;
  params[1] = call7305;
  params[2] = call7307;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7308 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7298);
// compiled call node returning call7308 (depth = 5)
    gc_frame_newslot(call7308);
    if7285 = call7308;
  } else {
  }
// compiled if node returning if7285 (depth = 4)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7309 = gc_frame_new();
// call case 4: self request
  Object call7310 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7309);
// compiled member node returning call7310 (depth = 4)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7311 = alloc_Boolean(0);
// compiled identifier node returning bool7311 (depth = 5)
  *var_comma = bool7311;
  if (bool7311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7312 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7313 = alloc_Block(NULL, NULL, "parser", 2519);
  gc_frame_newslot(block7313);
// method "_apply"
  block_savedest(block7313);
  Object closure7314 = createclosure(2, "_apply");
  setclosureframe(closure7314, stackframe);
  addtoclosure(closure7314, var_sym);
  addtoclosure(closure7314, selfslot);
  struct UserObject *uo7314 = (struct UserObject*)block7313;
  uo7314->data[0] = (Object)closure7314;
  Method *meth_meth_parser_7314__apply = addmethod2pos(block7313, "_apply", &meth_parser_7314__apply, 0);
  int argcv_meth_parser_7314__apply[] = {0};
  meth_meth_parser_7314__apply->type = alloc_MethodType(1, argcv_meth_parser_7314__apply);
  meth_meth_parser_7314__apply->definitionModule = modulename;
  meth_meth_parser_7314__apply->definitionLine = 3208;
// compiled block node returning block7313 (depth = 5)
  gc_frame_newslot(block7313);
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block7334 = alloc_Block(NULL, NULL, "parser", 2520);
  gc_frame_newslot(block7334);
// method "_apply"
  block_savedest(block7334);
  Object closure7335 = createclosure(7, "_apply");
  setclosureframe(closure7335, stackframe);
  addtoclosure(closure7335, var_sym);
  addtoclosure(closure7335, var_lastToken);
  addtoclosure(closure7335, var_errormessages);
  addtoclosure(closure7335, var_values);
  addtoclosure(closure7335, var_part);
  addtoclosure(closure7335, var_comma);
  addtoclosure(closure7335, selfslot);
  struct UserObject *uo7335 = (struct UserObject*)block7334;
  uo7335->data[0] = (Object)closure7335;
  Method *meth_meth_parser_7335__apply = addmethod2pos(block7334, "_apply", &meth_parser_7335__apply, 0);
  int argcv_meth_parser_7335__apply[] = {0};
  meth_meth_parser_7335__apply->type = alloc_MethodType(1, argcv_meth_parser_7335__apply);
  meth_meth_parser_7335__apply->definitionModule = modulename;
  meth_meth_parser_7335__apply->definitionLine = 3208;
// compiled block node returning block7334 (depth = 5)
  gc_frame_newslot(block7334);
// call case 5: prelude request
  params[0] = block7313;
  params[1] = block7334;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7381 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7312);
// compiled call node returning call7381 (depth = 4)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7384 == NULL) {
    strlit7384 = alloc_String("rparen");
    gc_root(strlit7384);
  }
// compiled string node returning strlit7384 (depth = 6)
  int op_slot_right_7383 = gc_frame_newslot(strlit7384);
// starting to compile member node (depth = 6)
  int callframe7386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7387 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7386);
// compiled member node returning call7387 (depth = 6)
  int op_slot_left_7383 = gc_frame_newslot(call7387);
  params[0] = strlit7384;
  partcv[0] = 1;
  Object opresult7388 = callmethod(call7387, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7388 (depth = 5)
  Object if7382 = done;
  if (istrue(opresult7388)) {
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7389 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call7391 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7390);
// compiled member node returning call7391 (depth = 7)
  Object call7392 = callmethodflags(call7391, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7389);
// compiled member node returning call7392 (depth = 6)
  *var_suggestion = call7392;
  if (call7392 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7393 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7394 == NULL) {
    strlit7394 = alloc_String(")");
    gc_root(strlit7394);
  }
// compiled string node returning strlit7394 (depth = 6)
  gc_frame_newslot(strlit7394);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7394;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7395 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7393);
// compiled call node returning call7395 (depth = 5)
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7396 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7397 == NULL) {
    strlit7397 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit7397);
  }
// compiled string node returning strlit7397 (depth = 6)
  gc_frame_newslot(strlit7397);
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7398 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7399 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7398);
// compiled member node returning call7399 (depth = 6)
  gc_frame_newslot(call7399);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7401 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7402 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7401);
// compiled member node returning call7402 (depth = 7)
  int op_slot_right_7400 = gc_frame_newslot(call7402);
// starting to compile member node (depth = 7)
  int callframe7404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7405 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7404);
// compiled member node returning call7405 (depth = 7)
  int op_slot_left_7400 = gc_frame_newslot(call7405);
  params[0] = call7402;
  partcv[0] = 1;
  Object sum7406 = callmethod(call7405, "+(1)", 1, partcv, params);
// compiled op node returning sum7406 (depth = 6)
  gc_frame_newslot(sum7406);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7397;
  params[1] = call7399;
  params[2] = sum7406;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7407 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7396);
// compiled call node returning call7407 (depth = 5)
    gc_frame_newslot(call7407);
    if7382 = call7407;
  } else {
  }
// compiled if node returning if7382 (depth = 4)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7408 = gc_frame_new();
// call case 4: self request
  Object call7409 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7408);
// compiled member node returning call7409 (depth = 4)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7410 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call7411 = callmethodflags(*var_signature, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7410);
// compiled call node returning call7411 (depth = 4)
  gc_frame_end(frame);
  return call7411;
}
Object meth_parser_7252_methodDecRest_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodDecRest(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method methodDecRest(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodDecRest(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part methodDecRest(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_signature = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "signature");
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe7253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tm (depth = 4)
  Object call7254 = callmethodflags(*var_tm, "signature", 0, partcv, params, 0);
  gc_frame_end(callframe7253);
// compiled member node returning call7254 (depth = 3)
  *var_signature = call7254;
  if (call7254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7255 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7256 = alloc_Block(NULL, NULL, "parser", 2507);
  gc_frame_newslot(block7256);
// method "_apply"
  block_savedest(block7256);
  Object closure7257 = createclosure(2, "_apply");
  setclosureframe(closure7257, stackframe);
  addtoclosure(closure7257, var_sameline);
  addtoclosure(closure7257, selfslot);
  struct UserObject *uo7257 = (struct UserObject*)block7256;
  uo7257->data[0] = (Object)closure7257;
  Method *meth_meth_parser_7257__apply = addmethod2pos(block7256, "_apply", &meth_parser_7257__apply, 0);
  int argcv_meth_parser_7257__apply[] = {0};
  meth_meth_parser_7257__apply->type = alloc_MethodType(1, argcv_meth_parser_7257__apply);
  meth_meth_parser_7257__apply->definitionModule = modulename;
  meth_meth_parser_7257__apply->definitionLine = 3208;
// compiled block node returning block7256 (depth = 3)
  gc_frame_newslot(block7256);
// starting to compile block node (depth = 3)
  Object block7273 = alloc_Block(NULL, NULL, "parser", 2507);
  gc_frame_newslot(block7273);
// method "_apply"
  block_savedest(block7273);
  Object closure7274 = createclosure(7, "_apply");
  setclosureframe(closure7274, stackframe);
  addtoclosure(closure7274, var_values);
  addtoclosure(closure7274, var_ast);
  addtoclosure(closure7274, var_errormessages);
  addtoclosure(closure7274, var_lastToken);
  addtoclosure(closure7274, var_sym);
  addtoclosure(closure7274, var_signature);
  addtoclosure(closure7274, selfslot);
  struct UserObject *uo7274 = (struct UserObject*)block7273;
  uo7274->data[0] = (Object)closure7274;
  Method *meth_meth_parser_7274__apply = addmethod2pos(block7273, "_apply", &meth_parser_7274__apply, 0);
  int argcv_meth_parser_7274__apply[] = {0};
  meth_meth_parser_7274__apply->type = alloc_MethodType(1, argcv_meth_parser_7274__apply);
  meth_meth_parser_7274__apply->definitionModule = modulename;
  meth_meth_parser_7274__apply->definitionLine = 3208;
// compiled block node returning block7273 (depth = 3)
  gc_frame_newslot(block7273);
// call case 5: prelude request
  params[0] = block7256;
  params[1] = block7273;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7413 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7255);
// compiled call node returning call7413 (depth = 2)
  gc_frame_end(frame);
  return call7413;
}
Object meth_parser_7424__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe7425 = gc_frame_new();
// call case 4: self request
  Object call7426 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7425);
// compiled member node returning call7426 (depth = 6)
  gc_frame_end(frame);
  return call7426;
}
Object meth_parser_7414_optionalTypeAnnotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7416 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7417 == NULL) {
    strlit7417 = alloc_String("colon");
    gc_root(strlit7417);
  }
// compiled string node returning strlit7417 (depth = 4)
  gc_frame_newslot(strlit7417);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7417;
  partcv[0] = 1;
  Object call7418 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7416);
// compiled call node returning call7418 (depth = 3)
  Object if7415 = done;
  if (istrue(call7418)) {
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7419 = gc_frame_new();
// call case 4: self request
  Object call7420 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7419);
// compiled member node returning call7420 (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7422 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7423 = alloc_Block(NULL, NULL, "parser", 2552);
  gc_frame_newslot(block7423);
// method "_apply"
  block_savedest(block7423);
  Object closure7424 = createclosure(1, "_apply");
  setclosureframe(closure7424, stackframe);
  addtoclosure(closure7424, selfslot);
  struct UserObject *uo7424 = (struct UserObject*)block7423;
  uo7424->data[0] = (Object)closure7424;
  Method *meth_meth_parser_7424__apply = addmethod2pos(block7423, "_apply", &meth_parser_7424__apply, 0);
  int argcv_meth_parser_7424__apply[] = {0};
  meth_meth_parser_7424__apply->type = alloc_MethodType(1, argcv_meth_parser_7424__apply);
  meth_meth_parser_7424__apply->definitionModule = modulename;
  meth_meth_parser_7424__apply->definitionLine = 3208;
// compiled block node returning block7423 (depth = 5)
  gc_frame_newslot(block7423);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block7423;
  partcv[0] = 1;
  Object call7428 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7422);
// compiled call node returning call7428 (depth = 4)
  Object if7421 = done;
  if (istrue(call7428)) {
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call7430 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7429);
// compiled member node returning call7430 (depth = 4)
    gc_frame_newslot(call7430);
    if7421 = call7430;
  } else {
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7431 = gc_frame_new();
// call case 4: self request
  Object call7432 = callmethodflags(self, "checkBadTypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7431);
// compiled member node returning call7432 (depth = 4)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array7433 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7433 (depth = 5)
  *var_suggestions = array7433;
  if (array7433 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7434 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7436 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7435);
// compiled member node returning call7436 (depth = 6)
  Object call7437 = callmethodflags(call7436, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7434);
// compiled member node returning call7437 (depth = 5)
  *var_suggestion = call7437;
  if (call7437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7438 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7439 == NULL) {
    strlit7439 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit7439);
  }
// compiled string node returning strlit7439 (depth = 5)
  gc_frame_newslot(strlit7439);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7439;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7440 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7438);
// compiled call node returning call7440 (depth = 4)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7441 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7442 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7441);
// compiled call node returning call7442 (depth = 4)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7443 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7444 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7445 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7444);
// compiled member node returning call7445 (depth = 6)
  Object call7446 = callmethodflags(call7445, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7443);
// compiled member node returning call7446 (depth = 5)
  *var_suggestion = call7446;
  if (call7446 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7448 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool7449 = alloc_Boolean(1);
// compiled identifier node returning bool7449 (depth = 5)
  gc_frame_newslot(bool7449);
// starting to compile identifier node (depth = 5)
  Object bool7450 = alloc_Boolean(0);
// compiled identifier node returning bool7450 (depth = 5)
  gc_frame_newslot(bool7450);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool7449;
  params[2] = bool7450;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7451 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7448);
// compiled call node returning call7451 (depth = 4)
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7452 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7453 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7452);
// compiled call node returning call7453 (depth = 4)
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7454 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7455 == NULL) {
    strlit7455 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit7455);
  }
// compiled string node returning strlit7455 (depth = 5)
  gc_frame_newslot(strlit7455);
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7457 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7456);
// compiled member node returning call7457 (depth = 5)
  gc_frame_newslot(call7457);
// starting to compile member node (depth = 5)
  int callframe7458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7459 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7458);
// compiled member node returning call7459 (depth = 5)
  gc_frame_newslot(call7459);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7455;
  params[1] = call7457;
  params[2] = call7459;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7460 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7454);
// compiled call node returning call7460 (depth = 4)
    gc_frame_newslot(call7460);
    if7421 = call7460;
  }
// compiled if node returning if7421 (depth = 3)
    gc_frame_newslot(if7421);
    if7415 = if7421;
  } else {
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7461 = alloc_Boolean(0);
// compiled identifier node returning bool7461 (depth = 3)
    gc_frame_newslot(bool7461);
    if7415 = bool7461;
  }
// compiled if node returning if7415 (depth = 2)
  gc_frame_end(frame);
  return if7415;
}
Object meth_parser_7529__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7531 == NULL) {
    strlit7531 = alloc_String("rsquare");
    gc_root(strlit7531);
  }
// compiled string node returning strlit7531 (depth = 6)
  int op_slot_right_7530 = gc_frame_newslot(strlit7531);
// starting to compile member node (depth = 6)
  int callframe7533 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7534 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7533);
// compiled member node returning call7534 (depth = 6)
  int op_slot_left_7530 = gc_frame_newslot(call7534);
  params[0] = strlit7531;
  partcv[0] = 1;
  Object opresult7535 = callmethod(call7534, "==(1)", 1, partcv, params);
// compiled op node returning opresult7535 (depth = 5)
  gc_frame_end(frame);
  return opresult7535;
}
Object meth_parser_7609__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7613 == NULL) {
    strlit7613 = alloc_String("*");
    gc_root(strlit7613);
  }
// compiled string node returning strlit7613 (depth = 8)
  int op_slot_right_7612 = gc_frame_newslot(strlit7613);
// starting to compile member node (depth = 8)
  int callframe7615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7616 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7615);
// compiled member node returning call7616 (depth = 8)
  int op_slot_left_7612 = gc_frame_newslot(call7616);
  params[0] = strlit7613;
  partcv[0] = 1;
  Object opresult7617 = callmethod(call7616, "==(1)", 1, partcv, params);
// compiled op node returning opresult7617 (depth = 7)
  int op_slot_right_7611 = gc_frame_newslot(opresult7617);
// starting to compile call node (depth = 7)
  int callframe7619 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7620 == NULL) {
    strlit7620 = alloc_String("op");
    gc_root(strlit7620);
  }
// compiled string node returning strlit7620 (depth = 8)
  gc_frame_newslot(strlit7620);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7620;
  partcv[0] = 1;
  Object call7621 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7619);
// compiled call node returning call7621 (depth = 7)
  int op_slot_left_7611 = gc_frame_newslot(call7621);
  params[0] = opresult7617;
  partcv[0] = 1;
  Object opresult7622 = callmethod(call7621, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7622 (depth = 6)
  int op_slot_right_7610 = gc_frame_newslot(opresult7622);
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7624 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7625 == NULL) {
    strlit7625 = alloc_String("identifier");
    gc_root(strlit7625);
  }
// compiled string node returning strlit7625 (depth = 7)
  gc_frame_newslot(strlit7625);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7625;
  partcv[0] = 1;
  Object call7626 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7624);
// compiled call node returning call7626 (depth = 6)
  int op_slot_left_7610 = gc_frame_newslot(call7626);
  params[0] = opresult7622;
  partcv[0] = 1;
  Object opresult7627 = callmethod(call7626, "||(1)", 1, partcv, params);
// compiled op node returning opresult7627 (depth = 5)
  gc_frame_end(frame);
  return opresult7627;
}
Object meth_parser_7630__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_id = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object *var_comma = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// definebindings:
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7632 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7633 == NULL) {
    strlit7633 = alloc_String("op");
    gc_root(strlit7633);
  }
// compiled string node returning strlit7633 (depth = 7)
  gc_frame_newslot(strlit7633);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7633;
  partcv[0] = 1;
  Object call7634 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7632);
// compiled call node returning call7634 (depth = 6)
  Object if7631 = done;
  if (istrue(call7634)) {
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7635 = gc_frame_new();
// call case 4: self request
  Object call7636 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7635);
// compiled member node returning call7636 (depth = 6)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7637 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7639 == NULL) {
    strlit7639 = alloc_String(" an Iterable.");
    gc_root(strlit7639);
  }
// compiled string node returning strlit7639 (depth = 8)
  int op_slot_right_7638 = gc_frame_newslot(strlit7639);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7642 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call7643 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7642);
// compiled member node returning call7643 (depth = 9)
  int op_slot_right_7641 = gc_frame_newslot(call7643);
// starting to compile string node (depth = 9)
  if (strlit7645 == NULL) {
    strlit7645 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit7645);
  }
// compiled string node returning strlit7645 (depth = 9)
  int op_slot_left_7641 = gc_frame_newslot(strlit7645);
  params[0] = call7643;
  partcv[0] = 1;
  Object opresult7646 = callmethod(strlit7645, "++(1)", 1, partcv, params);
// compiled op node returning opresult7646 (depth = 8)
  int op_slot_left_7638 = gc_frame_newslot(opresult7646);
  params[0] = strlit7639;
  partcv[0] = 1;
  Object opresult7647 = callmethod(opresult7646, "++(1)", 1, partcv, params);
// compiled op node returning opresult7647 (depth = 7)
  gc_frame_newslot(opresult7647);
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7648 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7649 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7648);
// compiled member node returning call7649 (depth = 7)
  gc_frame_newslot(call7649);
// starting to compile member node (depth = 7)
  int callframe7650 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7651 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7650);
// compiled member node returning call7651 (depth = 7)
  gc_frame_newslot(call7651);
// call case 6: other requests
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult7647;
  params[1] = call7649;
  params[2] = call7651;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7652 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7637);
// compiled call node returning call7652 (depth = 6)
    gc_frame_newslot(call7652);
    if7631 = call7652;
  } else {
  }
// compiled if node returning if7631 (depth = 5)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7653 = gc_frame_new();
// call case 4: self request
  Object call7654 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7653);
// compiled member node returning call7654 (depth = 5)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7655 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call7656 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7655);
// compiled member node returning call7656 (depth = 6)
  *var_id = call7656;
  if (call7656 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7658 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool7659 = alloc_Boolean(1);
// compiled identifier node returning bool7659 (depth = 6)
  gc_frame_newslot(bool7659);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool7659;
  partcv[0] = 1;
  Object call7660 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7658);
// compiled call node returning call7660 (depth = 5)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7661 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe7662 = gc_frame_new();
// call case 4: self request
  Object call7663 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7662);
// compiled member node returning call7663 (depth = 6)
  gc_frame_newslot(call7663);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = call7663;
  partcv[0] = 1;
  Object call7664 = callmethodflags(*var_id, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7661);
// compiled call node returning call7664 (depth = 5)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7665 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7666 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call7667 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe7666);
// compiled member node returning call7667 (depth = 6)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call7668 = callmethodflags(call7667, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7665);
// compiled call node returning call7668 (depth = 5)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7670 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7671 == NULL) {
    strlit7671 = alloc_String("comma");
    gc_root(strlit7671);
  }
// compiled string node returning strlit7671 (depth = 7)
  gc_frame_newslot(strlit7671);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7671;
  partcv[0] = 1;
  Object call7672 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7670);
// compiled call node returning call7672 (depth = 6)
  Object if7669 = done;
  if (istrue(call7672)) {
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7674 = gc_frame_new();
// call case 4: self request
  Object call7675 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7674);
// compiled member node returning call7675 (depth = 6)
    gc_frame_newslot(call7675);
    if7669 = call7675;
  } else {
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7678 == NULL) {
    strlit7678 = alloc_String("rparen");
    gc_root(strlit7678);
  }
// compiled string node returning strlit7678 (depth = 8)
  int op_slot_right_7677 = gc_frame_newslot(strlit7678);
// starting to compile member node (depth = 8)
  int callframe7680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7681 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7680);
// compiled member node returning call7681 (depth = 8)
  int op_slot_left_7677 = gc_frame_newslot(call7681);
  params[0] = strlit7678;
  partcv[0] = 1;
  Object opresult7682 = callmethod(call7681, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7682 (depth = 7)
  Object if7676 = done;
  if (istrue(opresult7682)) {
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7685 == NULL) {
    strlit7685 = alloc_String("rparen");
    gc_root(strlit7685);
  }
// compiled string node returning strlit7685 (depth = 9)
  int op_slot_right_7684 = gc_frame_newslot(strlit7685);
// starting to compile member node (depth = 9)
  int callframe7687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call7688 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7687);
// compiled member node returning call7688 (depth = 9)
  int op_slot_left_7684 = gc_frame_newslot(call7688);
  params[0] = strlit7685;
  partcv[0] = 1;
  Object opresult7689 = callmethod(call7688, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7689 (depth = 8)
  Object if7683 = done;
  if (istrue(opresult7689)) {
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7690 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call7692 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7691);
// compiled member node returning call7692 (depth = 10)
  Object call7693 = callmethodflags(call7692, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7690);
// compiled member node returning call7693 (depth = 9)
  *var_suggestion = call7693;
  if (call7693 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7694 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7695 == NULL) {
    strlit7695 = alloc_String(")");
    gc_root(strlit7695);
  }
// compiled string node returning strlit7695 (depth = 9)
  gc_frame_newslot(strlit7695);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit7695;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7696 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7694);
// compiled call node returning call7696 (depth = 8)
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7697 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7698 == NULL) {
    strlit7698 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit7698);
  }
// compiled string node returning strlit7698 (depth = 9)
  gc_frame_newslot(strlit7698);
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe7699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call7700 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7699);
// compiled member node returning call7700 (depth = 9)
  gc_frame_newslot(call7700);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call7703 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7702);
// compiled member node returning call7703 (depth = 10)
  int op_slot_right_7701 = gc_frame_newslot(call7703);
// starting to compile member node (depth = 10)
  int callframe7705 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call7706 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7705);
// compiled member node returning call7706 (depth = 10)
  int op_slot_left_7701 = gc_frame_newslot(call7706);
  params[0] = call7703;
  partcv[0] = 1;
  Object sum7707 = callmethod(call7706, "+(1)", 1, partcv, params);
// compiled op node returning sum7707 (depth = 9)
  gc_frame_newslot(sum7707);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7698;
  params[1] = call7700;
  params[2] = sum7707;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7708 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7697);
// compiled call node returning call7708 (depth = 8)
    gc_frame_newslot(call7708);
    if7683 = call7708;
  } else {
  }
// compiled if node returning if7683 (depth = 7)
    gc_frame_newslot(if7683);
    if7676 = if7683;
  } else {
  }
// compiled if node returning if7676 (depth = 6)
    gc_frame_newslot(if7676);
    if7669 = if7676;
  }
// compiled if node returning if7669 (depth = 5)
  gc_frame_end(frame);
  return if7669;
}
Object meth_parser_7724__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call7728 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7727);
// compiled member node returning call7728 (depth = 9)
  int op_slot_right_7726 = gc_frame_newslot(call7728);
// starting to compile member node (depth = 9)
  int callframe7730 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call7731 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7730);
// compiled member node returning call7731 (depth = 9)
  int op_slot_left_7726 = gc_frame_newslot(call7731);
  params[0] = call7728;
  partcv[0] = 1;
  Object opresult7732 = callmethod(call7731, "==(1)", 1, partcv, params);
// compiled op node returning opresult7732 (depth = 8)
  int op_slot_right_7725 = gc_frame_newslot(opresult7732);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7735 == NULL) {
    strlit7735 = alloc_String("rparen");
    gc_root(strlit7735);
  }
// compiled string node returning strlit7735 (depth = 9)
  int op_slot_right_7734 = gc_frame_newslot(strlit7735);
// starting to compile member node (depth = 9)
  int callframe7737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call7738 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7737);
// compiled member node returning call7738 (depth = 9)
  int op_slot_left_7734 = gc_frame_newslot(call7738);
  params[0] = strlit7735;
  partcv[0] = 1;
  Object opresult7739 = callmethod(call7738, "==(1)", 1, partcv, params);
// compiled op node returning opresult7739 (depth = 8)
  int op_slot_left_7725 = gc_frame_newslot(opresult7739);
  params[0] = opresult7732;
  partcv[0] = 1;
  Object opresult7740 = callmethod(opresult7739, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7740 (depth = 7)
  gc_frame_end(frame);
  return opresult7740;
}
Object meth_parser_7807__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe7808 = gc_frame_new();
// call case 4: self request
  Object call7809 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7808);
// compiled member node returning call7809 (depth = 6)
  gc_frame_end(frame);
  return call7809;
}
Object meth_parser_7462_methodsignature_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsignature(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_part = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "part");
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_lparen = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lparen");
  Object *var_id = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "id");
  Object *var_comma = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "comma");
// definebindings:
  Object *var_rparen = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "rparen");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7466 == NULL) {
    strlit7466 = alloc_String("lsquare");
    gc_root(strlit7466);
  }
// compiled string node returning strlit7466 (depth = 5)
  int op_slot_right_7465 = gc_frame_newslot(strlit7466);
// starting to compile member node (depth = 5)
  int callframe7468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7469 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7468);
// compiled member node returning call7469 (depth = 5)
  int op_slot_left_7465 = gc_frame_newslot(call7469);
  params[0] = strlit7466;
  partcv[0] = 1;
  Object opresult7470 = callmethod(call7469, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7470 (depth = 4)
  int op_slot_right_7464 = gc_frame_newslot(opresult7470);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7474 == NULL) {
    strlit7474 = alloc_String("op");
    gc_root(strlit7474);
  }
// compiled string node returning strlit7474 (depth = 6)
  int op_slot_right_7473 = gc_frame_newslot(strlit7474);
// starting to compile member node (depth = 6)
  int callframe7476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7477 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7476);
// compiled member node returning call7477 (depth = 6)
  int op_slot_left_7473 = gc_frame_newslot(call7477);
  params[0] = strlit7474;
  partcv[0] = 1;
  Object opresult7478 = callmethod(call7477, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7478 (depth = 5)
  int op_slot_right_7472 = gc_frame_newslot(opresult7478);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7481 == NULL) {
    strlit7481 = alloc_String("identifier");
    gc_root(strlit7481);
  }
// compiled string node returning strlit7481 (depth = 6)
  int op_slot_right_7480 = gc_frame_newslot(strlit7481);
// starting to compile member node (depth = 6)
  int callframe7483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7484 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7483);
// compiled member node returning call7484 (depth = 6)
  int op_slot_left_7480 = gc_frame_newslot(call7484);
  params[0] = strlit7481;
  partcv[0] = 1;
  Object opresult7485 = callmethod(call7484, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7485 (depth = 5)
  int op_slot_left_7472 = gc_frame_newslot(opresult7485);
  params[0] = opresult7478;
  partcv[0] = 1;
  Object opresult7486 = callmethod(opresult7485, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7486 (depth = 4)
  int op_slot_left_7464 = gc_frame_newslot(opresult7486);
  params[0] = opresult7470;
  partcv[0] = 1;
  Object opresult7487 = callmethod(opresult7486, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7487 (depth = 3)
  Object if7463 = done;
  if (istrue(opresult7487)) {
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7488 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7489 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call7490 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7489);
// compiled member node returning call7490 (depth = 5)
  Object call7491 = callmethodflags(call7490, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7488);
// compiled member node returning call7491 (depth = 4)
  *var_suggestion = call7491;
  if (call7491 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7492 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7493 == NULL) {
    strlit7493 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit7493);
  }
// compiled string node returning strlit7493 (depth = 4)
  gc_frame_newslot(strlit7493);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit7493;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7494 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7492);
// compiled call node returning call7494 (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7495 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7496 == NULL) {
    strlit7496 = alloc_String("a method name must start with an identifier, or be an operator.");
    gc_root(strlit7496);
  }
// compiled string node returning strlit7496 (depth = 4)
  gc_frame_newslot(strlit7496);
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7497 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7498 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7497);
// compiled member node returning call7498 (depth = 4)
  gc_frame_newslot(call7498);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7500 = alloc_Float64(1);
// compiled num node returning num7500 (depth = 5)
  int op_slot_right_7499 = gc_frame_newslot(num7500);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7504 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7503);
// compiled member node returning call7504 (depth = 6)
  int op_slot_right_7502 = gc_frame_newslot(call7504);
// starting to compile member node (depth = 6)
  int callframe7506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7507 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7506);
// compiled member node returning call7507 (depth = 6)
  int op_slot_left_7502 = gc_frame_newslot(call7507);
  params[0] = call7504;
  partcv[0] = 1;
  Object sum7508 = callmethod(call7507, "+(1)", 1, partcv, params);
// compiled op node returning sum7508 (depth = 5)
  int op_slot_left_7499 = gc_frame_newslot(sum7508);
  params[0] = num7500;
  partcv[0] = 1;
  Object sum7509 = callmethod(sum7508, "+(1)", 1, partcv, params);
// compiled op node returning sum7509 (depth = 4)
  gc_frame_newslot(sum7509);
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7496;
  params[1] = call7498;
  params[2] = sum7509;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7510 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7495);
// compiled call node returning call7510 (depth = 3)
    gc_frame_newslot(call7510);
    if7463 = call7510;
  } else {
  }
// compiled if node returning if7463 (depth = 2)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7511 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  Object call7513 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7512);
// compiled member node returning call7513 (depth = 4)
  gc_frame_newslot(call7513);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call7515 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe7514);
// compiled member node returning call7515 (depth = 4)
  params[0] = call7513;
  partcv[0] = 1;
  Object call7516 = callmethodflags(call7515, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7511);
// compiled call node returning call7516 (depth = 3)
  *var_part = call7516;
  if (call7516 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7517 = gc_frame_new();
// call case 4: self request
  Object call7518 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7517);
// compiled member node returning call7518 (depth = 2)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7519 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array7520 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  callmethodflags(array7520, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7520 (depth = 4)
  gc_frame_newslot(array7520);
// starting to compile array node (depth = 4)
  Object array7521 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7521 (depth = 4)
  gc_frame_newslot(array7521);
// starting to compile identifier node (depth = 4)
  Object bool7522 = alloc_Boolean(0);
// compiled identifier node returning bool7522 (depth = 4)
  gc_frame_newslot(bool7522);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call7524 = callmethodflags(*var_ast, "methodNode", 0, partcv, params, 0);
  gc_frame_end(callframe7523);
// compiled member node returning call7524 (depth = 4)
  params[0] = array7520;
  params[1] = array7521;
  params[2] = bool7522;
  partcv[0] = 3;
  Object call7525 = callmethodflags(call7524, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7519);
// compiled call node returning call7525 (depth = 3)
  *var_result = call7525;
  if (call7525 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block7528 = alloc_Block(NULL, NULL, "parser", 2584);
  gc_frame_newslot(block7528);
// method "_apply"
  block_savedest(block7528);
  Object closure7529 = createclosure(2, "_apply");
  setclosureframe(closure7529, stackframe);
  addtoclosure(closure7529, var_sym);
  addtoclosure(closure7529, selfslot);
  struct UserObject *uo7529 = (struct UserObject*)block7528;
  uo7529->data[0] = (Object)closure7529;
  Method *meth_meth_parser_7529__apply = addmethod2pos(block7528, "_apply", &meth_parser_7529__apply, 0);
  int argcv_meth_parser_7529__apply[] = {0};
  meth_meth_parser_7529__apply->type = alloc_MethodType(1, argcv_meth_parser_7529__apply);
  meth_meth_parser_7529__apply->definitionModule = modulename;
  meth_meth_parser_7529__apply->definitionLine = 3208;
// compiled block node returning block7528 (depth = 4)
  int op_slot_right_7527 = gc_frame_newslot(block7528);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7539 == NULL) {
    strlit7539 = alloc_String("[");
    gc_root(strlit7539);
  }
// compiled string node returning strlit7539 (depth = 5)
  int op_slot_right_7538 = gc_frame_newslot(strlit7539);
// starting to compile member node (depth = 5)
  int callframe7541 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startToken (depth = 6)
  Object call7542 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7541);
// compiled member node returning call7542 (depth = 5)
  int op_slot_left_7538 = gc_frame_newslot(call7542);
  params[0] = strlit7539;
  partcv[0] = 1;
  Object opresult7543 = callmethod(call7542, "==(1)", 1, partcv, params);
// compiled op node returning opresult7543 (depth = 4)
  int op_slot_left_7527 = gc_frame_newslot(opresult7543);
  params[0] = block7528;
  partcv[0] = 1;
  Object opresult7544 = callmethod(opresult7543, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7544 (depth = 3)
  Object if7526 = done;
  if (istrue(opresult7544)) {
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7545 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7546 == NULL) {
    strlit7546 = alloc_String("methods named '[]' and '[]:=' are no longer part of Grace.");
    gc_root(strlit7546);
  }
// compiled string node returning strlit7546 (depth = 4)
  gc_frame_newslot(strlit7546);
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7547 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7548 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7547);
// compiled member node returning call7548 (depth = 4)
  gc_frame_newslot(call7548);
// starting to compile member node (depth = 4)
  int callframe7549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7550 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7549);
// compiled member node returning call7550 (depth = 4)
  gc_frame_newslot(call7550);
// starting to compile member node (depth = 4)
  int callframe7551 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7552 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7551);
// compiled member node returning call7552 (depth = 4)
  gc_frame_newslot(call7552);
// call case 6: other requests
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7546;
  params[1] = call7548;
  params[2] = call7550;
  params[3] = call7552;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7553 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7545);
// compiled call node returning call7553 (depth = 3)
    gc_frame_newslot(call7553);
    if7526 = call7553;
  } else {
  }
// compiled if node returning if7526 (depth = 2)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7555 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7556 == NULL) {
    strlit7556 = alloc_String("lgeneric");
    gc_root(strlit7556);
  }
// compiled string node returning strlit7556 (depth = 4)
  gc_frame_newslot(strlit7556);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7556;
  partcv[0] = 1;
  Object call7557 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7555);
// compiled call node returning call7557 (depth = 3)
  Object if7554 = done;
  if (istrue(call7557)) {
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7558 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7559 = gc_frame_new();
// call case 4: self request
  Object call7560 = callmethodflags(self, "typeparameters", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7559);
// compiled member node returning call7560 (depth = 4)
  gc_frame_newslot(call7560);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call7560;
  partcv[0] = 1;
  Object call7561 = callmethodflags(*var_result, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7558);
// compiled call node returning call7561 (depth = 3)
    gc_frame_newslot(call7561);
    if7554 = call7561;
  } else {
  }
// compiled if node returning if7554 (depth = 2)
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7563 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7564 == NULL) {
    strlit7564 = alloc_String("bind");
    gc_root(strlit7564);
  }
// compiled string node returning strlit7564 (depth = 4)
  gc_frame_newslot(strlit7564);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7564;
  partcv[0] = 1;
  Object call7565 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7563);
// compiled call node returning call7565 (depth = 3)
  Object if7562 = done;
  if (istrue(call7565)) {
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7566 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7568 == NULL) {
    strlit7568 = alloc_String(":=");
    gc_root(strlit7568);
  }
// compiled string node returning strlit7568 (depth = 5)
  int op_slot_right_7567 = gc_frame_newslot(strlit7568);
// starting to compile member node (depth = 5)
  int callframe7570 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call7571 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe7570);
// compiled member node returning call7571 (depth = 5)
  int op_slot_left_7567 = gc_frame_newslot(call7571);
  params[0] = strlit7568;
  partcv[0] = 1;
  Object opresult7572 = callmethod(call7571, "++(1)", 1, partcv, params);
// compiled op node returning opresult7572 (depth = 4)
  gc_frame_newslot(opresult7572);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult7572;
  partcv[0] = 1;
  Object call7573 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7566);
// compiled call node returning call7573 (depth = 3)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7574 = gc_frame_new();
// call case 4: self request
  Object call7575 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7574);
// compiled member node returning call7575 (depth = 3)
    gc_frame_newslot(call7575);
    if7562 = call7575;
  } else {
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7579 == NULL) {
    strlit7579 = alloc_String("prefix");
    gc_root(strlit7579);
  }
// compiled string node returning strlit7579 (depth = 6)
  int op_slot_right_7578 = gc_frame_newslot(strlit7579);
// starting to compile member node (depth = 6)
  int callframe7581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startToken (depth = 7)
  Object call7582 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7581);
// compiled member node returning call7582 (depth = 6)
  int op_slot_left_7578 = gc_frame_newslot(call7582);
  params[0] = strlit7579;
  partcv[0] = 1;
  Object opresult7583 = callmethod(call7582, "==(1)", 1, partcv, params);
// compiled op node returning opresult7583 (depth = 5)
  int op_slot_right_7577 = gc_frame_newslot(opresult7583);
// starting to compile call node (depth = 5)
  int callframe7585 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7586 == NULL) {
    strlit7586 = alloc_String("op");
    gc_root(strlit7586);
  }
// compiled string node returning strlit7586 (depth = 6)
  gc_frame_newslot(strlit7586);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7586;
  partcv[0] = 1;
  Object call7587 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7585);
// compiled call node returning call7587 (depth = 5)
  int op_slot_left_7577 = gc_frame_newslot(call7587);
  params[0] = opresult7583;
  partcv[0] = 1;
  Object opresult7588 = callmethod(call7587, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7588 (depth = 4)
  Object if7576 = done;
  if (istrue(opresult7588)) {
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7589 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7592 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7591);
// compiled member node returning call7592 (depth = 6)
  int op_slot_right_7590 = gc_frame_newslot(call7592);
// starting to compile member node (depth = 6)
  int callframe7594 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call7595 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe7594);
// compiled member node returning call7595 (depth = 6)
  int op_slot_left_7590 = gc_frame_newslot(call7595);
  params[0] = call7592;
  partcv[0] = 1;
  Object opresult7596 = callmethod(call7595, "++(1)", 1, partcv, params);
// compiled op node returning opresult7596 (depth = 5)
  gc_frame_newslot(opresult7596);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult7596;
  partcv[0] = 1;
  Object call7597 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7589);
// compiled call node returning call7597 (depth = 4)
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7598 = gc_frame_new();
// call case 4: self request
  Object call7599 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7598);
// compiled member node returning call7599 (depth = 4)
    gc_frame_newslot(call7599);
    if7576 = call7599;
  } else {
  }
// compiled if node returning if7576 (depth = 3)
    gc_frame_newslot(if7576);
    if7562 = if7576;
  }
// compiled if node returning if7562 (depth = 2)
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7601 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7602 == NULL) {
    strlit7602 = alloc_String("lparen");
    gc_root(strlit7602);
  }
// compiled string node returning strlit7602 (depth = 4)
  gc_frame_newslot(strlit7602);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7602;
  partcv[0] = 1;
  Object call7603 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7601);
// compiled call node returning call7603 (depth = 3)
  Object if7600 = done;
  if (istrue(call7603)) {
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7604 = gc_frame_new();
// call case 4: self request
  Object call7605 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7604);
// compiled member node returning call7605 (depth = 3)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7606 = alloc_Boolean(0);
// compiled identifier node returning bool7606 (depth = 4)
  *var_comma = bool7606;
  if (bool7606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7607 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7608 = alloc_Block(NULL, NULL, "parser", 2601);
  gc_frame_newslot(block7608);
// method "_apply"
  block_savedest(block7608);
  Object closure7609 = createclosure(2, "_apply");
  setclosureframe(closure7609, stackframe);
  addtoclosure(closure7609, var_sym);
  addtoclosure(closure7609, selfslot);
  struct UserObject *uo7609 = (struct UserObject*)block7608;
  uo7609->data[0] = (Object)closure7609;
  Method *meth_meth_parser_7609__apply = addmethod2pos(block7608, "_apply", &meth_parser_7609__apply, 0);
  int argcv_meth_parser_7609__apply[] = {0};
  meth_meth_parser_7609__apply->type = alloc_MethodType(1, argcv_meth_parser_7609__apply);
  meth_meth_parser_7609__apply->definitionModule = modulename;
  meth_meth_parser_7609__apply->definitionLine = 3208;
// compiled block node returning block7608 (depth = 4)
  gc_frame_newslot(block7608);
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7629 = alloc_Block(NULL, NULL, "parser", 2602);
  gc_frame_newslot(block7629);
// method "_apply"
  block_savedest(block7629);
  Object closure7630 = createclosure(8, "_apply");
  setclosureframe(closure7630, stackframe);
  addtoclosure(closure7630, var_sym);
  addtoclosure(closure7630, var_lastToken);
  addtoclosure(closure7630, var_errormessages);
  addtoclosure(closure7630, var_values);
  addtoclosure(closure7630, var_id);
  addtoclosure(closure7630, var_part);
  addtoclosure(closure7630, var_comma);
  addtoclosure(closure7630, selfslot);
  struct UserObject *uo7630 = (struct UserObject*)block7629;
  uo7630->data[0] = (Object)closure7630;
  Method *meth_meth_parser_7630__apply = addmethod2pos(block7629, "_apply", &meth_parser_7630__apply, 0);
  int argcv_meth_parser_7630__apply[] = {0};
  meth_meth_parser_7630__apply->type = alloc_MethodType(1, argcv_meth_parser_7630__apply);
  meth_meth_parser_7630__apply->definitionModule = modulename;
  meth_meth_parser_7630__apply->definitionLine = 3208;
// compiled block node returning block7629 (depth = 4)
  gc_frame_newslot(block7629);
// call case 5: prelude request
  params[0] = block7608;
  params[1] = block7629;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7710 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7607);
// compiled call node returning call7710 (depth = 3)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7713 == NULL) {
    strlit7713 = alloc_String("rparen");
    gc_root(strlit7713);
  }
// compiled string node returning strlit7713 (depth = 5)
  int op_slot_right_7712 = gc_frame_newslot(strlit7713);
// starting to compile member node (depth = 5)
  int callframe7715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7716 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7715);
// compiled member node returning call7716 (depth = 5)
  int op_slot_left_7712 = gc_frame_newslot(call7716);
  params[0] = strlit7713;
  partcv[0] = 1;
  Object opresult7717 = callmethod(call7716, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7717 (depth = 4)
  Object if7711 = done;
  if (istrue(opresult7717)) {
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7718 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7719 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7720 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7719);
// compiled member node returning call7720 (depth = 6)
  Object call7721 = callmethodflags(call7720, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7718);
// compiled member node returning call7721 (depth = 5)
  *var_suggestion = call7721;
  if (call7721 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7722 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7723 = alloc_Block(NULL, NULL, "parser", 2629);
  gc_frame_newslot(block7723);
// method "_apply(_)"
  block_savedest(block7723);
  Object closure7724 = createclosure(2, "_apply(1)");
  setclosureframe(closure7724, stackframe);
  addtoclosure(closure7724, var_lastToken);
  addtoclosure(closure7724, selfslot);
  struct UserObject *uo7724 = (struct UserObject*)block7723;
  uo7724->data[0] = (Object)closure7724;
  Method *meth_meth_parser_7724__apply_40_1_41_ = addmethod2pos(block7723, "_apply(1)", &meth_parser_7724__apply_40_1_41_, 0);
  int argcv_meth_parser_7724__apply_40_1_41_[] = {1};
  meth_meth_parser_7724__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7724__apply_40_1_41_);
  meth_meth_parser_7724__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7724__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block7723 (depth = 6)
  gc_frame_newslot(block7723);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block7723;
  partcv[0] = 1;
  Object call7742 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7722);
// compiled call node returning call7742 (depth = 5)
  *var_rparen = call7742;
  if (call7742 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_right_7744 = gc_frame_newslot(*var_rparen);
// starting to compile identifier node (depth = 6)
  Object bool7746 = alloc_Boolean(0);
// compiled identifier node returning bool7746 (depth = 6)
  int op_slot_left_7744 = gc_frame_newslot(bool7746);
  params[0] = *var_rparen;
  partcv[0] = 1;
  Object opresult7747 = callmethod(bool7746, "==(1)", 1, partcv, params);
// compiled op node returning opresult7747 (depth = 5)
  Object if7743 = done;
  if (istrue(opresult7747)) {
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7748 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit7749 == NULL) {
    strlit7749 = alloc_String(")");
    gc_root(strlit7749);
  }
// compiled string node returning strlit7749 (depth = 6)
  gc_frame_newslot(strlit7749);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit7749;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7750 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7748);
// compiled call node returning call7750 (depth = 5)
    gc_frame_newslot(call7750);
    if7743 = call7750;
  } else {
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7751 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call7752 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7751);
// compiled call node returning call7752 (depth = 5)
    gc_frame_newslot(call7752);
    if7743 = call7752;
  }
// compiled if node returning if7743 (depth = 4)
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7753 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7754 == NULL) {
    strlit7754 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit7754);
  }
// compiled string node returning strlit7754 (depth = 5)
  gc_frame_newslot(strlit7754);
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7755 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7756 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7755);
// compiled member node returning call7756 (depth = 5)
  gc_frame_newslot(call7756);
// starting to compile member node (depth = 5)
  int callframe7757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7758 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7757);
// compiled member node returning call7758 (depth = 5)
  gc_frame_newslot(call7758);
// starting to compile member node (depth = 5)
  int callframe7759 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7760 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7759);
// compiled member node returning call7760 (depth = 5)
  gc_frame_newslot(call7760);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7754;
  params[1] = call7756;
  params[2] = call7758;
  params[3] = call7760;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7761 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7753);
// compiled call node returning call7761 (depth = 4)
    gc_frame_newslot(call7761);
    if7711 = call7761;
  } else {
  }
// compiled if node returning if7711 (depth = 3)
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7764 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call7765 = callmethodflags(*var_part, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7764);
// compiled member node returning call7765 (depth = 5)
  int op_slot_right_7763 = gc_frame_newslot(call7765);
// starting to compile member node (depth = 5)
  int callframe7767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7768 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7767);
// compiled member node returning call7768 (depth = 5)
  int op_slot_left_7763 = gc_frame_newslot(call7768);
  params[0] = call7765;
  partcv[0] = 1;
  Object opresult7769 = callmethod(call7768, "==(1)", 1, partcv, params);
// compiled op node returning opresult7769 (depth = 4)
  Object if7762 = done;
  if (istrue(opresult7769)) {
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7770 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7772 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call7773 = callmethodflags(*var_part, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7772);
// compiled member node returning call7773 (depth = 6)
  int op_slot_right_7771 = gc_frame_newslot(call7773);
// starting to compile member node (depth = 6)
  int callframe7775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7776 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7775);
// compiled member node returning call7776 (depth = 6)
  int op_slot_left_7771 = gc_frame_newslot(call7776);
  params[0] = call7773;
  partcv[0] = 1;
  Object diff7777 = callmethod(call7776, "-(1)", 1, partcv, params);
// compiled op node returning diff7777 (depth = 5)
  gc_frame_newslot(diff7777);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff7777;
  partcv[0] = 1;
  Object call7778 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7770);
// compiled call node returning call7778 (depth = 4)
    gc_frame_newslot(call7778);
    if7762 = call7778;
  } else {
  }
// compiled if node returning if7762 (depth = 3)
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7779 = gc_frame_new();
// call case 4: self request
  Object call7780 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compiled member node returning call7780 (depth = 3)
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7783 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7784 == NULL) {
    strlit7784 = alloc_String("identifier");
    gc_root(strlit7784);
  }
// compiled string node returning strlit7784 (depth = 6)
  gc_frame_newslot(strlit7784);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7784;
  partcv[0] = 1;
  Object call7785 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7783);
// compiled call node returning call7785 (depth = 5)
  int op_slot_right_7782 = gc_frame_newslot(call7785);
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7788 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7789 == NULL) {
    strlit7789 = alloc_String("identifier");
    gc_root(strlit7789);
  }
// compiled string node returning strlit7789 (depth = 7)
  gc_frame_newslot(strlit7789);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7789;
  partcv[0] = 1;
  Object call7790 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7788);
// compiled call node returning call7790 (depth = 6)
  int op_slot_right_7787 = gc_frame_newslot(call7790);
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call7793 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7792);
// compiled call node returning call7793 (depth = 6)
  int op_slot_left_7787 = gc_frame_newslot(call7793);
  params[0] = call7790;
  partcv[0] = 1;
  Object opresult7794 = callmethod(call7793, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7794 (depth = 5)
  int op_slot_left_7782 = gc_frame_newslot(opresult7794);
  params[0] = call7785;
  partcv[0] = 1;
  Object opresult7795 = callmethod(opresult7794, "||(1)", 1, partcv, params);
// compiled op node returning opresult7795 (depth = 4)
  Object if7781 = done;
  if (istrue(opresult7795)) {
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7796 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sameline (depth = 5)
  gc_frame_newslot(*var_sameline);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_result;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call7797 = callmethodflags(module_parser, "methodDecRest(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7796);
// compiled call node returning call7797 (depth = 4)
    gc_frame_newslot(call7797);
    if7781 = call7797;
  } else {
  }
// compiled if node returning if7781 (depth = 3)
    gc_frame_newslot(if7781);
    if7600 = if7781;
  } else {
  }
// compiled if node returning if7600 (depth = 2)
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7799 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7800 == NULL) {
    strlit7800 = alloc_String("arrow");
    gc_root(strlit7800);
  }
// compiled string node returning strlit7800 (depth = 4)
  gc_frame_newslot(strlit7800);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7800;
  partcv[0] = 1;
  Object call7801 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7799);
// compiled call node returning call7801 (depth = 3)
  Object if7798 = done;
  if (istrue(call7801)) {
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7802 = gc_frame_new();
// call case 4: self request
  Object call7803 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7802);
// compiled member node returning call7803 (depth = 3)
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7805 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7806 = alloc_Block(NULL, NULL, "parser", 2652);
  gc_frame_newslot(block7806);
// method "_apply"
  block_savedest(block7806);
  Object closure7807 = createclosure(1, "_apply");
  setclosureframe(closure7807, stackframe);
  addtoclosure(closure7807, selfslot);
  struct UserObject *uo7807 = (struct UserObject*)block7806;
  uo7807->data[0] = (Object)closure7807;
  Method *meth_meth_parser_7807__apply = addmethod2pos(block7806, "_apply", &meth_parser_7807__apply, 0);
  int argcv_meth_parser_7807__apply[] = {0};
  meth_meth_parser_7807__apply->type = alloc_MethodType(1, argcv_meth_parser_7807__apply);
  meth_meth_parser_7807__apply->definitionModule = modulename;
  meth_meth_parser_7807__apply->definitionLine = 3208;
// compiled block node returning block7806 (depth = 5)
  gc_frame_newslot(block7806);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block7806;
  partcv[0] = 1;
  Object call7811 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7805);
// compiled call node returning call7811 (depth = 4)
  Object if7804 = done;
  if (istrue(call7811)) {
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7812 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7814 == NULL) {
    strlit7814 = alloc_String("type. If you don't want to state the return type, omit the arrow.");
    gc_root(strlit7814);
  }
// compiled string node returning strlit7814 (depth = 6)
  int op_slot_right_7813 = gc_frame_newslot(strlit7814);
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7816 == NULL) {
    strlit7816 = alloc_String("after an arrow, write the method's return ");
    gc_root(strlit7816);
  }
// compiled string node returning strlit7816 (depth = 6)
  int op_slot_left_7813 = gc_frame_newslot(strlit7816);
  params[0] = strlit7814;
  partcv[0] = 1;
  Object opresult7817 = callmethod(strlit7816, "++(1)", 1, partcv, params);
// compiled op node returning opresult7817 (depth = 5)
  gc_frame_newslot(opresult7817);
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7818 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7819 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7818);
// compiled member node returning call7819 (depth = 5)
  gc_frame_newslot(call7819);
// starting to compile member node (depth = 5)
  int callframe7820 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7821 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7820);
// compiled member node returning call7821 (depth = 5)
  gc_frame_newslot(call7821);
// starting to compile member node (depth = 5)
  int callframe7822 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7823 = callmethodflags(*var_sym, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe7822);
// compiled member node returning call7823 (depth = 5)
  gc_frame_newslot(call7823);
// call case 6: other requests
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult7817;
  params[1] = call7819;
  params[2] = call7821;
  params[3] = call7823;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7824 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7812);
// compiled call node returning call7824 (depth = 4)
    gc_frame_newslot(call7824);
    if7804 = call7824;
  } else {
  }
// compiled if node returning if7804 (depth = 3)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7825 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7826 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call7827 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7826);
// compiled member node returning call7827 (depth = 4)
  gc_frame_newslot(call7827);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call7827;
  partcv[0] = 1;
  Object call7828 = callmethodflags(*var_result, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7825);
// compiled call node returning call7828 (depth = 3)
    gc_frame_newslot(call7828);
    if7798 = call7828;
  } else {
  }
// compiled if node returning if7798 (depth = 2)
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_7835__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe7836 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7837 == NULL) {
    strlit7837 = alloc_String("identifier");
    gc_root(strlit7837);
  }
// compiled string node returning strlit7837 (depth = 5)
  gc_frame_newslot(strlit7837);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit7837;
  partcv[0] = 1;
  Object call7838 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7836);
// compiled call node returning call7838 (depth = 4)
  gc_frame_end(frame);
  return call7838;
}
Object meth_parser_7841__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// definebindings:
// definebindings:
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7842 = gc_frame_new();
// call case 4: self request
  Object call7843 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7842);
// compiled member node returning call7843 (depth = 4)
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7844 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call7845 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7844);
// compiled member node returning call7845 (depth = 5)
  *var_id = call7845;
  if (call7845 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7846 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7847 = alloc_Boolean(1);
// compiled identifier node returning bool7847 (depth = 5)
  gc_frame_newslot(bool7847);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  params[0] = bool7847;
  partcv[0] = 1;
  Object call7848 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7846);
// compiled call node returning call7848 (depth = 4)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call7850 = callmethodflags(*var_typeIds, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7849);
// compiled call node returning call7850 (depth = 4)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7852 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7853 == NULL) {
    strlit7853 = alloc_String("comma");
    gc_root(strlit7853);
  }
// compiled string node returning strlit7853 (depth = 6)
  gc_frame_newslot(strlit7853);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7853;
  partcv[0] = 1;
  Object call7854 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7852);
// compiled call node returning call7854 (depth = 5)
  Object if7851 = done;
  if (istrue(call7854)) {
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7855 = gc_frame_new();
// call case 4: self request
  Object call7856 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7855);
// compiled member node returning call7856 (depth = 5)
    gc_frame_newslot(call7856);
    if7851 = call7856;
  } else {
  }
// compiled if node returning if7851 (depth = 4)
  gc_frame_end(frame);
  return if7851;
}
Object meth_parser_7861__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe7862 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7863 = alloc_Boolean(1);
// compiled identifier node returning bool7863 (depth = 5)
  gc_frame_newslot(bool7863);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  params[0] = bool7863;
  partcv[0] = 1;
  Object call7864 = callmethodflags(*var_each, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7862);
// compiled call node returning call7864 (depth = 4)
  gc_frame_end(frame);
  return call7864;
}
Object meth_parser_7829_typeparameters(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_typeIds = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeIds");
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7830 = gc_frame_new();
// call case 4: self request
  Object call7831 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7830);
// compiled member node returning call7831 (depth = 2)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7832 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7832 (depth = 3)
  *var_typeIds = array7832;
  if (array7832 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7833 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7834 = alloc_Block(NULL, NULL, "parser", 2665);
  gc_frame_newslot(block7834);
// method "_apply"
  block_savedest(block7834);
  Object closure7835 = createclosure(1, "_apply");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, selfslot);
  struct UserObject *uo7835 = (struct UserObject*)block7834;
  uo7835->data[0] = (Object)closure7835;
  Method *meth_meth_parser_7835__apply = addmethod2pos(block7834, "_apply", &meth_parser_7835__apply, 0);
  int argcv_meth_parser_7835__apply[] = {0};
  meth_meth_parser_7835__apply->type = alloc_MethodType(1, argcv_meth_parser_7835__apply);
  meth_meth_parser_7835__apply->definitionModule = modulename;
  meth_meth_parser_7835__apply->definitionLine = 3208;
// compiled block node returning block7834 (depth = 3)
  gc_frame_newslot(block7834);
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block7840 = alloc_Block(NULL, NULL, "parser", 2665);
  gc_frame_newslot(block7840);
// method "_apply"
  block_savedest(block7840);
  Object closure7841 = createclosure(3, "_apply");
  setclosureframe(closure7841, stackframe);
  addtoclosure(closure7841, var_values);
  addtoclosure(closure7841, var_typeIds);
  addtoclosure(closure7841, selfslot);
  struct UserObject *uo7841 = (struct UserObject*)block7840;
  uo7841->data[0] = (Object)closure7841;
  Method *meth_meth_parser_7841__apply = addmethod2pos(block7840, "_apply", &meth_parser_7841__apply, 0);
  int argcv_meth_parser_7841__apply[] = {0};
  meth_meth_parser_7841__apply->type = alloc_MethodType(1, argcv_meth_parser_7841__apply);
  meth_meth_parser_7841__apply->definitionModule = modulename;
  meth_meth_parser_7841__apply->definitionLine = 3208;
// compiled block node returning block7840 (depth = 3)
  gc_frame_newslot(block7840);
// call case 5: prelude request
  params[0] = block7834;
  params[1] = block7840;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7858 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7833);
// compiled call node returning call7858 (depth = 2)
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7859 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7860 = alloc_Block(NULL, NULL, "parser", 2674);
  gc_frame_newslot(block7860);
// method "_apply(_)"
  block_savedest(block7860);
  Object closure7861 = createclosure(1, "_apply(1)");
  setclosureframe(closure7861, stackframe);
  addtoclosure(closure7861, selfslot);
  struct UserObject *uo7861 = (struct UserObject*)block7860;
  uo7861->data[0] = (Object)closure7861;
  Method *meth_meth_parser_7861__apply_40_1_41_ = addmethod2pos(block7860, "_apply(1)", &meth_parser_7861__apply_40_1_41_, 0);
  int argcv_meth_parser_7861__apply_40_1_41_[] = {1};
  meth_meth_parser_7861__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7861__apply_40_1_41_);
  meth_meth_parser_7861__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7861__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block7860 (depth = 3)
  gc_frame_newslot(block7860);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block7860;
  partcv[0] = 1;
  Object call7866 = callmethodflags(*var_typeIds, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7859);
// compiled call node returning call7866 (depth = 2)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7867 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeIds (depth = 4)
  gc_frame_newslot(*var_typeIds);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7868 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call7869 = callmethodflags(*var_ast, "typeParametersNode", 0, partcv, params, 0);
  gc_frame_end(callframe7868);
// compiled member node returning call7869 (depth = 4)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call7870 = callmethodflags(call7869, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7867);
// compiled call node returning call7870 (depth = 3)
  *var_result = call7870;
  if (call7870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7873 == NULL) {
    strlit7873 = alloc_String("rgeneric");
    gc_root(strlit7873);
  }
// compiled string node returning strlit7873 (depth = 4)
  int op_slot_right_7872 = gc_frame_newslot(strlit7873);
// starting to compile member node (depth = 4)
  int callframe7875 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7876 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7875);
// compiled member node returning call7876 (depth = 4)
  int op_slot_left_7872 = gc_frame_newslot(call7876);
  params[0] = strlit7873;
  partcv[0] = 1;
  Object opresult7877 = callmethod(call7876, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7877 (depth = 3)
  Object if7871 = done;
  if (istrue(opresult7877)) {
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7878 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7879 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call7880 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7879);
// compiled member node returning call7880 (depth = 5)
  Object call7881 = callmethodflags(call7880, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7878);
// compiled member node returning call7881 (depth = 4)
  *var_suggestion = call7881;
  if (call7881 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7882 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7883 == NULL) {
    strlit7883 = alloc_String(">");
    gc_root(strlit7883);
  }
// compiled string node returning strlit7883 (depth = 4)
  gc_frame_newslot(strlit7883);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit7883;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7884 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7882);
// compiled call node returning call7884 (depth = 3)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7885 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7886 == NULL) {
    strlit7886 = alloc_String("a list of type parameters starting with '""\xe2""""\x9f""""\xa6""' must end with '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit7886);
  }
// compiled string node returning strlit7886 (depth = 4)
  gc_frame_newslot(strlit7886);
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7888 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7887);
// compiled member node returning call7888 (depth = 4)
  gc_frame_newslot(call7888);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7890 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7891 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7890);
// compiled member node returning call7891 (depth = 5)
  int op_slot_right_7889 = gc_frame_newslot(call7891);
// starting to compile member node (depth = 5)
  int callframe7893 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7894 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7893);
// compiled member node returning call7894 (depth = 5)
  int op_slot_left_7889 = gc_frame_newslot(call7894);
  params[0] = call7891;
  partcv[0] = 1;
  Object sum7895 = callmethod(call7894, "+(1)", 1, partcv, params);
// compiled op node returning sum7895 (depth = 4)
  gc_frame_newslot(sum7895);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7886;
  params[1] = call7888;
  params[2] = sum7895;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7896 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7885);
// compiled call node returning call7896 (depth = 3)
    gc_frame_newslot(call7896);
    if7871 = call7896;
  } else {
  }
// compiled if node returning if7871 (depth = 2)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7897 = gc_frame_new();
// call case 4: self request
  Object call7898 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7897);
// compiled member node returning call7898 (depth = 2)
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_7899_doimport(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_importSym = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importSym");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
// definebindings:
// definebindings:
// definebindings:
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7901 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7902 == NULL) {
    strlit7902 = alloc_String("import");
    gc_root(strlit7902);
  }
// compiled string node returning strlit7902 (depth = 4)
  gc_frame_newslot(strlit7902);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7902;
  partcv[0] = 1;
  Object call7903 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7901);
// compiled call node returning call7903 (depth = 3)
  Object if7900 = done;
  if (istrue(call7903)) {
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_importSym = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7904 = gc_frame_new();
// call case 4: self request
  Object call7905 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7904);
// compiled member node returning call7905 (depth = 3)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7908 == NULL) {
    strlit7908 = alloc_String("string");
    gc_root(strlit7908);
  }
// compiled string node returning strlit7908 (depth = 5)
  int op_slot_right_7907 = gc_frame_newslot(strlit7908);
// starting to compile member node (depth = 5)
  int callframe7910 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7911 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7910);
// compiled member node returning call7911 (depth = 5)
  int op_slot_left_7907 = gc_frame_newslot(call7911);
  params[0] = strlit7908;
  partcv[0] = 1;
  Object opresult7912 = callmethod(call7911, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7912 (depth = 4)
  Object if7906 = done;
  if (istrue(opresult7912)) {
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7913 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7914 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7915 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7914);
// compiled member node returning call7915 (depth = 6)
  Object call7916 = callmethodflags(call7915, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7913);
// compiled member node returning call7916 (depth = 5)
  *var_suggestion = call7916;
  if (call7916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7920 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7921 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7920);
// compiled member node returning call7921 (depth = 7)
  int op_slot_right_7919 = gc_frame_newslot(call7921);
// starting to compile member node (depth = 7)
  int callframe7923 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7924 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7923);
// compiled member node returning call7924 (depth = 7)
  int op_slot_left_7919 = gc_frame_newslot(call7924);
  params[0] = call7921;
  partcv[0] = 1;
  Object opresult7925 = callmethod(call7924, "==(1)", 1, partcv, params);
// compiled op node returning opresult7925 (depth = 6)
  int op_slot_right_7918 = gc_frame_newslot(opresult7925);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7928 == NULL) {
    strlit7928 = alloc_String("identifier");
    gc_root(strlit7928);
  }
// compiled string node returning strlit7928 (depth = 7)
  int op_slot_right_7927 = gc_frame_newslot(strlit7928);
// starting to compile member node (depth = 7)
  int callframe7930 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7931 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7930);
// compiled member node returning call7931 (depth = 7)
  int op_slot_left_7927 = gc_frame_newslot(call7931);
  params[0] = strlit7928;
  partcv[0] = 1;
  Object opresult7932 = callmethod(call7931, "==(1)", 1, partcv, params);
// compiled op node returning opresult7932 (depth = 6)
  int op_slot_left_7918 = gc_frame_newslot(opresult7932);
  params[0] = opresult7925;
  partcv[0] = 1;
  Object opresult7933 = callmethod(opresult7932, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7933 (depth = 5)
  Object if7917 = done;
  if (istrue(opresult7933)) {
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7934 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7936 == NULL) {
    strlit7936 = alloc_String("""\x22""");
    gc_root(strlit7936);
  }
// compiled string node returning strlit7936 (depth = 7)
  int op_slot_right_7935 = gc_frame_newslot(strlit7936);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7940 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7939);
// compiled member node returning call7940 (depth = 8)
  int op_slot_right_7938 = gc_frame_newslot(call7940);
// starting to compile string node (depth = 8)
  if (strlit7942 == NULL) {
    strlit7942 = alloc_String("""\x22""");
    gc_root(strlit7942);
  }
// compiled string node returning strlit7942 (depth = 8)
  int op_slot_left_7938 = gc_frame_newslot(strlit7942);
  params[0] = call7940;
  partcv[0] = 1;
  Object opresult7943 = callmethod(strlit7942, "++(1)", 1, partcv, params);
// compiled op node returning opresult7943 (depth = 7)
  int op_slot_left_7935 = gc_frame_newslot(opresult7943);
  params[0] = strlit7936;
  partcv[0] = 1;
  Object opresult7944 = callmethod(opresult7943, "++(1)", 1, partcv, params);
// compiled op node returning opresult7944 (depth = 6)
  gc_frame_newslot(opresult7944);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7944;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7945 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7934);
// compiled call node returning call7945 (depth = 5)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7946 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7947 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7946);
// compiled member node returning call7947 (depth = 6)
  *var_errorPos = call7947;
  if (call7947 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7917 = done;
  } else {
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7949 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7950 == NULL) {
    strlit7950 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7950);
  }
// compiled string node returning strlit7950 (depth = 6)
  gc_frame_newslot(strlit7950);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7950;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7951 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7949);
// compiled call node returning call7951 (depth = 5)
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7953 = alloc_Float64(1);
// compiled num node returning num7953 (depth = 7)
  int op_slot_right_7952 = gc_frame_newslot(num7953);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7957 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7956);
// compiled member node returning call7957 (depth = 8)
  int op_slot_right_7955 = gc_frame_newslot(call7957);
// starting to compile member node (depth = 8)
  int callframe7959 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7960 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7959);
// compiled member node returning call7960 (depth = 8)
  int op_slot_left_7955 = gc_frame_newslot(call7960);
  params[0] = call7957;
  partcv[0] = 1;
  Object sum7961 = callmethod(call7960, "+(1)", 1, partcv, params);
// compiled op node returning sum7961 (depth = 7)
  int op_slot_left_7952 = gc_frame_newslot(sum7961);
  params[0] = num7953;
  partcv[0] = 1;
  Object sum7962 = callmethod(sum7961, "+(1)", 1, partcv, params);
// compiled op node returning sum7962 (depth = 6)
  *var_errorPos = sum7962;
  if (sum7962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7917 = done;
  }
// compiled if node returning if7917 (depth = 4)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7964 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7965 == NULL) {
    strlit7965 = alloc_String("an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit7965);
  }
// compiled string node returning strlit7965 (depth = 5)
  gc_frame_newslot(strlit7965);
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7966 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7967 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7966);
// compiled member node returning call7967 (depth = 5)
  gc_frame_newslot(call7967);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7965;
  params[1] = call7967;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7968 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7964);
// compiled call node returning call7968 (depth = 4)
    gc_frame_newslot(call7968);
    if7906 = call7968;
  } else {
  }
// compiled if node returning if7906 (depth = 3)
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7969 = gc_frame_new();
// call case 4: self request
  Object call7970 = callmethodflags(self, "pushstring", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7969);
// compiled member node returning call7970 (depth = 3)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call7972 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7971);
// compiled member node returning call7972 (depth = 4)
  *var_p = call7972;
  if (call7972 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7976 == NULL) {
    strlit7976 = alloc_String("as");
    gc_root(strlit7976);
  }
// compiled string node returning strlit7976 (depth = 6)
  int op_slot_right_7975 = gc_frame_newslot(strlit7976);
// starting to compile member node (depth = 6)
  int callframe7978 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7979 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7978);
// compiled member node returning call7979 (depth = 6)
  int op_slot_left_7975 = gc_frame_newslot(call7979);
  params[0] = strlit7976;
  partcv[0] = 1;
  Object opresult7980 = callmethod(call7979, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7980 (depth = 5)
  int op_slot_right_7974 = gc_frame_newslot(opresult7980);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7983 == NULL) {
    strlit7983 = alloc_String("identifier");
    gc_root(strlit7983);
  }
// compiled string node returning strlit7983 (depth = 6)
  int op_slot_right_7982 = gc_frame_newslot(strlit7983);
// starting to compile member node (depth = 6)
  int callframe7985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7986 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7985);
// compiled member node returning call7986 (depth = 6)
  int op_slot_left_7982 = gc_frame_newslot(call7986);
  params[0] = strlit7983;
  partcv[0] = 1;
  Object opresult7987 = callmethod(call7986, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7987 (depth = 5)
  int op_slot_left_7974 = gc_frame_newslot(opresult7987);
  params[0] = opresult7980;
  partcv[0] = 1;
  Object opresult7988 = callmethod(opresult7987, "||(1)", 1, partcv, params);
// compiled op node returning opresult7988 (depth = 4)
  Object if7973 = done;
  if (istrue(opresult7988)) {
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7989 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7990 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7991 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7990);
// compiled member node returning call7991 (depth = 6)
  Object call7992 = callmethodflags(call7991, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7989);
// compiled member node returning call7992 (depth = 5)
  *var_suggestion = call7992;
  if (call7992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7996 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7997 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7996);
// compiled member node returning call7997 (depth = 7)
  int op_slot_right_7995 = gc_frame_newslot(call7997);
// starting to compile member node (depth = 7)
  int callframe7999 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8000 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7999);
// compiled member node returning call8000 (depth = 7)
  int op_slot_left_7995 = gc_frame_newslot(call8000);
  params[0] = call7997;
  partcv[0] = 1;
  Object opresult8001 = callmethod(call8000, "==(1)", 1, partcv, params);
// compiled op node returning opresult8001 (depth = 6)
  int op_slot_right_7994 = gc_frame_newslot(opresult8001);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8004 == NULL) {
    strlit8004 = alloc_String("identifier");
    gc_root(strlit8004);
  }
// compiled string node returning strlit8004 (depth = 7)
  int op_slot_right_8003 = gc_frame_newslot(strlit8004);
// starting to compile member node (depth = 7)
  int callframe8006 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8007 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8006);
// compiled member node returning call8007 (depth = 7)
  int op_slot_left_8003 = gc_frame_newslot(call8007);
  params[0] = strlit8004;
  partcv[0] = 1;
  Object opresult8008 = callmethod(call8007, "==(1)", 1, partcv, params);
// compiled op node returning opresult8008 (depth = 6)
  int op_slot_left_7994 = gc_frame_newslot(opresult8008);
  params[0] = opresult8001;
  partcv[0] = 1;
  Object opresult8009 = callmethod(opresult8008, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8009 (depth = 5)
  Object if7993 = done;
  if (istrue(opresult8009)) {
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8010 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8011 == NULL) {
    strlit8011 = alloc_String(" as");
    gc_root(strlit8011);
  }
// compiled string node returning strlit8011 (depth = 6)
  gc_frame_newslot(strlit8011);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8011;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8012 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8010);
// compiled call node returning call8012 (depth = 5)
    gc_frame_newslot(call8012);
    if7993 = call8012;
  } else {
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8013 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8015 == NULL) {
    strlit8015 = alloc_String("");
    gc_root(strlit8015);
  }
// compiled string node returning strlit8015 (depth = 7)
  int op_slot_right_8014 = gc_frame_newslot(strlit8015);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  Object call8019 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8018);
// compiled member node returning call8019 (depth = 8)
  int op_slot_right_8017 = gc_frame_newslot(call8019);
// starting to compile string node (depth = 8)
  if (strlit8021 == NULL) {
    strlit8021 = alloc_String(" as ");
    gc_root(strlit8021);
  }
// compiled string node returning strlit8021 (depth = 8)
  int op_slot_left_8017 = gc_frame_newslot(strlit8021);
  params[0] = call8019;
  partcv[0] = 1;
  Object opresult8022 = callmethod(strlit8021, "++(1)", 1, partcv, params);
// compiled op node returning opresult8022 (depth = 7)
  int op_slot_left_8014 = gc_frame_newslot(opresult8022);
  params[0] = strlit8015;
  partcv[0] = 1;
  Object opresult8023 = callmethod(opresult8022, "++(1)", 1, partcv, params);
// compiled op node returning opresult8023 (depth = 6)
  gc_frame_newslot(opresult8023);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult8023;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8024 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8013);
// compiled call node returning call8024 (depth = 5)
    gc_frame_newslot(call8024);
    if7993 = call8024;
  }
// compiled if node returning if7993 (depth = 4)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8025 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8026 == NULL) {
    strlit8026 = alloc_String("an import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit8026);
  }
// compiled string node returning strlit8026 (depth = 5)
  gc_frame_newslot(strlit8026);
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8028 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8027);
// compiled member node returning call8028 (depth = 5)
  gc_frame_newslot(call8028);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8030 = alloc_Float64(1);
// compiled num node returning num8030 (depth = 6)
  int op_slot_right_8029 = gc_frame_newslot(num8030);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8034 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8033);
// compiled member node returning call8034 (depth = 7)
  int op_slot_right_8032 = gc_frame_newslot(call8034);
// starting to compile member node (depth = 7)
  int callframe8036 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8037 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8036);
// compiled member node returning call8037 (depth = 7)
  int op_slot_left_8032 = gc_frame_newslot(call8037);
  params[0] = call8034;
  partcv[0] = 1;
  Object sum8038 = callmethod(call8037, "+(1)", 1, partcv, params);
// compiled op node returning sum8038 (depth = 6)
  int op_slot_left_8029 = gc_frame_newslot(sum8038);
  params[0] = num8030;
  partcv[0] = 1;
  Object sum8039 = callmethod(sum8038, "+(1)", 1, partcv, params);
// compiled op node returning sum8039 (depth = 5)
  gc_frame_newslot(sum8039);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8026;
  params[1] = call8028;
  params[2] = sum8039;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8040 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8025);
// compiled call node returning call8040 (depth = 4)
    gc_frame_newslot(call8040);
    if7973 = call8040;
  } else {
  }
// compiled if node returning if7973 (depth = 3)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8041 = gc_frame_new();
// call case 4: self request
  Object call8042 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8041);
// compiled member node returning call8042 (depth = 3)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8045 == NULL) {
    strlit8045 = alloc_String("identifier");
    gc_root(strlit8045);
  }
// compiled string node returning strlit8045 (depth = 5)
  int op_slot_right_8044 = gc_frame_newslot(strlit8045);
// starting to compile member node (depth = 5)
  int callframe8047 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8048 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8047);
// compiled member node returning call8048 (depth = 5)
  int op_slot_left_8044 = gc_frame_newslot(call8048);
  params[0] = strlit8045;
  partcv[0] = 1;
  Object opresult8049 = callmethod(call8048, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8049 (depth = 4)
  Object if8043 = done;
  if (istrue(opresult8049)) {
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8050 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8052 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8051);
// compiled member node returning call8052 (depth = 6)
  Object call8053 = callmethodflags(call8052, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8050);
// compiled member node returning call8053 (depth = 5)
  *var_suggestion = call8053;
  if (call8053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8058 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8057);
// compiled member node returning call8058 (depth = 7)
  int op_slot_right_8056 = gc_frame_newslot(call8058);
// starting to compile member node (depth = 7)
  int callframe8060 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8061 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8060);
// compiled member node returning call8061 (depth = 7)
  int op_slot_left_8056 = gc_frame_newslot(call8061);
  params[0] = call8058;
  partcv[0] = 1;
  Object opresult8062 = callmethod(call8061, "==(1)", 1, partcv, params);
// compiled op node returning opresult8062 (depth = 6)
  int op_slot_right_8055 = gc_frame_newslot(opresult8062);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8065 == NULL) {
    strlit8065 = alloc_String("string");
    gc_root(strlit8065);
  }
// compiled string node returning strlit8065 (depth = 7)
  int op_slot_right_8064 = gc_frame_newslot(strlit8065);
// starting to compile member node (depth = 7)
  int callframe8067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8068 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8067);
// compiled member node returning call8068 (depth = 7)
  int op_slot_left_8064 = gc_frame_newslot(call8068);
  params[0] = strlit8065;
  partcv[0] = 1;
  Object opresult8069 = callmethod(call8068, "==(1)", 1, partcv, params);
// compiled op node returning opresult8069 (depth = 6)
  int op_slot_left_8055 = gc_frame_newslot(opresult8069);
  params[0] = opresult8062;
  partcv[0] = 1;
  Object opresult8070 = callmethod(opresult8069, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8070 (depth = 5)
  Object if8054 = done;
  if (istrue(opresult8070)) {
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8071 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8073 == NULL) {
    strlit8073 = alloc_String("");
    gc_root(strlit8073);
  }
// compiled string node returning strlit8073 (depth = 7)
  int op_slot_right_8072 = gc_frame_newslot(strlit8073);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8077 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8076);
// compiled member node returning call8077 (depth = 8)
  int op_slot_right_8075 = gc_frame_newslot(call8077);
// starting to compile string node (depth = 8)
  if (strlit8079 == NULL) {
    strlit8079 = alloc_String("");
    gc_root(strlit8079);
  }
// compiled string node returning strlit8079 (depth = 8)
  int op_slot_left_8075 = gc_frame_newslot(strlit8079);
  params[0] = call8077;
  partcv[0] = 1;
  Object opresult8080 = callmethod(strlit8079, "++(1)", 1, partcv, params);
// compiled op node returning opresult8080 (depth = 7)
  int op_slot_left_8072 = gc_frame_newslot(opresult8080);
  params[0] = strlit8073;
  partcv[0] = 1;
  Object opresult8081 = callmethod(opresult8080, "++(1)", 1, partcv, params);
// compiled op node returning opresult8081 (depth = 6)
  gc_frame_newslot(opresult8081);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult8081;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8082 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8071);
// compiled call node returning call8082 (depth = 5)
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8083 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8084 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8083);
// compiled member node returning call8084 (depth = 6)
  *var_errorPos = call8084;
  if (call8084 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8054 = done;
  } else {
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8086 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8088 == NULL) {
    strlit8088 = alloc_String("");
    gc_root(strlit8088);
  }
// compiled string node returning strlit8088 (depth = 7)
  int op_slot_right_8087 = gc_frame_newslot(strlit8088);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8091 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  Object call8092 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8091);
// compiled member node returning call8092 (depth = 8)
  int op_slot_right_8090 = gc_frame_newslot(call8092);
// starting to compile string node (depth = 8)
  if (strlit8094 == NULL) {
    strlit8094 = alloc_String(" ");
    gc_root(strlit8094);
  }
// compiled string node returning strlit8094 (depth = 8)
  int op_slot_left_8090 = gc_frame_newslot(strlit8094);
  params[0] = call8092;
  partcv[0] = 1;
  Object opresult8095 = callmethod(strlit8094, "++(1)", 1, partcv, params);
// compiled op node returning opresult8095 (depth = 7)
  int op_slot_left_8087 = gc_frame_newslot(opresult8095);
  params[0] = strlit8088;
  partcv[0] = 1;
  Object opresult8096 = callmethod(opresult8095, "++(1)", 1, partcv, params);
// compiled op node returning opresult8096 (depth = 6)
  gc_frame_newslot(opresult8096);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult8096;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8097 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8086);
// compiled call node returning call8097 (depth = 5)
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8099 = alloc_Float64(1);
// compiled num node returning num8099 (depth = 7)
  int op_slot_right_8098 = gc_frame_newslot(num8099);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call8103 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8102);
// compiled member node returning call8103 (depth = 8)
  int op_slot_right_8101 = gc_frame_newslot(call8103);
// starting to compile member node (depth = 8)
  int callframe8105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call8106 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8105);
// compiled member node returning call8106 (depth = 8)
  int op_slot_left_8101 = gc_frame_newslot(call8106);
  params[0] = call8103;
  partcv[0] = 1;
  Object sum8107 = callmethod(call8106, "+(1)", 1, partcv, params);
// compiled op node returning sum8107 (depth = 7)
  int op_slot_left_8098 = gc_frame_newslot(sum8107);
  params[0] = num8099;
  partcv[0] = 1;
  Object sum8108 = callmethod(sum8107, "+(1)", 1, partcv, params);
// compiled op node returning sum8108 (depth = 6)
  *var_errorPos = sum8108;
  if (sum8108 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8054 = done;
  }
// compiled if node returning if8054 (depth = 4)
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8110 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8111 == NULL) {
    strlit8111 = alloc_String("an import statement must have an identifier after 'as'.");
    gc_root(strlit8111);
  }
// compiled string node returning strlit8111 (depth = 5)
  gc_frame_newslot(strlit8111);
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8113 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8112);
// compiled member node returning call8113 (depth = 5)
  gc_frame_newslot(call8113);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8111;
  params[1] = call8113;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8114 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8110);
// compiled call node returning call8114 (depth = 4)
    gc_frame_newslot(call8114);
    if8043 = call8114;
  } else {
  }
// compiled if node returning if8043 (depth = 3)
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8115 = gc_frame_new();
// call case 4: self request
  Object call8116 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8115);
// compiled member node returning call8116 (depth = 3)
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call8118 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8117);
// compiled member node returning call8118 (depth = 4)
  *var_name = call8118;
  if (call8118 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8119 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8120 = alloc_Boolean(1);
// compiled identifier node returning bool8120 (depth = 4)
  gc_frame_newslot(bool8120);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool8120;
  partcv[0] = 1;
  Object call8121 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8119);
// compiled call node returning call8121 (depth = 3)
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8122 = gc_frame_new();
// call case 4: self request
  Object call8123 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8122);
// compiled member node returning call8123 (depth = 4)
  *var_dtype = call8123;
  if (call8123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8124 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importSym (depth = 5)
  gc_frame_newslot(*var_importSym);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8125 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8126 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  Object call8127 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8126);
// compiled member node returning call8127 (depth = 6)
  gc_frame_newslot(call8127);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8128 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call8129 = callmethodflags(*var_ast, "importNode", 0, partcv, params, 0);
  gc_frame_end(callframe8128);
// compiled member node returning call8129 (depth = 6)
  params[0] = call8127;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call8130 = callmethodflags(call8129, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8125);
// compiled call node returning call8130 (depth = 5)
  params[0] = *var_importSym;
  partcv[0] = 1;
  Object call8131 = callmethodflags(call8130, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8124);
// compiled call node returning call8131 (depth = 4)
  *var_o = call8131;
  if (call8131 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8132 = gc_frame_new();
// call case 4: self request
  Object call8133 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8132);
// compiled member node returning call8133 (depth = 4)
  *var_anns = call8133;
  if (call8133 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8135 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8137 = alloc_Boolean(0);
// compiled identifier node returning bool8137 (depth = 5)
  int op_slot_left_8135 = gc_frame_newslot(bool8137);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8138 = callmethod(bool8137, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8138 (depth = 4)
  Object if8134 = done;
  if (istrue(opresult8138)) {
// starting to compile call node (depth = 4)
  int callframe8139 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call8141 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe8140);
// compiled member node returning call8141 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8142 = callmethodflags(call8141, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8139);
// compiled call node returning call8142 (depth = 4)
    gc_frame_newslot(call8142);
    if8134 = call8142;
  } else {
  }
// compiled if node returning if8134 (depth = 3)
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8143 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8144 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8143);
// compiled call node returning call8144 (depth = 3)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8145 = gc_frame_new();
// call case 4: self request
  Object call8146 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8145);
// compiled member node returning call8146 (depth = 3)
    gc_frame_newslot(call8146);
    if7900 = call8146;
  } else {
  }
// compiled if node returning if7900 (depth = 2)
  gc_frame_end(frame);
  return if7900;
}
Object meth_parser_8157__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe8158 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe8159 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8160 == NULL) {
    strlit8160 = alloc_String("rbrace");
    gc_root(strlit8160);
  }
// compiled string node returning strlit8160 (depth = 8)
  gc_frame_newslot(strlit8160);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit8160;
  partcv[0] = 1;
  Object call8161 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8159);
// compiled call node returning call8161 (depth = 7)
  Object call8162 = callmethodflags(call8161, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8158);
// compiled member node returning call8162 (depth = 6)
  gc_frame_end(frame);
  return call8162;
}
Object meth_parser_8171__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe8172 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8173 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8172);
// compiled call node returning call8173 (depth = 7)
  gc_frame_end(frame);
  return call8173;
}
Object meth_parser_8147_doreturn(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// definebindings:
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8149 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8150 == NULL) {
    strlit8150 = alloc_String("return");
    gc_root(strlit8150);
  }
// compiled string node returning strlit8150 (depth = 4)
  gc_frame_newslot(strlit8150);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8150;
  partcv[0] = 1;
  Object call8151 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8149);
// compiled call node returning call8151 (depth = 3)
  Object if8148 = done;
  if (istrue(call8151)) {
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8152 = gc_frame_new();
// call case 4: self request
  Object call8153 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8152);
// compiled member node returning call8153 (depth = 3)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8156 = alloc_Block(NULL, NULL, "parser", 2749);
  gc_frame_newslot(block8156);
// method "_apply"
  block_savedest(block8156);
  Object closure8157 = createclosure(1, "_apply");
  setclosureframe(closure8157, stackframe);
  addtoclosure(closure8157, selfslot);
  struct UserObject *uo8157 = (struct UserObject*)block8156;
  uo8157->data[0] = (Object)closure8157;
  Method *meth_meth_parser_8157__apply = addmethod2pos(block8156, "_apply", &meth_parser_8157__apply, 0);
  int argcv_meth_parser_8157__apply[] = {0};
  meth_meth_parser_8157__apply->type = alloc_MethodType(1, argcv_meth_parser_8157__apply);
  meth_meth_parser_8157__apply->definitionModule = modulename;
  meth_meth_parser_8157__apply->definitionLine = 3208;
// compiled block node returning block8156 (depth = 5)
  int op_slot_right_8155 = gc_frame_newslot(block8156);
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8165 = gc_frame_new();
// call case 4: self request
  Object call8166 = callmethodflags(self, "tokenOnSameLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8165);
// compiled member node returning call8166 (depth = 5)
  int op_slot_left_8155 = gc_frame_newslot(call8166);
  params[0] = block8156;
  partcv[0] = 1;
  Object opresult8167 = callmethod(call8166, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8167 (depth = 4)
  Object if8154 = done;
  if (istrue(opresult8167)) {
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8169 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8170 = alloc_Block(NULL, NULL, "parser", 2750);
  gc_frame_newslot(block8170);
// method "_apply"
  block_savedest(block8170);
  Object closure8171 = createclosure(2, "_apply");
  setclosureframe(closure8171, stackframe);
  addtoclosure(closure8171, var_blocksOK);
  addtoclosure(closure8171, selfslot);
  struct UserObject *uo8171 = (struct UserObject*)block8170;
  uo8171->data[0] = (Object)closure8171;
  Method *meth_meth_parser_8171__apply = addmethod2pos(block8170, "_apply", &meth_parser_8171__apply, 0);
  int argcv_meth_parser_8171__apply[] = {0};
  meth_meth_parser_8171__apply->type = alloc_MethodType(1, argcv_meth_parser_8171__apply);
  meth_meth_parser_8171__apply->definitionModule = modulename;
  meth_meth_parser_8171__apply->definitionLine = 3208;
// compiled block node returning block8170 (depth = 6)
  gc_frame_newslot(block8170);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block8170;
  partcv[0] = 1;
  Object call8175 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8169);
// compiled call node returning call8175 (depth = 5)
  Object if8168 = done;
  if (istrue(call8175)) {
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array8176 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8176 (depth = 6)
  *var_suggestions = array8176;
  if (array8176 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8177 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8179 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8178);
// compiled member node returning call8179 (depth = 7)
  Object call8180 = callmethodflags(call8179, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8177);
// compiled member node returning call8180 (depth = 6)
  *var_suggestion = call8180;
  if (call8180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8181 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array8182 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit8183 == NULL) {
    strlit8183 = alloc_String("rbrace");
    gc_root(strlit8183);
  }
// compiled string node returning strlit8183 (depth = 8)
  params[0] = strlit8183;
  partcv[0] = 1;
  callmethodflags(array8182, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8182 (depth = 7)
  gc_frame_newslot(array8182);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array8182;
  partcv[0] = 1;
  Object call8184 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8181);
// compiled call node returning call8184 (depth = 6)
  *var_nextTok = call8184;
  if (call8184 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_8186 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_8186 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8188 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult8188 (depth = 6)
  Object if8185 = done;
  if (istrue(opresult8188)) {
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8189 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8190 == NULL) {
    strlit8190 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit8190);
  }
// compiled string node returning strlit8190 (depth = 7)
  gc_frame_newslot(strlit8190);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8190;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8191 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8189);
// compiled call node returning call8191 (depth = 6)
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8192 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8193 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8192);
// compiled call node returning call8193 (depth = 6)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8194 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call8196 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8195);
// compiled member node returning call8196 (depth = 8)
  Object call8197 = callmethodflags(call8196, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8194);
// compiled member node returning call8197 (depth = 7)
  *var_suggestion = call8197;
  if (call8197 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8199 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool8200 = alloc_Boolean(1);
// compiled identifier node returning bool8200 (depth = 7)
  gc_frame_newslot(bool8200);
// starting to compile identifier node (depth = 7)
  Object bool8201 = alloc_Boolean(0);
// compiled identifier node returning bool8201 (depth = 7)
  gc_frame_newslot(bool8201);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool8200;
  params[2] = bool8201;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8202 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8199);
// compiled call node returning call8202 (depth = 6)
    gc_frame_newslot(call8202);
    if8185 = call8202;
  } else {
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8203 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe8204 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call8205 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe8204);
// compiled member node returning call8205 (depth = 7)
  gc_frame_newslot(call8205);
// starting to compile identifier node (depth = 7)
  Object bool8206 = alloc_Boolean(1);
// compiled identifier node returning bool8206 (depth = 7)
  gc_frame_newslot(bool8206);
// starting to compile identifier node (depth = 7)
  Object bool8207 = alloc_Boolean(0);
// compiled identifier node returning bool8207 (depth = 7)
  gc_frame_newslot(bool8207);
// starting to compile string node (depth = 7)
  if (strlit8208 == NULL) {
    strlit8208 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit8208);
  }
// compiled string node returning strlit8208 (depth = 7)
  gc_frame_newslot(strlit8208);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call8205;
  params[2] = bool8206;
  params[3] = bool8207;
  params[4] = strlit8208;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call8209 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe8203);
// compiled call node returning call8209 (depth = 6)
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8210 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8211 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8210);
// compiled call node returning call8211 (depth = 6)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8212 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call8214 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8213);
// compiled member node returning call8214 (depth = 8)
  Object call8215 = callmethodflags(call8214, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8212);
// compiled member node returning call8215 (depth = 7)
  *var_suggestion = call8215;
  if (call8215 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8217 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe8218 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call8219 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe8218);
// compiled member node returning call8219 (depth = 7)
  gc_frame_newslot(call8219);
// starting to compile identifier node (depth = 7)
  Object bool8220 = alloc_Boolean(1);
// compiled identifier node returning bool8220 (depth = 7)
  gc_frame_newslot(bool8220);
// starting to compile identifier node (depth = 7)
  Object bool8221 = alloc_Boolean(0);
// compiled identifier node returning bool8221 (depth = 7)
  gc_frame_newslot(bool8221);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call8219;
  params[2] = bool8220;
  params[3] = bool8221;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8222 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8217);
// compiled call node returning call8222 (depth = 6)
    gc_frame_newslot(call8222);
    if8185 = call8222;
  }
// compiled if node returning if8185 (depth = 5)
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8223 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8224 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8223);
// compiled call node returning call8224 (depth = 5)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8225 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8227 == NULL) {
    strlit8227 = alloc_String("an expression or a newline after the word 'return'.");
    gc_root(strlit8227);
  }
// compiled string node returning strlit8227 (depth = 7)
  int op_slot_right_8226 = gc_frame_newslot(strlit8227);
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8229 == NULL) {
    strlit8229 = alloc_String("a return statement must have ");
    gc_root(strlit8229);
  }
// compiled string node returning strlit8229 (depth = 7)
  int op_slot_left_8226 = gc_frame_newslot(strlit8229);
  params[0] = strlit8227;
  partcv[0] = 1;
  Object opresult8230 = callmethod(strlit8229, "++(1)", 1, partcv, params);
// compiled op node returning opresult8230 (depth = 6)
  gc_frame_newslot(opresult8230);
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8231 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8232 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8231);
// compiled member node returning call8232 (depth = 6)
  gc_frame_newslot(call8232);
// starting to compile member node (depth = 6)
  int callframe8233 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8234 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8233);
// compiled member node returning call8234 (depth = 6)
  gc_frame_newslot(call8234);
// starting to compile member node (depth = 6)
  int callframe8235 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8236 = callmethodflags(*var_sym, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe8235);
// compiled member node returning call8236 (depth = 6)
  gc_frame_newslot(call8236);
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult8230;
  params[1] = call8232;
  params[2] = call8234;
  params[3] = call8236;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8237 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8225);
// compiled call node returning call8237 (depth = 5)
    gc_frame_newslot(call8237);
    if8168 = call8237;
  } else {
  }
// compiled if node returning if8168 (depth = 4)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8238 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call8239 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8238);
// compiled member node returning call8239 (depth = 5)
  *var_retval = call8239;
  if (call8239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8154 = done;
  } else {
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8241 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call8243 = callmethodflags(*var_ast, "noPosition", 0, partcv, params, 0);
  gc_frame_end(callframe8242);
// compiled member node returning call8243 (depth = 6)
  gc_frame_newslot(call8243);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8244 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8245 == NULL) {
    strlit8245 = alloc_String("done");
    gc_root(strlit8245);
  }
// compiled string node returning strlit8245 (depth = 7)
  gc_frame_newslot(strlit8245);
// starting to compile identifier node (depth = 7)
  Object bool8246 = alloc_Boolean(0);
// compiled identifier node returning bool8246 (depth = 7)
  gc_frame_newslot(bool8246);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call8248 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe8247);
// compiled member node returning call8248 (depth = 7)
  params[0] = strlit8245;
  params[1] = bool8246;
  partcv[0] = 2;
  Object call8249 = callmethodflags(call8248, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8244);
// compiled call node returning call8249 (depth = 6)
  params[0] = call8243;
  partcv[0] = 1;
  Object call8250 = callmethodflags(call8249, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8241);
// compiled call node returning call8250 (depth = 5)
  *var_retval = call8250;
  if (call8250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8252 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8254 = callmethodflags(*var_ast, "noPosition", 0, partcv, params, 0);
  gc_frame_end(callframe8253);
// compiled member node returning call8254 (depth = 5)
  gc_frame_newslot(call8254);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  params[0] = call8254;
  partcv[0] = 1;
  Object call8255 = callmethodflags(*var_retval, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8252);
// compiled call node returning call8255 (depth = 4)
    gc_frame_newslot(call8255);
    if8154 = call8255;
  }
// compiled if node returning if8154 (depth = 3)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8256 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  Object call8258 = callmethodflags(*var_retTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8257);
// compiled member node returning call8258 (depth = 4)
  gc_frame_newslot(call8258);
// starting to compile member node (depth = 4)
  int callframe8259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  Object call8260 = callmethodflags(*var_retTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8259);
// compiled member node returning call8260 (depth = 4)
  gc_frame_newslot(call8260);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8258;
  params[1] = call8260;
  partcv[0] = 2;
  Object call8261 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8256);
// compiled call node returning call8261 (depth = 3)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8262 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8263 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8264 = callmethodflags(*var_ast, "returnNode", 0, partcv, params, 0);
  gc_frame_end(callframe8263);
// compiled member node returning call8264 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call8265 = callmethodflags(call8264, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8262);
// compiled call node returning call8265 (depth = 4)
  *var_o = call8265;
  if (call8265 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8266 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8267 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8266);
// compiled call node returning call8267 (depth = 3)
    gc_frame_newslot(call8267);
    if8148 = call8267;
  } else {
  }
// compiled if node returning if8148 (depth = 2)
  gc_frame_end(frame);
  return if8148;
}
Object meth_parser_8268_domethodtype(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_methNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methNode");
  Object *var_dtype = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dtype");
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_newLine = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newLine");
// definebindings:
// definebindings:
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8269 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8270 = alloc_Boolean(1);
// compiled identifier node returning bool8270 (depth = 4)
  gc_frame_newslot(bool8270);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool8270;
  partcv[0] = 1;
  Object call8271 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8269);
// compiled call node returning call8271 (depth = 3)
  *var_methNode = call8271;
  if (call8271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe8272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  Object call8273 = callmethodflags(*var_methNode, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe8272);
// compiled member node returning call8273 (depth = 3)
  *var_dtype = call8273;
  if (call8273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8276 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methNode (depth = 5)
  Object call8277 = callmethodflags(*var_methNode, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe8276);
// compiled member node returning call8277 (depth = 4)
  int op_slot_right_8275 = gc_frame_newslot(call8277);
// starting to compile identifier node (depth = 4)
  Object bool8279 = alloc_Boolean(0);
// compiled identifier node returning bool8279 (depth = 4)
  int op_slot_left_8275 = gc_frame_newslot(bool8279);
  params[0] = call8277;
  partcv[0] = 1;
  Object opresult8280 = callmethod(bool8279, "==(1)", 1, partcv, params);
// compiled op node returning opresult8280 (depth = 3)
  Object if8274 = done;
  if (istrue(opresult8280)) {
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8281 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8282 == NULL) {
    strlit8282 = alloc_String("Done");
    gc_root(strlit8282);
  }
// compiled string node returning strlit8282 (depth = 5)
  gc_frame_newslot(strlit8282);
// starting to compile identifier node (depth = 5)
  Object bool8283 = alloc_Boolean(0);
// compiled identifier node returning bool8283 (depth = 5)
  gc_frame_newslot(bool8283);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8285 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe8284);
// compiled member node returning call8285 (depth = 5)
  params[0] = strlit8282;
  params[1] = bool8283;
  partcv[0] = 2;
  Object call8286 = callmethodflags(call8285, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8281);
// compiled call node returning call8286 (depth = 4)
  *var_dtype = call8286;
  if (call8286 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8274 = done;
  } else {
  }
// compiled if node returning if8274 (depth = 2)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8288 = gc_frame_new();
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodTypeTok (depth = 4)
  gc_frame_newslot(*var_methodTypeTok);
// call case 6: other requests
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8289 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8290 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  Object call8291 = callmethodflags(*var_methNode, "signature", 0, partcv, params, 0);
  gc_frame_end(callframe8290);
// compiled member node returning call8291 (depth = 5)
  gc_frame_newslot(call8291);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8293 = callmethodflags(*var_ast, "methodTypeNode", 0, partcv, params, 0);
  gc_frame_end(callframe8292);
// compiled member node returning call8293 (depth = 5)
  params[0] = call8291;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call8294 = callmethodflags(call8293, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8289);
// compiled call node returning call8294 (depth = 4)
  params[0] = *var_methodTypeTok;
  partcv[0] = 1;
  Object call8295 = callmethodflags(call8294, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8288);
// compiled call node returning call8295 (depth = 3)
  *var_o = call8295;
  if (call8295 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8296 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe8297 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  Object call8298 = callmethodflags(*var_methNode, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe8297);
// compiled member node returning call8298 (depth = 3)
  gc_frame_newslot(call8298);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call8298;
  partcv[0] = 1;
  Object call8299 = callmethodflags(*var_o, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8296);
// compiled call node returning call8299 (depth = 2)
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8300 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8301 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8300);
// compiled call node returning call8301 (depth = 2)
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8302 = gc_frame_new();
// call case 4: self request
  Object call8303 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8302);
// compiled member node returning call8303 (depth = 2)
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8305 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8306 == NULL) {
    strlit8306 = alloc_String("semicolon");
    gc_root(strlit8306);
  }
// compiled string node returning strlit8306 (depth = 4)
  gc_frame_newslot(strlit8306);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8306;
  partcv[0] = 1;
  Object call8307 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8305);
// compiled call node returning call8307 (depth = 3)
  Object if8304 = done;
  if (istrue(call8307)) {
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8308 = gc_frame_new();
// call case 4: self request
  Object call8309 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8308);
// compiled member node returning call8309 (depth = 3)
    gc_frame_newslot(call8309);
    if8304 = call8309;
  } else {
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8311 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8312 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8313 == NULL) {
    strlit8313 = alloc_String("rbrace");
    gc_root(strlit8313);
  }
// compiled string node returning strlit8313 (depth = 6)
  gc_frame_newslot(strlit8313);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit8313;
  partcv[0] = 1;
  Object call8314 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8312);
// compiled call node returning call8314 (depth = 5)
  partcv[0] = 0;
  Object call8315 = callmethodflags(call8314, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8311);
// compiled call node returning call8315 (depth = 4)
  Object if8310 = done;
  if (istrue(call8315)) {
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8319 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8318);
// compiled member node returning call8319 (depth = 6)
  int op_slot_right_8317 = gc_frame_newslot(call8319);
// starting to compile member node (depth = 6)
  int callframe8321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8322 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8321);
// compiled member node returning call8322 (depth = 6)
  int op_slot_left_8317 = gc_frame_newslot(call8322);
  params[0] = call8319;
  partcv[0] = 1;
  Object opresult8323 = callmethod(call8322, "==(1)", 1, partcv, params);
// compiled op node returning opresult8323 (depth = 5)
  Object if8316 = done;
  if (istrue(opresult8323)) {
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8324 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8326 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8325);
// compiled member node returning call8326 (depth = 7)
  Object call8327 = callmethodflags(call8326, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8324);
// compiled member node returning call8327 (depth = 6)
  *var_suggestion = call8327;
  if (call8327 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8329 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8330 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8329);
// compiled member node returning call8330 (depth = 7)
  int op_slot_right_8328 = gc_frame_newslot(call8330);
// starting to compile call node (depth = 7)
  int callframe8332 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8333 = alloc_Float64(1);
// compiled num node returning num8333 (depth = 8)
  gc_frame_newslot(num8333);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8335 = alloc_Float64(1);
// compiled num node returning num8335 (depth = 9)
  int op_slot_right_8334 = gc_frame_newslot(num8335);
// starting to compile member node (depth = 9)
  int callframe8337 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call8338 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8337);
// compiled member node returning call8338 (depth = 9)
  int op_slot_left_8334 = gc_frame_newslot(call8338);
  params[0] = num8335;
  partcv[0] = 1;
  Object diff8339 = callmethod(call8338, "-(1)", 1, partcv, params);
// compiled op node returning diff8339 (depth = 8)
  gc_frame_newslot(diff8339);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe8340 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe8341 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8342 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8341);
// compiled member node returning call8342 (depth = 9)
  gc_frame_newslot(call8342);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8343 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call8344 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe8343);
// compiled member node returning call8344 (depth = 9)
  params[0] = call8342;
  partcv[0] = 1;
  Object call8345 = callmethodflags(call8344, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8340);
// compiled call node returning call8345 (depth = 8)
  params[0] = num8333;
  params[1] = diff8339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8346 = callmethodflags(call8345, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8332);
// compiled call node returning call8346 (depth = 7)
  int op_slot_left_8328 = gc_frame_newslot(call8346);
  params[0] = call8330;
  partcv[0] = 1;
  Object opresult8347 = callmethod(call8346, "++(1)", 1, partcv, params);
// compiled op node returning opresult8347 (depth = 6)
  *var_newLine = opresult8347;
  if (opresult8347 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8348 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8350 = alloc_Float64(0.1);
// compiled num node returning num8350 (depth = 7)
  int op_slot_right_8349 = gc_frame_newslot(num8350);
// starting to compile member node (depth = 7)
  int callframe8352 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8353 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8352);
// compiled member node returning call8353 (depth = 7)
  int op_slot_left_8349 = gc_frame_newslot(call8353);
  params[0] = num8350;
  partcv[0] = 1;
  Object sum8354 = callmethod(call8353, "+(1)", 1, partcv, params);
// compiled op node returning sum8354 (depth = 6)
  gc_frame_newslot(sum8354);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum8354;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call8355 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8348);
// compiled call node returning call8355 (depth = 5)
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8356 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool8357 = alloc_Boolean(1);
// compiled identifier node returning bool8357 (depth = 6)
  gc_frame_newslot(bool8357);
// starting to compile identifier node (depth = 6)
  Object bool8358 = alloc_Boolean(1);
// compiled identifier node returning bool8358 (depth = 6)
  gc_frame_newslot(bool8358);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool8357;
  params[2] = bool8358;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8359 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8356);
// compiled call node returning call8359 (depth = 5)
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8360 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8361 == NULL) {
    strlit8361 = alloc_String("methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit8361);
  }
// compiled string node returning strlit8361 (depth = 6)
  gc_frame_newslot(strlit8361);
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8362 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8363 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8362);
// compiled member node returning call8363 (depth = 6)
  gc_frame_newslot(call8363);
// starting to compile member node (depth = 6)
  int callframe8364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8365 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8364);
// compiled member node returning call8365 (depth = 6)
  gc_frame_newslot(call8365);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8361;
  params[1] = call8363;
  params[2] = call8365;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8366 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8360);
// compiled call node returning call8366 (depth = 5)
    gc_frame_newslot(call8366);
    if8316 = call8366;
  } else {
  }
// compiled if node returning if8316 (depth = 4)
    gc_frame_newslot(if8316);
    if8310 = if8316;
  } else {
  }
// compiled if node returning if8310 (depth = 3)
    gc_frame_newslot(if8310);
    if8304 = if8310;
  }
// compiled if node returning if8304 (depth = 2)
  gc_frame_end(frame);
  return if8304;
}
Object meth_parser_8409__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe8410 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8411 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8412 == NULL) {
    strlit8412 = alloc_String("rbrace");
    gc_root(strlit8412);
  }
// compiled string node returning strlit8412 (depth = 7)
  gc_frame_newslot(strlit8412);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8412;
  partcv[0] = 1;
  Object call8413 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8413 (depth = 6)
  Object call8414 = callmethodflags(call8413, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8410);
// compiled member node returning call8414 (depth = 5)
  gc_frame_end(frame);
  return call8414;
}
Object meth_parser_8417__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_types = getfromclosure(closure, 1);
  Object *var_meths = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8419 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8420 == NULL) {
    strlit8420 = alloc_String("type");
    gc_root(strlit8420);
  }
// compiled string node returning strlit8420 (depth = 7)
  gc_frame_newslot(strlit8420);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8420;
  partcv[0] = 1;
  Object call8421 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8419);
// compiled call node returning call8421 (depth = 6)
  Object if8418 = done;
  if (istrue(call8421)) {
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8422 = gc_frame_new();
// call case 4: self request
  Object call8423 = callmethodflags(self, "typedec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8422);
// compiled member node returning call8423 (depth = 6)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8424 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call8426 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8425);
// compiled member node returning call8426 (depth = 7)
  gc_frame_newslot(call8426);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call8426;
  partcv[0] = 1;
  Object call8427 = callmethodflags(*var_types, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8424);
// compiled call node returning call8427 (depth = 6)
    gc_frame_newslot(call8427);
    if8418 = call8427;
  } else {
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8428 = gc_frame_new();
// call case 4: self request
  Object call8429 = callmethodflags(self, "domethodtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8428);
// compiled member node returning call8429 (depth = 6)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8430 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8431 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call8432 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8431);
// compiled member node returning call8432 (depth = 7)
  gc_frame_newslot(call8432);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call8432;
  partcv[0] = 1;
  Object call8433 = callmethodflags(*var_meths, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8430);
// compiled call node returning call8433 (depth = 6)
    gc_frame_newslot(call8433);
    if8418 = call8433;
  }
// compiled if node returning if8418 (depth = 5)
  gc_frame_end(frame);
  return if8418;
}
Object meth_parser_8367_dotypeLiteral(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// definebindings:
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8369 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8370 == NULL) {
    strlit8370 = alloc_String("type");
    gc_root(strlit8370);
  }
// compiled string node returning strlit8370 (depth = 4)
  gc_frame_newslot(strlit8370);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8370;
  partcv[0] = 1;
  Object call8371 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8369);
// compiled call node returning call8371 (depth = 3)
  Object if8368 = done;
  if (istrue(call8371)) {
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8372 = gc_frame_new();
// call case 4: self request
  Object call8373 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8372);
// compiled member node returning call8373 (depth = 3)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8375 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8376 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8377 == NULL) {
    strlit8377 = alloc_String("lbrace");
    gc_root(strlit8377);
  }
// compiled string node returning strlit8377 (depth = 6)
  gc_frame_newslot(strlit8377);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit8377;
  partcv[0] = 1;
  Object call8378 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8376);
// compiled call node returning call8378 (depth = 5)
  partcv[0] = 0;
  Object call8379 = callmethodflags(call8378, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8375);
// compiled call node returning call8379 (depth = 4)
  Object if8374 = done;
  if (istrue(call8379)) {
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8380 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8382 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8381);
// compiled member node returning call8382 (depth = 6)
  Object call8383 = callmethodflags(call8382, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8380);
// compiled member node returning call8383 (depth = 5)
  *var_suggestion = call8383;
  if (call8383 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8384 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit8385 == NULL) {
    strlit8385 = alloc_String("{");
    gc_root(strlit8385);
  }
// compiled string node returning strlit8385 (depth = 5)
  gc_frame_newslot(strlit8385);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit8385;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8386 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8384);
// compiled call node returning call8386 (depth = 4)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8387 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8388 == NULL) {
    strlit8388 = alloc_String("type literals must open with a brace.");
    gc_root(strlit8388);
  }
// compiled string node returning strlit8388 (depth = 5)
  gc_frame_newslot(strlit8388);
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8389 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8390 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8389);
// compiled member node returning call8390 (depth = 5)
  gc_frame_newslot(call8390);
// starting to compile member node (depth = 5)
  int callframe8391 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8392 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8391);
// compiled member node returning call8392 (depth = 5)
  gc_frame_newslot(call8392);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8388;
  params[1] = call8390;
  params[2] = call8392;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8393 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8387);
// compiled call node returning call8393 (depth = 4)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8374 = undefined;
  } else {
  }
// compiled if node returning if8374 (depth = 3)
    gc_frame_newslot(if8374);
    if8368 = if8374;
  } else {
  }
// compiled if node returning if8368 (depth = 2)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8395 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8396 == NULL) {
    strlit8396 = alloc_String("lbrace");
    gc_root(strlit8396);
  }
// compiled string node returning strlit8396 (depth = 4)
  gc_frame_newslot(strlit8396);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8396;
  partcv[0] = 1;
  Object call8397 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8395);
// compiled call node returning call8397 (depth = 3)
  Object if8394 = done;
  if (istrue(call8397)) {
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8398 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8398 (depth = 4)
  *var_meths = array8398;
  if (array8398 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8399 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8399 (depth = 4)
  *var_types = array8399;
  if (array8399 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8401 = alloc_Float64(1);
// compiled num node returning num8401 (depth = 5)
  int op_slot_right_8400 = gc_frame_newslot(num8401);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_8400 = gc_frame_newslot(*var_auto_count);
  params[0] = num8401;
  partcv[0] = 1;
  Object sum8403 = callmethod(*var_auto_count, "+(1)", 1, partcv, params);
// compiled op node returning sum8403 (depth = 4)
  *var_auto_count = sum8403;
  if (sum8403 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8405 = gc_frame_new();
// call case 4: self request
  Object call8406 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8405);
// compiled member node returning call8406 (depth = 3)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8407 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8408 = alloc_Block(NULL, NULL, "parser", 2830);
  gc_frame_newslot(block8408);
// method "_apply"
  block_savedest(block8408);
  Object closure8409 = createclosure(1, "_apply");
  setclosureframe(closure8409, stackframe);
  addtoclosure(closure8409, selfslot);
  struct UserObject *uo8409 = (struct UserObject*)block8408;
  uo8409->data[0] = (Object)closure8409;
  Method *meth_meth_parser_8409__apply = addmethod2pos(block8408, "_apply", &meth_parser_8409__apply, 0);
  int argcv_meth_parser_8409__apply[] = {0};
  meth_meth_parser_8409__apply->type = alloc_MethodType(1, argcv_meth_parser_8409__apply);
  meth_meth_parser_8409__apply->definitionModule = modulename;
  meth_meth_parser_8409__apply->definitionLine = 3208;
// compiled block node returning block8408 (depth = 4)
  gc_frame_newslot(block8408);
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8416 = alloc_Block(NULL, NULL, "parser", 2830);
  gc_frame_newslot(block8416);
// method "_apply"
  block_savedest(block8416);
  Object closure8417 = createclosure(4, "_apply");
  setclosureframe(closure8417, stackframe);
  addtoclosure(closure8417, var_values);
  addtoclosure(closure8417, var_types);
  addtoclosure(closure8417, var_meths);
  addtoclosure(closure8417, selfslot);
  struct UserObject *uo8417 = (struct UserObject*)block8416;
  uo8417->data[0] = (Object)closure8417;
  Method *meth_meth_parser_8417__apply = addmethod2pos(block8416, "_apply", &meth_parser_8417__apply, 0);
  int argcv_meth_parser_8417__apply[] = {0};
  meth_meth_parser_8417__apply->type = alloc_MethodType(1, argcv_meth_parser_8417__apply);
  meth_meth_parser_8417__apply->definitionModule = modulename;
  meth_meth_parser_8417__apply->definitionLine = 3208;
// compiled block node returning block8416 (depth = 4)
  gc_frame_newslot(block8416);
// call case 5: prelude request
  params[0] = block8408;
  params[1] = block8416;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8435 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8407);
// compiled call node returning call8435 (depth = 3)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8436 = gc_frame_new();
// call case 4: self request
  Object call8437 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8436);
// compiled member node returning call8437 (depth = 3)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8438 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8439 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  Object call8440 = callmethodflags(*var_typeLiteralTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8439);
// compiled member node returning call8440 (depth = 4)
  gc_frame_newslot(call8440);
// starting to compile member node (depth = 4)
  int callframe8441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  Object call8442 = callmethodflags(*var_typeLiteralTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8441);
// compiled member node returning call8442 (depth = 4)
  gc_frame_newslot(call8442);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8440;
  params[1] = call8442;
  partcv[0] = 2;
  Object call8443 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8438);
// compiled call node returning call8443 (depth = 3)
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8444 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8445 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8446 = callmethodflags(*var_ast, "typeLiteralNode", 0, partcv, params, 0);
  gc_frame_end(callframe8445);
// compiled member node returning call8446 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call8447 = callmethodflags(call8446, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8444);
// compiled call node returning call8447 (depth = 4)
  *var_t = call8447;
  if (call8447 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8448 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call8449 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8448);
// compiled call node returning call8449 (depth = 3)
    gc_frame_newslot(call8449);
    if8394 = call8449;
  } else {
  }
// compiled if node returning if8394 (depth = 2)
  gc_frame_end(frame);
  return if8394;
}
Object meth_parser_8539__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8541 == NULL) {
    strlit8541 = alloc_String("lbrace");
    gc_root(strlit8541);
  }
// compiled string node returning strlit8541 (depth = 8)
  int op_slot_right_8540 = gc_frame_newslot(strlit8541);
// starting to compile member node (depth = 8)
  int callframe8543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  Object call8544 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8543);
// compiled member node returning call8544 (depth = 8)
  int op_slot_left_8540 = gc_frame_newslot(call8544);
  params[0] = strlit8541;
  partcv[0] = 1;
  Object opresult8545 = callmethod(call8544, "==(1)", 1, partcv, params);
// compiled op node returning opresult8545 (depth = 7)
  gc_frame_end(frame);
  return opresult8545;
}
Object meth_parser_8551__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8552 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_8552 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8554 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult8554 (depth = 7)
  gc_frame_end(frame);
  return opresult8554;
}
Object meth_parser_8450_typedec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
// definebindings:
// definebindings:
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
// definebindings:
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8452 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8453 == NULL) {
    strlit8453 = alloc_String("type");
    gc_root(strlit8453);
  }
// compiled string node returning strlit8453 (depth = 4)
  gc_frame_newslot(strlit8453);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8453;
  partcv[0] = 1;
  Object call8454 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8452);
// compiled call node returning call8454 (depth = 3)
  Object if8451 = done;
  if (istrue(call8454)) {
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8456 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8455);
// compiled member node returning call8456 (depth = 4)
  *var_line = call8456;
  if (call8456 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8458 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8457);
// compiled member node returning call8458 (depth = 4)
  *var_pos = call8458;
  if (call8458 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8459 = gc_frame_new();
// call case 4: self request
  Object call8460 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8459);
// compiled member node returning call8460 (depth = 3)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8463 == NULL) {
    strlit8463 = alloc_String("identifier");
    gc_root(strlit8463);
  }
// compiled string node returning strlit8463 (depth = 5)
  int op_slot_right_8462 = gc_frame_newslot(strlit8463);
// starting to compile member node (depth = 5)
  int callframe8465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8466 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8465);
// compiled member node returning call8466 (depth = 5)
  int op_slot_left_8462 = gc_frame_newslot(call8466);
  params[0] = strlit8463;
  partcv[0] = 1;
  Object opresult8467 = callmethod(call8466, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8467 (depth = 4)
  Object if8461 = done;
  if (istrue(opresult8467)) {
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8468 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8470 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8469);
// compiled member node returning call8470 (depth = 6)
  Object call8471 = callmethodflags(call8470, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8468);
// compiled member node returning call8471 (depth = 5)
  *var_suggestion = call8471;
  if (call8471 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8472 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8473 == NULL) {
    strlit8473 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit8473);
  }
// compiled string node returning strlit8473 (depth = 5)
  gc_frame_newslot(strlit8473);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8473;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8474 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8472);
// compiled call node returning call8474 (depth = 4)
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8475 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8476 == NULL) {
    strlit8476 = alloc_String("a type declaration must have a name after the 'type'.");
    gc_root(strlit8476);
  }
// compiled string node returning strlit8476 (depth = 5)
  gc_frame_newslot(strlit8476);
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8477 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8478 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8477);
// compiled member node returning call8478 (depth = 5)
  gc_frame_newslot(call8478);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8480 = alloc_Float64(1);
// compiled num node returning num8480 (depth = 6)
  int op_slot_right_8479 = gc_frame_newslot(num8480);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8484 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8483);
// compiled member node returning call8484 (depth = 7)
  int op_slot_right_8482 = gc_frame_newslot(call8484);
// starting to compile member node (depth = 7)
  int callframe8486 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8487 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8486);
// compiled member node returning call8487 (depth = 7)
  int op_slot_left_8482 = gc_frame_newslot(call8487);
  params[0] = call8484;
  partcv[0] = 1;
  Object sum8488 = callmethod(call8487, "+(1)", 1, partcv, params);
// compiled op node returning sum8488 (depth = 6)
  int op_slot_left_8479 = gc_frame_newslot(sum8488);
  params[0] = num8480;
  partcv[0] = 1;
  Object sum8489 = callmethod(sum8488, "+(1)", 1, partcv, params);
// compiled op node returning sum8489 (depth = 5)
  gc_frame_newslot(sum8489);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8476;
  params[1] = call8478;
  params[2] = sum8489;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8490 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8475);
// compiled call node returning call8490 (depth = 4)
    gc_frame_newslot(call8490);
    if8461 = call8490;
  } else {
  }
// compiled if node returning if8461 (depth = 3)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8491 = gc_frame_new();
// call case 4: self request
  Object call8492 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8491);
// compiled member node returning call8492 (depth = 3)
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8493 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call8494 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8493);
// compiled call node returning call8494 (depth = 3)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8495 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8496 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call8497 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8496);
// compiled member node returning call8497 (depth = 5)
  gc_frame_newslot(call8497);
// starting to compile identifier node (depth = 5)
  Object bool8498 = alloc_Boolean(0);
// compiled identifier node returning bool8498 (depth = 5)
  gc_frame_newslot(bool8498);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8499 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call8500 = callmethodflags(*var_ast, "typeDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe8499);
// compiled member node returning call8500 (depth = 5)
  params[0] = call8497;
  params[1] = bool8498;
  partcv[0] = 2;
  Object call8501 = callmethodflags(call8500, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8495);
// compiled call node returning call8501 (depth = 4)
  *var_nt = call8501;
  if (call8501 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8503 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8504 == NULL) {
    strlit8504 = alloc_String("lgeneric");
    gc_root(strlit8504);
  }
// compiled string node returning strlit8504 (depth = 5)
  gc_frame_newslot(strlit8504);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8504;
  partcv[0] = 1;
  Object call8505 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8503);
// compiled call node returning call8505 (depth = 4)
  Object if8502 = done;
  if (istrue(call8505)) {
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8506 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8507 = gc_frame_new();
// call case 4: self request
  Object call8508 = callmethodflags(self, "typeparameters", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8507);
// compiled member node returning call8508 (depth = 5)
  gc_frame_newslot(call8508);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call8508;
  partcv[0] = 1;
  Object call8509 = callmethodflags(*var_nt, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8506);
// compiled call node returning call8509 (depth = 4)
    gc_frame_newslot(call8509);
    if8502 = call8509;
  } else {
  }
// compiled if node returning if8502 (depth = 3)
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8510 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8511 = alloc_Boolean(1);
// compiled identifier node returning bool8511 (depth = 4)
  gc_frame_newslot(bool8511);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  Object call8513 = callmethodflags(*var_nt, "name", 0, partcv, params, 0);
  gc_frame_end(callframe8512);
// compiled member node returning call8513 (depth = 4)
  params[0] = bool8511;
  partcv[0] = 1;
  Object call8514 = callmethodflags(call8513, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8510);
// compiled call node returning call8514 (depth = 3)
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8515 = gc_frame_new();
// call case 4: self request
  Object call8516 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8515);
// compiled member node returning call8516 (depth = 4)
  *var_anns = call8516;
  if (call8516 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8520 == NULL) {
    strlit8520 = alloc_String("=");
    gc_root(strlit8520);
  }
// compiled string node returning strlit8520 (depth = 6)
  int op_slot_right_8519 = gc_frame_newslot(strlit8520);
// starting to compile member node (depth = 6)
  int callframe8522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8523 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8522);
// compiled member node returning call8523 (depth = 6)
  int op_slot_left_8519 = gc_frame_newslot(call8523);
  params[0] = strlit8520;
  partcv[0] = 1;
  Object opresult8524 = callmethod(call8523, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8524 (depth = 5)
  int op_slot_right_8518 = gc_frame_newslot(opresult8524);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8527 == NULL) {
    strlit8527 = alloc_String("op");
    gc_root(strlit8527);
  }
// compiled string node returning strlit8527 (depth = 6)
  int op_slot_right_8526 = gc_frame_newslot(strlit8527);
// starting to compile member node (depth = 6)
  int callframe8529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8530 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8529);
// compiled member node returning call8530 (depth = 6)
  int op_slot_left_8526 = gc_frame_newslot(call8530);
  params[0] = strlit8527;
  partcv[0] = 1;
  Object opresult8531 = callmethod(call8530, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8531 (depth = 5)
  int op_slot_left_8518 = gc_frame_newslot(opresult8531);
  params[0] = opresult8524;
  partcv[0] = 1;
  Object opresult8532 = callmethod(opresult8531, "||(1)", 1, partcv, params);
// compiled op node returning opresult8532 (depth = 4)
  Object if8517 = done;
  if (istrue(opresult8532)) {
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8533 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8535 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8534);
// compiled member node returning call8535 (depth = 6)
  Object call8536 = callmethodflags(call8535, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8533);
// compiled member node returning call8536 (depth = 5)
  *var_suggestion = call8536;
  if (call8536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8537 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8538 = alloc_Block(NULL, NULL, "parser", 2866);
  gc_frame_newslot(block8538);
// method "_apply(_)"
  block_savedest(block8538);
  Object closure8539 = createclosure(1, "_apply(1)");
  setclosureframe(closure8539, stackframe);
  addtoclosure(closure8539, selfslot);
  struct UserObject *uo8539 = (struct UserObject*)block8538;
  uo8539->data[0] = (Object)closure8539;
  Method *meth_meth_parser_8539__apply_40_1_41_ = addmethod2pos(block8538, "_apply(1)", &meth_parser_8539__apply_40_1_41_, 0);
  int argcv_meth_parser_8539__apply_40_1_41_[] = {1};
  meth_meth_parser_8539__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_8539__apply_40_1_41_);
  meth_meth_parser_8539__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_8539__apply_40_1_41_->definitionLine = 3208;
// compiled block node returning block8538 (depth = 6)
  gc_frame_newslot(block8538);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block8538;
  partcv[0] = 1;
  Object call8547 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8537);
// compiled call node returning call8547 (depth = 5)
  *var_nextTok = call8547;
  if (call8547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block8550 = alloc_Block(NULL, NULL, "parser", 2867);
  gc_frame_newslot(block8550);
// method "_apply"
  block_savedest(block8550);
  Object closure8551 = createclosure(3, "_apply");
  setclosureframe(closure8551, stackframe);
  addtoclosure(closure8551, var_sym);
  addtoclosure(closure8551, var_nextTok);
  addtoclosure(closure8551, selfslot);
  struct UserObject *uo8551 = (struct UserObject*)block8550;
  uo8551->data[0] = (Object)closure8551;
  Method *meth_meth_parser_8551__apply = addmethod2pos(block8550, "_apply", &meth_parser_8551__apply, 0);
  int argcv_meth_parser_8551__apply[] = {0};
  meth_meth_parser_8551__apply->type = alloc_MethodType(1, argcv_meth_parser_8551__apply);
  meth_meth_parser_8551__apply->definitionModule = modulename;
  meth_meth_parser_8551__apply->definitionLine = 3208;
// compiled block node returning block8550 (depth = 6)
  int op_slot_right_8549 = gc_frame_newslot(block8550);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_8557 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool8559 = alloc_Boolean(0);
// compiled identifier node returning bool8559 (depth = 7)
  int op_slot_left_8557 = gc_frame_newslot(bool8559);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult8560 = callmethod(bool8559, "==(1)", 1, partcv, params);
// compiled op node returning opresult8560 (depth = 6)
  int op_slot_left_8549 = gc_frame_newslot(opresult8560);
  params[0] = block8550;
  partcv[0] = 1;
  Object opresult8561 = callmethod(opresult8560, "||(1)", 1, partcv, params);
// compiled op node returning opresult8561 (depth = 5)
  Object if8548 = done;
  if (istrue(opresult8561)) {
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8562 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8563 == NULL) {
    strlit8563 = alloc_String(" =");
    gc_root(strlit8563);
  }
// compiled string node returning strlit8563 (depth = 6)
  gc_frame_newslot(strlit8563);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8563;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8564 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8562);
// compiled call node returning call8564 (depth = 5)
    gc_frame_newslot(call8564);
    if8548 = call8564;
  } else {
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8565 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe8566 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call8567 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe8566);
// compiled member node returning call8567 (depth = 6)
  gc_frame_newslot(call8567);
// starting to compile string node (depth = 6)
  if (strlit8568 == NULL) {
    strlit8568 = alloc_String("=");
    gc_root(strlit8568);
  }
// compiled string node returning strlit8568 (depth = 6)
  gc_frame_newslot(strlit8568);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call8567;
  params[2] = strlit8568;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8569 = callmethodflags(*var_suggestion, "replaceTokenRange(2)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8565);
// compiled call node returning call8569 (depth = 5)
    gc_frame_newslot(call8569);
    if8548 = call8569;
  }
// compiled if node returning if8548 (depth = 4)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8570 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8571 == NULL) {
    strlit8571 = alloc_String("a type declaration must have an '=' after the type name.");
    gc_root(strlit8571);
  }
// compiled string node returning strlit8571 (depth = 5)
  gc_frame_newslot(strlit8571);
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8573 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8572);
// compiled member node returning call8573 (depth = 5)
  gc_frame_newslot(call8573);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8575 = alloc_Float64(1);
// compiled num node returning num8575 (depth = 6)
  int op_slot_right_8574 = gc_frame_newslot(num8575);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8578 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8579 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8578);
// compiled member node returning call8579 (depth = 7)
  int op_slot_right_8577 = gc_frame_newslot(call8579);
// starting to compile member node (depth = 7)
  int callframe8581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8582 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8581);
// compiled member node returning call8582 (depth = 7)
  int op_slot_left_8577 = gc_frame_newslot(call8582);
  params[0] = call8579;
  partcv[0] = 1;
  Object sum8583 = callmethod(call8582, "+(1)", 1, partcv, params);
// compiled op node returning sum8583 (depth = 6)
  int op_slot_left_8574 = gc_frame_newslot(sum8583);
  params[0] = num8575;
  partcv[0] = 1;
  Object sum8584 = callmethod(sum8583, "+(1)", 1, partcv, params);
// compiled op node returning sum8584 (depth = 5)
  gc_frame_newslot(sum8584);
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8571;
  params[1] = call8573;
  params[2] = sum8584;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8585 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8570);
// compiled call node returning call8585 (depth = 4)
    gc_frame_newslot(call8585);
    if8517 = call8585;
  } else {
  }
// compiled if node returning if8517 (depth = 3)
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8586 = gc_frame_new();
// call case 4: self request
  Object call8587 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8586);
// compiled member node returning call8587 (depth = 3)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8589 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8590 == NULL) {
    strlit8590 = alloc_String("lbrace");
    gc_root(strlit8590);
  }
// compiled string node returning strlit8590 (depth = 5)
  gc_frame_newslot(strlit8590);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8590;
  partcv[0] = 1;
  Object call8591 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8589);
// compiled call node returning call8591 (depth = 4)
  Object if8588 = done;
  if (istrue(call8591)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8592 = gc_frame_new();
// call case 4: self request
  Object call8593 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8592);
// compiled member node returning call8593 (depth = 4)
    gc_frame_newslot(call8593);
    if8588 = call8593;
  } else {
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8594 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call8595 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8594);
// compiled call node returning call8595 (depth = 4)
    gc_frame_newslot(call8595);
    if8588 = call8595;
  }
// compiled if node returning if8588 (depth = 3)
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8596 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call8598 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8597);
// compiled member node returning call8598 (depth = 4)
  gc_frame_newslot(call8598);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  params[0] = call8598;
  partcv[0] = 1;
  Object call8599 = callmethodflags(*var_nt, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8596);
// compiled call node returning call8599 (depth = 3)
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8601 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8603 = alloc_Boolean(0);
// compiled identifier node returning bool8603 (depth = 5)
  int op_slot_left_8601 = gc_frame_newslot(bool8603);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8604 = callmethod(bool8603, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8604 (depth = 4)
  Object if8600 = done;
  if (istrue(opresult8604)) {
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8605 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nt (depth = 6)
  Object call8607 = callmethodflags(*var_nt, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe8606);
// compiled member node returning call8607 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8608 = callmethodflags(call8607, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8605);
// compiled call node returning call8608 (depth = 4)
    gc_frame_newslot(call8608);
    if8600 = call8608;
  } else {
  }
// compiled if node returning if8600 (depth = 3)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8609 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call8610 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8609);
// compiled call node returning call8610 (depth = 3)
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8611 = gc_frame_new();
// call case 4: self request
  Object call8612 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8611);
// compiled member node returning call8612 (depth = 3)
    gc_frame_newslot(call8612);
    if8451 = call8612;
  } else {
  }
// compiled if node returning if8451 (depth = 2)
  gc_frame_end(frame);
  return if8451;
}
Object meth_parser_8704__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_8706 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
  int callframe8708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call8709 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8708);
// compiled member node returning call8709 (depth = 12)
  int op_slot_left_8706 = gc_frame_newslot(call8709);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8710 = callmethod(call8709, "≥(1)", 1, partcv, params);
// compiled op node returning opresult8710 (depth = 11)
  int op_slot_right_8705 = gc_frame_newslot(opresult8710);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num8714 = alloc_Float64(1);
// compiled num node returning num8714 (depth = 13)
  int op_slot_right_8713 = gc_frame_newslot(num8714);
// starting to compile member node (depth = 13)
  int callframe8716 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  Object call8717 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8716);
// compiled member node returning call8717 (depth = 13)
  int op_slot_left_8713 = gc_frame_newslot(call8717);
  params[0] = num8714;
  partcv[0] = 1;
  Object sum8718 = callmethod(call8717, "+(1)", 1, partcv, params);
// compiled op node returning sum8718 (depth = 12)
  int op_slot_right_8712 = gc_frame_newslot(sum8718);
// starting to compile member node (depth = 12)
  int callframe8720 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call8721 = callmethodflags(*var_tok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8720);
// compiled member node returning call8721 (depth = 12)
  int op_slot_left_8712 = gc_frame_newslot(call8721);
  params[0] = sum8718;
  partcv[0] = 1;
  Object opresult8722 = callmethod(call8721, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8722 (depth = 11)
  int op_slot_left_8705 = gc_frame_newslot(opresult8722);
  params[0] = opresult8710;
  partcv[0] = 1;
  Object opresult8723 = callmethod(opresult8722, "||(1)", 1, partcv, params);
// compiled op node returning opresult8723 (depth = 10)
  gc_frame_end(frame);
  return opresult8723;
}
Object meth_parser_8726__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe8727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call8728 = callmethodflags(*var_tok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe8727);
// compiled member node returning call8728 (depth = 11)
  *var_tok = call8728;
  if (call8728 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_8613_checkIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_correctIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "correctIndent");
  Object *var_tok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "tok");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if8614 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8615 = alloc_Boolean(0);
// compiled identifier node returning bool8615 (depth = 4)
  *var_indentFreePass = bool8615;
  if (bool8615 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8614 = done;
  } else {
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8619 == NULL) {
    strlit8619 = alloc_String("semicolon");
    gc_root(strlit8619);
  }
// compiled string node returning strlit8619 (depth = 5)
  int op_slot_right_8618 = gc_frame_newslot(strlit8619);
// starting to compile member node (depth = 5)
  int callframe8621 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8622 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8621);
// compiled member node returning call8622 (depth = 5)
  int op_slot_left_8618 = gc_frame_newslot(call8622);
  params[0] = strlit8619;
  partcv[0] = 1;
  Object opresult8623 = callmethod(call8622, "==(1)", 1, partcv, params);
// compiled op node returning opresult8623 (depth = 4)
  Object if8617 = done;
  if (istrue(opresult8623)) {
    gc_frame_newslot(done);
    if8617 = done;
  } else {
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8627 == NULL) {
    strlit8627 = alloc_String("rsquare");
    gc_root(strlit8627);
  }
// compiled string node returning strlit8627 (depth = 7)
  int op_slot_right_8626 = gc_frame_newslot(strlit8627);
// starting to compile member node (depth = 7)
  int callframe8629 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8630 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8629);
// compiled member node returning call8630 (depth = 7)
  int op_slot_left_8626 = gc_frame_newslot(call8630);
  params[0] = strlit8627;
  partcv[0] = 1;
  Object opresult8631 = callmethod(call8630, "==(1)", 1, partcv, params);
// compiled op node returning opresult8631 (depth = 6)
  int op_slot_right_8625 = gc_frame_newslot(opresult8631);
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8635 == NULL) {
    strlit8635 = alloc_String("rparen");
    gc_root(strlit8635);
  }
// compiled string node returning strlit8635 (depth = 8)
  int op_slot_right_8634 = gc_frame_newslot(strlit8635);
// starting to compile member node (depth = 8)
  int callframe8637 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8638 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8637);
// compiled member node returning call8638 (depth = 8)
  int op_slot_left_8634 = gc_frame_newslot(call8638);
  params[0] = strlit8635;
  partcv[0] = 1;
  Object opresult8639 = callmethod(call8638, "==(1)", 1, partcv, params);
// compiled op node returning opresult8639 (depth = 7)
  int op_slot_right_8633 = gc_frame_newslot(opresult8639);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8642 == NULL) {
    strlit8642 = alloc_String("rbrace");
    gc_root(strlit8642);
  }
// compiled string node returning strlit8642 (depth = 8)
  int op_slot_right_8641 = gc_frame_newslot(strlit8642);
// starting to compile member node (depth = 8)
  int callframe8644 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8645 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8644);
// compiled member node returning call8645 (depth = 8)
  int op_slot_left_8641 = gc_frame_newslot(call8645);
  params[0] = strlit8642;
  partcv[0] = 1;
  Object opresult8646 = callmethod(call8645, "==(1)", 1, partcv, params);
// compiled op node returning opresult8646 (depth = 7)
  int op_slot_left_8633 = gc_frame_newslot(opresult8646);
  params[0] = opresult8639;
  partcv[0] = 1;
  Object opresult8647 = callmethod(opresult8646, "||(1)", 1, partcv, params);
// compiled op node returning opresult8647 (depth = 6)
  int op_slot_left_8625 = gc_frame_newslot(opresult8647);
  params[0] = opresult8631;
  partcv[0] = 1;
  Object opresult8648 = callmethod(opresult8647, "||(1)", 1, partcv, params);
// compiled op node returning opresult8648 (depth = 5)
  Object if8624 = done;
  if (istrue(opresult8648)) {
    gc_frame_newslot(done);
    if8624 = done;
  } else {
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8651 == NULL) {
    strlit8651 = alloc_String("eof");
    gc_root(strlit8651);
  }
// compiled string node returning strlit8651 (depth = 7)
  int op_slot_right_8650 = gc_frame_newslot(strlit8651);
// starting to compile member node (depth = 7)
  int callframe8653 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8654 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8653);
// compiled member node returning call8654 (depth = 7)
  int op_slot_left_8650 = gc_frame_newslot(call8654);
  params[0] = strlit8651;
  partcv[0] = 1;
  Object opresult8655 = callmethod(call8654, "==(1)", 1, partcv, params);
// compiled op node returning opresult8655 (depth = 6)
  Object if8649 = done;
  if (istrue(opresult8655)) {
    gc_frame_newslot(done);
    if8649 = done;
  } else {
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_8657 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
  int callframe8659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8660 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8659);
// compiled member node returning call8660 (depth = 8)
  int op_slot_left_8657 = gc_frame_newslot(call8660);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8661 = callmethod(call8660, "<(1)", 1, partcv, params);
// compiled op node returning opresult8661 (depth = 7)
  Object if8656 = done;
  if (istrue(opresult8661)) {
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_8663 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num8666 = alloc_Float64(1);
// compiled num node returning num8666 (depth = 10)
  int op_slot_right_8665 = gc_frame_newslot(num8666);
// starting to compile member node (depth = 10)
  int callframe8668 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call8669 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8668);
// compiled member node returning call8669 (depth = 10)
  int op_slot_left_8665 = gc_frame_newslot(call8669);
  params[0] = num8666;
  partcv[0] = 1;
  Object diff8670 = callmethod(call8669, "-(1)", 1, partcv, params);
// compiled op node returning diff8670 (depth = 9)
  int op_slot_left_8663 = gc_frame_newslot(diff8670);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8671 = callmethod(diff8670, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8671 (depth = 8)
  Object if8662 = done;
  if (istrue(opresult8671)) {
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array8672 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8672 (depth = 9)
  *var_suggestions = array8672;
  if (array8672 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8673 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8674 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call8675 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8674);
// compiled member node returning call8675 (depth = 10)
  Object call8676 = callmethodflags(call8675, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8673);
// compiled member node returning call8676 (depth = 9)
  *var_suggestion = call8676;
  if (call8676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num8680 = alloc_Float64(1);
// compiled num node returning num8680 (depth = 12)
  int op_slot_right_8679 = gc_frame_newslot(num8680);
// starting to compile member node (depth = 12)
  int callframe8682 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  Object call8683 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8682);
// compiled member node returning call8683 (depth = 12)
  int op_slot_left_8679 = gc_frame_newslot(call8683);
  params[0] = num8680;
  partcv[0] = 1;
  Object diff8684 = callmethod(call8683, "-(1)", 1, partcv, params);
// compiled op node returning diff8684 (depth = 11)
  int op_slot_right_8678 = gc_frame_newslot(diff8684);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_8678 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff8684;
  partcv[0] = 1;
  Object diff8686 = callmethod(*var_minIndentLevel, "-(1)", 1, partcv, params);
// compiled op node returning diff8686 (depth = 10)
  int op_slot_right_8677 = gc_frame_newslot(diff8686);
// starting to compile string node (depth = 10)
  if (strlit8688 == NULL) {
    strlit8688 = alloc_String(" ");
    gc_root(strlit8688);
  }
// compiled string node returning strlit8688 (depth = 10)
  int op_slot_left_8677 = gc_frame_newslot(strlit8688);
  params[0] = diff8686;
  partcv[0] = 1;
  Object prod8689 = callmethod(strlit8688, "*(1)", 1, partcv, params);
// compiled op node returning prod8689 (depth = 9)
  *var_correctIndent = prod8689;
  if (prod8689 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8690 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_correctIndent (depth = 9)
  gc_frame_newslot(*var_correctIndent);
// starting to compile num node (depth = 9)
  Object num8691 = alloc_Float64(1);
// compiled num node returning num8691 (depth = 9)
  gc_frame_newslot(num8691);
// starting to compile member node (depth = 9)
  int callframe8692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8693 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8692);
// compiled member node returning call8693 (depth = 9)
  gc_frame_newslot(call8693);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_correctIndent;
  params[1] = num8691;
  params[2] = call8693;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8694 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8690);
// compiled call node returning call8694 (depth = 8)
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8695 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8696 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 8)
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8697 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8698 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call8699 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8698);
// compiled member node returning call8699 (depth = 10)
  Object call8700 = callmethodflags(call8699, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8697);
// compiled member node returning call8700 (depth = 9)
  *var_suggestion = call8700;
  if (call8700 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8702 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block8703 = alloc_Block(NULL, NULL, "parser", 2911);
  gc_frame_newslot(block8703);
// method "_apply"
  block_savedest(block8703);
  Object closure8704 = createclosure(3, "_apply");
  setclosureframe(closure8704, stackframe);
  addtoclosure(closure8704, var_minIndentLevel);
  addtoclosure(closure8704, var_tok);
  addtoclosure(closure8704, selfslot);
  struct UserObject *uo8704 = (struct UserObject*)block8703;
  uo8704->data[0] = (Object)closure8704;
  Method *meth_meth_parser_8704__apply = addmethod2pos(block8703, "_apply", &meth_parser_8704__apply, 0);
  int argcv_meth_parser_8704__apply[] = {0};
  meth_meth_parser_8704__apply->type = alloc_MethodType(1, argcv_meth_parser_8704__apply);
  meth_meth_parser_8704__apply->definitionModule = modulename;
  meth_meth_parser_8704__apply->definitionLine = 3208;
// compiled block node returning block8703 (depth = 9)
  gc_frame_newslot(block8703);
// starting to compile block node (depth = 9)
  Object block8725 = alloc_Block(NULL, NULL, "parser", 2911);
  gc_frame_newslot(block8725);
// method "_apply"
  block_savedest(block8725);
  Object closure8726 = createclosure(2, "_apply");
  setclosureframe(closure8726, stackframe);
  addtoclosure(closure8726, var_tok);
  addtoclosure(closure8726, selfslot);
  struct UserObject *uo8726 = (struct UserObject*)block8725;
  uo8726->data[0] = (Object)closure8726;
  Method *meth_meth_parser_8726__apply = addmethod2pos(block8725, "_apply", &meth_parser_8726__apply, 0);
  int argcv_meth_parser_8726__apply[] = {0};
  meth_meth_parser_8726__apply->type = alloc_MethodType(1, argcv_meth_parser_8726__apply);
  meth_meth_parser_8726__apply->definitionModule = modulename;
  meth_meth_parser_8726__apply->definitionLine = 3208;
// compiled block node returning block8725 (depth = 9)
  gc_frame_newslot(block8725);
// call case 5: prelude request
  params[0] = block8703;
  params[1] = block8725;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8731 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8702);
// compiled call node returning call8731 (depth = 8)
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8733 == NULL) {
    strlit8733 = alloc_String("}");
    gc_root(strlit8733);
  }
// compiled string node returning strlit8733 (depth = 10)
  int op_slot_right_8732 = gc_frame_newslot(strlit8733);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe8736 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call8737 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8736);
// compiled member node returning call8737 (depth = 11)
  int op_slot_right_8735 = gc_frame_newslot(call8737);
// starting to compile string node (depth = 11)
  if (strlit8739 == NULL) {
    strlit8739 = alloc_String(" ");
    gc_root(strlit8739);
  }
// compiled string node returning strlit8739 (depth = 11)
  int op_slot_left_8735 = gc_frame_newslot(strlit8739);
  params[0] = call8737;
  partcv[0] = 1;
  Object prod8740 = callmethod(strlit8739, "*(1)", 1, partcv, params);
// compiled op node returning prod8740 (depth = 10)
  int op_slot_left_8732 = gc_frame_newslot(prod8740);
  params[0] = strlit8733;
  partcv[0] = 1;
  Object opresult8741 = callmethod(prod8740, "++(1)", 1, partcv, params);
// compiled op node returning opresult8741 (depth = 9)
  *var_line = opresult8741;
  if (opresult8741 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8742 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num8744 = alloc_Float64(0.9);
// compiled num node returning num8744 (depth = 10)
  int op_slot_right_8743 = gc_frame_newslot(num8744);
// starting to compile member node (depth = 10)
  int callframe8746 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call8747 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8746);
// compiled member node returning call8747 (depth = 10)
  int op_slot_left_8743 = gc_frame_newslot(call8747);
  params[0] = num8744;
  partcv[0] = 1;
  Object diff8748 = callmethod(call8747, "-(1)", 1, partcv, params);
// compiled op node returning diff8748 (depth = 9)
  gc_frame_newslot(diff8748);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff8748;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call8749 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8742);
// compiled call node returning call8749 (depth = 8)
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8750 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8751 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8750);
// compiled call node returning call8751 (depth = 8)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8752 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8755 == NULL) {
    strlit8755 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit8755);
  }
// compiled string node returning strlit8755 (depth = 11)
  int op_slot_right_8754 = gc_frame_newslot(strlit8755);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_8757 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 12)
  if (strlit8759 == NULL) {
    strlit8759 = alloc_String("at least ");
    gc_root(strlit8759);
  }
// compiled string node returning strlit8759 (depth = 12)
  int op_slot_left_8757 = gc_frame_newslot(strlit8759);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8760 = callmethod(strlit8759, "++(1)", 1, partcv, params);
// compiled op node returning opresult8760 (depth = 11)
  int op_slot_left_8754 = gc_frame_newslot(opresult8760);
  params[0] = strlit8755;
  partcv[0] = 1;
  Object opresult8761 = callmethod(opresult8760, "++(1)", 1, partcv, params);
// compiled op node returning opresult8761 (depth = 10)
  int op_slot_right_8753 = gc_frame_newslot(opresult8761);
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit8763 == NULL) {
    strlit8763 = alloc_String("the indentation for this line must be ");
    gc_root(strlit8763);
  }
// compiled string node returning strlit8763 (depth = 10)
  int op_slot_left_8753 = gc_frame_newslot(strlit8763);
  params[0] = opresult8761;
  partcv[0] = 1;
  Object opresult8764 = callmethod(strlit8763, "++(1)", 1, partcv, params);
// compiled op node returning opresult8764 (depth = 9)
  gc_frame_newslot(opresult8764);
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe8765 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8766 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8765);
// compiled member node returning call8766 (depth = 9)
  gc_frame_newslot(call8766);
// starting to compile member node (depth = 9)
  int callframe8767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8768 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8767);
// compiled member node returning call8768 (depth = 9)
  gc_frame_newslot(call8768);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult8764;
  params[1] = call8766;
  params[2] = call8768;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8769 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8752);
// compiled call node returning call8769 (depth = 8)
    gc_frame_newslot(call8769);
    if8662 = call8769;
  } else {
  }
// compiled if node returning if8662 (depth = 7)
    gc_frame_newslot(if8662);
    if8656 = if8662;
  } else {
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_8771 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 9)
  int callframe8773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8774 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8773);
// compiled member node returning call8774 (depth = 9)
  int op_slot_left_8771 = gc_frame_newslot(call8774);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8775 = callmethod(call8774, ">(1)", 1, partcv, params);
// compiled op node returning opresult8775 (depth = 8)
  Object if8770 = done;
  if (istrue(opresult8775)) {
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8776 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8777 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8776);
// compiled member node returning call8777 (depth = 9)
  *var_minIndentLevel = call8777;
  if (call8777 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if8770 = done;
  } else {
  }
// compiled if node returning if8770 (depth = 7)
    gc_frame_newslot(if8770);
    if8656 = if8770;
  }
// compiled if node returning if8656 (depth = 6)
    gc_frame_newslot(if8656);
    if8649 = if8656;
  }
// compiled if node returning if8649 (depth = 5)
    gc_frame_newslot(if8649);
    if8624 = if8649;
  }
// compiled if node returning if8624 (depth = 4)
    gc_frame_newslot(if8624);
    if8617 = if8624;
  }
// compiled if node returning if8617 (depth = 3)
    gc_frame_newslot(if8617);
    if8614 = if8617;
  }
// compiled if node returning if8614 (depth = 2)
  gc_frame_end(frame);
  return if8614;
}
Object meth_parser_8878__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe8879 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8880 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 6)
  gc_frame_end(frame);
  return call8880;
}
Object meth_parser_8946__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe8947 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8948 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8947);
// compiled call node returning call8948 (depth = 8)
  gc_frame_end(frame);
  return call8948;
}
Object meth_parser_8779_statement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_indentFreePass = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_dest = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "dest");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_oldLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldLine");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe8780 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call8781 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8780);
// compiled member node returning call8781 (depth = 3)
  *var_statementIndent = call8781;
  if (call8781 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8784 = gc_frame_new();
// call case 4: self request
  Object call8785 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8784);
// compiled member node returning call8785 (depth = 2)
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8786 = gc_frame_new();
// call case 4: self request
  Object call8787 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8786);
// compiled member node returning call8787 (depth = 2)
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8789 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8790 == NULL) {
    strlit8790 = alloc_String("keyword");
    gc_root(strlit8790);
  }
// compiled string node returning strlit8790 (depth = 4)
  gc_frame_newslot(strlit8790);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8790;
  partcv[0] = 1;
  Object call8791 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8789);
// compiled call node returning call8791 (depth = 3)
  Object if8788 = done;
  if (istrue(call8791)) {
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8794 == NULL) {
    strlit8794 = alloc_String("var");
    gc_root(strlit8794);
  }
// compiled string node returning strlit8794 (depth = 5)
  int op_slot_right_8793 = gc_frame_newslot(strlit8794);
// starting to compile member node (depth = 5)
  int callframe8796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8797 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8796);
// compiled member node returning call8797 (depth = 5)
  int op_slot_left_8793 = gc_frame_newslot(call8797);
  params[0] = strlit8794;
  partcv[0] = 1;
  Object opresult8798 = callmethod(call8797, "==(1)", 1, partcv, params);
// compiled op node returning opresult8798 (depth = 4)
  Object if8792 = done;
  if (istrue(opresult8798)) {
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8799 = gc_frame_new();
// call case 4: self request
  Object call8800 = callmethodflags(self, "vardec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8799);
// compiled member node returning call8800 (depth = 4)
    gc_frame_newslot(call8800);
    if8792 = call8800;
  } else {
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8803 == NULL) {
    strlit8803 = alloc_String("def");
    gc_root(strlit8803);
  }
// compiled string node returning strlit8803 (depth = 6)
  int op_slot_right_8802 = gc_frame_newslot(strlit8803);
// starting to compile member node (depth = 6)
  int callframe8805 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8806 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8805);
// compiled member node returning call8806 (depth = 6)
  int op_slot_left_8802 = gc_frame_newslot(call8806);
  params[0] = strlit8803;
  partcv[0] = 1;
  Object opresult8807 = callmethod(call8806, "==(1)", 1, partcv, params);
// compiled op node returning opresult8807 (depth = 5)
  Object if8801 = done;
  if (istrue(opresult8807)) {
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8808 = gc_frame_new();
// call case 4: self request
  Object call8809 = callmethodflags(self, "defdec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8808);
// compiled member node returning call8809 (depth = 5)
    gc_frame_newslot(call8809);
    if8801 = call8809;
  } else {
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8812 == NULL) {
    strlit8812 = alloc_String("import");
    gc_root(strlit8812);
  }
// compiled string node returning strlit8812 (depth = 7)
  int op_slot_right_8811 = gc_frame_newslot(strlit8812);
// starting to compile member node (depth = 7)
  int callframe8814 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8815 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8814);
// compiled member node returning call8815 (depth = 7)
  int op_slot_left_8811 = gc_frame_newslot(call8815);
  params[0] = strlit8812;
  partcv[0] = 1;
  Object opresult8816 = callmethod(call8815, "==(1)", 1, partcv, params);
// compiled op node returning opresult8816 (depth = 6)
  Object if8810 = done;
  if (istrue(opresult8816)) {
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8817 = gc_frame_new();
// call case 4: self request
  Object call8818 = callmethodflags(self, "doimport", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8817);
// compiled member node returning call8818 (depth = 6)
    gc_frame_newslot(call8818);
    if8810 = call8818;
  } else {
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8821 == NULL) {
    strlit8821 = alloc_String("dialect");
    gc_root(strlit8821);
  }
// compiled string node returning strlit8821 (depth = 8)
  int op_slot_right_8820 = gc_frame_newslot(strlit8821);
// starting to compile member node (depth = 8)
  int callframe8823 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8824 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8823);
// compiled member node returning call8824 (depth = 8)
  int op_slot_left_8820 = gc_frame_newslot(call8824);
  params[0] = strlit8821;
  partcv[0] = 1;
  Object opresult8825 = callmethod(call8824, "==(1)", 1, partcv, params);
// compiled op node returning opresult8825 (depth = 7)
  Object if8819 = done;
  if (istrue(opresult8825)) {
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8826 = gc_frame_new();
// call case 4: self request
  Object call8827 = callmethodflags(self, "dodialect", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8826);
// compiled member node returning call8827 (depth = 7)
    gc_frame_newslot(call8827);
    if8819 = call8827;
  } else {
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8830 == NULL) {
    strlit8830 = alloc_String("type");
    gc_root(strlit8830);
  }
// compiled string node returning strlit8830 (depth = 9)
  int op_slot_right_8829 = gc_frame_newslot(strlit8830);
// starting to compile member node (depth = 9)
  int callframe8832 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8833 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8832);
// compiled member node returning call8833 (depth = 9)
  int op_slot_left_8829 = gc_frame_newslot(call8833);
  params[0] = strlit8830;
  partcv[0] = 1;
  Object opresult8834 = callmethod(call8833, "==(1)", 1, partcv, params);
// compiled op node returning opresult8834 (depth = 8)
  Object if8828 = done;
  if (istrue(opresult8834)) {
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe8835 = gc_frame_new();
// call case 4: self request
  Object call8836 = callmethodflags(self, "typedec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8835);
// compiled member node returning call8836 (depth = 8)
    gc_frame_newslot(call8836);
    if8828 = call8836;
  } else {
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8839 == NULL) {
    strlit8839 = alloc_String("class");
    gc_root(strlit8839);
  }
// compiled string node returning strlit8839 (depth = 10)
  int op_slot_right_8838 = gc_frame_newslot(strlit8839);
// starting to compile member node (depth = 10)
  int callframe8841 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call8842 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8841);
// compiled member node returning call8842 (depth = 10)
  int op_slot_left_8838 = gc_frame_newslot(call8842);
  params[0] = strlit8839;
  partcv[0] = 1;
  Object opresult8843 = callmethod(call8842, "==(1)", 1, partcv, params);
// compiled op node returning opresult8843 (depth = 9)
  Object if8837 = done;
  if (istrue(opresult8843)) {
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe8844 = gc_frame_new();
// call case 4: self request
  Object call8845 = callmethodflags(self, "doclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8844);
// compiled member node returning call8845 (depth = 9)
    gc_frame_newslot(call8845);
    if8837 = call8845;
  } else {
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8848 == NULL) {
    strlit8848 = alloc_String("trait");
    gc_root(strlit8848);
  }
// compiled string node returning strlit8848 (depth = 11)
  int op_slot_right_8847 = gc_frame_newslot(strlit8848);
// starting to compile member node (depth = 11)
  int callframe8850 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call8851 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8850);
// compiled member node returning call8851 (depth = 11)
  int op_slot_left_8847 = gc_frame_newslot(call8851);
  params[0] = strlit8848;
  partcv[0] = 1;
  Object opresult8852 = callmethod(call8851, "==(1)", 1, partcv, params);
// compiled op node returning opresult8852 (depth = 10)
  Object if8846 = done;
  if (istrue(opresult8852)) {
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe8853 = gc_frame_new();
// call case 4: self request
  Object call8854 = callmethodflags(self, "doclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8853);
// compiled member node returning call8854 (depth = 10)
    gc_frame_newslot(call8854);
    if8846 = call8854;
  } else {
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8857 == NULL) {
    strlit8857 = alloc_String("factory");
    gc_root(strlit8857);
  }
// compiled string node returning strlit8857 (depth = 12)
  int op_slot_right_8856 = gc_frame_newslot(strlit8857);
// starting to compile member node (depth = 12)
  int callframe8859 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  Object call8860 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8859);
// compiled member node returning call8860 (depth = 12)
  int op_slot_left_8856 = gc_frame_newslot(call8860);
  params[0] = strlit8857;
  partcv[0] = 1;
  Object opresult8861 = callmethod(call8860, "==(1)", 1, partcv, params);
// compiled op node returning opresult8861 (depth = 11)
  Object if8855 = done;
  if (istrue(opresult8861)) {
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe8862 = gc_frame_new();
// call case 4: self request
  Object call8863 = callmethodflags(self, "dofactoryMethod", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8862);
// compiled member node returning call8863 (depth = 11)
    gc_frame_newslot(call8863);
    if8855 = call8863;
  } else {
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit8866 == NULL) {
    strlit8866 = alloc_String("return");
    gc_root(strlit8866);
  }
// compiled string node returning strlit8866 (depth = 13)
  int op_slot_right_8865 = gc_frame_newslot(strlit8866);
// starting to compile member node (depth = 13)
  int callframe8868 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  Object call8869 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8868);
// compiled member node returning call8869 (depth = 13)
  int op_slot_left_8865 = gc_frame_newslot(call8869);
  params[0] = strlit8866;
  partcv[0] = 1;
  Object opresult8870 = callmethod(call8869, "==(1)", 1, partcv, params);
// compiled op node returning opresult8870 (depth = 12)
  Object if8864 = done;
  if (istrue(opresult8870)) {
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe8871 = gc_frame_new();
// call case 4: self request
  Object call8872 = callmethodflags(self, "doreturn", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8871);
// compiled member node returning call8872 (depth = 12)
    gc_frame_newslot(call8872);
    if8864 = call8872;
  } else {
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe8873 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning module_parser (depth = 13)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8874 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8873);
// compiled call node returning call8874 (depth = 12)
    gc_frame_newslot(call8874);
    if8864 = call8874;
  }
// compiled if node returning if8864 (depth = 11)
    gc_frame_newslot(if8864);
    if8855 = if8864;
  }
// compiled if node returning if8855 (depth = 10)
    gc_frame_newslot(if8855);
    if8846 = if8855;
  }
// compiled if node returning if8846 (depth = 9)
    gc_frame_newslot(if8846);
    if8837 = if8846;
  }
// compiled if node returning if8837 (depth = 8)
    gc_frame_newslot(if8837);
    if8828 = if8837;
  }
// compiled if node returning if8828 (depth = 7)
    gc_frame_newslot(if8828);
    if8819 = if8828;
  }
// compiled if node returning if8819 (depth = 6)
    gc_frame_newslot(if8819);
    if8810 = if8819;
  }
// compiled if node returning if8810 (depth = 5)
    gc_frame_newslot(if8810);
    if8801 = if8810;
  }
// compiled if node returning if8801 (depth = 4)
    gc_frame_newslot(if8801);
    if8792 = if8801;
  }
// compiled if node returning if8792 (depth = 3)
    gc_frame_newslot(if8792);
    if8788 = if8792;
  } else {
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8876 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8877 = alloc_Block(NULL, NULL, "parser", 2963);
  gc_frame_newslot(block8877);
// method "_apply"
  block_savedest(block8877);
  Object closure8878 = createclosure(2, "_apply");
  setclosureframe(closure8878, stackframe);
  addtoclosure(closure8878, var_blocksOK);
  addtoclosure(closure8878, selfslot);
  struct UserObject *uo8878 = (struct UserObject*)block8877;
  uo8878->data[0] = (Object)closure8878;
  Method *meth_meth_parser_8878__apply = addmethod2pos(block8877, "_apply", &meth_parser_8878__apply, 0);
  int argcv_meth_parser_8878__apply[] = {0};
  meth_meth_parser_8878__apply->type = alloc_MethodType(1, argcv_meth_parser_8878__apply);
  meth_meth_parser_8878__apply->definitionModule = modulename;
  meth_meth_parser_8878__apply->definitionLine = 3208;
// compiled block node returning block8877 (depth = 5)
  gc_frame_newslot(block8877);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block8877;
  partcv[0] = 1;
  Object call8882 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8876);
// compiled call node returning call8882 (depth = 4)
  Object if8875 = done;
  if (istrue(call8882)) {
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8885 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8886 == NULL) {
    strlit8886 = alloc_String("bind");
    gc_root(strlit8886);
  }
// compiled string node returning strlit8886 (depth = 7)
  gc_frame_newslot(strlit8886);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8886;
  partcv[0] = 1;
  Object call8887 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8885);
// compiled call node returning call8887 (depth = 6)
  int op_slot_right_8884 = gc_frame_newslot(call8887);
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8891 == NULL) {
    strlit8891 = alloc_String("member");
    gc_root(strlit8891);
  }
// compiled string node returning strlit8891 (depth = 8)
  int op_slot_right_8890 = gc_frame_newslot(strlit8891);
// starting to compile member node (depth = 8)
  int callframe8893 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call8895 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe8894);
// compiled member node returning call8895 (depth = 9)
  Object call8896 = callmethodflags(call8895, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8893);
// compiled member node returning call8896 (depth = 8)
  int op_slot_left_8890 = gc_frame_newslot(call8896);
  params[0] = strlit8891;
  partcv[0] = 1;
  Object opresult8897 = callmethod(call8896, "==(1)", 1, partcv, params);
// compiled op node returning opresult8897 (depth = 7)
  int op_slot_right_8889 = gc_frame_newslot(opresult8897);
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8900 == NULL) {
    strlit8900 = alloc_String("identifier");
    gc_root(strlit8900);
  }
// compiled string node returning strlit8900 (depth = 8)
  int op_slot_right_8899 = gc_frame_newslot(strlit8900);
// starting to compile member node (depth = 8)
  int callframe8902 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8903 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call8904 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe8903);
// compiled member node returning call8904 (depth = 9)
  Object call8905 = callmethodflags(call8904, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8902);
// compiled member node returning call8905 (depth = 8)
  int op_slot_left_8899 = gc_frame_newslot(call8905);
  params[0] = strlit8900;
  partcv[0] = 1;
  Object opresult8906 = callmethod(call8905, "==(1)", 1, partcv, params);
// compiled op node returning opresult8906 (depth = 7)
  int op_slot_left_8889 = gc_frame_newslot(opresult8906);
  params[0] = opresult8897;
  partcv[0] = 1;
  Object opresult8907 = callmethod(opresult8906, "||(1)", 1, partcv, params);
// compiled op node returning opresult8907 (depth = 6)
  int op_slot_left_8884 = gc_frame_newslot(opresult8907);
  params[0] = call8887;
  partcv[0] = 1;
  Object opresult8908 = callmethod(opresult8907, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8908 (depth = 5)
  Object if8883 = done;
  if (istrue(opresult8908)) {
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8909 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call8910 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8909);
// compiled member node returning call8910 (depth = 6)
  *var_dest = call8910;
  if (call8910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8913 == NULL) {
    strlit8913 = alloc_String("lbrace");
    gc_root(strlit8913);
  }
// compiled string node returning strlit8913 (depth = 7)
  int op_slot_right_8912 = gc_frame_newslot(strlit8913);
// starting to compile member node (depth = 7)
  int callframe8915 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  Object call8916 = callmethodflags(*var_dest, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8915);
// compiled member node returning call8916 (depth = 7)
  int op_slot_left_8912 = gc_frame_newslot(call8916);
  params[0] = strlit8913;
  partcv[0] = 1;
  Object opresult8917 = callmethod(call8916, "==(1)", 1, partcv, params);
// compiled op node returning opresult8917 (depth = 6)
  Object if8911 = done;
  if (istrue(opresult8917)) {
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8919 == NULL) {
    strlit8919 = alloc_String("");
    gc_root(strlit8919);
  }
// compiled string node returning strlit8919 (depth = 8)
  int op_slot_right_8918 = gc_frame_newslot(strlit8919);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8922 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8923 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8922);
// compiled member node returning call8923 (depth = 9)
  int op_slot_right_8921 = gc_frame_newslot(call8923);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8926 == NULL) {
    strlit8926 = alloc_String(", sym.line = ");
    gc_root(strlit8926);
  }
// compiled string node returning strlit8926 (depth = 10)
  int op_slot_right_8925 = gc_frame_newslot(strlit8926);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_8928 = gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 11)
  if (strlit8930 == NULL) {
    strlit8930 = alloc_String("sym = ");
    gc_root(strlit8930);
  }
// compiled string node returning strlit8930 (depth = 11)
  int op_slot_left_8928 = gc_frame_newslot(strlit8930);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8931 = callmethod(strlit8930, "++(1)", 1, partcv, params);
// compiled op node returning opresult8931 (depth = 10)
  int op_slot_left_8925 = gc_frame_newslot(opresult8931);
  params[0] = strlit8926;
  partcv[0] = 1;
  Object opresult8932 = callmethod(opresult8931, "++(1)", 1, partcv, params);
// compiled op node returning opresult8932 (depth = 9)
  int op_slot_left_8921 = gc_frame_newslot(opresult8932);
  params[0] = call8923;
  partcv[0] = 1;
  Object opresult8933 = callmethod(opresult8932, "++(1)", 1, partcv, params);
// compiled op node returning opresult8933 (depth = 8)
  int op_slot_left_8918 = gc_frame_newslot(opresult8933);
  params[0] = strlit8919;
  partcv[0] = 1;
  Object opresult8934 = callmethod(opresult8933, "++(1)", 1, partcv, params);
// compiled op node returning opresult8934 (depth = 7)
  params[0] = opresult8934;
  Object call8935 = gracelib_print(NULL, 1,  params);
// compiled call node returning call8935 (depth = 6)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8936 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8937 == NULL) {
    strlit8937 = alloc_String("popped lbrace token while parsing statement");
    gc_root(strlit8937);
  }
// compiled string node returning strlit8937 (depth = 7)
  gc_frame_newslot(strlit8937);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8938 = gc_frame_new();
// call case 5: prelude request
  Object call8939 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8938);
// compiled member node returning call8939 (depth = 7)
  params[0] = strlit8937;
  partcv[0] = 1;
  Object call8940 = callmethodflags(call8939, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8936);
// compiled call node returning call8940 (depth = 6)
    gc_frame_newslot(call8940);
    if8911 = call8940;
  } else {
  }
// compiled if node returning if8911 (depth = 5)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8941 = gc_frame_new();
// call case 4: self request
  Object call8942 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8941);
// compiled member node returning call8942 (depth = 5)
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8944 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8945 = alloc_Block(NULL, NULL, "parser", 2973);
  gc_frame_newslot(block8945);
// method "_apply"
  block_savedest(block8945);
  Object closure8946 = createclosure(2, "_apply");
  setclosureframe(closure8946, stackframe);
  addtoclosure(closure8946, var_blocksOK);
  addtoclosure(closure8946, selfslot);
  struct UserObject *uo8946 = (struct UserObject*)block8945;
  uo8946->data[0] = (Object)closure8946;
  Method *meth_meth_parser_8946__apply = addmethod2pos(block8945, "_apply", &meth_parser_8946__apply, 0);
  int argcv_meth_parser_8946__apply[] = {0};
  meth_meth_parser_8946__apply->type = alloc_MethodType(1, argcv_meth_parser_8946__apply);
  meth_meth_parser_8946__apply->definitionModule = modulename;
  meth_meth_parser_8946__apply->definitionLine = 3208;
// compiled block node returning block8945 (depth = 7)
  gc_frame_newslot(block8945);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block8945;
  partcv[0] = 1;
  Object call8950 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8944);
// compiled call node returning call8950 (depth = 6)
  Object if8943 = done;
  if (istrue(call8950)) {
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8951 = gc_frame_new();
// call case 4: self request
  Object call8952 = callmethodflags(self, "reportBadRhs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8951);
// compiled member node returning call8952 (depth = 6)
    gc_frame_newslot(call8952);
    if8943 = call8952;
  } else {
  }
// compiled if node returning if8943 (depth = 5)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call8954 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8953);
// compiled member node returning call8954 (depth = 6)
  *var_val = call8954;
  if (call8954 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8955 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call8957 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8956);
// compiled member node returning call8957 (depth = 6)
  gc_frame_newslot(call8957);
// starting to compile member node (depth = 6)
  int callframe8958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call8959 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8958);
// compiled member node returning call8959 (depth = 6)
  gc_frame_newslot(call8959);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = call8957;
  params[1] = call8959;
  partcv[0] = 2;
  Object call8960 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8955);
// compiled call node returning call8960 (depth = 5)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8961 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dest (depth = 7)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8962 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call8963 = callmethodflags(*var_ast, "bindNode", 0, partcv, params, 0);
  gc_frame_end(callframe8962);
// compiled member node returning call8963 (depth = 7)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call8964 = callmethodflags(call8963, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8961);
// compiled call node returning call8964 (depth = 6)
  *var_o = call8964;
  if (call8964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8965 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8966 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8965);
// compiled call node returning call8966 (depth = 5)
    gc_frame_newslot(call8966);
    if8883 = call8966;
  } else {
  }
// compiled if node returning if8883 (depth = 4)
    gc_frame_newslot(if8883);
    if8875 = if8883;
  } else {
  }
// compiled if node returning if8875 (depth = 3)
    gc_frame_newslot(if8875);
    if8788 = if8875;
  }
// compiled if node returning if8788 (depth = 2)
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8967 = gc_frame_new();
// call case 4: self request
  Object call8968 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8967);
// compiled member node returning call8968 (depth = 2)
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8970 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8971 == NULL) {
    strlit8971 = alloc_String("eof");
    gc_root(strlit8971);
  }
// compiled string node returning strlit8971 (depth = 4)
  gc_frame_newslot(strlit8971);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8971;
  partcv[0] = 1;
  Object call8972 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8970);
// compiled call node returning call8972 (depth = 3)
  Object if8969 = done;
  if (istrue(call8972)) {
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8973 = alloc_Boolean(1);
// compiled identifier node returning bool8973 (depth = 4)
  return bool8973;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if8969 = undefined;
  } else {
  }
// compiled if node returning if8969 (depth = 2)
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8975 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8976 == NULL) {
    strlit8976 = alloc_String("semicolon");
    gc_root(strlit8976);
  }
// compiled string node returning strlit8976 (depth = 4)
  gc_frame_newslot(strlit8976);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8976;
  partcv[0] = 1;
  Object call8977 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8975);
// compiled call node returning call8977 (depth = 3)
  Object if8974 = done;
  if (istrue(call8977)) {
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8978 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8979 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8978);
// compiled member node returning call8979 (depth = 4)
  *var_oldLine = call8979;
  if (call8979 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8980 = gc_frame_new();
// call case 4: self request
  Object call8981 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8980);
// compiled member node returning call8981 (depth = 3)
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_8983 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
  int callframe8985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8986 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8985);
// compiled member node returning call8986 (depth = 5)
  int op_slot_left_8983 = gc_frame_newslot(call8986);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult8987 = callmethod(call8986, "==(1)", 1, partcv, params);
// compiled op node returning opresult8987 (depth = 4)
  Object if8982 = done;
  if (istrue(opresult8987)) {
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8988 = alloc_Boolean(1);
// compiled identifier node returning bool8988 (depth = 5)
  *var_indentFreePass = bool8988;
  if (bool8988 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8982 = done;
  } else {
  }
// compiled if node returning if8982 (depth = 3)
    gc_frame_newslot(if8982);
    if8974 = if8982;
  } else {
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8990 = gc_frame_new();
// call case 4: self request
  Object call8991 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8990);
// compiled member node returning call8991 (depth = 3)
    gc_frame_newslot(call8991);
    if8974 = call8991;
  }
// compiled if node returning if8974 (depth = 2)
  gc_frame_end(frame);
  return if8974;
}
Object meth_parser_9050__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9052 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call9053 = callmethodflags(*var_tokens, "poll", 0, partcv, params, 0);
  gc_frame_end(callframe9052);
// compiled member node returning call9053 (depth = 5)
  *var_sym = call9053;
  if (call9053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9055 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9056 == NULL) {
    strlit9056 = alloc_String("comment");
    gc_root(strlit9056);
  }
// compiled string node returning strlit9056 (depth = 5)
  gc_frame_newslot(strlit9056);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit9056;
  partcv[0] = 1;
  Object call9057 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9055);
// compiled call node returning call9057 (depth = 4)
  gc_frame_end(frame);
  return call9057;
}
Object meth_parser_9060__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9061 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9063 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9062);
// compiled member node returning call9063 (depth = 5)
  gc_frame_newslot(call9063);
// starting to compile member node (depth = 5)
  int callframe9064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9065 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9064);
// compiled member node returning call9065 (depth = 5)
  gc_frame_newslot(call9065);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call9063;
  params[1] = call9065;
  partcv[0] = 2;
  Object call9066 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9061);
// compiled call node returning call9066 (depth = 4)
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9067 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe9068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9069 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9068);
// compiled member node returning call9069 (depth = 6)
  gc_frame_newslot(call9069);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9070 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call9071 = callmethodflags(*var_ast, "commentNode", 0, partcv, params, 0);
  gc_frame_end(callframe9070);
// compiled member node returning call9071 (depth = 6)
  params[0] = call9069;
  partcv[0] = 1;
  Object call9072 = callmethodflags(call9071, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9067);
// compiled call node returning call9072 (depth = 5)
  *var_o = call9072;
  if (call9072 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9077 = alloc_Float64(1);
// compiled num node returning num9077 (depth = 7)
  int op_slot_right_9076 = gc_frame_newslot(num9077);
// starting to compile member node (depth = 7)
  int callframe9079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9080 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9079);
// compiled member node returning call9080 (depth = 7)
  int op_slot_left_9076 = gc_frame_newslot(call9080);
  params[0] = num9077;
  partcv[0] = 1;
  Object diff9081 = callmethod(call9080, "-(1)", 1, partcv, params);
// compiled op node returning diff9081 (depth = 6)
  int op_slot_right_9075 = gc_frame_newslot(diff9081);
// starting to compile member node (depth = 6)
  int callframe9083 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9084 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  Object call9085 = callmethodflags(*var_comments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9084);
// compiled member node returning call9085 (depth = 7)
  Object call9086 = callmethodflags(call9085, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe9083);
// compiled member node returning call9086 (depth = 6)
  int op_slot_left_9075 = gc_frame_newslot(call9086);
  params[0] = diff9081;
  partcv[0] = 1;
  Object opresult9087 = callmethod(call9086, "==(1)", 1, partcv, params);
// compiled op node returning opresult9087 (depth = 5)
  Object if9074 = done;
  if (istrue(opresult9087)) {
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9088 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  Object call9090 = callmethodflags(*var_comments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9089);
// compiled member node returning call9090 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9091 = callmethodflags(call9090, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9088);
// compiled call node returning call9091 (depth = 5)
    gc_frame_newslot(call9091);
    if9074 = call9091;
  } else {
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9092 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9093 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9092);
// compiled call node returning call9093 (depth = 5)
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9097 = alloc_Float64(1);
// compiled num node returning num9097 (depth = 8)
  int op_slot_right_9096 = gc_frame_newslot(num9097);
// starting to compile member node (depth = 8)
  int callframe9099 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9100 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9099);
// compiled member node returning call9100 (depth = 8)
  int op_slot_left_9096 = gc_frame_newslot(call9100);
  params[0] = num9097;
  partcv[0] = 1;
  Object diff9101 = callmethod(call9100, "-(1)", 1, partcv, params);
// compiled op node returning diff9101 (depth = 7)
  int op_slot_right_9095 = gc_frame_newslot(diff9101);
// starting to compile member node (depth = 7)
  int callframe9103 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9104 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9103);
// compiled member node returning call9104 (depth = 7)
  int op_slot_left_9095 = gc_frame_newslot(call9104);
  params[0] = diff9101;
  partcv[0] = 1;
  Object opresult9105 = callmethod(call9104, "<(1)", 1, partcv, params);
// compiled op node returning opresult9105 (depth = 6)
  Object if9094 = done;
  if (istrue(opresult9105)) {
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9106 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool9107 = alloc_Boolean(1);
// compiled identifier node returning bool9107 (depth = 7)
  gc_frame_newslot(bool9107);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = bool9107;
  partcv[0] = 1;
  Object call9108 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9106);
// compiled call node returning call9108 (depth = 6)
    gc_frame_newslot(call9108);
    if9094 = call9108;
  } else {
  }
// compiled if node returning if9094 (depth = 5)
    gc_frame_newslot(if9094);
    if9074 = if9094;
  }
// compiled if node returning if9074 (depth = 4)
  gc_frame_end(frame);
  return if9074;
}
Object meth_parser_8992_pushComments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8994 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8995 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8996 == NULL) {
    strlit8996 = alloc_String("comment");
    gc_root(strlit8996);
  }
// compiled string node returning strlit8996 (depth = 5)
  gc_frame_newslot(strlit8996);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8996;
  partcv[0] = 1;
  Object call8997 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8995);
// compiled call node returning call8997 (depth = 4)
  partcv[0] = 0;
  Object call8998 = callmethodflags(call8997, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8994);
// compiled call node returning call8998 (depth = 3)
  Object if8993 = done;
  if (istrue(call8998)) {
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if8993 = undefined;
  } else {
  }
// compiled if node returning if8993 (depth = 2)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8999 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe9000 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call9001 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9000);
// compiled member node returning call9001 (depth = 3)
  gc_frame_newslot(call9001);
// starting to compile member node (depth = 3)
  int callframe9002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call9003 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9002);
// compiled member node returning call9003 (depth = 3)
  gc_frame_newslot(call9003);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call9001;
  params[1] = call9003;
  partcv[0] = 2;
  Object call9004 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8999);
// compiled call node returning call9004 (depth = 2)
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9005 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9006 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9007 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9006);
// compiled member node returning call9007 (depth = 4)
  gc_frame_newslot(call9007);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9008 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call9009 = callmethodflags(*var_ast, "commentNode", 0, partcv, params, 0);
  gc_frame_end(callframe9008);
// compiled member node returning call9009 (depth = 4)
  params[0] = call9007;
  partcv[0] = 1;
  Object call9010 = callmethodflags(call9009, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9005);
// compiled call node returning call9010 (depth = 3)
  *var_o = call9010;
  if (call9010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9014 == NULL) {
    strlit9014 = alloc_String("comment");
    gc_root(strlit9014);
  }
// compiled string node returning strlit9014 (depth = 5)
  int op_slot_right_9013 = gc_frame_newslot(strlit9014);
// starting to compile member node (depth = 5)
  int callframe9016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9017 = callmethodflags(*var_lastToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9016);
// compiled member node returning call9017 (depth = 5)
  int op_slot_left_9013 = gc_frame_newslot(call9017);
  params[0] = strlit9014;
  partcv[0] = 1;
  Object opresult9018 = callmethod(call9017, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9018 (depth = 4)
  int op_slot_right_9012 = gc_frame_newslot(opresult9018);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9021 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9022 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9021);
// compiled member node returning call9022 (depth = 5)
  int op_slot_right_9020 = gc_frame_newslot(call9022);
// starting to compile member node (depth = 5)
  int callframe9024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9025 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9024);
// compiled member node returning call9025 (depth = 5)
  int op_slot_left_9020 = gc_frame_newslot(call9025);
  params[0] = call9022;
  partcv[0] = 1;
  Object opresult9026 = callmethod(call9025, "==(1)", 1, partcv, params);
// compiled op node returning opresult9026 (depth = 4)
  int op_slot_left_9012 = gc_frame_newslot(opresult9026);
  params[0] = opresult9018;
  partcv[0] = 1;
  Object opresult9027 = callmethod(opresult9026, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9027 (depth = 3)
  Object if9011 = done;
  if (istrue(opresult9027)) {
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9028 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9029 = alloc_Boolean(1);
// compiled identifier node returning bool9029 (depth = 4)
  gc_frame_newslot(bool9029);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool9029;
  partcv[0] = 1;
  Object call9030 = callmethodflags(*var_o, "isPartialLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9028);
// compiled call node returning call9030 (depth = 3)
    gc_frame_newslot(call9030);
    if9011 = call9030;
  } else {
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9034 = alloc_Float64(1);
// compiled num node returning num9034 (depth = 6)
  int op_slot_right_9033 = gc_frame_newslot(num9034);
// starting to compile member node (depth = 6)
  int callframe9036 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9037 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9036);
// compiled member node returning call9037 (depth = 6)
  int op_slot_left_9033 = gc_frame_newslot(call9037);
  params[0] = num9034;
  partcv[0] = 1;
  Object diff9038 = callmethod(call9037, "-(1)", 1, partcv, params);
// compiled op node returning diff9038 (depth = 5)
  int op_slot_right_9032 = gc_frame_newslot(diff9038);
// starting to compile member node (depth = 5)
  int callframe9040 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9041 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9040);
// compiled member node returning call9041 (depth = 5)
  int op_slot_left_9032 = gc_frame_newslot(call9041);
  params[0] = diff9038;
  partcv[0] = 1;
  Object opresult9042 = callmethod(call9041, "<(1)", 1, partcv, params);
// compiled op node returning opresult9042 (depth = 4)
  Object if9031 = done;
  if (istrue(opresult9042)) {
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9043 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9044 = alloc_Boolean(1);
// compiled identifier node returning bool9044 (depth = 5)
  gc_frame_newslot(bool9044);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool9044;
  partcv[0] = 1;
  Object call9045 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9043);
// compiled call node returning call9045 (depth = 4)
    gc_frame_newslot(call9045);
    if9031 = call9045;
  } else {
  }
// compiled if node returning if9031 (depth = 3)
    gc_frame_newslot(if9031);
    if9011 = if9031;
  }
// compiled if node returning if9011 (depth = 2)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9046 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9047 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9046);
// compiled call node returning call9047 (depth = 2)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9048 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9049 = alloc_Block(NULL, NULL, "parser", 3013);
  gc_frame_newslot(block9049);
// method "_apply"
  block_savedest(block9049);
  Object closure9050 = createclosure(4, "_apply");
  setclosureframe(closure9050, stackframe);
  addtoclosure(closure9050, var_sym);
  addtoclosure(closure9050, var_previousCommentToken);
  addtoclosure(closure9050, var_tokens);
  addtoclosure(closure9050, selfslot);
  struct UserObject *uo9050 = (struct UserObject*)block9049;
  uo9050->data[0] = (Object)closure9050;
  Method *meth_meth_parser_9050__apply = addmethod2pos(block9049, "_apply", &meth_parser_9050__apply, 0);
  int argcv_meth_parser_9050__apply[] = {0};
  meth_meth_parser_9050__apply->type = alloc_MethodType(1, argcv_meth_parser_9050__apply);
  meth_meth_parser_9050__apply->definitionModule = modulename;
  meth_meth_parser_9050__apply->definitionLine = 3208;
// compiled block node returning block9049 (depth = 3)
  gc_frame_newslot(block9049);
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block9059 = alloc_Block(NULL, NULL, "parser", 3017);
  gc_frame_newslot(block9059);
// method "_apply"
  block_savedest(block9059);
  Object closure9060 = createclosure(7, "_apply");
  setclosureframe(closure9060, stackframe);
  addtoclosure(closure9060, var_sym);
  addtoclosure(closure9060, var_util);
  addtoclosure(closure9060, var_ast);
  addtoclosure(closure9060, var_o);
  addtoclosure(closure9060, var_comments);
  addtoclosure(closure9060, var_lastToken);
  addtoclosure(closure9060, selfslot);
  struct UserObject *uo9060 = (struct UserObject*)block9059;
  uo9060->data[0] = (Object)closure9060;
  Method *meth_meth_parser_9060__apply = addmethod2pos(block9059, "_apply", &meth_parser_9060__apply, 0);
  int argcv_meth_parser_9060__apply[] = {0};
  meth_meth_parser_9060__apply->type = alloc_MethodType(1, argcv_meth_parser_9060__apply);
  meth_meth_parser_9060__apply->definitionModule = modulename;
  meth_meth_parser_9060__apply->definitionLine = 3208;
// compiled block node returning block9059 (depth = 3)
  gc_frame_newslot(block9059);
// call case 5: prelude request
  params[0] = block9049;
  params[1] = block9059;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9110 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9048);
// compiled call node returning call9110 (depth = 2)
  gc_frame_end(frame);
  return call9110;
}
Object meth_parser_9136__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9138 = alloc_Float64(0);
// compiled num node returning num9138 (depth = 5)
  int op_slot_right_9137 = gc_frame_newslot(num9138);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_9137 = gc_frame_newslot(*var_ix);
  params[0] = num9138;
  partcv[0] = 1;
  Object opresult9140 = callmethod(*var_ix, ">(1)", 1, partcv, params);
// compiled op node returning opresult9140 (depth = 4)
  gc_frame_end(frame);
  return opresult9140;
}
Object meth_parser_9143__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9144 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9145 = callmethodflags(*var_comments, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9144);
// compiled call node returning call9145 (depth = 5)
  *var_each = call9145;
  if (call9145 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9149 = alloc_Float64(1);
// compiled num node returning num9149 (depth = 8)
  int op_slot_right_9148 = gc_frame_newslot(num9149);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_9148 = gc_frame_newslot(*var_oLine);
  params[0] = num9149;
  partcv[0] = 1;
  Object sum9151 = callmethod(*var_oLine, "+(1)", 1, partcv, params);
// compiled op node returning sum9151 (depth = 7)
  int op_slot_right_9147 = gc_frame_newslot(sum9151);
// starting to compile member node (depth = 7)
  int callframe9153 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call9154 = callmethodflags(*var_each, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9153);
// compiled member node returning call9154 (depth = 7)
  int op_slot_left_9147 = gc_frame_newslot(call9154);
  params[0] = sum9151;
  partcv[0] = 1;
  Object opresult9155 = callmethod(call9154, "==(1)", 1, partcv, params);
// compiled op node returning opresult9155 (depth = 6)
  int op_slot_right_9146 = gc_frame_newslot(opresult9155);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_9157 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
  int callframe9159 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call9160 = callmethodflags(*var_each, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9159);
// compiled member node returning call9160 (depth = 7)
  int op_slot_left_9157 = gc_frame_newslot(call9160);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult9161 = callmethod(call9160, "==(1)", 1, partcv, params);
// compiled op node returning opresult9161 (depth = 6)
  int op_slot_left_9146 = gc_frame_newslot(opresult9161);
  params[0] = opresult9155;
  partcv[0] = 1;
  Object opresult9162 = callmethod(opresult9161, "||(1)", 1, partcv, params);
// compiled op node returning opresult9162 (depth = 5)
  *var_isPostComment = opresult9162;
  if (opresult9162 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9166 = alloc_Float64(1);
// compiled num node returning num9166 (depth = 8)
  int op_slot_right_9165 = gc_frame_newslot(num9166);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_9165 = gc_frame_newslot(*var_oLine);
  params[0] = num9166;
  partcv[0] = 1;
  Object diff9168 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff9168 (depth = 7)
  int op_slot_right_9164 = gc_frame_newslot(diff9168);
// starting to compile member node (depth = 7)
  int callframe9170 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call9171 = callmethodflags(*var_each, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe9170);
// compiled member node returning call9171 (depth = 7)
  int op_slot_left_9164 = gc_frame_newslot(call9171);
  params[0] = diff9168;
  partcv[0] = 1;
  Object opresult9172 = callmethod(call9171, "==(1)", 1, partcv, params);
// compiled op node returning opresult9172 (depth = 6)
  int op_slot_right_9163 = gc_frame_newslot(opresult9172);
// starting to compile member node (depth = 6)
  int callframe9174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call9175 = callmethodflags(*var_each, "isPreceededByBlankLine", 0, partcv, params, 0);
  gc_frame_end(callframe9174);
// compiled member node returning call9175 (depth = 6)
  int op_slot_left_9163 = gc_frame_newslot(call9175);
  params[0] = opresult9172;
  partcv[0] = 1;
  Object opresult9176 = callmethod(call9175, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9176 (depth = 5)
  *var_isPreComment = opresult9176;
  if (opresult9176 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if9177 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9178 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe9179 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9180 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9179);
// compiled call node returning call9180 (depth = 6)
  gc_frame_newslot(call9180);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call9180;
  partcv[0] = 1;
  Object call9181 = callmethodflags(*var_postComments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9178);
// compiled call node returning call9181 (depth = 5)
    gc_frame_newslot(call9181);
    if9177 = call9181;
  } else {
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if9182 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9183 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe9184 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9185 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9184);
// compiled call node returning call9185 (depth = 7)
  gc_frame_newslot(call9185);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call9185;
  partcv[0] = 1;
  Object call9186 = callmethodflags(*var_preComments, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9183);
// compiled call node returning call9186 (depth = 6)
    gc_frame_newslot(call9186);
    if9182 = call9186;
  } else {
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9190 = alloc_Float64(1);
// compiled num node returning num9190 (depth = 9)
  int op_slot_right_9189 = gc_frame_newslot(num9190);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_9189 = gc_frame_newslot(*var_oLine);
  params[0] = num9190;
  partcv[0] = 1;
  Object diff9192 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff9192 (depth = 8)
  int op_slot_right_9188 = gc_frame_newslot(diff9192);
// starting to compile member node (depth = 8)
  int callframe9194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  Object call9195 = callmethodflags(*var_each, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe9194);
// compiled member node returning call9195 (depth = 8)
  int op_slot_left_9188 = gc_frame_newslot(call9195);
  params[0] = diff9192;
  partcv[0] = 1;
  Object opresult9196 = callmethod(call9195, "<(1)", 1, partcv, params);
// compiled op node returning opresult9196 (depth = 7)
  Object if9187 = done;
  if (istrue(opresult9196)) {
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9197 = alloc_Float64(0);
// compiled num node returning num9197 (depth = 8)
  *var_ix = num9197;
  if (num9197 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9187 = done;
  } else {
  }
// compiled if node returning if9187 (depth = 6)
    gc_frame_newslot(if9187);
    if9182 = if9187;
  }
// compiled if node returning if9182 (depth = 5)
    gc_frame_newslot(if9182);
    if9177 = if9182;
  }
// compiled if node returning if9177 (depth = 4)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9200 = alloc_Float64(1);
// compiled num node returning num9200 (depth = 6)
  int op_slot_right_9199 = gc_frame_newslot(num9200);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_9199 = gc_frame_newslot(*var_ix);
  params[0] = num9200;
  partcv[0] = 1;
  Object diff9202 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff9202 (depth = 5)
  *var_ix = diff9202;
  if (diff9202 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9111_reconcileComments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_comments = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
// definebindings:
// definebindings:
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// definebindings:
// definebindings:
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9112 = gc_frame_new();
// call case 4: self request
  Object call9113 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9112);
// compiled member node returning call9113 (depth = 2)
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call9116 = callmethodflags(*var_values, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9115);
// compiled member node returning call9116 (depth = 4)
  Object if9114 = done;
struct StackFrameObject *iftmpstackframe9114 = stackframe;
  if (istrue(call9116)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9114);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
    gc_frame_newslot(*var_moduleObject);
    if9114 = *var_moduleObject;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9114);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call9118 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9117);
// compiled member node returning call9118 (depth = 4)
    gc_frame_newslot(call9118);
    if9114 = call9118;
  }
stackframe = iftmpstackframe9114;
// compiled if node returning if9114 (depth = 3)
  *var_node = if9114;
  if (if9114 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9121 == NULL) {
    strlit9121 = alloc_String("lbrace");
    gc_root(strlit9121);
  }
// compiled string node returning strlit9121 (depth = 4)
  int op_slot_right_9120 = gc_frame_newslot(strlit9121);
// starting to compile member node (depth = 4)
  int callframe9123 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  Object call9124 = callmethodflags(*var_node, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9123);
// compiled member node returning call9124 (depth = 4)
  int op_slot_left_9120 = gc_frame_newslot(call9124);
  params[0] = strlit9121;
  partcv[0] = 1;
  Object opresult9125 = callmethod(call9124, "==(1)", 1, partcv, params);
// compiled op node returning opresult9125 (depth = 3)
  Object if9119 = done;
  if (istrue(opresult9125)) {
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if9119 = undefined;
  } else {
  }
// compiled if node returning if9119 (depth = 2)
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9126 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  Object call9127 = callmethodflags(*var_node, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9126);
// compiled member node returning call9127 (depth = 3)
  *var_oLine = call9127;
  if (call9127 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9128 = gc_frame_new();
// call case 5: prelude request
  Object call9129 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9128);
// compiled member node returning call9129 (depth = 3)
  *var_preComments = call9129;
  if (call9129 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9130 = gc_frame_new();
// call case 5: prelude request
  Object call9131 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9130);
// compiled member node returning call9131 (depth = 3)
  *var_postComments = call9131;
  if (call9131 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_comments (depth = 4)
  Object call9133 = callmethodflags(*var_comments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9132);
// compiled member node returning call9133 (depth = 3)
  *var_ix = call9133;
  if (call9133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9134 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9135 = alloc_Block(NULL, NULL, "parser", 3053);
  gc_frame_newslot(block9135);
// method "_apply"
  block_savedest(block9135);
  Object closure9136 = createclosure(2, "_apply");
  setclosureframe(closure9136, stackframe);
  addtoclosure(closure9136, var_ix);
  addtoclosure(closure9136, selfslot);
  struct UserObject *uo9136 = (struct UserObject*)block9135;
  uo9136->data[0] = (Object)closure9136;
  Method *meth_meth_parser_9136__apply = addmethod2pos(block9135, "_apply", &meth_parser_9136__apply, 0);
  int argcv_meth_parser_9136__apply[] = {0};
  meth_meth_parser_9136__apply->type = alloc_MethodType(1, argcv_meth_parser_9136__apply);
  meth_meth_parser_9136__apply->definitionModule = modulename;
  meth_meth_parser_9136__apply->definitionLine = 3208;
// compiled block node returning block9135 (depth = 3)
  gc_frame_newslot(block9135);
// starting to compile block node (depth = 3)
  Object block9142 = alloc_Block(NULL, NULL, "parser", 3053);
  gc_frame_newslot(block9142);
// method "_apply"
  block_savedest(block9142);
  Object closure9143 = createclosure(6, "_apply");
  setclosureframe(closure9143, stackframe);
  addtoclosure(closure9143, var_ix);
  addtoclosure(closure9143, var_comments);
  addtoclosure(closure9143, var_oLine);
  addtoclosure(closure9143, var_postComments);
  addtoclosure(closure9143, var_preComments);
  addtoclosure(closure9143, selfslot);
  struct UserObject *uo9143 = (struct UserObject*)block9142;
  uo9143->data[0] = (Object)closure9143;
  Method *meth_meth_parser_9143__apply = addmethod2pos(block9142, "_apply", &meth_parser_9143__apply, 0);
  int argcv_meth_parser_9143__apply[] = {0};
  meth_meth_parser_9143__apply->type = alloc_MethodType(1, argcv_meth_parser_9143__apply);
  meth_meth_parser_9143__apply->definitionModule = modulename;
  meth_meth_parser_9143__apply->definitionLine = 3208;
// compiled block node returning block9142 (depth = 3)
  gc_frame_newslot(block9142);
// call case 5: prelude request
  params[0] = block9135;
  params[1] = block9142;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9205 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9134);
// compiled call node returning call9205 (depth = 2)
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9206 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_postComments (depth = 4)
  Object call9207 = callmethodflags(*var_postComments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9206);
// compiled member node returning call9207 (depth = 3)
  *var_postSz = call9207;
  if (call9207 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_preComments (depth = 4)
  Object call9209 = callmethodflags(*var_preComments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9208);
// compiled member node returning call9209 (depth = 3)
  *var_preSz = call9209;
  if (call9209 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9213 = alloc_Float64(1);
// compiled num node returning num9213 (depth = 5)
  int op_slot_right_9212 = gc_frame_newslot(num9213);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_9212 = gc_frame_newslot(*var_preSz);
  params[0] = num9213;
  partcv[0] = 1;
  Object opresult9215 = callmethod(*var_preSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult9215 (depth = 4)
  int op_slot_right_9211 = gc_frame_newslot(opresult9215);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9218 = alloc_Float64(1);
// compiled num node returning num9218 (depth = 5)
  int op_slot_right_9217 = gc_frame_newslot(num9218);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_9217 = gc_frame_newslot(*var_postSz);
  params[0] = num9218;
  partcv[0] = 1;
  Object opresult9220 = callmethod(*var_postSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult9220 (depth = 4)
  int op_slot_left_9211 = gc_frame_newslot(opresult9220);
  params[0] = opresult9215;
  partcv[0] = 1;
  Object opresult9221 = callmethod(opresult9220, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9221 (depth = 3)
  Object if9210 = done;
  if (istrue(opresult9221)) {
// Begin line 3071
  setline(3071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9222 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9224 == NULL) {
    strlit9224 = alloc_String("""\x0a""");
    gc_root(strlit9224);
  }
// compiled string node returning strlit9224 (depth = 5)
  int op_slot_right_9223 = gc_frame_newslot(strlit9224);
// starting to compile member node (depth = 5)
  int callframe9226 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9227 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  Object call9228 = callmethodflags(*var_preComments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9227);
// compiled member node returning call9228 (depth = 6)
  Object call9229 = callmethodflags(call9228, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9226);
// compiled member node returning call9229 (depth = 5)
  int op_slot_left_9223 = gc_frame_newslot(call9229);
  params[0] = strlit9224;
  partcv[0] = 1;
  Object opresult9230 = callmethod(call9229, "++(1)", 1, partcv, params);
// compiled op node returning opresult9230 (depth = 4)
  gc_frame_newslot(opresult9230);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9231 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  Object call9232 = callmethodflags(*var_preComments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9231);
// compiled member node returning call9232 (depth = 4)
  params[0] = opresult9230;
  partcv[0] = 1;
  Object call9233 = callmethodflags(call9232, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9222);
// compiled call node returning call9233 (depth = 3)
    gc_frame_newslot(call9233);
    if9210 = call9233;
  } else {
  }
// compiled if node returning if9210 (depth = 2)
// Begin line 3073
  setline(3073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9234 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call9235 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9234);
// compiled call node returning call9235 (depth = 2)
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9236 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call9237 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9236);
// compiled call node returning call9237 (depth = 2)
  gc_frame_end(frame);
  return call9237;
}
Object meth_parser_9238_checkBadOperators(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// definebindings:
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9241 == NULL) {
    strlit9241 = alloc_String("=");
    gc_root(strlit9241);
  }
// compiled string node returning strlit9241 (depth = 4)
  int op_slot_right_9240 = gc_frame_newslot(strlit9241);
// starting to compile member node (depth = 4)
  int callframe9243 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9244 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9243);
// compiled member node returning call9244 (depth = 4)
  int op_slot_left_9240 = gc_frame_newslot(call9244);
  params[0] = strlit9241;
  partcv[0] = 1;
  Object opresult9245 = callmethod(call9244, "==(1)", 1, partcv, params);
// compiled op node returning opresult9245 (depth = 3)
  Object if9239 = done;
  if (istrue(opresult9245)) {
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9246 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call9248 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9247);
// compiled member node returning call9248 (depth = 5)
  Object call9249 = callmethodflags(call9248, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9246);
// compiled member node returning call9249 (depth = 4)
  *var_sugg = call9249;
  if (call9249 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9250 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9251 == NULL) {
    strlit9251 = alloc_String("=");
    gc_root(strlit9251);
  }
// compiled string node returning strlit9251 (depth = 4)
  gc_frame_newslot(strlit9251);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit9251;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9252 = callmethodflags(*var_sugg, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9250);
// compiled call node returning call9252 (depth = 3)
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9253 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9254 == NULL) {
    strlit9254 = alloc_String("use '==' to test equality, not '='.");
    gc_root(strlit9254);
  }
// compiled string node returning strlit9254 (depth = 4)
  gc_frame_newslot(strlit9254);
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9256 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9255);
// compiled member node returning call9256 (depth = 4)
  gc_frame_newslot(call9256);
// starting to compile member node (depth = 4)
  int callframe9257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9258 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9257);
// compiled member node returning call9258 (depth = 4)
  gc_frame_newslot(call9258);
// starting to compile member node (depth = 4)
  int callframe9259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9260 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9259);
// compiled member node returning call9260 (depth = 4)
  gc_frame_newslot(call9260);
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9254;
  params[1] = call9256;
  params[2] = call9258;
  params[3] = call9260;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9261 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9253);
// compiled call node returning call9261 (depth = 3)
    gc_frame_newslot(call9261);
    if9239 = call9261;
  } else {
  }
// compiled if node returning if9239 (depth = 2)
  gc_frame_end(frame);
  return if9239;
}
Object meth_parser_9262_checkBadTypeLiteral(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// definebindings:
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9265 == NULL) {
    strlit9265 = alloc_String("lbrace");
    gc_root(strlit9265);
  }
// compiled string node returning strlit9265 (depth = 4)
  int op_slot_right_9264 = gc_frame_newslot(strlit9265);
// starting to compile member node (depth = 4)
  int callframe9267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9268 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9267);
// compiled member node returning call9268 (depth = 4)
  int op_slot_left_9264 = gc_frame_newslot(call9268);
  params[0] = strlit9265;
  partcv[0] = 1;
  Object opresult9269 = callmethod(call9268, "==(1)", 1, partcv, params);
// compiled op node returning opresult9269 (depth = 3)
  Object if9263 = done;
  if (istrue(opresult9269)) {
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9271 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call9272 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9271);
// compiled member node returning call9272 (depth = 5)
  Object call9273 = callmethodflags(call9272, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9270);
// compiled member node returning call9273 (depth = 4)
  *var_sugg = call9273;
  if (call9273 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9274 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9275 == NULL) {
    strlit9275 = alloc_String("type ");
    gc_root(strlit9275);
  }
// compiled string node returning strlit9275 (depth = 4)
  gc_frame_newslot(strlit9275);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit9275;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9276 = callmethodflags(*var_sugg, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9274);
// compiled call node returning call9276 (depth = 3)
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9277 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9278 == NULL) {
    strlit9278 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit9278);
  }
// compiled string node returning strlit9278 (depth = 4)
  gc_frame_newslot(strlit9278);
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9280 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9279);
// compiled member node returning call9280 (depth = 4)
  gc_frame_newslot(call9280);
// starting to compile member node (depth = 4)
  int callframe9281 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9282 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9281);
// compiled member node returning call9282 (depth = 4)
  gc_frame_newslot(call9282);
// starting to compile member node (depth = 4)
  int callframe9283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9284 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9283);
// compiled member node returning call9284 (depth = 4)
  gc_frame_newslot(call9284);
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9278;
  params[1] = call9280;
  params[2] = call9282;
  params[3] = call9284;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9285 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9277);
// compiled call node returning call9285 (depth = 3)
    gc_frame_newslot(call9285);
    if9263 = call9285;
  } else {
  }
// compiled if node returning if9263 (depth = 2)
  gc_frame_end(frame);
  return if9263;
}
Object meth_parser_9363__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9365 == NULL) {
    strlit9365 = alloc_String("identifier");
    gc_root(strlit9365);
  }
// compiled string node returning strlit9365 (depth = 8)
  int op_slot_right_9364 = gc_frame_newslot(strlit9365);
// starting to compile member node (depth = 8)
  int callframe9367 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9368 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9367);
// compiled member node returning call9368 (depth = 8)
  int op_slot_left_9364 = gc_frame_newslot(call9368);
  params[0] = strlit9365;
  partcv[0] = 1;
  Object opresult9369 = callmethod(call9368, "==(1)", 1, partcv, params);
// compiled op node returning opresult9369 (depth = 7)
  gc_frame_end(frame);
  return opresult9369;
}
Object meth_parser_9377__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9379 == NULL) {
    strlit9379 = alloc_String("member");
    gc_root(strlit9379);
  }
// compiled string node returning strlit9379 (depth = 11)
  int op_slot_right_9378 = gc_frame_newslot(strlit9379);
// starting to compile member node (depth = 11)
  int callframe9381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe9382 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  Object call9383 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9382);
// compiled member node returning call9383 (depth = 12)
  Object call9384 = callmethodflags(call9383, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9381);
// compiled member node returning call9384 (depth = 11)
  int op_slot_left_9378 = gc_frame_newslot(call9384);
  params[0] = strlit9379;
  partcv[0] = 1;
  Object opresult9385 = callmethod(call9384, "==(1)", 1, partcv, params);
// compiled op node returning opresult9385 (depth = 10)
  gc_frame_end(frame);
  return opresult9385;
}
Object meth_parser_9374__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block9376 = alloc_Block(NULL, NULL, "parser", 3115);
  gc_frame_newslot(block9376);
// method "_apply"
  block_savedest(block9376);
  Object closure9377 = createclosure(2, "_apply");
  setclosureframe(closure9377, stackframe);
  addtoclosure(closure9377, var_values);
  addtoclosure(closure9377, selfslot);
  struct UserObject *uo9377 = (struct UserObject*)block9376;
  uo9377->data[0] = (Object)closure9377;
  Method *meth_meth_parser_9377__apply = addmethod2pos(block9376, "_apply", &meth_parser_9377__apply, 0);
  int argcv_meth_parser_9377__apply[] = {0};
  meth_meth_parser_9377__apply->type = alloc_MethodType(1, argcv_meth_parser_9377__apply);
  meth_meth_parser_9377__apply->definitionModule = modulename;
  meth_meth_parser_9377__apply->definitionLine = 3208;
// compiled block node returning block9376 (depth = 9)
  int op_slot_right_9375 = gc_frame_newslot(block9376);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9389 == NULL) {
    strlit9389 = alloc_String("identifier");
    gc_root(strlit9389);
  }
// compiled string node returning strlit9389 (depth = 10)
  int op_slot_right_9388 = gc_frame_newslot(strlit9389);
// starting to compile member node (depth = 10)
  int callframe9391 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe9392 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_values (depth = 12)
  Object call9393 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9392);
// compiled member node returning call9393 (depth = 11)
  Object call9394 = callmethodflags(call9393, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9391);
// compiled member node returning call9394 (depth = 10)
  int op_slot_left_9388 = gc_frame_newslot(call9394);
  params[0] = strlit9389;
  partcv[0] = 1;
  Object opresult9395 = callmethod(call9394, "==(1)", 1, partcv, params);
// compiled op node returning opresult9395 (depth = 9)
  int op_slot_left_9375 = gc_frame_newslot(opresult9395);
  params[0] = block9376;
  partcv[0] = 1;
  Object opresult9396 = callmethod(opresult9395, "||(1)", 1, partcv, params);
// compiled op node returning opresult9396 (depth = 8)
  gc_frame_end(frame);
  return opresult9396;
}
Object meth_parser_9286_checkUnexpectedTokenAfterStatement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// definebindings:
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// definebindings:
// definebindings:
// definebindings:
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9289 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call9290 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9289);
// compiled member node returning call9290 (depth = 4)
  int op_slot_right_9288 = gc_frame_newslot(call9290);
// starting to compile member node (depth = 4)
  int callframe9292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9293 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9292);
// compiled member node returning call9293 (depth = 4)
  int op_slot_left_9288 = gc_frame_newslot(call9293);
  params[0] = call9290;
  partcv[0] = 1;
  Object opresult9294 = callmethod(call9293, "==(1)", 1, partcv, params);
// compiled op node returning opresult9294 (depth = 3)
  Object if9287 = done;
  if (istrue(opresult9294)) {
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9298 == NULL) {
    strlit9298 = alloc_String("identifier");
    gc_root(strlit9298);
  }
// compiled string node returning strlit9298 (depth = 6)
  int op_slot_right_9297 = gc_frame_newslot(strlit9298);
// starting to compile member node (depth = 6)
  int callframe9300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call9301 = callmethodflags(*var_lastToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9300);
// compiled member node returning call9301 (depth = 6)
  int op_slot_left_9297 = gc_frame_newslot(call9301);
  params[0] = strlit9298;
  partcv[0] = 1;
  Object opresult9302 = callmethod(call9301, "==(1)", 1, partcv, params);
// compiled op node returning opresult9302 (depth = 5)
  int op_slot_right_9296 = gc_frame_newslot(opresult9302);
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9306 == NULL) {
    strlit9306 = alloc_String("=");
    gc_root(strlit9306);
  }
// compiled string node returning strlit9306 (depth = 7)
  int op_slot_right_9305 = gc_frame_newslot(strlit9306);
// starting to compile member node (depth = 7)
  int callframe9308 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9309 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9308);
// compiled member node returning call9309 (depth = 7)
  int op_slot_left_9305 = gc_frame_newslot(call9309);
  params[0] = strlit9306;
  partcv[0] = 1;
  Object opresult9310 = callmethod(call9309, "==(1)", 1, partcv, params);
// compiled op node returning opresult9310 (depth = 6)
  int op_slot_right_9304 = gc_frame_newslot(opresult9310);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9313 == NULL) {
    strlit9313 = alloc_String("op");
    gc_root(strlit9313);
  }
// compiled string node returning strlit9313 (depth = 7)
  int op_slot_right_9312 = gc_frame_newslot(strlit9313);
// starting to compile member node (depth = 7)
  int callframe9315 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9316 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9315);
// compiled member node returning call9316 (depth = 7)
  int op_slot_left_9312 = gc_frame_newslot(call9316);
  params[0] = strlit9313;
  partcv[0] = 1;
  Object opresult9317 = callmethod(call9316, "==(1)", 1, partcv, params);
// compiled op node returning opresult9317 (depth = 6)
  int op_slot_left_9304 = gc_frame_newslot(opresult9317);
  params[0] = opresult9310;
  partcv[0] = 1;
  Object opresult9318 = callmethod(opresult9317, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9318 (depth = 5)
  int op_slot_left_9296 = gc_frame_newslot(opresult9318);
  params[0] = opresult9302;
  partcv[0] = 1;
  Object opresult9319 = callmethod(opresult9318, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9319 (depth = 4)
  Object if9295 = done;
  if (istrue(opresult9319)) {
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9320 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9322 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9321);
// compiled member node returning call9322 (depth = 6)
  Object call9323 = callmethodflags(call9322, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9320);
// compiled member node returning call9323 (depth = 5)
  *var_sugg = call9323;
  if (call9323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array9324 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9324 (depth = 5)
  *var_suggestions = array9324;
  if (array9324 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9325 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool9326 = alloc_Boolean(0);
// compiled identifier node returning bool9326 (depth = 5)
  gc_frame_newslot(bool9326);
// starting to compile identifier node (depth = 5)
  Object bool9327 = alloc_Boolean(0);
// compiled identifier node returning bool9327 (depth = 5)
  gc_frame_newslot(bool9327);
// starting to compile string node (depth = 5)
  if (strlit9328 == NULL) {
    strlit9328 = alloc_String(":=");
    gc_root(strlit9328);
  }
// compiled string node returning strlit9328 (depth = 5)
  gc_frame_newslot(strlit9328);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool9326;
  params[2] = bool9327;
  params[3] = strlit9328;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9329 = callmethodflags(*var_sugg, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9325);
// compiled call node returning call9329 (depth = 4)
// Begin line 3104
  setline(3104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9330 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call9331 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9330);
// compiled call node returning call9331 (depth = 4)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9332 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9334 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9333);
// compiled member node returning call9334 (depth = 6)
  Object call9335 = callmethodflags(call9334, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9332);
// compiled member node returning call9335 (depth = 5)
  *var_sugg2 = call9335;
  if (call9335 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9336 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool9337 = alloc_Boolean(0);
// compiled identifier node returning bool9337 (depth = 5)
  gc_frame_newslot(bool9337);
// starting to compile identifier node (depth = 5)
  Object bool9338 = alloc_Boolean(0);
// compiled identifier node returning bool9338 (depth = 5)
  gc_frame_newslot(bool9338);
// starting to compile string node (depth = 5)
  if (strlit9339 == NULL) {
    strlit9339 = alloc_String("==");
    gc_root(strlit9339);
  }
// compiled string node returning strlit9339 (depth = 5)
  gc_frame_newslot(strlit9339);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool9337;
  params[2] = bool9338;
  params[3] = strlit9339;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9340 = callmethodflags(*var_sugg2, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9336);
// compiled call node returning call9340 (depth = 4)
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9341 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call9342 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9341);
// compiled call node returning call9342 (depth = 4)
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9343 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9344 == NULL) {
    strlit9344 = alloc_String("assignment uses ':=', not '='.");
    gc_root(strlit9344);
  }
// compiled string node returning strlit9344 (depth = 5)
  gc_frame_newslot(strlit9344);
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9345 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9346 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9345);
// compiled member node returning call9346 (depth = 5)
  gc_frame_newslot(call9346);
// starting to compile member node (depth = 5)
  int callframe9347 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9348 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9347);
// compiled member node returning call9348 (depth = 5)
  gc_frame_newslot(call9348);
// starting to compile member node (depth = 5)
  int callframe9349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9350 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9349);
// compiled member node returning call9350 (depth = 5)
  gc_frame_newslot(call9350);
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9344;
  params[1] = call9346;
  params[2] = call9348;
  params[3] = call9350;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9351 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9343);
// compiled call node returning call9351 (depth = 4)
    gc_frame_newslot(call9351);
    if9295 = call9351;
  } else {
  }
// compiled if node returning if9295 (depth = 3)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9354 == NULL) {
    strlit9354 = alloc_String("rbrace");
    gc_root(strlit9354);
  }
// compiled string node returning strlit9354 (depth = 5)
  int op_slot_right_9353 = gc_frame_newslot(strlit9354);
// starting to compile member node (depth = 5)
  int callframe9356 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9357 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9356);
// compiled member node returning call9357 (depth = 5)
  int op_slot_left_9353 = gc_frame_newslot(call9357);
  params[0] = strlit9354;
  partcv[0] = 1;
  Object opresult9358 = callmethod(call9357, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9358 (depth = 4)
  Object if9352 = done;
  if (istrue(opresult9358)) {
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array9359 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9359 (depth = 5)
  *var_suggestions = array9359;
  if (array9359 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block9362 = alloc_Block(NULL, NULL, "parser", 3115);
  gc_frame_newslot(block9362);
// method "_apply"
  block_savedest(block9362);
  Object closure9363 = createclosure(2, "_apply");
  setclosureframe(closure9363, stackframe);
  addtoclosure(closure9363, var_sym);
  addtoclosure(closure9363, selfslot);
  struct UserObject *uo9363 = (struct UserObject*)block9362;
  uo9363->data[0] = (Object)closure9363;
  Method *meth_meth_parser_9363__apply = addmethod2pos(block9362, "_apply", &meth_parser_9363__apply, 0);
  int argcv_meth_parser_9363__apply[] = {0};
  meth_meth_parser_9363__apply->type = alloc_MethodType(1, argcv_meth_parser_9363__apply);
  meth_meth_parser_9363__apply->definitionModule = modulename;
  meth_meth_parser_9363__apply->definitionLine = 3208;
// compiled block node returning block9362 (depth = 6)
  int op_slot_right_9361 = gc_frame_newslot(block9362);
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block9373 = alloc_Block(NULL, NULL, "parser", 3115);
  gc_frame_newslot(block9373);
// method "_apply"
  block_savedest(block9373);
  Object closure9374 = createclosure(2, "_apply");
  setclosureframe(closure9374, stackframe);
  addtoclosure(closure9374, var_values);
  addtoclosure(closure9374, selfslot);
  struct UserObject *uo9374 = (struct UserObject*)block9373;
  uo9374->data[0] = (Object)closure9374;
  Method *meth_meth_parser_9374__apply = addmethod2pos(block9373, "_apply", &meth_parser_9374__apply, 0);
  int argcv_meth_parser_9374__apply[] = {0};
  meth_meth_parser_9374__apply->type = alloc_MethodType(1, argcv_meth_parser_9374__apply);
  meth_meth_parser_9374__apply->definitionModule = modulename;
  meth_meth_parser_9374__apply->definitionLine = 3208;
// compiled block node returning block9373 (depth = 7)
  int op_slot_right_9372 = gc_frame_newslot(block9373);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9400 = alloc_Float64(0);
// compiled num node returning num9400 (depth = 8)
  int op_slot_right_9399 = gc_frame_newslot(num9400);
// starting to compile member node (depth = 8)
  int callframe9402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call9403 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9402);
// compiled member node returning call9403 (depth = 8)
  int op_slot_left_9399 = gc_frame_newslot(call9403);
  params[0] = num9400;
  partcv[0] = 1;
  Object opresult9404 = callmethod(call9403, ">(1)", 1, partcv, params);
// compiled op node returning opresult9404 (depth = 7)
  int op_slot_left_9372 = gc_frame_newslot(opresult9404);
  params[0] = block9373;
  partcv[0] = 1;
  Object opresult9405 = callmethod(opresult9404, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9405 (depth = 6)
  int op_slot_left_9361 = gc_frame_newslot(opresult9405);
  params[0] = block9362;
  partcv[0] = 1;
  Object opresult9406 = callmethod(opresult9405, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9406 (depth = 5)
  Object if9360 = done;
  if (istrue(opresult9406)) {
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9407 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9408 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9409 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9408);
// compiled member node returning call9409 (depth = 7)
  Object call9410 = callmethodflags(call9409, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9407);
// compiled member node returning call9410 (depth = 6)
  *var_suggestion = call9410;
  if (call9410 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9412 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool9413 = alloc_Boolean(1);
// compiled identifier node returning bool9413 (depth = 6)
  gc_frame_newslot(bool9413);
// starting to compile identifier node (depth = 6)
  Object bool9414 = alloc_Boolean(0);
// compiled identifier node returning bool9414 (depth = 6)
  gc_frame_newslot(bool9414);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9416 == NULL) {
    strlit9416 = alloc_String(")");
    gc_root(strlit9416);
  }
// compiled string node returning strlit9416 (depth = 7)
  int op_slot_right_9415 = gc_frame_newslot(strlit9416);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9419 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9420 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9419);
// compiled member node returning call9420 (depth = 8)
  int op_slot_right_9418 = gc_frame_newslot(call9420);
// starting to compile string node (depth = 8)
  if (strlit9422 == NULL) {
    strlit9422 = alloc_String("(");
    gc_root(strlit9422);
  }
// compiled string node returning strlit9422 (depth = 8)
  int op_slot_left_9418 = gc_frame_newslot(strlit9422);
  params[0] = call9420;
  partcv[0] = 1;
  Object opresult9423 = callmethod(strlit9422, "++(1)", 1, partcv, params);
// compiled op node returning opresult9423 (depth = 7)
  int op_slot_left_9415 = gc_frame_newslot(opresult9423);
  params[0] = strlit9416;
  partcv[0] = 1;
  Object opresult9424 = callmethod(opresult9423, "++(1)", 1, partcv, params);
// compiled op node returning opresult9424 (depth = 6)
  gc_frame_newslot(opresult9424);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool9413;
  params[2] = bool9414;
  params[3] = opresult9424;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9425 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9412);
// compiled call node returning call9425 (depth = 5)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9426 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9427 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9426);
// compiled call node returning call9427 (depth = 5)
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9430 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9431 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe9430);
// compiled member node returning call9431 (depth = 7)
  int op_slot_right_9429 = gc_frame_newslot(call9431);
// starting to compile identifier node (depth = 7)
  Object bool9433 = alloc_Boolean(0);
// compiled identifier node returning bool9433 (depth = 7)
  int op_slot_left_9429 = gc_frame_newslot(bool9433);
  params[0] = call9431;
  partcv[0] = 1;
  Object opresult9434 = callmethod(bool9433, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9434 (depth = 6)
  Object if9428 = done;
  if (istrue(opresult9434)) {
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9436 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe9435);
// compiled member node returning call9436 (depth = 7)
  *var_n = call9436;
  if (call9436 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9439 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9440 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9439);
// compiled member node returning call9440 (depth = 8)
  int op_slot_right_9438 = gc_frame_newslot(call9440);
// starting to compile member node (depth = 8)
  int callframe9442 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call9443 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9442);
// compiled member node returning call9443 (depth = 8)
  int op_slot_left_9438 = gc_frame_newslot(call9443);
  params[0] = call9440;
  partcv[0] = 1;
  Object opresult9444 = callmethod(call9443, "==(1)", 1, partcv, params);
// compiled op node returning opresult9444 (depth = 7)
  Object if9437 = done;
  if (istrue(opresult9444)) {
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9445 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9446 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call9447 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9446);
// compiled member node returning call9447 (depth = 9)
  Object call9448 = callmethodflags(call9447, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9445);
// compiled member node returning call9448 (depth = 8)
  *var_suggestion = call9448;
  if (call9448 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9450 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool9451 = alloc_Boolean(1);
// compiled identifier node returning bool9451 (depth = 8)
  gc_frame_newslot(bool9451);
// starting to compile identifier node (depth = 8)
  Object bool9452 = alloc_Boolean(0);
// compiled identifier node returning bool9452 (depth = 8)
  gc_frame_newslot(bool9452);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9454 == NULL) {
    strlit9454 = alloc_String("");
    gc_root(strlit9454);
  }
// compiled string node returning strlit9454 (depth = 9)
  int op_slot_right_9453 = gc_frame_newslot(strlit9454);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe9457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9458 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9457);
// compiled member node returning call9458 (depth = 10)
  int op_slot_right_9456 = gc_frame_newslot(call9458);
// starting to compile string node (depth = 10)
  if (strlit9460 == NULL) {
    strlit9460 = alloc_String("(");
    gc_root(strlit9460);
  }
// compiled string node returning strlit9460 (depth = 10)
  int op_slot_left_9456 = gc_frame_newslot(strlit9460);
  params[0] = call9458;
  partcv[0] = 1;
  Object opresult9461 = callmethod(strlit9460, "++(1)", 1, partcv, params);
// compiled op node returning opresult9461 (depth = 9)
  int op_slot_left_9453 = gc_frame_newslot(opresult9461);
  params[0] = strlit9454;
  partcv[0] = 1;
  Object opresult9462 = callmethod(opresult9461, "++(1)", 1, partcv, params);
// compiled op node returning opresult9462 (depth = 8)
  gc_frame_newslot(opresult9462);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool9451;
  params[2] = bool9452;
  params[3] = opresult9462;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9463 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9450);
// compiled call node returning call9463 (depth = 7)
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9464 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9465 == NULL) {
    strlit9465 = alloc_String(")");
    gc_root(strlit9465);
  }
// compiled string node returning strlit9465 (depth = 8)
  gc_frame_newslot(strlit9465);
// starting to compile member node (depth = 8)
  int callframe9466 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9467 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9466);
// compiled member node returning call9467 (depth = 8)
  gc_frame_newslot(call9467);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9465;
  params[1] = call9467;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9468 = callmethodflags(*var_suggestion, "append(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9464);
// compiled call node returning call9468 (depth = 7)
// Begin line 3125
  setline(3125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9469 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9470 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9469);
// compiled call node returning call9470 (depth = 7)
    gc_frame_newslot(call9470);
    if9437 = call9470;
  } else {
  }
// compiled if node returning if9437 (depth = 6)
    gc_frame_newslot(if9437);
    if9428 = if9437;
  } else {
  }
// compiled if node returning if9428 (depth = 5)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9473 == NULL) {
    strlit9473 = alloc_String("identifier");
    gc_root(strlit9473);
  }
// compiled string node returning strlit9473 (depth = 7)
  int op_slot_right_9472 = gc_frame_newslot(strlit9473);
// starting to compile member node (depth = 7)
  int callframe9475 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call9477 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe9476);
// compiled member node returning call9477 (depth = 8)
  Object call9478 = callmethodflags(call9477, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9475);
// compiled member node returning call9478 (depth = 7)
  int op_slot_left_9472 = gc_frame_newslot(call9478);
  params[0] = strlit9473;
  partcv[0] = 1;
  Object opresult9479 = callmethod(call9478, "==(1)", 1, partcv, params);
// compiled op node returning opresult9479 (depth = 6)
  Object if9471 = done;
  if (istrue(opresult9479)) {
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9480 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call9482 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9481);
// compiled member node returning call9482 (depth = 8)
  Object call9483 = callmethodflags(call9482, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9480);
// compiled member node returning call9483 (depth = 7)
  *var_suggestion = call9483;
  if (call9483 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9485 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool9486 = alloc_Boolean(0);
// compiled identifier node returning bool9486 (depth = 7)
  gc_frame_newslot(bool9486);
// starting to compile identifier node (depth = 7)
  Object bool9487 = alloc_Boolean(0);
// compiled identifier node returning bool9487 (depth = 7)
  gc_frame_newslot(bool9487);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9489 == NULL) {
    strlit9489 = alloc_String("""\x22""");
    gc_root(strlit9489);
  }
// compiled string node returning strlit9489 (depth = 8)
  int op_slot_right_9488 = gc_frame_newslot(strlit9489);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe9492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9493 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9492);
// compiled member node returning call9493 (depth = 9)
  int op_slot_right_9491 = gc_frame_newslot(call9493);
// starting to compile string node (depth = 9)
  if (strlit9495 == NULL) {
    strlit9495 = alloc_String("""\x22""");
    gc_root(strlit9495);
  }
// compiled string node returning strlit9495 (depth = 9)
  int op_slot_left_9491 = gc_frame_newslot(strlit9495);
  params[0] = call9493;
  partcv[0] = 1;
  Object opresult9496 = callmethod(strlit9495, "++(1)", 1, partcv, params);
// compiled op node returning opresult9496 (depth = 8)
  int op_slot_left_9488 = gc_frame_newslot(opresult9496);
  params[0] = strlit9489;
  partcv[0] = 1;
  Object opresult9497 = callmethod(opresult9496, "++(1)", 1, partcv, params);
// compiled op node returning opresult9497 (depth = 7)
  gc_frame_newslot(opresult9497);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool9486;
  params[2] = bool9487;
  params[3] = opresult9497;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9498 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9485);
// compiled call node returning call9498 (depth = 6)
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9499 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9500 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9499);
// compiled call node returning call9500 (depth = 6)
    gc_frame_newslot(call9500);
    if9471 = call9500;
  } else {
  }
// compiled if node returning if9471 (depth = 5)
    gc_frame_newslot(if9471);
    if9360 = if9471;
  } else {
  }
// compiled if node returning if9360 (depth = 4)
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9501 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array9502 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("rbrace");
    gc_root(strlit9503);
  }
// compiled string node returning strlit9503 (depth = 7)
  params[0] = strlit9503;
  partcv[0] = 1;
  callmethodflags(array9502, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array9502 (depth = 6)
  gc_frame_newslot(array9502);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array9502;
  partcv[0] = 1;
  Object call9504 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9501);
// compiled call node returning call9504 (depth = 5)
  *var_nextTok = call9504;
  if (call9504 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_9506 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_9506 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9508 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult9508 (depth = 5)
  Object if9505 = done;
  if (istrue(opresult9508)) {
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9509 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9511 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9510);
// compiled member node returning call9511 (depth = 7)
  Object call9512 = callmethodflags(call9511, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9509);
// compiled member node returning call9512 (depth = 6)
  *var_suggestion = call9512;
  if (call9512 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9514 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe9515 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call9516 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9515);
// compiled member node returning call9516 (depth = 6)
  gc_frame_newslot(call9516);
// starting to compile call node (depth = 6)
  int callframe9517 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9518 = alloc_Float64(1);
// compiled num node returning num9518 (depth = 7)
  gc_frame_newslot(num9518);
// starting to compile member node (depth = 7)
  int callframe9519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9520 = callmethodflags(*var_lastToken, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe9519);
// compiled member node returning call9520 (depth = 7)
  gc_frame_newslot(call9520);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe9521 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe9522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call9523 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9522);
// compiled member node returning call9523 (depth = 8)
  gc_frame_newslot(call9523);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9524 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  Object call9525 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe9524);
// compiled member node returning call9525 (depth = 8)
  params[0] = call9523;
  partcv[0] = 1;
  Object call9526 = callmethodflags(call9525, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9521);
// compiled call node returning call9526 (depth = 7)
  params[0] = num9518;
  params[1] = call9520;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9527 = callmethodflags(call9526, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9517);
// compiled call node returning call9527 (depth = 6)
  gc_frame_newslot(call9527);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call9516;
  params[1] = call9527;
  partcv[0] = 2;
  Object call9528 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9514);
// compiled call node returning call9528 (depth = 5)
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9529 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe9530 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9531 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9530);
// compiled member node returning call9531 (depth = 7)
  gc_frame_newslot(call9531);
// starting to compile member node (depth = 7)
  int callframe9532 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe9533 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe9534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9535 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9534);
// compiled member node returning call9535 (depth = 9)
  gc_frame_newslot(call9535);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call9537 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe9536);
// compiled member node returning call9537 (depth = 9)
  params[0] = call9535;
  partcv[0] = 1;
  Object call9538 = callmethodflags(call9537, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9533);
// compiled call node returning call9538 (depth = 8)
  Object call9539 = callmethodflags(call9538, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9532);
// compiled member node returning call9539 (depth = 7)
  gc_frame_newslot(call9539);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe9540 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe9541 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9542 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9541);
// compiled member node returning call9542 (depth = 8)
  gc_frame_newslot(call9542);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  Object call9544 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe9543);
// compiled member node returning call9544 (depth = 8)
  params[0] = call9542;
  partcv[0] = 1;
  Object call9545 = callmethodflags(call9544, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9540);
// compiled call node returning call9545 (depth = 7)
  params[0] = call9531;
  params[1] = call9539;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9546 = callmethodflags(call9545, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9529);
// compiled call node returning call9546 (depth = 6)
  *var_newLine = call9546;
  if (call9546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9547 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9549 = alloc_Float64(0.1);
// compiled num node returning num9549 (depth = 7)
  int op_slot_right_9548 = gc_frame_newslot(num9549);
// starting to compile member node (depth = 7)
  int callframe9551 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9552 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9551);
// compiled member node returning call9552 (depth = 7)
  int op_slot_left_9548 = gc_frame_newslot(call9552);
  params[0] = num9549;
  partcv[0] = 1;
  Object sum9553 = callmethod(call9552, "+(1)", 1, partcv, params);
// compiled op node returning sum9553 (depth = 6)
  gc_frame_newslot(sum9553);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum9553;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call9554 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9547);
// compiled call node returning call9554 (depth = 5)
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9555 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9556 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9555);
// compiled call node returning call9556 (depth = 5)
    gc_frame_newslot(call9556);
    if9505 = call9556;
  } else {
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9557 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9558 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9559 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9558);
// compiled member node returning call9559 (depth = 7)
  Object call9560 = callmethodflags(call9559, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9557);
// compiled member node returning call9560 (depth = 6)
  *var_suggestion = call9560;
  if (call9560 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3143
  setline(3143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9562 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe9563 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call9564 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe9563);
// compiled member node returning call9564 (depth = 6)
  gc_frame_newslot(call9564);
// starting to compile identifier node (depth = 6)
  Object bool9565 = alloc_Boolean(1);
// compiled identifier node returning bool9565 (depth = 6)
  gc_frame_newslot(bool9565);
// starting to compile identifier node (depth = 6)
  Object bool9566 = alloc_Boolean(0);
// compiled identifier node returning bool9566 (depth = 6)
  gc_frame_newslot(bool9566);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call9564;
  params[2] = bool9565;
  params[3] = bool9566;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9567 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9562);
// compiled call node returning call9567 (depth = 5)
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9568 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9569 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9568);
// compiled call node returning call9569 (depth = 5)
    gc_frame_newslot(call9569);
    if9505 = call9569;
  }
// compiled if node returning if9505 (depth = 4)
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9570 = gc_frame_new();
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9572 == NULL) {
    strlit9572 = alloc_String("or by omitting a part of a method name.");
    gc_root(strlit9572);
  }
// compiled string node returning strlit9572 (depth = 6)
  int op_slot_right_9571 = gc_frame_newslot(strlit9572);
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9575 == NULL) {
    strlit9575 = alloc_String("This error is often caused by unbalanced parentheses, ");
    gc_root(strlit9575);
  }
// compiled string node returning strlit9575 (depth = 7)
  int op_slot_right_9574 = gc_frame_newslot(strlit9575);
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9577 == NULL) {
    strlit9577 = alloc_String("multiple statements must be separated by a newline or a semicolon. ");
    gc_root(strlit9577);
  }
// compiled string node returning strlit9577 (depth = 7)
  int op_slot_left_9574 = gc_frame_newslot(strlit9577);
  params[0] = strlit9575;
  partcv[0] = 1;
  Object opresult9578 = callmethod(strlit9577, "++(1)", 1, partcv, params);
// compiled op node returning opresult9578 (depth = 6)
  int op_slot_left_9571 = gc_frame_newslot(opresult9578);
  params[0] = strlit9572;
  partcv[0] = 1;
  Object opresult9579 = callmethod(opresult9578, "++(1)", 1, partcv, params);
// compiled op node returning opresult9579 (depth = 5)
  gc_frame_newslot(opresult9579);
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9580 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9581 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9580);
// compiled member node returning call9581 (depth = 5)
  gc_frame_newslot(call9581);
// starting to compile member node (depth = 5)
  int callframe9582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9583 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9582);
// compiled member node returning call9583 (depth = 5)
  gc_frame_newslot(call9583);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult9579;
  params[1] = call9581;
  params[2] = call9583;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9584 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9570);
// compiled call node returning call9584 (depth = 4)
    gc_frame_newslot(call9584);
    if9352 = call9584;
  } else {
  }
// compiled if node returning if9352 (depth = 3)
    gc_frame_newslot(if9352);
    if9287 = if9352;
  } else {
  }
// compiled if node returning if9287 (depth = 2)
  gc_frame_end(frame);
  return if9287;
}
Object meth_parser_9636__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9638 = alloc_Float64(0);
// compiled num node returning num9638 (depth = 5)
  int op_slot_right_9637 = gc_frame_newslot(num9638);
// starting to compile member node (depth = 5)
  int callframe9640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call9641 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9640);
// compiled member node returning call9641 (depth = 5)
  int op_slot_left_9637 = gc_frame_newslot(call9641);
  params[0] = num9638;
  partcv[0] = 1;
  Object opresult9642 = callmethod(call9641, ">(1)", 1, partcv, params);
// compiled op node returning opresult9642 (depth = 4)
  gc_frame_end(frame);
  return opresult9642;
}
Object meth_parser_9655__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe9656 = gc_frame_new();
// call case 4: self request
  Object call9657 = callmethodflags(self, "inheritOrUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9656);
// compiled member node returning call9657 (depth = 7)
  gc_frame_end(frame);
  return call9657;
}
Object meth_parser_9645__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_oldlength = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9646 = gc_frame_new();
// call case 4: self request
  Object call9647 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9646);
// compiled member node returning call9647 (depth = 4)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9648 = gc_frame_new();
// call case 4: self request
  Object call9649 = callmethodflags(self, "methoddec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9648);
// compiled member node returning call9649 (depth = 4)
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9650 = gc_frame_new();
// call case 4: self request
  Object call9651 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9650);
// compiled member node returning call9651 (depth = 4)
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9653 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9654 = alloc_Block(NULL, NULL, "parser", 3181);
  gc_frame_newslot(block9654);
// method "_apply"
  block_savedest(block9654);
  Object closure9655 = createclosure(1, "_apply");
  setclosureframe(closure9655, stackframe);
  addtoclosure(closure9655, selfslot);
  struct UserObject *uo9655 = (struct UserObject*)block9654;
  uo9655->data[0] = (Object)closure9655;
  Method *meth_meth_parser_9655__apply = addmethod2pos(block9654, "_apply", &meth_parser_9655__apply, 0);
  int argcv_meth_parser_9655__apply[] = {0};
  meth_meth_parser_9655__apply->type = alloc_MethodType(1, argcv_meth_parser_9655__apply);
  meth_meth_parser_9655__apply->definitionModule = modulename;
  meth_meth_parser_9655__apply->definitionLine = 3208;
// compiled block node returning block9654 (depth = 6)
  gc_frame_newslot(block9654);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block9654;
  partcv[0] = 1;
  Object call9659 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9653);
// compiled call node returning call9659 (depth = 5)
  Object if9652 = done;
  if (istrue(call9659)) {
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call9661 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9660);
// compiled member node returning call9661 (depth = 6)
  *var_parentNode = call9661;
  if (call9661 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9663 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_parentNode (depth = 7)
  Object call9664 = callmethodflags(*var_parentNode, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe9663);
// compiled member node returning call9664 (depth = 6)
  Object if9662 = done;
  if (istrue(call9664)) {
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9665 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_parentNode (depth = 7)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9666 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_moduleObject (depth = 8)
  Object call9667 = callmethodflags(*var_moduleObject, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe9666);
// compiled member node returning call9667 (depth = 7)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call9668 = callmethodflags(call9667, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9665);
// compiled call node returning call9668 (depth = 6)
    gc_frame_newslot(call9668);
    if9662 = call9668;
  } else {
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe9670 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9671 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  Object call9672 = callmethodflags(*var_moduleObject, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe9671);
// compiled member node returning call9672 (depth = 8)
  Object call9673 = callmethodflags(call9672, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9670);
// compiled member node returning call9673 (depth = 7)
  Object if9669 = done;
  if (istrue(call9673)) {
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9674 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_moduleObject (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call9675 = callmethodflags(*var_moduleObject, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9674);
// compiled call node returning call9675 (depth = 7)
    gc_frame_newslot(call9675);
    if9669 = call9675;
  } else {
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9676 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit9678 == NULL) {
    strlit9678 = alloc_String("before 'use' in a module.");
    gc_root(strlit9678);
  }
// compiled string node returning strlit9678 (depth = 9)
  int op_slot_right_9677 = gc_frame_newslot(strlit9678);
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit9680 == NULL) {
    strlit9680 = alloc_String("'inherit' must come ");
    gc_root(strlit9680);
  }
// compiled string node returning strlit9680 (depth = 9)
  int op_slot_left_9677 = gc_frame_newslot(strlit9680);
  params[0] = strlit9678;
  partcv[0] = 1;
  Object opresult9681 = callmethod(strlit9680, "++(1)", 1, partcv, params);
// compiled op node returning opresult9681 (depth = 8)
  gc_frame_newslot(opresult9681);
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe9682 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  Object call9683 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9682);
// compiled member node returning call9683 (depth = 8)
  gc_frame_newslot(call9683);
// starting to compile member node (depth = 8)
  int callframe9684 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  Object call9685 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9684);
// compiled member node returning call9685 (depth = 8)
  gc_frame_newslot(call9685);
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9687 = alloc_Float64(6);
// compiled num node returning num9687 (depth = 9)
  int op_slot_right_9686 = gc_frame_newslot(num9687);
// starting to compile member node (depth = 9)
  int callframe9689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call9690 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9689);
// compiled member node returning call9690 (depth = 9)
  int op_slot_left_9686 = gc_frame_newslot(call9690);
  params[0] = num9687;
  partcv[0] = 1;
  Object sum9691 = callmethod(call9690, "+(1)", 1, partcv, params);
// compiled op node returning sum9691 (depth = 8)
  gc_frame_newslot(sum9691);
// call case 6: other requests
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult9681;
  params[1] = call9683;
  params[2] = call9685;
  params[3] = sum9691;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call9692 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe9676);
// compiled call node returning call9692 (depth = 7)
    gc_frame_newslot(call9692);
    if9669 = call9692;
  }
// compiled if node returning if9669 (depth = 6)
    gc_frame_newslot(if9669);
    if9662 = if9669;
  }
// compiled if node returning if9662 (depth = 5)
    gc_frame_newslot(if9662);
    if9652 = if9662;
  } else {
  }
// compiled if node returning if9652 (depth = 4)
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9693 = gc_frame_new();
// call case 4: self request
  Object call9694 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9693);
// compiled member node returning call9694 (depth = 4)
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9695 = gc_frame_new();
// call case 4: self request
  Object call9696 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9695);
// compiled member node returning call9696 (depth = 4)
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_9698 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
  int callframe9700 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  Object call9701 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9700);
// compiled member node returning call9701 (depth = 6)
  int op_slot_left_9698 = gc_frame_newslot(call9701);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult9702 = callmethod(call9701, "==(1)", 1, partcv, params);
// compiled op node returning opresult9702 (depth = 5)
  Object if9697 = done;
  if (istrue(opresult9702)) {
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9703 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9705 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9704);
// compiled member node returning call9705 (depth = 7)
  Object call9706 = callmethodflags(call9705, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9703);
// compiled member node returning call9706 (depth = 6)
  *var_suggestion = call9706;
  if (call9706 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9707 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9708 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9707);
// compiled call node returning call9708 (depth = 5)
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9709 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 3200
  setline(3200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9711 == NULL) {
    strlit9711 = alloc_String("caused by an extra '}', ')', or ']'.");
    gc_root(strlit9711);
  }
// compiled string node returning strlit9711 (depth = 7)
  int op_slot_right_9710 = gc_frame_newslot(strlit9711);
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9713 == NULL) {
    strlit9713 = alloc_String("invalid statement. This is often ");
    gc_root(strlit9713);
  }
// compiled string node returning strlit9713 (depth = 7)
  int op_slot_left_9710 = gc_frame_newslot(strlit9713);
  params[0] = strlit9711;
  partcv[0] = 1;
  Object opresult9714 = callmethod(strlit9713, "++(1)", 1, partcv, params);
// compiled op node returning opresult9714 (depth = 6)
  gc_frame_newslot(opresult9714);
// Begin line 3201
  setline(3201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9716 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9715);
// compiled member node returning call9716 (depth = 6)
  gc_frame_newslot(call9716);
// starting to compile member node (depth = 6)
  int callframe9717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9718 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9717);
// compiled member node returning call9718 (depth = 6)
  gc_frame_newslot(call9718);
// starting to compile member node (depth = 6)
  int callframe9719 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9720 = callmethodflags(*var_sym, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe9719);
// compiled member node returning call9720 (depth = 6)
  gc_frame_newslot(call9720);
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult9714;
  params[1] = call9716;
  params[2] = call9718;
  params[3] = call9720;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9721 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9709);
// compiled call node returning call9721 (depth = 5)
    gc_frame_newslot(call9721);
    if9697 = call9721;
  } else {
  }
// compiled if node returning if9697 (depth = 4)
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9722 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call9723 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9722);
// compiled member node returning call9723 (depth = 5)
  *var_oldlength = call9723;
  if (call9723 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9585_parse_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parse(_)");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_moduleObject = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parse(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parse(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
// definebindings:
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9586 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit9587 == NULL) {
    strlit9587 = alloc_String("parsing.");
    gc_root(strlit9587);
  }
// compiled string node returning strlit9587 (depth = 3)
  gc_frame_newslot(strlit9587);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit9587;
  partcv[0] = 1;
  Object call9588 = callmethodflags(*var_util, "log_verbose(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9586);
// compiled call node returning call9588 (depth = 2)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9589 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
  int callframe9590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  Object call9591 = callmethodflags(*var_util, "modname", 0, partcv, params, 0);
  gc_frame_end(callframe9590);
// compiled member node returning call9591 (depth = 4)
  gc_frame_newslot(call9591);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9592 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call9593 = callmethodflags(*var_ast, "moduleNode", 0, partcv, params, 0);
  gc_frame_end(callframe9592);
// compiled member node returning call9593 (depth = 4)
  params[0] = *var_values;
  params[1] = call9591;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9594 = callmethodflags(call9593, "body(1)named(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9589);
// compiled call node returning call9594 (depth = 3)
  *var_moduleObject = call9594;
  if (call9594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num9598 = alloc_Float64(0);
// compiled num node returning num9598 (depth = 4)
  int op_slot_right_9597 = gc_frame_newslot(num9598);
// starting to compile member node (depth = 4)
  int callframe9600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_toks (depth = 5)
  Object call9601 = callmethodflags(*var_toks, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9600);
// compiled member node returning call9601 (depth = 4)
  int op_slot_left_9597 = gc_frame_newslot(call9601);
  params[0] = num9598;
  partcv[0] = 1;
  Object opresult9602 = callmethod(call9601, "==(1)", 1, partcv, params);
// compiled op node returning opresult9602 (depth = 3)
  Object if9596 = done;
  if (istrue(opresult9602)) {
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if9596 = undefined;
  } else {
  }
// compiled if node returning if9596 (depth = 2)
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9604 = gc_frame_new();
// call case 4: self request
  Object call9605 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9604);
// compiled member node returning call9605 (depth = 2)
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num9608 = alloc_Float64(0);
// compiled num node returning num9608 (depth = 4)
  int op_slot_right_9607 = gc_frame_newslot(num9608);
// starting to compile member node (depth = 4)
  int callframe9610 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9611 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9610);
// compiled member node returning call9611 (depth = 4)
  int op_slot_left_9607 = gc_frame_newslot(call9611);
  params[0] = num9608;
  partcv[0] = 1;
  Object opresult9612 = callmethod(call9611, ">(1)", 1, partcv, params);
// compiled op node returning opresult9612 (depth = 3)
  Object if9606 = done;
  if (istrue(opresult9612)) {
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9613 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call9615 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9614);
// compiled member node returning call9615 (depth = 5)
  Object call9616 = callmethodflags(call9615, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9613);
// compiled member node returning call9616 (depth = 4)
  *var_sugg = call9616;
  if (call9616 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9617 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9618 = alloc_Float64(1);
// compiled num node returning num9618 (depth = 4)
  gc_frame_newslot(num9618);
// starting to compile member node (depth = 4)
  int callframe9619 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9620 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9619);
// compiled member node returning call9620 (depth = 4)
  gc_frame_newslot(call9620);
// starting to compile member node (depth = 4)
  int callframe9621 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9622 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9621);
// compiled member node returning call9622 (depth = 4)
  gc_frame_newslot(call9622);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num9618;
  params[1] = call9620;
  params[2] = call9622;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9623 = callmethodflags(*var_sugg, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9617);
// compiled call node returning call9623 (depth = 3)
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9624 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9625 == NULL) {
    strlit9625 = alloc_String("the first line must not be indented.");
    gc_root(strlit9625);
  }
// compiled string node returning strlit9625 (depth = 4)
  gc_frame_newslot(strlit9625);
// Begin line 3173
  setline(3173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9627 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9626);
// compiled member node returning call9627 (depth = 4)
  gc_frame_newslot(call9627);
// starting to compile num node (depth = 4)
  Object num9628 = alloc_Float64(1);
// compiled num node returning num9628 (depth = 4)
  gc_frame_newslot(num9628);
// starting to compile member node (depth = 4)
  int callframe9629 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9630 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9629);
// compiled member node returning call9630 (depth = 4)
  gc_frame_newslot(call9630);
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9625;
  params[1] = call9627;
  params[2] = num9628;
  params[3] = call9630;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9631 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9624);
// compiled call node returning call9631 (depth = 3)
    gc_frame_newslot(call9631);
    if9606 = call9631;
  } else {
  }
// compiled if node returning if9606 (depth = 2)
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9632 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call9633 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9632);
// compiled member node returning call9633 (depth = 3)
  *var_oldlength = call9633;
  if (call9633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9634 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9635 = alloc_Block(NULL, NULL, "parser", 3177);
  gc_frame_newslot(block9635);
// method "_apply"
  block_savedest(block9635);
  Object closure9636 = createclosure(2, "_apply");
  setclosureframe(closure9636, stackframe);
  addtoclosure(closure9636, var_tokens);
  addtoclosure(closure9636, selfslot);
  struct UserObject *uo9636 = (struct UserObject*)block9635;
  uo9636->data[0] = (Object)closure9636;
  Method *meth_meth_parser_9636__apply = addmethod2pos(block9635, "_apply", &meth_parser_9636__apply, 0);
  int argcv_meth_parser_9636__apply[] = {0};
  meth_meth_parser_9636__apply->type = alloc_MethodType(1, argcv_meth_parser_9636__apply);
  meth_meth_parser_9636__apply->definitionModule = modulename;
  meth_meth_parser_9636__apply->definitionLine = 3208;
// compiled block node returning block9635 (depth = 3)
  gc_frame_newslot(block9635);
// starting to compile block node (depth = 3)
  Object block9644 = alloc_Block(NULL, NULL, "parser", 3177);
  gc_frame_newslot(block9644);
// method "_apply"
  block_savedest(block9644);
  Object closure9645 = createclosure(7, "_apply");
  setclosureframe(closure9645, stackframe);
  addtoclosure(closure9645, var_values);
  addtoclosure(closure9645, var_moduleObject);
  addtoclosure(closure9645, var_errormessages);
  addtoclosure(closure9645, var_oldlength);
  addtoclosure(closure9645, var_tokens);
  addtoclosure(closure9645, var_sym);
  addtoclosure(closure9645, selfslot);
  struct UserObject *uo9645 = (struct UserObject*)block9644;
  uo9645->data[0] = (Object)closure9645;
  Method *meth_meth_parser_9645__apply = addmethod2pos(block9644, "_apply", &meth_parser_9645__apply, 0);
  int argcv_meth_parser_9645__apply[] = {0};
  meth_meth_parser_9645__apply->type = alloc_MethodType(1, argcv_meth_parser_9645__apply);
  meth_meth_parser_9645__apply->definitionModule = modulename;
  meth_meth_parser_9645__apply->definitionLine = 3208;
// compiled block node returning block9644 (depth = 3)
  gc_frame_newslot(block9644);
// call case 5: prelude request
  params[0] = block9635;
  params[1] = block9644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9726 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9634);
// compiled call node returning call9726 (depth = 2)
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9727 = gc_frame_new();
// call case 4: self request
  Object call9728 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9727);
// compiled member node returning call9728 (depth = 2)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9729 = gc_frame_new();
// call case 4: self request
  Object call9730 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9729);
// compiled member node returning call9730 (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_9732_lastLine(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_9733_lastLine_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastLine:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastLine:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9736_lastIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_9737_lastIndent_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9740_indentFreePass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_9741_indentFreePass_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indentFreePass:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indentFreePass:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9744_minIndentLevel(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_9745_minIndentLevel_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method minIndentLevel:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part minIndentLevel:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9748_statementIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_9749_statementIndent_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9752_tokens(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_9753_tokens_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokens:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tokens:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9755_moduleObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  gc_frame_end(frame);
  return *var_moduleObject;
}
Object meth_parser_9756_moduleObject_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method moduleObject:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part moduleObject:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_moduleObject = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9760_comments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_9761_comments_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comments:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comments:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9764_auto_count(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_9765_auto_count_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method auto_count:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part auto_count:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9768_noBlocks(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_9770_blocksOK(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_9772_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_9773_values_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method values:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part values:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9783__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9786 = alloc_Boolean(0);
// compiled identifier node returning bool9786 (depth = 5)
  int op_slot_right_9785 = gc_frame_newslot(bool9786);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  int op_slot_left_9785 = gc_frame_newslot(*var_other);
  params[0] = bool9786;
  partcv[0] = 1;
  Object opresult9788 = callmethod(*var_other, "==(1)", 1, partcv, params);
// compiled op node returning opresult9788 (depth = 4)
  Object if9784 = done;
  if (istrue(opresult9788)) {
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9789 = alloc_Boolean(0);
// compiled identifier node returning bool9789 (depth = 4)
    gc_frame_newslot(bool9789);
    if9784 = bool9789;
  } else {
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9792 = gc_frame_new();
// call case 4: self request
  Object call9793 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9792);
// compiled member node returning call9793 (depth = 6)
  int op_slot_right_9791 = gc_frame_newslot(call9793);
// starting to compile member node (depth = 6)
  int callframe9795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  Object call9796 = callmethodflags(*var_other, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9795);
// compiled member node returning call9796 (depth = 6)
  int op_slot_left_9791 = gc_frame_newslot(call9796);
  params[0] = call9793;
  partcv[0] = 1;
  Object opresult9797 = callmethod(call9796, "==(1)", 1, partcv, params);
// compiled op node returning opresult9797 (depth = 5)
  int op_slot_right_9790 = gc_frame_newslot(opresult9797);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9800 = gc_frame_new();
// call case 4: self request
  Object call9801 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9800);
// compiled member node returning call9801 (depth = 6)
  int op_slot_right_9799 = gc_frame_newslot(call9801);
// starting to compile member node (depth = 6)
  int callframe9803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  Object call9804 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9803);
// compiled member node returning call9804 (depth = 6)
  int op_slot_left_9799 = gc_frame_newslot(call9804);
  params[0] = call9801;
  partcv[0] = 1;
  Object opresult9805 = callmethod(call9804, "==(1)", 1, partcv, params);
// compiled op node returning opresult9805 (depth = 5)
  int op_slot_left_9790 = gc_frame_newslot(opresult9805);
  params[0] = opresult9797;
  partcv[0] = 1;
  Object opresult9806 = callmethod(opresult9805, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9806 (depth = 4)
    gc_frame_newslot(opresult9806);
    if9784 = opresult9806;
  }
// compiled if node returning if9784 (depth = 3)
  gc_frame_end(frame);
  return if9784;
}
Object meth_parser_9813_sym(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_9814_sym_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sym:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sym:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9816_lastToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_9817_lastToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9819_previousCommentToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_9820_previousCommentToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 116, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method previousCommentToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part previousCommentToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9822_statementToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 117, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_9823_statementToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 118, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9826_comment(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 119, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_9827_comment_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 120, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comment:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comment:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  if (module_parser) return module_parser;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(126, 126);
  module_parser = self;
  self->class->definitionModule = "parser";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("parser");
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(126, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
// definebindings:
  Object *var_io = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "io");
  Object *var_ast = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ast");
  Object *var_util = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "util");
  Object *var_errormessages = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "errormessages");
  Object *var_lastLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "statementIndent");
  Object *var_tokens = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tokens");
  Object *var_moduleObject = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "moduleObject");
  Object *var_comments = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "comments");
  Object *var_auto_count = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "blocksOK");
  Object *var_values = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "values");
  Object *var_sym = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "sym");
  Object *var_lastToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "statementToken");
  Object *var_comment = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "comment");
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "next"
  block_savedest(self);
  Object closure1 = createclosure(7, "next");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_tokens);
  addtoclosure(closure1, var_sym);
  addtoclosure(closure1, var_lastToken);
  addtoclosure(closure1, var_lastLine);
  addtoclosure(closure1, var_lastIndent);
  addtoclosure(closure1, var_util);
  addtoclosure(closure1, var_errormessages);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_parser_1_next = addmethod2pos(self, "next", &meth_parser_1_next, 1);
  int argcv_meth_parser_1_next[] = {0};
  meth_meth_parser_1_next->type = alloc_MethodType(1, argcv_meth_parser_1_next);
  meth_meth_parser_1_next->definitionModule = modulename;
  meth_meth_parser_1_next->definitionLine = 70;
// compiled method node returning  (depth = 1)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "indentHasIncreased"
  block_savedest(self);
  Object closure38 = createclosure(3, "indentHasIncreased");
  setclosureframe(closure38, stackframe);
  addtoclosure(closure38, var_lastIndent);
  addtoclosure(closure38, var_sym);
  addtoclosure(closure38, var_lastLine);
  struct UserObject *uo38 = (struct UserObject*)self;
  uo38->data[2] = (Object)closure38;
  Method *meth_meth_parser_38_indentHasIncreased = addmethod2pos(self, "indentHasIncreased", &meth_parser_38_indentHasIncreased, 2);
  int argcv_meth_parser_38_indentHasIncreased[] = {0};
  meth_meth_parser_38_indentHasIncreased->type = alloc_MethodType(1, argcv_meth_parser_38_indentHasIncreased);
  meth_meth_parser_38_indentHasIncreased->definitionModule = modulename;
  meth_meth_parser_38_indentHasIncreased->definitionLine = 88;
// compiled method node returning  (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "saveParsePosition"
  block_savedest(self);
  Object closure84 = createclosure(2, "saveParsePosition");
  setclosureframe(closure84, stackframe);
  addtoclosure(closure84, var_tokens);
  addtoclosure(closure84, var_values);
  struct UserObject *uo84 = (struct UserObject*)self;
  uo84->data[3] = (Object)closure84;
  Method *meth_meth_parser_84_saveParsePosition = addmethod2pos(self, "saveParsePosition", &meth_parser_84_saveParsePosition, 3);
  int argcv_meth_parser_84_saveParsePosition[] = {0};
  meth_meth_parser_84_saveParsePosition->type = alloc_MethodType(1, argcv_meth_parser_84_saveParsePosition);
  meth_meth_parser_84_saveParsePosition->definitionModule = modulename;
  meth_meth_parser_84_saveParsePosition->definitionLine = 102;
// compiled method node returning  (depth = 1)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "restoreParsePosition(_)"
  block_savedest(self);
  Object closure90 = createclosure(4, "restoreParsePosition(1)");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, var_tokens);
  addtoclosure(closure90, var_sym);
  addtoclosure(closure90, var_lastToken);
  addtoclosure(closure90, var_values);
  struct UserObject *uo90 = (struct UserObject*)self;
  uo90->data[4] = (Object)closure90;
  Method *meth_meth_parser_90_restoreParsePosition_40_1_41_ = addmethod2pos(self, "restoreParsePosition(1)", &meth_parser_90_restoreParsePosition_40_1_41_, 4);
  int argcv_meth_parser_90_restoreParsePosition_40_1_41_[] = {1};
  meth_meth_parser_90_restoreParsePosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_90_restoreParsePosition_40_1_41_);
  meth_meth_parser_90_restoreParsePosition_40_1_41_->definitionModule = modulename;
  meth_meth_parser_90_restoreParsePosition_40_1_41_->definitionLine = 107;
// compiled method node returning  (depth = 1)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextToken(_)"
  block_savedest(self);
  Object closure131 = createclosure(2, "findNextToken(1)");
  setclosureframe(closure131, stackframe);
  addtoclosure(closure131, var_sym);
  addtoclosure(closure131, var_lastToken);
  struct UserObject *uo131 = (struct UserObject*)self;
  uo131->data[5] = (Object)closure131;
  Method *meth_meth_parser_131_findNextToken_40_1_41_ = addmethod2pos(self, "findNextToken(1)", &meth_parser_131_findNextToken_40_1_41_, 5);
  int argcv_meth_parser_131_findNextToken_40_1_41_[] = {1};
  meth_meth_parser_131_findNextToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_131_findNextToken_40_1_41_);
  meth_meth_parser_131_findNextToken_40_1_41_->definitionModule = modulename;
  meth_meth_parser_131_findNextToken_40_1_41_->definitionLine = 118;
// compiled method node returning  (depth = 1)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextTokenIndentedAt(_)"
  block_savedest(self);
  Object closure178 = createclosure(1, "findNextTokenIndentedAt(1)");
  setclosureframe(closure178, stackframe);
  addtoclosure(closure178, var_sym);
  struct UserObject *uo178 = (struct UserObject*)self;
  uo178->data[6] = (Object)closure178;
  Method *meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_ = addmethod2pos(self, "findNextTokenIndentedAt(1)", &meth_parser_178_findNextTokenIndentedAt_40_1_41_, 6);
  int argcv_meth_parser_178_findNextTokenIndentedAt_40_1_41_[] = {1};
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_178_findNextTokenIndentedAt_40_1_41_);
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->definitionModule = modulename;
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->definitionLine = 136;
// compiled method node returning  (depth = 1)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextValidToken(_)"
  block_savedest(self);
  Object closure260 = createclosure(1, "findNextValidToken(1)");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_sym);
  struct UserObject *uo260 = (struct UserObject*)self;
  uo260->data[7] = (Object)closure260;
  Method *meth_meth_parser_260_findNextValidToken_40_1_41_ = addmethod2pos(self, "findNextValidToken(1)", &meth_parser_260_findNextValidToken_40_1_41_, 7);
  int argcv_meth_parser_260_findNextValidToken_40_1_41_[] = {1};
  meth_meth_parser_260_findNextValidToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_260_findNextValidToken_40_1_41_);
  meth_meth_parser_260_findNextValidToken_40_1_41_->definitionModule = modulename;
  meth_meth_parser_260_findNextValidToken_40_1_41_->definitionLine = 151;
// compiled method node returning  (depth = 1)
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findClosingBrace(_,_)"
  block_savedest(self);
  Object closure301 = createclosure(1, "findClosingBrace(2)");
  setclosureframe(closure301, stackframe);
  addtoclosure(closure301, var_sym);
  struct UserObject *uo301 = (struct UserObject*)self;
  uo301->data[8] = (Object)closure301;
  Method *meth_meth_parser_301_findClosingBrace_40_2_41_ = addmethod2pos(self, "findClosingBrace(2)", &meth_parser_301_findClosingBrace_40_2_41_, 8);
  int argcv_meth_parser_301_findClosingBrace_40_2_41_[] = {2};
  meth_meth_parser_301_findClosingBrace_40_2_41_->type = alloc_MethodType(1, argcv_meth_parser_301_findClosingBrace_40_2_41_);
  meth_meth_parser_301_findClosingBrace_40_2_41_->definitionModule = modulename;
  meth_meth_parser_301_findClosingBrace_40_2_41_->definitionLine = 176;
// compiled method node returning  (depth = 1)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)"
  block_savedest(self);
  Object closure453 = createclosure(1, "accept(1)");
  setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_sym);
  struct UserObject *uo453 = (struct UserObject*)self;
  uo453->data[9] = (Object)closure453;
  Method *meth_meth_parser_453_accept_40_1_41_ = addmethod2pos(self, "accept(1)", &meth_parser_453_accept_40_1_41_, 9);
  int argcv_meth_parser_453_accept_40_1_41_[] = {1};
  meth_meth_parser_453_accept_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_453_accept_40_1_41_);
  meth_meth_parser_453_accept_40_1_41_->definitionModule = modulename;
  meth_meth_parser_453_accept_40_1_41_->definitionLine = 214;
// compiled method node returning  (depth = 1)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword(_)"
  block_savedest(self);
  Object closure459 = createclosure(1, "acceptKeyword(1)");
  setclosureframe(closure459, stackframe);
  addtoclosure(closure459, var_sym);
  struct UserObject *uo459 = (struct UserObject*)self;
  uo459->data[10] = (Object)closure459;
  Method *meth_meth_parser_459_acceptKeyword_40_1_41_ = addmethod2pos(self, "acceptKeyword(1)", &meth_parser_459_acceptKeyword_40_1_41_, 10);
  int argcv_meth_parser_459_acceptKeyword_40_1_41_[] = {1};
  meth_meth_parser_459_acceptKeyword_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_459_acceptKeyword_40_1_41_);
  meth_meth_parser_459_acceptKeyword_40_1_41_->definitionModule = modulename;
  meth_meth_parser_459_acceptKeyword_40_1_41_->definitionLine = 220;
// compiled method node returning  (depth = 1)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptSameLine(_)"
  block_savedest(self);
  Object closure473 = createclosure(3, "acceptSameLine(1)");
  setclosureframe(closure473, stackframe);
  addtoclosure(closure473, var_lastIndent);
  addtoclosure(closure473, var_sym);
  addtoclosure(closure473, var_lastLine);
  struct UserObject *uo473 = (struct UserObject*)self;
  uo473->data[11] = (Object)closure473;
  Method *meth_meth_parser_473_acceptSameLine_40_1_41_ = addmethod2pos(self, "acceptSameLine(1)", &meth_parser_473_acceptSameLine_40_1_41_, 11);
  int argcv_meth_parser_473_acceptSameLine_40_1_41_[] = {1};
  meth_meth_parser_473_acceptSameLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_473_acceptSameLine_40_1_41_);
  meth_meth_parser_473_acceptSameLine_40_1_41_->definitionModule = modulename;
  meth_meth_parser_473_acceptSameLine_40_1_41_->definitionLine = 225;
// compiled method node returning  (depth = 1)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptWithoutSpaces(_)"
  block_savedest(self);
  Object closure495 = createclosure(3, "acceptWithoutSpaces(1)");
  setclosureframe(closure495, stackframe);
  addtoclosure(closure495, var_lastToken);
  addtoclosure(closure495, var_sym);
  addtoclosure(closure495, var_lastLine);
  struct UserObject *uo495 = (struct UserObject*)self;
  uo495->data[12] = (Object)closure495;
  Method *meth_meth_parser_495_acceptWithoutSpaces_40_1_41_ = addmethod2pos(self, "acceptWithoutSpaces(1)", &meth_parser_495_acceptWithoutSpaces_40_1_41_, 12);
  int argcv_meth_parser_495_acceptWithoutSpaces_40_1_41_[] = {1};
  meth_meth_parser_495_acceptWithoutSpaces_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_495_acceptWithoutSpaces_40_1_41_);
  meth_meth_parser_495_acceptWithoutSpaces_40_1_41_->definitionModule = modulename;
  meth_meth_parser_495_acceptWithoutSpaces_40_1_41_->definitionLine = 233;
// compiled method node returning  (depth = 1)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOf(_)"
  block_savedest(self);
  Object closure524 = createclosure(1, "accept(1)onLineOf(1)");
  setclosureframe(closure524, stackframe);
  addtoclosure(closure524, var_sym);
  struct UserObject *uo524 = (struct UserObject*)self;
  uo524->data[13] = (Object)closure524;
  Method *meth_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_ = addmethod2pos(self, "accept(1)onLineOf(1)", &meth_parser_524_accept_40_1_41_onLineOf_40_1_41_, 13);
  int argcv_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_[] = {1, 1};
  meth_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_);
  meth_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_524_accept_40_1_41_onLineOf_40_1_41_->definitionLine = 240;
// compiled method node returning  (depth = 1)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOfLastOr(_)"
  block_savedest(self);
  Object closure550 = createclosure(3, "accept(1)onLineOfLastOr(1)");
  setclosureframe(closure550, stackframe);
  addtoclosure(closure550, var_sym);
  addtoclosure(closure550, var_lastLine);
  addtoclosure(closure550, var_lastIndent);
  struct UserObject *uo550 = (struct UserObject*)self;
  uo550->data[14] = (Object)closure550;
  Method *meth_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_ = addmethod2pos(self, "accept(1)onLineOfLastOr(1)", &meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_, 14);
  int argcv_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_[] = {1, 1};
  meth_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_);
  meth_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_->definitionModule = modulename;
  meth_meth_parser_550_accept_40_1_41_onLineOfLastOr_40_1_41_->definitionLine = 247;
// compiled method node returning  (depth = 1)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptArgumentOnLineOf(_)"
  block_savedest(self);
  Object closure591 = createclosure(1, "acceptArgumentOnLineOf(1)");
  setclosureframe(closure591, stackframe);
  addtoclosure(closure591, var_sym);
  struct UserObject *uo591 = (struct UserObject*)self;
  uo591->data[15] = (Object)closure591;
  Method *meth_meth_parser_591_acceptArgumentOnLineOf_40_1_41_ = addmethod2pos(self, "acceptArgumentOnLineOf(1)", &meth_parser_591_acceptArgumentOnLineOf_40_1_41_, 15);
  int argcv_meth_parser_591_acceptArgumentOnLineOf_40_1_41_[] = {1};
  meth_meth_parser_591_acceptArgumentOnLineOf_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_591_acceptArgumentOnLineOf_40_1_41_);
  meth_meth_parser_591_acceptArgumentOnLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_591_acceptArgumentOnLineOf_40_1_41_->definitionLine = 257;
// compiled method node returning  (depth = 1)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnSameLine"
  block_savedest(self);
  Object closure632 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure632, stackframe);
  addtoclosure(closure632, var_lastIndent);
  addtoclosure(closure632, var_sym);
  addtoclosure(closure632, var_lastLine);
  struct UserObject *uo632 = (struct UserObject*)self;
  uo632->data[16] = (Object)closure632;
  Method *meth_meth_parser_632_tokenOnSameLine = addmethod2pos(self, "tokenOnSameLine", &meth_parser_632_tokenOnSameLine, 16);
  int argcv_meth_parser_632_tokenOnSameLine[] = {0};
  meth_meth_parser_632_tokenOnSameLine->type = alloc_MethodType(1, argcv_meth_parser_632_tokenOnSameLine);
  meth_meth_parser_632_tokenOnSameLine->definitionModule = modulename;
  meth_meth_parser_632_tokenOnSameLine->definitionLine = 268;
// compiled method node returning  (depth = 1)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnLineOfLastOr(_)"
  block_savedest(self);
  Object closure646 = createclosure(3, "tokenOnLineOfLastOr(1)");
  setclosureframe(closure646, stackframe);
  addtoclosure(closure646, var_sym);
  addtoclosure(closure646, var_lastLine);
  addtoclosure(closure646, var_lastIndent);
  struct UserObject *uo646 = (struct UserObject*)self;
  uo646->data[17] = (Object)closure646;
  Method *meth_meth_parser_646_tokenOnLineOfLastOr_40_1_41_ = addmethod2pos(self, "tokenOnLineOfLastOr(1)", &meth_parser_646_tokenOnLineOfLastOr_40_1_41_, 17);
  int argcv_meth_parser_646_tokenOnLineOfLastOr_40_1_41_[] = {1};
  meth_meth_parser_646_tokenOnLineOfLastOr_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_646_tokenOnLineOfLastOr_40_1_41_);
  meth_meth_parser_646_tokenOnLineOfLastOr_40_1_41_->definitionModule = modulename;
  meth_meth_parser_646_tokenOnLineOfLastOr_40_1_41_->definitionLine = 272;
// compiled method node returning  (depth = 1)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didConsume(_)"
  block_savedest(self);
  Object closure680 = createclosure(1, "didConsume(1)");
  setclosureframe(closure680, stackframe);
  addtoclosure(closure680, var_tokens);
  struct UserObject *uo680 = (struct UserObject*)self;
  uo680->data[18] = (Object)closure680;
  Method *meth_meth_parser_680_didConsume_40_1_41_ = addmethod2pos(self, "didConsume(1)", &meth_parser_680_didConsume_40_1_41_, 18);
  int argcv_meth_parser_680_didConsume_40_1_41_[] = {1};
  meth_meth_parser_680_didConsume_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_680_didConsume_40_1_41_);
  meth_meth_parser_680_didConsume_40_1_41_->definitionModule = modulename;
  meth_meth_parser_680_didConsume_40_1_41_->definitionLine = 281;
// compiled method node returning  (depth = 1)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didNotConsume(_)"
  block_savedest(self);
  Object closure690 = createclosure(1, "didNotConsume(1)");
  setclosureframe(closure690, stackframe);
  addtoclosure(closure690, var_tokens);
  struct UserObject *uo690 = (struct UserObject*)self;
  uo690->data[19] = (Object)closure690;
  Method *meth_meth_parser_690_didNotConsume_40_1_41_ = addmethod2pos(self, "didNotConsume(1)", &meth_parser_690_didNotConsume_40_1_41_, 19);
  int argcv_meth_parser_690_didNotConsume_40_1_41_[] = {1};
  meth_meth_parser_690_didNotConsume_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_690_didNotConsume_40_1_41_);
  meth_meth_parser_690_didNotConsume_40_1_41_->definitionModule = modulename;
  meth_meth_parser_690_didNotConsume_40_1_41_->definitionLine = 287;
// compiled method node returning  (depth = 1)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushnum"
  block_savedest(self);
  Object closure700 = createclosure(3, "pushnum");
  setclosureframe(closure700, stackframe);
  addtoclosure(closure700, var_sym);
  addtoclosure(closure700, var_ast);
  addtoclosure(closure700, var_values);
  struct UserObject *uo700 = (struct UserObject*)self;
  uo700->data[20] = (Object)closure700;
  Method *meth_meth_parser_700_pushnum = addmethod2pos(self, "pushnum", &meth_parser_700_pushnum, 20);
  int argcv_meth_parser_700_pushnum[] = {0};
  meth_meth_parser_700_pushnum->type = alloc_MethodType(1, argcv_meth_parser_700_pushnum);
  meth_meth_parser_700_pushnum->definitionModule = modulename;
  meth_meth_parser_700_pushnum->definitionLine = 293;
// compiled method node returning  (depth = 1)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushstring"
  block_savedest(self);
  Object closure711 = createclosure(3, "pushstring");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_sym);
  addtoclosure(closure711, var_ast);
  addtoclosure(closure711, var_values);
  struct UserObject *uo711 = (struct UserObject*)self;
  uo711->data[21] = (Object)closure711;
  Method *meth_meth_parser_711_pushstring = addmethod2pos(self, "pushstring", &meth_parser_711_pushstring, 21);
  int argcv_meth_parser_711_pushstring[] = {0};
  meth_meth_parser_711_pushstring->type = alloc_MethodType(1, argcv_meth_parser_711_pushstring);
  meth_meth_parser_711_pushstring->definitionModule = modulename;
  meth_meth_parser_711_pushstring->definitionLine = 300;
// compiled method node returning  (depth = 1)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushidentifier"
  block_savedest(self);
  Object closure730 = createclosure(4, "pushidentifier");
  setclosureframe(closure730, stackframe);
  addtoclosure(closure730, var_sym);
  addtoclosure(closure730, var_util);
  addtoclosure(closure730, var_ast);
  addtoclosure(closure730, var_values);
  struct UserObject *uo730 = (struct UserObject*)self;
  uo730->data[22] = (Object)closure730;
  Method *meth_meth_parser_730_pushidentifier = addmethod2pos(self, "pushidentifier", &meth_parser_730_pushidentifier, 22);
  int argcv_meth_parser_730_pushidentifier[] = {0};
  meth_meth_parser_730_pushidentifier->type = alloc_MethodType(1, argcv_meth_parser_730_pushidentifier);
  meth_meth_parser_730_pushidentifier->definitionModule = modulename;
  meth_meth_parser_730_pushidentifier->definitionLine = 310;
// compiled method node returning  (depth = 1)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkAnnotation(_)"
  block_savedest(self);
  Object closure760 = createclosure(2, "checkAnnotation(1)");
  setclosureframe(closure760, stackframe);
  addtoclosure(closure760, var_sym);
  addtoclosure(closure760, var_errormessages);
  struct UserObject *uo760 = (struct UserObject*)self;
  uo760->data[23] = (Object)closure760;
  Method *meth_meth_parser_760_checkAnnotation_40_1_41_ = addmethod2pos(self, "checkAnnotation(1)", &meth_parser_760_checkAnnotation_40_1_41_, 23);
  int argcv_meth_parser_760_checkAnnotation_40_1_41_[] = {1};
  meth_meth_parser_760_checkAnnotation_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_760_checkAnnotation_40_1_41_);
  meth_meth_parser_760_checkAnnotation_40_1_41_->definitionModule = modulename;
  meth_meth_parser_760_checkAnnotation_40_1_41_->definitionLine = 321;
// compiled method node returning  (depth = 1)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doannotation"
  block_savedest(self);
  Object closure839 = createclosure(2, "doannotation");
  setclosureframe(closure839, stackframe);
  addtoclosure(closure839, var_noBlocks);
  addtoclosure(closure839, var_values);
  struct UserObject *uo839 = (struct UserObject*)self;
  uo839->data[24] = (Object)closure839;
  Method *meth_meth_parser_839_doannotation = addmethod2pos(self, "doannotation", &meth_parser_839_doannotation, 24);
  int argcv_meth_parser_839_doannotation[] = {0};
  meth_meth_parser_839_doannotation->type = alloc_MethodType(1, argcv_meth_parser_839_doannotation);
  meth_meth_parser_839_doannotation->definitionModule = modulename;
  meth_meth_parser_839_doannotation->definitionLine = 340;
// compiled method node returning  (depth = 1)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorMissingAnnotation"
  block_savedest(self);
  Object closure895 = createclosure(3, "errorMissingAnnotation");
  setclosureframe(closure895, stackframe);
  addtoclosure(closure895, var_errormessages);
  addtoclosure(closure895, var_sym);
  addtoclosure(closure895, var_lastToken);
  struct UserObject *uo895 = (struct UserObject*)self;
  uo895->data[25] = (Object)closure895;
  Method *meth_meth_parser_895_errorMissingAnnotation = addmethod2pos(self, "errorMissingAnnotation", &meth_parser_895_errorMissingAnnotation, 25);
  int argcv_meth_parser_895_errorMissingAnnotation[] = {0};
  meth_meth_parser_895_errorMissingAnnotation->type = alloc_MethodType(1, argcv_meth_parser_895_errorMissingAnnotation);
  meth_meth_parser_895_errorMissingAnnotation->definitionModule = modulename;
  meth_meth_parser_895_errorMissingAnnotation->definitionLine = 360;
// compiled method node returning  (depth = 1)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeterm"
  block_savedest(self);
  Object closure943 = createclosure(1, "dotypeterm");
  setclosureframe(closure943, stackframe);
  addtoclosure(closure943, var_noBlocks);
  struct UserObject *uo943 = (struct UserObject*)self;
  uo943->data[26] = (Object)closure943;
  Method *meth_meth_parser_943_dotypeterm = addmethod2pos(self, "dotypeterm", &meth_parser_943_dotypeterm, 26);
  int argcv_meth_parser_943_dotypeterm[] = {0};
  meth_meth_parser_943_dotypeterm->type = alloc_MethodType(1, argcv_meth_parser_943_dotypeterm);
  meth_meth_parser_943_dotypeterm->definitionModule = modulename;
  meth_meth_parser_943_dotypeterm->definitionLine = 378;
// compiled method node returning  (depth = 1)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpression"
  block_savedest(self);
  Object closure960 = createclosure(6, "typeexpression");
  setclosureframe(closure960, stackframe);
  addtoclosure(closure960, var_values);
  addtoclosure(closure960, var_statementToken);
  addtoclosure(closure960, var_sym);
  addtoclosure(closure960, var_errormessages);
  addtoclosure(closure960, var_lastToken);
  addtoclosure(closure960, var_noBlocks);
  struct UserObject *uo960 = (struct UserObject*)self;
  uo960->data[27] = (Object)closure960;
  Method *meth_meth_parser_960_typeexpression = addmethod2pos(self, "typeexpression", &meth_parser_960_typeexpression, 27);
  int argcv_meth_parser_960_typeexpression[] = {0};
  meth_meth_parser_960_typeexpression->type = alloc_MethodType(1, argcv_meth_parser_960_typeexpression);
  meth_meth_parser_960_typeexpression->definitionModule = modulename;
  meth_meth_parser_960_typeexpression->definitionLine = 390;
// compiled method node returning  (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "newIf(_,_,_)"
  block_savedest(self);
  Object closure1047 = createclosure(1, "newIf(3)");
  setclosureframe(closure1047, stackframe);
  addtoclosure(closure1047, var_ast);
  struct UserObject *uo1047 = (struct UserObject*)self;
  uo1047->data[28] = (Object)closure1047;
  Method *meth_meth_parser_1047_newIf_40_3_41_ = addmethod2pos(self, "newIf(3)", &meth_parser_1047_newIf_40_3_41_, 28);
  int argcv_meth_parser_1047_newIf_40_3_41_[] = {3};
  meth_meth_parser_1047_newIf_40_3_41_->type = alloc_MethodType(1, argcv_meth_parser_1047_newIf_40_3_41_);
  meth_meth_parser_1047_newIf_40_3_41_->definitionModule = modulename;
  meth_meth_parser_1047_newIf_40_3_41_->definitionLine = 429;
// compiled method node returning  (depth = 1)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportSyntaxError(_)before(_)"
  block_savedest(self);
  Object closure1064 = createclosure(3, "reportSyntaxError(1)before(1)");
  setclosureframe(closure1064, stackframe);
  addtoclosure(closure1064, var_errormessages);
  addtoclosure(closure1064, var_sym);
  addtoclosure(closure1064, var_lastToken);
  struct UserObject *uo1064 = (struct UserObject*)self;
  uo1064->data[29] = (Object)closure1064;
  Method *meth_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_ = addmethod2pos(self, "reportSyntaxError(1)before(1)", &meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_, 29);
  int argcv_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_[] = {1, 1};
  meth_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_);
  meth_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1064_reportSyntaxError_40_1_41_before_40_1_41_->definitionLine = 435;
// compiled method node returning  (depth = 1)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportMissingArrow"
  block_savedest(self);
  Object closure1107 = createclosure(3, "reportMissingArrow");
  setclosureframe(closure1107, stackframe);
  addtoclosure(closure1107, var_errormessages);
  addtoclosure(closure1107, var_sym);
  addtoclosure(closure1107, var_lastToken);
  struct UserObject *uo1107 = (struct UserObject*)self;
  uo1107->data[30] = (Object)closure1107;
  Method *meth_meth_parser_1107_reportMissingArrow = addmethod2pos(self, "reportMissingArrow", &meth_parser_1107_reportMissingArrow, 30);
  int argcv_meth_parser_1107_reportMissingArrow[] = {0};
  meth_meth_parser_1107_reportMissingArrow->type = alloc_MethodType(1, argcv_meth_parser_1107_reportMissingArrow);
  meth_meth_parser_1107_reportMissingArrow->definitionModule = modulename;
  meth_meth_parser_1107_reportMissingArrow->definitionLine = 453;
// compiled method node returning  (depth = 1)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportBadRhs"
  block_savedest(self);
  Object closure1141 = createclosure(3, "reportBadRhs");
  setclosureframe(closure1141, stackframe);
  addtoclosure(closure1141, var_errormessages);
  addtoclosure(closure1141, var_sym);
  addtoclosure(closure1141, var_lastToken);
  struct UserObject *uo1141 = (struct UserObject*)self;
  uo1141->data[31] = (Object)closure1141;
  Method *meth_meth_parser_1141_reportBadRhs = addmethod2pos(self, "reportBadRhs", &meth_parser_1141_reportBadRhs, 31);
  int argcv_meth_parser_1141_reportBadRhs[] = {0};
  meth_meth_parser_1141_reportBadRhs->type = alloc_MethodType(1, argcv_meth_parser_1141_reportBadRhs);
  meth_meth_parser_1141_reportBadRhs->definitionModule = modulename;
  meth_meth_parser_1141_reportBadRhs->definitionLine = 464;
// compiled method node returning  (depth = 1)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "block"
  block_savedest(self);
  Object closure1187 = createclosure(5, "block");
  setclosureframe(closure1187, stackframe);
  addtoclosure(closure1187, var_sym);
  addtoclosure(closure1187, var_minIndentLevel);
  addtoclosure(closure1187, var_statementIndent);
  addtoclosure(closure1187, var_statementToken);
  addtoclosure(closure1187, var_values);
  struct UserObject *uo1187 = (struct UserObject*)self;
  uo1187->data[32] = (Object)closure1187;
  Method *meth_meth_parser_1187_block = addmethod2pos(self, "block", &meth_parser_1187_block, 32);
  int argcv_meth_parser_1187_block[] = {0};
  meth_meth_parser_1187_block->type = alloc_MethodType(1, argcv_meth_parser_1187_block);
  meth_meth_parser_1187_block->definitionModule = modulename;
  meth_meth_parser_1187_block->definitionLine = 483;
// compiled method node returning  (depth = 1)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockParameters"
  struct UserObject *uo1216 = (struct UserObject*)self;
  uo1216->data[33] = emptyclosure;
  Method *meth_meth_parser_1216_blockParameters = addmethod2pos(self, "blockParameters", &meth_parser_1216_blockParameters, 33);
  int argcv_meth_parser_1216_blockParameters[] = {0};
  meth_meth_parser_1216_blockParameters->type = alloc_MethodType(1, argcv_meth_parser_1216_blockParameters);
  meth_meth_parser_1216_blockParameters->definitionModule = modulename;
  meth_meth_parser_1216_blockParameters->definitionLine = 515;
// compiled method node returning  (depth = 1)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockParameter(_)"
  block_savedest(self);
  Object closure1242 = createclosure(4, "blockParameter(1)");
  setclosureframe(closure1242, stackframe);
  addtoclosure(closure1242, var_sym);
  addtoclosure(closure1242, var_blocksOK);
  addtoclosure(closure1242, var_values);
  addtoclosure(closure1242, var_ast);
  struct UserObject *uo1242 = (struct UserObject*)self;
  uo1242->data[34] = (Object)closure1242;
  Method *meth_meth_parser_1242_blockParameter_40_1_41_ = addmethod2pos(self, "blockParameter(1)", &meth_parser_1242_blockParameter_40_1_41_, 34);
  int argcv_meth_parser_1242_blockParameter_40_1_41_[] = {1};
  meth_meth_parser_1242_blockParameter_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1242_blockParameter_40_1_41_);
  meth_meth_parser_1242_blockParameter_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1242_blockParameter_40_1_41_->definitionLine = 533;
// compiled method node returning  (depth = 1)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockBody(_)beginningWith(_)"
  block_savedest(self);
  Object closure1341 = createclosure(6, "blockBody(1)beginningWith(1)");
  setclosureframe(closure1341, stackframe);
  addtoclosure(closure1341, var_values);
  addtoclosure(closure1341, var_lastToken);
  addtoclosure(closure1341, var_sym);
  addtoclosure(closure1341, var_indentFreePass);
  addtoclosure(closure1341, var_errormessages);
  addtoclosure(closure1341, var_ast);
  struct UserObject *uo1341 = (struct UserObject*)self;
  uo1341->data[35] = (Object)closure1341;
  Method *meth_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_ = addmethod2pos(self, "blockBody(1)beginningWith(1)", &meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_, 35);
  int argcv_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_[] = {1, 1};
  meth_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_);
  meth_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1341_blockBody_40_1_41_beginningWith_40_1_41_->definitionLine = 574;
// compiled method node returning  (depth = 1)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doif"
  block_savedest(self);
  Object closure1398 = createclosure(9, "doif");
  setclosureframe(closure1398, stackframe);
  addtoclosure(closure1398, var_sym);
  addtoclosure(closure1398, var_errormessages);
  addtoclosure(closure1398, var_blocksOK);
  addtoclosure(closure1398, var_lastToken);
  addtoclosure(closure1398, var_values);
  addtoclosure(closure1398, var_minIndentLevel);
  addtoclosure(closure1398, var_statementIndent);
  addtoclosure(closure1398, var_statementToken);
  addtoclosure(closure1398, var_util);
  struct UserObject *uo1398 = (struct UserObject*)self;
  uo1398->data[36] = (Object)closure1398;
  Method *meth_meth_parser_1398_doif = addmethod2pos(self, "doif", &meth_parser_1398_doif, 36);
  int argcv_meth_parser_1398_doif[] = {0};
  meth_meth_parser_1398_doif->type = alloc_MethodType(1, argcv_meth_parser_1398_doif);
  meth_meth_parser_1398_doif->definitionModule = modulename;
  meth_meth_parser_1398_doif->definitionLine = 601;
// compiled method node returning  (depth = 1)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "identifier"
  block_savedest(self);
  Object closure2792 = createclosure(1, "identifier");
  setclosureframe(closure2792, stackframe);
  addtoclosure(closure2792, var_sym);
  struct UserObject *uo2792 = (struct UserObject*)self;
  uo2792->data[37] = (Object)closure2792;
  Method *meth_meth_parser_2792_identifier = addmethod2pos(self, "identifier", &meth_parser_2792_identifier, 37);
  int argcv_meth_parser_2792_identifier[] = {0};
  meth_meth_parser_2792_identifier->type = alloc_MethodType(1, argcv_meth_parser_2792_identifier);
  meth_meth_parser_2792_identifier->definitionModule = modulename;
  meth_meth_parser_2792_identifier->definitionLine = 1005;
// compiled method node returning  (depth = 1)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "prefixop"
  block_savedest(self);
  Object closure2808 = createclosure(7, "prefixop");
  setclosureframe(closure2808, stackframe);
  addtoclosure(closure2808, var_minIndentLevel);
  addtoclosure(closure2808, var_sym);
  addtoclosure(closure2808, var_blocksOK);
  addtoclosure(closure2808, var_errormessages);
  addtoclosure(closure2808, var_lastToken);
  addtoclosure(closure2808, var_values);
  addtoclosure(closure2808, var_ast);
  struct UserObject *uo2808 = (struct UserObject*)self;
  uo2808->data[38] = (Object)closure2808;
  Method *meth_meth_parser_2808_prefixop = addmethod2pos(self, "prefixop", &meth_parser_2808_prefixop, 38);
  int argcv_meth_parser_2808_prefixop[] = {0};
  meth_meth_parser_2808_prefixop->type = alloc_MethodType(1, argcv_meth_parser_2808_prefixop);
  meth_meth_parser_2808_prefixop->definitionModule = modulename;
  meth_meth_parser_2808_prefixop->definitionLine = 1015;
// compiled method node returning  (depth = 1)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "generic"
  block_savedest(self);
  Object closure2986 = createclosure(5, "generic");
  setclosureframe(closure2986, stackframe);
  addtoclosure(closure2986, var_values);
  addtoclosure(closure2986, var_sym);
  addtoclosure(closure2986, var_errormessages);
  addtoclosure(closure2986, var_lastToken);
  addtoclosure(closure2986, var_ast);
  struct UserObject *uo2986 = (struct UserObject*)self;
  uo2986->data[39] = (Object)closure2986;
  Method *meth_meth_parser_2986_generic = addmethod2pos(self, "generic", &meth_parser_2986_generic, 39);
  int argcv_meth_parser_2986_generic[] = {0};
  meth_meth_parser_2986_generic->type = alloc_MethodType(1, argcv_meth_parser_2986_generic);
  meth_meth_parser_2986_generic->definitionModule = modulename;
  meth_meth_parser_2986_generic->definitionLine = 1072;
// compiled method node returning  (depth = 1)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "trycatch"
  block_savedest(self);
  Object closure3169 = createclosure(10, "trycatch");
  setclosureframe(closure3169, stackframe);
  addtoclosure(closure3169, var_sym);
  addtoclosure(closure3169, var_done);
  addtoclosure(closure3169, var_minIndentLevel);
  addtoclosure(closure3169, var_errormessages);
  addtoclosure(closure3169, var_lastToken);
  addtoclosure(closure3169, var_blocksOK);
  addtoclosure(closure3169, var_values);
  addtoclosure(closure3169, var_tokens);
  addtoclosure(closure3169, var_util);
  addtoclosure(closure3169, var_ast);
  struct UserObject *uo3169 = (struct UserObject*)self;
  uo3169->data[40] = (Object)closure3169;
  Method *meth_meth_parser_3169_trycatch = addmethod2pos(self, "trycatch", &meth_parser_3169_trycatch, 40);
  int argcv_meth_parser_3169_trycatch[] = {0};
  meth_meth_parser_3169_trycatch->type = alloc_MethodType(1, argcv_meth_parser_3169_trycatch);
  meth_meth_parser_3169_trycatch->definitionModule = modulename;
  meth_meth_parser_3169_trycatch->definitionLine = 1132;
// compiled method node returning  (depth = 1)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "matchcase"
  block_savedest(self);
  Object closure3769 = createclosure(9, "matchcase");
  setclosureframe(closure3769, stackframe);
  addtoclosure(closure3769, var_sym);
  addtoclosure(closure3769, var_minIndentLevel);
  addtoclosure(closure3769, var_errormessages);
  addtoclosure(closure3769, var_blocksOK);
  addtoclosure(closure3769, var_lastToken);
  addtoclosure(closure3769, var_values);
  addtoclosure(closure3769, var_tokens);
  addtoclosure(closure3769, var_util);
  addtoclosure(closure3769, var_ast);
  struct UserObject *uo3769 = (struct UserObject*)self;
  uo3769->data[41] = (Object)closure3769;
  Method *meth_meth_parser_3769_matchcase = addmethod2pos(self, "matchcase", &meth_parser_3769_matchcase, 41);
  int argcv_meth_parser_3769_matchcase[] = {0};
  meth_meth_parser_3769_matchcase->type = alloc_MethodType(1, argcv_meth_parser_3769_matchcase);
  meth_meth_parser_3769_matchcase->definitionModule = modulename;
  meth_meth_parser_3769_matchcase->definitionLine = 1304;
// compiled method node returning  (depth = 1)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "term"
  block_savedest(self);
  Object closure4139 = createclosure(2, "term");
  setclosureframe(closure4139, stackframe);
  addtoclosure(closure4139, var_sym);
  addtoclosure(closure4139, var_util);
  struct UserObject *uo4139 = (struct UserObject*)self;
  uo4139->data[42] = (Object)closure4139;
  Method *meth_meth_parser_4139_term = addmethod2pos(self, "term", &meth_parser_4139_term, 42);
  int argcv_meth_parser_4139_term[] = {0};
  meth_meth_parser_4139_term->type = alloc_MethodType(1, argcv_meth_parser_4139_term);
  meth_meth_parser_4139_term->definitionModule = modulename;
  meth_meth_parser_4139_term->definitionLine = 1408;
// compiled method node returning  (depth = 1)
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expression(_)"
  block_savedest(self);
  Object closure4224 = createclosure(6, "expression(1)");
  setclosureframe(closure4224, stackframe);
  addtoclosure(closure4224, var_values);
  addtoclosure(closure4224, var_sym);
  addtoclosure(closure4224, var_util);
  addtoclosure(closure4224, var_statementToken);
  addtoclosure(closure4224, var_errormessages);
  addtoclosure(closure4224, var_lastToken);
  struct UserObject *uo4224 = (struct UserObject*)self;
  uo4224->data[43] = (Object)closure4224;
  Method *meth_meth_parser_4224_expression_40_1_41_ = addmethod2pos(self, "expression(1)", &meth_parser_4224_expression_40_1_41_, 43);
  int argcv_meth_parser_4224_expression_40_1_41_[] = {1};
  meth_meth_parser_4224_expression_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4224_expression_40_1_41_);
  meth_meth_parser_4224_expression_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4224_expression_40_1_41_->definitionLine = 1438;
// compiled method node returning  (depth = 1)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "oprec(_)"
  struct UserObject *uo4330 = (struct UserObject*)self;
  uo4330->data[44] = emptyclosure;
  Method *meth_meth_parser_4330_oprec_40_1_41_ = addmethod2pos(self, "oprec(1)", &meth_parser_4330_oprec_40_1_41_, 44);
  int argcv_meth_parser_4330_oprec_40_1_41_[] = {1};
  meth_meth_parser_4330_oprec_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4330_oprec_40_1_41_);
  meth_meth_parser_4330_oprec_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4330_oprec_40_1_41_->definitionLine = 1481;
// compiled method node returning  (depth = 1)
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "toprec(_)"
  struct UserObject *uo4344 = (struct UserObject*)self;
  uo4344->data[45] = emptyclosure;
  Method *meth_meth_parser_4344_toprec_40_1_41_ = addmethod2pos(self, "toprec(1)", &meth_parser_4344_toprec_40_1_41_, 45);
  int argcv_meth_parser_4344_toprec_40_1_41_[] = {1};
  meth_meth_parser_4344_toprec_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4344_toprec_40_1_41_);
  meth_meth_parser_4344_toprec_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4344_toprec_40_1_41_->definitionLine = 1491;
// compiled method node returning  (depth = 1)
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpressionrest"
  block_savedest(self);
  Object closure4357 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure4357, stackframe);
  addtoclosure(closure4357, var_noBlocks);
  struct UserObject *uo4357 = (struct UserObject*)self;
  uo4357->data[46] = (Object)closure4357;
  Method *meth_meth_parser_4357_typeexpressionrest = addmethod2pos(self, "typeexpressionrest", &meth_parser_4357_typeexpressionrest, 46);
  int argcv_meth_parser_4357_typeexpressionrest[] = {0};
  meth_meth_parser_4357_typeexpressionrest->type = alloc_MethodType(1, argcv_meth_parser_4357_typeexpressionrest);
  meth_meth_parser_4357_typeexpressionrest->definitionModule = modulename;
  meth_meth_parser_4357_typeexpressionrest->definitionLine = 1500;
// compiled method node returning  (depth = 1)
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "valueexpressionrest"
  block_savedest(self);
  Object closure4370 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure4370, stackframe);
  addtoclosure(closure4370, var_blocksOK);
  struct UserObject *uo4370 = (struct UserObject*)self;
  uo4370->data[47] = (Object)closure4370;
  Method *meth_meth_parser_4370_valueexpressionrest = addmethod2pos(self, "valueexpressionrest", &meth_parser_4370_valueexpressionrest, 47);
  int argcv_meth_parser_4370_valueexpressionrest[] = {0};
  meth_meth_parser_4370_valueexpressionrest->type = alloc_MethodType(1, argcv_meth_parser_4370_valueexpressionrest);
  meth_meth_parser_4370_valueexpressionrest->definitionModule = modulename;
  meth_meth_parser_4370_valueexpressionrest->definitionLine = 1506;
// compiled method node returning  (depth = 1)
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expressionrest(_)recursingWith(_)blocks(_)"
  block_savedest(self);
  Object closure4383 = createclosure(8, "expressionrest(1)recursingWith(1)blocks(1)");
  setclosureframe(closure4383, stackframe);
  addtoclosure(closure4383, var_minIndentLevel);
  addtoclosure(closure4383, var_values);
  addtoclosure(closure4383, var_sym);
  addtoclosure(closure4383, var_statementToken);
  addtoclosure(closure4383, var_errormessages);
  addtoclosure(closure4383, var_lastToken);
  addtoclosure(closure4383, var_util);
  addtoclosure(closure4383, var_ast);
  struct UserObject *uo4383 = (struct UserObject*)self;
  uo4383->data[48] = (Object)closure4383;
  Method *meth_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_ = addmethod2pos(self, "expressionrest(1)recursingWith(1)blocks(1)", &meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_, 48);
  int argcv_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_);
  meth_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4383_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->definitionLine = 1512;
// compiled method node returning  (depth = 1)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotrest(_)"
  block_savedest(self);
  Object closure4905 = createclosure(7, "dotrest(1)");
  setclosureframe(closure4905, stackframe);
  addtoclosure(closure4905, var_minIndentLevel);
  addtoclosure(closure4905, var_sym);
  addtoclosure(closure4905, var_util);
  addtoclosure(closure4905, var_values);
  addtoclosure(closure4905, var_ast);
  addtoclosure(closure4905, var_errormessages);
  addtoclosure(closure4905, var_lastToken);
  struct UserObject *uo4905 = (struct UserObject*)self;
  uo4905->data[49] = (Object)closure4905;
  Method *meth_meth_parser_4905_dotrest_40_1_41_ = addmethod2pos(self, "dotrest(1)", &meth_parser_4905_dotrest_40_1_41_, 49);
  int argcv_meth_parser_4905_dotrest_40_1_41_[] = {1};
  meth_meth_parser_4905_dotrest_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4905_dotrest_40_1_41_);
  meth_meth_parser_4905_dotrest_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4905_dotrest_40_1_41_->definitionLine = 1660;
// compiled method node returning  (depth = 1)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callrest(_)"
  block_savedest(self);
  Object closure5014 = createclosure(7, "callrest(1)");
  setclosureframe(closure5014, stackframe);
  addtoclosure(closure5014, var_values);
  addtoclosure(closure5014, var_done);
  addtoclosure(closure5014, var_ast);
  addtoclosure(closure5014, var_lastToken);
  addtoclosure(closure5014, var_statementToken);
  addtoclosure(closure5014, var_sym);
  addtoclosure(closure5014, var_errormessages);
  struct UserObject *uo5014 = (struct UserObject*)self;
  uo5014->data[50] = (Object)closure5014;
  Method *meth_meth_parser_5014_callrest_40_1_41_ = addmethod2pos(self, "callrest(1)", &meth_parser_5014_callrest_40_1_41_, 50);
  int argcv_meth_parser_5014_callrest_40_1_41_[] = {1};
  meth_meth_parser_5014_callrest_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5014_callrest_40_1_41_);
  meth_meth_parser_5014_callrest_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5014_callrest_40_1_41_->definitionLine = 1701;
// compiled method node returning  (depth = 1)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseArgumentsFor(_)into(_)acceptBlocks(_)"
  block_savedest(self);
  Object closure5164 = createclosure(4, "parseArgumentsFor(1)into(1)acceptBlocks(1)");
  setclosureframe(closure5164, stackframe);
  addtoclosure(closure5164, var_lastToken);
  addtoclosure(closure5164, var_sym);
  addtoclosure(closure5164, var_statementToken);
  addtoclosure(closure5164, var_values);
  struct UserObject *uo5164 = (struct UserObject*)self;
  uo5164->data[51] = (Object)closure5164;
  Method *meth_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_ = addmethod2pos(self, "parseArgumentsFor(1)into(1)acceptBlocks(1)", &meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_, 51);
  int argcv_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_);
  meth_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5164_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->definitionLine = 1781;
// compiled method node returning  (depth = 1)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parenthesizedArgs(_)startingWith(_)"
  block_savedest(self);
  Object closure5200 = createclosure(6, "parenthesizedArgs(1)startingWith(1)");
  setclosureframe(closure5200, stackframe);
  addtoclosure(closure5200, var_blocksOK);
  addtoclosure(closure5200, var_values);
  addtoclosure(closure5200, var_errormessages);
  addtoclosure(closure5200, var_sym);
  addtoclosure(closure5200, var_lastToken);
  addtoclosure(closure5200, var_ast);
  struct UserObject *uo5200 = (struct UserObject*)self;
  uo5200->data[52] = (Object)closure5200;
  Method *meth_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_ = addmethod2pos(self, "parenthesizedArgs(1)startingWith(1)", &meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_, 52);
  int argcv_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_);
  meth_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5200_parenthesizedArgs_40_1_41_startingWith_40_1_41_->definitionLine = 1805;
// compiled method node returning  (depth = 1)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArgs"
  block_savedest(self);
  Object closure5346 = createclosure(4, "typeArgs");
  setclosureframe(closure5346, stackframe);
  addtoclosure(closure5346, var_sym);
  addtoclosure(closure5346, var_values);
  addtoclosure(closure5346, var_errormessages);
  addtoclosure(closure5346, var_lastToken);
  struct UserObject *uo5346 = (struct UserObject*)self;
  uo5346->data[53] = (Object)closure5346;
  Method *meth_meth_parser_5346_typeArgs = addmethod2pos(self, "typeArgs", &meth_parser_5346_typeArgs, 53);
  int argcv_meth_parser_5346_typeArgs[] = {0};
  meth_meth_parser_5346_typeArgs->type = alloc_MethodType(1, argcv_meth_parser_5346_typeArgs);
  meth_meth_parser_5346_typeArgs->definitionModule = modulename;
  meth_meth_parser_5346_typeArgs->definitionLine = 1847;
// compiled method node returning  (depth = 1)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArg"
  block_savedest(self);
  Object closure5421 = createclosure(3, "typeArg");
  setclosureframe(closure5421, stackframe);
  addtoclosure(closure5421, var_sym);
  addtoclosure(closure5421, var_values);
  addtoclosure(closure5421, var_ast);
  struct UserObject *uo5421 = (struct UserObject*)self;
  uo5421->data[54] = (Object)closure5421;
  Method *meth_meth_parser_5421_typeArg = addmethod2pos(self, "typeArg", &meth_parser_5421_typeArg, 54);
  int argcv_meth_parser_5421_typeArg[] = {0};
  meth_meth_parser_5421_typeArg->type = alloc_MethodType(1, argcv_meth_parser_5421_typeArg);
  meth_meth_parser_5421_typeArg->definitionModule = modulename;
  meth_meth_parser_5421_typeArg->definitionLine = 1872;
// compiled method node returning  (depth = 1)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefNoName"
  block_savedest(self);
  Object closure5447 = createclosure(3, "errorDefNoName");
  setclosureframe(closure5447, stackframe);
  addtoclosure(closure5447, var_errormessages);
  addtoclosure(closure5447, var_sym);
  addtoclosure(closure5447, var_lastToken);
  struct UserObject *uo5447 = (struct UserObject*)self;
  uo5447->data[55] = (Object)closure5447;
  Method *meth_meth_parser_5447_errorDefNoName = addmethod2pos(self, "errorDefNoName", &meth_parser_5447_errorDefNoName, 55);
  int argcv_meth_parser_5447_errorDefNoName[] = {0};
  meth_meth_parser_5447_errorDefNoName->type = alloc_MethodType(1, argcv_meth_parser_5447_errorDefNoName);
  meth_meth_parser_5447_errorDefNoName->definitionModule = modulename;
  meth_meth_parser_5447_errorDefNoName->definitionLine = 1887;
// compiled method node returning  (depth = 1)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefNoExpression"
  block_savedest(self);
  Object closure5515 = createclosure(3, "errorDefNoExpression");
  setclosureframe(closure5515, stackframe);
  addtoclosure(closure5515, var_errormessages);
  addtoclosure(closure5515, var_sym);
  addtoclosure(closure5515, var_lastToken);
  struct UserObject *uo5515 = (struct UserObject*)self;
  uo5515->data[56] = (Object)closure5515;
  Method *meth_meth_parser_5515_errorDefNoExpression = addmethod2pos(self, "errorDefNoExpression", &meth_parser_5515_errorDefNoExpression, 56);
  int argcv_meth_parser_5515_errorDefNoExpression[] = {0};
  meth_meth_parser_5515_errorDefNoExpression->type = alloc_MethodType(1, argcv_meth_parser_5515_errorDefNoExpression);
  meth_meth_parser_5515_errorDefNoExpression->definitionModule = modulename;
  meth_meth_parser_5515_errorDefNoExpression->definitionLine = 1904;
// compiled method node returning  (depth = 1)
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefUsesAssign(_)"
  block_savedest(self);
  Object closure5549 = createclosure(2, "errorDefUsesAssign(1)");
  setclosureframe(closure5549, stackframe);
  addtoclosure(closure5549, var_errormessages);
  addtoclosure(closure5549, var_sym);
  struct UserObject *uo5549 = (struct UserObject*)self;
  uo5549->data[57] = (Object)closure5549;
  Method *meth_meth_parser_5549_errorDefUsesAssign_40_1_41_ = addmethod2pos(self, "errorDefUsesAssign(1)", &meth_parser_5549_errorDefUsesAssign_40_1_41_, 57);
  int argcv_meth_parser_5549_errorDefUsesAssign_40_1_41_[] = {1};
  meth_meth_parser_5549_errorDefUsesAssign_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5549_errorDefUsesAssign_40_1_41_);
  meth_meth_parser_5549_errorDefUsesAssign_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5549_errorDefUsesAssign_40_1_41_->definitionLine = 1918;
// compiled method node returning  (depth = 1)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefMissingRhs(_)"
  block_savedest(self);
  Object closure5587 = createclosure(3, "errorDefMissingRhs(1)");
  setclosureframe(closure5587, stackframe);
  addtoclosure(closure5587, var_errormessages);
  addtoclosure(closure5587, var_lastToken);
  addtoclosure(closure5587, var_sym);
  struct UserObject *uo5587 = (struct UserObject*)self;
  uo5587->data[58] = (Object)closure5587;
  Method *meth_meth_parser_5587_errorDefMissingRhs_40_1_41_ = addmethod2pos(self, "errorDefMissingRhs(1)", &meth_parser_5587_errorDefMissingRhs_40_1_41_, 58);
  int argcv_meth_parser_5587_errorDefMissingRhs_40_1_41_[] = {1};
  meth_meth_parser_5587_errorDefMissingRhs_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5587_errorDefMissingRhs_40_1_41_);
  meth_meth_parser_5587_errorDefMissingRhs_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5587_errorDefMissingRhs_40_1_41_->definitionLine = 1931;
// compiled method node returning  (depth = 1)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "defdec"
  block_savedest(self);
  Object closure5619 = createclosure(6, "defdec");
  setclosureframe(closure5619, stackframe);
  addtoclosure(closure5619, var_minIndentLevel);
  addtoclosure(closure5619, var_sym);
  addtoclosure(closure5619, var_values);
  addtoclosure(closure5619, var_blocksOK);
  addtoclosure(closure5619, var_util);
  addtoclosure(closure5619, var_ast);
  struct UserObject *uo5619 = (struct UserObject*)self;
  uo5619->data[59] = (Object)closure5619;
  Method *meth_meth_parser_5619_defdec = addmethod2pos(self, "defdec", &meth_parser_5619_defdec, 59);
  int argcv_meth_parser_5619_defdec[] = {0};
  meth_meth_parser_5619_defdec->type = alloc_MethodType(1, argcv_meth_parser_5619_defdec);
  meth_meth_parser_5619_defdec->definitionModule = modulename;
  meth_meth_parser_5619_defdec->definitionLine = 1944;
// compiled method node returning  (depth = 1)
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "vardec"
  block_savedest(self);
  Object closure5713 = createclosure(8, "vardec");
  setclosureframe(closure5713, stackframe);
  addtoclosure(closure5713, var_minIndentLevel);
  addtoclosure(closure5713, var_sym);
  addtoclosure(closure5713, var_errormessages);
  addtoclosure(closure5713, var_lastToken);
  addtoclosure(closure5713, var_values);
  addtoclosure(closure5713, var_blocksOK);
  addtoclosure(closure5713, var_util);
  addtoclosure(closure5713, var_ast);
  struct UserObject *uo5713 = (struct UserObject*)self;
  uo5713->data[60] = (Object)closure5713;
  Method *meth_meth_parser_5713_vardec = addmethod2pos(self, "vardec", &meth_parser_5713_vardec, 60);
  int argcv_meth_parser_5713_vardec[] = {0};
  meth_meth_parser_5713_vardec->type = alloc_MethodType(1, argcv_meth_parser_5713_vardec);
  meth_meth_parser_5713_vardec->definitionModule = modulename;
  meth_meth_parser_5713_vardec->definitionLine = 1983;
// compiled method node returning  (depth = 1)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doarray"
  block_savedest(self);
  Object closure5931 = createclosure(6, "doarray");
  setclosureframe(closure5931, stackframe);
  addtoclosure(closure5931, var_blocksOK);
  addtoclosure(closure5931, var_values);
  addtoclosure(closure5931, var_errormessages);
  addtoclosure(closure5931, var_sym);
  addtoclosure(closure5931, var_lastToken);
  addtoclosure(closure5931, var_ast);
  struct UserObject *uo5931 = (struct UserObject*)self;
  uo5931->data[61] = (Object)closure5931;
  Method *meth_meth_parser_5931_doarray = addmethod2pos(self, "doarray", &meth_parser_5931_doarray, 61);
  int argcv_meth_parser_5931_doarray[] = {0};
  meth_meth_parser_5931_doarray->type = alloc_MethodType(1, argcv_meth_parser_5931_doarray);
  meth_meth_parser_5931_doarray->definitionModule = modulename;
  meth_meth_parser_5931_doarray->definitionLine = 2055;
// compiled method node returning  (depth = 1)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dodialect"
  block_savedest(self);
  Object closure6057 = createclosure(7, "dodialect");
  setclosureframe(closure6057, stackframe);
  addtoclosure(closure6057, var_sym);
  addtoclosure(closure6057, var_errormessages);
  addtoclosure(closure6057, var_lastToken);
  addtoclosure(closure6057, var_values);
  addtoclosure(closure6057, var_ast);
  addtoclosure(closure6057, var_moduleObject);
  addtoclosure(closure6057, var_util);
  struct UserObject *uo6057 = (struct UserObject*)self;
  uo6057->data[62] = (Object)closure6057;
  Method *meth_meth_parser_6057_dodialect = addmethod2pos(self, "dodialect", &meth_parser_6057_dodialect, 62);
  int argcv_meth_parser_6057_dodialect[] = {0};
  meth_meth_parser_6057_dodialect->type = alloc_MethodType(1, argcv_meth_parser_6057_dodialect);
  meth_meth_parser_6057_dodialect->definitionModule = modulename;
  meth_meth_parser_6057_dodialect->definitionLine = 2099;
// compiled method node returning  (depth = 1)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritOrUse"
  block_savedest(self);
  Object closure6158 = createclosure(9, "inheritOrUse");
  setclosureframe(closure6158, stackframe);
  addtoclosure(closure6158, var_done);
  addtoclosure(closure6158, var_sym);
  addtoclosure(closure6158, var_statementToken);
  addtoclosure(closure6158, var_noBlocks);
  addtoclosure(closure6158, var_errormessages);
  addtoclosure(closure6158, var_lastToken);
  addtoclosure(closure6158, var_util);
  addtoclosure(closure6158, var_values);
  addtoclosure(closure6158, var_ast);
  struct UserObject *uo6158 = (struct UserObject*)self;
  uo6158->data[63] = (Object)closure6158;
  Method *meth_meth_parser_6158_inheritOrUse = addmethod2pos(self, "inheritOrUse", &meth_parser_6158_inheritOrUse, 63);
  int argcv_meth_parser_6158_inheritOrUse[] = {0};
  meth_meth_parser_6158_inheritOrUse->type = alloc_MethodType(1, argcv_meth_parser_6158_inheritOrUse);
  meth_meth_parser_6158_inheritOrUse->definitionModule = modulename;
  meth_meth_parser_6158_inheritOrUse->definitionLine = 2130;
// compiled method node returning  (depth = 1)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritModifier(_)onLineOf(_)"
  block_savedest(self);
  Object closure6308 = createclosure(1, "inheritModifier(1)onLineOf(1)");
  setclosureframe(closure6308, stackframe);
  addtoclosure(closure6308, var_sym);
  struct UserObject *uo6308 = (struct UserObject*)self;
  uo6308->data[64] = (Object)closure6308;
  Method *meth_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_ = addmethod2pos(self, "inheritModifier(1)onLineOf(1)", &meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_, 64);
  int argcv_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_[] = {1, 1};
  meth_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_);
  meth_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6308_inheritModifier_40_1_41_onLineOf_40_1_41_->definitionLine = 2172;
// compiled method node returning  (depth = 1)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseAlias(_)"
  block_savedest(self);
  Object closure6335 = createclosure(3, "parseAlias(1)");
  setclosureframe(closure6335, stackframe);
  addtoclosure(closure6335, var_sym);
  addtoclosure(closure6335, var_errormessages);
  addtoclosure(closure6335, var_lastToken);
  struct UserObject *uo6335 = (struct UserObject*)self;
  uo6335->data[65] = (Object)closure6335;
  Method *meth_meth_parser_6335_parseAlias_40_1_41_ = addmethod2pos(self, "parseAlias(1)", &meth_parser_6335_parseAlias_40_1_41_, 65);
  int argcv_meth_parser_6335_parseAlias_40_1_41_[] = {1};
  meth_meth_parser_6335_parseAlias_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6335_parseAlias_40_1_41_);
  meth_meth_parser_6335_parseAlias_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6335_parseAlias_40_1_41_->definitionLine = 2186;
// compiled method node returning  (depth = 1)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseExclude(_)"
  struct UserObject *uo6401 = (struct UserObject*)self;
  uo6401->data[66] = emptyclosure;
  Method *meth_meth_parser_6401_parseExclude_40_1_41_ = addmethod2pos(self, "parseExclude(1)", &meth_parser_6401_parseExclude_40_1_41_, 66);
  int argcv_meth_parser_6401_parseExclude_40_1_41_[] = {1};
  meth_meth_parser_6401_parseExclude_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6401_parseExclude_40_1_41_);
  meth_meth_parser_6401_parseExclude_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6401_parseExclude_40_1_41_->definitionLine = 2204;
// compiled method node returning  (depth = 1)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doobject"
  block_savedest(self);
  Object closure6414 = createclosure(1, "doobject");
  setclosureframe(closure6414, stackframe);
  addtoclosure(closure6414, var_lastToken);
  struct UserObject *uo6414 = (struct UserObject*)self;
  uo6414->data[67] = (Object)closure6414;
  Method *meth_meth_parser_6414_doobject = addmethod2pos(self, "doobject", &meth_parser_6414_doobject, 67);
  int argcv_meth_parser_6414_doobject[] = {0};
  meth_meth_parser_6414_doobject->type = alloc_MethodType(1, argcv_meth_parser_6414_doobject);
  meth_meth_parser_6414_doobject->definitionModule = modulename;
  meth_meth_parser_6414_doobject->definitionLine = 2211;
// compiled method node returning  (depth = 1)
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseObjectConstructorBody(_)startingWith(_)after(_)"
  block_savedest(self);
  Object closure6425 = createclosure(7, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  setclosureframe(closure6425, stackframe);
  addtoclosure(closure6425, var_minIndentLevel);
  addtoclosure(closure6425, var_sym);
  addtoclosure(closure6425, var_errormessages);
  addtoclosure(closure6425, var_lastToken);
  addtoclosure(closure6425, var_statementToken);
  addtoclosure(closure6425, var_values);
  addtoclosure(closure6425, var_ast);
  struct UserObject *uo6425 = (struct UserObject*)self;
  uo6425->data[68] = (Object)closure6425;
  Method *meth_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_ = addmethod2pos(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", &meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_, 68);
  int argcv_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_);
  meth_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6425_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->definitionLine = 2222;
// compiled method node returning  (depth = 1)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doclass"
  block_savedest(self);
  Object closure6695 = createclosure(8, "doclass");
  setclosureframe(closure6695, stackframe);
  addtoclosure(closure6695, var_sym);
  addtoclosure(closure6695, var_minIndentLevel);
  addtoclosure(closure6695, var_errormessages);
  addtoclosure(closure6695, var_lastToken);
  addtoclosure(closure6695, var_tokens);
  addtoclosure(closure6695, var_values);
  addtoclosure(closure6695, var_util);
  addtoclosure(closure6695, var_ast);
  struct UserObject *uo6695 = (struct UserObject*)self;
  uo6695->data[69] = (Object)closure6695;
  Method *meth_meth_parser_6695_doclass = addmethod2pos(self, "doclass", &meth_parser_6695_doclass, 69);
  int argcv_meth_parser_6695_doclass[] = {0};
  meth_meth_parser_6695_doclass->type = alloc_MethodType(1, argcv_meth_parser_6695_doclass);
  meth_meth_parser_6695_doclass->definitionModule = modulename;
  meth_meth_parser_6695_doclass->definitionLine = 2293;
// compiled method node returning  (depth = 1)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dofactoryMethod"
  block_savedest(self);
  Object closure6914 = createclosure(7, "dofactoryMethod");
  setclosureframe(closure6914, stackframe);
  addtoclosure(closure6914, var_tokens);
  addtoclosure(closure6914, var_sym);
  addtoclosure(closure6914, var_minIndentLevel);
  addtoclosure(closure6914, var_errormessages);
  addtoclosure(closure6914, var_lastToken);
  addtoclosure(closure6914, var_values);
  addtoclosure(closure6914, var_util);
  struct UserObject *uo6914 = (struct UserObject*)self;
  uo6914->data[70] = (Object)closure6914;
  Method *meth_meth_parser_6914_dofactoryMethod = addmethod2pos(self, "dofactoryMethod", &meth_parser_6914_dofactoryMethod, 70);
  int argcv_meth_parser_6914_dofactoryMethod[] = {0};
  meth_meth_parser_6914_dofactoryMethod->type = alloc_MethodType(1, argcv_meth_parser_6914_dofactoryMethod);
  meth_meth_parser_6914_dofactoryMethod->definitionModule = modulename;
  meth_meth_parser_6914_dofactoryMethod->definitionLine = 2382;
// compiled method node returning  (depth = 1)
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methoddec"
  block_savedest(self);
  Object closure7043 = createclosure(7, "methoddec");
  setclosureframe(closure7043, stackframe);
  addtoclosure(closure7043, var_sym);
  addtoclosure(closure7043, var_statementToken);
  addtoclosure(closure7043, var_values);
  addtoclosure(closure7043, var_minIndentLevel);
  addtoclosure(closure7043, var_errormessages);
  addtoclosure(closure7043, var_lastToken);
  addtoclosure(closure7043, var_util);
  struct UserObject *uo7043 = (struct UserObject*)self;
  uo7043->data[71] = (Object)closure7043;
  Method *meth_meth_parser_7043_methoddec = addmethod2pos(self, "methoddec", &meth_parser_7043_methoddec, 71);
  int argcv_meth_parser_7043_methoddec[] = {0};
  meth_meth_parser_7043_methoddec->type = alloc_MethodType(1, argcv_meth_parser_7043_methoddec);
  meth_meth_parser_7043_methoddec->definitionModule = modulename;
  meth_meth_parser_7043_methoddec->definitionLine = 2425;
// compiled method node returning  (depth = 1)
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodDecRest(_,_)"
  block_savedest(self);
  Object closure7252 = createclosure(5, "methodDecRest(2)");
  setclosureframe(closure7252, stackframe);
  addtoclosure(closure7252, var_values);
  addtoclosure(closure7252, var_ast);
  addtoclosure(closure7252, var_errormessages);
  addtoclosure(closure7252, var_lastToken);
  addtoclosure(closure7252, var_sym);
  struct UserObject *uo7252 = (struct UserObject*)self;
  uo7252->data[72] = (Object)closure7252;
  Method *meth_meth_parser_7252_methodDecRest_40_2_41_ = addmethod2pos(self, "methodDecRest(2)", &meth_parser_7252_methodDecRest_40_2_41_, 72);
  int argcv_meth_parser_7252_methodDecRest_40_2_41_[] = {2};
  meth_meth_parser_7252_methodDecRest_40_2_41_->type = alloc_MethodType(1, argcv_meth_parser_7252_methodDecRest_40_2_41_);
  meth_meth_parser_7252_methodDecRest_40_2_41_->definitionModule = modulename;
  meth_meth_parser_7252_methodDecRest_40_2_41_->definitionLine = 2499;
// compiled method node returning  (depth = 1)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "optionalTypeAnnotation"
  block_savedest(self);
  Object closure7414 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure7414, stackframe);
  addtoclosure(closure7414, var_values);
  addtoclosure(closure7414, var_errormessages);
  addtoclosure(closure7414, var_lastToken);
  addtoclosure(closure7414, var_sym);
  struct UserObject *uo7414 = (struct UserObject*)self;
  uo7414->data[73] = (Object)closure7414;
  Method *meth_meth_parser_7414_optionalTypeAnnotation = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_7414_optionalTypeAnnotation, 73);
  int argcv_meth_parser_7414_optionalTypeAnnotation[] = {0};
  meth_meth_parser_7414_optionalTypeAnnotation->type = alloc_MethodType(1, argcv_meth_parser_7414_optionalTypeAnnotation);
  meth_meth_parser_7414_optionalTypeAnnotation->definitionModule = modulename;
  meth_meth_parser_7414_optionalTypeAnnotation->definitionLine = 2547;
// compiled method node returning  (depth = 1)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodsignature(_)"
  block_savedest(self);
  Object closure7462 = createclosure(5, "methodsignature(1)");
  setclosureframe(closure7462, stackframe);
  addtoclosure(closure7462, var_sym);
  addtoclosure(closure7462, var_errormessages);
  addtoclosure(closure7462, var_lastToken);
  addtoclosure(closure7462, var_ast);
  addtoclosure(closure7462, var_values);
  struct UserObject *uo7462 = (struct UserObject*)self;
  uo7462->data[74] = (Object)closure7462;
  Method *meth_meth_parser_7462_methodsignature_40_1_41_ = addmethod2pos(self, "methodsignature(1)", &meth_parser_7462_methodsignature_40_1_41_, 74);
  int argcv_meth_parser_7462_methodsignature_40_1_41_[] = {1};
  meth_meth_parser_7462_methodsignature_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7462_methodsignature_40_1_41_);
  meth_meth_parser_7462_methodsignature_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7462_methodsignature_40_1_41_->definitionLine = 2571;
// compiled method node returning  (depth = 1)
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeparameters"
  block_savedest(self);
  Object closure7829 = createclosure(5, "typeparameters");
  setclosureframe(closure7829, stackframe);
  addtoclosure(closure7829, var_values);
  addtoclosure(closure7829, var_ast);
  addtoclosure(closure7829, var_sym);
  addtoclosure(closure7829, var_errormessages);
  addtoclosure(closure7829, var_lastToken);
  struct UserObject *uo7829 = (struct UserObject*)self;
  uo7829->data[75] = (Object)closure7829;
  Method *meth_meth_parser_7829_typeparameters = addmethod2pos(self, "typeparameters", &meth_parser_7829_typeparameters, 75);
  int argcv_meth_parser_7829_typeparameters[] = {0};
  meth_meth_parser_7829_typeparameters->type = alloc_MethodType(1, argcv_meth_parser_7829_typeparameters);
  meth_meth_parser_7829_typeparameters->definitionModule = modulename;
  meth_meth_parser_7829_typeparameters->definitionLine = 2662;
// compiled method node returning  (depth = 1)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doimport"
  block_savedest(self);
  Object closure7899 = createclosure(5, "doimport");
  setclosureframe(closure7899, stackframe);
  addtoclosure(closure7899, var_sym);
  addtoclosure(closure7899, var_errormessages);
  addtoclosure(closure7899, var_lastToken);
  addtoclosure(closure7899, var_values);
  addtoclosure(closure7899, var_ast);
  struct UserObject *uo7899 = (struct UserObject*)self;
  uo7899->data[76] = (Object)closure7899;
  Method *meth_meth_parser_7899_doimport = addmethod2pos(self, "doimport", &meth_parser_7899_doimport, 76);
  int argcv_meth_parser_7899_doimport[] = {0};
  meth_meth_parser_7899_doimport->type = alloc_MethodType(1, argcv_meth_parser_7899_doimport);
  meth_meth_parser_7899_doimport->definitionModule = modulename;
  meth_meth_parser_7899_doimport->definitionLine = 2686;
// compiled method node returning  (depth = 1)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doreturn"
  block_savedest(self);
  Object closure8147 = createclosure(7, "doreturn");
  setclosureframe(closure8147, stackframe);
  addtoclosure(closure8147, var_sym);
  addtoclosure(closure8147, var_blocksOK);
  addtoclosure(closure8147, var_errormessages);
  addtoclosure(closure8147, var_lastToken);
  addtoclosure(closure8147, var_values);
  addtoclosure(closure8147, var_ast);
  addtoclosure(closure8147, var_util);
  struct UserObject *uo8147 = (struct UserObject*)self;
  uo8147->data[77] = (Object)closure8147;
  Method *meth_meth_parser_8147_doreturn = addmethod2pos(self, "doreturn", &meth_parser_8147_doreturn, 77);
  int argcv_meth_parser_8147_doreturn[] = {0};
  meth_meth_parser_8147_doreturn->type = alloc_MethodType(1, argcv_meth_parser_8147_doreturn);
  meth_meth_parser_8147_doreturn->definitionModule = modulename;
  meth_meth_parser_8147_doreturn->definitionLine = 2743;
// compiled method node returning  (depth = 1)
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "domethodtype"
  block_savedest(self);
  Object closure8268 = createclosure(6, "domethodtype");
  setclosureframe(closure8268, stackframe);
  addtoclosure(closure8268, var_sym);
  addtoclosure(closure8268, var_ast);
  addtoclosure(closure8268, var_values);
  addtoclosure(closure8268, var_lastToken);
  addtoclosure(closure8268, var_errormessages);
  addtoclosure(closure8268, var_util);
  struct UserObject *uo8268 = (struct UserObject*)self;
  uo8268->data[78] = (Object)closure8268;
  Method *meth_meth_parser_8268_domethodtype = addmethod2pos(self, "domethodtype", &meth_parser_8268_domethodtype, 78);
  int argcv_meth_parser_8268_domethodtype[] = {0};
  meth_meth_parser_8268_domethodtype->type = alloc_MethodType(1, argcv_meth_parser_8268_domethodtype);
  meth_meth_parser_8268_domethodtype->definitionModule = modulename;
  meth_meth_parser_8268_domethodtype->definitionLine = 2782;
// compiled method node returning  (depth = 1)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeLiteral"
  block_savedest(self);
  Object closure8367 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure8367, stackframe);
  addtoclosure(closure8367, var_sym);
  addtoclosure(closure8367, var_errormessages);
  addtoclosure(closure8367, var_done);
  addtoclosure(closure8367, var_auto_count);
  addtoclosure(closure8367, var_values);
  addtoclosure(closure8367, var_util);
  addtoclosure(closure8367, var_ast);
  struct UserObject *uo8367 = (struct UserObject*)self;
  uo8367->data[79] = (Object)closure8367;
  Method *meth_meth_parser_8367_dotypeLiteral = addmethod2pos(self, "dotypeLiteral", &meth_parser_8367_dotypeLiteral, 79);
  int argcv_meth_parser_8367_dotypeLiteral[] = {0};
  meth_meth_parser_8367_dotypeLiteral->type = alloc_MethodType(1, argcv_meth_parser_8367_dotypeLiteral);
  meth_meth_parser_8367_dotypeLiteral->definitionModule = modulename;
  meth_meth_parser_8367_dotypeLiteral->definitionLine = 2811;
// compiled method node returning  (depth = 1)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typedec"
  block_savedest(self);
  Object closure8450 = createclosure(7, "typedec");
  setclosureframe(closure8450, stackframe);
  addtoclosure(closure8450, var_sym);
  addtoclosure(closure8450, var_errormessages);
  addtoclosure(closure8450, var_lastToken);
  addtoclosure(closure8450, var_util);
  addtoclosure(closure8450, var_values);
  addtoclosure(closure8450, var_ast);
  addtoclosure(closure8450, var_noBlocks);
  struct UserObject *uo8450 = (struct UserObject*)self;
  uo8450->data[80] = (Object)closure8450;
  Method *meth_meth_parser_8450_typedec = addmethod2pos(self, "typedec", &meth_parser_8450_typedec, 80);
  int argcv_meth_parser_8450_typedec[] = {0};
  meth_meth_parser_8450_typedec->type = alloc_MethodType(1, argcv_meth_parser_8450_typedec);
  meth_meth_parser_8450_typedec->definitionModule = modulename;
  meth_meth_parser_8450_typedec->definitionLine = 2846;
// compiled method node returning  (depth = 1)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkIndent"
  block_savedest(self);
  Object closure8613 = createclosure(5, "checkIndent");
  setclosureframe(closure8613, stackframe);
  addtoclosure(closure8613, var_indentFreePass);
  addtoclosure(closure8613, var_sym);
  addtoclosure(closure8613, var_minIndentLevel);
  addtoclosure(closure8613, var_errormessages);
  addtoclosure(closure8613, var_lastToken);
  struct UserObject *uo8613 = (struct UserObject*)self;
  uo8613->data[81] = (Object)closure8613;
  Method *meth_meth_parser_8613_checkIndent = addmethod2pos(self, "checkIndent", &meth_parser_8613_checkIndent, 81);
  int argcv_meth_parser_8613_checkIndent[] = {0};
  meth_meth_parser_8613_checkIndent->type = alloc_MethodType(1, argcv_meth_parser_8613_checkIndent);
  meth_meth_parser_8613_checkIndent->definitionModule = modulename;
  meth_meth_parser_8613_checkIndent->definitionLine = 2892;
// compiled method node returning  (depth = 1)
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "statement"
  block_savedest(self);
  Object closure8779 = createclosure(8, "statement");
  setclosureframe(closure8779, stackframe);
  addtoclosure(closure8779, var_sym);
  addtoclosure(closure8779, var_statementIndent);
  addtoclosure(closure8779, var_statementToken);
  addtoclosure(closure8779, var_blocksOK);
  addtoclosure(closure8779, var_values);
  addtoclosure(closure8779, var_util);
  addtoclosure(closure8779, var_ast);
  addtoclosure(closure8779, var_indentFreePass);
  struct UserObject *uo8779 = (struct UserObject*)self;
  uo8779->data[82] = (Object)closure8779;
  Method *meth_meth_parser_8779_statement = addmethod2pos(self, "statement", &meth_parser_8779_statement, 82);
  int argcv_meth_parser_8779_statement[] = {0};
  meth_meth_parser_8779_statement->type = alloc_MethodType(1, argcv_meth_parser_8779_statement);
  meth_meth_parser_8779_statement->definitionModule = modulename;
  meth_meth_parser_8779_statement->definitionLine = 2928;
// compiled method node returning  (depth = 1)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushComments"
  block_savedest(self);
  Object closure8992 = createclosure(8, "pushComments");
  setclosureframe(closure8992, stackframe);
  addtoclosure(closure8992, var_done);
  addtoclosure(closure8992, var_sym);
  addtoclosure(closure8992, var_util);
  addtoclosure(closure8992, var_ast);
  addtoclosure(closure8992, var_lastToken);
  addtoclosure(closure8992, var_comments);
  addtoclosure(closure8992, var_previousCommentToken);
  addtoclosure(closure8992, var_tokens);
  struct UserObject *uo8992 = (struct UserObject*)self;
  uo8992->data[83] = (Object)closure8992;
  Method *meth_meth_parser_8992_pushComments = addmethod2pos(self, "pushComments", &meth_parser_8992_pushComments, 83);
  int argcv_meth_parser_8992_pushComments[] = {0};
  meth_meth_parser_8992_pushComments->type = alloc_MethodType(1, argcv_meth_parser_8992_pushComments);
  meth_meth_parser_8992_pushComments->definitionModule = modulename;
  meth_meth_parser_8992_pushComments->definitionLine = 2998;
// compiled method node returning  (depth = 1)
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reconcileComments"
  block_savedest(self);
  Object closure9111 = createclosure(4, "reconcileComments");
  setclosureframe(closure9111, stackframe);
  addtoclosure(closure9111, var_values);
  addtoclosure(closure9111, var_moduleObject);
  addtoclosure(closure9111, var_done);
  addtoclosure(closure9111, var_comments);
  struct UserObject *uo9111 = (struct UserObject*)self;
  uo9111->data[84] = (Object)closure9111;
  Method *meth_meth_parser_9111_reconcileComments = addmethod2pos(self, "reconcileComments", &meth_parser_9111_reconcileComments, 84);
  int argcv_meth_parser_9111_reconcileComments[] = {0};
  meth_meth_parser_9111_reconcileComments->type = alloc_MethodType(1, argcv_meth_parser_9111_reconcileComments);
  meth_meth_parser_9111_reconcileComments->definitionModule = modulename;
  meth_meth_parser_9111_reconcileComments->definitionLine = 3031;
// compiled method node returning  (depth = 1)
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadOperators"
  block_savedest(self);
  Object closure9238 = createclosure(2, "checkBadOperators");
  setclosureframe(closure9238, stackframe);
  addtoclosure(closure9238, var_sym);
  addtoclosure(closure9238, var_errormessages);
  struct UserObject *uo9238 = (struct UserObject*)self;
  uo9238->data[85] = (Object)closure9238;
  Method *meth_meth_parser_9238_checkBadOperators = addmethod2pos(self, "checkBadOperators", &meth_parser_9238_checkBadOperators, 85);
  int argcv_meth_parser_9238_checkBadOperators[] = {0};
  meth_meth_parser_9238_checkBadOperators->type = alloc_MethodType(1, argcv_meth_parser_9238_checkBadOperators);
  meth_meth_parser_9238_checkBadOperators->definitionModule = modulename;
  meth_meth_parser_9238_checkBadOperators->definitionLine = 3077;
// compiled method node returning  (depth = 1)
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadTypeLiteral"
  block_savedest(self);
  Object closure9262 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure9262, stackframe);
  addtoclosure(closure9262, var_sym);
  addtoclosure(closure9262, var_errormessages);
  struct UserObject *uo9262 = (struct UserObject*)self;
  uo9262->data[86] = (Object)closure9262;
  Method *meth_meth_parser_9262_checkBadTypeLiteral = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_9262_checkBadTypeLiteral, 86);
  int argcv_meth_parser_9262_checkBadTypeLiteral[] = {0};
  meth_meth_parser_9262_checkBadTypeLiteral->type = alloc_MethodType(1, argcv_meth_parser_9262_checkBadTypeLiteral);
  meth_meth_parser_9262_checkBadTypeLiteral->definitionModule = modulename;
  meth_meth_parser_9262_checkBadTypeLiteral->definitionLine = 3087;
// compiled method node returning  (depth = 1)
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkUnexpectedTokenAfterStatement"
  block_savedest(self);
  Object closure9286 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure9286, stackframe);
  addtoclosure(closure9286, var_lastToken);
  addtoclosure(closure9286, var_sym);
  addtoclosure(closure9286, var_errormessages);
  addtoclosure(closure9286, var_values);
  addtoclosure(closure9286, var_util);
  struct UserObject *uo9286 = (struct UserObject*)self;
  uo9286->data[87] = (Object)closure9286;
  Method *meth_meth_parser_9286_checkUnexpectedTokenAfterStatement = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_9286_checkUnexpectedTokenAfterStatement, 87);
  int argcv_meth_parser_9286_checkUnexpectedTokenAfterStatement[] = {0};
  meth_meth_parser_9286_checkUnexpectedTokenAfterStatement->type = alloc_MethodType(1, argcv_meth_parser_9286_checkUnexpectedTokenAfterStatement);
  meth_meth_parser_9286_checkUnexpectedTokenAfterStatement->definitionModule = modulename;
  meth_meth_parser_9286_checkUnexpectedTokenAfterStatement->definitionLine = 3097;
// compiled method node returning  (depth = 1)
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parse(_)"
  block_savedest(self);
  Object closure9585 = createclosure(7, "parse(1)");
  setclosureframe(closure9585, stackframe);
  addtoclosure(closure9585, var_util);
  addtoclosure(closure9585, var_values);
  addtoclosure(closure9585, var_ast);
  addtoclosure(closure9585, var_moduleObject);
  addtoclosure(closure9585, var_tokens);
  addtoclosure(closure9585, var_sym);
  addtoclosure(closure9585, var_errormessages);
  struct UserObject *uo9585 = (struct UserObject*)self;
  uo9585->data[88] = (Object)closure9585;
  Method *meth_meth_parser_9585_parse_40_1_41_ = addmethod2pos(self, "parse(1)", &meth_parser_9585_parse_40_1_41_, 88);
  int argcv_meth_parser_9585_parse_40_1_41_[] = {1};
  meth_meth_parser_9585_parse_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9585_parse_40_1_41_);
  meth_meth_parser_9585_parse_40_1_41_->definitionModule = modulename;
  meth_meth_parser_9585_parse_40_1_41_->definitionLine = 3156;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9731 = alloc_Float64(0);
// compiled num node returning num9731 (depth = 2)
  *var_lastLine = num9731;
  if (num9731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine"
  block_savedest(self);
  Object closure9732 = createclosure(1, "lastLine");
  setclosureframe(closure9732, stackframe);
  addtoclosure(closure9732, var_lastLine);
  struct UserObject *uo9732 = (struct UserObject*)self;
  uo9732->data[89] = (Object)closure9732;
  Method *meth_meth_parser_9732_lastLine = addmethod2pos(self, "lastLine", &meth_parser_9732_lastLine, 89);
  int argcv_meth_parser_9732_lastLine[] = {0};
  meth_meth_parser_9732_lastLine->type = alloc_MethodType(1, argcv_meth_parser_9732_lastLine);
  meth_meth_parser_9732_lastLine->definitionModule = modulename;
  meth_meth_parser_9732_lastLine->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine:=(_)"
  block_savedest(self);
  Object closure9733 = createclosure(1, "lastLine:=(1)");
  setclosureframe(closure9733, stackframe);
  addtoclosure(closure9733, var_lastLine);
  struct UserObject *uo9733 = (struct UserObject*)self;
  uo9733->data[90] = (Object)closure9733;
  Method *meth_meth_parser_9733_lastLine_58__61__40_1_41_ = addmethod2pos(self, "lastLine:=(1)", &meth_parser_9733_lastLine_58__61__40_1_41_, 90);
  int argcv_meth_parser_9733_lastLine_58__61__40_1_41_[] = {1};
  meth_meth_parser_9733_lastLine_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9733_lastLine_58__61__40_1_41_);
  meth_meth_parser_9733_lastLine_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9733_lastLine_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9735 = alloc_Float64(0);
// compiled num node returning num9735 (depth = 2)
  *var_lastIndent = num9735;
  if (num9735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent"
  block_savedest(self);
  Object closure9736 = createclosure(1, "lastIndent");
  setclosureframe(closure9736, stackframe);
  addtoclosure(closure9736, var_lastIndent);
  struct UserObject *uo9736 = (struct UserObject*)self;
  uo9736->data[91] = (Object)closure9736;
  Method *meth_meth_parser_9736_lastIndent = addmethod2pos(self, "lastIndent", &meth_parser_9736_lastIndent, 91);
  int argcv_meth_parser_9736_lastIndent[] = {0};
  meth_meth_parser_9736_lastIndent->type = alloc_MethodType(1, argcv_meth_parser_9736_lastIndent);
  meth_meth_parser_9736_lastIndent->definitionModule = modulename;
  meth_meth_parser_9736_lastIndent->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent:=(_)"
  block_savedest(self);
  Object closure9737 = createclosure(1, "lastIndent:=(1)");
  setclosureframe(closure9737, stackframe);
  addtoclosure(closure9737, var_lastIndent);
  struct UserObject *uo9737 = (struct UserObject*)self;
  uo9737->data[92] = (Object)closure9737;
  Method *meth_meth_parser_9737_lastIndent_58__61__40_1_41_ = addmethod2pos(self, "lastIndent:=(1)", &meth_parser_9737_lastIndent_58__61__40_1_41_, 92);
  int argcv_meth_parser_9737_lastIndent_58__61__40_1_41_[] = {1};
  meth_meth_parser_9737_lastIndent_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9737_lastIndent_58__61__40_1_41_);
  meth_meth_parser_9737_lastIndent_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9737_lastIndent_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9739 = alloc_Boolean(0);
// compiled identifier node returning bool9739 (depth = 2)
  *var_indentFreePass = bool9739;
  if (bool9739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass"
  block_savedest(self);
  Object closure9740 = createclosure(1, "indentFreePass");
  setclosureframe(closure9740, stackframe);
  addtoclosure(closure9740, var_indentFreePass);
  struct UserObject *uo9740 = (struct UserObject*)self;
  uo9740->data[93] = (Object)closure9740;
  Method *meth_meth_parser_9740_indentFreePass = addmethod2pos(self, "indentFreePass", &meth_parser_9740_indentFreePass, 93);
  int argcv_meth_parser_9740_indentFreePass[] = {0};
  meth_meth_parser_9740_indentFreePass->type = alloc_MethodType(1, argcv_meth_parser_9740_indentFreePass);
  meth_meth_parser_9740_indentFreePass->definitionModule = modulename;
  meth_meth_parser_9740_indentFreePass->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass:=(_)"
  block_savedest(self);
  Object closure9741 = createclosure(1, "indentFreePass:=(1)");
  setclosureframe(closure9741, stackframe);
  addtoclosure(closure9741, var_indentFreePass);
  struct UserObject *uo9741 = (struct UserObject*)self;
  uo9741->data[94] = (Object)closure9741;
  Method *meth_meth_parser_9741_indentFreePass_58__61__40_1_41_ = addmethod2pos(self, "indentFreePass:=(1)", &meth_parser_9741_indentFreePass_58__61__40_1_41_, 94);
  int argcv_meth_parser_9741_indentFreePass_58__61__40_1_41_[] = {1};
  meth_meth_parser_9741_indentFreePass_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9741_indentFreePass_58__61__40_1_41_);
  meth_meth_parser_9741_indentFreePass_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9741_indentFreePass_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9743 = alloc_Float64(0);
// compiled num node returning num9743 (depth = 2)
  *var_minIndentLevel = num9743;
  if (num9743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel"
  block_savedest(self);
  Object closure9744 = createclosure(1, "minIndentLevel");
  setclosureframe(closure9744, stackframe);
  addtoclosure(closure9744, var_minIndentLevel);
  struct UserObject *uo9744 = (struct UserObject*)self;
  uo9744->data[95] = (Object)closure9744;
  Method *meth_meth_parser_9744_minIndentLevel = addmethod2pos(self, "minIndentLevel", &meth_parser_9744_minIndentLevel, 95);
  int argcv_meth_parser_9744_minIndentLevel[] = {0};
  meth_meth_parser_9744_minIndentLevel->type = alloc_MethodType(1, argcv_meth_parser_9744_minIndentLevel);
  meth_meth_parser_9744_minIndentLevel->definitionModule = modulename;
  meth_meth_parser_9744_minIndentLevel->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel:=(_)"
  block_savedest(self);
  Object closure9745 = createclosure(1, "minIndentLevel:=(1)");
  setclosureframe(closure9745, stackframe);
  addtoclosure(closure9745, var_minIndentLevel);
  struct UserObject *uo9745 = (struct UserObject*)self;
  uo9745->data[96] = (Object)closure9745;
  Method *meth_meth_parser_9745_minIndentLevel_58__61__40_1_41_ = addmethod2pos(self, "minIndentLevel:=(1)", &meth_parser_9745_minIndentLevel_58__61__40_1_41_, 96);
  int argcv_meth_parser_9745_minIndentLevel_58__61__40_1_41_[] = {1};
  meth_meth_parser_9745_minIndentLevel_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9745_minIndentLevel_58__61__40_1_41_);
  meth_meth_parser_9745_minIndentLevel_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9745_minIndentLevel_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9747 = alloc_Float64(0);
// compiled num node returning num9747 (depth = 2)
  *var_statementIndent = num9747;
  if (num9747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent"
  block_savedest(self);
  Object closure9748 = createclosure(1, "statementIndent");
  setclosureframe(closure9748, stackframe);
  addtoclosure(closure9748, var_statementIndent);
  struct UserObject *uo9748 = (struct UserObject*)self;
  uo9748->data[97] = (Object)closure9748;
  Method *meth_meth_parser_9748_statementIndent = addmethod2pos(self, "statementIndent", &meth_parser_9748_statementIndent, 97);
  int argcv_meth_parser_9748_statementIndent[] = {0};
  meth_meth_parser_9748_statementIndent->type = alloc_MethodType(1, argcv_meth_parser_9748_statementIndent);
  meth_meth_parser_9748_statementIndent->definitionModule = modulename;
  meth_meth_parser_9748_statementIndent->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent:=(_)"
  block_savedest(self);
  Object closure9749 = createclosure(1, "statementIndent:=(1)");
  setclosureframe(closure9749, stackframe);
  addtoclosure(closure9749, var_statementIndent);
  struct UserObject *uo9749 = (struct UserObject*)self;
  uo9749->data[98] = (Object)closure9749;
  Method *meth_meth_parser_9749_statementIndent_58__61__40_1_41_ = addmethod2pos(self, "statementIndent:=(1)", &meth_parser_9749_statementIndent_58__61__40_1_41_, 98);
  int argcv_meth_parser_9749_statementIndent_58__61__40_1_41_[] = {1};
  meth_meth_parser_9749_statementIndent_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9749_statementIndent_58__61__40_1_41_);
  meth_meth_parser_9749_statementIndent_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9749_statementIndent_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9751 = alloc_Boolean(0);
// compiled identifier node returning bool9751 (depth = 2)
  *var_tokens = bool9751;
  if (bool9751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens"
  block_savedest(self);
  Object closure9752 = createclosure(1, "tokens");
  setclosureframe(closure9752, stackframe);
  addtoclosure(closure9752, var_tokens);
  struct UserObject *uo9752 = (struct UserObject*)self;
  uo9752->data[99] = (Object)closure9752;
  Method *meth_meth_parser_9752_tokens = addmethod2pos(self, "tokens", &meth_parser_9752_tokens, 99);
  int argcv_meth_parser_9752_tokens[] = {0};
  meth_meth_parser_9752_tokens->type = alloc_MethodType(1, argcv_meth_parser_9752_tokens);
  meth_meth_parser_9752_tokens->definitionModule = modulename;
  meth_meth_parser_9752_tokens->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens:=(_)"
  block_savedest(self);
  Object closure9753 = createclosure(1, "tokens:=(1)");
  setclosureframe(closure9753, stackframe);
  addtoclosure(closure9753, var_tokens);
  struct UserObject *uo9753 = (struct UserObject*)self;
  uo9753->data[100] = (Object)closure9753;
  Method *meth_meth_parser_9753_tokens_58__61__40_1_41_ = addmethod2pos(self, "tokens:=(1)", &meth_parser_9753_tokens_58__61__40_1_41_, 100);
  int argcv_meth_parser_9753_tokens_58__61__40_1_41_[] = {1};
  meth_meth_parser_9753_tokens_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9753_tokens_58__61__40_1_41_);
  meth_meth_parser_9753_tokens_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9753_tokens_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_moduleObject = undefined;
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject"
  block_savedest(self);
  Object closure9755 = createclosure(1, "moduleObject");
  setclosureframe(closure9755, stackframe);
  addtoclosure(closure9755, var_moduleObject);
  struct UserObject *uo9755 = (struct UserObject*)self;
  uo9755->data[101] = (Object)closure9755;
  Method *meth_meth_parser_9755_moduleObject = addmethod2pos(self, "moduleObject", &meth_parser_9755_moduleObject, 101);
  int argcv_meth_parser_9755_moduleObject[] = {0};
  meth_meth_parser_9755_moduleObject->type = alloc_MethodType(1, argcv_meth_parser_9755_moduleObject);
  meth_meth_parser_9755_moduleObject->definitionModule = modulename;
  meth_meth_parser_9755_moduleObject->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject:=(_)"
  block_savedest(self);
  Object closure9756 = createclosure(1, "moduleObject:=(1)");
  setclosureframe(closure9756, stackframe);
  addtoclosure(closure9756, var_moduleObject);
  struct UserObject *uo9756 = (struct UserObject*)self;
  uo9756->data[102] = (Object)closure9756;
  Method *meth_meth_parser_9756_moduleObject_58__61__40_1_41_ = addmethod2pos(self, "moduleObject:=(1)", &meth_parser_9756_moduleObject_58__61__40_1_41_, 102);
  int argcv_meth_parser_9756_moduleObject_58__61__40_1_41_[] = {1};
  meth_meth_parser_9756_moduleObject_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9756_moduleObject_58__61__40_1_41_);
  meth_meth_parser_9756_moduleObject_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9756_moduleObject_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe9758 = gc_frame_new();
// call case 5: prelude request
  Object call9759 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9758);
// compiled member node returning call9759 (depth = 2)
  *var_comments = call9759;
  if (call9759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments"
  block_savedest(self);
  Object closure9760 = createclosure(1, "comments");
  setclosureframe(closure9760, stackframe);
  addtoclosure(closure9760, var_comments);
  struct UserObject *uo9760 = (struct UserObject*)self;
  uo9760->data[103] = (Object)closure9760;
  Method *meth_meth_parser_9760_comments = addmethod2pos(self, "comments", &meth_parser_9760_comments, 103);
  int argcv_meth_parser_9760_comments[] = {0};
  meth_meth_parser_9760_comments->type = alloc_MethodType(1, argcv_meth_parser_9760_comments);
  meth_meth_parser_9760_comments->definitionModule = modulename;
  meth_meth_parser_9760_comments->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments:=(_)"
  block_savedest(self);
  Object closure9761 = createclosure(1, "comments:=(1)");
  setclosureframe(closure9761, stackframe);
  addtoclosure(closure9761, var_comments);
  struct UserObject *uo9761 = (struct UserObject*)self;
  uo9761->data[104] = (Object)closure9761;
  Method *meth_meth_parser_9761_comments_58__61__40_1_41_ = addmethod2pos(self, "comments:=(1)", &meth_parser_9761_comments_58__61__40_1_41_, 104);
  int argcv_meth_parser_9761_comments_58__61__40_1_41_[] = {1};
  meth_meth_parser_9761_comments_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9761_comments_58__61__40_1_41_);
  meth_meth_parser_9761_comments_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9761_comments_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9763 = alloc_Float64(0);
// compiled num node returning num9763 (depth = 2)
  *var_auto_count = num9763;
  if (num9763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count"
  block_savedest(self);
  Object closure9764 = createclosure(1, "auto_count");
  setclosureframe(closure9764, stackframe);
  addtoclosure(closure9764, var_auto_count);
  struct UserObject *uo9764 = (struct UserObject*)self;
  uo9764->data[105] = (Object)closure9764;
  Method *meth_meth_parser_9764_auto_count = addmethod2pos(self, "auto_count", &meth_parser_9764_auto_count, 105);
  int argcv_meth_parser_9764_auto_count[] = {0};
  meth_meth_parser_9764_auto_count->type = alloc_MethodType(1, argcv_meth_parser_9764_auto_count);
  meth_meth_parser_9764_auto_count->definitionModule = modulename;
  meth_meth_parser_9764_auto_count->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count:=(_)"
  block_savedest(self);
  Object closure9765 = createclosure(1, "auto_count:=(1)");
  setclosureframe(closure9765, stackframe);
  addtoclosure(closure9765, var_auto_count);
  struct UserObject *uo9765 = (struct UserObject*)self;
  uo9765->data[106] = (Object)closure9765;
  Method *meth_meth_parser_9765_auto_count_58__61__40_1_41_ = addmethod2pos(self, "auto_count:=(1)", &meth_parser_9765_auto_count_58__61__40_1_41_, 106);
  int argcv_meth_parser_9765_auto_count_58__61__40_1_41_[] = {1};
  meth_meth_parser_9765_auto_count_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9765_auto_count_58__61__40_1_41_);
  meth_meth_parser_9765_auto_count_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9765_auto_count_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9767 = alloc_Boolean(0);
// compiled identifier node returning bool9767 (depth = 2)
  *var_noBlocks = bool9767;
  if (bool9767 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noBlocks"
  block_savedest(self);
  Object closure9768 = createclosure(1, "noBlocks");
  setclosureframe(closure9768, stackframe);
  addtoclosure(closure9768, var_noBlocks);
  struct UserObject *uo9768 = (struct UserObject*)self;
  uo9768->data[107] = (Object)closure9768;
  Method *meth_meth_parser_9768_noBlocks = addmethod2pos(self, "noBlocks", &meth_parser_9768_noBlocks, 107);
  int argcv_meth_parser_9768_noBlocks[] = {0};
  meth_meth_parser_9768_noBlocks->type = alloc_MethodType(1, argcv_meth_parser_9768_noBlocks);
  meth_meth_parser_9768_noBlocks->definitionModule = modulename;
  meth_meth_parser_9768_noBlocks->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9769 = alloc_Boolean(1);
// compiled identifier node returning bool9769 (depth = 2)
  *var_blocksOK = bool9769;
  if (bool9769 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blocksOK"
  block_savedest(self);
  Object closure9770 = createclosure(1, "blocksOK");
  setclosureframe(closure9770, stackframe);
  addtoclosure(closure9770, var_blocksOK);
  struct UserObject *uo9770 = (struct UserObject*)self;
  uo9770->data[108] = (Object)closure9770;
  Method *meth_meth_parser_9770_blocksOK = addmethod2pos(self, "blocksOK", &meth_parser_9770_blocksOK, 108);
  int argcv_meth_parser_9770_blocksOK[] = {0};
  meth_meth_parser_9770_blocksOK->type = alloc_MethodType(1, argcv_meth_parser_9770_blocksOK);
  meth_meth_parser_9770_blocksOK->definitionModule = modulename;
  meth_meth_parser_9770_blocksOK->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile array node (depth = 2)
  Object array9771 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9771 (depth = 2)
  *var_values = array9771;
  if (array9771 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values"
  block_savedest(self);
  Object closure9772 = createclosure(1, "values");
  setclosureframe(closure9772, stackframe);
  addtoclosure(closure9772, var_values);
  struct UserObject *uo9772 = (struct UserObject*)self;
  uo9772->data[109] = (Object)closure9772;
  Method *meth_meth_parser_9772_values = addmethod2pos(self, "values", &meth_parser_9772_values, 109);
  int argcv_meth_parser_9772_values[] = {0};
  meth_meth_parser_9772_values->type = alloc_MethodType(1, argcv_meth_parser_9772_values);
  meth_meth_parser_9772_values->definitionModule = modulename;
  meth_meth_parser_9772_values->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values:=(_)"
  block_savedest(self);
  Object closure9773 = createclosure(1, "values:=(1)");
  setclosureframe(closure9773, stackframe);
  addtoclosure(closure9773, var_values);
  struct UserObject *uo9773 = (struct UserObject*)self;
  uo9773->data[110] = (Object)closure9773;
  Method *meth_meth_parser_9773_values_58__61__40_1_41_ = addmethod2pos(self, "values:=(1)", &meth_parser_9773_values_58__61__40_1_41_, 110);
  int argcv_meth_parser_9773_values_58__61__40_1_41_[] = {1};
  meth_meth_parser_9773_values_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9773_values_58__61__40_1_41_);
  meth_meth_parser_9773_values_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9773_values_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9775 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9775 = alloc_userobj2(7,8, objclass9775);
  gc_frame_newslot(obj9775);
// OBJECT OUTER DEC outer
  adddatum2(obj9775, self, 0);
  addmethodreal(obj9775,"outer", &reader_parser_outer_9776);
  Object oldself9775 = self;
  struct StackFrameObject *oldstackframe9775 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9775);
  gc_frame_newslot((Object)stackframe);
  self = obj9775;
  Object *oldselfslot9775 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9775 = (*(struct UserObject *)self).data[0], lowerouter9775 = thisouter9775;
  if (inheritingObject9775) {
    struct UserObject *inho9775 = (struct UserObject *)inheritingObject9775;
    while (inho9775->super != GraceDefaultObject) inho9775 = (struct UserObject *)inho9775->super;
    inho9775->super = obj9775;
    self = inheritingObject9775;
    *selfslot = self;
    lowerouter9775 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9775;
  }
  if (objclass9775 == NULL) {
  Method *reader9777 = addmethodrealflags(obj9775, "kind",&reader_parser_kind_9777, MFLAG_DEF);
  reader9777->definitionModule = modulename;
  reader9777->definitionLine = 50;
  }
  adddatum2(obj9775, alloc_Undefined(), 1);
  if (objclass9775 == NULL) {
  Method *reader9778 = addmethodrealflags(obj9775, "line",&reader_parser_line_9778, MFLAG_DEF);
  reader9778->definitionModule = modulename;
  reader9778->definitionLine = 51;
  }
  adddatum2(obj9775, alloc_Undefined(), 2);
  if (objclass9775 == NULL) {
  Method *reader9779 = addmethodrealflags(obj9775, "linePos",&reader_parser_linePos_9779, MFLAG_DEF);
  reader9779->definitionModule = modulename;
  reader9779->definitionLine = 52;
  }
  adddatum2(obj9775, alloc_Undefined(), 3);
  if (objclass9775 == NULL) {
  Method *reader9780 = addmethodrealflags(obj9775, "indent",&reader_parser_indent_9780, MFLAG_DEF);
  reader9780->definitionModule = modulename;
  reader9780->definitionLine = 53;
  }
  adddatum2(obj9775, alloc_Undefined(), 4);
  if (objclass9775 == NULL) {
  Method *reader9781 = addmethodrealflags(obj9775, "value",&reader_parser_value_9781, MFLAG_DEF);
  reader9781->definitionModule = modulename;
  reader9781->definitionLine = 54;
  }
  adddatum2(obj9775, alloc_Undefined(), 5);
  if (objclass9775 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9775, "size",&reader_parser_size_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 55;
  }
  adddatum2(obj9775, alloc_Undefined(), 6);
// method "==(_)"
  struct UserObject *uo9783 = (struct UserObject*)obj9775;
  uo9783->data[7] = emptyclosure;
  Method *meth_meth_parser_9783__61__61__40_1_41_ = addmethod2pos(obj9775, "==(1)", &meth_parser_9783__61__61__40_1_41_, 7);
  int argcv_meth_parser_9783__61__61__40_1_41_[] = {1};
  meth_meth_parser_9783__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9783__61__61__40_1_41_);
  meth_meth_parser_9783__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9783__61__61__40_1_41_->definitionLine = 56;
  sourceObject = obj9775;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9807 == NULL) {
    strlit9807 = alloc_String("start");
    gc_root(strlit9807);
  }
// compiled string node returning strlit9807 (depth = 3)
  adddatum2(obj9775, strlit9807, 1);
  sourceObject = obj9775;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9808 = alloc_Float64(0);
// compiled num node returning num9808 (depth = 3)
  adddatum2(obj9775, num9808, 2);
  sourceObject = obj9775;
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9809 = alloc_Float64(0);
// compiled num node returning num9809 (depth = 3)
  adddatum2(obj9775, num9809, 3);
  sourceObject = obj9775;
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9810 = alloc_Float64(0);
// compiled num node returning num9810 (depth = 3)
  adddatum2(obj9775, num9810, 4);
  sourceObject = obj9775;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9811 == NULL) {
    strlit9811 = alloc_String("");
    gc_root(strlit9811);
  }
// compiled string node returning strlit9811 (depth = 3)
  adddatum2(obj9775, strlit9811, 5);
  sourceObject = obj9775;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9812 = alloc_Float64(0);
// compiled num node returning num9812 (depth = 3)
  adddatum2(obj9775, num9812, 6);
  sourceObject = obj9775;
  objclass9775 = obj9775->class;
  objclass9775->definitionModule = modulename;
  objclass9775->definitionLine = 49;
  (*(struct UserObject *)self).data[0] = lowerouter9775;
  self = oldself9775;
  selfslot = oldselfslot9775;
  stackframe = oldstackframe9775;
// compiled object node returning obj9775 (depth = 2)
  *var_sym = obj9775;
  if (obj9775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym"
  block_savedest(self);
  Object closure9813 = createclosure(1, "sym");
  setclosureframe(closure9813, stackframe);
  addtoclosure(closure9813, var_sym);
  struct UserObject *uo9813 = (struct UserObject*)self;
  uo9813->data[111] = (Object)closure9813;
  Method *meth_meth_parser_9813_sym = addmethod2pos(self, "sym", &meth_parser_9813_sym, 111);
  int argcv_meth_parser_9813_sym[] = {0};
  meth_meth_parser_9813_sym->type = alloc_MethodType(1, argcv_meth_parser_9813_sym);
  meth_meth_parser_9813_sym->definitionModule = modulename;
  meth_meth_parser_9813_sym->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym:=(_)"
  block_savedest(self);
  Object closure9814 = createclosure(1, "sym:=(1)");
  setclosureframe(closure9814, stackframe);
  addtoclosure(closure9814, var_sym);
  struct UserObject *uo9814 = (struct UserObject*)self;
  uo9814->data[112] = (Object)closure9814;
  Method *meth_meth_parser_9814_sym_58__61__40_1_41_ = addmethod2pos(self, "sym:=(1)", &meth_parser_9814_sym_58__61__40_1_41_, 112);
  int argcv_meth_parser_9814_sym_58__61__40_1_41_[] = {1};
  meth_meth_parser_9814_sym_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9814_sym_58__61__40_1_41_);
  meth_meth_parser_9814_sym_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9814_sym_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken"
  block_savedest(self);
  Object closure9816 = createclosure(1, "lastToken");
  setclosureframe(closure9816, stackframe);
  addtoclosure(closure9816, var_lastToken);
  struct UserObject *uo9816 = (struct UserObject*)self;
  uo9816->data[113] = (Object)closure9816;
  Method *meth_meth_parser_9816_lastToken = addmethod2pos(self, "lastToken", &meth_parser_9816_lastToken, 113);
  int argcv_meth_parser_9816_lastToken[] = {0};
  meth_meth_parser_9816_lastToken->type = alloc_MethodType(1, argcv_meth_parser_9816_lastToken);
  meth_meth_parser_9816_lastToken->definitionModule = modulename;
  meth_meth_parser_9816_lastToken->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken:=(_)"
  block_savedest(self);
  Object closure9817 = createclosure(1, "lastToken:=(1)");
  setclosureframe(closure9817, stackframe);
  addtoclosure(closure9817, var_lastToken);
  struct UserObject *uo9817 = (struct UserObject*)self;
  uo9817->data[114] = (Object)closure9817;
  Method *meth_meth_parser_9817_lastToken_58__61__40_1_41_ = addmethod2pos(self, "lastToken:=(1)", &meth_parser_9817_lastToken_58__61__40_1_41_, 114);
  int argcv_meth_parser_9817_lastToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9817_lastToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9817_lastToken_58__61__40_1_41_);
  meth_meth_parser_9817_lastToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9817_lastToken_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken"
  block_savedest(self);
  Object closure9819 = createclosure(1, "previousCommentToken");
  setclosureframe(closure9819, stackframe);
  addtoclosure(closure9819, var_previousCommentToken);
  struct UserObject *uo9819 = (struct UserObject*)self;
  uo9819->data[115] = (Object)closure9819;
  Method *meth_meth_parser_9819_previousCommentToken = addmethod2pos(self, "previousCommentToken", &meth_parser_9819_previousCommentToken, 115);
  int argcv_meth_parser_9819_previousCommentToken[] = {0};
  meth_meth_parser_9819_previousCommentToken->type = alloc_MethodType(1, argcv_meth_parser_9819_previousCommentToken);
  meth_meth_parser_9819_previousCommentToken->definitionModule = modulename;
  meth_meth_parser_9819_previousCommentToken->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken:=(_)"
  block_savedest(self);
  Object closure9820 = createclosure(1, "previousCommentToken:=(1)");
  setclosureframe(closure9820, stackframe);
  addtoclosure(closure9820, var_previousCommentToken);
  struct UserObject *uo9820 = (struct UserObject*)self;
  uo9820->data[116] = (Object)closure9820;
  Method *meth_meth_parser_9820_previousCommentToken_58__61__40_1_41_ = addmethod2pos(self, "previousCommentToken:=(1)", &meth_parser_9820_previousCommentToken_58__61__40_1_41_, 116);
  int argcv_meth_parser_9820_previousCommentToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9820_previousCommentToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9820_previousCommentToken_58__61__40_1_41_);
  meth_meth_parser_9820_previousCommentToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9820_previousCommentToken_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken"
  block_savedest(self);
  Object closure9822 = createclosure(1, "statementToken");
  setclosureframe(closure9822, stackframe);
  addtoclosure(closure9822, var_statementToken);
  struct UserObject *uo9822 = (struct UserObject*)self;
  uo9822->data[117] = (Object)closure9822;
  Method *meth_meth_parser_9822_statementToken = addmethod2pos(self, "statementToken", &meth_parser_9822_statementToken, 117);
  int argcv_meth_parser_9822_statementToken[] = {0};
  meth_meth_parser_9822_statementToken->type = alloc_MethodType(1, argcv_meth_parser_9822_statementToken);
  meth_meth_parser_9822_statementToken->definitionModule = modulename;
  meth_meth_parser_9822_statementToken->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken:=(_)"
  block_savedest(self);
  Object closure9823 = createclosure(1, "statementToken:=(1)");
  setclosureframe(closure9823, stackframe);
  addtoclosure(closure9823, var_statementToken);
  struct UserObject *uo9823 = (struct UserObject*)self;
  uo9823->data[118] = (Object)closure9823;
  Method *meth_meth_parser_9823_statementToken_58__61__40_1_41_ = addmethod2pos(self, "statementToken:=(1)", &meth_parser_9823_statementToken_58__61__40_1_41_, 118);
  int argcv_meth_parser_9823_statementToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9823_statementToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9823_statementToken_58__61__40_1_41_);
  meth_meth_parser_9823_statementToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9823_statementToken_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9825 = alloc_Boolean(0);
// compiled identifier node returning bool9825 (depth = 2)
  *var_comment = bool9825;
  if (bool9825 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment"
  block_savedest(self);
  Object closure9826 = createclosure(1, "comment");
  setclosureframe(closure9826, stackframe);
  addtoclosure(closure9826, var_comment);
  struct UserObject *uo9826 = (struct UserObject*)self;
  uo9826->data[119] = (Object)closure9826;
  Method *meth_meth_parser_9826_comment = addmethod2pos(self, "comment", &meth_parser_9826_comment, 119);
  int argcv_meth_parser_9826_comment[] = {0};
  meth_meth_parser_9826_comment->type = alloc_MethodType(1, argcv_meth_parser_9826_comment);
  meth_meth_parser_9826_comment->definitionModule = modulename;
  meth_meth_parser_9826_comment->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment:=(_)"
  block_savedest(self);
  Object closure9827 = createclosure(1, "comment:=(1)");
  setclosureframe(closure9827, stackframe);
  addtoclosure(closure9827, var_comment);
  struct UserObject *uo9827 = (struct UserObject*)self;
  uo9827->data[120] = (Object)closure9827;
  Method *meth_meth_parser_9827_comment_58__61__40_1_41_ = addmethod2pos(self, "comment:=(1)", &meth_parser_9827_comment_58__61__40_1_41_, 120);
  int argcv_meth_parser_9827_comment_58__61__40_1_41_[] = {1};
  meth_meth_parser_9827_comment_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9827_comment_58__61__40_1_41_);
  meth_meth_parser_9827_comment_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9827_comment_58__61__40_1_41_->definitionLine = 3208;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
